/* A Bison parser, made by GNU Bison 3.3.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.3.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs

#define yylval          base_yylval
#define yychar          base_yychar
#define yylloc          base_yylloc

/* First part of user prologue.  */
#line 5 "preproc.y" /* yacc.c:337  */

#include "postgres_fe.h"

#include "preproc_extern.h"
#include "ecpg_config.h"
#include <unistd.h>

/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N)						\
			(Current) = (Rhs)[1];	\
		else						\
			(Current) = (Rhs)[0];	\
	} while (0)

/*
 * The %name-prefix option below will make bison call base_yylex, but we
 * really want it to call filtered_base_yylex (see parser.c).
 */
#define base_yylex filtered_base_yylex

/*
 * This is only here so the string gets into the POT.  Bison uses it
 * internally.
 */
#define bison_gettext_dummy gettext_noop("syntax error")

/*
 * Variables containing simple states.
 */
int struct_level = 0;
int braces_open; /* brace level counter */
char *current_function;
int ecpg_internal_var = 0;
char	*connection = NULL;
char	*input_filename = NULL;

static int	FoundInto = 0;
static int	initializer = 0;
static int	pacounter = 1;
static char	pacounter_buffer[sizeof(int) * CHAR_BIT * 10 / 3]; /* a rough guess at the size we need */
static struct this_type actual_type[STRUCT_DEPTH];
static char *actual_startline[STRUCT_DEPTH];
static int	varchar_counter = 1;
static int	bytea_counter = 1;

/* temporarily store struct members while creating the data structure */
struct ECPGstruct_member *struct_member_list[STRUCT_DEPTH] = { NULL };

/* also store struct type so we can do a sizeof() later */
static char *ECPGstruct_sizeof = NULL;

/* for forward declarations we have to store some data as well */
static char *forward_name = NULL;

struct ECPGtype ecpg_no_indicator = {ECPGt_NO_INDICATOR, NULL, NULL, NULL, {NULL}, 0};
struct variable no_indicator = {"no_indicator", &ecpg_no_indicator, 0, NULL};

static struct ECPGtype ecpg_query = {ECPGt_char_variable, NULL, NULL, NULL, {NULL}, 0};

static void vmmerror(int error_code, enum errortype type, const char *error, va_list ap) pg_attribute_printf(3, 0);

/*
 * Handle parsing errors and warnings
 */
static void
vmmerror(int error_code, enum errortype type, const char *error, va_list ap)
{
	/* localize the error message string */
	error = _(error);

	fprintf(stderr, "%s:%d: ", input_filename, base_yylineno);

	switch(type)
	{
		case ET_WARNING:
			fprintf(stderr, _("WARNING: "));
			break;
		case ET_ERROR:
			fprintf(stderr, _("ERROR: "));
			break;
	}

	vfprintf(stderr, error, ap);

	fprintf(stderr, "\n");

	switch(type)
	{
		case ET_WARNING:
			break;
		case ET_ERROR:
			ret_value = error_code;
			break;
	}
}

void
mmerror(int error_code, enum errortype type, const char *error, ...)
{
	va_list		ap;

	va_start(ap, error);
	vmmerror(error_code, type, error, ap);
	va_end(ap);
}

void
mmfatal(int error_code, const char *error, ...)
{
	va_list		ap;

	va_start(ap, error);
	vmmerror(error_code, ET_ERROR, error, ap);
	va_end(ap);

	if (base_yyin)
		fclose(base_yyin);
	if (base_yyout)
		fclose(base_yyout);

	if (strcmp(output_filename, "-") != 0 && unlink(output_filename) != 0)
		fprintf(stderr, _("could not remove output file \"%s\"\n"), output_filename);
	exit(error_code);
}

/*
 * string concatenation
 */

static char *
cat2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 2);

	strcpy(res_str, str1);
	if (strlen(str1) != 0 && strlen(str2) != 0)
		strcat(res_str, " ");
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return res_str;
}

static char *
cat_str(int count, ...)
{
	va_list		args;
	int			i;
	char		*res_str;

	va_start(args, count);

	res_str = va_arg(args, char *);

	/* now add all other strings */
	for (i = 1; i < count; i++)
		res_str = cat2_str(res_str, va_arg(args, char *));

	va_end(args);

	return res_str;
}

static char *
make2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return res_str;
}

static char *
make3_str(char *str1, char *str2, char *str3)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) +strlen(str3) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	strcat(res_str, str3);
	free(str1);
	free(str2);
	free(str3);
	return res_str;
}

/* and the rest */
static char *
make_name(void)
{
	return mm_strdup(base_yytext);
}

static char *
create_questionmarks(char *name, bool array)
{
	struct variable *p = find_variable(name);
	int count;
	char *result = EMPTY;

	/* In case we have a struct, we have to print as many "?" as there are attributes in the struct
	 * An array is only allowed together with an element argument
	 * This is essentially only used for inserts, but using a struct as input parameter is an error anywhere else
	 * so we don't have to worry here. */

	if (p->type->type == ECPGt_struct || (array && p->type->type == ECPGt_array && p->type->u.element->type == ECPGt_struct))
	{
		struct ECPGstruct_member *m;

		if (p->type->type == ECPGt_struct)
			m = p->type->u.members;
		else
			m = p->type->u.element->u.members;

		for (count = 0; m != NULL; m=m->next, count++);
	}
	else
		count = 1;

	for (; count > 0; count --)
	{
		sprintf(pacounter_buffer, "$%d", pacounter++);
		result = cat_str(3, result, mm_strdup(pacounter_buffer), mm_strdup(" , "));
	}

	/* removed the trailing " ," */

	result[strlen(result)-3] = '\0';
	return result;
}

static char *
adjust_outofscope_cursor_vars(struct cursor *cur)
{
	/* Informix accepts DECLARE with variables that are out of scope when OPEN is called.
	 * For instance you can DECLARE a cursor in one function, and OPEN/FETCH/CLOSE
	 * it in another functions. This is very useful for e.g. event-driver programming,
	 * but may also lead to dangerous programming. The limitation when this is allowed
	 * and doesn't cause problems have to be documented, like the allocated variables
	 * must not be realloc()'ed.
	 *
	 * We have to change the variables to our own struct and just store the pointer
	 * instead of the variable. Do it only for local variables, not for globals.
	 */

	char *result = EMPTY;
	int insert;

	for (insert = 1; insert >= 0; insert--)
	{
		struct arguments *list;
		struct arguments *ptr;
		struct arguments *newlist = NULL;
		struct variable *newvar, *newind;

		list = (insert ? cur->argsinsert : cur->argsresult);

		for (ptr = list; ptr != NULL; ptr = ptr->next)
		{
			char var_text[20];
			char *original_var;
			bool skip_set_var = false;
			bool var_ptr = false;

			/* change variable name to "ECPGget_var(<counter>)" */
			original_var = ptr->variable->name;
			sprintf(var_text, "%d))", ecpg_internal_var);

			/* Don't emit ECPGset_var() calls for global variables */
			if (ptr->variable->brace_level == 0)
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type == ECPGt_char_variable)
					 && (strncmp(ptr->variable->name, "ECPGprepared_statement", strlen("ECPGprepared_statement")) == 0))
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type != ECPGt_varchar
					  && ptr->variable->type->type != ECPGt_char
					  && ptr->variable->type->type != ECPGt_unsigned_char
					  && ptr->variable->type->type != ECPGt_string
					  && ptr->variable->type->type != ECPGt_bytea)
					 && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, mm_strdup("("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->u.element->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type,
																			   mm_strdup("1"),
																			   ptr->variable->type->u.element->counter),
														  ptr->variable->type->size),
									  0);
			}
			else if ((ptr->variable->type->type == ECPGt_varchar
					  || ptr->variable->type->type == ECPGt_char
					  || ptr->variable->type->type == ECPGt_unsigned_char
					  || ptr->variable->type->type == ECPGt_string
					  || ptr->variable->type->type == ECPGt_bytea)
					 && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, mm_strdup("("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_simple_type(ptr->variable->type->type,
														   ptr->variable->type->size,
														   ptr->variable->type->counter),
									  0);
				if (ptr->variable->type->type == ECPGt_varchar ||
					ptr->variable->type->type == ECPGt_bytea)
					var_ptr = true;
			}
			else if (ptr->variable->type->type == ECPGt_struct
					 || ptr->variable->type->type == ECPGt_union)
			{
				newvar = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->variable->type->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
									  ECPGmake_struct_type(ptr->variable->type->u.members,
														   ptr->variable->type->type,
														   ptr->variable->type->type_name,
														   ptr->variable->type->struct_sizeof),
									  0);
				var_ptr = true;
			}
			else if (ptr->variable->type->type == ECPGt_array)
			{
				if (ptr->variable->type->u.element->type == ECPGt_struct
					|| ptr->variable->type->u.element->type == ECPGt_union)
				{
					newvar = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->variable->type->u.element->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
										  ECPGmake_struct_type(ptr->variable->type->u.element->u.members,
															   ptr->variable->type->u.element->type,
															   ptr->variable->type->u.element->type_name,
															   ptr->variable->type->u.element->struct_sizeof),
										  0);
				}
				else
				{
					newvar = new_variable(cat_str(4, mm_strdup("("),
												  mm_strdup(ecpg_type_name(ptr->variable->type->u.element->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type,
																				   ptr->variable->type->u.element->size,
																				   ptr->variable->type->u.element->counter),
															  ptr->variable->type->size),
										  0);
					var_ptr = true;
				}
			}
			else
			{
				newvar = new_variable(cat_str(4, mm_strdup("*("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_simple_type(ptr->variable->type->type,
														   ptr->variable->type->size,
														   ptr->variable->type->counter),
									  0);
				var_ptr = true;
			}

			/* create call to "ECPGset_var(<counter>, <connection>, <pointer>. <line number>)" */
			if (!skip_set_var)
			{
				sprintf(var_text, "%d, %s", ecpg_internal_var++, var_ptr ? "&(" : "(");
				result = cat_str(5, result, mm_strdup("ECPGset_var("),
								 mm_strdup(var_text), mm_strdup(original_var),
								 mm_strdup("), __LINE__);\n"));
			}

			/* now the indicator if there is one and it's not a global variable */
			if ((ptr->indicator->type->type == ECPGt_NO_INDICATOR) || (ptr->indicator->brace_level == 0))
			{
				newind = ptr->indicator;
			}
			else
			{
				/* change variable name to "ECPGget_var(<counter>)" */
				original_var = ptr->indicator->name;
				sprintf(var_text, "%d))", ecpg_internal_var);
				var_ptr = false;

				if (ptr->indicator->type->type == ECPGt_struct
					|| ptr->indicator->type->type == ECPGt_union)
				{
					newind = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->indicator->type->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
										  ECPGmake_struct_type(ptr->indicator->type->u.members,
															   ptr->indicator->type->type,
															   ptr->indicator->type->type_name,
															   ptr->indicator->type->struct_sizeof),
										  0);
					var_ptr = true;
				}
				else if (ptr->indicator->type->type == ECPGt_array)
				{
					if (ptr->indicator->type->u.element->type == ECPGt_struct
						|| ptr->indicator->type->u.element->type == ECPGt_union)
					{
						newind = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->indicator->type->u.element->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
											  ECPGmake_struct_type(ptr->indicator->type->u.element->u.members,
																   ptr->indicator->type->u.element->type,
																   ptr->indicator->type->u.element->type_name,
																   ptr->indicator->type->u.element->struct_sizeof),
											  0);
					}
					else
					{
						newind = new_variable(cat_str(4, mm_strdup("("),
													  mm_strdup(ecpg_type_name(ptr->indicator->type->u.element->type)),
													  mm_strdup(" *)(ECPGget_var("), mm_strdup(var_text)),
											  ECPGmake_array_type(ECPGmake_simple_type(ptr->indicator->type->u.element->type,
																					   ptr->indicator->type->u.element->size,
																					   ptr->indicator->type->u.element->counter),
																  ptr->indicator->type->size),
											  0);
						var_ptr = true;
					}
				}
				else if (atoi(ptr->indicator->type->size) > 1)
				{
					newind = new_variable(cat_str(4, mm_strdup("("),
												  mm_strdup(ecpg_type_name(ptr->indicator->type->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_simple_type(ptr->indicator->type->type,
															   ptr->indicator->type->size,
															   ptr->variable->type->counter),
										  0);
				}
				else
				{
					newind = new_variable(cat_str(4, mm_strdup("*("),
												  mm_strdup(ecpg_type_name(ptr->indicator->type->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_simple_type(ptr->indicator->type->type,
															   ptr->indicator->type->size,
															   ptr->variable->type->counter),
										  0);
					var_ptr = true;
				}

				/* create call to "ECPGset_var(<counter>, <pointer>. <line number>)" */
				sprintf(var_text, "%d, %s", ecpg_internal_var++, var_ptr ? "&(" : "(");
				result = cat_str(5, result, mm_strdup("ECPGset_var("),
								 mm_strdup(var_text), mm_strdup(original_var),
								 mm_strdup("), __LINE__);\n"));
			}

			add_variable_to_tail(&newlist, newvar, newind);
		}

		if (insert)
			cur->argsinsert_oos = newlist;
		else
			cur->argsresult_oos = newlist;
	}

	return result;
}

/* This tests whether the cursor was declared and opened in the same function. */
#define SAMEFUNC(cur)	\
	((cur->function == NULL) ||		\
	 (cur->function != NULL && strcmp(cur->function, current_function) == 0))

static struct cursor *
add_additional_variables(char *name, bool insert)
{
	struct cursor *ptr;
	struct arguments *p;
	int (* strcmp_fn)(const char *, const char *) = ((name[0] == ':' || name[0] == '"') ? strcmp : pg_strcasecmp);

	for (ptr = cur; ptr != NULL; ptr=ptr->next)
	{
		if (strcmp_fn(ptr->name, name) == 0)
			break;
	}

	if (ptr == NULL)
	{
		mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" does not exist", name);
		return NULL;
	}

	if (insert)
	{
		/* add all those input variables that were given earlier
		 * note that we have to append here but have to keep the existing order */
		for (p = (SAMEFUNC(ptr) ? ptr->argsinsert : ptr->argsinsert_oos); p; p = p->next)
			add_variable_to_tail(&argsinsert, p->variable, p->indicator);
	}

	/* add all those output variables that were given earlier */
	for (p = (SAMEFUNC(ptr) ? ptr->argsresult : ptr->argsresult_oos); p; p = p->next)
		add_variable_to_tail(&argsresult, p->variable, p->indicator);

	return ptr;
}

static void
add_typedef(char *name, char *dimension, char *length, enum ECPGttype type_enum,
			char *type_dimension, char *type_index, int initializer, int array)
{
	/* add entry to list */
	struct typedefs *ptr, *this;

	if ((type_enum == ECPGt_struct ||
		 type_enum == ECPGt_union) &&
		initializer == 1)
		mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in type definition");
	else if (INFORMIX_MODE && strcmp(name, "string") == 0)
		mmerror(PARSE_ERROR, ET_ERROR, "type name \"string\" is reserved in Informix mode");
	else
	{
		for (ptr = types; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp(name, ptr->name) == 0)
				/* re-definition is a bug */
				mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", name);
		}
		adjust_array(type_enum, &dimension, &length, type_dimension, type_index, array, true);

		this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

		/* initial definition */
		this->next = types;
		this->name = name;
		this->brace_level = braces_open;
		this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
		this->type->type_enum = type_enum;
		this->type->type_str = mm_strdup(name);
		this->type->type_dimension = dimension; /* dimension of array */
		this->type->type_index = length;	/* length of string */
		this->type->type_sizeof = ECPGstruct_sizeof;
		this->struct_member_list = (type_enum == ECPGt_struct || type_enum == ECPGt_union) ?
		ECPGstruct_member_dup(struct_member_list[struct_level]) : NULL;

		if (type_enum != ECPGt_varchar &&
			type_enum != ECPGt_bytea &&
			type_enum != ECPGt_char &&
			type_enum != ECPGt_unsigned_char &&
			type_enum != ECPGt_string &&
			atoi(this->type->type_index) >= 0)
			mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

		types = this;
	}
}

#line 656 "preproc.c" /* yacc.c:337  */
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "preproc.h".  */
#ifndef YY_BASE_YY_PREPROC_H_INCLUDED
# define YY_BASE_YY_PREPROC_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    SQL_ALLOCATE = 258,
    SQL_AUTOCOMMIT = 259,
    SQL_BOOL = 260,
    SQL_BREAK = 261,
    SQL_CARDINALITY = 262,
    SQL_CONNECT = 263,
    SQL_COUNT = 264,
    SQL_DATETIME_INTERVAL_CODE = 265,
    SQL_DATETIME_INTERVAL_PRECISION = 266,
    SQL_DESCRIBE = 267,
    SQL_DESCRIPTOR = 268,
    SQL_DISCONNECT = 269,
    SQL_FOUND = 270,
    SQL_FREE = 271,
    SQL_GET = 272,
    SQL_GO = 273,
    SQL_GOTO = 274,
    SQL_IDENTIFIED = 275,
    SQL_INDICATOR = 276,
    SQL_KEY_MEMBER = 277,
    SQL_LENGTH = 278,
    SQL_LONG = 279,
    SQL_NULLABLE = 280,
    SQL_OCTET_LENGTH = 281,
    SQL_OPEN = 282,
    SQL_OUTPUT = 283,
    SQL_REFERENCE = 284,
    SQL_RETURNED_LENGTH = 285,
    SQL_RETURNED_OCTET_LENGTH = 286,
    SQL_SCALE = 287,
    SQL_SECTION = 288,
    SQL_SHORT = 289,
    SQL_SIGNED = 290,
    SQL_SQLERROR = 291,
    SQL_SQLPRINT = 292,
    SQL_SQLWARNING = 293,
    SQL_START = 294,
    SQL_STOP = 295,
    SQL_STRUCT = 296,
    SQL_UNSIGNED = 297,
    SQL_VAR = 298,
    SQL_WHENEVER = 299,
    S_ADD = 300,
    S_AND = 301,
    S_ANYTHING = 302,
    S_AUTO = 303,
    S_CONST = 304,
    S_DEC = 305,
    S_DIV = 306,
    S_DOTPOINT = 307,
    S_EQUAL = 308,
    S_EXTERN = 309,
    S_INC = 310,
    S_LSHIFT = 311,
    S_MEMPOINT = 312,
    S_MEMBER = 313,
    S_MOD = 314,
    S_MUL = 315,
    S_NEQUAL = 316,
    S_OR = 317,
    S_REGISTER = 318,
    S_RSHIFT = 319,
    S_STATIC = 320,
    S_SUB = 321,
    S_VOLATILE = 322,
    S_TYPEDEF = 323,
    CSTRING = 324,
    CVARIABLE = 325,
    CPP_LINE = 326,
    IP = 327,
    IDENT = 328,
    UIDENT = 329,
    FCONST = 330,
    SCONST = 331,
    USCONST = 332,
    BCONST = 333,
    XCONST = 334,
    Op = 335,
    ICONST = 336,
    PARAM = 337,
    TYPECAST = 338,
    DOT_DOT = 339,
    COLON_EQUALS = 340,
    EQUALS_GREATER = 341,
    LESS_EQUALS = 342,
    GREATER_EQUALS = 343,
    NOT_EQUALS = 344,
    ABORT_P = 345,
    ABSOLUTE_P = 346,
    ACCESS = 347,
    ACTION = 348,
    ADD_P = 349,
    ADMIN = 350,
    AFTER = 351,
    AGGREGATE = 352,
    ALL = 353,
    ALSO = 354,
    ALTER = 355,
    ALWAYS = 356,
    ANALYSE = 357,
    ANALYZE = 358,
    AND = 359,
    ANY = 360,
    ARRAY = 361,
    AS = 362,
    ASC = 363,
    ASSERTION = 364,
    ASSIGNMENT = 365,
    ASYMMETRIC = 366,
    AT = 367,
    ATTACH = 368,
    ATTRIBUTE = 369,
    AUTHORIZATION = 370,
    BACKWARD = 371,
    BEFORE = 372,
    BEGIN_P = 373,
    BETWEEN = 374,
    BIGINT = 375,
    BINARY = 376,
    BIT = 377,
    BOOLEAN_P = 378,
    BOTH = 379,
    BY = 380,
    CACHE = 381,
    CALL = 382,
    CALLED = 383,
    CASCADE = 384,
    CASCADED = 385,
    CASE = 386,
    CAST = 387,
    CATALOG_P = 388,
    CHAIN = 389,
    CHAR_P = 390,
    CHARACTER = 391,
    CHARACTERISTICS = 392,
    CHECK = 393,
    CHECKPOINT = 394,
    CLASS = 395,
    CLOSE = 396,
    CLUSTER = 397,
    COALESCE = 398,
    COLLATE = 399,
    COLLATION = 400,
    COLUMN = 401,
    COLUMNS = 402,
    COMMENT = 403,
    COMMENTS = 404,
    COMMIT = 405,
    COMMITTED = 406,
    CONCURRENTLY = 407,
    CONFIGURATION = 408,
    CONFLICT = 409,
    CONNECTION = 410,
    CONSTRAINT = 411,
    CONSTRAINTS = 412,
    CONTENT_P = 413,
    CONTINUE_P = 414,
    CONVERSION_P = 415,
    COPY = 416,
    COST = 417,
    CREATE = 418,
    CROSS = 419,
    CSV = 420,
    CUBE = 421,
    CURRENT_P = 422,
    CURRENT_CATALOG = 423,
    CURRENT_DATE = 424,
    CURRENT_ROLE = 425,
    CURRENT_SCHEMA = 426,
    CURRENT_TIME = 427,
    CURRENT_TIMESTAMP = 428,
    CURRENT_USER = 429,
    CURSOR = 430,
    CYCLE = 431,
    DATA_P = 432,
    DATABASE = 433,
    DAY_P = 434,
    DEALLOCATE = 435,
    DEC = 436,
    DECIMAL_P = 437,
    DECLARE = 438,
    DEFAULT = 439,
    DEFAULTS = 440,
    DEFERRABLE = 441,
    DEFERRED = 442,
    DEFINER = 443,
    DELETE_P = 444,
    DELIMITER = 445,
    DELIMITERS = 446,
    DEPENDS = 447,
    DESC = 448,
    DETACH = 449,
    DICTIONARY = 450,
    DISABLE_P = 451,
    DISCARD = 452,
    DISTINCT = 453,
    DO = 454,
    DOCUMENT_P = 455,
    DOMAIN_P = 456,
    DOUBLE_P = 457,
    DROP = 458,
    EACH = 459,
    ELSE = 460,
    ENABLE_P = 461,
    ENCODING = 462,
    ENCRYPTED = 463,
    END_P = 464,
    ENUM_P = 465,
    ESCAPE = 466,
    EVENT = 467,
    EXCEPT = 468,
    EXCLUDE = 469,
    EXCLUDING = 470,
    EXCLUSIVE = 471,
    EXECUTE = 472,
    EXISTS = 473,
    EXPLAIN = 474,
    EXPRESSION = 475,
    EXTENSION = 476,
    EXTERNAL = 477,
    EXTRACT = 478,
    FALSE_P = 479,
    FAMILY = 480,
    FETCH = 481,
    FILTER = 482,
    FIRST_P = 483,
    FLOAT_P = 484,
    FOLLOWING = 485,
    FOR = 486,
    FORCE = 487,
    FOREIGN = 488,
    FORWARD = 489,
    FREEZE = 490,
    FROM = 491,
    FULL = 492,
    FUNCTION = 493,
    FUNCTIONS = 494,
    GENERATED = 495,
    GLOBAL = 496,
    GRANT = 497,
    GRANTED = 498,
    GREATEST = 499,
    GROUP_P = 500,
    GROUPING = 501,
    GROUPS = 502,
    HANDLER = 503,
    HAVING = 504,
    HEADER_P = 505,
    HOLD = 506,
    HOUR_P = 507,
    IDENTITY_P = 508,
    IF_P = 509,
    ILIKE = 510,
    IMMEDIATE = 511,
    IMMUTABLE = 512,
    IMPLICIT_P = 513,
    IMPORT_P = 514,
    IN_P = 515,
    INCLUDE = 516,
    INCLUDING = 517,
    INCREMENT = 518,
    INDEX = 519,
    INDEXES = 520,
    INHERIT = 521,
    INHERITS = 522,
    INITIALLY = 523,
    INLINE_P = 524,
    INNER_P = 525,
    INOUT = 526,
    INPUT_P = 527,
    INSENSITIVE = 528,
    INSERT = 529,
    INSTEAD = 530,
    INT_P = 531,
    INTEGER = 532,
    INTERSECT = 533,
    INTERVAL = 534,
    INTO = 535,
    INVOKER = 536,
    IS = 537,
    ISNULL = 538,
    ISOLATION = 539,
    JOIN = 540,
    KEY = 541,
    LABEL = 542,
    LANGUAGE = 543,
    LARGE_P = 544,
    LAST_P = 545,
    LATERAL_P = 546,
    LEADING = 547,
    LEAKPROOF = 548,
    LEAST = 549,
    LEFT = 550,
    LEVEL = 551,
    LIKE = 552,
    LIMIT = 553,
    LISTEN = 554,
    LOAD = 555,
    LOCAL = 556,
    LOCALTIME = 557,
    LOCALTIMESTAMP = 558,
    LOCATION = 559,
    LOCK_P = 560,
    LOCKED = 561,
    LOGGED = 562,
    MAPPING = 563,
    MATCH = 564,
    MATERIALIZED = 565,
    MAXVALUE = 566,
    METHOD = 567,
    MINUTE_P = 568,
    MINVALUE = 569,
    MODE = 570,
    MONTH_P = 571,
    MOVE = 572,
    NAME_P = 573,
    NAMES = 574,
    NATIONAL = 575,
    NATURAL = 576,
    NCHAR = 577,
    NEW = 578,
    NEXT = 579,
    NFC = 580,
    NFD = 581,
    NFKC = 582,
    NFKD = 583,
    NO = 584,
    NONE = 585,
    NORMALIZE = 586,
    NORMALIZED = 587,
    NOT = 588,
    NOTHING = 589,
    NOTIFY = 590,
    NOTNULL = 591,
    NOWAIT = 592,
    NULL_P = 593,
    NULLIF = 594,
    NULLS_P = 595,
    NUMERIC = 596,
    OBJECT_P = 597,
    OF = 598,
    OFF = 599,
    OFFSET = 600,
    OIDS = 601,
    OLD = 602,
    ON = 603,
    ONLY = 604,
    OPERATOR = 605,
    OPTION = 606,
    OPTIONS = 607,
    OR = 608,
    ORDER = 609,
    ORDINALITY = 610,
    OTHERS = 611,
    OUT_P = 612,
    OUTER_P = 613,
    OVER = 614,
    OVERLAPS = 615,
    OVERLAY = 616,
    OVERRIDING = 617,
    OWNED = 618,
    OWNER = 619,
    PARALLEL = 620,
    PARSER = 621,
    PARTIAL = 622,
    PARTITION = 623,
    PASSING = 624,
    PASSWORD = 625,
    PLACING = 626,
    PLANS = 627,
    POLICY = 628,
    POSITION = 629,
    PRECEDING = 630,
    PRECISION = 631,
    PRESERVE = 632,
    PREPARE = 633,
    PREPARED = 634,
    PRIMARY = 635,
    PRIOR = 636,
    PRIVILEGES = 637,
    PROCEDURAL = 638,
    PROCEDURE = 639,
    PROCEDURES = 640,
    PROGRAM = 641,
    PUBLICATION = 642,
    QUOTE = 643,
    RANGE = 644,
    READ = 645,
    REAL = 646,
    REASSIGN = 647,
    RECHECK = 648,
    RECURSIVE = 649,
    REF = 650,
    REFERENCES = 651,
    REFERENCING = 652,
    REFRESH = 653,
    REINDEX = 654,
    RELATIVE_P = 655,
    RELEASE = 656,
    RENAME = 657,
    REPEATABLE = 658,
    REPLACE = 659,
    REPLICA = 660,
    RESET = 661,
    RESTART = 662,
    RESTRICT = 663,
    RETURNING = 664,
    RETURNS = 665,
    REVOKE = 666,
    RIGHT = 667,
    ROLE = 668,
    ROLLBACK = 669,
    ROLLUP = 670,
    ROUTINE = 671,
    ROUTINES = 672,
    ROW = 673,
    ROWS = 674,
    RULE = 675,
    SAVEPOINT = 676,
    SCHEMA = 677,
    SCHEMAS = 678,
    SCROLL = 679,
    SEARCH = 680,
    SECOND_P = 681,
    SECURITY = 682,
    SELECT = 683,
    SEQUENCE = 684,
    SEQUENCES = 685,
    SERIALIZABLE = 686,
    SERVER = 687,
    SESSION = 688,
    SESSION_USER = 689,
    SET = 690,
    SETS = 691,
    SETOF = 692,
    SHARE = 693,
    SHOW = 694,
    SIMILAR = 695,
    SIMPLE = 696,
    SKIP = 697,
    SMALLINT = 698,
    SNAPSHOT = 699,
    SOME = 700,
    SQL_P = 701,
    STABLE = 702,
    STANDALONE_P = 703,
    START = 704,
    STATEMENT = 705,
    STATISTICS = 706,
    STDIN = 707,
    STDOUT = 708,
    STORAGE = 709,
    STORED = 710,
    STRICT_P = 711,
    STRIP_P = 712,
    SUBSCRIPTION = 713,
    SUBSTRING = 714,
    SUPPORT = 715,
    SYMMETRIC = 716,
    SYSID = 717,
    SYSTEM_P = 718,
    TABLE = 719,
    TABLES = 720,
    TABLESAMPLE = 721,
    TABLESPACE = 722,
    TEMP = 723,
    TEMPLATE = 724,
    TEMPORARY = 725,
    TEXT_P = 726,
    THEN = 727,
    TIES = 728,
    TIME = 729,
    TIMESTAMP = 730,
    TO = 731,
    TRAILING = 732,
    TRANSACTION = 733,
    TRANSFORM = 734,
    TREAT = 735,
    TRIGGER = 736,
    TRIM = 737,
    TRUE_P = 738,
    TRUNCATE = 739,
    TRUSTED = 740,
    TYPE_P = 741,
    TYPES_P = 742,
    UESCAPE = 743,
    UNBOUNDED = 744,
    UNCOMMITTED = 745,
    UNENCRYPTED = 746,
    UNION = 747,
    UNIQUE = 748,
    UNKNOWN = 749,
    UNLISTEN = 750,
    UNLOGGED = 751,
    UNTIL = 752,
    UPDATE = 753,
    USER = 754,
    USING = 755,
    VACUUM = 756,
    VALID = 757,
    VALIDATE = 758,
    VALIDATOR = 759,
    VALUE_P = 760,
    VALUES = 761,
    VARCHAR = 762,
    VARIADIC = 763,
    VARYING = 764,
    VERBOSE = 765,
    VERSION_P = 766,
    VIEW = 767,
    VIEWS = 768,
    VOLATILE = 769,
    WHEN = 770,
    WHERE = 771,
    WHITESPACE_P = 772,
    WINDOW = 773,
    WITH = 774,
    WITHIN = 775,
    WITHOUT = 776,
    WORK = 777,
    WRAPPER = 778,
    WRITE = 779,
    XML_P = 780,
    XMLATTRIBUTES = 781,
    XMLCONCAT = 782,
    XMLELEMENT = 783,
    XMLEXISTS = 784,
    XMLFOREST = 785,
    XMLNAMESPACES = 786,
    XMLPARSE = 787,
    XMLPI = 788,
    XMLROOT = 789,
    XMLSERIALIZE = 790,
    XMLTABLE = 791,
    YEAR_P = 792,
    YES_P = 793,
    ZONE = 794,
    NOT_LA = 795,
    NULLS_LA = 796,
    WITH_LA = 797,
    POSTFIXOP = 798,
    UMINUS = 799
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 586 "preproc.y" /* yacc.c:352  */

	double	dval;
	char	*str;
	int		ival;
	struct	when		action;
	struct	index		index;
	int		tagname;
	struct	this_type	type;
	enum	ECPGttype	type_enum;
	enum	ECPGdtype	dtype_enum;
	struct	fetch_desc	descriptor;
	struct  su_symbol	struct_union;
	struct	prep		prep;
	struct	exec		exec;

#line 1260 "preproc.c" /* yacc.c:352  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE base_yylval;
extern YYLTYPE base_yylloc;
int base_yyparse (void);

#endif /* !YY_BASE_YY_PREPROC_H_INCLUDED  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   143521

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  564
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  817
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3232
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6212

#define YYUNDEFTOK  2
#define YYMAXUTOK   799

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   551,     2,     2,
     556,   557,   549,   547,   559,   548,   558,   550,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   561,   560,
     543,   545,   544,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   554,     2,   555,   552,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   562,     2,   563,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   546,   553
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,  1624,  1624,  1627,  1629,  1631,  1633,  1635,  1637,  1639,
    1641,  1643,  1645,  1647,  1649,  1651,  1653,  1655,  1657,  1659,
    1661,  1663,  1665,  1667,  1669,  1671,  1673,  1675,  1677,  1679,
    1681,  1683,  1685,  1687,  1689,  1691,  1693,  1695,  1697,  1699,
    1717,  1719,  1721,  1723,  1725,  1727,  1729,  1731,  1733,  1735,
    1737,  1739,  1741,  1743,  1745,  1747,  1749,  1751,  1753,  1755,
    1757,  1759,  1761,  1763,  1765,  1767,  1769,  1771,  1773,  1775,
    1777,  1779,  1781,  1783,  1785,  1787,  1789,  1793,  1795,  1797,
    1799,  1801,  1803,  1805,  1807,  1809,  1811,  1813,  1815,  1817,
    1819,  1821,  1823,  1825,  1827,  1850,  1852,  1854,  1856,  1858,
    1860,  1862,  1864,  1866,  1868,  1870,  1872,  1874,  1901,  1903,
    1905,  1907,  1909,  1911,  1913,  1915,  1917,  1919,  1921,  1923,
    1929,  1931,  1933,  1935,  1937,  1939,  1941,  1943,  1945,  1951,
    1961,  1965,  1971,  1975,  1985,  1995,  1996,  2010,  2017,  2023,
    2034,  2040,  2049,  2056,  2062,  2071,  2078,  2086,  2091,  2099,
    2107,  2111,  2116,  2122,  2127,  2133,  2138,  2144,  2148,  2152,
    2156,  2161,  2165,  2169,  2173,  2177,  2185,  2189,  2193,  2197,
    2201,  2205,  2213,  2221,  2225,  2234,  2236,  2244,  2248,  2252,
    2256,  2264,  2268,  2272,  2276,  2280,  2284,  2292,  2300,  2308,
    2312,  2320,  2324,  2328,  2333,  2342,  2347,  2353,  2358,  2364,
    2368,  2372,  2376,  2380,  2384,  2392,  2396,  2400,  2408,  2412,
    2416,  2424,  2428,  2432,  2436,  2444,  2448,  2452,  2456,  2461,
    2465,  2469,  2473,  2477,  2481,  2485,  2493,  2497,  2505,  2509,
    2517,  2521,  2535,  2539,  2543,  2547,  2555,  2559,  2563,  2567,
    2575,  2579,  2583,  2587,  2591,  2595,  2599,  2607,  2611,  2616,
    2622,  2626,  2634,  2642,  2646,  2650,  2654,  2662,  2666,  2674,
    2678,  2686,  2690,  2698,  2702,  2706,  2710,  2714,  2723,  2731,
    2735,  2743,  2747,  2755,  2763,  2767,  2771,  2775,  2779,  2787,
    2791,  2795,  2799,  2803,  2807,  2811,  2815,  2819,  2823,  2827,
    2831,  2835,  2839,  2843,  2847,  2851,  2855,  2859,  2867,  2871,
    2879,  2883,  2891,  2899,  2903,  2907,  2911,  2915,  2919,  2923,
    2927,  2931,  2935,  2939,  2943,  2947,  2951,  2955,  2959,  2963,
    2967,  2971,  2975,  2979,  2983,  2987,  2991,  2995,  2999,  3003,
    3007,  3011,  3015,  3019,  3023,  3027,  3031,  3035,  3039,  3043,
    3047,  3051,  3055,  3059,  3063,  3067,  3071,  3075,  3079,  3083,
    3087,  3091,  3095,  3099,  3103,  3107,  3111,  3115,  3119,  3123,
    3127,  3135,  3139,  3147,  3151,  3156,  3162,  3167,  3173,  3178,
    3184,  3188,  3192,  3196,  3204,  3212,  3217,  3223,  3227,  3235,
    3239,  3243,  3247,  3255,  3259,  3267,  3271,  3275,  3279,  3287,
    3291,  3295,  3299,  3307,  3315,  3319,  3327,  3335,  3339,  3347,
    3351,  3355,  3359,  3367,  3372,  3380,  3388,  3396,  3400,  3408,
    3413,  3419,  3423,  3427,  3435,  3439,  3447,  3452,  3458,  3462,
    3466,  3470,  3474,  3478,  3482,  3486,  3490,  3494,  3498,  3502,
    3506,  3514,  3519,  3525,  3530,  3536,  3541,  3547,  3551,  3559,
    3567,  3571,  3575,  3579,  3584,  3590,  3594,  3602,  3610,  3614,
    3618,  3622,  3626,  3630,  3638,  3642,  3646,  3650,  3654,  3658,
    3662,  3667,  3673,  3678,  3684,  3689,  3695,  3699,  3707,  3711,
    3719,  3723,  3727,  3735,  3739,  3747,  3755,  3759,  3767,  3772,
    3778,  3782,  3786,  3790,  3798,  3802,  3806,  3810,  3814,  3818,
    3822,  3826,  3830,  3838,  3842,  3850,  3854,  3858,  3862,  3870,
    3878,  3882,  3887,  3893,  3897,  3901,  3905,  3909,  3913,  3917,
    3921,  3925,  3933,  3937,  3945,  3949,  3953,  3957,  3961,  3965,
    3969,  3977,  3982,  3988,  3993,  3999,  4003,  4011,  4019,  4024,
    4030,  4034,  4039,  4044,  4050,  4054,  4062,  4066,  4074,  4079,
    4085,  4089,  4093,  4097,  4102,  4108,  4116,  4124,  4128,  4132,
    4136,  4140,  4148,  4153,  4159,  4164,  4170,  4178,  4182,  4190,
    4194,  4198,  4206,  4211,  4217,  4221,  4226,  4232,  4236,  4240,
    4245,  4251,  4256,  4262,  4267,  4273,  4281,  4285,  4293,  4297,
    4305,  4313,  4317,  4322,  4328,  4332,  4340,  4348,  4353,  4359,
    4367,  4371,  4379,  4383,  4391,  4396,  4402,  4407,  4413,  4417,
    4425,  4429,  4433,  4437,  4441,  4445,  4449,  4453,  4457,  4461,
    4465,  4469,  4473,  4477,  4485,  4490,  4496,  4500,  4504,  4508,
    4516,  4520,  4528,  4532,  4540,  4545,  4551,  4555,  4563,  4568,
    4574,  4578,  4586,  4591,  4597,  4601,  4609,  4614,  4620,  4628,
    4633,  4639,  4643,  4651,  4655,  4663,  4668,  4674,  4678,  4682,
    4687,  4695,  4703,  4708,  4714,  4722,  4726,  4730,  4734,  4738,
    4742,  4746,  4750,  4754,  4758,  4762,  4766,  4770,  4774,  4778,
    4782,  4786,  4790,  4794,  4798,  4802,  4806,  4810,  4814,  4818,
    4822,  4826,  4830,  4838,  4846,  4850,  4854,  4858,  4866,  4870,
    4878,  4883,  4889,  4893,  4901,  4906,  4912,  4916,  4924,  4932,
    4936,  4944,  4948,  4952,  4956,  4964,  4972,  4980,  4988,  4992,
    5000,  5005,  5011,  5015,  5023,  5028,  5034,  5038,  5042,  5050,
    5054,  5058,  5062,  5070,  5074,  5082,  5090,  5094,  5102,  5107,
    5113,  5117,  5125,  5129,  5137,  5141,  5149,  5157,  5165,  5173,
    5178,  5184,  5189,  5195,  5200,  5206,  5211,  5217,  5222,  5228,
    5233,  5239,  5243,  5247,  5251,  5255,  5263,  5271,  5275,  5283,
    5287,  5295,  5299,  5303,  5311,  5315,  5323,  5327,  5331,  5335,
    5339,  5347,  5352,  5358,  5362,  5370,  5378,  5382,  5390,  5394,
    5402,  5410,  5415,  5421,  5426,  5432,  5436,  5444,  5449,  5455,
    5459,  5467,  5471,  5476,  5482,  5486,  5490,  5494,  5502,  5507,
    5514,  5516,  5524,  5528,  5532,  5536,  5540,  5544,  5552,  5556,
    5564,  5568,  5576,  5584,  5588,  5596,  5604,  5608,  5612,  5616,
    5624,  5633,  5637,  5641,  5645,  5649,  5653,  5657,  5661,  5665,
    5669,  5673,  5677,  5681,  5685,  5689,  5693,  5701,  5709,  5713,
    5721,  5725,  5733,  5737,  5741,  5745,  5749,  5753,  5761,  5769,
    5773,  5781,  5789,  5794,  5800,  5804,  5812,  5816,  5820,  5824,
    5832,  5837,  5843,  5851,  5855,  5863,  5867,  5871,  5875,  5879,
    5887,  5892,  5898,  5903,  5909,  5913,  5918,  5924,  5930,  5936,
    5944,  5948,  5956,  5960,  5968,  5972,  5980,  5984,  5992,  5996,
    6004,  6012,  6020,  6024,  6028,  6032,  6036,  6040,  6044,  6048,
    6052,  6056,  6060,  6064,  6072,  6076,  6080,  6084,  6088,  6092,
    6096,  6100,  6104,  6108,  6112,  6116,  6120,  6128,  6132,  6136,
    6140,  6144,  6148,  6152,  6160,  6164,  6168,  6176,  6180,  6188,
    6192,  6200,  6204,  6212,  6216,  6224,  6232,  6236,  6241,  6247,
    6251,  6255,  6259,  6263,  6267,  6271,  6275,  6279,  6283,  6287,
    6291,  6295,  6299,  6303,  6307,  6311,  6315,  6319,  6327,  6331,
    6335,  6339,  6343,  6347,  6351,  6355,  6359,  6363,  6367,  6371,
    6375,  6379,  6387,  6391,  6395,  6399,  6403,  6407,  6411,  6415,
    6419,  6423,  6427,  6431,  6439,  6443,  6451,  6455,  6459,  6463,
    6467,  6471,  6475,  6479,  6483,  6491,  6496,  6502,  6506,  6510,
    6514,  6518,  6522,  6530,  6534,  6538,  6542,  6546,  6550,  6554,
    6558,  6566,  6570,  6578,  6582,  6586,  6590,  6596,  6602,  6608,
    6614,  6620,  6626,  6632,  6642,  6653,  6664,  6675,  6686,  6697,
    6708,  6724,  6740,  6756,  6767,  6783,  6794,  6810,  6825,  6829,
    6837,  6842,  6848,  6856,  6860,  6868,  6872,  6876,  6880,  6884,
    6892,  6896,  6904,  6908,  6912,  6916,  6924,  6928,  6932,  6936,
    6940,  6944,  6948,  6952,  6956,  6960,  6964,  6968,  6972,  6976,
    6980,  6984,  6988,  6992,  6996,  7000,  7008,  7012,  7020,  7024,
    7032,  7037,  7043,  7051,  7055,  7063,  7068,  7074,  7079,  7085,
    7093,  7098,  7104,  7108,  7112,  7120,  7124,  7128,  7136,  7140,
    7144,  7148,  7152,  7156,  7164,  7168,  7176,  7181,  7187,  7192,
    7198,  7203,  7209,  7214,  7220,  7224,  7232,  7236,  7244,  7248,
    7252,  7260,  7265,  7271,  7275,  7283,  7288,  7294,  7299,  7305,
    7309,  7314,  7320,  7324,  7329,  7335,  7339,  7343,  7347,  7355,
    7360,  7366,  7370,  7378,  7382,  7390,  7394,  7402,  7406,  7410,
    7414,  7422,  7426,  7434,  7438,  7446,  7450,  7454,  7458,  7462,
    7470,  7474,  7478,  7482,  7486,  7494,  7502,  7510,  7514,  7518,
    7526,  7530,  7534,  7542,  7551,  7555,  7559,  7563,  7571,  7575,
    7583,  7591,  7595,  7603,  7607,  7615,  7619,  7623,  7627,  7631,
    7635,  7639,  7643,  7647,  7651,  7655,  7659,  7663,  7667,  7671,
    7675,  7679,  7687,  7691,  7695,  7699,  7703,  7711,  7715,  7723,
    7727,  7735,  7740,  7746,  7754,  7758,  7766,  7770,  7774,  7782,
    7786,  7794,  7799,  7805,  7809,  7813,  7817,  7821,  7825,  7833,
    7837,  7845,  7849,  7857,  7861,  7865,  7869,  7877,  7881,  7889,
    7893,  7901,  7909,  7917,  7921,  7929,  7933,  7941,  7945,  7949,
    7957,  7961,  7966,  7972,  7980,  7985,  7991,  7999,  8003,  8007,
    8011,  8019,  8027,  8031,  8035,  8039,  8047,  8051,  8059,  8063,
    8067,  8075,  8079,  8087,  8095,  8099,  8107,  8111,  8115,  8119,
    8123,  8127,  8131,  8135,  8139,  8143,  8147,  8151,  8155,  8159,
    8163,  8167,  8171,  8175,  8179,  8183,  8187,  8191,  8195,  8199,
    8203,  8207,  8211,  8215,  8219,  8223,  8227,  8231,  8235,  8239,
    8243,  8247,  8251,  8255,  8259,  8263,  8267,  8271,  8275,  8279,
    8283,  8287,  8291,  8295,  8299,  8303,  8307,  8311,  8315,  8319,
    8323,  8331,  8336,  8342,  8347,  8353,  8357,  8361,  8365,  8369,
    8373,  8381,  8386,  8392,  8396,  8400,  8404,  8408,  8412,  8416,
    8420,  8424,  8428,  8432,  8436,  8440,  8444,  8448,  8452,  8456,
    8460,  8464,  8468,  8472,  8476,  8480,  8484,  8488,  8492,  8496,
    8504,  8512,  8516,  8524,  8528,  8536,  8540,  8544,  8548,  8552,
    8560,  8568,  8572,  8576,  8580,  8584,  8588,  8592,  8596,  8600,
    8604,  8608,  8612,  8616,  8620,  8624,  8628,  8632,  8636,  8640,
    8644,  8648,  8652,  8656,  8660,  8668,  8676,  8681,  8687,  8691,
    8699,  8703,  8707,  8711,  8719,  8727,  8731,  8739,  8747,  8751,
    8755,  8759,  8763,  8767,  8775,  8779,  8787,  8795,  8799,  8803,
    8811,  8815,  8823,  8827,  8831,  8835,  8839,  8847,  8852,  8858,
    8862,  8866,  8870,  8878,  8882,  8887,  8893,  8901,  8906,  8912,
    8920,  8924,  8932,  8936,  8940,  8944,  8948,  8952,  8956,  8960,
    8964,  8968,  8972,  8976,  8980,  8984,  8992,  8996,  9001,  9007,
    9011,  9015,  9019,  9023,  9031,  9035,  9039,  9047,  9052,  9058,
    9062,  9067,  9073,  9077,  9081,  9086,  9095,  9099,  9103,  9108,
    9114,  9122,  9130,  9135,  9141,  9145,  9153,  9157,  9161,  9169,
    9173,  9177,  9181,  9185,  9189,  9193,  9201,  9206,  9212,  9216,
    9220,  9228,  9236,  9240,  9244,  9248,  9256,  9260,  9268,  9276,
    9284,  9288,  9296,  9304,  9308,  9312,  9316,  9320,  9324,  9328,
    9336,  9341,  9347,  9355,  9359,  9363,  9367,  9371,  9375,  9383,
    9387,  9395,  9403,  9407,  9411,  9419,  9424,  9430,  9434,  9442,
    9446,  9454,  9458,  9466,  9470,  9478,  9486,  9490,  9498,  9502,
    9507,  9513,  9518,  9524,  9529,  9535,  9540,  9546,  9551,  9557,
    9562,  9568,  9576,  9580,  9588,  9593,  9599,  9603,  9607,  9611,
    9619,  9623,  9627,  9631,  9635,  9639,  9643,  9647,  9651,  9659,
    9663,  9671,  9679,  9683,  9691,  9695,  9700,  9706,  9712,  9722,
    9727,  9733,  9737,  9741,  9745,  9753,  9758,  9762,  9770,  9775,
    9781,  9789,  9793,  9801,  9805,  9809,  9813,  9817,  9825,  9829,
    9837,  9841,  9849,  9857,  9861,  9866,  9872,  9876,  9881,  9887,
    9892,  9898,  9906,  9911,  9917,  9925,  9930,  9936,  9940,  9944,
    9948,  9952,  9956,  9960,  9964,  9972,  9977,  9983,  9987,  9992,
    9998, 10006, 10010, 10018, 10022, 10030, 10038, 10042, 10050, 10098,
   10102, 10115, 10117, 10121, 10125, 10129, 10138, 10144, 10148, 10156,
   10160, 10168, 10172, 10180, 10184, 10188, 10192, 10196, 10200, 10204,
   10208, 10216, 10220, 10228, 10232, 10236, 10240, 10244, 10248, 10252,
   10260, 10264, 10268, 10276, 10280, 10288, 10296, 10300, 10305, 10311,
   10316, 10322, 10327, 10329, 10335, 10339, 10343, 10347, 10351, 10355,
   10359, 10363, 10367, 10375, 10380, 10386, 10390, 10395, 10401, 10405,
   10413, 10418, 10424, 10429, 10435, 10443, 10447, 10455, 10459, 10467,
   10471, 10475, 10479, 10487, 10492, 10498, 10502, 10507, 10511, 10515,
   10519, 10527, 10531, 10539, 10543, 10551, 10559, 10563, 10567, 10575,
   10579, 10587, 10591, 10599, 10603, 10611, 10616, 10622, 10626, 10634,
   10638, 10642, 10646, 10650, 10658, 10666, 10674, 10682, 10690, 10695,
   10701, 10705, 10713, 10718, 10724, 10728, 10736, 10744, 10748, 10752,
   10756, 10764, 10769, 10775, 10779, 10787, 10792, 10798, 10802, 10810,
   10814, 10818, 10822, 10826, 10830, 10834, 10841, 10848, 10852, 10860,
   10864, 10868, 10872, 10876, 10880, 10888, 10892, 10896, 10900, 10908,
   10913, 10919, 10923, 10927, 10931, 10936, 10942, 10946, 10950, 10954,
   10962, 10967, 10973, 10977, 10985, 10989, 10993, 10997, 11005, 11009,
   11017, 11021, 11025, 11033, 11041, 11046, 11052, 11056, 11064, 11072,
   11076, 11084, 11089, 11095, 11100, 11106, 11111, 11117, 11121, 11127,
   11133, 11138, 11144, 11148, 11156, 11164, 11168, 11176, 11180, 11188,
   11192, 11196, 11204, 11208, 11216, 11220, 11224, 11228, 11236, 11240,
   11248, 11252, 11260, 11262, 11264, 11268, 11272, 11276, 11284, 11294,
   11305, 11314, 11318, 11322, 11326, 11330, 11334, 11338, 11346, 11350,
   11354, 11358, 11366, 11370, 11378, 11383, 11389, 11393, 11397, 11401,
   11405, 11409, 11413, 11417, 11421, 11425, 11429, 11437, 11442, 11448,
   11452, 11460, 11464, 11472, 11480, 11488, 11492, 11500, 11504, 11512,
   11520, 11528, 11532, 11536, 11540, 11544, 11548, 11556, 11561, 11567,
   11571, 11575, 11579, 11587, 11595, 11599, 11604, 11610, 11614, 11618,
   11622, 11626, 11630, 11634, 11638, 11642, 11646, 11650, 11654, 11658,
   11663, 11669, 11673, 11681, 11685, 11689, 11693, 11697, 11701, 11705,
   11709, 11713, 11717, 11721, 11725, 11729, 11733, 11737, 11741, 11745,
   11749, 11753, 11757, 11761, 11765, 11769, 11773, 11777, 11781, 11785,
   11789, 11793, 11797, 11801, 11805, 11809, 11813, 11817, 11821, 11825,
   11829, 11833, 11837, 11841, 11845, 11849, 11853, 11857, 11861, 11865,
   11869, 11873, 11877, 11881, 11885, 11889, 11893, 11897, 11901, 11905,
   11909, 11913, 11917, 11921, 11926, 11930, 11934, 11938, 11942, 11946,
   11950, 11958, 11962, 11966, 11970, 11974, 11978, 11982, 11986, 11990,
   11994, 11998, 12002, 12006, 12010, 12014, 12018, 12022, 12026, 12030,
   12034, 12038, 12042, 12046, 12050, 12054, 12062, 12066, 12070, 12074,
   12078, 12082, 12086, 12090, 12094, 12098, 12102, 12106, 12110, 12114,
   12122, 12126, 12130, 12134, 12138, 12142, 12146, 12154, 12158, 12166,
   12170, 12178, 12182, 12186, 12190, 12194, 12198, 12202, 12206, 12210,
   12214, 12218, 12222, 12226, 12230, 12234, 12238, 12242, 12246, 12250,
   12254, 12258, 12262, 12266, 12270, 12274, 12278, 12282, 12286, 12290,
   12294, 12298, 12302, 12306, 12310, 12314, 12318, 12322, 12326, 12330,
   12334, 12338, 12342, 12346, 12350, 12358, 12362, 12370, 12374, 12378,
   12383, 12389, 12397, 12401, 12409, 12413, 12421, 12425, 12433, 12437,
   12442, 12448, 12452, 12456, 12460, 12468, 12472, 12480, 12485, 12491,
   12496, 12502, 12507, 12513, 12517, 12525, 12533, 12537, 12542, 12548,
   12556, 12560, 12567, 12572, 12578, 12582, 12586, 12591, 12597, 12601,
   12609, 12613, 12617, 12621, 12625, 12633, 12637, 12641, 12645, 12650,
   12656, 12660, 12664, 12672, 12676, 12684, 12692, 12696, 12700, 12708,
   12712, 12720, 12724, 12728, 12732, 12736, 12740, 12744, 12748, 12752,
   12756, 12760, 12764, 12772, 12776, 12784, 12788, 12796, 12800, 12804,
   12808, 12812, 12816, 12824, 12828, 12836, 12840, 12848, 12852, 12856,
   12864, 12868, 12876, 12880, 12884, 12892, 12896, 12904, 12909, 12915,
   12919, 12923, 12927, 12931, 12935, 12939, 12943, 12951, 12955, 12959,
   12963, 12971, 12975, 12983, 12991, 12996, 13002, 13006, 13010, 13014,
   13018, 13023, 13029, 13037, 13045, 13049, 13053, 13061, 13065, 13073,
   13081, 13085, 13093, 13101, 13106, 13112, 13117, 13123, 13127, 13135,
   13139, 13143, 13147, 13155, 13160, 13166, 13170, 13179, 13181, 13189,
   13194, 13200, 13205, 13211, 13215, 13223, 13227, 13231, 13235, 13243,
   13247, 13255, 13259, 13267, 13271, 13279, 13287, 13295, 13303, 13311,
   13319, 13327, 13331, 13339, 13343, 13347, 13351, 13355, 13359, 13363,
   13367, 13371, 13375, 13379, 13383, 13387, 13391, 13392, 13397, 13403,
   13407, 13408, 13412, 13420, 13428, 13432, 13436, 13444, 13448, 13456,
   13460, 13464, 13468, 13476, 13480, 13484, 13488, 13492, 13496, 13500,
   13504, 13508, 13512, 13516, 13520, 13524, 13528, 13532, 13536, 13540,
   13544, 13548, 13552, 13556, 13560, 13564, 13568, 13572, 13576, 13580,
   13584, 13588, 13592, 13596, 13600, 13604, 13608, 13612, 13616, 13620,
   13624, 13628, 13632, 13636, 13640, 13644, 13648, 13652, 13656, 13660,
   13664, 13668, 13672, 13676, 13680, 13684, 13688, 13692, 13696, 13700,
   13704, 13708, 13712, 13716, 13720, 13724, 13728, 13732, 13736, 13740,
   13744, 13748, 13752, 13756, 13760, 13764, 13768, 13772, 13776, 13780,
   13784, 13788, 13792, 13796, 13800, 13804, 13808, 13812, 13816, 13820,
   13824, 13828, 13832, 13836, 13840, 13844, 13848, 13852, 13856, 13860,
   13864, 13868, 13872, 13876, 13880, 13884, 13888, 13892, 13896, 13900,
   13904, 13908, 13912, 13916, 13920, 13924, 13928, 13932, 13936, 13940,
   13944, 13948, 13952, 13956, 13960, 13964, 13968, 13972, 13976, 13980,
   13984, 13988, 13992, 13996, 14000, 14004, 14008, 14012, 14016, 14020,
   14024, 14028, 14032, 14036, 14040, 14044, 14048, 14052, 14056, 14060,
   14064, 14068, 14072, 14076, 14080, 14084, 14088, 14092, 14096, 14100,
   14104, 14108, 14112, 14116, 14120, 14124, 14128, 14132, 14136, 14140,
   14144, 14148, 14152, 14156, 14160, 14164, 14168, 14172, 14176, 14180,
   14184, 14188, 14192, 14196, 14200, 14204, 14208, 14212, 14216, 14220,
   14224, 14228, 14232, 14236, 14240, 14244, 14248, 14252, 14256, 14260,
   14264, 14268, 14272, 14276, 14280, 14284, 14288, 14292, 14296, 14300,
   14304, 14308, 14312, 14316, 14320, 14324, 14328, 14332, 14336, 14340,
   14344, 14348, 14352, 14356, 14360, 14364, 14368, 14372, 14376, 14380,
   14384, 14388, 14392, 14396, 14400, 14404, 14408, 14412, 14416, 14420,
   14424, 14428, 14432, 14436, 14440, 14444, 14448, 14452, 14456, 14460,
   14464, 14468, 14472, 14476, 14480, 14484, 14488, 14492, 14496, 14500,
   14504, 14508, 14512, 14516, 14520, 14524, 14528, 14532, 14536, 14540,
   14544, 14548, 14552, 14556, 14560, 14564, 14568, 14572, 14576, 14580,
   14584, 14588, 14592, 14596, 14600, 14604, 14608, 14612, 14616, 14620,
   14624, 14628, 14632, 14640, 14644, 14648, 14652, 14656, 14660, 14664,
   14668, 14672, 14676, 14680, 14684, 14688, 14692, 14696, 14700, 14704,
   14708, 14712, 14716, 14720, 14724, 14728, 14732, 14736, 14740, 14744,
   14748, 14752, 14756, 14760, 14764, 14768, 14772, 14776, 14780, 14784,
   14788, 14792, 14796, 14800, 14804, 14808, 14812, 14816, 14820, 14824,
   14828, 14836, 14840, 14844, 14848, 14852, 14856, 14860, 14864, 14868,
   14872, 14876, 14880, 14884, 14888, 14892, 14896, 14900, 14904, 14908,
   14912, 14916, 14920, 14924, 14932, 14936, 14940, 14944, 14948, 14952,
   14956, 14960, 14964, 14968, 14972, 14976, 14980, 14984, 14988, 14992,
   14996, 15000, 15004, 15008, 15012, 15016, 15020, 15024, 15028, 15032,
   15036, 15040, 15044, 15048, 15052, 15056, 15060, 15064, 15068, 15072,
   15076, 15080, 15084, 15088, 15092, 15096, 15100, 15104, 15108, 15112,
   15116, 15120, 15124, 15128, 15132, 15136, 15140, 15144, 15148, 15152,
   15156, 15160, 15164, 15168, 15172, 15176, 15180, 15184, 15188, 15192,
   15196, 15200, 15204, 15208, 15212, 15216, 15220, 15224, 15228, 15238,
   15239, 15242, 15243, 15244, 15250, 15251, 15252, 15253, 15254, 15267,
   15267, 15274, 15274, 15283, 15298, 15300, 15303, 15305, 15309, 15321,
   15337, 15341, 15352, 15353, 15356, 15368, 15377, 15378, 15381, 15382,
   15383, 15386, 15387, 15390, 15391, 15394, 15395, 15398, 15400, 15402,
   15404, 15408, 15415, 15422, 15438, 15472, 15482, 15485, 15489, 15502,
   15503, 15505, 15507, 15511, 15525, 15532, 15589, 15598, 15600, 15601,
   15604, 15606, 15607, 15610, 15611, 15612, 15613, 15614, 15621, 15620,
   15630, 15632, 15634, 15635, 15638, 15639, 15640, 15641, 15644, 15645,
   15649, 15648, 15665, 15663, 15679, 15678, 15692, 15698, 15699, 15702,
   15704, 15705, 15708, 15709, 15710, 15711, 15714, 15715, 15718, 15726,
   15743, 15751, 15774, 15888, 15922, 15924, 15926, 15930, 15934, 15933,
   15984, 15986, 15985, 16000, 16006, 16013, 16018, 16024, 16025, 16028,
   16029, 16030, 16031, 16032, 16033, 16034, 16035, 16036, 16039, 16040,
   16041, 16042, 16043, 16044, 16045, 16046, 16047, 16048, 16051, 16052,
   16055, 16057, 16066, 16166, 16167, 16174, 16175, 16176, 16182, 16191,
   16194, 16195, 16196, 16197, 16200, 16201, 16202, 16205, 16207, 16215,
   16216, 16222, 16230, 16231, 16234, 16235, 16238, 16243, 16250, 16255,
   16262, 16269, 16269, 16271, 16278, 16279, 16282, 16283, 16284, 16285,
   16286, 16287, 16288, 16289, 16290, 16296, 16303, 16315, 16321, 16328,
   16336, 16337, 16349, 16360, 16371, 16375, 16376, 16379, 16384, 16388,
   16389, 16392, 16398, 16406, 16412, 16419, 16423, 16424, 16427, 16430,
   16434, 16435, 16438, 16444, 16453, 16458, 16468, 16478, 16490, 16491,
   16492, 16493, 16494, 16495, 16496, 16497, 16498, 16499, 16500, 16501,
   16502, 16503, 16504, 16511, 16512, 16515, 16516, 16523, 16524, 16525,
   16532, 16531, 16548, 16549, 16556, 16555, 16626, 16632, 16638, 16646,
   16652, 16658, 16664, 16670, 16676, 16682, 16688, 16694, 16700, 16711,
   16712, 16715, 16716, 16717, 16718, 16719, 16720, 16721, 16722, 16723,
   16724, 16725, 16726, 16727, 16728, 16729, 16730, 16731, 16732, 16733,
   16734, 16735, 16736, 16739, 16740, 16741, 16742, 16743, 16744, 16748,
   16749, 16750, 16751, 16752, 16753, 16754, 16757, 16760, 16761, 16762,
   16763, 16764, 16765, 16766, 16767, 16780, 16781, 16782, 16783, 16784,
   16785, 16786, 16791, 16792, 16793, 16794, 16795, 16796, 16802, 16803,
   16804, 16805, 16806, 16807, 16808, 16809, 16810, 16811, 16812, 16815,
   16816, 16817, 16818, 16819, 16822, 16823, 16824, 16825, 16828, 16829,
   16830, 16831, 16832, 16833, 16834, 16851, 16852, 16853, 16856, 16857,
   16858, 16859, 16860, 16861, 16865, 16865, 16868, 16874, 16875, 16878,
   16880, 16885, 16895, 16906, 16913, 16914, 16915, 16918, 16951, 16953,
   16955, 16957, 16959, 16961, 16962, 16965, 16967, 16975, 16976, 16977,
   16981, 16982, 16986, 16987, 16990, 16991, 16994, 16995, 16996, 16997,
   16998, 17001, 17002, 17003, 17004, 17005, 17006, 17007, 17008, 17009,
   17010, 17011, 17012, 17013, 17014, 17015, 17016, 17017, 17018, 17019,
   17020, 17021, 17022, 17023, 17024, 17025, 17026, 17027, 17028, 17029,
   17030, 17031, 17032, 17033, 17034, 17035, 17036, 17037, 17038, 17039,
   17040, 17041, 17042, 17043, 17044, 17045, 17046, 17047, 17048, 17049,
   17050, 17051, 17052, 17053, 17054, 17055, 17056, 17059, 17060, 17061,
   17062, 17065, 17066, 17067, 17068, 17069, 17070, 17071, 17072, 17073,
   17074, 17081, 17082, 17083, 17084, 17087, 17088, 17091, 17092, 17095,
   17096, 17107, 17108
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SQL_ALLOCATE", "SQL_AUTOCOMMIT",
  "SQL_BOOL", "SQL_BREAK", "SQL_CARDINALITY", "SQL_CONNECT", "SQL_COUNT",
  "SQL_DATETIME_INTERVAL_CODE", "SQL_DATETIME_INTERVAL_PRECISION",
  "SQL_DESCRIBE", "SQL_DESCRIPTOR", "SQL_DISCONNECT", "SQL_FOUND",
  "SQL_FREE", "SQL_GET", "SQL_GO", "SQL_GOTO", "SQL_IDENTIFIED",
  "SQL_INDICATOR", "SQL_KEY_MEMBER", "SQL_LENGTH", "SQL_LONG",
  "SQL_NULLABLE", "SQL_OCTET_LENGTH", "SQL_OPEN", "SQL_OUTPUT",
  "SQL_REFERENCE", "SQL_RETURNED_LENGTH", "SQL_RETURNED_OCTET_LENGTH",
  "SQL_SCALE", "SQL_SECTION", "SQL_SHORT", "SQL_SIGNED", "SQL_SQLERROR",
  "SQL_SQLPRINT", "SQL_SQLWARNING", "SQL_START", "SQL_STOP", "SQL_STRUCT",
  "SQL_UNSIGNED", "SQL_VAR", "SQL_WHENEVER", "S_ADD", "S_AND",
  "S_ANYTHING", "S_AUTO", "S_CONST", "S_DEC", "S_DIV", "S_DOTPOINT",
  "S_EQUAL", "S_EXTERN", "S_INC", "S_LSHIFT", "S_MEMPOINT", "S_MEMBER",
  "S_MOD", "S_MUL", "S_NEQUAL", "S_OR", "S_REGISTER", "S_RSHIFT",
  "S_STATIC", "S_SUB", "S_VOLATILE", "S_TYPEDEF", "CSTRING", "CVARIABLE",
  "CPP_LINE", "IP", "IDENT", "UIDENT", "FCONST", "SCONST", "USCONST",
  "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT",
  "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS", "GREATER_EQUALS",
  "NOT_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P",
  "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS",
  "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION",
  "ASSIGNMENT", "ASYMMETRIC", "AT", "ATTACH", "ATTRIBUTE", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALL", "CALLED", "CASCADE",
  "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS", "COMMENT",
  "COMMENTS", "COMMIT", "COMMITTED", "CONCURRENTLY", "CONFIGURATION",
  "CONFLICT", "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P",
  "CONTINUE_P", "CONVERSION_P", "COPY", "COST", "CREATE", "CROSS", "CSV",
  "CUBE", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE",
  "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER",
  "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC",
  "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED",
  "DEFINER", "DELETE_P", "DELIMITER", "DELIMITERS", "DEPENDS", "DESC",
  "DETACH", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO",
  "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P",
  "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE", "EVENT", "EXCEPT",
  "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN",
  "EXPRESSION", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY",
  "FETCH", "FILTER", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE",
  "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS",
  "GENERATED", "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P",
  "GROUPING", "GROUPS", "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P",
  "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P",
  "IMPORT_P", "IN_P", "INCLUDE", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P",
  "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL", "LIKE",
  "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP",
  "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING", "MATCH",
  "MATERIALIZED", "MAXVALUE", "METHOD", "MINUTE_P", "MINVALUE", "MODE",
  "MONTH_P", "MOVE", "NAME_P", "NAMES", "NATIONAL", "NATURAL", "NCHAR",
  "NEW", "NEXT", "NFC", "NFD", "NFKC", "NFKD", "NO", "NONE", "NORMALIZE",
  "NORMALIZED", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P",
  "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OIDS", "OLD", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR",
  "ORDER", "ORDINALITY", "OTHERS", "OUT_P", "OUTER_P", "OVER", "OVERLAPS",
  "OVERLAY", "OVERRIDING", "OWNED", "OWNER", "PARALLEL", "PARSER",
  "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS",
  "POLICY", "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE",
  "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROCEDURES", "PROGRAM", "PUBLICATION", "QUOTE", "RANGE", "READ", "REAL",
  "REASSIGN", "RECHECK", "RECURSIVE", "REF", "REFERENCES", "REFERENCING",
  "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURNING",
  "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROUTINE",
  "ROUTINES", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCHEMAS",
  "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE",
  "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET",
  "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP",
  "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE", "STANDALONE_P",
  "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE",
  "STORED", "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING", "SUPPORT",
  "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE", "TABLES", "TABLESAMPLE",
  "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIES",
  "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TRANSFORM",
  "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "TYPES_P", "UESCAPE", "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION",
  "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER",
  "USING", "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLNAMESPACES", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "XMLTABLE", "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA",
  "'<'", "'>'", "'='", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'", "','", "';'", "':'",
  "'{'", "'}'", "$accept", "prog", "stmt", "CallStmt", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "CreateSchemaStmt", "OptSchemaName",
  "OptSchemaEltList", "schema_stmt", "VariableSetStmt", "set_rest",
  "generic_set", "set_rest_more", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "reset_rest",
  "generic_reset", "SetResetClause", "FunctionSetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_drop_behavior", "opt_collate_clause", "alter_using",
  "replica_identity", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "copy_delimiter",
  "opt_using", "copy_generic_opt_list", "copy_generic_opt_elem",
  "copy_generic_opt_arg", "copy_generic_opt_arg_list",
  "copy_generic_opt_arg_list_item", "CreateStmt", "OptTemp",
  "OptTableElementList", "OptTypedTableElementList", "TableElementList",
  "TypedTableElementList", "TableElement", "TypedTableElement",
  "columnDef", "columnOptions", "ColQualList", "ColConstraint",
  "ColConstraintElem", "generated_when", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "opt_c_include", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem",
  "ExclusionWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "part_params", "part_elem", "table_access_method_clause", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateStatsStmt", "AlterStatsStmt", "create_as_target", "opt_with_data",
  "CreateMatViewStmt", "create_mv_target", "OptNoLog",
  "RefreshMatViewStmt", "CreateSeqStmt", "AlterSeqStmt", "OptSeqOptList",
  "OptParenthesizedSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "AlterForeignTableStmt",
  "ImportForeignSchemaStmt", "import_qualification_type",
  "import_qualification", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreatePolicyStmt",
  "AlterPolicyStmt", "RowSecurityOptionalExpr",
  "RowSecurityOptionalWithCheck", "RowSecurityDefaultToRole",
  "RowSecurityOptionalToRole", "RowSecurityDefaultPermissive",
  "RowSecurityDefaultForCmd", "row_security_cmd", "CreateAmStmt",
  "am_type", "CreateTrigStmt", "TriggerActionTime", "TriggerEvents",
  "TriggerOneEvent", "TriggerReferencing", "TriggerTransitions",
  "TriggerTransition", "TransitionOldOrNew", "TransitionRowOrTable",
  "TransitionRelName", "TriggerForSpec", "TriggerForOptEach",
  "TriggerForType", "TriggerWhen", "FUNCTION_or_PROCEDURE",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertionStmt",
  "DefineStmt", "definition", "def_list", "def_elem", "def_arg",
  "old_aggr_definition", "old_aggr_list", "old_aggr_elem",
  "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type_any_name", "drop_type_name", "drop_type_name_on_any_name",
  "any_name_list", "any_name", "attrs", "type_name_list", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type_any_name",
  "comment_type_name", "comment_text", "SecLabelStmt", "opt_provider",
  "security_label_type_any_name", "security_label_type_name",
  "security_label", "FetchStmt", "fetch_args", "from_in", "opt_from_in",
  "GrantStmt", "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "GrantRoleStmt", "RevokeRoleStmt", "opt_grant_admin_option",
  "opt_granted_by", "AlterDefaultPrivilegesStmt", "DefACLOptionList",
  "DefACLOption", "DefACLAction", "defacl_privilege_target", "IndexStmt",
  "opt_unique", "opt_concurrently", "opt_index_name",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_class", "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "transform_type_list", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "operator_with_argtypes_list",
  "operator_with_argtypes", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "CreateTransformStmt", "transform_element_list", "DropTransformStmt",
  "ReindexStmt", "reindex_target_type", "reindex_target_multitable",
  "reindex_option_list", "reindex_option_elem", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectDependsStmt",
  "opt_no", "AlterObjectSchemaStmt", "AlterOperatorStmt",
  "operator_def_list", "operator_def_elem", "operator_def_arg",
  "AlterTypeStmt", "AlterOwnerStmt", "CreatePublicationStmt",
  "opt_publication_for_tables", "publication_for_tables",
  "AlterPublicationStmt", "CreateSubscriptionStmt",
  "publication_name_list", "publication_name_item",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "opt_transaction", "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "opt_transaction_chain", "ViewStmt",
  "opt_check_option", "LoadStmt", "CreatedbStmt", "createdb_opt_list",
  "createdb_opt_items", "createdb_opt_item", "createdb_opt_name",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "vac_analyze_option_list",
  "analyze_keyword", "vac_analyze_option_elem", "vac_analyze_option_name",
  "vac_analyze_option_arg", "opt_analyze", "opt_verbose", "opt_full",
  "opt_freeze", "opt_name_list", "vacuum_relation", "vacuum_relation_list",
  "opt_vacuum_relation_list", "ExplainStmt", "ExplainableStmt",
  "explain_option_list", "explain_option_elem", "explain_option_name",
  "explain_option_arg", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause", "InsertStmt",
  "insert_target", "insert_rest", "override_kind", "insert_column_list",
  "insert_column_item", "opt_on_conflict", "opt_conf_expr",
  "returning_clause", "DeleteStmt", "using_clause", "LockStmt", "opt_lock",
  "lock_type", "opt_nowait", "opt_nowait_or_skip", "UpdateStmt",
  "set_clause_list", "set_clause", "set_target", "set_target_list",
  "DeclareCursorStmt", "cursor_name", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_with_clause", "into_clause", "OptTempTableName",
  "opt_table", "all_or_distinct", "distinct_clause", "opt_all_clause",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value", "select_fetch_first_value",
  "I_or_F_const", "row_or_rows", "first_or_next", "group_clause",
  "group_by_list", "group_by_item", "empty_grouping_set", "rollup_clause",
  "cube_clause", "grouping_sets_clause", "having_clause",
  "for_locking_clause", "opt_for_locking_clause", "for_locking_items",
  "for_locking_item", "for_locking_strength", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "opt_alias_clause", "func_alias_clause", "join_type",
  "join_outer", "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "xml_passing_mech", "within_group_clause",
  "filter_clause", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "opt_window_exclusion_clause", "row",
  "explicit_row", "implicit_row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "unicode_normal_form", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "case_default", "case_arg", "columnref", "indirection_el",
  "opt_slice_bound", "indirection", "opt_indirection", "opt_asymmetric",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "SignedIconst", "RoleId", "RoleSpec", "role_list",
  "NonReservedWord", "unreserved_keyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", "statements", "statement",
  "CreateAsStmt", "$@1", "$@2", "at", "ECPGConnect", "connection_target",
  "opt_database_name", "db_prefix", "server", "opt_server", "server_name",
  "opt_port", "opt_connection_name", "opt_user", "ora_user", "user_name",
  "char_variable", "opt_options", "connect_options", "opt_opt_value",
  "prepared_name", "ECPGCursorStmt", "ECPGExecuteImmediateStmt",
  "ECPGVarDeclaration", "single_vt_declaration", "precision", "opt_scale",
  "ecpg_interval", "ECPGDeclaration", "$@3", "sql_startdeclare",
  "sql_enddeclare", "var_type_declarations", "vt_declarations",
  "variable_declarations", "type_declaration", "$@4", "var_declaration",
  "$@5", "$@6", "opt_bit_field", "storage_declaration", "storage_clause",
  "storage_modifier", "var_type", "enum_type", "enum_definition",
  "struct_union_type_with_symbol", "$@7", "struct_union_type", "$@8",
  "s_struct_union_symbol", "s_struct_union", "simple_type",
  "unsigned_type", "signed_type", "opt_signed", "variable_list",
  "variable", "opt_initializer", "opt_pointer", "ECPGDeclare",
  "ECPGDisconnect", "dis_name", "connection_object", "execstring",
  "ECPGFree", "ECPGOpen", "opt_ecpg_using", "ecpg_using",
  "using_descriptor", "into_descriptor", "into_sqlda", "using_list",
  "UsingValue", "UsingConst", "ECPGDescribe", "opt_output",
  "ECPGAllocateDescr", "ECPGDeallocateDescr", "ECPGGetDescriptorHeader",
  "ECPGGetDescHeaderItems", "ECPGGetDescHeaderItem",
  "ECPGSetDescriptorHeader", "ECPGSetDescHeaderItems",
  "ECPGSetDescHeaderItem", "IntConstVar", "desc_header_item",
  "ECPGGetDescriptor", "ECPGGetDescItems", "ECPGGetDescItem",
  "ECPGSetDescriptor", "ECPGSetDescItems", "ECPGSetDescItem",
  "AllConstVar", "descriptor_item", "ECPGSetAutocommit", "on_off",
  "ECPGSetConnection", "ECPGTypedef", "$@9", "opt_reference", "ECPGVar",
  "$@10", "ECPGWhenever", "action", "ECPGKeywords", "ECPGKeywords_vanames",
  "ECPGKeywords_rest", "ECPGTypeName", "symbol", "ECPGColId", "ColId",
  "type_function_name", "ColLabel", "ECPGColLabel", "ECPGColLabelCommon",
  "ECPGCKeywords", "all_unreserved_keyword", "ECPGunreserved_interval",
  "into_list", "ecpgstart", "c_args", "coutputvariable", "civarind",
  "char_civar", "civar", "indicator", "cvariable", "ecpg_param",
  "ecpg_bconst", "ecpg_fconst", "ecpg_sconst", "ecpg_xconst", "ecpg_ident",
  "quoted_ident_stringvar", "c_stuff_item", "c_stuff", "c_list", "c_term",
  "c_thing", "c_anything", "DeallocateStmt", "Iresult", "execute_rest",
  "ecpg_into", "opt_ecpg_into", "ecpg_fetch_into", "opt_ecpg_fetch_into", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,    60,    62,    61,   798,    43,    45,    42,
      47,    37,    94,   799,    91,    93,    40,    41,    46,    44,
      59,    58,   123,   125
};
# endif

#define YYPACT_NINF -5580

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5580)))

#define YYTABLE_NINF -3077

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-3077)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
   -5580,  1039,  8116, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, 37974, -5580, -5580, -5580, -5580, -5580,130062,
    1078, -5580, -5580,135491, -5580, -5580, -5580,   419, 87876, -5580,
   91614,  1326, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   95886, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   74508,  1813, -5580,  1087, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580,    40, 20364, -5580, -5580, 92148, -5580,   170, -5580, -5580,
   -5580, -5580, -5580, 76113, -5580, -5580, 92682,   925, -5580, -5580,
    1220,  1413, -5580,   177, 19133, -5580, -5580, 93216, 88944, -5580,
   -5580, 96420,   849,  1179, 19832,    40, 37436, 96954, -5580,  1223,
   -5580, 70726, -5580, -5580, -5580, 88410, -5580, -5580, -5580,  1653,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
  103896,  1819,  1442, 71269, -5580, -5580, -5580, -5580, -5580,103896,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, 97488,
   -5580,  1562,  1728,   766,104430,104964, 86274, -5580,  1590, -5580,
  103896,  1803,  1730, 73438, -5580,105498, -5580, -5580,  1698, -5580,
   98022, -5580, -5580, -5580, -5580, -5580,  1442, -5580, 74508, 69654,
     438,  1644, -5580, -5580,106032, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580,103896,  2118,  1736, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580,  1515, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580,   861, -5580,  1446,   964,  1781,   224,  1779,
   -5580, -5580, -5580, 12096, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580,131655,   478, -5580, -5580, -5580,  1807, -5580,  1830, -5580,
   -5580, -5580,  2003, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
    1052, -5580, -5580, -5580, -5580,  2400,130593, 95886, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, 89478, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,   234,
   -5580, -5580, -5580, -5580, -5580, 95886, 95886, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, 95886,  1954, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580,  1032,  2214, -5580, -5580, 74508,
    3023,  3023,  2548,131655, -5580, -5580,  2467, 76113,103896,103896,
  103896,  2207,103896,  2102,103896,   489, 76113,138770, 98556,  2267,
    2105, 64752,106566, -5580, 76113,103896,136898, 76113,103896,103896,
  107100,103896,107634,103896,   114, 93750,103896,  2205,103896,103896,
  137366,108168,  2345, -5580,  2608,  1638, -5580,  2096, -5580,   201,
   -5580,  2027, -5580,   204,   235,   265, -5580, -5580, -5580,103896,
   19894,  1819,  2467, -5580,  2118,103896,  2353,103896,  2124,108702,
    2202,103896, -5580,103896,  2224,109236,   826,  2275,138770,  2283,
   65299,  2333,103896,103896,138770,109770,110304,110838,103896,103896,
   -5580, -5580,  2288,103896,103896, -5580,  2415,139238,  1914,  2421,
    2605,  2504,   434, -5580, -5580,  2694,  2236, -5580, -5580,  2757,
   95886, -5580, 94284, -5580, -5580, -5580,  2523, -5580, -5580, -5580,
   -5580, -5580, -5580,142046,  1179, -5580, -5580,  2527, 76648,  2598,
   -5580, -5580,111372, 81463,  2349, -5580,   831, 77183,139706,  2705,
    2361, 65846,  2772, -5580, 77718, -5580,140174, 78253, -5580, -5580,
   -5580, -5580, -5580,111906, -5580,112440,  2483,  2598, -5580, 81998,
  140642, -5580,  2625,112974,113508,114042,  2467, 10204, -5580,  2356,
    2753,  2370,  1247, 95886, 95886,  1346,133122, -5580, -5580,   925,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,   221,   288,
   71812,   807, 72355, -5580, -5580,   944,   976,  1153,   221,  2841,
    2841,   884, 95886, -5580, -5580,   288, -5580,   931,   803,  2373,
    2373,  2373,  2589,    21, -5580,  2373,  2520, -5580, -5580, -5580,
   -5580, 98022, 71812, 72355, -5580,  2408,  1819,   354,  2869,  2489,
   -5580, -5580, -5580, -5580, -5580,  2501,  2864,  2864,103896, -5580,
   -5580, -5580,  2912,  2491,  2759, -5580,  2490, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580,  2707,  2710,  2723,   296,
    1819,   255, -5580,  2847, -5580,  2726, 44018, 44018,  1574, 95886,
    1819, 72898, 99090,125790,   184,142046,  1819,114576,  2555,  1633,
    2736, -5580, -5580, -5580,   791, -5580,  2982,  2570,  2816,   180,
    1638, 61501, -5580,  2557,  2027, 98022,132186, -5580, -5580, -5580,
   -5580,141110,  2882, 47882,103896,  2568, -5580,  2592,  2568,  2580,
    2613,  1781, -5580,141110,103896,  1763,  1763,  3060,  1763,  1918,
    2146, -5580,  1625, -5580,  2962,  2978, 98022,  2686,    40,  2704,
   -5580, -5580, -5580,  2730, -5580,  2724,  2750, -5580,  1178,  3024,
   -5580, -5580, -5580, -5580,  2825,  2840,  2845,  2852,  2779,  2885,
     355, -5580, -5580, -5580, -5580,  3149, -5580, -5580, -5580, -5580,
   -5580, -5580,  3258,  3270,135962,135962,  1134,  1135,   247,   279,
   -5580, -5580, -5580,  3128, -5580, -5580,  3126,  2936,103896, -5580,
   -5580,103896, -5580,115110, -5580, -5580,  3023,  2730,  1240, -5580,
    1933,  2877,  2192,  2862,  2044,  1672, -5580,   269,103896,   476,
    2914, 99624,  7606,  2890,  2895,  2027,  3051,  1883,  3195,  3238,
    9170,   355,100158, -5580, -5580, -5580, -5580,103896,103896, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,  2901,  1617,
   -5580, -5580,  2900,  3241,  3112, 12709,   871,  3203,  3062,  1679,
   12875,  3118,  1928,  3249,  9384,  1800,  3250,  2133,  1904,115644,
  126324,  3209,  3254,  8373,  2327,   878,  3125,  1168,  3203,  3243,
    3073,  1679,  3259,  2737,103896,  2916, -5580,  3182,  3294,    91,
   -5580,   160, -5580, 38517, 47882, 68582, -5580,  2027,  2981,  3134,
      84,  3173, 76113,  2930, -5580, -5580,103896, -5580, -5580, 82533,
    3006, -5580,   893, 76113, -5580,  3146,  2979, 66393,103896, 76113,
   -5580, -5580, 76113,103896, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580,  3067,  3262,103896, 82533, -5580,  3206,103896,103896, -5580,
   -5580,  2938, -5580, -5580, -5580, -5580,  2373,103896,  3359, 82533,
    3168,   361,103896,  1720,  3396,103896,  3171,  1720,  2983,116178,
   -5580, -5580,  1720, -5580, -5580,103896,103896,  2949,  1685,  3159,
    3278,  1720,  3177,  3397,  3398,  3178,  3030,  3184,  2592,  3363,
    3155,  1136,  1776,   167,  2319,  1720,  3008,116712,117246,103896,
    3010,103896,  2864, 76113, 76113, 76113,103896,  3292, -5580,  3142,
  100692, -5580,  2966,  2694, -5580, -5580, -5580, -5580, -5580,  1483,
   -5580, -5580, -5580, -5580, -5580,  3310, -5580,   211,  3311,  2974,
    3314,  1765, -5580,  3025, -5580,  3025,  3025,  2977,  2977,  3160,
    2984,  3317, -5580, -5580, -5580,  2810,  3025,  2977, -5580, 83603,
   -5580,  2098,  2150, -5580,   223, -5580,  3431, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580,  2985, -5580,  1069, -5580,  2247,
   -5580, -5580, -5580, -5580,  3015, -5580,  3321,   273, -5580,  3324,
   -5580,  2986,117780, -5580,118314,118848,  3325,   274, -5580,138770,
    3326,   273,  3330,  2986,  3331,   273,  3332,   319,  3333, -5580,
    1180,  3322,  3336,   223,  3337,  2368,  2986,142514,  3338,   278,
   -5580,  3339,   281, -5580,  3340,  3211, -5580, 14018, 10204, -5580,
   16529,  2222, -5580, -5580, -5580, -5580, -5580, -5580, 47882,  1228,
    3096, -5580, -5580, -5580,  2257, -5580,134545, -5580,  1346,   288,
   -5580, 95886,   288, 95886,   884,   288, 95886,   288, 95886,   884,
     288, 95886, 95886, 95886,   288, -5580, -5580,   382,   305, -5580,
   -5580, -5580, -5580, -5580, 95886,  3005,103896,103896, -5580, -5580,
   -5580, 90012,138770, 90546, -5580,103896, -5580,   401, 95886, -5580,
   95886, -5580,  1819, -5580, -5580,  2753, 82533,  3455,138770,  2864,
   -5580,  2312, -5580, -5580,103896,103896, -5580, -5580, -5580,  3267,
  103896,  3334,  3341, 90012,138770, -5580,119382, -5580,142046,  3216,
    3014, -5580, -5580, -5580, -5580,  2322,  3495,   193,  3501, 47882,
    3019,   193,   193,  3022,  3352, -5580, -5580, -5580,   280,  3028,
    3031, -5580,   220,   220, -5580,  3032,  3033, -5580,   225,  3034,
    3035,  3517,   229,  3038,  3039,  3041,  2810,   193,  3044, 47882,
   -5580,  3045,   220,  3047,  3049,  3050,  3531,  3053, -5580,  3534,
    3056,   190,   219,  3057,  3059, -5580,  3032, -5580,   253,  3061,
    3063,  3064,  3065,  3066,  3069,  3070,  3071, 47882, 47882, 47882,
   -5580, 42362,  2027,  1819, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580,   257,  6186, -5580,  3103, -5580, -5580,  3256, -5580,
   -5580, 47882, -5580, -5580,   832, -5580,   259, -5580, -5580,  2027,
   -5580, -5580,   491, -5580, -5580, -5580, -5580, -5580,  3348,  3072,
    2438,  2438,   249, -5580, 92148, 92148, -5580, -5580,  1911,  3074,
   -5580,  2250, -5580, -5580, -5580, -5580, -5580, -5580,141578,  3525,
   -5580,   300,  1819,   160,   352,  3467,133593,134069,  3356,  3356,
    3342, -5580, -5580,103896, -5580, -5580,  2027,   165,  3355,  2323,
   -5580, -5580,134545, -5580, -5580,   925, 18913,  2326,  2568,103896,
  103896,  3532, -5580, -5580,  2344, -5580,  3081, -5580,  2592, -5580,
   -5580,  1781,  1781, 47882,  1781,   251,  1734, 44570, 48434,  3410,
    3297,  1714,  1968,  3414, -5580,  3303,  1918,  2146, 98022,103896,
  119916,  3212, 47882, -5580,  2730,  3099,  2392, -5580, 84672,131124,
  131124,  3373, -5580, -5580,  1494,   169,  3224,  3335,  2841,   162,
    1936,  1936, -5580, -5580,  3093, -5580,  3470, 92148,  3156,135962,
   -5580, -5580,103896, -5580, -5580,101226, -5580, -5580, -5580,   463,
    3095, -5580,  3111,103896,  3644,  1936,  1936, -5580, -5580,  3100,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,131655,103896,
   -5580,  3102,  3107,  3106,  3114, -5580,132186, -5580,  3533,  3192,
    3196,  3251, 69118, -5580,  3198,  3164,  3200,  3255, 74508,  3113,
    3202,  3204,  3263,  3383, -5580, -5580,  3210,  3222,126858, -5580,
   -5580,   886, -5580, -5580, -5580,   886, -5580,  3154, -5580,  1845,
     857,   293,  3225,   456,  1031,  3546, -5580,  1570, -5580, -5580,
    3281, -5580,  6822,103896,  3487,  9400,  3358,   355,  3280, -5580,
   -5580, -5580,  3416,  3235,103896,  3236,  3375,   355,   295,127392,
   -5580, -5580,103896, -5580, -5580, -5580, -5580,  3840,  3522, 41282,
   -5580,  1692,  3239,  3217,  3257,103896, 85206,  1371,  3349,  3370,
      85,  2343,   212,  3307,103896,  2001,  3378,103896,  3176,  3260,
    3261,  3480,  3179,  1726,  3582,  3181, -5580, -5580, -5580,  3549,
    3379,  3485,  3535, 10334,  3252,  3264, 79858, -5580,  3273,  1076,
   66940,103896,103896,  3274,  3275,127926,  3840,  3563,  3293,  3296,
    3282,  3285,    17,  3578,  1068,  3289, -5580, -5580, -5580,  1068,
    3295,  3298,128460,  3840,  3576,103896,  3299,  3300,103896, 83603,
     355, -5580,  3645,   355,   355,  2296,  3647,  3302,   316,  3461,
    1273,  1720,  3181,  2309, -5580,  3304,  3306,   926, -5580,  3421,
  103896,  3309,  3312,  1327,  1819, -5580, -5580,  3313,  3399,  3315,
    1109, -5580, -5580,  1716,  3316, 98022,  3424,  3425,  2001,   395,
    1853,  3181, -5580,  3318,  3319,  3179,  3179,103896,103896,103896,
  103896,103896,   216,  3683,  3684,  3323,   200,  1433,  3244, -5580,
    1068,137834,  3328, -5580,  1068,103896,   186,  2021,  3181,  2091,
   -5580,  2029, -5580, -5580, -5580,  1638, -5580, 47882, 47882, 47882,
    3245, -5580,  2873, 18913,  1115, -5580,   261, 14432,  3246, -5580,
   -5580, -5580, -5580,103896, -5580,103896, -5580,  3518, 82533,  3457,
    3524, -5580,  3290, -5580,  3530,   355, -5580,103896,103896,  3537,
    3474,  3542,  3543,  3478,  1198, 82533,  3479,  3547, -5580,  3548,
    3550,  3357,   173,  3345,  3284,  3727,  3618,103896, 74508, -5580,
    3741,   886, -5580, 82533,  3490,  3623, -5580,103896,  3509,  1214,
   -5580,  3660,  3343, -5580, -5580,    79,103896,   266,  3327, -5580,
   -5580,  3627,138770,   336,  3629,  1819,  3344,  3630,  3502,  1819,
  138770,  3554,103896,103896,103896,103896, -5580, -5580,  3508,  1053,
     194, -5580,137834,  3519, -5580,103896,  3520,  2309,  3521,  3752,
      99,  2373,120450,  3631,120984,  3320,  3329,  3329,  3753, 82533,
    3579, -5580, -5580,  3308,  2841, -5580,  2966, -5580,  2381, -5580,
    3444, -5580, 76113, -5580, -5580, 76113, -5580, -5580, 82533,103896,
    3351, -5580,  3353, -5580, -5580, 47882, -5580, -5580, -5580,  2841,
   -5580, 82533,  3025,  3025, -5580, -5580,  3763,  3401,  3403,  2841,
   -5580,  2841, -5580, 82533, -5580,  3346,  3347,  2841,  3394, -5580,
    3395,  2841, -5580,  2358, -5580, -5580, 76113, 76113, -5580,138770,
  138770,  3654,   278,  3655,  3382,  3665,  3384, 66940, 66940, -5580,
     306, 76113, -5580,138770, 76113, -5580,103896, -5580,103896, -5580,
   -5580, -5580, -5580, 82533, 82533, -5580,138770,137834,  3668,  3669,
     319,103896,103896, -5580,103896,103896, -5580,103896,103896, -5580,
   15689,  2258, -5580, 10204, -5580,  2362,  3356, -5580,  1954,121518,
    1600,  1346,141110, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, 95886, -5580, 95886,   884, -5580, -5580, 95886, -5580, 95886,
     884, -5580, 95886, -5580, -5580, -5580, 95886,103896,  3876,  3354,
   -5580,   491, -5580,103896,  2366, -5580, -5580,  2375,  1479,103896,
  103896,   859, 76113,103896,  3551, 76113, 76113,103896,103896,103896,
  103896,103896,  3415,  3074,  1356, -5580,  1216,   423, 98022,  3553,
   -5580, -5580, -5580, -5580, -5580,  2396,  2118,  1036,103896,   961,
    2501, -5580, -5580, -5580, -5580, 90546, 88410,  3656,   158,103896,
   -5580, -5580,  6462, 47882, 43466, -5580, -5580, 18913,  3380, 47882,
   47882,  3361,  2841,  2841, -5580,   385, 47882, 47882, 47882,  2841,
    2841, 47882,  7369, 47882, 66940, 47882, 51746, 39623, 47882, 47882,
   42914, -5580, 47882,  3580, 53402, 47882,   352,  3581, 47882,   352,
    7369,  3814,  3814,  1644,  1737,  7143,  3360,  2027, -5580,  2841,
     968,   318, 82533, 47882, 47882, 47882, 47882, 74508,  3430,   283,
  103896, 47882,  3362,  2826, -5580, 47882, -5580,  3364, 47882,  3432,
     979, 47882, 47882, 47882, 47882, 47882, 47882, 47882, 47882, 47882,
   -5580, 55019,   328, -5580,  3666,  3694,  1140,   794, 91080, 44018,
    3688, -5580, 38517, -5580,   187, 95886, -5580, -5580,  2027,  3688,
   -5580, -5580, -5580, -5580, -5580,   463,  3366, -5580,  3387, -5580,
   -5580, -5580, -5580, -5580,103896,  3525, -5580, -5580,  3449, -5580,
   -5580, -5580, -5580,   263, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580,  3369, -5580, -5580, -5580, -5580,  3369, -5580, -5580,
    3356,  3372,  3680,  3681,   319,131655,103896,141110, -5580, -5580,
   -5580,  2919, -5580, 47882, -5580,  2406,  2348,103896,103896, -5580,
    3657, -5580,  3377, -5580, 14520,  3657, -5580, -5580, 52298,  3506,
    3651,  3596, -5580, -5580, -5580,  3390, 18913, 47882, 47882, -5580,
    2635, 18913,  2646, -5580, -5580, -5580, -5580, -5580, -5580,  1659,
   -5580,103896,   772,  3410,  1968,  3458,   892,  3848,103896, -5580,
   62040,  2424,  2561, -5580,  2730, -5580, -5580, 13376, -5580, 36618,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,  3400,
   -5580, -5580, -5580, -5580, -5580,   355,  3402,  3927, -5580,135962,
   -5580, -5580, -5580,  3876, -5580,  2757, -5580,  2757,  3952, -5580,
   95886, -5580, -5580, -5580, -5580,   309, -5580, -5580, 10204, 10204,
   -5580, -5580,138770,103896,103896,  3605, -5580,  3839, -5580, 83603,
   -5580,  3408, -5580, 83068, 78788, -5580, -5580,    77, -5580,   740,
  138770, -5580,103896,103896, -5580, 74508,138770,103896,103896, -5580,
  138770,103896,103896, -5580, -5580, -5580, -5580, -5580,135018,    75,
   88410,  3544, 86808, -5580, -5580,  3411,103896,  3471,  3687,  3693,
    1336, -5580, -5580,122052, -5580,  3632,138770,103896,103896, 47882,
    3636,103896,103896, -5580,   521,  3504,  3505, -5580,103896,  3507,
    3670, 76113,  3428,103896,103896, 82533,  3510,   905, 76113,  3473,
   67487, 76113, 76113,103896,103896,103896,103896,  3561,  3756, 82533,
  103896,  3700,  1540, 98022,   282,  2048,  3181,  3658, -5580,   301,
   -5580,138770, -5580,103896,  3641, -5580, -5580, -5580,101760,  3877,
    3557, -5580, -5580, -5580,128994, -5580, -5580,  3646, -5580,  2425,
   -5580,138770,138770,103896, 10952,122586,  1695,  3664, -5580, -5580,
   82533, -5580,103896,102294,103896,103896,  3697,103896, 94818,123120,
  123654,    86,  1634,  3702,103896, 95352,  3707, -5580,  3586,103896,
   -5580, -5580, 75043,138770,103896,  1335, 74508, -5580, -5580,103896,
   -5580,  1077, -5580,103896,  4498,  3663,  3529,  3540,103896,   375,
    2138,  3181,  3816,103896,103896,  3453,  2440,138770,103896, 74508,
   -5580,  3667,  1589,138770,103896,101760, -5580,  3671, 98022, 98022,
  138770,103896, 98022, -5580,103896,125790, -5580,138770,  1110, -5580,
  138770,103896,101760, -5580,  3673,  3611,138770,103896,  9625, -5580,
   -5580, -5580,   355, -5580, -5580, -5580, -5580, -5580,103896,103896,
     355,103896,103896,   355,  1718, -5580,138770,103896, -5580, -5580,
   -5580,  3583,138770,103896,103896,   221, -5580,138770,  3327,103896,
   74508, -5580,103896,  8618,103896,103896,103896,103896,103896,103896,
  138770,103896, -5580, -5580,  1516,  1550,  1723,  2060,  1455,103896,
    3760,103896,124188,138770,103896,103896,  1819,103896, 74508,  2144,
   -5580, -5580,  3584, -5580,138770,  1110, -5580, 11314,103896,103896,
  103896,  3541,  3556,   210,  3634, -5580, -5580, -5580,  1119,  1119,
    3672, -5580, 47882, 47882, 45122,  3472, -5580, -5580, 47882, -5580,
   -5580, -5580,  1061,  3920,124722,  1061, -5580,  1061,  3748,  3538,
    3555,  1061,103896,  1061,  1061,103896, -5580, -5580, -5580, -5580,
    3746,103896,  1061,  1061,  1061,  3674, -5580, -5580,  3674,  1018,
   47882, 82533,103896, -5580,  2443, -5580,  3496,  1053, -5580, -5580,
   74508,103896,   205,   830,  3822,  3701, 85740,  2600,  3812,103896,
    3545,103896,  3946,  3589, 98022,  2949, -5580,  2600,103896, -5580,
    1290, 88410, -5580, -5580, -5580, -5580, -5580, -5580, -5580,103896,
   -5580, -5580,  3823,103896, 47882,  3676, -5580,  1819,  2949,  2949,
    2949,  2949, -5580, -5580, -5580, -5580,  3715,  1951, -5580,  3503,
    2949,103896,  3635,  3843,  2600,  3514,  3846, -5580,  2309,  3853,
    3849,103896,  3729, 85740,  3573,  3558,  3743,  3971,  2373,  1819,
    3747,  3731, -5580, 69118, -5580,  2949, 41822,  7303,  7600,  3733,
    3795,142046,100692, -5580,  3536,  3834,  3838,  3859, -5580,   211,
   -5580,  3989,  2038,  3881, 47882,  2448,  3552,   223, -5580, -5580,
    3560,  3347,  3569,  3585,  3562,  3566, -5580,  2841, 60423,  3574,
     203,  3799,  3575, -5580,   273, -5580,  2986, -5580,103896, -5580,
  103896,103896,103896,103896,   274, -5580, -5580,   273,  2986,   273,
     319, -5580,  3829,   223,  2986,  3686,  3895,142046, -5580,   278,
   -5580,   281, -5580,  3780,   319, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580,  3797,  2373,  2381, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, 95886,  2757, -5580,  2449,
   -5580,103896, -5580,  3874,  3875,  3878,  3886,  3888,  3590,  3591,
    3628,103896,  3600,  3590,   355,  3600,  3600,  3590,  3074,  3074,
    3590,  3591,138302,  4046,  3912, -5580,  3685,  3604,  3928,   850,
   -5580,   958,  1024,  3860, -5580, -5580, -5580, -5580, 82533, -5580,
  138770,  3649,  2864,  2864, -5580,   321,  3826,  3617,138302,  4052,
     319, -5580, 76113, -5580, -5580, 82533,  3699,  3714, 76113,  3844,
    3689, 76113, -5580, -5580, 76113, -5580, -5580, -5580, -5580, -5580,
   82533, -5580,  3893,103896,103896,  2460, -5580,  2274, -5580,  2281,
   47882,   195, -5580, 16752,  2466, 47882,  3642,  3662, -5580, -5580,
   -5580, -5580, -5580, -5580,  3675,  3961, -5580, -5580,  2480,  2487,
    2492,  3677,  3678,  4884,  6275,  3682, 17227,  3696,  3661, 51746,
   51746, 42362,   570, -5580, 51746,  3703,  3852,  2500, 14606,  3639,
    3704, 17411, 45674, 47882, 45674, 45674, 17813,  3639,  3705,  2518,
   74508,  3847, 18124,  2524, -5580, 47882, 74508,  6288, 47882, -5580,
   47882,  3706, -5580, -5580,  5226,  5226,  5226,  7369, -5580,  3712,
   -5580, 51746, 51746, -5580,  2874, 42362, -5580, -5580,  3977, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580,  2376, -5580,  3698, -5580,
   -5580,  3883,  3499, 66940,  6360, 47882,   304, 47882,  3362, 47882,
    3744,  5226,  5226,  5226,   582,   582,   236,   236,   236,   424,
     794, -5580, -5580, -5580,  3708,  3709,  3713,  3862,  3718, 47882,
   -5580,  2519,  2614,103896,  9835, 12180, 12715, -5580, -5580, -5580,
   56110,  3710,  1115, -5580, -5580, -5580,  3710,  1074,  3952,   463,
   -5580,  1638,  2841,   968,134545, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580,103896, 18913, -5580, -5580,  3913,  3720,
   -5580, -5580, 47882, -5580, -5580,  1583,  3717,  1192,  1054,  1936,
    1936,  2635,  1193, -5580, -5580,  3724, -5580, 47882, -5580,  2738,
    2747, -5580, -5580, -5580, -5580,  3074, -5580,  3918, -5580, -5580,
   -5580, 56110,  3711,  3719,    60, 59884,  3890, -5580,103896, -5580,
  103896,   324, -5580,  3695, -5580, -5580, -5580, -5580,   959, -5580,
   -5580, -5580, -5580, -5580, -5580,  3722, -5580,  3721, -5580,  3723,
   -5580, -5580, -5580, -5580,   226,  3726,  3732,  3738,  2166, -5580,
   -5580, -5580, -5580, 78788,  2247, -5580, 83068, -5580, 83068, -5580,
    2247,  4117, -5580, 78788,   -16, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,138770,138770,
    3896,103896,  3919,  3923, 47882,   948,103896,  3730,  3734,  1742,
    4014,103896, -5580,  4070,   319, -5580, -5580,  3821, -5580, 18913,
   -5580, -5580, -5580, -5580, -5580,138770,103896, -5580,142046, -5580,
  103896, -5580, 82533, -5580, -5580, -5580,103896,  3776,103896, -5580,
  103896,103896,103896, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
    1298, 82533, -5580, -5580,103896,103896,   166,  3825,  3827,103896,
   -5580,  1227,  3421, 11613,103896,103896,103896,  4039, -5580, -5580,
   -5580, -5580,  3974, -5580,  4092, -5580, 78788, -5580,  2986,   694,
    3842,  3181,  3981, -5580,  4097,  3968, -5580,  3889,  1132, -5580,
   -5580,  3898, -5580, -5580, -5580, -5580,  4105,   319,  4108,   319,
  103896,103896,103896,103896,  3900, -5580, -5580, -5580, -5580,  3902,
    4035, -5580, 74508, 74508, 74508,  2531, -5580, -5580,  1819, -5580,
   -5580, -5580, -5580, -5580, -5580,  4068, -5580,  2536, -5580,  1332,
   -5580, -5580, -5580, -5580, -5580,  4113,138770,103896, 11700,103896,
  103896,103896,  3987,  2201, -5580,   913, 82533, -5580, 80393, -5580,
   -5580,  2539, -5580,  3791,103896,  3861,138770,  3841, -5580, -5580,
   -5580,  4118,  3783,  3783, -5580, -5580,  3783, -5580, -5580,  4045,
    3975, -5580,  1072,  3976,138770,  3854, -5580, -5580, -5580, -5580,
   -5580,  4123,  3879, -5580, -5580,  3880,  2254,  3181,  2309, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,  3899, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580,  1837, -5580, -5580,  1596,
     397,  2268,  3181, -5580,  1984, -5580,  3882, -5580,  3884, -5580,
   -5580, -5580,  4044,  4049,  4051,  3885,  3891,  3942,  3892,  3894,
    3943, -5580,  3901,  3947,  3903,  3953,  3904,  4182,   319, 82533,
    4043,  1819,  3950,  4160,   319, -5580,  3906, -5580,  3907, -5580,
    2553,  4273, -5580,103896, -5580,   460,  2305,  3181, -5580,  3914,
   -5580,138770,103896, -5580, -5580, -5580, 47882,  3831,  3832,  3845,
   18913, 18913, 47882, -5580, -5580, 18913,  3850, -5580, -5580, -5580,
   82533,103896,  4116, -5580, -5580,  1061,103896,103896, -5580,  4119,
   -5580, -5580,  4125,103896,  4126, -5580, -5580, -5580, -5580,   414,
     414, -5580, -5580,  4147,  7329,  3855,   377, -5580, 74508, 63657,
    2070,  1715,   471,  1720, -5580,142046,103896,142046, -5580,   830,
    3968,103896,103896,103896,  3856,  3864, -5580, -5580, -5580, -5580,
  138770,  1431,138770,  2841, -5580, -5580,  3924, -5580,103896,  2373,
    2523,  4168, -5580,  3783, -5580,  4299,  3398,   336,  4011,  1930,
    3030,  4242,  2592,   392, 74508,  3558, -5580, -5580, -5580, -5580,
  103896,103896,  1053,  1819, -5580,  3867,  3887, -5580,103896,  4190,
  103896,103896,103896, 95886,  2118,  3905,103896,  3908, 82533,103896,
    2594,  3179,  4326,  4219,  2118,  3573,  3962,  4222, 98022,  2559,
   -5580,  3897, -5580, -5580,  2567,   183, -5580,  1819,142046, 79323,
    4210, -5580,  7600, -5580, -5580,  7600,  1027,103896,  4195, -5580,
  103896, -5580, -5580, 59345, -5580, 82533,  3910, -5580,  2571, -5580,
    2576, -5580, -5580, -5580,  2841, -5580, -5580,     5,     5,  3915,
   -5580, 60962, -5580,  3911, -5580,  2485, -5580, -5580, -5580,   278,
    3944,   319,  3945,   319, -5580, -5580, -5580, -5580,103896, -5580,
  103896,137834,   319, -5580, -5580,103896, -5580,  4229,  4217, -5580,
   -5580, -5580, -5580,  4029,  4033,  4034,  4038,  4041,103896,  3590,
   -5580,  3909,138770,  1847, -5580, -5580,  4120, -5580, -5580, 98022,
    4040, -5580, -5580, -5580, -5580,  4258,  4259, -5580, -5580, -5580,
    1201, -5580,103896,103896,138770, 90012,   310,138770, -5580,  4196,
    4197, -5580, -5580,  4198,   355, -5580,  4199,  4200,  4201, -5580,
    4202,  4203, -5580, -5580, -5580,  3932, 18298, 47882, -5580,  4268,
   82533, -5580,  7987, -5580, -5580, -5580, 47882, -5580, -5580, -5580,
   -5580, -5580, -5580,  2537, 47882, -5580, 47882,  4251, -5580, 40176,
    4405,  4405,  3931, 82533, 51746, 51746, 51746, 51746,  1780,  3047,
   51746, 51746, 51746, 51746, 51746, 51746, 51746, 51746, 51746, 52850,
     620, -5580,  4134, 47882, 47882,  4270,  4251, -5580, 82533,  3951,
    3639,  3954,  3955, 47882, -5580, -5580,  2581, 53941,  3956, 74508,
   -5580, 47882, 16179,  2587,  3993, 18840,  2027,  9112,  1819, 47882,
    2659,  2891, 47882,  2590, 47882,  4269, -5580, -5580, -5580, -5580,
    3959, -5580, -5580,  4175, 82533, -5580, 47882,  3960,  4209, 51746,
   51746,  4701, -5580,  5507, 47882, 42362, -5580,  3672,  3994, 62579,
   -5580, 40729,  3957,  1442,  1442,  1442,  1442, -5580,103896,103896,
  103896, 56649,  4282,  3963, 55571,102828,  3964,  2394, -5580,102828,
  103362,102828, -5580,  3967, -5580,  2027, 47882,  4275,  3965,  4275,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580,  3979, -5580,  3985, -5580, -5580,
     160,  3969, -5580, -5580,   226, -5580, -5580,  2118, -5580,  3978,
   -5580,  3717,  1642, -5580, -5580, -5580,  1339, -5580,  4060, -5580,
   -5580, -5580,  3964, 46226,  4115, -5580, -5580, -5580,  4030,  2603,
   -5580, -5580,  4382,  4115, -5580, -5580,  2604, 62040,  3711, 47882,
    2027,  2841,  3996, -5580,  2757,  1074, -5580, -5580, -5580, -5580,
   -5580,  2617,  2251, -5580, -5580, 78788, -5580,  4053,  2986,  2986,
    2245,  3590,  4311,  2245,  9159, -5580, -5580, 57188,103896,103896,
   -5580,103896,  2620,   271,103896, -5580,103896, -5580, -5580, -5580,
   -5580,  4436, -5580,103896, -5580, -5580,  4047,  4048,103896,103896,
  103896,103896,  4257, -5580, -5580,  2862, -5580, -5580,138770,103896,
   -5580, -5580, -5580,   470,  2391,  3181, -5580,  4074, -5580, -5580,
    4274,103896, -5580,  4426,  4085,103896,  4335,103896,  3998, -5580,
     271,  4104,  4317,  1920,  3179,  1870,  4586, -5580,  2061, -5580,
   -5580,  4072, -5580,103896, -5580,103896, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580,  4135, -5580, -5580, -5580, -5580, 75043, -5580,
   -5580,103896, -5580, 74508, 63657, 74508,103896, -5580,  1701,   472,
    2464,  3181, -5580,  4087, -5580,  4340,  4088,  4090,  4145,  1252,
    1461,  4093,  4094,  4146,  4017,  4019,  4020, -5580, 74508, 64205,
    4176,103896,  2986,  4023,  4063,103896,   221,  1819, -5580, -5580,
    1819,  2986,  1819,103896,103896,103896,103896,   221, 74508, -5580,
    4463,  4122,103896,103896,103896,103896, -5580,  4084, -5580,103896,
  103896,  4360,   231,  2430,138770,103896,103896,138770,103896,103896,
  103896,103896,103896,103896,103896,  4245, -5580,  4450,  4377,  2321,
    4419,  4111,103896, -5580,103896,  1819, -5580,  3421,103896,103896,
  103896,103896, -5580, -5580, -5580, -5580, -5580,  3672, -5580,  4054,
    4320,  1061, -5580,  4327,  4328,  1061,  1061,  4330,  1061, -5580,
   -5580,  1720, -5580,   320,103896, -5580,  2662,103896, -5580, -5580,
   -5580,  3978,  1936,  1936, -5580, -5580, -5580, -5580, -5580, -5580,
  103896,  4057,103896,103896, 51746, -5580,  1775,  1921,  1451, -5580,
    4331,103896,  3327, -5580, -5580, -5580,   215,103896, -5580, -5580,
   -5580, -5580, -5580,  1307,  3905, -5580,  4347, 85740,  2986,138770,
  138770,  2986, -5580, 82533,  4062,  3558, -5580,   403,  4140,138770,
     336,  1111,125256,  3344,  4096,  4278, 56110,  1837, -5580,  4064,
    4224, -5580,  4065,  4069, -5580, -5580,103896,  3968,137834,  2621,
    2309,  4522,  1167,  2370,  3649, 87342,  4262,  3905,  4347, -5580,
    3179,  4285,  4284, -5580,  2118,103896,  3649,  3558,  1819,103896,
    3471, -5580,  2523, 63657, -5580, 78788, 47882, 47882, -5580,  4075,
   -5580,  4079,  7600, -5580,  4152,  4080, -5580, -5580, -5580, -5580,
   -5580,  4165,  4089,103896,  4564, -5580, -5580,  4091,  3881, -5580,
    3881, -5580,  4098, -5580, -5580, -5580,  2243,131655, 60962, 60962,
   60962, 60962, 60962, -5580, -5580,103896, -5580,103896, -5580,   319,
   -5580,  4214, -5580,   319,103896,  2118,103896,103896,103896,103896,
  103896,  3590,   355, -5580,  4409,138302, -5580, -5580,  2631,103896,
   -5580, -5580, -5580,  4470, -5580, -5580,   158,  4416, -5580, -5580,
    1090,  1090,  1090,  4373,  1090,  1090,  1090,  1090,  1090, -5580,
   47882, 18913, -5580,  4099, -5580, 18913,  4101,  9651, 18913,  4270,
   -5580,  2634, 47882, -5580,  2099,  2099,  2099,  4056,  4423, -5580,
    1632,  4107,  2099,  2099,  2099,   502,   502,   214,   214,   214,
    4405,   620, 18913, 18913, -5580, -5580,  4103, -5580, -5580, -5580,
    3639, -5580, 48986,    76,  4536, 53402, -5580, -5580, -5580,  4148,
    4149,  4110, -5580, 47882, 49538,  4112, 83603,  4309, -5580,  2059,
   47882, 47882,  2755, -5580,  8143, 47882, 82533, -5580,  2637,  2755,
     371, 47882,  3640,  3948, 47882, 47882,  5875, 10031,  4121, 47882,
  129528, -5580, -5580, -5580,  2640, 47882,103896,103896,103896,103896,
   -5580, -5580, -5580,102828,103362,102828,  4127, 54480, 58805,  2394,
    4124,103896, -5580, -5580,  4128, 56110,  4388,  4316, -5580, 56110,
    4316,  1777,  4316,  4391,  4211, 63118, -5580, -5580,  4129, -5580,
    4324, -5580,  1692, 18913,  4557,  4437,  1819,  4437,  1074,   302,
    1819, -5580,  4131, 66940, -5580, -5580, -5580, -5580,  4216, -5580,
    4348, 18913, 44018, -5580,  2118,  2456,103896,  2027,   844, -5580,
    4151,103896, -5580,  4115, 18913, -5580, 10204, -5580, -5580, -5580,
   -5580,  4204,  2655, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
    4221, 88410,  4462, -5580, 47882,  2656, -5580,  4180,  4556,   155,
    2668,  2669,   271, -5580,  4442, -5580,  2025,  4439,   437, -5580,
     319, -5580, 82533, -5580,103896,103896, -5580, -5580, -5580, -5580,
  103896,  3113, -5580, -5580,103896,103896,103896,103896, -5580, -5580,
  138770,103896, -5580,103896, -5580, 74508,  1715,   221,  1775,  4452,
    4454,  4371, -5580,   355, -5580,  1775,  4376,   221,103896, -5580,
   -5580,  2960, -5580, 82533,   319,   319, -5580, -5580, -5580, -5580,
   -5580,  4166, -5580,  4590,  4249,103896,103896,103896,103896,103896,
  138770,103896,103896,  2841,  2841, 82533,  4158, -5580,  2841,  2841,
    4159, -5580,138770,103896,103896, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580,  4247, -5580, 47882,  4581,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580,138770,103896,  4250, -5580,  4255, -5580,   997, -5580,
   -5580,103896,103896,103896,103896,  4507, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580,  4506,103896, -5580,
   -5580,  1819,  1819, 82533,   319,   319, -5580, -5580, -5580,  4256,
   -5580, -5580,  4178,  4455,  1061, -5580,  1061,  1061, -5580, -5580,
    1061, -5580,  4184, -5580,  1720,  4553, -5580,   271,  2270,  4510,
   -5580,  4514, 47882, -5580,  1148,  4056, -5580,  4567,  4645, -5580,
   -5580, -5580, -5580,  3327,  2373,  4266, -5580, -5580, 76113,   911,
   -5580,  4508,   205,  4424, 85740,  1984,  2135,  4213,  4339, -5580,
    2986,  2986,  4279,103896,  4667, -5580, -5580, -5580, -5580, -5580,
   -5580,138770,  3841, -5580,  4445,  1293,  4547,103896, 47882,  3964,
   -5580,  2231,  4552, -5580,  1819, -5580, -5580,  4353,  3558, -5580,
    4569,103896,  4444, 85740,  3649, -5580,  2674, -5580, -5580, -5580,
    4271,  4666,  3573, -5580,  1984,  4262, -5580, -5580,  4642,  4329,
    4276,  4686, -5580,  4329,  4558,  4449,  4244, -5580,  3897, -5580,
   -5580, 18913, 18913,  1819, 84138,  7600, 82533,  4568,103896,   720,
    4529,103896, -5580,   319,  2675, -5580, -5580, -5580,  4246,  2340,
    2340, -5580, -5580, -5580,   319,   319, -5580,103896, -5580,  3590,
    3590,  3590,  3590,  3590, -5580,  4451, -5580, -5580,  4521, -5580,
     319,138302, -5580, -5580, -5580, -5580, -5580,  1090, -5580, -5580,
   -5580, -5580, -5580, 18913, -5580, -5580, -5580, -5580, -5580, 10539,
   51746,  4571, -5580,  4248, 82533, -5580,  4260,  2678,  2688, -5580,
   -5580,    76, -5580,  4536, -5580, -5580, -5580, 10638,  4300, 18913,
    4363,  4261,  4264,  2755,  2755,  8143,  2692, -5580,  2755, 47882,
   47882,  2755,  2755, 47882, -5580, -5580, 10713,  4446, -5580, -5580,
   11052, -5580, -5580, -5580, -5580, -5580, -5580, -5580, 75578,  4263,
    3847,102828,  4267,103896,  2394, 56110, -5580, -5580,  1202, -5580,
   56110,  4527, -5580, 56110, 76113, -5580,103896,  4272,103896, -5580,
   50090, 47882,  4297, -5580,  4297, -5580,  1936, -5580, -5580, -5580,
   -5580, -5580, -5580,  4265, -5580, 95886,   873, -5580,    60, -5580,
   -5580,  4661, 57188,  4626, 47882, -5580, -5580, -5580, -5580, -5580,
  138302,  4481,138302,   271, 11287,  4442, 57188, 68034,103896, -5580,
  103896, -5580,  4434,  4442,  4280,  3327, -5580, -5580, -5580, -5580,
   -5580, -5580,  4277, -5580, -5580, -5580, -5580,  4356, -5580, -5580,
      39,  3553, -5580,  2695, -5580, -5580,  4728,  4619,  4620, -5580,
   -5580, -5580, -5580, -5580, -5580,  4450, -5580, -5580, 63657,138770,
  103896, -5580,  4364, -5580, -5580, -5580, -5580, -5580, -5580, 58266,
   66940, -5580,  1252,  4283,  4287,  1461, -5580, -5580, -5580,103896,
   11338,  4288,   673,  3553,103896,103896,  4290,  4291,  4292,  2069,
    1712,  2151,  3590,  4621,103896, -5580, -5580, -5580,  4450, -5580,
   -5580,103896, -5580,  1061, -5580, -5580, -5580, -5580, 74508, -5580,
    2053,  4184,  1819, 76113,  4744,  4744,103896, -5580, 11905,  4515,
   -5580, -5580,   767,  4266,  4545,  4591, -5580,  4301,103896,   215,
    4305,103896,  4306,  4432,  1756,  1756,103896,103896,103896,  2696,
    2118,  2986,  4063,   336,  4638, 85740,  4688,  3968,   409, -5580,
   -5580,  2231, -5580,    90,  4663,  4355, -5580,103896,  4761, 95886,
    2118,  3905,103896,  4314,  1228, -5580, 87342,  4520,  1715,103896,
    2594,  4262,  3573,  1424,103896, -5580,  1655, -5580,  2118, -5580,
  103896, 98022, 57188, -5580, 83068, -5580,  2702, -5580, -5580,  4387,
    3710,  4428,  4429,  4322,103896,   121, -5580,  4332, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580,103896, -5580,   310, -5580, -5580,
    4342, 51746, 82533,  2708, 47882, -5580, 47882, -5580, -5580, -5580,
   -5580,   661, -5580, -5580, -5580,  2755,  2755,  2755, -5580,  4756,
    3672, -5580, -5580,  2711,  4775, 51194,  4737, -5580,103896,  2716,
   -5580, 47882,  4343, -5580, -5580, 56110,  1202,  4346,  2725,103896,
    2728, 82533,  4349,    30,  4350, 39070,  4336, -5580, -5580, -5580,
   -5580, -5580, 18913, 18913,103896, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580,  4393,103896,  2739, -5580,   688, 18913,  1847,  2245,
     310,  4556,  3327, -5580,  4351, -5580, -5580,  3179,   384,103896,
    3327,103896,  4266, -5580,103896,  4441, -5580, -5580, 74508,  4643,
   -5580, -5580,  4410, -5580,  1378,  3553,103896, 82533, -5580,   140,
    4678, -5580, 82533, 82533, -5580, -5580, -5580, 47882,  4447, -5580,
   -5580, -5580, 47882, 47882,142982, -5580, -5580,103896,103896,103896,
  103896,103896, -5580,   319, -5580, -5580,  2740, -5580,132654, -5580,
   -5580,  3396,  1819,  3396,  2019, -5580, -5580,  3396,  3396, -5580,
    3710, -5580,  4744,   353, -5580, -5580, -5580,  2055,  4582,  4357,
   47882, -5580,  1264,  4573,  4458,  4359, -5580, 76113,  4841,  3905,
    4347,103896, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580,  2751,  3968,  4697,  3558,  4276, -5580,103896,
    4403, -5580, 56110, -5580, -5580, -5580,  3396, -5580,  2120,  4375,
    4710,  3968,  2118,  2370,  3649,  4262,  3905,  4347, -5580, -5580,
   -5580,  4378,  4284,  3573,  2594,  4513, -5580,  4516, -5580,  4791,
    4587,  4799,  3649, -5580,  3471,  2754, -5580,  7600, 84138, 82533,
    4740,  4421,  4422, -5580, -5580,  4438,103896, -5580, -5580,  2697,
    4863,  3968, -5580,  4342,  2767, -5580,  2768,  2777,  4440, -5580,
   47882,  1651,  3967, 75578,  4392, -5580, 51746,  2782, -5580,  3659,
  103896,  2783, -5580, 18913,103896, -5580, -5580, 47882, -5580,  2788,
   -5580, 47882,  4394, 47882, -5580, 50090,  4385, -5580,  4840,  2118,
   -5580,  3710, 57188, -5580,  4517, -5580,  4715, -5580, -5580,  4266,
   66940,   384,  3717,  2373,  4266,  2793, -5580, -5580,103896, -5580,
    4357, 47882, -5580,  4487, -5580, -5580,  2794,  1668,  4562,  4562,
    2797,  2798, 12475,103896,  2805,  2809, -5580,  2814,  2841,  3591,
    2151,  3591, -5580,  3590, -5580, -5580, 74508, -5580,136430, -5580,
   -5580, -5580,  1819, -5580,  1819,  4624,103896, 70190,  1819,  1819,
   -5580, -5580, -5580, -5580,  4754,  4699, -5580,  2309, -5580, 12538,
   -5580, -5580, -5580,   498, -5580,  4615,  4618,103896, -5580,  4412,
   -5580,  2815,  1984,  4537,  3968, -5580, -5580,103896,  4867,  4868,
   -5580,  1409,103896,  3964,103896, -5580, -5580, -5580, 47882,   215,
   -5580,  4276,  3649, -5580,  3573,  1984,  4262,  1715, 57727,  4329,
    2594,  4284, -5580, -5580,  4625, -5580,  4627, -5580,  4414,  4716,
    7600, -5580, -5580,  1083,  4741,  4742, -5580, -5580, -5580, -5580,
   -5580,103896, -5580, -5580, -5580, -5580, -5580,  3639, 46778, 46778,
   46778,  4425, -5580, -5580,103896,  4056,  4427, 51194, 74508,  2818,
   -5580, 80928, -5580,  2821,  2822, -5580,  2827, 50090,  2831, -5580,
  103896,  4431, -5580, -5580, -5580, 62040,138302,  4465,  4433,  3717,
   -5580,  4545, -5580, -5580,   271,  3553, -5580, 18913,103896, 76113,
    4858, -5580, -5580, -5580, -5580, -5580, -5580, -5580,  3553,  4509,
   -5580, -5580,142982, -5580,103896, -5580, -5580,  2834, -5580, -5580,
   -5580,103896,  4064, -5580,  4064, -5580, -5580,  4566, -5580,  1755,
    4534,  1360,  1360,  4803, -5580,  4496, -5580, -5580,  4443, -5580,
    4919,  4565,103896, -5580, -5580,  1252,  2118, 85740,  3968, -5580,
   -5580, 12603, 76113, -5580,  1228,  2594,  4262,  3573, 47882,  2835,
   -5580,  4556,   155, -5580,  4284,  4329, -5580, -5580, 57188,  4448,
    3558, -5580, -5580,  1992, 76113, 76113, -5580, 50642,  4584,  1165,
   16423,  4785, -5580,  4785,  4785, -5580,  2839, 53402, -5580, -5580,
   -5580,103896,  4650,  1476, -5580,  4603, -5580,  2842, -5580, -5580,
   -5580,  1774,   310,  4453, -5580, -5580, -5580,  4573,   271, -5580,
    3553, -5580,103896, -5580,  4456, -5580, -5580, -5580,136430,  4064,
    4355, -5580, -5580, -5580,  4914, -5580,  1246, -5580, -5580, -5580,
   -5580,103896,  3968,  4158,  4276, -5580, -5580,  4457, -5580,  4284,
    3573,  2594, 12917, -5580, 57727,103896,103896,  4329, -5580,  2843,
   57188,  4329, -5580,  2942, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580,  4459,  4460,  4904, -5580, -5580, -5580, -5580, -5580,  1079,
   -5580, -5580, -5580, -5580,  3847, -5580, -5580, 51746,  4672, -5580,
    1476, -5580, 51746,  4461, -5580, -5580, -5580, -5580, 47882,   271,
   -5580, -5580, -5580, 47882, -5580,  4804, -5580, -5580, -5580,  3968,
   -5580, -5580, 73973,  4329,  2594,  4284,  4556, -5580, -5580, -5580,
   -5580, -5580,  4716, -5580,  2846,  3710,  1877, -5580, -5580,  1976,
    2613,  4540,  4786, 47330,  4605, -5580,  4668, -5580,  4878,  4056,
   -5580, -5580,  4056, 47882, 14045,   271,  2854,   215, -5580,  2860,
   -5580, -5580, -5580, -5580, -5580, -5580,  4284,  4329,103896,  3558,
   -5580, 57188, -5580, -5580,  2942,  4583,  4585, -5580, -5580, -5580,
  103896, 14131, -5580, -5580, 76113, -5580, 73973,  4329, -5580, -5580,
    4329, -5580, -5580,  4511,  4519,  2870, -5580,  4471, -5580, -5580,
    3710,  4794,  4795, -5580, 73973, -5580, 76113, 76113,  2871, -5580,
   -5580, -5580
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    2759,     0,     2,     1,  3185,  3189,  3193,  3194,  3116,  3195,
    3196,  3161,  3162,  3163,  3164,  3165,  3166,  3167,  3168,  3169,
    3170,  3171,  3172,  3174,  3173,  3175,  3176,  3177,  3178,  3179,
    3180,  3181,  3182,  3184,  3183,  3134,  2766,  3133,  3130,  3131,
    2308,  3198,  3186,  3199,  3187,  3188,  3190,  3191,  3160,  3192,
    3200,  3201,  3202,  3197,  3205,  3156,  3157,  3155,  3158,  3159,
    3203,  3204,  3147,  3148,  3149,  3150,  3206,  2767,  2768,  3152,
    2760,  2764,  2828,  2899,  3153,  3154,  3151,  2765,  3146,  2899,
       0,  3021,  3022,     0,  3023,  3024,  3025,  2951,  2913,  3026,
       0,     0,  3027,  3028,  3029,  3030,  3031,  3032,  3033,  3034,
       0,  3035,  3036,  3037,  3038,  2898,  3039,  3040,  3041,  3042,
    2875,  2881,  3004,     0,  2855,  2856,  2852,  2854,  2853,  2857,
    2840,  1468,   637,  1554,  1553,     0,  2661,  1468,  2613,  2614,
    2662,  2615,  2616,     0,  2617,   273,     0,  1564,  2618,  2663,
       0,  1468,  2664,   432,  1140,  2665,  2666,  2783,     0,  2619,
    2620,     0,     0,     0,   637,  1468,     0,     0,  2621,  1700,
    2622,     0,  2623,  2667,  2668,     0,  2624,  2625,  2669,     0,
    2670,  2626,  2627,  2628,  2671,  2672,  2673,  2629,  2674,  2675,
       0,     0,  1714,     0,  2630,  2676,  2631,  2632,  2633,     0,
    2677,  2634,  2635,  2636,  2678,  2679,  2637,  2638,  2639,     0,
    2640,     0,     0,     0,     0,     0,     0,  2680,  1468,  2641,
       0,     0,  1721,     0,  2642,     0,  2681,  2643,     0,  2644,
       0,  2682,  2645,  2646,  2647,  2648,  1714,  3000,  2876,     0,
    1566,     0,  2649,  2683,     0,  2650,  2651,  2652,  2653,  2654,
    2655,  2656,  2657,  2658,  2659,  2660,     0,     0,     0,    37,
      72,    73,    30,    29,    91,    55,    16,    63,   125,   124,
     126,    42,    38,    80,    25,    27,    39,    43,    65,    67,
      32,    56,   103,    64,    23,    62,    86,    68,    89,    50,
      10,    11,    51,    12,    52,    13,    53,    14,    99,    74,
      92,    35,    61,    22,    44,    70,    71,     3,    46,    78,
       9,    57,    58,    60,    83,    84,    85,   108,    87,   120,
      41,   117,    96,    97,   114,    98,   115,     7,   100,    54,
      15,   111,   110,   112,    81,    47,    82,    69,    90,   109,
      26,   113,    17,    18,    20,    21,    19,    59,    28,    66,
      31,    88,   116,   106,   102,   121,   119,   127,   104,    75,
       5,     6,    93,     4,    24,    49,     8,    34,    33,    48,
      40,   123,    36,  1564,    95,   107,    94,   101,    79,   105,
     122,    77,   118,  1682,  1669,  1723,  1681,  1699,     0,  1685,
    3095,  3096,    45,  1700,   129,   130,   135,  2763,  2817,  2818,
    2819,  2899,  2850,  2851,  2844,  2860,  2870,  2859,  2863,  2871,
    2858,  2877,     0,   132,   134,   136,   139,   133,   128,   131,
     138,   143,   137,   142,   140,   141,   144,   145,   146,  3097,
    1950,  3094,    76,  2835,  2834,     0,  2899,     0,  3127,  2323,
    2324,  2325,  2326,  2327,  2328,  2329,  2330,  2331,  2332,  2333,
    2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,  2342,  2343,
    2344,  2345,  2346,  2347,  2348,  2349,  2350,  2351,  2352,  2353,
    2354,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,
    2364,  2365,  2366,  2367,  2368,  2369,  2315,  2370,  2371,  2372,
    2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,  2381,  2382,
    2383,  2384,  2385,  2386,  2387,  2388,  2389,  2390,  2391,  2392,
    2393,  2394,  2395,  2396,  2397,  2398,  2399,  2400,  2401,  2402,
    2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,  2411,  2412,
    2413,  2414,  2415,  2416,  2417,  2418,  2419,  2420,  2421,  2422,
    2423,  2424,  2425,  2426,  2427,  2428,  2429,  2430,  2431,  2432,
    2433,  2434,  2435,  2436,  2437,  2438,  2439,  2440,  2441,  2442,
    2443,  2444,  2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,
    2453,  2454,  2455,  2456,  2457,  2458,  2459,  2460,  2461,  2462,
    2463,  2464,  2465,  2466,  2467,  2468,  2469,  2470,  2471,  2472,
    2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,  2482,
    2483,  2484,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,
    2493,  2494,  2495,  2496,  2497,  2498,  2501,  2499,  2500,  2502,
    2503,  2504,  2505,  2506,  2507,  2508,  2509,  2510,  2511,  2512,
    2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,  2521,  2522,
    2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,  2532,
    2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,  2541,  2542,
    2543,  2544,  2545,  2546,  2547,  2316,  2548,  2549,  2550,  2551,
    2552,  2553,  2554,  2555,  2556,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,
    2572,  2573,  2574,  2575,  2576,  2577,  2783,  2578,  2579,  2580,
    2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,  2595,  2596,  2597,  2598,  2599,  2600,
    2601,  2602,  2603,  2604,  2605,  2606,  2607,  2608,  2609,  2610,
    2611,  2612,  2801,  2313,  2314,  2320,  2321,  2322,  2776,  2797,
    2803,  3123,  2802,  2319,  2950,     0,     0,  3043,  3044,  3045,
    3046,  3047,  3048,  3098,  3099,  3100,  3101,  3102,  3104,  3103,
    2912,  3070,  3107,  2911,  3108,  2915,  3109,  3110,  3111,  3112,
    3071,  3113,  2914,  3105,  3067,  2916,  2909,  2910,  3068,  3019,
    3020,  2286,  3069,  3066,  3106,  2804,  3065,  2920,  2919,  1659,
    3122,  2285,  1660,     0,  2922,  3049,  3050,  3051,  3052,  3054,
    3053,  3055,  2684,  2685,  2686,  2687,  2688,  2689,  2690,  2691,
    2692,  2693,  2694,  2695,  3080,  2696,  2697,  2698,  3093,  2699,
    2700,  3081,  2701,  2702,  2703,  2704,  2705,  2706,  2707,  2708,
    2709,  2710,  2711,  2712,  2713,  2714,  2715,  2716,  2717,  2718,
    2719,  2720,  2721,  2722,  2723,  2724,  3082,  3083,  2725,  2726,
    2727,  2728,  2729,  2730,  2731,  2732,  2733,  2734,  2735,  2736,
    2737,  2738,  2739,  2740,  2741,  2742,  2743,  2744,  2745,  2746,
    2747,  2748,  3084,  2749,  2750,  3085,  2751,  2752,  2753,  3086,
    2754,  2755,  2756,  2757,  2758,  3090,  3091,  3092,  3079,  2873,
    3056,  3078,  3089,  3087,  3088,  2883,  2879,  2887,  2882,     0,
       0,     0,     0,  2899,  1467,  1466,  1481,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2773,     0,  1478,   148,     0,  3074,  3068,
    3077,     0,  2291,  3069,  3066,  3065,   404,   403,  1563,  1543,
     637,     0,  1481,   431,  1700,     0,     0,     0,     0,     0,
       0,     0,   870,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   196,     0,     0,     0,     0,
     455,   454,     0,     0,     0,  1106,   460,     0,     0,     0,
       0,     0,   625,  2782,  2777,  2787,     0,  2780,  2781,  3065,
       0,  3209,  2499,  2813,  2814,  3207,  2559,  1661,   274,   277,
     278,   275,   276,     0,  1242,  1243,  1245,     0,     0,  1255,
     910,   911,     0,     0,     0,   919,     0,     0,     0,   908,
       0,     0,     0,   924,     0,   921,     0,     0,   925,   922,
     905,   923,   912,     0,   904,     0,     0,  1255,   926,     0,
       0,   906,     0,     0,     0,     0,  1481,     0,  2865,  2866,
    2423,  1609,   461,     0,     0,  1700,     0,  1586,  1587,  1564,
    1576,  1588,  1581,  1583,  1582,  1584,  1580,  1585,  2324,  1041,
    2339,  1041,  2411,  1038,  1039,  1041,  1041,  1041,  2519,     0,
       0,  1013,     0,  1024,  2309,  1041,  2310,  3123,  1046,   524,
     524,   524,     0,  1045,  1050,   524,     0,  1449,  1490,  2290,
    1713,     0,  2339,  2411,  1014,  1448,  2578,  1600,     0,     0,
    1270,  1266,  1268,  1269,  1267,     0,  1109,  1109,  2537,  1460,
     258,  3063,  2547,  2645,  2578,  3064,   257,   252,   253,  3058,
    3059,  3061,   226,  3062,  3060,  3057,  2328,     0,     0,  1045,
       0,  1481,  1458,   996,  1720,  1718,     0,  2272,     0,     0,
    2348,     0,  2362,  2449,   249,  2530,  2538,  2547,  2645,  2578,
    2610,   205,   215,   210,     0,   267,  2547,  2645,  2578,     0,
    1478,     0,  1686,  1824,  2281,     0,     0,  2874,  1451,  1450,
    1565,     0,  1568,     0,  2514,  1690,  1693,  1570,  1691,  1682,
       0,     0,  2762,     0,  1575,  1717,  1717,     0,  1717,     0,
    1674,  1682,  1677,  1681,     0,     0,     0,     0,  1468,     0,
    2842,  2870,  2849,  2905,  2846,     0,     0,  2895,  2891,  2888,
    2896,  2897,  2890,  2878,  1939,  1940,  1941,  1938,  1951,  1937,
       0,  2823,  1942,  2862,  2829,     0,  2837,  2836,  3135,  3136,
    2952,  2775,  2794,     0,     0,     0,     0,     0,     0,     0,
    2921,  2923,  2925,  2885,  2884,  2880,     0,     0,     0,  3010,
    3011,     0,  3009,     0,  3006,  3008,     0,  2905,     0,  1452,
       0,     0,     0,   929,     0,  1493,  1091,     0,     0,     0,
       0,     0,  1342,     0,  1148,  1149,     0,  2313,     0,  2422,
    1342,     0,     0,  2179,  2190,  2191,  2192,  2352,  2406,  2187,
    2188,  2189,  2181,  2182,  2183,  2184,  2185,  2186,     0,     0,
    1237,  2180,     0,  2422,     0,  1342,     0,   175,     0,   152,
    1342,     0,     0,  2422,     0,     0,  2422,     0,     0,     0,
       0,     0,  2422,     0,     0,     0,     0,     0,   175,  2454,
       0,   152,  2422,     0,     0,     0,  1472,     0,     0,     0,
    1474,  1477,  1453,     0,  2264,     0,  2265,  2292,  1546,     0,
    2281,     0,     0,     0,   965,   958,     0,   966,   973,     0,
       0,   975,     0,     0,   959,     0,     0,     0,     0,     0,
     978,   979,     0,     0,   980,   960,   981,   961,   982,   962,
     983,     0,     0,     0,     0,   963,     0,     0,     0,  1464,
    1455,     0,  1602,  1604,  1603,  1601,   524,     0,     0,     0,
    2422,     0,     0,   152,  1531,     0,  2422,   152,     0,     0,
     459,   458,   152,   457,   456,  2352,  2406,     0,  1139,     0,
    1407,   152,  2422,     0,   198,  2422,   711,  2422,  1570,     0,
     640,     0,     0,   825,  2454,   152,     0,     0,     0,     0,
       0,     0,  1109,     0,     0,     0,     0,     0,   624,   637,
       0,  2786,  2792,     0,  2784,  2953,  3210,  3208,  2908,     0,
    1246,   250,   251,  1244,   917,  2422,  1181,   365,     0,     0,
    2422,   152,  1899,  1928,  1906,  1928,  1928,  1895,  1895,  2389,
    1908,  2422,  1896,  1897,  1933,     0,  1928,  1895,  1900,     0,
    1898,  1936,  1936,  1923,   365,   933,  1880,  1881,  1882,  1883,
    1909,  1910,  1884,  1915,  1916,  1920,  1885,  1950,  3075,  1895,
    3076,  3073,  3072,   918,     0,   909,  2422,   365,  1145,  2422,
    2317,   185,     0,   907,  2352,  2406,  2422,   365,  1239,     0,
    2422,   365,  2422,   181,  2422,   365,  2422,   365,  2422,   641,
       0,     0,  2422,   365,  2422,  2454,   183,     0,  2422,   365,
     927,  2422,   365,  2283,  2422,     0,  1456,     0,     0,  3140,
    3144,     0,  3142,  3137,  2864,  2918,  2917,  2816,     0,  3221,
       0,  1661,  1578,  1593,     0,  1589,  1596,  1592,  1700,  1041,
    1040,     0,  1041,     0,  3231,  1041,     0,  1041,     0,  3231,
    1041,     0,     0,     0,  1041,  2311,  2312,     0,     0,  3230,
    3226,  3229,  1015,  1025,     0,  1047,     0,     0,  1054,  1053,
    1052,     0,     0,     0,  1055,     0,  1828,  1636,     0,  1022,
       0,  1020,     0,  1446,  1463,     0,     0,     0,     0,  1109,
    1273,     0,  1271,  1108,     0,     0,  1459,   256,   254,     0,
       0,     0,     0,     0,     0,  1465,     0,  1457,     0,     0,
       0,  3129,  3132,  2193,  3128,     0,  2614,  2615,  2616,  2256,
       0,  3070,  2617,  2618,  2663,  2085,  2072,  2081,  2086,  2073,
    2075,  2082,  2619,  2620,  2020,  2621,  2622,  2304,  2623,  2624,
    2625,  2627,  2628,  2629,  2077,  2079,  2630,  2631,  2633,     0,
    2305,  2634,  2635,  2481,  2637,  2638,  2640,  2641,  2083,  2643,
    2644,  2645,  2646,  2647,  2648,  2303,     0,  2084,  2649,  2651,
    2652,  2653,  2654,  2656,  2657,  2658,  2659,     0,     0,     0,
    2278,     0,  2052,     0,  1888,  1889,  1911,  1912,  1890,  1917,
    1918,  1891,     0,  2277,  1953,  2138,  2051,  2068,     0,  2057,
    2058,     0,  2050,  2046,  1703,  2273,     0,  2047,  2293,  2257,
    2307,  2306,  3123,  2267,  2296,  2294,  2295,  2297,  1703,  2271,
       0,     0,     0,   218,     0,     0,  2999,   269,     0,   270,
    2279,  2547,   206,   248,   220,   247,   221,   219,     0,  2350,
     207,     0,     0,   208,     0,     0,     0,     0,     0,     0,
       0,   263,  1454,     0,  1826,  1825,  2282,   938,     0,     0,
    1557,  1551,  1560,  1556,  1567,  1564,  2203,     0,  1692,     0,
       0,     0,  1672,  1671,     0,  1572,  1574,  1549,  1570,  1715,
    1716,     0,     0,     0,     0,     0,     0,     0,     0,  1773,
    1731,  1732,  1734,  1770,  1774,  1782,     0,  1678,     0,     0,
    1830,     0,     0,  2761,  2905,  2906,     0,  2900,     0,  2899,
    2899,  2893,  2892,  2889,     0,     0,     0,     0,     0,     0,
       0,     0,  2820,   619,  2822,   616,     0,     0,  2796,     0,
    2800,  2798,     0,  2945,  2948,     0,  2946,  2947,  2949,     0,
    2954,  2955,     0,     0,     0,     0,     0,  2936,  2924,  2931,
    2933,  2935,  2934,  2943,  2939,  2942,  2944,  2886,  2899,     0,
    3012,  3018,  3015,  2364,     0,  3007,     0,  1479,     0,     0,
       0,     0,     0,  1180,     0,     0,     0,     0,     0,   930,
       0,     0,     0,     0,  1501,  1502,  1503,     0,     0,  1504,
    1505,  1493,   260,  1511,  1509,  1492,  1494,  1507,  1499,     0,
       0,     0,     0,     0,     0,     0,  1523,     0,   189,   190,
       0,   653,   637,     0,  2422,     0,     0,     0,     0,  1188,
    1195,  1341,     0,     0,     0,     0,     0,     0,     0,     0,
    1189,  1187,     0,  1190,   262,  1200,  1219,  1222,     0,     0,
    1147,  1150,     0,     0,     0,     0,     0,  1332,     0,     0,
       0,  1332,     0,     0,     0,  1341,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   285,   287,   298,   360,     0,
       0,     0,  2422,  1342,     0,     0,     0,  1241,     0,     0,
       0,     0,     0,     0,     0,     0,  1222,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   150,   151,   156,     0,
       0,     0,     0,  1222,     0,     0,     0,     0,     0,     0,
       0,   602,   615,     0,     0,     0,     0,     0,   612,     0,
       0,   152,   290,   592,   598,     0,     0,     0,   718,   717,
       0,     0,     0,     0,     0,  1423,  1422,     0,     0,     0,
       0,  1521,  1520,     0,     0,     0,     0,     0,     0,  1332,
       0,   279,   281,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   396,   397,
       0,     0,     0,   156,     0,     0,  1332,     0,   292,     0,
    2830,     0,  1473,  1470,  1471,     0,  1476,     0,     0,     0,
       0,  2060,     0,  2207,  1723,  2205,  1165,  2263,     0,  2260,
    2259,  2288,  2266,     0,  1542,     0,   972,     0,     0,     0,
       0,   974,     0,   967,     0,     0,   964,  2352,  2406,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   977,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   833,
       0,  1493,  1530,     0,     0,     0,   646,     0,  2422,     0,
     154,   871,     0,   823,   460,     0,     0,     0,  1212,  1406,
     154,     0,     0,   192,     0,     0,   715,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   762,   761,     0,     0,
       0,   824,     0,     0,   154,     0,  2422,   595,  2422,     0,
     524,   524,     0,     0,  1111,     0,     0,     0,     0,     0,
       0,  2790,  2785,  2788,     0,  2778,  2792,  1664,  1666,  1665,
       0,  1663,     0,   363,   364,     0,  1229,  1254,     0,     0,
       0,  1927,  1914,  1922,  1921,     0,  1904,  1903,  1902,     0,
    1901,     0,  1928,  1928,  1926,  1905,  1880,     0,     0,     0,
    1932,     0,  1930,     0,   900,  1876,  1872,     0,  1939,  1938,
    1937,     0,  1886,  1895,  1892,   920,     0,     0,  1223,     0,
       0,  2422,   365,  2422,     0,  2422,     0,     0,     0,  1231,
     365,     0,  1225,     0,     0,  1227,     0,  1424,     0,   916,
     914,   913,   915,     0,     0,   898,     0,     0,     0,  2422,
     365,     0,     0,   893,     0,     0,   895,     0,     0,  3138,
       0,     0,  3141,     0,  2867,     0,  3227,  1605,  3224,     0,
       0,  1700,     0,   237,   238,   236,  1594,   239,  1595,  1591,
    1577,     0,  1033,     0,  3231,  3232,  1018,     0,  1028,     0,
    3231,  1016,     0,  1029,  1026,  1027,     0,     0,     0,  3225,
    3114,  3120,  1032,     0,     0,   525,   527,     0,     0,  2373,
    2388,     0,  2412,  2442,  2443,  2505,  2533,  2538,  2543,     0,
    2572,  2583,     0,  1056,  1086,  1051,   729,     0,     0,  1646,
    1023,  1021,  1447,  1598,  2210,     0,  1700,     0,     0,     0,
       0,  1262,  1263,   255,   227,     0,     0,     0,  1088,  2537,
    1462,   995,   637,     0,     0,  2055,  2056,  2255,     0,     0,
       0,     0,     0,     0,  2054,  2218,     0,     0,     0,     0,
       0,     0,  1976,     0,     0,     0,  2235,     0,  2241,     0,
       0,  2013,     0,     0,     0,     0,     0,     0,     0,     0,
    1977,  1957,  1958,  3071,  2052,  2203,     0,  2053,  2300,     0,
    1950,  2193,     0,  2190,  2191,  2192,     0,     0,     0,  2270,
       0,  2201,     0,     0,  1991,  2199,  1993,     0,     0,     0,
       0,  2187,  2188,  2189,  2181,  2182,  2183,  2184,  2185,  2186,
    2197,  1973,     0,  2276,     0,  2140,     0,  1972,     0,     0,
    1786,  1702,     0,  2298,  2258,     0,  3121,  3124,  2048,  1786,
    2996,  2995,  2994,  2993,  2964,     0,  2958,  2959,     0,  2997,
    2998,   271,   272,   268,     0,     0,   223,   222,     0,   245,
     246,   217,   244,     0,   240,   241,   225,  2127,  2126,   224,
     216,   213,   211,   228,   230,   231,   214,   212,   266,   264,
       0,     0,     0,     0,   365,  2899,  1575,     0,  1558,  1559,
    1555,  1562,  1783,     0,  1694,     0,  1698,  1575,     0,  1571,
    1689,  1688,  1724,  1725,  1131,  1687,  1753,  1754,     0,     0,
       0,     0,  1779,  1777,  1744,  1735,  1743,     0,     0,  1741,
       0,  1745,  1953,  1772,  1676,  1729,  1730,  1733,  1675,     0,
    1775,     0,  1649,  1773,  1734,  1633,     0,  1611,     0,  1831,
       0,     0,     0,  2907,  2905,  2845,  1880,  2899,  2838,  2899,
    2894,  2826,  1944,  1945,  1946,  1947,  1948,  1949,  2827,     0,
    2824,  1943,  2825,   617,   618,     0,     0,     0,  2793,     0,
    2774,  2799,  2930,  2555,  2962,     0,  2963,     0,     0,  2927,
       0,  2937,  2940,  2938,  2941,     0,  1880,  3013,  3117,  3117,
    1880,  1480,     0,     0,     0,  1160,  1162,     0,  1161,     0,
    1164,     0,  1173,     0,     0,  1159,  1178,     0,  1167,  1165,
       0,  1519,     0,     0,   931,     0,     0,     0,     0,  1500,
       0,     0,  2572,   259,  1503,  1508,  1495,  1506,     0,     0,
       0,     0,     0,  1090,  1089,     0,     0,  1113,     0,     0,
       0,  1526,   513,     0,   362,     0,     0,     0,     0,     0,
       0,     0,     0,   819,   816,     0,     0,   815,     0,   651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   691,     0,  1332,     0,   723,     0,  1197,     0,
    1196,     0,  1201,     0,     0,  1198,  1193,  1194,  2538,  2547,
    2578,   261,  1199,  1221,     0,  1220,  1216,     0,  1142,     0,
    1143,     0,     0,     0,     0,     0,  2398,  2422,   303,   325,
       0,  1331,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   347,     0,     0,
     350,   349,     0,     0,     0,     0,     0,   354,   333,     0,
     334,     0,   353,     0,     0,     0,     0,     0,     0,  1332,
       0,   294,     0,     0,     0,     0,     0,     0,     0,     0,
    1238,     0,   746,     0,     0,  2538,  1217,     0,     0,     0,
       0,     0,     0,  1410,     0,     0,   178,     0,   173,   177,
       0,     0,  2538,  1218,     0,     0,     0,     0,     0,   600,
     601,   614,     0,   605,   606,   603,   607,   608,     0,     0,
       0,     0,     0,     0,     0,   599,     0,     0,   713,   712,
     716,     0,     0,     0,     0,     0,  1419,     0,  1212,     0,
       0,  1418,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1275,  1274,     0,     0,     0,     0,  1342,     0,
     861,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     180,   733,     0,   732,     0,   174,   179,     0,     0,     0,
       0,     0,     0,     0,     0,   235,  1469,  1475,  1723,  1723,
    1723,  2066,     0,     0,     0,     0,  1722,  2261,  2264,  1545,
    2289,  1544,     0,     0,     0,     0,   976,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   968,   969,   970,   971,
       0,     0,     0,     0,     0,   410,   407,   408,   410,     0,
       0,     0,     0,   835,     0,   838,   841,     0,  1491,   479,
       0,     0,   643,   691,     0,     0,   463,   187,     0,     0,
       0,     0,   748,     0,     0,     0,  1405,   149,   196,   198,
     461,     0,   197,   199,   201,   202,   203,   200,   204,     0,
     710,   714,     0,     0,     0,     0,   639,     0,     0,     0,
       0,     0,   763,   767,   766,   770,   768,     0,   764,     0,
       0,  1851,     0,     0,   172,     0,     0,   590,   594,     0,
    2769,     0,     0,   463,   563,   376,  2422,     0,   524,     0,
    2422,     0,  1110,     0,   822,     0,     0,     0,     0,     0,
       0,     0,     0,  2791,     0,     0,     0,     0,  1662,   365,
    1182,     0,   152,     0,     0,     0,     0,   365,  1925,  1924,
    1877,  1873,     0,     0,     0,     0,   934,     0,     0,     0,
       0,     0,     0,  1893,   365,  1146,   186,  2318,     0,   902,
       0,     0,     0,     0,   365,  1240,   890,   365,   182,   365,
     365,   642,     0,   365,   184,     0,     0,     0,   634,   365,
     928,   365,  2284,     0,   365,  3139,  3145,  3143,  1608,  3228,
    3222,  3223,  2422,   524,  1666,  1579,  1590,  1030,  1037,  1019,
    1036,  1035,  1017,  1034,  1031,  2929,     0,     0,  3119,     0,
    1048,     0,   523,     0,     0,     0,     0,     0,  1064,  1065,
       0,     0,  1061,  1066,     0,  1062,  1063,  1068,  1058,  1057,
    1069,  1070,     0,     0,  1088,   727,     0,     0,     0,     0,
    1643,     0,  1641,     0,  1829,  1645,  1634,  1599,     0,  1597,
       0,   583,  1109,  1109,  1272,     0,     0,  1045,     0,     0,
     365,  1461,     0,   997,  1003,     0,     0,     0,     0,     0,
       0,     0,  1006,  1007,     0,  1008,   999,  1009,  1000,  1010,
       0,  1001,     0,     0,     0,     0,  2214,     0,  2215,     0,
       0,  2254,  2250,     0,     0,     0,     0,     0,  2222,  2223,
    2224,  2221,  2225,  2220,     0,     0,  2226,  2219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2641,     0,
       0,     0,     0,  2021,     0,     0,  2174,     0,  2203,  2240,
       0,     0,     0,     0,     0,     0,  2203,  2246,     0,     0,
       0,     0,  2125,     0,  2122,     0,     0,     0,     0,  2267,
       0,     0,  2301,  1954,  1968,  1969,  1970,  1974,  2275,     0,
    2269,     0,     0,  1955,  1982,     0,  2247,  2009,     0,  2014,
    1997,  2227,  2228,  2229,  2230,  2016,     0,  1990,     0,  1995,
    1999,     0,  1978,     0,  1975,     0,  2270,  2202,     0,  2200,
       0,  1965,  1966,  1967,  1959,  1960,  1961,  1962,  1963,  1964,
    1971,  2178,  2176,  2177,     0,     0,     0,  2148,     0,     0,
    1994,  2415,  2449,     0,  1714,  1714,  1714,  1701,  1712,  2274,
       0,  1846,  1723,  3126,  3125,  2268,  1846,     0,     0,     0,
    2280,     0,     0,  1950,     0,   265,  1827,   936,   937,   935,
    1880,  1548,  1552,  1561,  1575,  2204,  1569,  1696,     0,     0,
    1550,  1573,     0,  1129,  1130,     0,  1134,  2641,  2535,     0,
       0,     0,     0,  1746,  1780,     0,  1771,     0,  1747,  2293,
    2294,  1748,  1751,  1752,  1742,  1781,  1647,     0,  1776,  1680,
    1679,     0,  1849,     0,     0,     0,  1625,  1613,     0,  1832,
       0,  1786,  1651,     0,  2267,  1784,  2843,  2901,  2848,  2869,
    2839,  2872,  1952,  2821,  2861,     0,  2795,  2965,  2966,     0,
    2956,  2957,  2926,  2932,  3003,     0,  3118,     0,     0,  1381,
    1276,  1343,  1163,     0,  1895,  1174,     0,  1158,     0,  1157,
    1895,     0,  1175,     0,  1895,  1382,  1277,  1344,   932,  1383,
    1278,  1345,  1384,  1279,  1510,  1498,  1497,  1496,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   800,  2422,   365,  1524,  1385,     0,  1280,   361,
    1525,  1346,  1529,   818,   817,     0,     0,  1347,     0,   652,
       0,   656,     0,   658,   659,   660,     0,     0,     0,   661,
       0,  2352,  2406,   663,   666,   667,   668,   675,   680,   670,
       0,     0,   682,   676,     0,     0,     0,     0,     0,     0,
     688,   690,     0,     0,     0,     0,     0,     0,  1191,  1192,
    1386,  1283,     0,  1348,     0,  1141,     0,  1284,   188,     0,
       0,   286,  2422,   305,     0,   695,   800,     0,  1334,   302,
     331,     0,   346,   341,   342,   340,  2422,   365,  2422,   365,
       0,     0,     0,     0,     0,   343,   338,   339,   335,     0,
       0,   348,  2327,  2390,  2548,     0,   699,   701,     0,   706,
     351,  1304,   372,   371,   370,     0,   355,     0,   377,   380,
     352,   332,   330,   327,   299,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2287,     0,     0,  1233,     0,  1389,
    1349,     0,  1371,     0,     0,     0,     0,   740,  1392,  1290,
    1352,     0,  1411,  1413,  1403,  1291,  1412,   176,  1321,     0,
       0,   161,     0,     0,     0,     0,   155,   165,  1393,  1292,
    1353,     0,     0,  1394,  1293,     0,     0,   291,   593,   604,
     609,  1298,   613,   610,  1361,   611,  1401,  1294,     0,  1397,
    1324,  1356,   578,  1404,  1420,  1295,  1212,  1415,  1417,     0,
    1332,     0,   280,   282,     0,   301,     0,  1296,     0,  1354,
    1396,  1323,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1532,     0,     0,     0,     0,     0,     0,   365,     0,
       0,     0,  1334,  2422,   365,  1395,     0,  1329,     0,  1369,
       0,     0,   398,     0,  1322,  1332,     0,   293,  1300,     0,
    1363,     0,     0,   233,   232,   234,     0,     0,     0,     0,
    2208,  2209,     0,  2206,  2061,  2263,     0,   985,   943,   984,
       0,  2388,     0,   942,   944,     0,     0,     0,   945,     0,
     949,   950,     0,     0,     0,   941,   939,   940,   409,     0,
       0,   757,   758,     0,     0,     0,     0,   837,     0,     0,
       0,  1522,     0,   152,   650,     0,     0,     0,   645,   690,
     695,     0,     0,     0,     0,   462,   466,   470,   471,   472,
       0,     0,     0,     0,   166,   153,     0,   879,     0,   524,
       0,   750,  1409,  1408,  1211,     0,   198,   191,     0,     0,
     711,     0,  1570,     0,     0,   376,   832,   830,   829,   831,
       0,     0,     0,   853,   828,     0,  1850,  1852,     0,     0,
       0,     0,     0,     0,     0,   465,     0,     0,   527,     0,
     566,     0,     0,     0,     0,   563,     0,     0,     0,     0,
     849,  3072,   821,  1152,     0,  1170,  1153,     0,     0,     0,
       0,  1205,  1137,  1206,  1183,  1138,     0,     0,   622,  2789,
    2783,  1667,  1668,     0,  1230,     0,     0,  1518,     0,  1516,
       0,  1894,  1907,   901,     0,  1935,  1934,  1936,  1936,     0,
    1878,     0,  3211,  3219,  3218,     0,  1919,  1887,  1224,   365,
       0,   365,     0,   365,  1232,  1226,  1228,  1425,     0,   899,
       0,     0,   365,   892,   894,     0,   896,     0,     0,  2928,
    3115,  1049,   526,     0,     0,     0,     0,     0,     0,  1060,
     620,  1067,     0,  1081,  1076,  1078,     0,  1082,   726,     0,
       0,  1644,  1637,  1639,  1638,     0,     0,  1635,  2211,   891,
       0,   589,     0,     0,     0,     0,   365,     0,  1083,     0,
       0,  1004,   998,     0,     0,  1002,     0,     0,     0,  1005,
       0,     0,  1719,  2212,  2213,     0,     0,     0,  2251,     0,
       0,  2100,     0,  2074,  2076,  2088,     0,  2101,  2059,  2102,
    2078,  2080,  2089,     0,     0,  2194,     0,     0,  2091,     0,
    2023,  2024,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2039,
    2038,  2092,  2173,     0,     0,  2238,  2239,  2093,     0,     0,
    2245,     0,     0,     0,  2098,  2103,     0,     0,     0,     0,
    2109,     0,  2130,     0,     0,     0,  2049,  2204,     0,     0,
       0,     0,     0,     0,     0,     0,  2015,  1998,  2018,  1992,
       0,  1996,  2000,     0,     0,  2017,     0,     0,  1986,     0,
       0,  1984,  2010,  1980,     0,     0,  2011,     0,     0,     0,
    2067,     0,     0,  1714,  1714,  1714,  1714,  1711,     0,     0,
       0,     0,  2535,  2660,     0,  1810,  1785,  1787,  1797,  1810,
    1815,  1810,  2069,  1844,  2070,  2281,     0,  1756,     0,  1756,
    2978,  2980,  2981,  2982,  2983,  2984,  2986,  2987,  2989,  2990,
    2991,  2979,  2985,  2988,  2992,  2969,  2970,     0,  2960,  2961,
     209,     0,   242,   229,  3003,  1547,  1697,  1700,  1726,     0,
    2195,  1134,     0,  1728,  1749,  1750,     0,  1739,     0,  1778,
    1736,  1648,  1632,     0,  1630,  1617,  1619,  1618,     0,     0,
    1620,  2267,     0,  1630,  1612,  1656,     0,     0,  1849,     0,
    1655,     0,  2903,  2831,     0,     0,  3002,  3005,  3017,  3014,
    2841,     0,  1895,  1155,  1156,     0,  1179,     0,  1093,  1094,
       0,  1092,     0,     0,     0,   512,  1112,     0,     0,     0,
     800,     0,     0,   516,     0,  1527,     0,  1402,  1320,   654,
     655,     0,   669,     0,   678,   677,     0,     0,     0,     0,
       0,     0,     0,   662,   684,   626,   685,   687,     0,     0,
     686,   689,   692,  1332,     0,   724,  1306,     0,  1367,  1185,
       0,     0,  1144,     0,     0,     0,     0,     0,     0,   479,
     326,     0,     0,     0,     0,   152,     0,   307,   318,   383,
     324,     0,   357,     0,   329,     0,   322,   344,   336,   345,
     337,   356,   358,     0,   703,   704,   702,   698,     0,   705,
     707,     0,   374,     0,     0,     0,     0,  1388,     0,  1332,
       0,   295,  1302,     0,  1365,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1370,     0,     0,
       0,     0,   745,     0,   742,     0,     0,     0,   158,   157,
       0,   164,     0,     0,     0,     0,     0,     0,     0,  1421,
       0,     0,     0,     0,     0,     0,   392,     0,   300,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   399,   367,     0,   856,
       0,     0,     0,   401,     0,     0,  1380,     0,     0,     0,
       0,     0,  1387,  1285,  2064,  2065,  2062,  1723,  2262,     0,
       0,     0,   956,     0,     0,     0,     0,     0,     0,   412,
     413,   152,   411,   434,     0,   800,     0,     0,   834,   839,
     847,  2481,  2181,  2182,   845,   840,   842,   844,   843,   846,
       0,     0,     0,     0,     0,   495,     0,     0,     0,   485,
       0,     0,  1212,   478,   481,   482,     0,     0,   646,   649,
     647,   648,   683,     0,   465,   502,   553,     0,   168,     0,
       0,   169,   167,     0,     0,   376,   747,     0,   744,     0,
     194,   461,     0,   715,     0,     0,     0,  1212,   638,   769,
     772,   765,     0,   852,   854,   826,     0,   695,     0,     0,
     595,     0,   524,  1609,   583,     0,   555,   465,   553,   562,
       0,     0,   570,   375,     0,     0,   583,   376,     0,     0,
    1113,   848,     0,     0,  1151,     0,     0,     0,  1202,  1207,
    1203,     0,     0,  1166,     0,  1204,  1184,  1441,  1442,  1439,
    1440,     0,     0,     0,  2806,  1658,  2815,     0,     0,  1514,
       0,  1913,     0,  1931,  1929,  1874,     0,  2899,     0,     0,
       0,     0,     0,  1879,   903,     0,   886,     0,   888,   365,
     734,     0,   635,   365,     0,     0,     0,     0,     0,     0,
       0,  1059,     0,  1079,     0,     0,  1042,  1085,     0,     0,
    1642,  1640,   581,     0,  1264,  1265,  1088,     0,  1043,  1087,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2216,
       0,  2253,  2249,     0,  2071,  2217,     0,     0,  2233,  2232,
    2174,     0,     0,  2022,  2034,  2035,  2036,  2234,     0,  2044,
       0,     0,  2031,  2032,  2033,  2025,  2026,  2027,  2028,  2029,
    2030,  2037,  2243,  2242,  2236,  2237,     0,  2095,  2096,  2097,
    2244,  2104,     0,  2342,  2131,     0,  2108,  2124,  2123,     0,
       0,     0,  2111,     0,     0,  2120,     0,  2175,  2302,  1956,
       0,     0,  1983,  2248,  2001,     0,     0,  2019,     0,  1979,
    2194,     0,     0,     0,     0,     0,  1988,     0,     0,     0,
    2151,  2146,  2147,  2171,     0,     0,     0,     0,     0,     0,
    1705,  1704,  1710,  1810,  1815,  1810,     0,     0,  1682,     0,
    1797,     0,  1809,  1795,  1808,     0,     0,  1821,  1819,     0,
    1821,     0,  1821,     0,  1789,     0,  1811,  1791,  1808,  1793,
       0,  1836,  2282,  1845,     0,  1769,  2061,  1769,     0,     0,
       0,  3001,     0,     0,  1727,  1132,  1133,  1737,     0,  1740,
       0,  1847,     0,  1631,     0,     0,     0,  1622,  1628,  1610,
       0,     0,  1652,  1630,  1653,  2847,     0,  2902,  2967,  2968,
    1176,     0,     0,  1168,  1099,  1100,  1103,  1101,  1098,  1102,
       0,     0,     0,   800,     0,     0,   534,     0,  1126,  1126,
       0,     0,   518,   575,   529,   803,     0,     0,     0,   801,
     365,  1281,     0,   679,     0,     0,   674,   672,   671,   673,
       0,   627,  1400,  1282,     0,     0,     0,     0,  1186,  1335,
       0,     0,  1305,     0,   304,     0,   475,     0,     0,   310,
     319,     0,   315,     0,  1333,     0,     0,     0,     0,   314,
     387,     0,   384,     0,   365,   365,   359,   700,   373,   378,
     379,   382,  1340,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   880,   863,     0,     0,
     881,   882,     0,     0,     0,  1235,  1236,  1234,  1372,  1373,
    1378,  1375,  1374,  1377,  1376,  1379,     0,  1288,     0,     0,
     738,  1336,   162,   159,   160,   163,  1337,  1318,  1299,  1362,
     579,  1416,     0,     0,     0,  1297,     0,  1355,     0,  1314,
    1308,     0,     0,     0,     0,     0,  1399,  1328,  1360,  1398,
    1326,  1358,  1325,  1357,  1327,  1359,  1319,     0,     0,  1854,
     860,     0,     0,     0,   365,   365,   859,   736,  1301,     0,
    1364,  1310,     0,     0,     0,   946,     0,     0,   948,   951,
       0,   953,   417,   435,   152,     0,   756,   820,     0,     0,
     836,   799,     0,   483,     0,   489,   493,     0,     0,   497,
     498,   496,   484,  1212,   524,   574,   789,   790,     0,     0,
     810,     0,   644,     0,   463,     0,   499,     0,     0,   467,
     171,   170,     0,     0,     0,   751,   755,   753,   752,   754,
     749,     0,   740,   198,  2422,     0,     0,     0,     0,   576,
    1414,     0,   782,   827,     0,  1853,   730,     0,   376,   591,
    2771,     0,     0,   463,   583,  2770,     0,   468,   473,   474,
     479,     0,   563,   554,     0,   555,   564,   565,     0,   572,
    1489,     0,   584,   572,     0,     0,     0,   850,     0,   851,
    1154,  1171,  1172,     0,     0,  1135,     0,     0,     0,     0,
     629,     0,  2779,   365,     0,  1517,  1875,  3212,     0,  3213,
    3214,  3215,  3216,  3217,   365,   365,  1261,     0,   897,  1073,
    1074,  1075,  1072,  1071,   621,     0,  1077,   728,     0,   582,
     365,     0,  1012,   990,  1011,   989,   991,     0,   993,   994,
     988,   986,   987,  2252,  2087,  2090,  2099,  2231,  2173,  2204,
       0,     0,  2045,     0,     0,  2094,  2650,     0,     0,  2135,
    2136,     0,  2132,  2133,  2128,  2129,  2110,     0,  2470,  2115,
       0,     0,     0,  2007,  2005,  2002,     0,  2003,  1987,     0,
       0,  1985,  1981,     0,  2012,  2137,     0,  2153,  2150,  2170,
    2204,  1709,  1708,  1707,  1706,  1796,  1792,  1794,     0,  2655,
       0,  1799,  1806,     0,  1788,     0,  1820,  1816,     0,  1817,
       0,     0,  1818,     0,     0,  1790,     0,  1806,     0,  1843,
       0,     0,  2142,  2299,  2142,  2971,     0,  2974,  2972,  2973,
    2977,   243,  1695,     0,  1738,     0,  3227,  1614,     0,  1615,
    1621,     0,     0,     0,     0,  1657,  1650,  2904,  1169,  1177,
       0,     0,     0,   514,     0,   529,     0,     0,     0,  1119,
    1128,  1118,     0,   529,     0,  1212,   805,   804,   807,   802,
     806,  1528,     0,   664,   665,   681,  1307,     0,  1368,  1316,
       0,  1646,   306,     0,   696,   313,     0,     0,     0,   308,
     386,   388,   309,   312,   316,   367,   328,   321,     0,     0,
       0,  1303,     0,  1366,  1312,  1339,  1390,  1286,  1350,     0,
       0,   869,     0,     0,     0,     0,  1391,  1287,  1351,     0,
       0,     0,     0,  1646,     0,     0,     0,     0,     0,     0,
       0,     0,  1537,     0,     0,   366,   858,   857,   367,   400,
    1330,     0,  2063,     0,   947,   954,   955,   952,     0,   406,
     414,   417,     0,     0,  1252,  1252,     0,   800,     0,     0,
     480,   494,     0,   574,   533,     0,   486,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   743,   742,   193,     0,   463,     0,   695,     0,   776,
     777,   771,   773,     0,   784,   788,   855,     0,     0,     0,
       0,   465,     0,     0,  3221,   464,     0,     0,   476,     0,
     566,   555,   563,     0,     0,   580,     0,  1482,     0,   586,
       0,     0,     0,  1208,     0,  1214,     0,  1165,  1209,     0,
    1846,     0,     0,     0,     0,   633,  2805,  2809,  1253,  1515,
    3220,   887,   889,   735,  1080,     0,  1084,   365,   992,  2175,
    2040,     0,     0,     0,     0,  2105,     0,  2106,  2134,  2112,
    2116,     0,  2113,  2114,  2004,  2008,  2006,  1989,  2139,     0,
    1723,  2172,  1839,     0,  1842,     0,     0,  1798,     0,     0,
    1800,     0,     0,  1802,  1804,     0,     0,     0,     0,     0,
       0,  2285,  2369,  2625,  2532,     0,  1755,  1757,  1760,  1762,
    1761,  1763,  1759,  1768,     0,  1684,  1683,  2976,  2975,  2196,
    1848,  1629,     0,     0,     0,  1114,     0,  1654,  1081,     0,
     365,  1126,  1212,   535,  2481,   536,  1125,  1127,  1131,     0,
    1212,     0,   574,   657,     0,     0,   288,   694,     0,     0,
     311,   320,   369,   381,     0,  1646,     0,     0,   867,   876,
     876,   864,     0,     0,   883,  1289,   739,     0,     0,   283,
    1315,  1309,     0,     0,     0,  1539,  1540,     0,     0,     0,
       0,     0,  1338,   365,  1311,   957,     0,   437,   444,   418,
     422,  1531,     0,  1531,     0,   419,   423,  1531,  1531,   416,
    1846,   433,  1252,     0,  1249,  1248,   798,     0,   522,   597,
       0,   487,     0,   544,     0,     0,   811,     0,     0,   465,
     553,     0,   511,   503,   504,   505,   507,   506,   508,   509,
     510,   501,   500,     0,   695,   873,   376,  1489,   737,     0,
       0,   708,     0,   774,   779,   778,  1531,   783,     0,     0,
       0,   695,     0,  1609,   583,   555,   465,   553,  1606,   469,
     479,     0,   570,   563,   566,     0,   567,     0,   571,     0,
       0,     0,   583,  1541,  1113,     0,  1213,     0,     0,     0,
       0,     0,     0,  1256,   628,     0,     0,   632,   623,     0,
    2807,   695,  1044,  2041,     0,  2042,     0,     0,  2118,  2117,
       0,  2157,  1844,     0,     0,  1838,     0,     0,  1868,     0,
       0,     0,  1807,  1823,     0,  1803,  1801,     0,  1812,     0,
    1814,     0,     0,     0,  1764,     0,  2141,  2143,     0,     0,
    1627,  1846,     0,  1624,     0,  1095,     0,  1096,  1120,   574,
       0,  1131,  1134,   524,   574,     0,   800,  1317,     0,   697,
     597,     0,   323,     0,   296,  1313,     0,     0,   878,   878,
       0,     0,     0,     0,     0,     0,   394,     0,     0,  1533,
       0,  1534,  1535,  1538,   402,   415,     0,   442,     0,   440,
     439,   441,     0,   430,     0,     0,     0,     0,     0,     0,
     405,  1247,  1251,  1250,     0,     0,   488,     0,   490,     0,
     530,   531,   532,     0,   492,   540,   541,     0,   808,     0,
     813,     0,     0,     0,   695,   552,   719,     0,     0,     0,
    1483,     0,     0,   577,     0,   785,   786,   781,     0,     0,
     731,  1489,   583,  2772,   563,     0,   555,   477,     0,   572,
     566,   570,   568,   569,     0,  1486,     0,   585,     0,  1122,
    1136,  1215,  1210,  1445,     0,     0,   631,   630,  2810,  2812,
    2811,     0,   725,  2043,  2121,  2107,  2119,  2152,     0,     0,
       0,     0,  1837,  1840,     0,  1871,     0,     0,     0,     0,
    1857,     0,  1805,     0,     0,  1813,     0,     0,     0,  1758,
       0,     0,  1616,  1626,  1115,     0,     0,   539,     0,  1134,
    1116,   533,   800,   528,   515,  1646,   317,   368,     0,     0,
       0,   874,   877,   865,   866,   885,   884,   741,  1646,     0,
     390,   389,     0,   393,     0,   438,   447,     0,   445,   420,
     425,     0,   429,   427,   426,   421,   424,     0,   521,     0,
       0,     0,     0,     0,   542,     0,   543,   573,     0,   812,
       0,     0,     0,   721,   872,     0,     0,   463,   695,   775,
     780,     0,     0,  1484,  3221,   566,   555,   563,     0,     0,
     557,  1126,  1126,   450,   570,   572,  1487,  1488,     0,     0,
     376,  1444,  1443,  1700,     0,     0,  2808,  2613,     0,  2586,
       0,  2169,  2158,  2169,  2169,  2149,     0,     0,  1869,  1870,
    1855,     0,     0,  1859,  1822,  1835,  1766,     0,  1765,  2144,
    2145,  1846,   365,     0,   800,   537,  1117,   544,   517,   289,
    1646,   868,     0,   284,     0,   395,  1536,   443,     0,   428,
     788,   596,   491,   549,     0,   548,     0,   546,   545,   809,
     814,     0,   695,   862,  1489,   709,   787,     0,  1607,   570,
     563,   566,     0,   556,     0,  1128,  1128,   572,   448,     0,
       0,   572,  1427,  1700,  1426,  1428,  1436,  1433,  1435,  1434,
    1432,  1259,  1260,     0,  2162,  2161,  2160,  2164,  2163,     0,
    2156,  2154,  2155,  1841,     0,  1858,  1861,     0,     0,  1867,
    1860,  1862,     0,     0,  1833,  1767,  1623,  1097,     0,   519,
     800,   297,   875,     0,   446,     0,   547,   551,   550,   695,
     720,  1485,   793,   572,   566,   570,  1126,   558,  1127,   560,
     559,   452,  1122,  1123,     0,  1846,     0,  1437,  1431,  1682,
    1669,     0,     0,     0,     0,  2166,     0,  2167,     0,  1865,
    1866,  1863,  1864,     0,     0,   520,     0,     0,   722,     0,
     791,   794,   797,   795,   796,   451,   570,   572,  1128,   376,
    1121,     0,  1104,  1429,  1700,     0,     0,  2159,  2165,  2168,
       0,     0,   538,   391,     0,   759,     0,   572,   449,   561,
     572,  1124,  1430,     0,     0,     0,  1834,     0,   792,   453,
    1846,     0,     0,  1856,   793,  1105,     0,     0,     0,  1257,
    1258,   760
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5580, -5580,  4651, -5580, -5580, -1314,   364,  2906, -1048, -5580,
   -5580, -5580,  1401, -5580, -5580, -5580, -5580,  3745, -5580,  1983,
   -2962, -5580, -5580,   -23,  3716, -1774,   -29,  3237,  1611, -5580,
   -1588, -5580, -5580,  -960,    29, -5580,  3725,   294, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -1227,  2103, -5580,  2183,
    1410,  3851, -2994, -5580, -5580, -1973, -3815, -5580,   677, -5580,
     704, -4844,  -879, -5580, -5580, -5580,  2085, -5580, -5580, -5580,
    2030,  1205,  -314, -5580, -5580, -5580, -5580, -5580, -5580,  -726,
   -5580, -5580,  -977,   332,  -104, -3003, -4363, -5580, -5580,   535,
    -363, -1955, -5580, -4200, -5580,    41, -2343, -5580, -5580, -5580,
    -328, -1926,  1517, -5580, -1078, -1601,  1859, -4745,  -840, -5580,
    -203, -5580,  -953,  -741,  -739,  -875, -4387, -4875, -5580, -5580,
    -986, -3834, -5183, -5413, -4874, -4554,  1520, -5580, -5580, -3689,
   -4377,   356,   509, -5580,   581,   601, -5580,   525,  -664, -1331,
   -2053, -5580, -1198, -5580, -5580, -5580, -3511, -5580, -5580, -5580,
   -5580,   -62, -5580, -5580, -5580, -5580,   580, -5580, -5580, -5580,
   -5580, -5580, -5580, -3205,  2056,  2057, -5580, -3605, -5580, -1302,
   -5580,   733, -3545,  1440, -5580, -5580,  1206,  3770,   564, -5580,
   -5580, -5580, -5580, -5580, -5580, -5580, -2153, -5580, -5580, -5580,
   -5580,    46,  -293, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
     617, -5580,  2073,  1199, -5580, -5580,  -296, -5580, -5580, -5580,
   -5580, -5580, -5580,  -923, -5166, -1086, -1067, -5580, -3543, -5580,
   -5580, -5580,  -268, -5580, -5580, -5580, -5580, -5580, -1317, -5580,
    1263, -4172, -5580, -5580,   540, -5580, -5580, -5580, -5580, -5580,
    -842,  -206,  2917, -5580,  -441,  -639, -5580, -5580, -5580,  -204,
   -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -1467,  9200,
   -1259,  -887, -5580, -5580, -5580, -5580, -5580, -2856, -5580, -5580,
   -5580, -5580, -4358, -5580,  4949,    95,  -802,   622, -5580,  -187,
     -83,  3500, -1578, -3197,   490,  -404, -5580, -5580, -5580, -3097,
   -5580, -5580, -5580, -5580, -4123,   909, -5580, -1028, -5580, -4409,
   -5190, -4611, -4187,  -996, -5580, -4159, -5579, -4510, -4119, -5580,
   -5580, -5580, -5580,  -816,  -870,  2881, -5580, -1929,  2426, -1304,
   -5580, -2619,   558,  1615,  2896, -3287,  -809,  2878, -3066, -1057,
   -3841, -5580, -5580, -2864,  -536, -5580, -5580,  1392, -1517, -5580,
   -5580, -5580, -5580,  -968,  2828,  -902, -5580, -5580,  4139, -5580,
   -4215, -5580,  4109, -5580, -5580, -5580, -5580,  2715,  2718, -5580,
    2719, -5580, -5580, -1920,  1366, -5580, -1137, -5580, -5580,  2193,
     762, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,  1258,
     745, -5580, -5580, -5580, -5580, -5580,  -829, -1009, -5580, -5580,
     919, -5580, -5580, -5580, -5580,  2114, -1303, -1085,  3990,   891,
     946, -5371, -5580, -5580, -1495, -5580,  3218, -5580, -5580, -5580,
   -5580, -5580,   563,   565, -5580, -5580, -5580, -5580, -3208, -5580,
   -5580, -4958, -5580, -5580, -5580, -5580, -5580,  3973,    13,  2582,
   -5580, -5580, -5580,  -235, -5580, -5580, -1392,  2569, -5580, -2398,
   -5580,  -913, -5580,  2806, -5580, -5580, -5580, -5580, -2330,   971,
   -4385,   -61, -5580, -5580,   -78, -5580,   366, -5580, -5580, -4016,
     -57, -5580, -5580, -5580, -5580, -5007, -5580,   -56,  -722,   927,
   -3342, -5580,   996,    44,  3594,  1993,   -60,  3571,  -242,  -218,
    -202,   -55,   -64,  3365, -5580, -5580,  3412, -5580,  -198,  2013,
   -5580, -5580, -1173,  -344, -5580,  1739,  -970,  2542,  3367,  3350,
   -5580,  1721,  2574, -2418, -2411, -5580,   990,  -704,  -540, -5580,
   -5580, -5580, -5580,   399,  -956,  2556, -5580,  3368, -5580, -5580,
   -5580, -2353, -3394, -4020,  1019, -3993, -3940,   440,   421, -1333,
    -301,  -148, -1135,  3371, -5580, -5580,  1025,  -506, -5580, -5580,
    -504, -3358,   951, -5580, -4995, -2826,  1029,  -969,  -799, -5580,
    -886, -5580,  -674,  7137, -2131, -1464, -5580, -5580, -1431, 21008,
   -5580, -5580, -5580, 23949, 24242, -5580, -5580, 28692, 30086, -5580,
   -1264, 31591, 14641, -1447, -1417, -1691, 29404, -2102,   986,   149,
   -5580, -4015, -1499, -5580, -5580, -5580,  -259,  1086, -1952, -5580,
   -5014, -4447, -5580, -5580,   -25, -5580,  -678, -5580,  -676, -5580,
   -5580, -5580, -2641, -5529, -2713,  2690, -5580, -5580, -5580,  -891,
   -5580, 31334, -3248, -5580,  -774, -1683, -2025, -3980, -2333, -5580,
   -5580, -5580, -3148, -5580, -5580, -5580, -5580, -2554, -3875,  -489,
    1839, -5580, -5580,  1939, -5580, -5580, -5580, -1321,  2235, -1122,
   -3149,  1849, -5580, -1119,  2701, -1147, 31115,  -949, 28592,   -99,
   -2819, -1716, -2085, -5580,  5670, -5580,  4243,  -151,  -760,  6376,
    -599, -1012,  9873,  7990,  6175, -3730, -5580, -5580,  1062, -5580,
   -5580, -5580, -5580,  4550,  1282, -5580,  3771, -5580,  2121,  2988,
   -5580, -5580,  2566, -1010,   -84, -5580,  -624, -5580,  -142, -5580,
   -5580, -5580,   348, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
   -5580, -5580,  3385, -5580, -5580, -1645, -5580, -5580, -5580, -5580,
   -5580,  4864,  -384, -5580,  4205,  -365, -5580, -5580, -5580, -5580,
   -5580, -5580, -5580, -5580, -5580,  3393,  2607, -5580,  3982, -5580,
   -5580, -5580,    -3,  3613, -5580, -5580, -5580,  -659,  -941,  4006,
    4008,  2572, -5580, -5580, -5580, -5580, -5580, -5580, -5580, -5580,
    2584, -5580, -5580,  1841, -2459,  2588, -5580, -5580,  1011, -5580,
   -5580,   480, -5580,  1014, -5580,  3511, -5580, -5580, -5580,  1056,
   -5580, -5580, -5580,  -579, 21392,   252,   -96,   729,  1943, -5580,
   13070, 18641,    36,  3413,   -44, 17410, 25175,   289, -5580,  4857,
    2585,  2076, -1129, -5580,  4705,  2884, 29979, -5580, -1124,  1609,
    2651, -1121,    -2,  -700, -1363,  3728,  -800, -2294, -5580,  5284,
   -5580, -3559, -5178, -1168,    31,  4207, -1397
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   248,   249,   250,  2058,  3047,  2898,  3884,  3885,
     251,   252,  2054,   253,   254,   255,   256,  1972,   257,  1443,
    2223,  3062,   258,  2733,  1172,  1173,  1174,  2582,  2583,  2986,
    2584,  2571,  1794,  2377,  1994,  1137,  1138,  1953,  1995,   260,
     261,  1788,  2563,   262,   263,   264,  2025,  2112,  2026,  2027,
    1966,  2276,  4989,  5762,  3676,  2862,  3932,  3677,  3678,  4348,
    4349,  4428,  5776,  5777,   265,  2128,  2129,   266,   267,  3028,
    3849,  4481,  5369,  5370,  5609,   955,  5014,  5015,  5596,  5597,
    5790,  5937,  5938,  3063,  2215,  3927,  4566,  3875,  5086,  3876,
    5087,  3877,  5088,  3861,  4513,  4514,  5028,  4515,  3878,  5046,
    5641,  3879,  2752,  5806,  3104,  2407,  2405,  5285,  5623,  4845,
    4846,  6024,  5814,  5815,  5816,  6047,  5048,  5092,  5093,  5979,
    5980,  3930,  4572,  5099,  5435,  5386,  3562,   269,   270,  2249,
    4041,  1067,  3107,   989,  1068,  3064,   274,  3097,  5808,  3098,
    2084,  2912,  4494,  4021,   275,  1469,  4314,  5455,  5697,  5698,
     276,   932,   277,  2231,   278,   279,  3042,  3868,   280,  2769,
    3579,   281,   282,  3610,  3611,  3612,   283,  4339,  5303,  2028,
    3665,  3666,  3667,  3668,  4369,   284,  2226,  3071,  3072,   285,
     286,   287,   288,  3237,  3238,   289,  2972,   290,   291,   292,
     293,  4404,  4950,  5062,  3707,  3891,  4538,  5060,   294,  3853,
    3065,  2239,  3087,  3088,  5072,  5411,  5412,  5413,  5656,  5969,
    5415,  5658,  5837,  5660,  5038,  6159,  6160,  5377,  4293,  4859,
     296,  5039,  5040,  5821,   297,  2767,   298,   299,  2199,  3034,
    3035,  4495,  3114,  3939,  3940,  4552,  4553,   300,  3791,   301,
    4926,  4927,   990,  5828,  5768,  5923,   302,   303,  4930,  4931,
     304,   305,   306,   307,   308,  1053,  1054,  1055,  1569,  1570,
    3534,  1514,   309,  2594,   310,  1407,  1408,  3828,   311,  1669,
    3283,  3284,  5153,   312,  1091,  1600,  1601,  3066,   314,  1102,
    3257,  1104,  2422,  4023,  4024,  4646,   315,   316,  3234,  3260,
     317,  1959,  2743,  2744,  4840,  3067,   991,  1654,  3111,  3557,
    5534,  5279,  5535,  5990,  6134,  5280,  5548,  3456,  4233,   319,
     992,  2000,  2819,  1537,  1538,  3117,  3944,  2712,  2713,  2714,
    4592,  2715,  3946,  2716,  1933,  2717,  1486,  1487,  3952,  3953,
    3954,  4588,  4595,  3056,  5445,  5446,   320,  1997,  2816,   321,
     322,   323,  2037,  1318,  1547,  1548,   324,  1014,  1015,   325,
    5614,   326,  1489,   327,  5453,   328,   329,  1126,  1127,  1651,
    1652,   330,   331,  2833,  4351,   332,  1998,   333,   334,  3701,
    3702,  4942,   335,   336,   337,  2218,  2219,   338,   339,  3756,
    3757,   340,   341,   342,  6074,  6136,  6137,  6138,  4601,  5993,
    6076,  1643,   344,   345,   346,   935,  1360,  1361,  1362,  1279,
    3068,  5437,   348,   349,  1954,  1955,  1956,  1957,  2738,   350,
     351,   352,  3968,  3969,   353,   354,   355,   356,  2203,   357,
     358,  5587,   359,   360,  2164,   361,   362,  1819,  1820,  1821,
    1822,  2600,  3444,   949,  1192,  1825,  1831,  1835,  1836,  1837,
     364,  1070,  1594,  1595,  1596,  2379,   365,  1647,  1411,  1071,
    1589,  1072,  2646,  3486,  4248,  4249,  4250,  4253,  5263,  4813,
    1073,  3482,   369,  2429,  3243,  3246,  3478,  1074,  3491,  3492,
    3493,  4256,  1075,  1093,  1479,  3127,  1076,  1742,   374,   375,
     376,  1201,  1195,  1196,  3449,   378,  2540,  3417,  1111,  1841,
    1156,  1157,  1209,  2996,  2612,  2613,  2637,  2638,  1850,  1851,
    2625,  2629,  2630,  3468,  3462,  2618,  4795,  5516,  5517,  5518,
    5519,  5520,  5521,  5242,  2633,  2634,  1853,  1854,  1855,  2642,
     379,  3421,  4186,  4187,  4188,  4772,  4773,  4787,  4783,  5227,
    5503,  4189,  1637,  1861,  5235,  6104,  4190,  5492,  5493,  5715,
    4791,  4197,  4244,  3915,  3916,  3917,  4191,  5889,  5890,  6100,
    6101,  5717,  5718,  2718,  2306,  1516,  1743,  1517,  2314,  1744,
    2290,  1519,  1745,  1746,  1747,  1522,  1748,  1749,  1750,  1525,
    2282,  1751,  1752,  2300,  1241,  1242,  1826,  5719,  1754,  1755,
    1756,  4193,  1757,  4725,  5191,  5177,  3343,  3344,  2579,  4721,
    4128,  4715,  2535,  3407,  5525,  5736,  5737,  4170,  4751,  5207,
    5490,  5881,  6001,  6002,  6090,  1758,  1759,  1760,  3404,  2530,
    1321,  1761,  4497,  2532,  3337,  2154,  2155,  2435,  2456,  3289,
    3304,  3305,  3381,  3317,  4087,  3325,  3330,  4115,  4116,  3338,
    3367,  1762,  3291,  3292,  4069,  2458,  1763,  1366,  2158,  1367,
    2548,  3362,  1778,  1764,  1765,  2423,  1183,  5499,   779,   762,
    3693,  2160,  1369,  1108,  1766,  1767,  1768,  1883,   722,  1540,
    1541,   724,   763,   764,   938,   876,     2,    70,  1077,  3924,
    5420,   383,   384,   994,   995,   996,  1471,  1472,  2262,  2265,
    1888,  2680,   728,   729,   780,  5122,  5456,  5700,  1061,   385,
     386,   387,   388,  1884,  2676,  1243,    71,    79,    72,  1244,
     425,   426,  2657,   389,   893,   390,  1864,  1223,  4262,   391,
     392,   393,   394,   395,  1058,   396,  1225,   397,  1226,   398,
     399,   400,   401,  1233,   402,  1866,  1867,  4827,  1868,   403,
     404,   766,   767,  1587,   405,   406,  1260,  2366,  1262,  1620,
    1894,  1908,  1909,  1910,   407,   736,   408,   409,   410,  1900,
    1901,   411,  2556,  2557,  2685,  2558,   412,  3507,  3508,   413,
    4215,  4216,  5248,  4217,   414,  2552,   415,   416,  1186,  4267,
     417,   889,   418,  1274,   768,   769,   770,   940,   879,  1142,
     781,   942,  3669,   881,   882,   772,   773,   774,  2399,    73,
    3515,  2400,  1770,   782,  1771,  2546,  1772,  1773,  1774,  1775,
    1776,  1777,   776,  1250,  1579,  1580,  3516,  1582,    77,  1583,
     422,  3985,  2367,  1621,  3190,  2385,  2386
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      76,  1481,  1437,  2083,   765,  1200,  1005,  1220,  2376,  1319,
    1095,  1811,   367,   372,   877,  1789,   368,   370,   377,  1148,
    1320,  1628,  1629,  1630,  1939,  2404,  1221,  1634,  1185,   420,
    2925,  1210,  1095,  2088,  2751,   420,  1292,  2133,  1779,  1856,
     988,   765,  1882,  3874,  1325,  2296,  2162,  1330,   993,  2857,
    1817,  2828,  3955,  1480,  1597,  3695,  2228,  1117,  2146,  2152,
     877,  4046,  1816,   997,  1004,  2302,  2286,  2287,  4199,  3187,
    2820,   421,  1182,  1004,  3754,  2322,  2295,   421,  2999,  1320,
    2829,   733,  1103,  1258,  1803,  2447,   363,  4242,  1280,  3092,
    4548,  2840,  1052,  4340,  3527,  3529,  3427,  3897,  4320,  1655,
    4847,  4577,   259,  2030,   377,  1572,  3249,  2082,   421,  2201,
    2312,  4596,  4804,  2206,  4596,  1004,  2111,  4364,  2210,  4366,
    2213,  3288,   933,  1149,  2990,  1261,  2138,  2220,  1204,  4498,
    1911,   945,   877,  3788,   778,  1913,  2241,  4027,  1916,  4886,
    1320,  2244,  2952,  2953,   784,   999,   880,  1296,  4255,  3833,
    1619,  3834,  1592,  1481,   421,  3838,  1328,  3840,  3841,  1212,
    4842,  5045,  1563,  2029,  4769,  3141,  3845,  3846,  3847,  3112,
    1350,  5106,  1069,  2001,  4738,  1213,  1136,  2280,  5084,  1823,
     947,  5095,  1198,  2664,  2666,  2667,  1179,  5085,  2047,  2948,
    1171,  1823,   880,  2064,  3175,  1007,  3426,  4786,  3441,  5102,
    4136,  5393,  4910,  1145,  5094,  1796,  5496,  4231,  1432,  3450,
    3471,  1145,  2391,  1145,  1441,  2811,  2979,  2362,  1551,  3474,
    5432,  1555,  2724,  5627,  2658,  2658,   421,  1455,  4153,  5439,
    3887,  2283,  2284,  4561,  2598,  1996,  4271,  4819,  5281,  1849,
    4704,  5508,  2294,  5510,  1890,  1891,  5668,  5672,  1816,  4784,
    5431,  4789,  5685,  1852,  1253,  4266,  1092,  1581,  2554,  5849,
      39,  2286,  2287, -2292,   880,  4522, -1936,  5182,  1996, -1928,
    2313,  2811,  4848,  1996,  2240,  2302,  5830, -3075,  1092,  1606,
   -3076,  2295,   936,  1611,  1612,  1613, -3075, -3075,  2811, -3076,
   -3076,   428,  1903,  1624,  5556, -1936, -1895,  4093,   953,  5278,
    1475, -1908,    40,  5155,  5156, -1933,  5158,  5159,  5160,  5161,
    5162, -3073,  1275,  2841,  2964,  1893,  1896,   428,  1903,  2502,
   -3073, -3073,   367,   372,  2592,   419,   368,   370,   377, -1923,
    2959,   419,  2831,    39,  3864,    39,  5579, -2291,  2192,    39,
    2273, -3072,  3991,  1249,  3993,  4260,  1356,   420,  2508,   428,
   -3072, -3072,  2273,   934,    38,    39, -2666,  1671,  1672,  1278,
      40,  3813,   419,  1960,  3053, -2666, -2666,  4586,  1793,    35,
     428,  5767,   428,    37,  3322,    38,    39,    38,    39,   428,
    2510,    40,   420,    40,    38,    39,  -152,  1671,  1672,   421,
      40,  -152,  5589,  5590,  3360,  2397,   363,  -152,  2378,   884,
    4067,  3259,  2273,  2273,  3089,   268,  4321,  2273,   419,  3026,
    2273,  5109,   259,  1214,  4316,  3360, -2179,  2283,  2284,  1827,
   -2463,  2368,  4616, -2179,   421,   428,  3401,   424,  2831,   271,
      38,  3531, -2289,  3402,  2254,  2273,    40,  1553,  5985,  2273,
    2143,  3865,  3101,  2294,  1357,   884,  2609,   734,  2273,  2753,
    5695,  1566,   428,  5036,    35,  2662,  2735,  4855,    37,  1782,
    1617,    39,  4972,  5802,  2988,  2989,  5732,  3102,  6083, -2198,
    5973,  5179,  1961,  3050,  5555,  2670, -2198,  2754,  2671,  2616,
     419,  2892,  2665,  2806,  2569,  2179,  6129,  6130,  3548,  3618,
      39,  5851,  3453,  1358,  1144,  2162,  1320,  1632,  1215,  3060,
    2146,  5055,  1144,  2836,  1144,  2837,  3650,  2502,  5654,  1277,
    2577,  -436,  2545,  2174,  5729,  3239,  2663,   884,   894,  2181,
    1339,  2831,  2182,  4246,  1083,  3498,  2297,   115,  1221,  2886,
    5542,  1463,  1664,   428,  3345,  4277,  2508,  3348,  5550,  4856,
    2285,  2831,  2725,  2831,    40,   119,  2903,  2298,  1084,  1340,
    1359,  2946,  2578,  4422,  5655,  1481,  5673,  4044,  5764,  4247,
    3420,   428,   895,  2167,  3298,  3514,  2838,  3651,  2510,  3518,
    1968,  6067,  2593,  2198,  3549,  2617,  2807,  3454,  3061,  1504,
    1633,  5180,  3619,  3090,  1481,  4093,  2467,   993,  2672,  6189,
    1645,  3051,  5056,  1256,  1257,  1238,  2541,  2197,  2320,  5037,
    4857,  2570,   997,  2572,  4858,  2909,  2831,  2350,  2585,  2585,
    2541,  5803,  2757,  4487,  6177,  2144,  2831,  2842,  2831,  2274,
    2497,  2438,  3573,  5289,  2599,  5696,  2755,  3866,  4546,  1238,
    2843,  2274,  2844,  1962,  3532,  4973,  3533,  3299,  1364,  3240,
    2588,  2589,  1365,   419,  4498,  5652,  6123,  2544,   894,  3027,
    1673,  1004,  1004,  4093,   272,  3103,  1481,  4094,  4095,  4096,
   -2463,  2427,  2978,  1619,  4321,  2502,  1290,  5984,  1619,  4944,
    4317,  1963,  1464,  5972,   273,  1190,  2965,  5057,   419,  1969,
    2162,  2274,  2274,  6121,   999,  2380,  2274,  5951,  4516,  2274,
     295,   735,   895,  2845,  2508,   313,  2036,  1925,  3300,  1249,
    3814,  3301,  2281,  4093,  1964,  2966,  3038,  5424,  2451,  1364,
    3290,  2297,  6167,  1365,  2274,   268,  3867,  2320,  2274,  2145,
    5054,  2960,  1216,  2198,  2428,  1904,  2510,  2274,  4587, -2463,
    3054,  1666,  2298,   954,  1254,  2893,  5478,  4286,  1660,   271,
    2297,  1364, -2463, -2292,  3361,  1365,  2299,  4852,  2796, -1928,
    3091,  1904,  1899,  6187,  2555,  5224,  5196, -3075,  3614,  5228,
   -3076,  2298,  5103, -2179,  2920,  4159,  4108,  2923,  1089,  1090,
    2275,  4786,  1965,  3403,  1247,  2301,  2285,  1343,  2361,  2798,
    3148,  2289,  2303,  2941,  1255, -1933,  1481,  2930,  2529,  2805,
    5844, -3073,  6059,   877,  1481,  1481,  6058,  2381,  6069,  5468,
    2383,  1285,  3209,  2387,  5167,  2389,  2871,  5266,  2392, -1923,
    1481,  3302,  2396,  2499,  2365,  2542, -2198, -2291,  1465,  3432,
    5013, -3072,  5934,  5215,  1200,  5217,  1905,  1906,  2398,  5621,
    4097,  5058,  2317,  2328,  1598,  2056, -2666,  2352,  2567,   878,
    2355,  3241,  2987,  2152,  2152,  2152, -1895,  1880,  1881,   420,
    5246,  3689,  4098,  4498,  1466,  1633,  1905,  1906,  2057,  3422,
    1477,  3242,  1423,  -152,  -152,  2320,  4479,  4480,  1857,  4645,
    3633,  2947,  2910,  4423,  3615,  2913,  2914,  2502,  6125,  2681,
    1633,  2605,  3153,  4257,  3179,   878,  2643,   421,  1406,  6006,
    5428,   421,  4419,  1412,  1415,   945,  2872,  1413,  1414,   377,
    2644,  5059,  1880,  1881,   945,   733,  2508,  4273,  6029,  4274,
    1646,  1970,   945,  1467,   733,   945,  1249,  2198,  1004,  1468,
    4099,  6033,  3303,  1491, -1895,  1266,  3574,  1599,   733,  1605,
    5748,  1610,  2758,  2198,  4540,  4676,  4458,  1614,  2510,  5290,
    2815,  6166,  5017,  3219,  1120,  4561,  4874,  1008,  4915,  3690,
    2330,  2603,  5076,  1291,  3231,    35,  5451,   878,  1590,    37,
    2428,  1605,  1610,  1636,   272,  2048,   733,  2496,  2603,  3823,
    4219,  5977,   733,  5016,  1971,  5983,  1586,  3008,  5961,  4472,
    1004,  2995,   318,  1212,   273,   733,  4517,  3199,  4832,  2815,
    5708,  6184,   343,  3202,  1191,  2745,  5952,  2362,  5756,  1213,
     295,  5976,    39,  1428,  1478,   313,  2815,  4389,  1534,  3538,
     377,   733,  3500,  2746,  3500,  5388,   945,  4473,  4474,   347,
    5619,  1532,  5743,  6111, -1670,   945,   733,  1805,  3138,  3139,
    1121,  2117,   945,  2424,   733,   945,  3220,  1636,  5752,     3,
    2811,  1943,  3471,  1083,   366,  2925,  4225,  1532,   733,  2437,
    4236,  4105,  4106,  4107,  4108,    76,  1263,  4333,  5665,  5129,
    5130,  5131,  5132,  5133,   733,  2448,  4031,  1084,  1860,   371,
    2172,  2747,  2880,  2118,  2049,  1249,  3483,   765,  3605,  1593,
    6148,  4200,  3587,  3352,  4201,  4202,  2745, -2408,  2651,  4847,
    2748,   427,  5120,  1944, -1895,  4203,  4204,  4205,  3386,  4206,
    4207,  6060,  4817, -1670,  4208,  4209,  4210,  1591,  5578,  3476,
    4569,  6068,  2538,  4100,  4101,  4102,  4390,  4103,  4104,  4105,
    4106,  4107,  4108,   890,  1604,   891,  1609, -1673,  5389,  4334,
    1828,  2526,  2527,  2528,  2529,   382,  1623,    39,  4258,  1120,
    1792,   419,  1818,  1975,  1800,   419,  5563,  2308,    39,  1320,
    3546,  4943,  5069,  1617,   945,   945,  1639,  1641,  1786,  3606,
    5615,  1145,  2747,   733,  1617,  1145,    39,  4103,  4104,  4105,
    4106,  4107,  4108,  3105,  4033,  1603,  2162,  1608,   884,    35,
    1083,  2748,  5991,    37,   421,  1625,  5744,  3945,  1122,   733,
    1945,   945,  5261,  6131,  5473,  5907,  5452,  6135,  3189,  5709,
    5912,   733,  1871,  5494,  1084,  5500, -1673,  1638,  1640, -1670,
    5504, -2804,  1083,  5506,  3477,  2759,  4597,  4090,  4091,  3681,
    1235,  1009,  4110,  2162, -2444,  1121,  4342,  3425,  5497,  1123,
    1124,  1234,  2320,  5346,  3387,  2050,  1084,  2749,  2152,  3388,
    4496,  5909,  3083,  5823,  2119,  2296,  6144,  4848,  2308,  6165,
    2734,  4211,   733,   733,  3484,    39, -2465,  5347,  5430,  4140,
    4141,  4848,  2122,  5418,  2928,  3719,  5822,  1806,  2123,   877,
   -1670,  3228,  3229,  2051,  4596,  5858,  3389,  4391,  5842,  1010,
    5846,  1236,  3851,  1958,  2309, -1895,  4501,  5843,  4032,  2232,
    1429,  3221,   318,  6188, -1895,  1535,  2285, -1895,  1938, -1895,
    5273,  4598,   343,  5845,  1235,  5857,  2052, -2408,  1264,  4224,
    1136,  2103, -1673,  6199,  1952,  4392,  6200,  1011,  3720,  1012,
     212,  1235,  1125,  5620,  6145,   123,   124,  3084,  2749,   347,
    4593,  2233,  4504,  2339,  3609,  4343,  1807,  1145,  1145,   783,
    5304,  2524,  2525,  2526,  2527,  2528,  2529,  2120,  4393,  1660,
    2750,  3016,   967,  1949,   366,  1950,   220,  2173,  5992,  1626,
    1597,   945,   945,   421,  2760,  1236,  4776, -2408,  1237,  3588,
     945,  2124,  2497, -1673,  1927,  2340,  3721,  1532,  4652,   371,
   -1670,   945,  1236,  1122,  1618,  2309,  1062,   945,  4506,  1083,
     945,  2539,  4212,  3017,  1238,  6085,  4034,  5801,   231,  3827,
    5262,  2161,  1532, -1752,  3137,  3181,  1063,  2260,  6146,  3526,
    4408,   234,   969,  1084,  1892,  1895,  5746,  1532, -1670,  3390,
     892, -1670,  3435,  3682,  1123,  1124,  3165,  4848,  5152,  3235,
    6117, -2804,  2539, -2502,   246,   948,  1320,  1320,   419,  4777,
    1064,  2750,  4035,  1619, -2444,   382,   960,  3155,  3485,  1619,
    4213,  4308,  1144,  2761,  1872,  4599,  1144,  3173,  3195,  2664,
    3218,   945,   945,   945,  3223,  5974,  3130,  1013,  3227,  1207,
    5847,  3230,  4778,  1207,   205,  3605, -2465,  3503,  1238,  5265,
    3722,  5379,  3852, -1673,  2018,  5725,  4509,  4779,   967,  6043,
    4923, -2804,  5704,  4309,  3475,  1238,  2940,  4780,  2878,  1200,
    3154,  5810,  2234,  2895, -2444,  2310,  3315,  1532,  1617,  1062,
    5081,  3135,  3250,  3148,  3236,  3167,  5348,  2831,  3169,  3672,
    4261, -1673,  4036,  4781, -1673,  4600,  5115,  2832,  4510,  1063,
    4653,   967,  2125,  4679,  2696,  5082, -2465,  3085,  4344,  4345,
    6086, -1751,  4237,   377,  4511,    35,  2341,   733,   969,    37,
    5501,  3086,  6147,  1221, -1107,  5904,  3606,  -588,  3408,  5150,
    4214,  1586,  4705,  1064,  3018,   733,  1911,  4346,   950,  1928,
    2126,  1913,  3673, -1752,  1916,    76,    76,  3738,    76,   980,
    2858,   981,  3045,  1320,  6118,  1823,   945,  5766,  4498,  1239,
    2601,   969,  5770,  5771,   733,  2320,  3222,  3631,  5674,  3225,
    3226,  3723,  4924,  2127,  2267,  2235,  2310,  2214,  1240,  3724,
    3772,    74,  3725,  5675,  4782,  5005,  3773,   419,   878,  5008,
    5009,   202,  5011,  2610,  2611,  2311,  2615,  5676,  1144,  1144,
     733,  5811,  2879,  5910,  1618,  1618,  3101,  5031,  3781,  1213,
    1213,  4512,  1213,  3898,  1532,  2382,   733,  2384,  5035,  2342,
    2388,   212,  2390, -2502,   884,  2393,  2394,  2395,  2268,  1205,
    6097,  3102,   733,  1303,  4310,  2198,   733,  3019,  2402,  3674,
    1304,  1305,  1306,  2661,  2994,  5043,  4529,   945,  3816,  3285,
    3287,  3737,  2430,  5070,  2431,  2925,  3294,   220,  4807,  6044,
    2152,  3989,  3308,  3309,  3310,  2922,  3409,  4332,  5494,  4928,
     765,   765,  5502,  3327,  3329,  5812,  4925,   945,  3339,  3191,
    1860, -1751,  4238, -2502,  3739,   980,  3762,   981,  3213,  3774,
    3156,  2267,  3742,  5083,  1206,  3745,  1481,  4848,  1259,   231,
    5075,  3609,  4669,  1065,  3168,   945,   945,   945,  3894,   945,
    2859,    35,   234,   986,   202,    37,  2662,  3174,  4089,  2934,
    3807,  2533,  5081,  3712,  3713,  4496,  2269,  3716,   980,   945,
     981,  3906,  3907,  3908,  3909,   246,  2763,  4311,  6045,  2860,
    3046,   983,   877,  3914,   212,  3194,  2764,  5082,  2935,  1066,
    4941,  2559,  2560,   985,  1981,  5679,  2214,  -693,  3605,  5032,
    6026,  3823,   951,  5680,  2861,  6046,   733,  4467,  3942,  2575,
    1207,  5677,  5651,   765,   733,   733,  5134,  2663,  5135,  6098,
     220,  4929,  2270,  5763,  6099,  3817,  3818,  3819,  3966,  1356,
     733,  3787,  6065,  6066,  1356,   420,   420,  1943,  1154,  2856,
    5171,  5829,  5172,  5981,  5617,  3675,  3560,   885,  1205,  5850,
    4424,   945,   877,  1410,  4530,   945,   945,   886,  4631,  5405,
    3726, -1723,   231,  4501,  5632,  2967, -1723,  3786,  4808,  4502,
     945,  1839,  2069,  5044,  3214,   234,   421,   421,   421,  3606,
    4805,  4503,  2236,  2269,   420,  3233,  5026,  4374,  3593,  1944,
    3775,  2070,  2700,  6133,  2678,  4459,  1106,   733,   246,  1320,
    4375,   894,  3561,  2237,  2915,    39,  3215,  4802,  5878,  4504,
    5027,  4505,   247,  1206,  3607,  5633,  1110,  2271,  3589,  3216,
    2791,  3594,  3595,  5634,  3778,  2320,   421,  1357,  3776,  3893,
    1238,  4194,  1357, -1723,   421,  1118,   967,  3726,  1155,  2270,
    1532,  2071,  4806,  4229,  2765,   895,   421,  2320,  1208,  2053,
    1845,  5635,  3608,  5694,  3217,  2619,  1145,  1576,   887,  1958,
   -1682,  3777,  3779,  1958,  5467,  4506,  5681,  2943,  4573,  4420,
    4292,  1840,  3581, -1682,  4496,  5967,  1358,  6168, -1682,  1150,
   -1723,  1358,  2766,  4848,  2161,  5173,  1945,  1968,  4688,  1207,
    4689,  2038,  4194,  4507,  6191,  3780,   969,  1145,  2620,  2968,
    3512,  3705,  4684,  4685,  4686,  4687,  5636,  1532,  4692,  4693,
    4694,  4695,  4696,  4697,  4698,  4699,  4700,  4701,  1227,  5637,
    5975,    38,  1847,  5759,  4777, -1682,  4222,    40,  2072,  4596,
    2619,  5638,  5920,  1359,  2271,   948,  4020,  1228,  1359,  2916,
    3935,  4421,  2917,  2858,  1532, -1682,  1946,  1229,  1119,  5826,
    5879,  5392,  1667,  1145,  3609,  5293,  5294,  4778,  4508,  5981,
    1780,  2238,  2039,  4509,  3652,  4848,  5840,  4742,  4743,  2094,
    1145,  3627,  5230,  2620,  4913,  3706,  2073,  1532,   894,  2074,
    5880,  1203,  4780,  5538,  1947,  5540,  2739,  1802,   205,  -461,
    5423, -2313, -1682,  1952,  2924,  -175,  1969,  2740,  1952,   888,
    1153, -1682,  5690,  5921,   878,  4510,  5872,  2622,  2561,  1059,
    2095,  5403,   877,  3153,  2754,  2741,  2198,  1948,  5029,  1481,
    2096,  4511,   895,  4690,  -175,  3653,  5588,  1208,  2076,  1781,
     419,   419,   419,  4691,  2621,  3782,  1309,  1310,  1311,   733,
    1312,  1313,  1314,  1315,  1316,  1317,  4914,  3718,  1230,  1949,
    4889,  1950,  2502,  6061,  1845,   945,   945,   945,  5364,  1846,
    5365,  5366,  2018,   980,  5367,   981,  4848,  2623,  3783,  1952,
    2858,  3958,  2078,  1952,  2085,  1481,  1532,  2562,  4426,  5383,
     419,  1187,  2622,  4890,  5599,  6071,  1180,  5030,   419,  1673,
    3132,  2214,  4093,  1532,  2079,  5867, -3077, -3077, -3077,  4782,
     419,  1951,  1806,  2859,  1845,  3556,   421,  -461,  2056,  1958,
    1193,  1532,  2086,  2510,  2081,  1231,  4853,  5639,  4512,   212,
    5640,  3440,  5286,  5914,  3804,  4427,  1847,  4002,  5600,  5963,
     733,  2057,  2860,  3628,  4042,  4043,  6124,   884,   733, -1682,
    1221,  5585,  2623,  2848,  3036,   896,  2585,  1144,  3801,  2056,
     733,  4855,  3560,  5601,  2123,   220,  1364,  2861, -2292,  4198,
    1365, -1113,  5800,  4891,  5586,   952,  2742,  1532,  5833,  3256,
    5602,  1807,  2057,  1848,  5603,  4272,  1847,  2849,  2097,  1056,
     945,  2355,  4019,   945,  1660,  2949,  1532,  -385,  1144,  1232,
    3244,  5287,  2856,   945,  2056,  5604,  5804,   231,  5605,  1532,
    4196,  1364,  2066,  4900,  1832,  1365,  1202,  1929,  4289,  3911,
    3903,  1532,  2098,  5606,  3912,  -385,  2099,  2057,  1456,  4549,
    4322,  2087,  6041,  1848,   945,   945,   377,   733,   733,  4559,
    2859,  5562,  1151,  4856,  1456, -1512,  6072,   189,  2858,   945,
    2067,   733,   945,  4257,  1144,  1930,  4350,   247,  1217,  2100,
    5247,  1532,  1532,  1457,   733,   733,  4220,  2124,  2896,  2860,
    5394,  1144,  5795,  2899,  6190,  2858,  3055,  5796,    76,  1457,
    3970,    76,  3255,  6055,  5593,  1798,  4644,  1224,  1931,  6028,
     733,  4892, -1722,  4899,  2861,  1412,  1415, -1722,  1458,  1413,
    1414,   377,  4884,  5903,  4857,  1593,  4325,  2565,  4858,  2056,
    3282,  5607, -2868,  5792,  4542,  5794,  4418,  5395,  4053,  5798,
    5799,  4056,  5025,  4875,  4057,  5077,  4645,  5797,  1940,  2856,
     945,   877,  2057,   945,   945,  4157,  2069,  4991,  4500,  2983,
     212,  5552,  1481,  3912,  2970,  3197,  1459,  3198,  2976,  -385,
    -385,  3200,  2984,  3201,  6173,  2070,  3203,  6174,  4992,     8,
    3204,  5608,  1459,  2980, -1722,  2858,  1941,  6120,  5834,  4099,
     419,   945,   945,  4049,  1259,  2981,   220,   945,   945,  4916,
    2985,  4381,  3784,  3307,   945,   945,   945,  4657,  4345,   945,
    3616,   945,  2915,   945,   945,   945,   945,   945,   945,  1942,
     945,  6109,   945,   945,  4834,  2071,   945,   884,  2859,  2831,
    1265, -1722,  1320,  2982,  5105,  3785,  4901,  2091,   231,  2839,
    1532,   945,   945,   945,   945,   421,  4009,  5595,  5373,   945,
    4545,   234,  2152,   945,  6158,  2859,   945,  2860,  2152,   945,
     945,   945,   945,   945,   945,   945,   945,   945,  2848,   945,
    4613,  4614,  5267,  1832,   246,  2092, -1670,   945,  5835,  4488,
     945,  5374,  2861,  3358,  2860,  5306,   212,  4092,  6073,  4518,
    2242,   420,  5311,  3550,  5409,  3553,  1934,  2056,  4776,  4120,
    3691,  2858,  2849,  1276,  4230,  4386,  1481,  6155,  2093,  2861,
    5836,  1278,  2072,  2243,  4145,  2858,  4146,  2856,  5410,  5645,
    2057,  1364,   220,  1288,  3057,  1365,  3487,  3547,  5585,  1286,
    1935,  4143,    35,   421,  1936,   733,    37,  5096, -1513,  2347,
    4147,   945,  4281,  4387,  2856,  2859,  1249,  2916,  3094,  1301,
    2917,  5586,  2858,   420,  3443,   420,   945,  1302,  4299,  2297,
    2073,  5860,  2348,  2074,   231,   945,   945,  1937,  2355,   877,
    1345,  4777,  3543,  1354,  2860,  4172,  4388,   234,  2924,  5089,
    2298,  1355, -3077, -3077, -3077,  3613,  4103,  4104,  4105,  4106,
    4107,  4108,  1363,    75,  2299,   421,  3945,   421,  3447,  2861,
     246,  4974,  4835,  6106,  4778,  1417,    74,   878,  4836,    35,
    5585,  2297,  2076,    37,   247,  4837,  4416,   733,  5749,  4779,
    1419,  3448,  4194,  1422,  4975,  4194,  5754,  4850,  4851,  4780,
    4425,  2113,  2298,  5586,  2856,  3880,    76,    76,  2858,  4496,
     733,  3371,  3372,  3373,  3374,  1425,  2301,  1532,  4148,  6022,
    4838,  1532,  1532,  1451,  4149,  4781,  2078,  2046,   733,  4150,
    3148,  2859,  2063,   421,   733,  -587,  4270,  4460,   733,  2114,
    2059,  1460,  4839,  2115,   732,  2859,   733,  1438,  2079,  1673,
    1636,  1636,  4093,  1430,  1636,  1431,  4094,  4095,  4096,  2130,
    2860,  1433,  2134,  1434,   733,  3719,   877,   945,  2081,   419,
     877,  2161,  2116,  4730,  2860,  1461,    35,   428,  1462,   945,
      37,  2858,  2859,  1532,  1470,  2861,   945,  6172,    40,   945,
     945,  2363,  2550,   877,  3752,  2364,  2551,  1532,  4194,  2861,
    4618,  4619,  4620,  4621,  4622,  3717,   884,  1473,   998,   733,
    5127,  2860,  4831,  2285,  1016,  1938,  4782,  2285,  3720,  2725,
    2856,  4535,  1145,  4876,  2371,  3425,  2372,  2363,  5258,   733,
     733,  3186,  1585,   428,  2856,  5686,  2861,   428,  1532,  4063,
    1533,  2006,  1109,  2603,  2632,  2501,  4064,  2007,  2502,  1484,
    4065,  3153,  6205,  4119,   877,  4121,  4122,   419,  4900,  1885,
     421,   733,  1488,  1481,   421,  1481,  4663,  1542,  2859,  4151,
    3881,  2856,  3371,  3372,  3373,  3374,  3721,  2508,  1914,  2439,
    4152,  2440,   877,  1543, -3077,   733,  2454,   421,   247,  2009,
    2596,   733,  2597,  2602,   212,  2603,  4917,  2860,   733,  4620,
    4621,  4622,  3679,  1145,  4648,   733,  3727,  1549,   733,  2510,
    3125,  2607,  3126,  2597,   733,  4519,  1636,  4521,  1560,   419,
    1885,   419,  2861,  1567,  2285,  3703,  2725,  2146,  1057,  3188,
     220,  2603,    40,  3210,   733,  3211,  1588,   878,  5302,  1627,
     733,  2859,  3212,  2010,  3211,   733,  1481,  1631,   421,  3425,
    2011,  4098,  1635,  2012,   877,  2292,  2293,  2856,   733,  4278,
    4279,  2654,  2655,  3247,  2501,  3248,  3899,  2502,  2992,  2993,
    2860,   733,   231,  3446,  5423,  2355,   421,  1642,  4230,  2013,
    3722,  1673,   733,  3727,  4093,   234,  3758,   419,  4094,  4095,
    4096,  3495,  3625,  2603,  3626,  2861,  2508,  4173,  4590,  4174,
     945,   945,   945, -3077,  1648,  4731,   945,  3697,   246,  3698,
    3857,  1649,  3858,  2014,  3703,  3971,  4011,  2603,  3211,  4099,
   -3077,  1650,   247,  3882,   884, -3077,  1653,  4062,  2510,  2603,
    2856,   123,   124,  4071,  3368,  2603,  3369,  1657,   945,  1532,
    1658,  4893,  4618,  4619,  4620,  4621,  4622,  4077,   421,  2603,
    4623,  1267,  1268,  1659,  4078,  3727,  2603,  4194,  1660,  4079,
    3370,  2603, -3077,  3472,  3473,  3727,  4871,  4112,  1661,  2603,
    1269,  1662,  3883,  1270, -1746, -1746,  2108,  2069,  5470,  4641,
    2016,  1663,   945,  4792,  1670,  4125,  3862,  2603,  1668,  1200,
    2017,  4130,  4175,  4131,  4176,  4142,  2070,  1804,  4367,  2018,
    4368,  3723,  3727,  4372,  1801,  4373,  4397,  1808,  4398,  3724,
    1810,  2019,  3725,  1144,   419,  2517,  1815,  4402,   419,  1809,
    4456,  3941,  4398,  4570,  1532,  4571,  4581,  1824,  4582,   733,
    2654,  3496,  1249,  1200,  4584,  4411,  4585,  1829,  4609, -3077,
    4610,   419,   945,  4611, -3077,  2603,  2071,  1832,  4711,  2136,
    4712,   884,  2021,  2022,  4722,   884,  4723,  4733,  1830,  2603,
    1271,  3371,  3372,  3373,  3374,  4997, -1749, -1749,  3375,  3376,
    4815,  4820,  4816,  4821,  3377, -1750, -1750,  5012,   884,  3378,
    1833, -3077,  2137,  4098,  4830,   733,  3533,  4854,  5078,  3211,
    3211,  5018,  1272,  5019,  1144,  1843,    74,    74,  5147,    74,
    2428,  5168,   419,  2603,  5197, -3077,  3248,  5209,  1858,  2603,
    4895,  4940,  4100,  4101,  4102,  1885,  4103,  4104,  4105,  4106,
    4107,  4108,  5269,  5275,  3533,  5276,  4178,  4179,  4180,  1842,
     419,  1844,  1273,  2072,  2517,  5282,  5283,  3211,  3211,   884,
     733,  5425,  5459,  5426,  4610,  5475,   878,  5476,  6003,  6004,
    2024,  4099,  1862,  1200,   877,  5477,  1532,  2603,   733,  5484,
     877,  3248,  5557,  5646,  5558,  3211,   733,   884,  1859,  5687,
     945,  5688,  5192,  1532,  1863,  5705,   945,  3248,  5712,   945,
    5713,  2073,   945,  5722,  2074,  2355,  4194,   189,  1532,  1865,
    4194,  4528,  5728,  4531,  4556,  5730,  1869,  4556,   945,  2924,
    6091,  6092,   419,   945,  5002, -3077,  5741,  5785,  5742,  5786,
    1873,  1874,  2524,  2525,  2526,  2527,  2528,  2529,  5825,  3379,
    2564,  5859,  1870,  5742, -3077,  4681,  1875,   945,   945,   945,
    3380,  1876,   945,  2076,  5873,  5874,  3248,  4131,  1877,   884,
     945,   945,   945,   945,  5875,  1878,  2603,   998,   421,  5886,
    5892,  5887,  2355,   945,   421,  5895,   945,  4556,   945,  4710,
    5913,  5919,  3211,  3248,  5925,  5926,  3248,  3248,  1886,   945,
     945,  1879,  5929,   945,  2603,  1887,  5930,  2078,  2603,  5703,
     212,  5931,  5959,  5932,  5960,  6010,  4126,  6011,  6014,  6015,
    2355,  2603,  4133,   945,  6016,   945,  2603,   945,  6018,  2079,
    2603,  6037,  6063,  6038,  6064,  1889,  6093,  4754,  4556,  6105,
    6132,  5735,  5742,  6170,  1917,  6171,   220,   945,  1918,  2081,
    1885,  6183,  1919,  2603, -3077,  1885,  1885,  6185,   945,  6186,
    1938,  2524,  2525,  2526,  2527,  2528,  2529,  6203,  6211,  6011,
    6186,  1885,   733,  1932,  4100,  4101,  4102,  1973,  4103,  4104,
    4105,  4106,  4107,  4108,  5144,  4656,  1999,  5229,   231,  5232,
     945, -3074,  5399,  2002,   878,  2004,  2005,  2036,  2040,  2041,
    2042,   234,  3323,  2053,  2055,   945,  2065,  2068,  2090,  2104,
    3341,  2162,  2105,  2121,  2131,  2132,  2140,  2135,  2141,   945,
    2142,  2163,  2165,  4230,   246,  2166,  2168,  2171,  2175,  2673,
    2674,  2176,  2184,  2185,  2188,  2191,  3425,  2194,   247, -1438,
    5089,  2196, -1438,  2202,  2205,  2198,  2207,  2216,  4230,  2217,
    2221,  2224,  2222,  -195,  2692,  2694,  2225,  2227,  2229,  2230,
    2245,  1532,  2252,  2259,  1532,   913,  1532,  2264,  2272,  2277,
    2278,  1532,  2279,  2285,  2281,  2291,  2288,  2305,  2315,  2316,
    2289,  2307,  2319,  2327,  2331,  2320,   733,   733,  2333,  2334,
    2336,  2338,   945,  2343,  2344,  2346,  2351,  2354,  2357,  2358,
    2369,  2403,  2436,  2443,  2452,  2445,   877,   877,   877,  4192,
    2453, -1899,  2446,   733,  5751,  2459,   733, -1906,  2460,  2501,
    1532,   878,  2502,  2461,  2462,   878,  1885,  2463,   247,  2465,
    2466,  2467,   419, -1897,  2468,  2469,  1885,  2470,   419,  1532,
    2471,  2473,  1409,  2474,  3463,  2475,  2476, -1900,   878,  2477,
   -1898,  2508,  2478,  2479,  5885,  2480,  2536,  2482, -3077,  2483,
    2484,  2485,  2486,  2534,  1532,  2487,  2488,  2489,  2538,   884,
    4192,  2539,  2568,  2564,  2580,   884,  1617,  2595,  2590,  2606,
    2608,  1846,  1848,  2510,   373,  2639,  2641,  2650,  2653,  2660,
    1238,  2668,  2675,  2677,  2687,  2679,  2688,  2690,  2698,  2695,
     421,   421,   421, -3021,  1482,  1016, -3016,  2701,  2702,   878,
    2699,  2725,  2703,  2704,  2720,  2721,  2722,  2723,  2726,  1885,
    2727,  2729,  1885,  1885,   733,  2728,  2730,  5139,  5140,  5141,
    5142,  5143,  4230,  5256,  1532,  5310,  1532,   878,  2731,  2737,
    5371,  2756,  2762,  2768,   733,  2793,  2797,  2799,    75,  2800,
    4156,  2801,  2803,  2804,  2817,  2821,  2822,  2834,  2835,  4194,
    1673,  2850,   733,  4093,  2823,  2846,  4194,  4094,  4095,  4096,
     373,  4194,  2852,  2855,  4194,  2856,  2853,  2854,  2863,  1673,
    2864,  2865,  4093,  2866,  5199,  2867,  4094,  4095,  4096,  2877,
    2883,  2884,  2873,  2868, -3077,  2887,  2894,  2888,  2890, -3077,
    2889,  2891,   877,  4194,  2874,  2897,  5888,  1644,  2904,   878,
    2911,  2900,  2918,  2018,  2901,  2906,  2907,  4194,  2919,  2921,
    2926,  4563,  2927,  2942,  1885,  2932,  2938,  1532,  2933,  2937,
    4580,  2939,  2944,  2945,  2950,  2951, -3077,  2961,  2962,  2963,
    3002,  1665,  2991,  2969,  2974,  3004,  3005,  2998,   877,   733,
    5444,  1783,  3007,  3006,   945,  1795,  1482,  1797,  1199,  3011,
     945,  4606,  3012,  4748,  3013,  3014,  3015,  3021,  1532,  3022,
    3023,  3029,  3024,  3025,  3031,  5253,  3032,  3037,  3040,  1004,
    3030,  3041,  3044,  3049,   962,  3058,  3055,  3069,  3073,  2517,
    3074,  3082,  3093,  3096,  3099,  2087,   421,  1532,  3077,  3100,
    3119,   993,  3109,   733,  4564,   733,  3122,  3121,  3128,  3140,
    3150,  3151,  3158,  3160,  4576,  3142,  3113,  3143,   733,  1004,
     733,  1636,  3161,  3162,  3163,  3116,  3176,  3177,  4536,  3206,
    3245,  3232,  3258,  3224,  3036,  3290,  2925,  2502,  3340,  3346,
    3147,  3148,   421,  4605,  3359,   732,   732,  3133,  3385,  3134,
    1915,  3405,  1320,  3207,   419,   419,   419,  3295,  3365,  3350,
    3383,  3406,  4098,  1200,  3420,  3428,  1532,  3431,  3434,  3436,
    5050,  5051,  3429,  3437,  3438,  1206,  3452,  3465,  5178, -3077,
    3758,  4098,  1200,  4194,  3464,  3466,   733,  1532,  1211,  3467,
    5755,   884,   884,   884,   373,  3488,  5384,  3502,  3481,  3504,
    3505,  2554,  3522,  1532,  3523,  3525,  3551,  3554,  1976,    74,
    3565,  3556,    74,  3558,  3570,  4756,  4757,  4758,  4759,  3559,
    3575,  3576,  3580,  3578,  3582,  3590,  3600,  3601,  3604,  3622,
    4099,  3586,  1798,  3641,  3624,  6149,  3617,  3634,  3654,   733,
    6152,  1802,  1977,  3659,  3660,  3686,  4194,  3687,  3692,  4099,
    5789,  3685,  3696,  3732,  3790,  3704,  3803,  3811,  3748,  3711,
     733,  3731,  5349,  5350,  3815,  5352,  1207,  3830,  1673,  3824,
    3835,  4093,  3812,   877,  3843,  4094,  4095,  4096,  3836, -3077,
    3871,  3859,   733,  3886,  3872,   733,  2524,  2525,  2526,  2527,
    2528,  2529,  5200,  3890,  3892,  3837,  3901,  3888,  3910,  3913,
    3848,  3919,  1978,  3904,  3921,   945,  3923,  3918,  1532,   878,
    3920,  3922,  3926,  3929,   945,   878,  3933,  3931,  3934,  3938,
    3937,  3956,   945,  3957,   945,  3961,  3960,   945,  3189,  3962,
    3963,  1532,   945,   945,   945,   945,  3965,  1979,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,  3975,  3972,
     419,   945,   945,  3967,  3974,  2671,  1532,  3998,  4000,  3977,
    5779,   945,  5781,  3978,  3976,   945,  4001,   421,  4005,   945,
    4007,  3986,  3987,  1980,  4013,  4014,  1673,   945,  4015,  4093,
     945,  4026,   945,  4094,  4095,  4096,  4016,   884,  4017,  2355,
    2352,  4018,  1532,  4194,   945,  3259,   419,   945,   945,  2317,
    4029,  4028,   945,   945,  4030,  4717,  1412,  1415,  4040,   945,
    1413,  1414,   377,  1982,  4045,  4037,  1633,  4047,  4052,   945,
    4051,  4059,   945,  4100,  4101,  4102,  4054,  4103,  4104,  4105,
    4106,  4107,  4108,   884,   945,  5942,  5944,  4076,  2603,  4073,
    5936,  4055,  4100,  4101,  4102,  1984,  4103,  4104,  4105,  4106,
    4107,  4108, -2171,  4144,  4194,  4155,  4127,  4089,  1482,  4074,
    4164,  4169,  4239,  4226,  4241,  4245,  4196,  4243,    75,    75,
    4098,    75,  4075,  5128,  4080,  4081,  3470,  3470,  4252,  4085,
    4259,   945,  4275,  4194,  4280,    69,   205,  1482,  2813,  5643,
    1986,  4139,  1221,  4088,  4154,  4952,  2368,   945,  4232,  1987,
    4111,  4117,  4124,  4138,  4165,  4167,  4960,  1988,  4265,  4168,
    4282,  4283,   877,  1532,  4171,  2814,  4227,   877,  4291,   877,
    4264,  5300,  4263,  4268,  1885,   945,  4287,  1990,  4294,  2501,
    4288,  2363,  2502,  2432,  5408,  4269,  1991,  4296,  4099,  4303,
    1992,  4318,   877,  4319,  1914,  3323,  3323,    74,    74,  5545,
    3323,  4329,  4330,  4331,  4336,  4337,   733,  5711,  4335,  1482,
    4338,  2508,   877,  4353,  4341,  4352,  4355,  4361, -3077,  4362,
    4192,  4363,  4371,  4192,  4376,  4385,  4399,  4401,  4098,  4405,
    6039,  4403,  2428,  4406,  4413,  4407,  4410,  3323,  3323,  4194,
    4417,  4412,  4431,  2510,  1993,  4414,  4415,  4432,  4429,  4433,
    4430,  4434,  5569,  5342,  4436,  4439,   421,  4435,  4437,  4441,
    4438,   421,  1532,   421,  4445,  4443,  4448,  4440,  4452,  4442,
    4444,   419,  4454,  4455,  5444,  4450,  1320,  2959,  4464,  4465,
    4461,   878,   878,   878,  2498,  4484,   421,  1532,  4471,  4537,
    5791,  4475,  4466,  2500,  1094,  4468,  4099,  4476,  4478,  3679,
    4533,  4911,  4486,  4526,  4539,  4541,   421,  2543,   884,  4544,
    4741,  4558,  1673,  4527,  4555,  4093,  1094,  4230,  5570,  4094,
    4095,  4096,   733,  4574,  3703,   733,  4192,  4575,  4578,  1320,
    4579,  4594,  4583,  4603,  4625,  4627,  4556,  4634,  4635,  1482,
    5936,  4636,  2574,  2576,  3758,  4637,  4638,  1482,  1482,  5568,
    4639,  4565,  5401,  4640, -3077,  4568,  4608,  4617,  4642, -3077,
    4615,  4647,  4649,  1482,  4650,  4651,  5949,  4672,  4660,  4661,
    4662,  4664,  4665,  4666,  4667,  4668,  2454,  4114,  4093,  4194,
    4682,  4100,  4101,  4102, -2170,  4103,  4104,  4105,  4106,  4107,
    4108,  4113,   945,  5612,  4724,  4735, -3077,  4737,  4707,  4790,
    4749,  4708,  4709,  4716,  5100,  4736,  4755,  4740,  4766,  4767,
    4794,  1885,  4796,  4775,  4812,   373,  4800,   733,   733,  1885,
    4799,  1532,  1885,  4809,  4803,  4814,  4818,   733,  4798,  4833,
     732,  4826,  4841,  4862,   945,  4870,  4878,  4864,  4865,  5721,
    4877,  4880,  4881,  4883,  4885,  4887,   733,  4888,  4903,  2517,
    5721,  4919,  4906,  4918,  4920,  4194,  4921,  4922,  4934,  4932,
    4933,  4194,  5778,   420,  4935,  4605,  4936,  4937,  4946,  4948,
    5108,  1532,  4949,  1532,   945,   945,  1481,   878,  4962,  4963,
    4968,  4971,  2006,  4987,  4988,  4990,  4894,  4993,  2007,  4100,
    4101,  4102,  5004,  4103,  4104,  4105,  4106,  4107,  4108,  5006,
    5007,  5003,  5010,  5022,  5047,   421,  5061,  5033,  5053,  5067,
     419,  5071,  5073,  3211, -3077,   419,  5068,   419,  5074,  5080,
    5091,  5097,  5098,   878,  5113,  5114,   373,  1199,  5116,  5117,
    2009,  5118,  5783,   733,  5121,  5119,  5137,  5149,  5123, -3077,
     419,  5145,  5151,  5126,  5271,  5157,  5164,   884,  5165,  5170,
    5175,  5181,   884,  5174,   884,  5184,  5185,  5186,   945, -2172,
     419,  5190,  4194,  5225,  5226,  5911,  5233,  5234,  5205,  5239,
     945,  5221,  5240,  5218,  5223,  5238,  5241,   884,  5252,  5254,
    5268,  5255,  4099,  2069,  2010,  4192,  5264,  5270,  5272,  5277,
    5278,  2011,  5707,  5284,  2012,  5288,  5307,   884,  5308,  5309,
     945,  5318,  2070,   945,  5312,  5319,  5320,  5332,  5335,  5341,
    5564,   945,   945,  5339,  1532,  5353,  5344,  5354,   945,   945,
    2013,  5345,  5361,   945,  1532,  5362,  5305,  5363,  2929,   945,
    5368,  2496,   945,   945,  5372,  2936,  5313,   945,  5375, -3077,
    5376,  5381,  5382,   945,  5257,  5259,  2524,  2525,  2526,  2527,
    2528,  2529,  2071,  4894,  2014,   945,  5385,  5391,  5390,  5396,
    2759,  5397,  1211,   945,  5400,  5893,  1481,   945,  5404,  5398,
    5406,  2501,  5908,  5414,  2502,  5417,  5419,  5422,   730,   877,
    5427,  5429,  5433,  5438,  5440,  5436,  5434,  5441,  5454,  5449,
    5442,  5465,  5464,  5460,  5472,  5480,  2368,  5471,  5774,  5775,
     945,  5481,  5505,  2508,  5489,  5524,  5474,  5533,  5482,  5495,
   -3077,  5483,  5529,  5498,    76,  5536,  4895,  2108,  5509,  5539,
    5549,  2016,  5554,  1885,  5553,  5559,  5551,  5560,  5561,  5572,
    5566,  2017,   945,  5573,  5577,  2510,  5582,  5583,  5584,  2072,
    2018,  5613,  5591,  5032,  5622,  5624,  5649,  5625,   878,  1320,
    1532,  5628,  2019,  5630,  5631,  5650,  1096,  5657,  5662,   419,
    5659,  5667,  5670,  5689,  5691,  5692,  3070,  5699,   733,  5693,
    3075,  5710,  5714,   421,  5720,  4100,  4101,  4102,  1096,  4103,
    4104,  4105,  4106,  4107,  4108,  5735,  5760,  2073,  5739,  5724,
    2074,  1532,  5727,  2021,  2022,  5731,  5733,  5750,  5758,  5767,
    5761,  5805,  4744,  5807,  5773,  2924,  5818,  5820,   733,  4896,
    5778,  5813,  5827,  1532,  4192,  5817,  5832,  5839,  4192,  5854,
     733,  5838,  5852,  2023,  5848,  5853,  5877,  5856,  5855,  5863,
    5864,  5865,  5866,  5871,  5900,  5876,   945,  5901,  5884,  2076,
    5897,  5906,  5905,  5894,  5918,  5922, -3077,  5896,  5947,  5898,
     733, -3077,  5941,  5953,  2501,  5948,  5955,  2502,  5958,  5962,
    5988,  2503,  2504,  2505,  5965,  5966,  5986,  5989,  5987,  5994,
    5995,  6023,  6005,  6032,  6040,  6034,  6007,  4750,  2506,  6042,
    6025,  1532,  5951,  2078,  5952,  6050,  2508,  6051, -3077,  6089,
    6049,  2024,  6084,  2509,  6070,  6096,  6103,  6116,  6143,  6108,
    6150,    75,  6113,  6122,    75,  2079,  6175,  6153,  6141,  6142,
     945,  6157,  6176,  6178,  6179,  6180,  1481,  6204,  2510,  6193,
    6201,  6194,  6206,  6207,  1219,  2081,   945,  4897,  6202,  2975,
    4898,  3895,  2003,  1885,  2587,  4223,  3763,  3684,  4347,  6031,
    4909,  2517,  4902,  6035,  3802,  4483,  2102,  5610,  3850,   733,
    5935,  6114,  5049,  5669,  2101,  5380,   945,  5642,  4235,  4235,
    4012,  6027,  4285,  5543,  6110,  5956,  5954,  6048,  6127,  4290,
    3323,  3323,  3323,  3323,  5101,  5079,  3323,  3323,  3323,  3323,
    3323,  3323,  3323,  3323,  3323,  3323,  5916,   878,  5042,  3869,
    3870,  4907,   878,  4365,   878,  2089,  4543,  5066,  5402,  5648,
    3860,  4551,  1532,  4714,  1532,  5653,  3306,  6115,  6208,  6198,
    5626,  4489,  5107,  6053,  6081,  6082,  5571,   878,  3048,  5769,
    5924,  5574,  1114,  2425,  5745,  5146,  6169,   419,  3118,  2511,
    3528, -3077,  2856,  5110,  2512,  3323,  3323,   878,  4276,   733,
    3129,  3115,  5861,  1483,  3252,  3164,  1561,  3253,  4451,  3254,
    4938,  3800,  4547,  4961,  6075,  6192,  2513,  2514,   945,   373,
    1812,  5124,  1532,  2736,   884,  5125,  1834,  3451,  3196,  3442,
    5532,  2515,  5260,  6021,  4822,  2370,  3480,  4008,  4240,  4797,
    2549,  4228,  3461,  6017,  2604,  5899,  5244,   945,   945,  3479,
    2635,   945,  5231,  4770,  5216,  5726,  4764,  5883,  5882,  4823,
    4765,  6195,  6095,  6008,  6151,  5706,   945,  4718,  2636,  5526,
    2516,  2640,  6019,   945,  3433,  6020,  3410,  4162,   945,  2645,
    4068,   945,   945,  3826,  2517,  4160,  1252,  2518,   945,   945,
    3419, -3077,  4604,  3959,  2266,  3506,  2455,  5996,  2524,  2525,
    2526,  2527,  2528,  2529,  3124,  2659,  1222,  2652,  2433,  1926,
     945,  3497,   945,  1897,  1584,  1898,  2464,  3513,   733,  4218,
     733,  3510,   877,  1200,   945,  4828,  3511,  5663,  5245,  4829,
    4801,  2656,  1245,  4010,  3517,  3208,    78,  5531,     0,     0,
       0,     0,  2553,  5684,     0,     0,     0,  2481,  1622,  5530,
      69,     0,     0,     0,     0,  2360,  2501,     0,     0,  2502,
       0,     0,  2494, -3077, -3077, -3077,  1532,   733,     0,     0,
       0,  1094,     0,  1094,  2519,  1094,     0,   945,     0,     0,
     732,  1094,  1615,  1616,     0,  1004,  6209,  6210,  2508,  6156,
    5647,     0,     0,     0,     0,  2509,  1915,     0,     0,    75,
      75,     0,     0,     0,     0,  1094,  1094,     0,     0,     0,
    5664,     0,     0,     0,     0,  2304,   421,  4192,     0,     0,
    2510,   945,     0,     0,  4192,     0,     0,     0,  5682,  4192,
       0,     0,  4192,     0,     0,     0,     0,     0,  2318,  1482,
       0,     0,     0,     0,     0,     0,     0,     0,  2329,     0,
       0,     0,  2332,     0,  5598,     0,  2335,     0,  2337,     0,
       0,  4192,  1211,  1211,  2345,  1211,     0,     0,     0,     0,
    2353,     0,     0,  2356,  2520,  4192,     0,  2521,  2522,  2523,
       0,  2524,  2525,  2526,  2527,  2528,  2529,     0,     0,     0,
     945,  4082,  1532,  4083,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1797,
       0,     0,   877,     0,     0,     0,     0,     0,  1885,   945,
    1532,     0,   945,     0,   945,     0,     0,     0,     0,     0,
       0,  2511,     0,  1094,     0,     0,  2512,     0,     0,     0,
    3323,     0,     0,   945,     0,     0,     0,     0,     0,   945,
       0,     0,  1907,   945,     0,     0,     0,     0,     0,  1532,
       0,     0,     0,   945,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2515,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1797,     0,     0,     0,
       0,     0,     0,     0,  1094,     0,     0,     0,     0,     0,
       0,     0,     0,  1797,     0,     0,   421,     0,     0,     0,
       0,     0,     0,     0,     0,  1532,     0,     0,     0,     0,
    1532,  1532,     0,     0,     0,   945,  2517,     0,     0,     0,
     945,   945,   733,     0,     0,     0,     0,  2501,     0,     0,
    2502,  4192,     0,     0,     0,     0,   733,     0,     0,     0,
       0,     0,  5841,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   878,     0,     0,  3798,   945,  2508,
     419,     0,     0,     0,     0,   945, -3077,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     945,  2510,     0,  3829,  4192,     0,  3829,   884,  3829,     0,
       0,     0,  3829,  1885,  3829,  3829,  2519,     0,     0,     0,
       0,     0,     0,  3829,  3829,  3829,     0,     0,     0,  5902,
       0,     0,     0,     0,     0,     0,  1532,  1532,     0,     0,
     877,     0,     0,     0,     0,     0,     0,  5870,     0,     0,
       0,  5183,     0,     0,     0,     0,     0,     0,   945,     0,
       0,   945,     0,     0,   945,     0,     0,     0,  4745,     0,
       0,     0,     0,     0,     0,   945,     0,     0,  3905,   945,
       0,   945,     0,   945,     0,     0,     0,     0,     0,     0,
     945,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5220,     0,     0,     0,     0,     0,   945,
    3936,     0, -3077,     0,     0,     0,  2520, -3077,     0, -3077,
   -3077, -3077,  1482,  2524,  2525,  2526,  2527,  2528,  2529,     0,
       0,     0,     0,  1096,   421,  1096,   733,  1096,     0,     0,
       0,     0,   877,  1096,     0,     0,     0,     0,     0,  3984,
       0,  4192,     0,   937, -3077,     0,     0,     0,     0,     0,
     419,     0,     0,     0,     0,     0,     0,  1096,  1096,     0,
      69,    69,  5598,    69,     0,     0,     0,     0,  1482,     0,
       0,  6140,     0,     0,     0,     0,   945,     0,     0,  1094,
       0,     0,     0,     0,     0,     0,   945,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2517,     0,     0,
       0,     0,  4192,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   945,   945,   945,     0,
       0,     0,     0,     0,     0,   945,   421,     0,     0,  1532,
       0,  4192,     0,     0,     0,   945,     0,     0,     0,     0,
       0,     0,     0,     0,   733,     0,  6054,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   945,     0,     0,
       0,     0,     0,     0,  6009,     0,     0,     0,     0,     0,
     733,     0,  6077,  6080,     0,     0,  6078,  6079,   377,     0,
       0,     0,   373,     0,     0,  1096,     0, -3077,     0,     0,
       0,     0,     0,     0,     0,  2501,     0,     0,  2502,   730,
     730,     0,     0,     0,  1912,     0,     0,     0,     0,     0,
     945,     0,     0,     0,     0,     0,   945,     0,     0,     0,
       0,     0,     0,  1885,     0,     0,   945,  2508,     0,     0,
       0,     0,   945,   945, -3077,   945,     0,  4192,     0,     0,
       0,     0,     0,     0,     0,   945,  1096,   373,  1885,     0,
       0,  6102,  6077,  6080,     0,     0,  6078,  6079,   377,  2510,
       0,     0,     0,     0,     0,     0,   877,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   733,     0,   419,     0,
       0,     0,     0,     0,  1094,     0,     0, -3077,     0,  1094,
    1094,     0,     0,     0,  2524,  2525,  2526,  2527,  2528,  2529,
       0,     0,   945,     0,     0,  1094,     0,     0,   945,     0,
       0,     0,     0,     0,     0,   884,     0,     0,     0,     0,
       0,     0,     0,  3366,     0,  1482,  5203,     0,     0,     0,
     877,     0,     0,     0,     0,   945,     0,   878,  6102,     0,
     945,  2673,  2674,     0,     0,     0,   945,     0,   877,     0,
       0,   945,     0,  6077,  6080,     0,     0,  6078,  6079,   377,
     421,  2669,     0,  1615,  1616,     0,     0,     0,     0,     0,
   -3077,     0,     0,     0,     0, -3077,     0,  4192,     0,     0,
     419,   945,  2684,     0,     0,     0,     0,     0,  2691,  2693,
       0,   945,     0,     0,     0,     0,  3323,     0,  6162,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   945,
       0,     0, -3077,  3159,     0,     0,     0,   884,     0,     0,
       0,  3166,   945,     0,   421,     0,     0,     0,     0,     0,
       0,     0,  1885,     0,     0,     0,     0,     0,     0,     0,
       0,  3178,   421,     0,   945,   945,     0,     0,     0,     0,
       0,     0,     0,  4192,     0,     0,     0,   373,     0,  4192,
    1094,     0,  6162,     0,     0,  2517,     0,     0,     0,  1482,
    1094,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6162,     0,     0,     0,     0,     0,     0,     0,   381,     0,
       0,  1885,     0,     0,   381,    35,     0,     0,   727,    37,
       0,     0,     0,     0,     0,     0,  2501,     0,     0,  2502,
       0,     0,     0,  2503,  2504,  2505,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   381,     0,   878,     0,     0,
    2506,     0,     0,  2507,     0,     0,     0,     0,  2508,     0,
       0,  1096,     0,     0,     0,  2509,     0,     0,     0,     0,
       0,     0,     0,  1094,     0, -3077,  1094,  1094,     0,  4370,
    4192,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2510,   381,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2501,     0,     0,  2502,     0,
       0,     0,  2503,  2504,  2505,     0,     0,     0,  2501,     0,
       0,  2502,     0,  4409,   419,  2503,  2504,  2505,     0,  2506,
       0,     0,     0,     0,     0,     0,     0,  2508,     0,     0,
       0,     0,  2506,     0,  2509,     0,     0,     0,     0,     0,
    2508,     0,     0,   381,     0,     0,     0,  2509,  5249,     0,
       0,   884,     0,     0,     0, -3077,     0,     0,  1094,  2510,
       0,     0,  2524,  2525,  2526,  2527,  2528,  2529,     0,     0,
       0,     0,  2510,     0,     0,    74,     0,     0,   419,     0,
    2501,  2511,  4449,  2502,     0,  3439,  2512,  2503,  2504,  2505,
       0,     0,     0,     0,     0,     0,   419,  3323,     0,   723,
       0,     0,     0,     0,  2506,     0,     0,     0,  2513,  2514,
       0,     0,  2508,     0,     0,   884,     0,     0,     0,  2509,
       0,  3323,     0,  2515,     0,     0,  3829,     0,     0,     0,
       0,     0,     0,   884,     0,     0,     0,     0,     0,     0,
    4482,  4482,  1885,     0,  2510,     0,  1096,  3123,     0,     0,
    4499,  1096,  1096,     0,     0,   878,  1482,     0,  1482,     0,
       0,     0,  2516,     0,     0,     0,     0,  1096,     0,     0,
    2511,     0,  3136,     0,     0,  2512,  2517,     0,     0,  2518,
       0,     0,  3144,  2511,  3145,     0,     0,     0,  2512,     0,
    3149,     0,     0,     0,  3152,     0,     0,  2513,  2514,  3262,
       0,     0,     0,     0,  4554,     0,   381,  1281,     0,     0,
    2513,  2514,  2515,     0,     0,     0,  1293,     0,     0,     0,
       0,     0,     0,     0,  1293,  2515,     0,  1293,     0,     0,
       0,     0,     0,     0,   730,     0,     0,     0,  4589,  1482,
       0,   381,     0,    69,     0,     0,    69,     0,  3263,     0,
       0,  2516,     0,     0,     0,  2511,     0,   878,     0,     0,
    2512,     0,     0,     0,  2516,  2517,  2519,     0,  2518,     0,
       0,     0,  3984,     0,     0,     0,     0,     0,  2517,     0,
    3264,  2518,  2513,  2514,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2515,     0,     0,
       0,     0,     0,  3265,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3266,     0,     0,     0,     0,     0,
       0,     0,  1096,     0,     0,     0,     0,     0,  1281,     0,
       0,     0,  1096,     0,     0,  3267,  2516,  1293,     0,     0,
    3268,     0,  3323,     0,  1293,  3296,  3297,  1293,     0,     0,
    2517,     0,  3311,  3312,     0,  2519,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2520,     0,  2519,  2521,
    2522,  2523,     0,  2524,  2525,  2526,  2527,  2528,  2529,     0,
       0,     0,  3351,     0,     0,     0,     0,     0,     0,     0,
       0,  3269,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3270,     0,     0,  1096,     0,     0,  1096,  1096,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4728,
       0,     0,     0,     0,     0,     0,     0,     0,  2684,     0,
    2519,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2520,     0,     0,  2521,  2522,
    2523,     0,  2524,  2525,  2526,  2527,  2528,  2529,  2520,     0,
       0,  2521,  2522,  2523,  4084,  2524,  2525,  2526,  2527,  2528,
    2529,     0,     0,     0,     0,   913,  3271,  4134,     0,  3272,
       0,   878,     0,     0,     0,  5528,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3469,  3469,     0,  3323,     0,  3273,     0,     0,  3274,     0,
    1096,     0,     0,     0,  3275,     0,     0,     0,     0,     0,
       0,  3276,  2494,     0,     0,     0,     0,     0,     0,     0,
    2520,     0,     0,  2521,  2522,  2523,     0,  2524,  2525,  2526,
    2527,  2528,  2529,     0,  2770,   878,     0,     0,  1094,  2771,
    3277,     0,     0,     0,     0,     0,  3278,  1885,     0,  3279,
       0,     0,     0,   878,     0,     0,  2494,     0,  1907,     0,
       0,    69,    69,     0,     0,     0,     0,     0,  3280,     0,
       0,     0,     0,     0,  2772,     0,     0,     0,     0,  3366,
       0,     0,     0,     0,     0,     0,     0,  2773,     0,     0,
       0,     0,     0,     0,  3281,  4166,     0,     0,     0,     0,
    3964,  1094,  2774,     0,     0,     0,     0,     0,  3973,     0,
       0,  4185,     0,  6094,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3988,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3994,     0,     0,  3995,     0,
    3996,  3997,     0,  2775,  3999,  4499,     0,     0,     0,     0,
    4003,     0,  4004,     0,  2776,  4006,     0,     0,     0,     0,
       0,     0,  1281,     0,     0,     0,     0,     0,     0,     0,
    4945,     0,  4185,  1293,     0,  2777,  1199,     0,  4953,  1293,
    2778,  4954,  1293,  4955,   381,     0,     0,     0,   381,     0,
       0,     0,     0,     0,     0,     0,  3637,     0,     0,     0,
       0,  1294,   727,  3323,     0,     0,     0,     0,  3323,  1294,
       0,   727,  1294,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   727,  4996,     0,     0,     0,
       0,  4048,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3829,     0,     0,     0,  3829,  3829,     0,  3829,
       0,     0,  2779,  2255,  2256,  2257,     0,     0,     0,     0,
       0,     0,     0,   727,     0,     0,     0,     0,     0,   727,
       0,     0,     0,     0,     0,  1094,     0,     0,     0,     0,
       0,     0,   727,  1094,     0,     0,  1094,     0,     0,     0,
       0,     0,  2780,     0,     0,     0,     0,     0,  1094,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   727,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1294,   727,     0,   913,  2781,  1885,     0,  1294,
       0,   727,  1294,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2501,     0,   727,  2502,     0,     0,  5104,
    2503,  2504,  2505,     0,  4499,     0,     0,     0,  2782,     0,
       0,   727,     0,     0,  2783,     0,     0,  2506,     0,     0,
       0,  2784,     0,     0,  2785,  2508,     0,     0,     0,     0,
       0,     0,  2509,     0,     0,     0,     0,     0,     0,  3984,
    3984,  3984,  3984,  3984,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1297,     0,     0,  2786,  2510,     0,     0,
       0,     0,  1329,  2787,     0,     0,     0,     0,     0,     0,
       0,  2788,     0,     0,     0,     0,  1351,     0,  2789,     0,
       0,  5154,  5154,  5154,     0,  5154,  5154,  5154,  5154,  5154,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2790,     0,     0,     0,     0,     0,
     727,     0,     0,     0,   723,     0,     0,     0,     0,     0,
     723,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   381,     0,   723,     0,     0,   727,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   727,     0,
    1096,     0,     0,     0,   730,     0,     0,     0,     0,     0,
    3979,  3982,     0,     0,     0,     0,     0,     0,  2511,     0,
    1912,     0,     0,  2512,     0,     0,     0,     0,     0,  2501,
    3947,     0,  2502,     0,     0,  4295,  2503,  2504,  2505,     0,
       0,     0,     0,     0,     0,  2513,  2514,     0,     0,   727,
     727,  1976,     0,  2506,     0,     0,     0,     0,     0,     0,
    2515,  2508,     0,  1096,     0,     0,     0,  5243,  2509,  2501,
    5250,  5251,  2502,     0,     0,     0,  2503,  2504,  2505,     0,
       0,     0,     0,     0,     0,  1977,     0,  1094,     0,     0,
       0,     0,     0,  2510,     0,     0,     0,    75,     0,  2516,
       0,  2508,     0,     0,     0,     0,     0,     0,  2509,     0,
       0,     0,     0,  2517,     0,   373,  2518,     0,  4354,     0,
    4356,     0,     0,     0,     0,   373,     0,     0,     0,     0,
       0,     0,     0,  2510,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1978,     0,     0,     0,     0,
       0,     0,     0,     0,   373,     0,     0,     0,     0,     0,
     381,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1294,     0,
    1979,     0,     0,     0,  1294,     0,     0,  1294,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2519,  2511,     0,     0,     0,     0,  2512,
       0,  3948,     0,     0,     0,     0,  1980,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2513,  2514,     0,     0,     0,     0,  1096,     0,     0,
       0,     0,     0,     0,  2511,  1096,  2515,     0,  1096,  2512,
     723,   723,     0,     0,     0,     0,  1982,     0,     0,  4446,
    1096,     0,  5356,  5357,     0,  4453,     0,     0,     0,     0,
       0,  2513,  2514,     0,     0,  3829,     0,  3829,  3829,     0,
       0,  3829,     0,     0,     0,  2516,  2515,     0,  1984,     0,
       0,     0,  2684,     0,     0,  4221,     0,  1094,     0,  2517,
       0,     0,  2518,  2520,     0,     0,  2521,  2522,  2523,     0,
    2524,  2525,  2526,  2527,  2528,  2529,     0,     0,     0,     0,
    3349,     0,  4234,  4234,     0,  2516,     0,  3947,     0,   205,
       0,     0,     0,  3949,     0,     0,     0,     0,     0,  2517,
       0,     0,  1987,     0,   727,  5416,     0,     0,  1976,     0,
    1988,  6163,     0,     0,  1976,     0,  2494,     0,  2814,     0,
       0,     0,   727,     0,     0,     0,     0,     0,     0,     0,
    1990,     0,  4763,     0,     0,  4768,     0,     0,     0,  1991,
       0,     0,  1977,  1992,  5443,     0,     0,     0,  1977,  2519,
       0,   727,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3950,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6163,     0,     0,   373,     0,
       0,     0,     0,     0,     0,     0,     0,   727,  5154,  2519,
       0,     0,     0,  6163,     0,     0,     0,  1993,     0,     0,
       0,  3951,  1978,   727,     0,     0,     0,     0,  1978,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   727,
    4624,     0,  4626,   727,  4628,     0,     0,     0,     0,     0,
       0,     0,     0,  4632,     0,     0,     0,  1979,     0,     0,
       0,     0,     0,  1979,     0,     0,     0,     0,     0,  2520,
       0,     0,  2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,
    2528,  2529,     0,     0,     0,     0,  4485,     0,  3948,     0,
       0,     0,     0,  1980,     0,     0,     0,  4658,     0,  1980,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2520,
       0,     0,  2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,
    2528,  2529,     0,     0,     0,     0,     0,     0,     0,  1096,
       0,     0,     0,  1982,     0,  1981,     0,     0,     0,  1982,
       0,     0,  1281,     0,     0,  1281,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1984,     0,     0,     0,  4499,
    1983,  1984,     0,   727,     0,     0,     0,     0,     0,     0,
       0,   727,   727,     0,     0,     0,  1293,  1293,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   727,     0,     0,
       0,  1293,     0,     0,  1293,     0,   205,     0,  1985,     0,
    1986,     0,   205,     0,  3829,     0,  1986,     0,     0,  1987,
       0,     0,     0,  5611,     0,  1987,     0,  1988,     0,     0,
       0,     0,     0,  1988,     0,  2814,     0,     0,     0,     0,
       0,  1989,     0,   381,   381,   381,     0,  1990,     0,     0,
       0,     0,     0,  1990,     0,     0,  1991,     0,     0,     0,
    1992,     0,  1991,   380,   727,     0,  1992,  2501,     0,   380,
    2502,     0,     0,   726,  2503,  2504,  2505,     0,     0,  3950,
       0,     0,  1293,     0,     0,  1293,  1293,     0,     0,     0,
       0,  2506,     0,   381,     0,     0,     0,     0,     0,  2508,
     380,   381,  1094,     0,     0,     0,  2509,     0,     0,     0,
       0,     0,     0,   381,  1993,     0,     0,  4185,  3951,     0,
    1993,     4,     0,     0,     0,     0,  4532,     0,     0,     0,
       0,  2510,     0,     0,     0,     0,     0,     0,     0,  1096,
       5,     0,     0,     0,     0,   373,   380,     0,     0,     0,
       6,     7,     0,     0,     0,     8,     0,     9,    10,     0,
    1515,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,  1515,    36,     0,    37,
       0,    38,    39,     0,     0,  1140,     0,    40,     0,     0,
       0,     0,     0,  1140,     0,  1140,   373,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4612,   380,     0,
       0,     0,     0,  2501,  3982,     0,  2502,     0,     0,     0,
    2503,  2504,  2505,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2511,     0,     0,     0,     0,  2512,     0,  1482,
       0,    41,     0,  5793,     0,  2508,     0,     0,     0,     0,
       0,     0,  2509,     0,     0,   723,     0,     0,     0,  2513,
    2514,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2515,     0,     0,  2510,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1094,     0,     0,
       0,     0,     0,     0,     0,     0,   727,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2516,     0,     0,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2517,     0,     0,
    2518,     0,     0,     0,     0,    43,  4185,     0,     0,     0,
    4185,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    44,     0,
       0,     0,     0,   381,     0,     0,     0,     0,     0,     0,
       0,   380,     0,     0,     0,   373,   373,     0,     0,     0,
       0,     0,    45,     0,     0,     0,     0,   727,  2511,     0,
       0,     0,     0,  2512,     0,   727,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   380,   727,     0,     0,
       0,     0,     0,     0,     0, -3077, -3077,  2519,     0,    46,
       0,     0,    47,     0,     0,     0,     0,     0,     0,  1482,
    2515,  1281,     0,  5939,     0,  5940,     0,     0,  1293,  5945,
    5946,  1293,  1293,     0,    48,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2006,     0,     0,
       0,     0,     0,  2007,     0,     0,     0,     0,     0, -3077,
    5136,     0,     0,     0,  5138,     0,  2106,     0,     0,     0,
       0,  1294,  1294,  2517,   727,   727,     0,     0,     0,     0,
       0,     0,     0,     0,  4825,     0,  1294,  2973,   727,  1294,
       0,     0,     0,     0,     0,  2009,  2170,     0,     0,     0,
       0,   727,   727,     0,     0,     0,     0,  2520,     0,     0,
    2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,  2528,  2529,
       0,  2187,    49,     0,  4674,     0,     0,   727,     0,     0,
       0,     0,     0,     0,     0,     0,  2195,     0,     0,     0,
       0,     0,     0,     0,  1096,     0,     0,  2107,     0,  2010,
       0,     0,     0,     0,     0,     0,  2011,     0,     0,  2012,
       0,     0,     0,  2519,     0,     0,     0,  1294,     0,     0,
    1294,  1294,    50,     0,     0,     0,     0,     0,  3059,     0,
       0,     0,     0,     0,     0,  2013,  3076,     0,    51,     0,
       0,     0,     0,     0,     0,     0,     0,  1094,  2973,     0,
       0,     0,     0,    52,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2014,
       0,     0,  1094,     0,     0,     0,     0,     0,     0,  1094,
       0,     0,     0,    53,     0,     0,     0,     0,     0,     0,
    1094,    54,     0,    55,    56,    57,    58,    59,     0,     0,
      60,    61,    62,    63,     0,    64,    65,    66,    67,    68,
       0,     0,   381,  2520,     0,     0,  2521,  2522,  2523,  1482,
    2524,  2525,  2526,  2527,  2528,  2529,  3157,     0,     0,     0,
       0,     0,  2108,     0,     0,     0,  2016,     0,     0,     0,
       0,  5291,  2006,     0,     0,     0,  2017,     0,  2007,     0,
       0,     0,     0,  2973,     0,  2018,     0,     0,     0,     0,
       0,  2106,     0,     0,     0,  1615,  1616,  2019,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5316,  5317,     0,     0,  1096,
    2009,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     381,     0,   727,  6164,     0,  2109,     0,     0,  2021,  2022,
       0,     0,     0,  2434,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4185,     0,     0,     0,
       0,  4185,     0,     0,  4185,     0,     0,     0,  2110,     0,
       0,     0,  2107,     0,  2010,     0,     0,     0,     0,     0,
       0,  2011,     0,     0,  2012,     0,  1094,     0,     0,     0,
       0,     0,   381,     0,   381,     0,     0,  6164,     0,     0,
       0,     0,     0,     0,     0,  5359,  5360,     0,     0,     0,
    2013,     0,     0,     0,   727,  6164,     0,     0,     0,     0,
       0,  3982,  3982,  3982,  3982,  3982,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2024,   727,     0,   380,
       0,     0,     0,   380,  2014,  1094,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   727,     0,   726,     0,     0,
     381,   727,     0,     0,     0,   727,   726,     0,     0,     0,
       0,     0,     0,   727,     0,     0,     0,     0,     0,     0,
     726,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   727,  1281,     0,     0,     0,     0,     0,  1293,     0,
       0,  1293,     0,     0,  1293,     0,     0,  2108,     0,     0,
       0,  2016,     0,  1294,     0,     0,  1294,  1294,   726,     0,
       0,  2017,     0,     0,   726,     0,     0,     0,     0,     0,
    2018,   373,     0,     0,  5458,     0,   727,   726,     0,     0,
       0,     0,  2019,     0,     0,  5461,  5462,     0,     0,     0,
       0,   373,     0,     0,     0,     0,   727,   727,     0,     0,
       0,  5466,     0,   726,     0,     0,     0,     0,     0,   373,
       0,     0,     0,     0,     0,     0,     0,     0,   726,     0,
    3760,     0,     0,  2021,  2022,     0,   726,   381,   727,     0,
       0,   381,     0,     0,     0,     0,     0,     0,     0,     0,
     726,     0,  2684,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   727,  3761,   381,   723,   726,     0,   727,     0,
       0,     0,     0,     0,     0,   727,     0,     0,     0,    69,
       0,     0,   727,     0,     0,   727,  4185,     0,  3519,  1096,
       0,   727,     0,     0,     0,     0,  2494,     0,     0,     0,
     937,     0,     0,     0,     0,     0,  3535,     0,     0,     0,
       0,   727,  3539,     0,  1096,     0,  3542,   727,     0,     0,
       0,  1096,   727,     0,     0,   381,     0,     0,     0,     0,
       0,  2024,  1096,     0,     0,   727,     0,     0,     0,     0,
    1094,     0,  3566,     0,     0,     0,  1094,     0,   727,     0,
    1094,     0,     0,   381,     0,     0,     0,     0,     0,   727,
       0,   937,     0,  1140,     0,   726,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,  5329,  5330,     0,     0,
       0,  5333,  5334,  2876,     0,     0,   380,  3620,     0,     0,
       0,   726,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2501,   726,     0,  2502,     0,   723,     0,  2503,
    2504,  2505,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   381,  2506,     0,     0,     0,
       0,     0,     0,  4185,  2508,     0,     0,     0,     0,  3670,
       0,  2509,     0,   373,     0,     0,     0,     0,     0,  2501,
       0,     0,  2502,     0,   726,   726,  2503,  2504,  2505,     0,
       0,     0,     0,  3699,     0,     0,  2510,     0,     0,  3708,
       0,     0,     0,  2506,  2006,     0,  3714,     0,     0,     0,
    2007,  2508,     0,   723,     0,     0,  3728,     0,  2509,     0,
       0,     0,  3733,  2008,     0,     0,     0,     0,  1096,     0,
       0,     0,     0,     0,     0,     0,   727,     0,     0,     0,
       0,     0,  3746,  2510,     0,  3003,     0,     0,  3749,     0,
     373,     0,  2009,  3753,     0,     0,     0,     0,  5702,     0,
       0,     0,  3020,     0,     0,     0,  3770,     0,     0,  1140,
    1140,     0,     0,     0,     0,     0,     0,     0,     0,  3795,
    3039,     0,     0,     0,     0,     0,     0,  1096,     0,     0,
     723,     0,   727,     0,     0,   380,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2010,  2511,     0,     0,
       0,     0,  2512,  2011,     0,     0,  2012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5747,     0,     0,  2513,  2514,  3120,     0,     0,     0,
       0,     0,  2013,     0,     0,     0,     0,   727,     0,  2515,
       0,     0,     0,     0,  2511,  3131,     0,     0,     0,  2512,
       0,     0,     0,     0,     0,   727,     0,     0,  1515,     0,
       0,     0,     0,   727,     0,     0,  2014,     0,     0,     0,
    3146,  2513,  2514,  1294,  5784,     0,  1294,     0,  2516,  1294,
       0,     0,     0,     0,     0,     0,  2515,     0,     0,     0,
       0,     0,  2517,     0,     0,  2518,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2006,     0,
    3172,  1515,     0,     0,  2007,     0,     0,     0,     0,  5527,
       0,  2069,     0,     0,  2006,  2516,     0,     0,     0,  2015,
    2007,     0,     0,  2016,     0,     0,     0,     0,     0,  2517,
    2070,     0,  2518,  2017,     0,   381,     0,     0,     0,     0,
       0,   381,  2018,     0,     0,     0,  2009,     0,     0,     0,
       0,     0,     0,     0,  2019,     0,     0,   373,     0,   726,
       0,     0,  2009,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2519,     0,     0,     0,     0,   726,     0,     0,
    2071,  1094,     0,     0,   373,     0,     0,     0,     0,     0,
       0,     0,  2020,     0,     0,  2021,  2022,     0,     0,     0,
    2010,     0,     0,     0,     0,     0,   726,  2011,     0,     0,
    2012,     0,  1096,     0,     0,     0,  2010,     0,  1096,  2519,
       0,     0,  1096,  2011,     0,  2023,  2012,     0,  4025,   727,
       0,     0,     0,     0,     0,     0,  2013,     0,     0,     0,
       0,     0,   726,     0,     0,     0,  4039,     0,     0,     0,
       0,     0,  2013,     0,  4025,     0,     0,     0,   726,  3353,
       0,     0,     0,     0,  6139,     0,     0,  2072,     0,     0,
    2014,     0,  2520,     0,   726,  2521,  2522,  2523,   726,  2524,
    2525,  2526,  2527,  2528,  2529,     0,  2014,     0,     0,  4727,
       0,     0,     0,  2024,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2073,     0,     0,  2074,  2520,
       0,     0,  2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,
    2528,  2529,     0,  2075,     0,     0,  4843,  2016,     0,  2006,
       0,     0,     0,   727,   727,  2007,     0,  2017,     0,  2108,
       0,  2501,  2069,  2016,  2502,     0,  2018,     0,  2503,  2504,
    2505,     0,     0,  2017,     0,   373,     0,  2076,  2019,     0,
     727,  2070,  2018,   727,     0,  2506,     0,     0,     0,     0,
       0,     0,     0,  2508,  2019,     0,     0,  2009,     0,     0,
    2509,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2077,     0,   726,  2021,
    2022,  2078,     0,     0,     0,  2510,   726,   726,     0,     0,
       0,  2071,  2794,     0,     0,  2021,  2022,     0,     0,     0,
       0,     0,   726,  2079,     0,     0,     0,     0,     0,  2080,
       0,  2010,     0,     0,     0,     0,     0,     0,  2011,     0,
       0,  2012,     0,  2081,     0,  2795,     0,   381,   381,   381,
       0,  1094,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   937,     0,     0,   937,     0,     0,  2013,   380,   380,
     380,   727,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6107,     0,     0,     0,     0,     0,   726,
       0,   727,     0,     0,     0,     0,     0,  2024,  2072,     0,
       0,  2014,     0,     0,     0,     0,     0,     0,     0,   727,
       0,     0,     0,  2024,     0,     0,  2511,     0,   380,     0,
       0,  2512,  3585,     0,     0,     0,   380,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3602,     0,   380,     0,
       0,     0,     0,  2513,  2514,     0,  2073,     0,  1140,  2074,
       0,     0,  5868,     0,     0,     0,     0,     0,  2515,     0,
       0,  4297,     0,     0,  2075,     0,   725,   937,  2016,     0,
       0,     0,     0,     0,     0,     0,     0,  3635,  2017,     0,
       0,     0,     0,     0,     0,     0,     0,  2018,     0,  1140,
       0,     0,     0,   875,     0,     0,   727,  2516,  2076,  2019,
       0,     0,     0,     0,     0,     0,     0,     0, -2573,     0,
       0,  2517,     0,     0,  2518,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5933,     0,  1096,     0,     0,     0,  3735,     0,   875,
    2021,  2022,  2078,   381,     0,  1140,     0,     0,     0,     0,
     727,     0,   727,     0,     0,     0,     0,     0, -2573,     0,
       0,     0,  1140,     0,  2079,   727,     0,   727,     0,     0,
    3736, -2573,  4377,     0,     0,     0, -2573,     0,     0,     0,
       0, -2573,     0,     0,  2081,     0,     0, -2573,  1139,   381,
   -2573,     0,     0,     0, -2573,     0,  1139,     0,  1139,     0,
       0,  2519,     0,     0,     0,     0,     0,     0,  1282,  1284,
       0,   875,  1287,     0,     0,     0,     0,     0,     0,     0,
       0,  2501,     0, -2573,  2502,     0,     0,     0,  2503,  2504,
    2505,   726,  1337,   727,     0,     0,     0,     0,  2024,  1347,
       0,     0,     0, -2573,     0,  2506,     0,     0,     0,     0,
       0,     0,     0,  2508,     0,     0,     0,     0,     0,     0,
    2509,     0,     0,     0,     0,     0,     0,  1418,     0,  1421,
       0,     0,     0,  1424,     0,     0,     0,     0,  3855,     0,
       0,     0,     0,     0,     0,  2510,   727,  1448,     0,     0,
   -2573,     0,     0, -2573,  1453,     0,     0,  4462,   380, -2573,
       0,  2520,     0,     0,  2521,  2522,  2523,   727,  2524,  2525,
    2526,  2527,  2528,  2529,     0,     0,     0,     0,  5166,     4,
       0,     0,   726,     0,     0,     0,   937,     0,     0,   727,
     726,     0,   727,     0,     0,     0,     0,     0,     5,     0,
       0,     0,   726,     0,     0,     0,     0,     0,     6,     7,
       0,     0,     0,     0, -2573,     9,    10,     0,     0,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,     0,     0,     0,    37,     0,    38,
      39,     0,     0,     0,     0,    40,  2511,     0,     0,     0,
       0,  2512,     0,     0,     0,     0,     0,     0,     0,  1110,
       0,     0,     0,  1096,   381,     0,     0,     0,     0,   726,
     726,     0,     0,  2513,  2514,     0,     0,     0,     0,     0,
       0,     0,     0,   726,     0,     0,     0, -2573,  2515,     0,
       0,     0,     0,     0,     0,     0,   726,   726,     0,    41,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -2573,     0, -2573, -2573,     0,     0,     0,     0,     0,
       0,     0,   726,     0,     0,  6161,     0,  2516,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2973,     0,     0,
       0,  2517,     0,     0,  2518,  4038,     0,     0,     0, -2573,
       0,     0, -2573, -2573,     0, -2573,     0,     0,  4643,     0,
       0,     0,  4050,     0,  5869,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    42,     0,     0,  4058,     0,     0,
       0,     0,     0,  4659,     0,     0,     0,     0,  2006,  6161,
       0,     0,     0,    43,  2007,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   937,     0,  6161,     0,   937,
       0,     0,     0,     0,     0,     0,    44,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2519,     0,     0,     0,     0,  2009,     0,     0,     0,
      45,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   727,     0,     0,     0,   380,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2034,  2035,     0,
       0,     0,     0,     0,     0,     0,     0,    46,     0,     0,
      47,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2010,     0,     0,     0,     0,     0,     0,  2011,     0,     0,
    2012,     0,    48,   381,     0,     0,     0,     0,   381,     0,
     381,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2013,     0,     0,     0,
       0,  2520,     0,   381,  2521,  2522,  2523,     0,  2524,  2525,
    2526,  2527,  2528,  2529,     0,   380,     0,   726,  5204,     0,
       0,     0,     0,   381,     0,     0,     0,     0,     0,     0,
    2014,     0,     0,     0,     0,     0,     0,  2189,     0,   727,
       0,     0,   727,     0,     0,     0,     0,     0,     0,  2501,
       0,     0,  2502,     0,     0,     0,  2503,  2504,  2505,     0,
      49,     0,     0,     0,     0,  2211,  2212,     0,     0,     0,
       0,     0,     0,  2506,     0,     0,     0,   380,     0,   380,
       0,  2508,     0,     0,     0,     0,     0,     0,  2509,     0,
       0,  2253,     0,  2015,     0,     0,     0,  2016,     0,   726,
       0,     0,     0,     0,     0,     0,     0,  2017,     0,     0,
      50,     0,     0,  2510,     0,     0,  2018,     0,     0,     0,
       0,     0,   726,     0,  4872,     0,    51,     0,  2019,     0,
       0,     0,     0,     0,   727,   727,     0,     0,  5387,     0,
     726,    52,     0,     0,   727,   380,   726,     0,  2501,  4301,
     726,  2502,     0,     0,     0,  2503,  2504,  2505,   726,     0,
       0,     0,     0,   727,     0,     0,  2869,     0,  4312,  2021,
    2022,    53,  2506,     0,  2324,  2326,   726,     0,     0,    54,
    2508,    55,    56,    57,    58,    59,     0,  2509,    60,    61,
    1577,     0,   875,     0,     0,    66,  1578,     0,     0,  2870,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     725,     0,  2510,     0,     0,     0,     0,     0,     0,   725,
       0,   726,   381,  2501,  2511,     0,  2502,     0,     0,  2512,
    2503,  2504,  2505,   725,  1140,     0,     0,     0,     0,     0,
    4976,   726,   726,  4979,     0,     0,     0,  2506,     0,     0,
     727,  2513,  2514,     0,     0,  2508,     0,     0,     0,     0,
       0,     0,  2509,  4394,     0,  4396,  2515,  2024,     0,     0,
       0,   725,   380,   726,     0,     0,   380,   725,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2510,     0,     0,
     725,     0,     0,     0,     0,     0,     0,   726,     0,   380,
       0,     0,     0,   726,     0,  2516,     0,     0,     0,     0,
     726,     0,     0,     0,     0,  1140,   725,   726,   937,  2517,
     726,     0,  2518,  2511,     0,   937,   726,     0,  2512,     0,
     937,   725,     0,   937,  5507,     0,     0,     0,     0,   725,
       0,     0,     0,     0,     0,  5063,   726,     0,     0,     0,
    2513,  2514,   726,   725,     0,     0,  4447,   726,     0,     0,
     380,     0,   937,     0,  2973,  2515,     0,     0,     0,   725,
     726,     0,     0,     0,     0,     0,   937,     0,     0,     0,
       0,     0,     0,   726,     0,     0,     0,     0,   380,     0,
       0,     0,     0,     0,   726,     0,     0,  4469,  2511,     0,
       0,     0,     0,  2512,  2516,     0,     0,     0,     0,  2519,
       0,     0,     0,     0,     0,     0,     0,     0,  2517,     0,
       0,  2518,     0,     0,     0,  2513,  2514,     0,     0,  1293,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2515,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4025,     0,     0,     0,     0,     0,     0,     0,     0,
     380,     0,     0,     0,     0,     0,  1139,     0,   725,     0,
    1139,     0,     0,  1293,     0,     0,  2006,     0,     0,  2516,
       0,     0,  2007,     0,     0,   727,     0,     0,     0,     0,
     381,     0,     0,  2517,   725,  3635,  2518,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   725,     0,  2519,  2520,
       0,     0,  2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,
    2528,  2529,     0,     0,  2009,   727,  5469,     0,     0,     0,
       0,     0,  4607,     0,     0,     0,     0,   727,     0,     0,
       0,   726,   937,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   725,   725,     0,
       0,     0,  2501,     0,     0,  2502,     0,   727,     0,  2503,
    2504,  2505,     0,     0,     0,     0,     0,     0,  2010,     0,
       0,     0,     0,  2519,     0,  2011,  2506,     0,  2012,     0,
       0,     0,     0,     0,  2508,     0,     0,   726,     0,     0,
       0,  2509,     0,     0,     0,   937,     0,     0,  2520,     0,
       0,  2521,  2522,  2523,  2013,  2524,  2525,  2526,  2527,  2528,
    2529,     0,  2812,     0,     0,  5479,  2510,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4673,     0,     0,
       0,     0,  1139,  1139,     0,     0,     0,  2851,  2014,     0,
       0,     0,   726,     0,     0,     0,     0,     0,     0,     0,
    4683,     0,     0,     0,     0,     0,   727,     0,   875,     0,
     726,     0,     0,     0,     0,     0,     0,     0,   726,     0,
       0,     0,     0,  2520,     0,  4706,  2521,  2522,  2523,     0,
    2524,  2525,  2526,  2527,  2528,  2529,     0,     0,     0,     0,
    5488,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2108,     0,     0,     0,  2016,     0,     0,     0,     0,
    2931,  2434,     0,     0,     0,  2017,  5326,  5819,     0,     0,
       0,     0,     0,     0,  2018,     0,     0,  2511,  5336,     0,
       0,     0,  2512,     0,     0,     0,  2019,  2954,  2955,  2956,
    2957,     0,   937,     0,     0,     0,   727,     0,     0,     0,
     380,     0,     0,     0,  2513,  2514,   380,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2515,
       0,     0,     0,     0,  3630,     0,     0,  2021,  2022,     0,
       0,     0,     0,     0,     0,     0,     0,  2501,     0,     0,
    2502,     0,     0,     0,  2503,  2504,  2505,  3009,  3010,     0,
       0,     0,     0,   937,     0,     0,     0,  2023,  2516,     0,
       0,  2506,     0,     0,     0,     0,     0,  3033,     0,  2508,
       0,     0,  2517,     0,     0,  2518,  2509,     0,  2006,     0,
       0,     0,   937,     0,  2007,     0,     0,     0,  2501,     0,
       0,  2502,   725,     0,   726,  2503,  2504,  2505,     0,     0,
       0,  2510,  3078,  3079,  3080,  3081,     0,     0,     0,     0,
     725,     0,  2506,     0,     0,   727,     0,   727,     0,     0,
    2508,     0,     0,     0,     0,  2024,  2009,  2509,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   725,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2510,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2519,     0,   727,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1294,   725,     0,     0,     0,     0,
    2010,     0,     0,     0,     0,     0,     0,  2011,   937,     0,
    2012,   725,     0,     0,     0,     0,     0,  4025,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   725,   726,   726,
       0,   725,  2511,   381,     0,     0,  2013,  2512,  1294,     0,
       0,     0,  3180,     0,     0,     0,     0,     0,  3184,     0,
       0,     0,     0,     0,     0,   726,     0,     0,   726,  2513,
    2514,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2014,     0,     0,     0,  2515,     0,     0,     0,     0,  1293,
       0,     0,  2520,  2511,     0,  2521,  2522,  2523,  2512,  2524,
    2525,  2526,  2527,  2528,  2529,     0,     0,     0,     0,  5491,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2513,  2514,     0,  2516,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2515,     0,  2517,     0,     0,
    2518,     0,  6057,  2108,     0,     0,  4025,  2016,  4025,     0,
       0,     0,   380,   380,   380,     0,     0,  2017,   937,     0,
       0,     0,     0,     0,  1293,  1293,  2018,     0,     0,     0,
    5052,   725,     0,     0,  2516,     0,   726,     0,  2019,   725,
     725,     0,     0,     0,     0,     0,     0,     0,  2517,     0,
       0,  2518,     0,     0,     0,   725,   726,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2006,     0,     0,
    3363,     0,     0,  2007,   726,     0,  3805,     0,     0,  2021,
    2022,     0,     0,     0,     0,     0,     0,  2519,     0,     0,
       0,     0,     0,   381,   937,     0,     0,     0,     0,     0,
     937,   875,     0,     0,     0,     0,     0,     0,     0,  3806,
       0,     0,     0,     0,     0,  2009,     0,     0,     0,   727,
       0,     0,   725,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   727,     0,     0,     0,     0,  2519,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2006,     0,     0,     0,     0,     0,
    2007,   726,     0,     0,     0,     0,     0,     0,     0,  2010,
       0,   875,     0,     0,     0,     0,  2011,  2024,     0,  2012,
       0,  1139,     0,     0,     0,     0,     0,  2520,     0,     0,
    2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,  2528,  2529,
       0,   937,  2009,     0,  5541,  2013,     0,     0,   380,     0,
       0,     0,     0,     0,  6197,   726,     0,   726,     0,     0,
       0,     0,  1139,     0,     0,     0,     0,     0,     0,     0,
     726,     0,   726,  2434,     0,     0,  1293,  1293,  2520,  2014,
       0,  2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,  2528,
    2529,     0,     0,     0,   380,  5576,  2010,     0,     0,     0,
       0,     0,     0,  2011,     0,     0,  2012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1139,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2013,     0,     0,  1139,     0,     0,   726,     0,
       0,     0,  2108,     0,     0,     0,  2016,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2017,     0,     0,     0,
       0,   381,     0,   727,     0,  2018,  2014,     0,     0,     0,
       0,     0,     0,  3583,  3584,     0,     0,  2019,     0,     0,
       0,     0,     0,     0,  3597,  2501,  3599,     0,  2502,     0,
    3603,   726,  2503,  2504,  2505,     0,     0,     0,     0,  5292,
       0,     0,     0,     0,   725,     0,     0,     0,     0,  2506,
       0,     0,   726,     0,     0,  4323,     0,  2508,  2021,  2022,
       0,     0,     0,     0,  2509,     0,     0,     0,     0,  2108,
       0,     0,     0,  2016,   726,     0,     0,   726,     0,     0,
    5315,     0,     0,  2017,     0,     0,     0,     0,  4324,  2510,
       0,     0,  2018,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5331,   381,  2019,     0,     0,     0,     0,     0,
       0,   875,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   727,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1294,   725,     0,     0,     0,    80,
       0,     0,  4379,   725,    83,  2021,  2022,   727,    87,     0,
      88,     0,    90,    91,     0,   725,  2024,     0,  3740,   380,
       0,  3743,     0,   100,     0,     0,     0,     0,     0,     0,
    5358,     0,     0,     0,     0,  4380,     0,     0,     0,   112,
     113,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2511,     0,     0,     0,     0,  2512,     0,     0,     0,  1294,
    1294,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   121,  2513,  2514,     0,
       0,     0,   725,   725,     0,     0,   122,     0,   123,   124,
       0,     0,  2515,  2024,  3832,     0,   725,     0,     0,     0,
       0,     0,  3839,   727,  1218,  3842,     0,     0,     0,   725,
     725,  3844,     0,   133,     0,     0,     0,     0,     0,     0,
       0,     0,  3856,     0,     0,   135,     0,   136,   137,     0,
       0,  2516,     0,     0,   140,   725,   141,     0,     0,     0,
       0,     0,     0,  5448,     0,  2517,     0,   143,  2518,   144,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3902,   147,     0,   148,     0,     0,   151,
       0,     0,  4025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   152,     0,   153,     0,   381,     0,   154,
       0,  3925,     0,     0,     0,   155,     0,     0,   726,     0,
       0,  2434,     0,   157,     0,   159,     0,     0,     0,     0,
       0,     0,   161,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   165,     0,
       0,     0,     0, -2575,     0,  2519,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   169,     0,     0,   380,     0,
    3990,   381,  3992,   380,     0,   380,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   381,
     875,  1294,  1294,     0,     0,     0,     0,     0,   380,     0,
       0,     0,     0, -2575,     0,   180,   181,     0,     0,     0,
       0,   182,     0,     0,     0,     0, -2575,     0,   380,     0,
       0, -2575,     0,   183,     0,     0, -2575,     0,     0,     0,
       0,     0, -2575,     0,   726, -2575,     0,   726,     0, -2575,
       0,   189,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2520,     0,     0,  2521,  2522,
    2523,     0,  2524,  2525,  2526,  2527,  2528,  2529, -2575,     0,
       0,     0,  5618,     0,     0,     0,     0,     0,     0,     0,
     725,     0,     0,     0,   199,     0,     0,     0, -2575,     0,
       0,     0,     0,  4060,     0,     0,     0,     0,   201,     0,
       0,     0,     0,     0,   202,   203,     0,   204,     0,     0,
       0,     0,   205,     0,     0,     0,     0,   206,     0,     0,
     208,     0,     0,     0,     0,     0,     0,   210,     0,   726,
     726,     0,     0,   211,   212, -2575,     0,     0, -2575,   726,
       0,   213,     0,     0, -2575,   215,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   218,     0,     0,   726,     0,
       0,     0,   725,     0,     0,  2501,     0,     0,  2502,     0,
     220,     0,  2503,  2504,  2505,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   725,     0,     0,     0,  2506,
     226,     0,   227,     0,     0,     0,     0,  2508,     0, -2575,
       0,   229,     0,   725,  2509,     0,     0,   230,   875,   725,
       0,     0,   231,   725,     0,     0,     0,   380,     0,  2434,
       0,   725,     0,     0,     0,   234,     0,     0,  2501,  2510,
       0,  2502,     0,     0,     0,  2503,  2504,  2505,     0,   725,
       0,     0,     0,     0,     0,   726,     0,     0,   246,     0,
       0,     0,  2506,     0,  1110,     0,     0,     0,  4447,     0,
    2508,     0,   247,     0,     0,     0,  -147,  2509,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2575,     0,   725,     0,     0,     0,     0,     0,
       0,     0,  2510,  2501,     0,     0,  2502,  1139,     0,     0,
    2503,  2504,  2505,     0,   725,   725, -2575,     0, -2575, -2575,
       0,     0,     0,     0,  2434,     0,     0,  2506,     0,  2434,
    2434,     0,     0,     0,     0,  2508,     0,     0,     0,     0,
       0,     0,  2509,     0,     0,   875,   725,     0,     0,   875,
    2511,     0,     0,     0, -2575,  2512,     0, -2575, -2575,     0,
   -2575,     0,     0,     0,     0,     0,     0,  2510,     0,     0,
     725,     0,   875,     0,     0,     0,   725,  2513,  2514,     0,
       0,     0,     0,   725,     0,     0,     0,     0,  1139,     0,
     725,     0,  2515,   725,     0,     0,     0,     0,     0,   725,
       0,     0,     0,     0,     0,     0,     0,     0,  4304,     0,
    4305,  4306,  4307,  2511,     0,     0,     0,     0,  2512,   725,
       0,     0,     0,     0,     0,   725,     0,     0,     0,     0,
     725,  2516,     0,   875,     0,     0,     0,     0,     0,     0,
    2513,  2514,     0,   725,     0,  2517,  5862,     0,  2518,     0,
       0,     0,     0,     0,     0,  2515,   725,  1976,     0,     0,
       0,   875,     0,     0,     0,     0,     0,   725,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2511,     0,
       0,     0,     0,  2512,     0,     0,     0,     0,     0,     0,
     726,  1977,     0,     0,  2516,   380,     0,     0, -2591,     0,
       0,     0,     0,     0,     0,  2513,  2514,     0,  2517,     0,
       0,  2518,     0,     0,     0,     0,     0,     0,     0,     0,
    2515,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     726,     0,     0,   875,     0,  2519,     0,     0,     0,     0,
       0,     0,   726,     0,     0,     0,     0,     0, -2591,     0,
       0,  1978,     0,     0,     0,     0,     0,     0,     0,  2516,
       0, -2591,     0,     0,     0,     0, -2591,     0,     0,     0,
       0, -2591,   726,  2517,     0,     0,  2518, -2591,     0,     0,
   -2591,     0,     0,     0, -2591,     0,  1979,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2519,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0, -2591,   725,     0,     0,  2501,     0,     0,
    2502,     0,  1980,  1976,  2503,  2504,  2505,     0,     0,     0,
       0,     0,     0, -2591,     0,  2520,     0,     0,  2521,  2522,
    2523,  2506,  2524,  2525,  2526,  2527,  2528,  2529,  6013,  2508,
       0,  4470,  5927,     0,     0,     0,  2509,  1977,  1981,     0,
       0,     0,  1982,  2519,     0,     0,     0,     0,     0,     0,
     725,   726,     0,     0,     0,     0,     0,     0,     0,     0,
   -2591,  2510,     0, -2591,     0,     0,     0,     0,     0, -2591,
       0,     0,     0,  2043,  1984,     0,     0,     0,  2520,     0,
       0,  2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,  2528,
    2529,     0,     0,     0,     0,  5950,     0,  1978,     0,     0,
       0,     0,     0,     0,     0,   725,     0,     0,     0,     0,
       0,  2044,     0,     0,     0,   205,     0,     0,     0,  1986,
       0,     0,     0,   725, -2591,     0,     0,     0,  1987,     0,
       0,   725,  1979,     0,     0,     0,  1988,     0,     0,     0,
       0,   726,     0,  2520,  2045,     0,  2521,  2522,  2523,     0,
    2524,  2525,  2526,  2527,  2528,  2529,  1990,     0,   771,     0,
    6056,     0,     0,     0,     0,  1991,     0,     0,  1980,  1992,
       0,     0,  2511,     0,     0,     0,     0,  2512,     0,  1110,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   771,     0,     0,     0,  2513,
    2514,     0,     0,   941,  1981,  4633,     0, -2591,  1982,     0,
       0,     0,     0,   875,  2515,     0,     0,   771,     0,   875,
       0,     0,     0,  1993,     0,     0,     0,     0,     0,     0,
       0, -2591,     0, -2591, -2591,  1105,     0,     0,     0,  2060,
    1984,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1107,     0,     0,  2516,     0,     0,     0,     0,     0,  1115,
     726,     0,   726,     0,     0,     0,     0,  2517,     0, -2591,
    2518,     0, -2591, -2591,  1129, -2591,  1105,  2061,     0,     0,
    1152,   205,     0,     0,     0,  1986,     0,     0,     0,     0,
    1184,     0,     0,     0,  1987,     0,     0,     0,     0,  1189,
       0,     0,  1988,     0,     0,     0,     0,   725,     0,   726,
    2062,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1990,     0,     0,     0,     0,     0,     0,     0,
       0,  1991,     0,     0,     0,  1992,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2519,   380,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    81,    82,     0,    84,    85,    86,     0,  1993,
       0,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,     0,     0,     0,   101,   102,   103,   104,
       0,   105,   106,   107,   108,     0,   109,   110,   111,     0,
       0,   725,   725,     0,   114,   115,     0,     0,     0,     0,
     116,     0,     0,     0,     0,     0,     0,     0,     0,   117,
       0,   118,     0,   119,     0,    35,     0,     0,   725,    37,
       0,   725,     0,     0,     0,     0,     0,  2520,     0,     0,
    2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,  2528,  2529,
       0,     0,     0,     0,  6126,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   126,     0,     0,     0,   128,   129,   130,   131,   132,
       0,     0,     0,     0,     0,     0,     0,     0,  4866,  4867,
    4868,  4869,   134,     0,     0,     0,     0,     0,     0,   138,
       0,   139,     0,     0,     0,     0,     0,     0,   142,     0,
       0,     0,     0,     0,     0,   875,   875,   875,     0,     0,
     145,     0,     0,     0,     0,     0,     0,   146,   380,     0,
       0,     0,     0,     0,     0,     0,     0,   149,   150,   725,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   726,     0,     0,     0,     0,   725,
       0,     0,     0,     0,     0,     0,   156,     0,   726,     0,
       0,     0,     0,     0,   158,     0,     0,   725,     0,   160,
       0,     0,     0,     0,     0,   162,     0,     0,     0,     0,
       0,   163,     0,   164,     0,     0,     0,     0,     0,     0,
     166,     0,   167,     0,     0,     0,     0,     0,     0,     0,
       0,   168,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   170,   171,     0,     0,
       0,     0,     0,   172,     0,   173,     0,     0,   174,   175,
       0,   176,     0,     0,     0,     0,     0,     0,     0,     0,
     177,   178,     0,   179,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   725,     0,     0,  5020,     0,     0,
       0,     0,     0,     0,     0,     0,   184,   185,   186,     0,
       0,     0,  5023,     0,     0,     0,   187,   188,     0,     0,
       0,     0,   190,     0,     0,   191,     0,   192,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   875,     0,   193,   194,     0,   195,   196,   725,     0,
     725,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     197,     0,   198,   725,     0,   725,   771,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,     0,     0,
       0,     0,     0,     0,     0,     0,   380,   875,   726,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   207,     0,
       0,     0,     0,     0,   209,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   214,     0,     0,   216,     0,     0,   217,
       0,   725,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   219,     0,     0,     0,     0,
       0,     0,   221,     0,     0,     0,     0,     0,     0,     0,
     222,   223,     0,     0,     0,     0,   224,     0,   225,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   228,     0,
       0,     0,     0,     0,   725,     0,     0,     0,   380,     0,
       0,     0,     0,   232,     0,     0,   233,     0,     0,     0,
       0,     0,     0,     0,     0,   725,   726,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,     0,     0,     0,     0,   725,     0,     0,
     725,     0,   726,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3499,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   941,  1283,  1283,
     771,     0,  1283,     0,     0,     0,  1295,     0,  1184,     0,
       0,  1322,     0,     0,  1295,     0,     0,  1295,     0,     0,
    1184,     0,  1283,     0,     0,  1184,     0,     0,     0,  1283,
       0,  1184,   875,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1370,
       0,     0,     0,     4,     0,  1184,     0,  1283,   726,  1283,
       0,   771,     0,  1283,     0,     0,     0,     0,     0,     0,
    1322,     0,     5,     0,     0,  1444,     0,  1283,     0,     0,
       0,     0,     6,     7,  1283,     0,     0,     0,     0,     9,
      10,     0,     0,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,   941,     0,
       0,    37,   771,    38,    39,     0,     0,  1295,     0,    40,
       0,  1322,     0,     0,  1295,     0,     0,  1295,     0,     0,
       0,     0,   380,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1283,     0,  2501,     0,     0,  2502,     0,
       0,     0,  2503,  2504,  2505,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2506,
       0,     0,     0,    41,     0,     0,     0,  2508,     0,     0,
       0,     0,     0,     0,  2509,     0,     0,     0,     0,     0,
       0,     0,     0,  5351,     0,     0,   380,     0,     0,     0,
       0,  1184,     0,     0,     0,     0,     0,     0,  5355,  2510,
       0,   725,     0,     0,   380,     0,     0,     0,  1656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2501,     0,     0,  2502,     0,     0,     0,  2503,  2504,
    2505,     0,     0,     0,     0,     0,  1769,  1769,    42,     0,
       0,   771,  1184,     0,     0,  2506,     0,     0,     0,     0,
       0,   875,     0,  2508,     0,     0,   875,    43,   875,     0,
    2509,  1184,     0,     0,     0,  1184,     0,     0,     0,     0,
       0,     0,     0,  1769,     0,     0,     0,     0,     0,     0,
      44,   875,     0,     0,  1184,  2510,     0,     0,     0,     0,
       0,  5421,     0,     0,     0,     0,  1184,     0,     0,     0,
       0,   875,     0,     0,    45,     0,     0,     0,     0,     0,
    2511,     0,     0,     0,     0,  2512,     0,   725,     0,     0,
     725,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2513,  2514,     0,
       0,    46,     0,     0,    47,     0,     0,     0,     0,     0,
       0,     0,  2515,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    48,     0,     0,     0,
       0,  1184,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1184,     0,     0,     0,     0,  1283,  1283,     0,
       0,  2516,     0,     0,     0,     0,  2511,     0,     0,     0,
       0,  2512,     0,     0,     0,  2517,     0,     0,  2518,     0,
       0,     0,   725,   725,     0,     0,     0,     0,     0,     0,
       0,     0,   725,  2513,  2514,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2515,     0,
       0,   725,     0,  1769,  1769,     0,     0,     0,     0,     0,
       0,     0,   941,     0,    49,     0,     0,     0,     0,     0,
       0,     0,     0,  1295,     0,     0,     0,  1322,     0,  1295,
       0,     0,  1295,     0,     0,     0,     0,  2516,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1283,  5546,     0,
    5547,  2517,     0,     0,  2518,  2519,     0,     0,     0,     0,
       0,     0,     0,     0,    50,     0,     0,     0,     0,  1184,
       0,     0,     0,     0,     0,  1283,  1283,     0,     0,     0,
      51,     0,  2501,     0,     0,  2502,     0,     0,   725,  2503,
    2504,  2505,     0,     0,     0,    52,     0,  1184,  1184,  1184,
       0,  1283,     0,   941,   941,   941,  2506,     0,     0,     0,
    2263,     0,     0,     0,  2508,     0,     0,     0,     0,     0,
       0,  2509,     0,     0,     0,    53,     0,     0,     0,     0,
       0,     0,     0,    54,     0,    55,    56,    57,    58,    59,
       0,  2519,    60,    61,  1577,  2359,  2510,     0,     0,    66,
       0,     0,     0,     0,     0,  2520,     0,     0,  2521,  2522,
    2523,     0,  2524,  2525,  2526,  2527,  2528,  2529,     0,     0,
    2501,     0,  6182,  2502,     0,     0,     0,  2503,  2504,  2505,
       0,     0,  1283,     0,  1283,  1283,     0,     0,     0,     0,
       0,     0,     0,     0,  2506,     0,     0,     0,  3453,     0,
       0,     0,  2508,     0,     0,     0,     0,     0,     0,  2509,
    5683,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1769,     0,
       0,     0,     0,     0,  2510,     0,     0,     0,     0,     0,
       0,  2520,     0,     0,  2521,  2522,  2523,     0,  2524,  2525,
    2526,  2527,  2528,  2529,     0,     0,  2501,  2511,  6196,  2502,
       0,     0,  2512,  2503,  2504,  2505,  2406,  2406,     0,     0,
       0,  1184,     0,  1105,     0,     0,     0,     0,     0,     0,
    2506,     0,     0,  3454,  2513,  2514,     0,     0,  2508,     0,
       0,     0,     0,     0,  1184,  2509,     0,     0,     0,  2515,
    2444,     0,     0,  1184,     0,     0,  2450,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1769,
    2510,     0,     0,   725,     0,     0,     0,     0,   875,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2516,     0,
       0,     0,     0,     0,     0,  2511,     0,     0,     0,  1769,
    2512,     0,  2517,     0,     0,  2518,     0,     0,  5780,     0,
    5782,     0,     0,   725,     0,     0,     0,     0,     0,     0,
       0,     0,  2513,  2514,     0,   725,     0,  1769,  1769,  1769,
       0,  1769,     0,     0,     0,     0,     0,  2515,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1769,     0,     0,     0,   725,     0,  4113,     0,     0,
       0,     0,  4114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   771,   771,  2516,     0,     0,     0,
       0,  2511,     0,     0,     0,     0,  2512,     0,     0,     0,
    2517,     0,  2519,  2518,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1184,     0,     0,     0,     0,  2513,  2514,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2515,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1769,     0,     0,     0,  1769,  1769,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1184,  1184,
    2649,     0,  1769,     0,   725,     0,     0,     0,     0,     0,
       0,     0,  2516,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2517,   771,     0,  2518,
    2519,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2520,     0,     0,  2521,  2522,  2523,     0,  2524,
    2525,  2526,  2527,  2528,  2529,     0,     0,  2997,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3455,     0,     0,     0,   725,     0,     0,  5964,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2519,     0,     0,     0,
       0,     0,     0,     0,  2802,     0,     0,     0,     0,     0,
    2520,     0,  1283,  2521,  2522,  2523,     0,  2524,  2525,  2526,
    2527,  2528,  2529,     0,     0,  1184,  2830,     0,     0,     0,
       0,     0,     0,     0,  1184,     0,     0,  1283,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1322,     0,  1184,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6036,  1184,     0,     0,  1184,     0,
       0,     0,     0,   725,     0,   725,  2520,     0,     0,  2521,
    2522,  2523,     0,  2524,  2525,  2526,  2527,  2528,  2529,     0,
    1283,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1184,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1283,  1283,  1283,
    1283,  1184,   725,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1184,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1769,  1769,  1769,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6112,  3000,     0,  1184,     0,     0,     0,     0,
       0,   875,     0,     0,     0,     0,     0,  1283,  1283,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6128,  6128,  1283,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1184,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1283,  1283,  1283,  1283,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1184,     0,     0,     0,     0,
       0,     0,  1184,     0,  3000,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   941,     0,     0,   941,     0,     0,     0,   771,
       0,     0,     0,     0,     0,  1769,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6128,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1295,  1295,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1322,  1322,     0,
       0,  1295,     0,     0,  1295,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1283,  1283,     0,     0,     0,     0,     0,  1283,     0,
       0,   875,     0,     0,     0,     0,     0,     0,     0,  1184,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   725,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   725,     0,  2406,     0,     0,     0,     0,     0,     0,
    1283,     0,  1295,     0,     0,  1295,  1295,     0,  1184,  1184,
       0,  1283,     0,     0,     0,     0,     0,     0,  1184,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1184,     0,
       0,     0,     0,     0,     0,  1105,  1105,     0,     0,  3261,
       0,     0,     0,  1769,  1769,     0,     0,     0,     0,  1769,
    1769,     0,     0,     0,     0,     0,  1769,  1769,  1769,     0,
       0,  1769,     0,  1769,  1322,  1769,  1769,  1769,  1769,  1769,
    1769,     0,  1769,     0,  1769,  1769,     0,     0,  1769,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1769,  1769,  1769,  1769,     0,     0,     0,
    1283,  1769,     0,     0,     0,  1769,     0,     0,  1769,     0,
       0,  1769,  1769,  1769,  1769,  1769,  1769,  1769,  1769,  1769,
       0,  1769,     0,     0,     0,     0,     0,     0,  1184,  1769,
       0,     0,  1769,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1184,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   875,
       0,   725,     0,     0,  1527,     0,  1184,     0,     0,     0,
       0,     0,     0,  1769,     0,     0,     0,  1184,  1184,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1769,     0,
    1527,     0,     0,     0,     4,     0,     0,  1769,  1769,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1184,     0,     5,     0,     0,     0,     0,  3489,     0,
    3494,     0,     0,     6,     7,     0,     0,     0,     0,     0,
       9,    10,     0,     0,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,     0,
       0,   875,    37,     0,    38,    39,     0,     0,     0,     0,
      40,     0,     0,     0,     0,     0,     0,     0,     0,   725,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   771,     0,     0,     0,   725,     0,     0,     0,     0,
    1105,     0,  1105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    41,     0,     0,     0,     0,  1769,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   941,     0,  1283,  1283,     0,     0,     0,  1295,     0,
    1322,  1295,  1295,     0,  1283,     0,  1283,     0,     0,     0,
    1283,     0,     0,  1184,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2830,     0,     0,     0,    42,
       0,     0,     0,  3638,  1184,     0,     0,     0,     0,     0,
    3649,   725,     0,     0,     0,     0,     0,     0,    43,  1184,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1184,     0,
       0,    44,     0,  3694,  3694,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1184,  1184,
       0,     0,  1184,     0,   771,    45,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1283,     0,
       0,  1283,     0,     0,     0,   875,     0,     0,     0,     0,
       0,     0,    46,     0,     0,    47,     0,     0,     0,     0,
       0,     0,     0,     0,  1184,  1184,     0,     0,     0,     0,
    1527,     0,     0,     0,     0,     0,     0,    48,     0,  3789,
       0,  3792,  3794,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1527,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   875,
    1527,     0,  1769,  1769,  1769,     0,     0,     0,  1769,     0,
       0,     0,     0,     0,  1283,     0,     0,   875,     0,     0,
       0,     0,  1283,     0,     0,  1283,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
    1769,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    49,  2830,     0,     0,  3694,
       0,  1184,     0,     0,  1184,     0,     0,     0,  3896,     0,
       0,  1105,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1283,  1769,     0,     0,     0,     0,     0,
    1527,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3789,     0,     0,     0,    50,     0,     0,     0,     0,
       0,  1283,     0,  3928,     0,     0,     0,     0,     0,     0,
       0,    51,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2263,     0,     0,     0,    52,     0,     0,     0,
       0,     0,     0,     0,  1769,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3983,     0,
       0,     0,     0,     0,     0,     0,    53,     0,  1283,     0,
    1283,  3694,  1283,  3694,    54,     0,    55,    56,    57,    58,
      59,     0,     0,    60,    61,  1577,  3185,     0,     0,     0,
      66,     0,     0,     0,     0,     0,     0,     0,     0,  2501,
       0,     0,  2502,     0,     0,     0,  2503,  2504,  2505,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2406,     0,  2506,     0,     0,     0,  1527,     0,     0,
       0,  2508,     0,     0,     0,     0,     0,     0,  2509,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2510,     0,     0,     0,     0,     0,     0,
       0,     0,   941,     0,     0,     0,     0,     0,  1295,     0,
       0,  1295,     0,     0,  1295,     0,     0,     0,     0,     0,
       0,     0,     0,  1283,     0,     0,     0,     0,     0,     0,
    1769,     0,     0,     0,     0,  1769,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1769,
    1769,  1769,     0,     0,  1769,     0,     0,     0,     0,     0,
       0,     0,  1769,  1769,  1769,  1769,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1769,     0,     0,  1769,     0,
    1769,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1769,  1769,     0,  2511,  1769,     0,     0,     0,  2512,
       0,     0,  2573,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1322,     0,  1769,     0,  1769,     0,  1769,
       0,  2513,  2514,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2515,     0,     0,  1769,
       0,     0,     0,  1184,     0,     0,     0,     0,     0,     0,
    4195,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2501,     0,     0,  2502,     0,     0,     0,
    2503,  2504,  2505,     0,  1184,  2516,     0,     0,     0,     0,
       0,     0,  1769,     0,     0,     0,     0,  2506,     0,  2517,
       0,     0,  2518,     0,     4,  2508,     0,  1769,     0,     0,
       0,     0,  2509,     0,     0,     0,     0,     0,     0,     0,
       0,  4195,     0,     5,     0,  4251,  4719,     0,  4254,     0,
    3494,     0,     0,     6,     7,     0,     0,  2510,     0,     0,
       9,    10,     0,  1527,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,     0,
       0,     0,    37,     0,    38,    39,     0,     0,     0,     0,
      40,     0,     0,     0,     0,     0,     0,     0,     0,  2519,
       0,     0,     0,     0,  1769,     0,  3694,     0,     0,     0,
       0,  2406,     0,     0,     0,     0,  4720,     0,     0,     0,
    1527,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6087,     0,     0,     0,     0,  1283,     0,
    1283,  1283,  1283,     0,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1527,  2511,     0,
       0,     0,     0,  2512,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2513,  2514,     0,     0,     0,
    1527,     0,     0,     0,     0,     0,     0,     0,     0,  2520,
    2515,     0,  2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,
    2528,  2529,     0,     0,     0,     0,     0,     0,     0,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    43,  2516,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2517,  1184,     0,  2518,     0,     0,     0,
       0,    44,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6088,     0,
       0,     0,     0,     0,     0,    45,     0,     0,     0,  1527,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1527,     0,     0,     0,
       0,     0,  2501,     0,     0,  2502,     0,     0,     0,  2503,
    2504,  2505,    46,     0,  1527,    47,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2506,     0,     0,  4070,
       0,     0,     0,  2519,  2508,     0,     0,    48,     0,     0,
       0,  2509,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1769,     0,     0,     0,
       0,     0,  1769,     0,     0,     0,  2510,     0,     0,     0,
    1527,  1283,     0,     0,     0,     0,  3694,  3694,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1527,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1527,     0,     0,     0,     0,     0,     0,     0,
       0,  1184,  1184,  1184,  1527,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    49,     0,     0,  1184,     0,
       0,     0,     0,  2520,     0,     0,  2521,  2522,  2523,     0,
    2524,  2525,  2526,  2527,  2528,  2529,     0,     0,     0,     0,
    2406,  1184,     0,     0,  1527,  1527,     0,     0,     0,     0,
    2406,  1184,  1184,     0,     0,     0,  1184,     0,     0,  3694,
       0,     0,     0,     0,     0,    50,     0,  2511,  1184,     0,
       0,     0,  2512,     0,     0,     0,     0,     0,     0,     0,
       0,    51,     0,     0,     0,     0,     0,     0,     0,     0,
     771,     0,     0,     0,  2513,  2514,    52,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2515,
       0,  3983,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    53,     0,     0,     0,
       0,     0,     0,     0,    54,  1283,    55,    56,    57,    58,
      59,     0,     0,    60,    61,  1577,     0,     0,  2516,     0,
      66,     0,     0,     0,     0,     0,     0,     0,     0,  1184,
       0,     0,  2517,     0,     0,  2518,     0,     0,     0,     0,
       0,     0,  1184,     0,     0,  1184,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1769,     0,     0,
       0,     0,     0,  1527,     0,     0,  1769,     0,     0,     0,
       0,     0,     0,     0,  1769,     0,  1769,     0,     0,  1769,
       0,     0,     0,     0,  1769,  1769,  1769,  1769,     0,     0,
    1769,  1769,  1769,  1769,  1769,  1769,  1769,  1769,  1769,  1769,
       0,     0,     0,  1769,  1769,     0,     0,     0,     0,     0,
       0,     0,  2519,  1769,     0,     0,     0,  1769,     0,     0,
       0,  1769,     0,     0,     0,     0,     0,     0,     0,  1769,
       0,     0,  1769,     0,  1769,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1769,     0,     0,  1769,
    1769,     0,     0,     0,  1769,  1769,     0,     0,     0,  4752,
       0,  1769,     0,     0,     0,     0,     0,     0,  1184,  1184,
    1184,   941,     0,     0,  4195,  4774,     0,     0,     0,  4774,
    4788,  4774,     0,     0,     0,     0,  1769,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2520,     0,     0,  2521,  2522,  2523,     0,  2524,
    2525,  2526,  2527,  2528,  2529,     0,     0,  2501,     0,     0,
    2502,     0,     0,  1769,  2503,  2504,  2505,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3494,     0,  1769,
       0,  2506,     0,     0,     0,     0,     0,     0,     0,  2508,
       0,     0,     0,     0,     0,     0,  2509,     0,     0,     0,
    1527,     0,     0,     0,  1527,  1527,     0,  4849,  2406,  2406,
       0,  3000,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2510,     0,     0,     0,     0,     0,     0,  1283,  1283,
    1283,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2830,     0,     0,
       0,     0,     0,     0,     0,     0,  1527,     0,     0,     0,
       0,     0,     0,     0,     0,  4905,     0,     0,     0,     0,
    1527,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1527,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2511,     0,     0,     0,     0,  2512,     0,     0,
       0,  2501,     0,     0,  2502,     0,     0,     0,  2503,  2504,
    2505,     0,     0,     0,     0,     0,     0,     0,     0,  2513,
    2514,     0,     0,     0,     0,  2506,     0,     0,  4118,     0,
     883,     0,  4994,  2508,  2515,     0,     0,     0,     0,     0,
    2509,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2510,     0,  1283,     0,     0,
       0,     0,     0,  2516,     0,     0,   883,     0,     0,     0,
    1184,     0,  1283,     0,  1769,     0,     0,  2517,     0,     0,
    2518,  1184,     0,     0,     0,     0,     0,  5041,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2830,  4086,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1184,     0,     0,  1143,  4195,     0,     0,     0,
       0,     0,     0,  1143,     0,  1143,  3789,     0,     0,     0,
       0,     0,     0,     0,     0,  5090,     0,     0,   883,     0,
       0,     0,     0,     0,     0,  1184,     0,     0,     0,  3000,
       0,     0,     0,     0,     0,     0,  1769,  1769,     0,     0,
       0,     0,     0,     0,     0,     0,  2511,  2519,     0,     0,
       0,  2512,  1527,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3983,  3983,
    3983,  3983,  3983,  2513,  2514,  3694,     0,  3694,     0,     0,
       0,     0,     0,     0,  1184,     0,     0,     0,  2515,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1769,     0,     0,     0,     0,     0,     0,  2516,     0,     0,
       0,     0,  1769,     0,  1527,     0,     0,  1527,     0,     0,
       0,  2517,     0,     0,  2518,     0,     0,  2520,     0,     0,
    2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,  2528,  2529,
       0,     0,  1769,     0,     0,  1769,     0,     0,     0,     0,
       0,     0,     0,  1769,  1769,     0,     0,     0,     0,     0,
    1769,  1769,     0,     0,     0,  1769,     0,     0,     0,     0,
       0,  1769,     0,     0,  1769,  1769,     0,     0,     0,  1769,
    5208,     0,     0,     0,     0,  1769,  1184,  1184,  1184,  1184,
       0,     0,     0,  4774,  4788,  4774,     0,  1769,  4774,     0,
       0,  5222,     0,     0,     0,  4195,     0,     0,     0,  4195,
       0,  2519,     0,     0,     0,  5237,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1322,     0,     0,     0,     0,     0,     0,
       0,     0,  1769,     0,     0,     0,  4251,     0,     0,  1527,
       0,  3494,     0,  2501,     0,     0,  2502,     0,     0,     0,
    2503,  2504,  2505,     0,     0,     0,  1527,     0,     0,     0,
       0,  1105,     0,     0,  1769,     0,     0,  2506,     0,     0,
       0,  1527,     0,     0,     0,  2508,     0,     0,     0,     0,
       0,     0,  2509,     0,  3694,  3694,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2520,     0,  2830,  2521,  2522,  2523,  2510,  2524,  2525,
    2526,  2527,  2528,  2529,     0,     0,     0,     0,  5314,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1769,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1283,     0,     0,     0,     0,     0,  4123,
       0,     0,     0,     0,     0,     0,     0,     0,  1283,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2511,     0,
       0,     0,     0,  2512,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1769,     0,     0,  2513,  2514,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   941,     0,
    2515,     0,     0,     0,  2830,     0,     0,     0,     0,     0,
       0,     0,     0,  2406,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1769,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2516,
       0,  1283,     0,  3928,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2517,  1527,     0,  2518,  1527,     0,  1527,
       0,     0,     0,     0,  1527,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1184,     0,
       0,  5457,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2501,     0,     0,  2502,     0,     0,
       0,  2503,  2504,  2505,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1527,     0,     0,     0,     0,  2506,     0,
       0,  4129,     0,     0,     0,     0,  2508,     0,     0,     0,
    1769,     0,  1527,  2509,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2519,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1527,  2510,  1769,
    1769,     0,     0,  1769,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   941,     0,
       0,  4774,     0,     0,     0,  4195,     0,     0,     0,   883,
    4195,     0,     0,  4195,   941,     0,  3789,   943,  5511,     0,
    1769,  1769,     0,     0,     0,     0,   943,     0,     0,     0,
       0,     0,     0,     0,   943,     0,     0,   943,     0,     0,
       0,     0,  4849,     0,  1769,     0,     0,  1527,     0,  1527,
       0,     0,     0,     0,     0,     0,  4849,  1322,  1283,     0,
    1283,     0,     0,  2520,     0,     0,  2521,  2522,  2523,     0,
    2524,  2525,  2526,  2527,  2528,  2529,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2501,  2511,
       0,  2502,     0,     0,  2512,  2503,  2504,  2505,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1295,
    1322,     0,  2506,     0,     0,     0,  2513,  2514,     0,     0,
    2508,     0,     0,     0,     0,     0,     0,  2509,     0,     0,
       0,  2515,     0,     0,     0,     0,     0,     0,   943,     0,
    1527,     0,     0,  1530,     0,     0,     0,   943,     0,     0,
       0,     0,  2510,  1295,   943,     0,  1184,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5041,  1530,
    2516,  1184,     0,     0,     0,     0,  1184,     0,  3694,     0,
       0,  1527,     0,     0,  2517,  2830,     0,  2518,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1184,     0,     0,     0,  5090,     0,     0,  5671,
    1527,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1283,  1184,  4849,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1769,     0,     0,  1769,     0,  1769,     0,     0,     0,
       0,     0,     0,  2511,     0,     0,     0,     0,  2512,     0,
       0,     0,     0,     0,  2519,  1769,   943,   943,     0,  1527,
       0,  1769,     0,  1143,     0,  4195,     0,  1143,     0,  5511,
    2513,  2514,     0,     0,     0,  1769,     0,     0,     0,     0,
    1527,     0,     0,     0,  5738,  2515,     0,     0,     0,     0,
       0,     0,     0,   943,     0,     0,  1527,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1184,
       0,  2406,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2516,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1769,  2517,     0,
       0,  2518,  1769,  1769,     0,     0,     0,  1283,  1283,  1283,
    1283,     0,     0,     0,  2520,     0,     0,  2521,  2522,  2523,
       0,  2524,  2525,  2526,  2527,  2528,  2529,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1769,     0,     0,     0,     0,     0,     0,   941,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1527,     0,     0,     0,     0,     0,     0,     0,  1184,
       0,     0,  4195,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1527,     0,     0,     0,  2519,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1143,
    1143,     0,     0,     0,     0,     0,     0,     0,     0,  1527,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4670,     0,     0,   943,   943,   883,     0,     0,     0,     0,
    1769,     0,   943,   941,     0,     0,  1769,     0,     0,  1530,
    5891,     0,     0,   943,     0,  1527,     0,  1769,     0,   943,
       0,  1769,   943,  1769,     0,  1769,     0,     0,     0,     0,
       0,     0,  4849,     0,  1530,     0,     0,     0,     0,     0,
    1322,     0,     0,     0,     0,     0,     0,     0,     0,  1530,
       0,  1769,     0,     0,     0,     0,     0,     0,  2520,     0,
       0,  2521,  2522,  2523,     0,  2524,  2525,  2526,  2527,  2528,
    2529,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2406,  2406,     0,     0,
       0,     0,     0,   943,   943,   943,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1283,     0,     0,
       0,     0,     0,     0,  5970,     0,     0,     0,  1769,     0,
       0,     0,     0,     0,     0,     0,  1527,     0,  5982,  1530,
    2501,     0,     0,  2502,     0,     0,     0,  2503,  2504,  2505,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5457,     0,     0,  2506,     0,     0,  4726,  1769,  1769,
    1769,     0,  2508,     0,  3789,     0,     0,  1769,     0,  2509,
       0,     0,     0,     0,     0,     0,     0,  1769,     0,     0,
    5738,     0,     0,     0,     0,  3494,     0,     0,     0,     0,
       0,     0,     0,     0,  2510,     0,     0,     0,     0,  1295,
       0,     0,     0,  2501,     0,     0,  2502,     0,   943,     0,
    2503,  2504,  2505,     0,  1283,     0,     0,     0,     0,     0,
       0,  2406,     0,     0,     0,  1527,     0,  2506,     0,     0,
       0,     0,     0,     0,     0,  2508,     0,     0,     0,     0,
       0,     0,  2509,     0,     0,     0,     0,  2830,     0,     0,
    1527,     0,   941,     0,     0,     0,     0,     0,  1769,     0,
       0,     0,     0,     0,     0,     0,  1530,  2510,  4849,     0,
       0,     0,     0,     0,  1295,  1295,     0,  1769,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1769,     0,     0,
       0,  5891,     0,     0,     0,     0,     0,     0,     0,   943,
       0,     0,     0,     0,     0,  2511,     0,     0,     0,     0,
    2512,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   943,
       0,     0,  2513,  2514,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5982,  1283,  1283,  2515,     0,     0,
    4849,     0,     0,     0,     0,     0,     0,   943,   943,   943,
       0,   943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1769,  2511,     0,
       0,   943,  1769,  2512,  1527,     0,  2516,     0,  1769,     0,
       0,     0,     0,  1769,     0,     0,     0,     0,     0,     0,
    2517,     0,     0,  2518,     0,  2513,  2514,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2515,     0,     0,  1769,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1769,  1527,   956,  1527,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1283,     0,
       0,  4849,   957,     0,     0,     0,     0,     0,     0,  2516,
    5891,     0,     0,   943,   941,     0,     0,   943,   943,     0,
       0,     0,     0,  2517,     0,   958,  2518,     0,     0,     0,
       0,     0,   943,     0,     0,     0,  1295,  1295,   959,     0,
    2519,     0,     0,     0,     0,     0,     0,     0,     0,   960,
       0,     0,     0,  -871,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   961,     0,     0,     0,     0,     0,   962,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   963,     0,     0,     0,     0,     0,
       0,     0,  1530,     0,     0,   964,     0,     0,   883,     0,
       0,     0,     0,  2519,   965,     0,     0,     0,  1143,     0,
       0,     0,     0,     0,     0,     0,   966,  1527,     0,     0,
       0,     0,     0,     0,   967,     0,     0,  1527,   968,     0,
    2520,     0,     0,  2521,  2522,  2523,     0,  2524,  2525,  2526,
    2527,  2528,  2529,     0,     0,     0,     0, -1107,     0,  1143,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1530,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   969,     0,     0,     0,     0,     0,
       0,     0,     0,  -588,     0,     0,  1530,     0,     0,     0,
       0,     0,     0,  2520,     0,  1143,  2521,  2522,  2523,     0,
    2524,  2525,  2526,  2527,  2528,  2529,     0,     0,     0,     0,
       0,     0,  1143,     0,     0,     0,     0,     0,     0,  1530,
       0,     0,     0,   970,     0,     0,   971,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1527,     0,     0,   972,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     973,     0,     0,     0,     0,     0,     0,  -461,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1527,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,   975,     0,   943,   943,   943,
       0,     0,  -461,     0,     0,   976,  1527,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1530,     0,
       0,     0,     0,     0,   977,     0,     0,     0,     0,     0,
       0,   978,     0,     0,     0,  1530,     0,  -461,     0,     0,
     979,   980,     0,   981,   982,     0,     0,     0,   883,     0,
       0,     0,     0,  1530,   983,     0,     0,     0,     0,   984,
       0,     0,     0,     0,     0,     0,   985,     0,     0,   986,
       0,     0,   987,     0,  1527,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -461,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1529,     0,     0,     0,     0,  1530,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,     0,   943,     0,     0,  1530,     0,
    1529,     0,     0,     0,     0,   943,     0,     0,     0,     0,
       0,  1530,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1530,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   943,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   943,     0,     0,   943,     0,     0,     0,     0,     0,
       0,     0,     0,  1530,  1530,     0,     0,  1527,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1527,     0,     0,     0,     0,
       0,     0,   943,     0,     0,   943,   943,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   943,   943,     0,     0,     0,     0,   943,
     943,     0,     0,     0,     0,     0,   943,   943,   943,     0,
       0,   943,     0,   943,     0,   943,   943,   943,   943,   943,
     943,     0,   943,     0,   943,   943,     0,     0,   943,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1530,   943,   943,   943,   943,   883,     0,     0,
       0,   943,     0,     0,  1017,   943,     0,     0,   943,  1018,
       0,   943,   943,   943,   943,   943,   943,   943,   943,   943,
       0,   943,     0,     0,     0,     0,     0,     0,     0,   943,
       0,     0,   943,     0,     0,     0,     0,     0,     0,  1527,
       0,     0,     0,     0,  1019,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1020,     0,     0,
       0,     0,     0,     0,     0,     0,  1371,     0,     0,     0,
       0,  1372,  1021,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2156,     0,     0,     0,     0,     0,
    1022,     0,     0,   943,     0,     0,     0,     0,     0,     0,
    1529,     0,     0,     0,     0,     0,  1373,     0,   943,     0,
       0,     0,     0,  1023,     0,     0,     0,   943,   943,  1374,
    1375,     0,     0,     0,  1024,  1529,     0,     0,     0,     0,
    1376,     0,     0,  1025,  1377,     0,     0,     0,     0,     0,
    1529,     0,     0,     0,     0,  1026,     0,     0,     0,     0,
    1027,     0,  1378,     0,     0,     0,     0,  1028,     0,     0,
       0,     0,     0,     0,     0,  1527,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1379,  1029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1380,     0,     0,     0,
       0,     0,     0,  1527,     0,  1381,     0,     0,     0,  1530,
       0,     0,     0,  1530,  1530,     0,     0,  1382,     0,     0,
       0,     0,  1383,     0,     0,   883,     0,     0,     0,     0,
       0,     0,  1030,     0,     0,     0,     0,     0,     0,     0,
    1529,     0,  1527,     0,     0,     0,     0,     0,  1384,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   943,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   943,  1031,  1385,     0,  1530,     0,     0,   943,     0,
       0,   943,   943,     0,     0,  1032,     0,     0,     0,  1530,
       0,     0,     0,     0,  1386,  1033,     0,     0,  1527,     0,
       0,     0,     0,  1527,  1527,   913,  1034,     0,     0,  1035,
       0,     0,     0,     0,  1143,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1530,     0,     0,     0,  1387,  1036,     0,     0,  1037,     0,
       0,     0,  1038,     0,  1039,     0,     0,     0,     0,     0,
       0,  1040,   883,     0,  1041,     0,   883,  1388,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   913,  1389,     0,
       0,  1390,     0,  1042,     0,     0,     0,  1529,     0,   883,
    1043,     0,     0,     0,     0,     0,  1044,     0,     0,  1045,
       0,     0,     0,  1046,     0,  1143,     0,  1391,     0,     0,
    1392,  1047,     0,  1048,  1393,     0,  1394,     0,  1049,     0,
       0,     0,     0,  1395,     0,     0,  1396,     0,     0,     0,
    1527,  1050,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1051,  1397,     0,     0,     0,     0,
     883,     0,  1398,     0,     0,     0,     0,     0,  1399,     0,
       0,  1400,     0,     0,     0,  1401,     0,     0,     0,     0,
       0,     0,     0,  1402,     0,  1403,     0,     0,   883,     0,
    1404,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,   943,   943,     0,  1405,     0,   943,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,  1530,     0,     0,     0,     0,     0,     0,     0,     0,
     883,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   897,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   898,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1530,   899,     0,  1530,     0,     0,     0,
       0,     0,  1527,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   900,     0,   943,     0,     0,     0,   901,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   902,     0,     0,     0,     0,
       0,     0,     0,  2719,     0,     0,   903,     0,     0,     0,
       0,     0,     0,     0,     0,   904,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   905,     0,     0,
       0,     0,   906,     0,     0,     0,     0,     0,     0,   907,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   908,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2719,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   909,     0,     0,     0,     0,  1530,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,   910,  1530,     0,  1529,   943,     0,
       0,   943,     0,     0,   943,     0,     0,     0,     0,     0,
    1530,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,     0,     0,     0,     0,   943,     0,     0,     0,     0,
    1529,     0,     0,     0,   911,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   943,
     943,   943,     0,     0,   943,     0,     0,   912,     0,     0,
       0,     0,   943,   943,   943,   943,     0,   913,   914,     0,
     883,   915,     0,     0,     0,   943,   883,     0,   943,     0,
     943,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   943,   943,     0,     0,   943,     0,   916,     0,     0,
     917,     0,     0,     0,   918,     0,   919,     0,  2156,  2156,
    2156,     0,     0,   920,     0,   943,   921,   943,     0,   943,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1529,
       0,     0,     0,     0,     0,   922,     0,     0,     0,   943,
       0,     0,   923,     0,     0,     0,  1529,   924,   925,     0,
     943,   926,     0,     0,     0,   927,     0,     0,     0,     0,
       0,     0,     0,     0,  1529,   928,     0,     0,     0,     0,
     929,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,   930,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   931,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   943,     0,     0,     0,     0,     0,     0,     0,     0,
    1529,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1529,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1529,  1530,     0,     0,  1530,     0,  1530,     0,
       0,     0,     0,  1530,  1529,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1529,  1529,     0,     0,     0,     0,
       0,     0,  1530,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1530,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1530,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   883,   883,   883,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1530,     0,  1530,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1529,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2156,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1530,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   943,     0,     0,     0,
       0,     0,   943,     0,     0,     0,     0,     0,     0,     0,
    1530,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   883,  1530,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   883,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1530,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3524,     0,     0,     0,  2719,  3530,     0,     0,     0,  1530,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1530,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1529,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1529,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1529,     0,     0,     0,     0,     0,   943,     0,     0,
    1530,     0,     0,     0,     0,     0,   943,     0,     0,     0,
       0,     0,     0,     0,   943,     0,   943,     0,     0,   943,
       0,     0,     0,  1530,   943,   943,   943,   943,     0,     0,
     943,   943,   943,   943,   943,   943,   943,   943,   943,   943,
       0,     0,     0,   943,   943,   939,     0,     0,  1530,     0,
       0,     0,     0,   943,     0,     0,     0,   943,     0,   883,
       0,   943,     0,     0,     0,     0,     0,     0,     0,   943,
       0,     0,   943,     0,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1530,     0,   943,     0,     0,   943,
     943,     0,     0,     0,   943,   943,     0,     0,     0,     0,
       0,   943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   943,     0,     0,   943,     0,     0,  1141,     0,     0,
       0,     0,     0,     0,     0,  1141,   943,  1141,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2156,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   943,
       0,     0,  1529,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1530,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2719,     0,     0,  2719,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   883,     0,
       0,     0,     0,   883,  1530,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   883,  1530,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   883,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1529,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1529,     0,     0,     0,
       0,     0,     0,     0,   943,     0,     0,     0,     0,     0,
       0,  1529,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1530,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   943,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1530,     0,  1530,   943,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1518,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,     0,   943,     0,     0,     0,     0,
       0,     0,     0,   943,   943,     0,  1530,     0,     0,     0,
     943,   943,     0,     0,     0,   943,  1530,     0,     0,     0,
       0,   943,     0,     0,   943,   943,     0,     0,     0,   943,
       0,     0,     0,     0,  2719,   943,     0,  3530,     0,  3530,
       0,     0,     0,     0,  2719,     0,     0,   943,     0,     0,
       0,     0,     0,     0,     0,   943,     0,     0,     0,   943,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,  1529,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1529,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2719,     0,     0,
       0,     0,  1530,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   939,
       0,     0,     0,     0,     0,   883,     0,     0,   939,     0,
       0,     0,     0,     0,     0,     0,   939,     0,     0,   939,
       0,     0,     0,  1530,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1530,     0,  1529,     0,  1529,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1530,     0,     0,     0,     0,     0,     0,
     939,     0,  1518,     0,     0,  1528,     0,     0,     0,   939,
       0,     0,     0,     0,     0,     0,   939,  1518,     0,   939,
    1529,     0,   943,     0,     0,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,     0,     0,     0,     0,  2156,     0,     0,
       0,     0,     0,  2156,     0,     0,     0,     0,     0,     0,
       0,  1529,     0,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3530,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,     0,     0,  1530,     0,  1530,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   939,   939,
       0,     0,     0,     0,     0,  1141,     0,     0,     0,  1141,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1529,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,     0,     0,     0,  1530,   939,     0,     0,     0,     0,
    3530,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1529,     0,     0,   943,
     943,     0,     0,   943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,     0,     0,   943,     0,     0,     0,     0,
     943,     0,     0,   943,   943,     0,     0,     0,     0,     0,
     943,   943,     0,     0,  1518,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   943,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1529,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1530,     0,
       0,  1141,  1141,     0,  1529,     0,     0,     0,     0,   943,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   939,   939,     0,     0,  1529,
       0,     0,     0,     0,   939,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,   939,     0,     0,   883,     0,
       0,   939,     0,   943,   939,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1529,  1528,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,  1530,   939,   939,   939,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   943,  1530,     0,   943,     0,   943,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,   943,     0,     0,     0,     0,
       0,   943,     0,     0,     0,   943,  2719,     0,     0,     0,
       0,  1530,     0,     0,     0,   943,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1518,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   883,     0,
       0,     0,     0,     0,     0,     0,     0,  1530,     0,     0,
     939,     0,  1530,  1530,     0,     0,     0,   943,     0,     0,
       0,     0,   943,   943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,     0,     0,     0,  3530,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,     0,     0,     0,     0,     0,     0,   943,  1528,     0,
    3530,     0,     0,     0,  1518,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,     0,     0,     0,     0,     0,     0,
       0,   939,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1530,  1530,
       0,   939,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,     0,     0,   943,     0,     0,   943,     0,     0,   939,
     939,   939,     0,   939,     0,     0,     0,   943,     0,     0,
       0,   943,     0,   943,     0,   943,     0,     0,     0,     0,
       0,     0,   943,   939,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   943,     0,     0,  1529,     0,  1518,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1518,     0,     0,   883,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1518,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3530,     0,  2719,     0,     0,     0,
       0,     0,     0,     0,     0,   939,     0,     0,     0,   939,
     939,     0,     0,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,     0,   939,     0,     0,     0,   943,     0,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1518,     0,   943,   943,
     943,     0,     0,     0,     0,     0,     0,   943,   883,  1518,
       0,  1530,     0,     0,     0,     0,     0,   943,     0,     0,
       0,  1518,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1528,     0,     0,     0,     0,   943,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1141,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1518,  1518,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1529,     0,     0,
       0,  1141,   943,     0,     0,     0,     0,     0,   943,     0,
       0,  1528,     0,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,     0,   943,   943,     0,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1528,     0,
       0,     0,     0,     0,     0,     0,     0,  1141,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1141,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   943,     0,     0,     0,     0,     0,
     943,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1529,     0,     0,     0,   943,     0,     0,
    1518,     0,   943,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,   943,     0,     0,     0,     0,     0,     0,
       0,     0,   883,     0,     0,     0,     0,     0,     0,   939,
     939,   939,     0,     0,  1529,     0,     0,     0,     0,     0,
       0,     0,     0,   943,     0,     0,     0,     0,     0,     0,
    1528,     0,     0,   943,     0,     0,  1529,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1528,     0,     0,
       0,   943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   943,  1528,   883,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   883,     0,   943,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1529,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   939,     0,     0,   939,     0,     0,
    1528,     0,     0,     0,     0,     0,     0,   939,     0,     0,
       0,     0,     0,  1528,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1528,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   939,   939,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,  1518,  1518,   939,     0,     0,   939,     0,     0,     0,
       0,     0,     0,     0,     0,  1528,  1528,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5447,     0,  1529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1518,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,     0,     0,   939,     0,     0,   939,   939,     0,
       0,     0,     0,     0,     0,  1529,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1518,     0,
       0,     0,     0,     0,     0,   939,   939,     0,     0,     0,
       0,   939,   939,     0,     0,     0,     0,     0,   939,   939,
     939,     0,     0,   939,     0,   939,     0,   939,   939,   939,
     939,   939,   939,     0,   939,     0,   939,   939,     0,     0,
     939,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1528,   939,   939,   939,   939,     0,
       0,     0,     0,   939,     0,     0,     0,   939,     0,     0,
     939,     0,     0,   939,   939,   939,   939,   939,   939,   939,
     939,   939,     0,   939,     0,     0,     0,     0,     0,     0,
       0,   939,     0,     0,   939,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3530,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   939,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     939,     0,     0,     0,     0,     0,     0,     0,     0,   939,
     939,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1518,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3530,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,  1528,  1528,     0,     0,     0,
       0,     0,     0,  1529,     0,     0,     0,     0,     0,     0,
       0,  1518,     0,     0,  1518,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   939,  1529,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   939,     0,     0,     0,  1528,     0,     0,
     939,     0,     0,   939,   939,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1141,     0,  1529,     0,
       0,     0,     0,  1529,  1529,     0,     0,     0,     0,     0,
       0,     0,  1528,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1518,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1518,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1141,  1518,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5447,
    1529,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   939,   939,   939,     0,     0,     0,
     939,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   939,  1528,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   939,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1528,     0,     0,  1528,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   939,     0,     0,     0,
       0,  1518,  1529,     0,  1518,     0,  1518,     0,     0,     0,
       0,  1518,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1518,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1518,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1518,     0,     0,     0,     0,     0,
    1528,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   939,     0,     0,  1528,     0,     0,
     939,     0,     0,   939,     0,     0,   939,     0,     0,     0,
       0,     0,  1528,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   939,     0,     0,     0,     0,   939,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1518,     0,  1518,     0,     0,     0,
       0,   939,   939,   939,     0,     0,   939,     0,     0,     0,
       0,     0,     0,     0,   939,   939,   939,   939,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   939,     0,     0,
     939,     0,   939,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   939,   939,     0,     0,   939,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   939,     0,   939,
       0,   939,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,   939,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   939,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1518,     0,
       0,     0,     0,     0,   939,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   939,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,     0,   939,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1528,     0,     0,  1528,     0,
    1528,     0,     0,     0,     0,  1528,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1518,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   939,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1520,  1518,  1528,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1528,     0,     0,     0,     0,  1520,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1528,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1518,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1528,     0,
    1528,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1518,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1518,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1518,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   939,     0,
       0,     0,     0,     0,   939,     0,     0,     0,     0,     0,
       0,     0,  1528,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1521,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1518,     0,     0,     0,     0,     0,     0,
       0,  1521,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   944,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1528,     0,     0,     0,     0,     0,     0,     0,  1520,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1520,     0,     0,     0,  1528,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1520,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1518,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1520,   939,
       0,     0,  1528,     0,     0,     0,     0,     0,   939,     0,
       0,     0,     0,     0,     0,     0,   939,     0,   939,     0,
       0,   939,     0,     0,     0,  1528,   939,   939,   939,   939,
       0,     0,   939,   939,   939,   939,   939,   939,   939,   939,
     939,   939,     0,     0,     0,   939,   939,     0,     0,     0,
    1528,     0,     0,     0,     0,   939,     0,     0,     0,   939,
       0,     0,     0,   939,     0,     0,     0,     0,     0,     0,
       0,   939,     0,     0,   939,     0,   939,     0,     0,     0,
       0,  1518,     0,     0,     0,     0,  1528,     0,   939,     0,
       0,   939,   939,     0,     0,     0,   939,   939,     0,     0,
       0,     0,     0,   939,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   939,     0,     0,   939,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   939,     0,
       0,  1518,     0,  1518,     0,  1520,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1521,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   939,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1521,     0,     0,     0,
       0,   939,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1521,     0,     0,     0,     0,     0,  1528,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   939,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1518,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1518,     0,     0,     0,     0,     0,
       0,  1521,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1528,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1518,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1520,     0,     0,     0,     0,     0,     0,  1521,     0,
       0,     0,     0,     0,     0,     0,   939,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1518,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1528,     0,     0,     0,     0,
       0,     0,     0,  1518,     0,     0,     0,     0,   939,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1520,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1528,     0,  1528,   939,   939,
       0,     0,     0,     0,     0,  1520,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1518,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1520,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   939,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   944,     0,   939,     0,     0,     0,     0,     0,
       0,   944,     0,     0,     0,     0,     0,     0,     0,   944,
       0,     0,   944,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   939,     0,     0,   939,     0,     0,
       0,     0,     0,     0,     0,   939,   939,  1520,  1528,     0,
       0,     0,   939,   939,  1518,     0,     0,   939,  1528,     0,
       0,     0,     0,   939,  1520,     0,   939,   939,     0,     0,
       0,   939,     0,     0,     0,     0,     0,   939,     0,     0,
       0,     0,  1520,     0,     0,     0,     0,     0,     0,   939,
       0,     0,     0,     0,     0,     0,     0,   939,     0,     0,
       0,   939,     0,     0,  1521,     0,     0,     0,     0,     0,
       0,     0,  1518,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,     0,     0,     0,     0,  1531,     0,
       0,     0,   944,     0,   939,     0,     0,     0,  1520,   944,
       0,     0,   944,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1531,     0,     0,  1520,     0,     0,
       0,     0,     0,     0,     0,     0,   939,     0,     0,     0,
    1520,  1521,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1520,     0,  1528,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1521,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1520,  1520,     0,  1528,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1521,     0,     0,     0,     0,     0,  1528,     0,     0,
       0,     0,     0,     0,     0,     0,  1518,     0,     0,     0,
       0,   944,   944,     0,     0,     0,     0,     0,     0,     0,
     939,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   944,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1528,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1521,     0,     0,     0,   939,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1521,     0,     0,
     939,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1521,     0,     0,     0,     0,
       0,  1520,  1518,     0,     0,     0,     0,     0,     0,     0,
     939,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1518,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1521,     0,     0,     0,     0,  1528,     0,  1528,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1518,
    1521,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1521,     0,     0,     0,     0,   944,   944,
       0,     0,     0,     0,     0,  1521,     0,   944,     0,     0,
       0,     0,     0,     0,  1531,     0,     0,     0,   944,     0,
       0,     0,   939,     0,   944,     0,  1528,   944,     0,     0,
       0,     0,     0,     0,     0,  1518,     0,     0,     0,  1531,
    1518,  1518,     0,     0,     0,  1521,  1521,     0,     0,     0,
       0,   939,   939,     0,  1531,   939,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     939,     0,     0,     0,     0,     0,     0,   939,     0,     0,
       0,     0,   939,     0,     0,   939,   939,     0,     0,     0,
       0,     0,   939,   939,     0,     0,     0,     0,   944,   944,
     944,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   939,     0,   939,     0,  1520,     0,
       0,     0,  1520,  1520,     0,     0,     0,     0,   939,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1518,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1528,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   939,     0,     0,  1520,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1520,     0,
       0,     0,     0,     0,  1521,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,     0,   939,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1520,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   939,     0,  1528,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   944,     0,     0,     0,     0,     0,
       0,     0,     0,   939,  1528,     0,   939,     0,   939,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   944,     0,     0,   939,     0,     0,
       0,     0,     0,   939,     0,     0,     0,   939,     0,  1518,
       0,     0,     0,  1528,     0,     0,     0,   939,     0,     0,
       0,     0,   944,   944,   944,     0,   944,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   944,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1521,     0,     0,     0,  1521,  1521,     0,     0,  1528,
       0,     0,     0,     0,  1528,  1528,     0,     0,     0,   939,
       0,     0,     0,     0,   939,   939,     0,     0,     0,     0,
    1520,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   939,     0,     0,     0,     0,  1521,   944,   939,
       0,     0,   944,   944,     0,     0,     0,     0,     0,     0,
       0,  1521,     0,     0,     0,     0,     0,   944,     0,     0,
       0,     0,     0,     0,   939,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1520,     0,     0,  1520,     0,     0,     0,     0,
       0,     0,  1521,     0,     0,     0,     0,     0,     0,     0,
    1528,  1528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   939,     0,     0,   939,     0,  1531,   939,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   939,
       0,     0,     0,   939,     0,   939,     0,   939,     0,     0,
       0,     0,     0,     0,   939,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   939,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1520,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1531,     0,     0,  1520,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1520,
     939,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     939,     0,     0,     0,  1531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     939,   939,   939,  1521,     0,     0,     0,     0,     0,   939,
       0,     0,     0,  1528,     0,     0,     0,     0,     0,   939,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   939,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   944,   944,   944,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1531,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1521,     0,     0,  1521,     0,
    1531,     0,     0,     0,   939,     0,     0,     0,     0,     0,
     939,     0,     0,     0,     0,     0,     0,     0,  1531,     0,
     939,     0,     0,     0,     0,     0,   939,   939,     0,   939,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   939,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   944,     0,     0,
     944,     0,     0,  1531,     0,     0,   939,     0,     0,     0,
     944,     0,   939,     0,     0,     0,  1531,     0,     0,     0,
       0,     0,  1520,     0,     0,  1520,     0,  1520,  1531,     0,
       0,     0,  1520,     0,     0,     0,     0,     0,     0,   939,
    1521,   944,   944,     0,   939,     0,     0,     0,     0,     0,
     939,     0,     0,     0,     0,   939,   944,  1521,     0,   944,
       0,     0,     0,     0,     0,     0,     0,     0,  1531,  1531,
       0,     0,  1521,     0,     0,     0,     0,     0,     0,     0,
       0,  1520,     0,     0,     0,   939,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   939,     0,     0,     0,     0,
    1520,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   939,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1520,   939,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   944,     0,     0,
     944,   944,     0,     0,     0,     0,     0,     0,   939,   939,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   944,   944,
       0,     0,     0,     0,   944,   944,     0,     0,     0,     0,
       0,   944,   944,   944,     0,  1520,   944,  1520,   944,     0,
     944,   944,   944,   944,   944,   944,     0,   944,     0,   944,
     944,     0,     0,   944,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1531,   944,   944,
     944,   944,     0,     0,     0,     0,   944,     0,     0,     0,
     944,     0,     0,   944,     0,     0,   944,   944,   944,   944,
     944,   944,   944,   944,   944,     0,   944,     0,     0,     0,
       0,     0,     0,     0,   944,     0,     0,   944,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1520,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1521,     0,     0,  1521,     0,
    1521,     0,     0,     0,     0,  1521,     0,     0,   944,  1520,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,     0,     0,     0,     0,     0,     0,
       0,     0,   944,   944,     0,     0,     0,     0,  1520,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1521,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1521,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1521,     0,
       0,     0,     0,     0,     0,     0,     0,  1520,     0,     0,
       0,     0,     0,     0,  1531,     0,     0,     0,  1531,  1531,
       0,     0,     0,     0,     0,     0,     0,     0,  1520,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1520,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   944,     0,     0,     0,  1521,     0,
    1521,     0,     0,     0,     0,     0,   944,     0,     0,     0,
    1531,     0,     0,   944,     0,     0,   944,   944,     0,     0,
       0,     0,     0,     0,  1531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1531,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1520,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1521,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1520,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1520,     0,     0,
       0,     0,  1521,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1521,     0,  1520,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   944,   944,   944,
    1521,     0,     0,   944,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1521,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   944,  1531,  1521,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1520,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   944,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1531,     0,
       0,  1531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   944,
       0,     0,  1521,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1520,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1521,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1520,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1521,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1521,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1531,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   944,     0,     0,
    1531,     0,     0,   944,     0,     0,   944,     0,     0,   944,
       0,     0,     0,     0,     0,  1531,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   944,     0,     0,     0,     0,
     944,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1520,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   944,   944,   944,     0,     0,   944,
       0,     0,     0,     0,     0,     0,     0,   944,   944,   944,
     944,     0,     0,     0,     0,     0,     0,  1521,     0,     0,
     944,     0,     0,   944,     0,   944,     0,     0,     0,     0,
       0,     0,  1520,     0,  1520,     0,   944,   944,     0,     0,
     944,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     944,     0,   944,     0,   944,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   944,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   944,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1521,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   944,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1521,   944,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   944,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1520,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1520,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1531,     0,
       0,  1531,     0,  1531,     0,     0,     0,     0,  1531,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   944,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1003,     0,     0,     0,     0,     0,     0,     0,     0,  1003,
       0,     0,     0,     0,     0,     0,     0,  1531,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1521,  1531,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1003,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1520,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1521,  1197,  1521,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1197,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1520,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1531,     0,  1531,  1520,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1520,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1531,     0,     0,     0,  1521,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1521,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   944,     0,     0,     0,     0,     0,   944,     0,     0,
       0,     0,     0,     0,     0,  1531,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1248,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1520,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1531,  1521,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1520,  1531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1531,     0,     0,     0,     0,  1521,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1521,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1521,     0,     0,     0,     0,
       0,     0,   944,     0,     0,  1531,     0,     0,     0,     0,
       0,   944,     0,     0,     0,     0,     0,     0,     0,   944,
       0,   944,     0,     0,   944,     0,     0,  1520,  1531,   944,
     944,   944,   944,     0,     0,   944,   944,   944,   944,   944,
     944,   944,   944,   944,   944,     0,     0,     0,   944,   944,
       0,     0,     0,  1531,     0,     0,     0,     0,   944,     0,
       0,     0,   944,     0,     0,     0,   944,     0,     0,     0,
       0,     0,     0,     0,   944,     0,     0,   944,     0,   944,
       0,     0,     0,     0,     0,     0,     0,  1003,  1003,  1531,
       0,   944,     0,     0,   944,   944,     0,     0,     0,   944,
     944,     0,     0,     0,     0,     0,   944,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   944,     0,  1521,   944,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   944,     0,     0,     0,  1248,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1520,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1521,     0,   944,     0,
       0,  1520,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   944,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1531,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1520,     0,   944,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1289,     0,     0,     0,
       0,     0,     0,     0,  1324,     0,     0,  1326,     0,     0,
    1331,  1332,     0,  1335,     0,  1338,  1520,     0,  1344,     0,
    1346,  1520,  1520,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1531,
       0,     0,     0,     0,     0,     0,     0,  1427,     0,     0,
    1521,     0,     0,     0,  1439,  1440,     0,     0,  1446,     0,
    1449,  1450,     0,     0,  1531,  1452,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1248,     0,  1003,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1557,     0,  1559,  1520,     0,
       0,     0,     0,     0,     0,     0,  1573,  1575,     0,     0,
       0,     0,     0,     0,     0,     0,  1003,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   944,
       0,     0,     0,     0,     0,     0,  1521,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1531,     0,
       0,     0,     0,     0,  1521,  1523,     0,     0,     0,     0,
       0,   944,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1248,     0,  1521,     0,     0,     0,     0,  1531,     0,
    1531,   944,   944,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1197,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1521,
       0,     0,     0,     0,  1521,  1521,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1520,     0,     0,     0,     0,   944,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   944,     0,     0,
    1920,     0,     0,  1921,     0,  1924,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1967,     0,     0,     0,     0,     0,     0,   944,     0,     0,
     944,     0,     0,     0,     0,     0,     0,     0,   944,   944,
       0,  1531,     0,     0,     0,   944,   944,     0,     0,     0,
     944,  1531,     0,     0,     0,     0,   944,     0,     0,   944,
     944,     0,     0,     0,   944,     0,     0,     0,     0,     0,
     944,  1521,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   944,     0,     0,     0,  2139,     0,     0,     0,
     944,     0,     0,     0,   944,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2169,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2180,     0,     0,     0,     0,  2183,     0,   944,     0,     0,
       0,     0,     0,     0,     0,  2186,     0,     0,     0,     0,
    2190,     0,     0,     0,     0,     0,     0,     0,     0,  2193,
       0,     0,     0,     0,  2200,     0,     0,  2204,     0,   944,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1531,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2258,     0,
       0,     0,   731,     0,     0,     0,     0,   775,     0,   775,
       0,  1523,     0,     0,     0,     0,     0,     0,  1531,   775,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1523,     0,     0,     0,
    1531,     0,     0,     0,   775,     0,     0,     0,     0,     0,
       0,  1523,     0,     0,     0,   775,     0,     0,     0,     0,
       0,     0,     0,   944,     0,     0,   775,   775,     0,     0,
     775,     0,     0,  1521,     0,     0,   775,     0,     0,     0,
    1097,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1097,     0,     0,     0,     0,     0,  1531,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   775,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   944,     0,     0,
       0,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2426,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,     0,     0,     0,  2442,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1531,
       0,  1531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1523,     0,
       0,     0,     0,     0,     0,   944,     0,     0,     0,  1531,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   944,   944,     0,     0,   944,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,     0,     0,     0,     0,     0,     0,
     944,     0,     0,     0,     0,   944,   775,     0,   944,   944,
       0,     0,     0,     0,     0,   944,   944,     0,     0,     0,
       0,  1197,  1573,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   944,     0,   944,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   944,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2682,     0,     0,  2682,     0,     0,
       0,     0,     0,  1531,     0,  2689,     0,     0,     0,     0,
       0,     0,     0,     0,   944,     0,     0,     0,     0,     0,
       0,  2697,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   944,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1753,  1753,     0,     0,     0,  2792,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   944,     0,  1531,
       0,     0,     0,     0,  1523,     0,     0,     0,     0,     0,
       0,     0,     0,  2881,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   944,  1531,     0,   944,
       0,   944,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   775,     0,     0,     0,     0,
     944,     0,     0,     0,     0,     0,   944,     0,     0,     0,
     944,     0,     0,     0,     0,     0,  1531,     0,     0,     0,
     944,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   775,   775,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1523,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1531,     0,     0,     0,     0,  1531,  1531,     0,
       0,     0,   944,     0,     0,     0,     0,   944,   944,     0,
       0,  1523,   775,     0,     0,     0,     0,  2153,  2157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   944,     0,     0,     0,  3043,
       0,     0,   944,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   944,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1523,     0,     0,  1531,  1531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1523,     0,     0,
       0,     0,     0,     0,     0,   944,     0,     0,   944,     0,
       0,   944,     0,     0,     0,  1523,     0,     0,     0,     0,
       0,     0,   944,     0,     0,     0,   944,     0,   944,     0,
     944,     0,     0,     0,     0,     0,     0,   944,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3170,     0,
    3171,     0,     0,     0,     0,     0,   944,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1573,  3182,     0,  3183,
       0,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1523,     0,     0,     0,     0,     0,     0,     0,  1474,   775,
       0,   775,     0,  1523,     0,     0,     0,     0,     0,  3205,
       0,     0,     0,     0,     0,  1523,     0,     0,     0,     0,
       0,  1573,     0,     0,     0,  1573,     0,     0,     0,  1573,
       0,     0,  1573,   944,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1523,  1523,     0,     0,   775,
       0,     0,   775,   775,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,   944,   944,     0,   731,     0,  1097,
       0,  1097,   944,     0,     0,     0,  1531,   731,     0,     0,
       0,   775,   944,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2457,     0,     0,     0,     0,     0,     0,
       0,  1097,  1097,     0,   944,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1524,
       0,     0,     0,  2472,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1524,     0,  3423,   775,     0,
     775,  2490,  2491,  2492,     0,  2495,     0,   944,     0,     0,
       0,     0,     0,   944,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,     0,  2537,     0,     0,     0,   944,
     944,     0,   944,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   944,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1523,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   731,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   731,   731,     0,     0,  1902,     0,   944,
       0,     0,     0,     0,     0,   944,     0,  2614,     0,     0,
       0,  2626,  2631,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   944,     0,     0,     0,     0,   944,     0,     0,
     731,     0,  1248,   944,     0,     0,     0,     0,   944,     0,
       0,     0,     0,     0,     0,  3520,  3521,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3536,  3537,     0,     0,   944,  3540,
    3541,     0,     0,     0,  3544,     0,     0,     0,   944,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3555,     0,
       0,     0,     0,     0,     0,  3564,   944,     0,     0,  3567,
    3568,     0,     0,  3571,  3572,     0,     0,     0,     0,   944,
    3577,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3596,     0,  3598,     0,     0,
       0,   944,   944,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3621,     0,     0,     0,     0,
    3623,  1523,     0,     0,     0,  1523,  1523,     0,     0,     0,
       0,     0,     0,     0,     0,  3629,     0,     0,     0,     0,
       0,     0,     0,     0,  3636,     0,     0,  3640,     0,  3642,
    3645,  3647,     0,     0,     0,     0,  3655,  3658,     0,     0,
       0,     0,     0,     0,     0,     0,  3671,     0,     0,     0,
       0,  3680,     0,     0,     0,  3683,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1524,     0,  1523,     0,     0,
    3700,     0,     0,     0,     0,     0,  3709,  3710,     0,     0,
       0,  1523,     0,  3715,     0,     0,     0,     0,     0,     0,
    1524,     0,     0,  3729,  3730,     0,     0,     0,     0,  3734,
       0,     0,     0,     0,     0,  1524,     0,     0,     0,     0,
       0,  3741,     0,     0,  3744,     0,     0,     0,     0,  3747,
       0,     0,  1523,     0,     0,  3750,  3751,     0,     0,     0,
       0,  3755,     0,     0,  3759,     0,     0,     0,  3766,  3767,
    3768,  3769,     0,  3771,     0,     0,     0,     0,     0,     0,
       0,  2153,  2153,  2153,     0,     0,  3796,  3797,     0,  3799,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3808,  3809,  3810,     0,     0,   731,     0,     0,     0,     0,
     775,     0,   775,     0,     0,   775,     0,   775,     0,     0,
     775,   775,   775,     0,     0,  1524,  2401,     0,     0,     0,
       0,     0,     0,   775,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   775,     0,   775,
       0,     0,     0,     0,   775,     0,     0,     0,     0,     0,
       0,     0,     0,  3863,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3900,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,  1524,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2547,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   775,   775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     731,     0,     0,     0,     0,   731,   731,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1248,     0,
       0,   731,     0,     0,     0,  1523,     0,     0,  1523,     0,
       0,     0,     0,  1573,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3293,     0,     0,   775,     0,   731,     0,
       0,     0,     0,     0,     0,  3313,  4061,  3314,  2686,  3316,
       0,     0,  3328,  3331,  3336,     0,     0,     0,     0,  3342,
       0,     0,  3347,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3354,  3355,  3356,
    3357,     0,     0,     0,     0,  3364,     0,     0,     0,  3382,
       0,     0,  3384,     0,     0,  3391,  3392,  3393,  3394,  3395,
    3396,  3397,  3398,  3399,     0,  3400,     0,     0,     0,     0,
    1523,     0,     0,  1753,     0,     0,  2153,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   731,  1523,     0,     0,
       0,     0,     0,     0,     0,     0,   731,     0,     0,     0,
       0,     0,  1523,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3445,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1524,     0,
       0,     0,     0,  1300,     0,     0,     0,     0,     0,     0,
       0,  2491,  2492,     0,     0,  1334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1353,     0,     0,   731,
       0,     0,   731,   731,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1368,     0,     0,     0,     0,     0,
    1416,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1524,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1524,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1573,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   731,  1524,     0,     0,     0,     0,
       0,     0,     0,  3569,     0,     0,     0,     0,  4298,     0,
       0,     0,  4300,     0,     0,     0,     0,     0,  4302,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4313,  4315,     0,     0,
       0,  4315,     0,     0,     0,     0,  4326,  4327,  4328,     0,
       0,     0,     0,     0,     0,  1523,     0,     0,  1523,     0,
    1523,     0,     0,     0,     0,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4357,  4358,  4359,  4360,     0,     0,     0,     0,
       0,     0,     0,     0,  1524,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1524,     0,     0,  1523,     0,     0,  1790,     0,  4378,
       0,  4382,  4383,  4384,     0,     0,     0,     0,     0,  1524,
       0,     0,     0,  1523,     0,     0,  1814,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1523,  1838,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1524,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     775,     0,   775,     0,  1524,     0,   775,     0,   775,     0,
       0,   775,     0,     0,     0,   775,     0,  1524,     0,     0,
    2547,     0,     0,     0,     0,     0,     0,     0,  1523,  1524,
    1523,     0,     0,     0,     0,  4457,  3820,  3821,  2153,     0,
       0,     0,  3825,     0,  4463,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2033,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1524,
    1524,     0,     0,     0,  3854,  4477,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4520,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4557,     0,     0,     0,     0,  1003,     0,  2401,     0,     0,
       0,     0,  1523,     0,  3424,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2686,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2209,     0,     0,     0,     0,  4602,
       0,  1523,     0,     0,     0,  1003,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2247,  2250,  2251,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1524,     0,
    4629,     0,  4630,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1573,     0,     0,     0,  1526,     0,     0,     0,     0,     0,
    1523,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4655,     0,     0,     0,     0,
    1526,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   731,     0,     0,  1523,   731,     0,
       0,     0,     0,     0,  3509,     0,  1902,     0,     0,   775,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4066,     0,     0,     0,     0,  4072,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   731,     0,     0,
       0,     0,     0,     0,     0,  2495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3336,     0,  3336,  3336,
       0,     0,     0,     0,     0,     0,  1790,     0,     0,  4132,
       0,     0,  4135,     0,  4137,     0,     0,     0,     0,     0,
       0,     0,  1523,     0,     0,     0,     0,     0,     0,  2441,
       0,     0,     0,     0,     0,     0,     0,     0,  1790,     0,
       0,     0,     0,     0,     0,  1523,     0,     0,     0,  4158,
       0,  4161,     0,  4163,     0,  1524,     0,     0,     0,  1524,
    1524,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1523,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1523,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2614,     0,     0,     0,
       0,  1524,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2631,     0,     0,     0,  1524,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4860,     0,  4861,     0,
       0,   731,     0,     0,     0,  4863,     0,     0,     0,   731,
       0,     0,   731,     0,     0,     0,     0,     0,     0,     0,
       0,  4873,     0,     0,   731,     0,  1524,     0,     0,     0,
       0,     0,     0,  4879,     0,     0,     0,  4882,  2591,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4904,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4284,     0,
       0,     0,     0,  4908,     0,     0,     0,  1523,  4912,     0,
    1526,     0,     0,     0,  2647,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4947,     0,  1526,     0,  4951,     0,     0,
       0,     0,     0,     0,     0,  4956,  4957,  4958,  4959,     0,
    1526,     0,     0,     0,  4964,  4965,  4966,  4967,     0,     0,
       0,  4969,  4970,     0,     0,     0,     0,  4977,  4978,     0,
    4980,  4981,  4982,  4983,  4984,  4985,  4986,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4995,     0,     0,     0,
    4998,  4999,  5000,  5001,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1523,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4315,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2531,     0,     0,
       0,  1523,     0,     0,     0,  5024,     0,     0,     0,     0,
    1526,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1524,     0,     0,
    2824,     0,     0,     0,     0,     0,     0,     0,     0,  2847,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2882,     0,     0,
    2531,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2905,     0,     0,  2908,     0,   775,  2401,     0,     0,     0,
       0,     0,     0,     0,     0,  4315,     0,     0,     0,  1524,
       0,     0,  1524,   731,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2153,     0,     0,     0,     0,  1523,  2153,     0,  1573,  1573,
    1573,  1573,  1573,     0,     0,     0,  2958,  1526,     0,     0,
       0,  5148,     0,     0,     0,     0,     0,     0,     0,     0,
    2977,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1523,     0,  1523,     0,     0,
    3001,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3052,     0,     0,  1524,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1524,     0,     0,     0,     0,     0,     0,     0,     0,
    3095,     0,     0,     0,     0,     0,  1524,  3108,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2686,     0,
       0,     0,     0,   731,     0,     0,     0,     0,  1523,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1523,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5295,     0,     0,     0,  5296,  5297,  5298,  5299,
       0,  4671,     0,  5301,     0,     0,     0,     0,     0,     0,
    4675,     0,     0,     0,  3193,     0,     0,  2531,  4677,     0,
    4678,  2531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5321,  5322,  5323,
    5324,  5325,     0,  5327,  5328,     0,     0,  4702,  4703,     0,
       0,     0,     0,  1526,     0,  5337,  5338,     0,     0,     0,
       0,     0,     0,  1790,  1790,  3342,     0,     0,     0,     0,
       0,     0,     0,  4729,     0,     0,  4732,     0,  4734,     0,
       0,     0,     0,  3251,  1523,  5343,     0,     0,     0,     0,
    4739,     0,     0,  1573,  1573,     0,  1573,     0,  4746,  4747,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1526,     0,     0,     0,     0,  1523,     0,     0,     0,     0,
    4793,     0,     0,     0,     0,     0,     0,     0,     0,  1524,
       0,     0,  1524,     0,  1524,     0,     0,  1523,     0,  1524,
       0,     0,     0,     0,     0,     0,     0,  1526,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4811,     0,     0,
       0,     0,     0,  3418,     0,     0,     0,     0,     0,  5407,
    1526,     0,     0,  4824,     0,     0,     0,     0,  1524,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3430,
       0,     0,     0,     0,     0,  1523,     0,  1524,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1838,  1524,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1838,  1838,     0,     0,     0,     0,     0,  5463,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1790,     0,     0,  1526,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1526,     0,     0,     0,
       0,     0,  1524,     0,  1524,     0,     0,     0,     0,     0,
       0,  2531,     0,     0,  1526,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2531,     0,  1523,     0,
    3324,     0,     0,     0,     0,  1573,     0,     0,     0,     0,
       0,     0,     0,     0,  2531,  2531,  2531,     0,     0,  2531,
    1573,     0,     0,     0,     0,     0,     0,     0,   731,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1526,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1523,     0,     0,  1526,
       0,  2531,     0,     0,     0,  1524,     0,     0,     0,     0,
       0,     0,  1526,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1526,     0,     0,     0,     0,     0,
       0,     0,   775,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5565,     0,     0,     0,  1524,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5575,     0,     0,  1526,  1526,  5580,  5581,     0,     0,
       0,     0,   775,     0,     0,  1524,  5592,     0,  2531,  3639,
       0,     0,     0,  5594,     0,     0,     0,     0,     0,     0,
    2531,     0,     0,     0,  3661,  2531,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3688,     0,     0,     0,     0,     0,  5644,
    5111,  5112,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5661,
    1523,  1003,     0,     0,  1524,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5678,     0,     0,     0,
       0,     0,     0,   731,     0,  1524,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4315,     0,     0,     0,
       0,  1524,     0,     0,     0,     0,     0,  5701,     0,  3764,
    3765,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5163,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5169,     0,     0,     0,
    1573,     0,     0,  1526,     0,     0,     0,     0,     0,     0,
       0,  1573,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5740,     0,  5187,  5189,     0,
       0,     0,     0,     0,  5193,  5194,  1523,     0,     0,  5195,
       0,     0,     0,     0,     0,  5198,  5757,     0,  5201,  5202,
       0,     0,     0,  5206,     0,     0,  1524,     0,  5765,  5210,
       0,     0,     0,     0,  1523,     0,  3889,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1524,
       0,     0,     0,  1573,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1523,  1524,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1753,     0,     0,     0,
       0,     0,     0,  5824,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1524,     0,     0,  3509,     0,     0,     0,     0,  5274,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1523,
       0,     0,     0,     0,  1523,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4315,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1526,     0,     0,     0,  1526,  1526,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1573,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5915,     0,  5340,   731,     0,     0,     0,     0,     0,     0,
       0,  1524,     0,     0,     0,  5928,  1526,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   731,     0,
    1526,  1523,     0,     0,     0,   731,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   731,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5957,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1526,     0,     0,  5968,     0,  5378,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1524,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1524,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6030,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4177,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6052,     0,     0,     0,     0,  1838,
       0,     0,   731,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5485,  5486,     0,     0,  5487,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1524,
       0,   731,  1526,     0,     0,     0,     0,  2531,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6119,  5522,  5523,     0,  2531,  2531,     0,
    2531,     0,     0,  3324,  3324,     0,  4109,     0,  3324,     0,
       0,     0,  2531,     0,     0,  2531,     0,     0,  5537,  1524,
    2531,  1524,     0,     0,     0,     0,  2531,     0,     0,     0,
       0,  2531,     0,     0,     0,     0,     0,     0,  2531,  2531,
    2531,  2531,     0,     0,     0,  3324,  3324,     0,  2531,     0,
       0,     0,     0,     0,  1526,     0,     0,  1526,     0,     0,
       0,     0,     0,     0,     0,     0,  2531,     0,  2531,     0,
       0,     0,     0,     0,     0,  2531,  2531,  2531,  2531,  2531,
    2531,  2531,  2531,  2531,  2531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2686,  2531,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1524,     0,     0,     0,     0,     0,     0,  4400,
       0,     0,  1524,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1526,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1526,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   731,     0,     0,     0,
       0,  1526,   731,     0,     0,     0,   731,     0,  3342,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2531,     0,  5723,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1524,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5772,     0,     0,     0,     0,  4523,  4524,  4525,  1524,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4534,     0,     0,     0,     0,     0,     0,
       0,  1524,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5809,     0,  4550,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4560,  4562,     0,     0,
       0,  4567,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1524,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1526,     0,     0,  1526,     0,  1526,
       0,     0,     0,     0,  1526,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5522,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2531,  2531,     0,  4654,     0,  2531,
    1790,     0,     0,     0,     0,  5917,     0,     0,     0,     0,
       0,     0,     0,  1526,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2531,     0,
       0,     0,  1526,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1524,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1526,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   775,     0,     0,     0,     0,     0,
       0,     0,  5971,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1524,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6000,  6000,  6000,     0,     0,  1526,     0,  1526,
       0,     0,     0,  4760,  4761,  4762,     0,   731,     0,     0,
       0,  5522,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1526,     0,  6062,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   775,     0,
    2531,  6000,     0,     0,  1524,     0,  2531,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1526,     0,     0,  4109,  4109,     0,     0,  3324,  3324,
    3324,  3324,     0,     0,  3324,  3324,  3324,  3324,  3324,  3324,
    3324,  3324,  3324,  3324,  4109,     0,     0,     0,     0,     0,
    1526,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2531,     0,     0,  2531,
       0,  2531,     0,     0,  4109,  4109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2531,  3324,  3324,  2531,     0,  2531,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6154,     0,     0,     0,     0,     0,     0,  1526,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1524,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1526,     0,     0,     0,     0,     0,     0,  6000,     0,     0,
       0,     0,     0,     0,     0,     0,  1526,  6181,  1524,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   731,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1524,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5021,     0,     0,  2531,     0,
       0,     0,     0,     0,     0,     0,  5034,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1524,     0,     0,     0,  5065,  1524,  1524,
       0,  1526,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   731,     0,
       0,     0,     0,     0,  1526,     0,     0,     0,     0,     0,
    3108,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1526,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1526,     0,     0,     0,  3193,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1524,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3324,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1526,     0,     0,     0,
       0,  5211,  5212,  5213,  5214,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1526,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1524,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1526,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2531,     0,     0,     0,  2531,
       0,  2531,  2531,     0,     0,     0,     0,     0,  4109,  4109,
    4109,  4109,     0,     0,     0,     0,  4109,  4109,  4109,  4109,
    4109,  4109,  4109,  4109,  4109,  4109,  2531,  2531,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2531,     0,     0,  2531,     0,  2531,     0,
       0,     0,     0,  2531,     0,     0,  4109,  4109,     0,     0,
    2531,  2531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1526,     0,     0,  2531,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2531,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2531,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1526,     0,  1526,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5450,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1526,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1526,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4109,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2531,  2531,     0,     0,     0,
       0,     0,     0,  1526,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5616,     0,     0,  1526,     0,     0,  2531,     0,     0,
       0,     0,     0,  2531,  3324,     0,  5629,     0,     0,     0,
       0,  1790,     0,     0,     0,     0,  1526,     0,     0,     0,
       0,  2531,     0,  2531,     0,     0,     0,  2531,  2531,  2531,
       0,     0,  2531,     0,     0,  2531,  2531,  5666,     0,     0,
    2531,     0,     0,     0,  2531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1526,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2531,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    81,    82,     0,    84,    85,    86,
       0,     0,     0,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,     0,     0,     0,   101,   102,
     103,   104,     0,   105,   106,   107,   108,     0,   109,   110,
     111,     0,     0,     0,  5753,     0,   114,   115,     0,     0,
       0,     0,   116,     0,  2531,     0,     0,     0,     0,     0,
       0,   117,     0,   118,     0,   119,     0,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1526,     0,     0,
       0,     0,  2531,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   126,     0,     0,     0,   128,   129,   130,
     131,   132,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   134,     0,     0,     0,     0,     0,
       0,   138,     0,   139,  5831,  1526,     0,     0,     0,     0,
     142,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   145,     0,     0,     0,     0,     0,     0,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   149,
     150,     0,     0,     0,  4109,  3324,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2531,
    2531,  2531,     0,     0,     0,     0,     0,     0,   156,  3324,
       0,     0,     0,     0,     0,     0,   158,     0,     0,     0,
       0,   160,     0,     0,     0,     0,     0,   162,     0,     0,
       0,     0,     0,   163,     0,   164,  2531,  2531,     0,     0,
       0,     0,   166,     0,   167,     0,     0,     0,     0,     0,
       0,  2531,     0,   168,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   170,   171,
       0,     0,     0,     0,     0,   172,     0,   173,     0,     0,
     174,   175,     0,   176,     0,     0,     0,     0,     0,  1526,
       0,     0,   177,   178,     0,   179,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   184,   185,
     186,     0,     0,     0,     0,     0,     0,     0,   187,   188,
       0,     0,     0,     0,   190,     0,     0,   191,     0,   192,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   193,   194,     0,   195,   196,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   197,     0,   198,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     207,     0,     0,     0,     0,  1526,   209,  4109,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3324,     0,     0,  4109,     0,   214,     0,  2531,   216,     0,
       0,   217,     0,  1526,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   219,     0,     0,
       0,     0,     0,     0,   221,     0,     0,     0,     0,     0,
       0,     0,   222,   223,     0,     0,     0,     0,   224,     0,
     225,     0,  1526,     0,     0,     0,  2531,     0,     0,     0,
     228,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   232,     0,     0,   233,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2531,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,     0,     0,     0,  1526,     0,
       0,     0,     0,  1526,  1526,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3501,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4109,
       0,  3324,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1526,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2531,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2531,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3324,     0,     0,     0,     0,  3324,     0,     0,     0,
       0,   785,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
     786,    98,    99,   740,   787,     0,   101,   102,   103,   104,
     788,   789,   106,   107,   108,     0,   109,   790,   791,   741,
     742,     0,  1526,  4109,   743,   744,  4109,     0,  2531,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,  2531,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   792,   437,   438,   439,   793,   794,
     795,   796,   797,   798,   799,   440,   441,   800,   442,   443,
     444,   126,   445,   446,   447,   128,   129,   130,   131,   132,
     801,   448,   449,   450,   451,   452,   453,   802,   803,   454,
     455,   804,   134,   456,   805,   457,   458,   459,   460,   138,
     806,   139,   807,   461,   462,   463,   464,   465,   142,   466,
     467,   808,   809,   468,   469,   470,   471,   472,   473,   810,
     145,   474,   475,   811,   812,   813,   814,   146,   815,   816,
     817,   477,   478,   479,   480,   754,   481,   149,   150,   482,
     818,   483,   819,   484,   485,   486,   487,   488,   489,   820,
     490,   491,   492,   493,   821,   822,   494,   495,   496,   497,
     498,   823,   499,   500,   501,   824,   502,   503,   504,   825,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
     826,   513,   827,   514,   515,   162,   516,   828,   517,   829,
     518,   163,   830,   164,   519,   520,   521,   522,   831,   523,
     166,   832,   167,   524,   525,   833,   526,   527,   756,   528,
     529,   168,   530,   531,   532,   533,   834,   534,   535,   536,
     537,   538,   539,   540,   835,   541,   170,   171,   836,   542,
     543,   544,   837,   172,   838,   173,   839,   545,   174,   175,
     546,   176,   547,   548,   549,   550,   551,   840,   841,   552,
     177,   178,   553,   179,   842,   554,   555,   556,   843,   844,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,   185,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,   845,
     579,   580,   190,   581,   846,   191,   582,   192,   583,   584,
     585,   847,   586,   587,   848,   849,   588,   589,   590,   850,
     851,   591,   592,   193,   194,   593,   195,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   852,   603,   604,
     197,   605,   198,   606,   607,   608,   853,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,   854,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   855,   635,   636,   207,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,   856,   650,   651,   652,   653,   654,
     857,   656,   657,   214,   658,   659,   216,   660,   661,   217,
     662,   858,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,   859,   677,   678,
     860,   679,   221,   680,   681,   682,   683,   684,   861,   685,
     222,   223,   862,   863,   687,   688,   224,   689,   225,   864,
     690,   691,   692,   693,   694,   695,   696,   697,   865,   866,
     698,   699,   700,   701,   702,   867,   868,   703,   704,   705,
     706,   707,   869,   232,   870,   708,   233,   709,   710,   711,
     712,   871,   872,   713,   873,   874,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,     0,    80,     0,     0,
      81,    82,    83,    84,    85,    86,    87,     0,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,  1057,    98,
      99,   100,     0,     0,   101,   102,   103,   104,     0,   105,
     106,   107,   108,     0,   109,   110,   111,   112,   113,     0,
       0,     0,   114,   115,     0,     0,     0,     0,   116,     0,
       0,     0,     0,     0,     0,     0,     0,   117,     0,   118,
       0,   119,   120,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   121,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   122,     0,   123,   124,     0,     0,
       0,     0,     0,     0,     0,     0,   125,     0,     0,   126,
       0,     0,   127,   128,   129,   130,   131,   132,     0,     0,
       0,   133,     0,     0,     0,     0,     0,     0,     0,     0,
     134,     0,     0,   135,     0,   136,   137,   138,     0,   139,
       0,     0,   140,     0,   141,     0,   142,     0,     0,     0,
       0,     0,     0,     0,     0,   143,     0,   144,   145,     0,
       0,     0,     0,     0,     0,   146,     0,     0,     0,     0,
       0,     0,   147,     0,   148,   149,   150,   151,     0,     0,
       0,     0,     0, -1700,     0,     0,     0,     0,     0,     0,
       0,   152,     0,   153,     0,     0,     0,   154,     0,     0,
       0,     0,     0,   155,   156,     0,     0,     0,     0,     0,
       0,   157,   158,   159,     0,     0,     0,   160,     0,     0,
     161,     0,     0,   162,     0,     0,     0,     0,     0,   163,
       0,   164,     0,     0,     0,     0,   165,     0,   166,     0,
     167,     0,     0,     0,     0,     0,     0,     0,     0,   168,
       0,     0,     0,   169,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   170,   171,     0,     0, -1700,     0,
       0,   172,     0,   173,     0,     0,   174,   175,     0,   176,
       0,     0,     0,     0,     0,     0,     0,     0,   177,   178,
       0,   179,     0,   180,   181,     0,     0,     0,     0,   182,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   183,     0,     0,   184,   185,   186,     0,     0,     0,
       0,     0,     0,     0,   187,   188,     0,     0,     0,   189,
     190,     0,     0,   191,     0,   192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   193,   194,     0,   195,   196,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   197,     0,
     198,     0,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,     0,     0,     0,
       0,     0,   202,   203,     0,   204,     0,     0,     0,     0,
     205,     0,     0,     0,     0,   206,   207,     0,   208,     0,
       0,     0,   209,     0,     0,   210,     0,     0,     0,     0,
       0,   211,   212,     0,     0,     0,     0,     0,     0,   213,
       0,   214,     0,   215,   216,     0,     0,   217,     0,     0,
       0,     0,     0,   218,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   219,     0,     0,     0,     0,   220,     0,
     221,     0,     0,     0,     0,     0,     0,     0,   222,   223,
       0,     0,     0,     0,   224,     0,   225,     0,   226,     0,
     227,     0,     0,     0,     0,     0,   228,     0,     0,   229,
       0,     0, -1700,     0,     0,   230,     0,     0,     0,     0,
     231,   232,     0,     0,   233,     0,     0,     0,     0,     0,
       0,     0,     0,   234,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,     0,     0,     0,     0,     0,   246,     0,     0,     0,
       0,     0,   785,    81,    82,   737,    84,    85,    86,   738,
     247,   739,    89,     0,  -147,    92,    93,    94,    95,    96,
      97,   786,    98,    99,   740,   787,     0,   101,   102,   103,
     104,   788,   789,   106,   107,   108,     0,   109,   790,   791,
     741,   742,     0,     0,     0,   743,   744,     0,     0,     0,
       0,   745,     0,     0,     0,     0,     0,     0,     0,     0,
     746,     0,   747,     0,   748,   749,    35,   428,     0,     0,
      37,     0,    38,    39,     0,  1671,  1672,  1673,    40,  1674,
       0,     0,     0,     0,     0,     0,     0,   429,   430,   431,
     432,   433,   434,   435,   436,  2147,   437,   438,   439,     0,
       0,     0,     0,  1675,     0,     0,   440,   441,     0,   442,
     443,   444,   126,   445,   446,   447,   128,  1676,   130,  1677,
    1678,     0,   448,   449,   450,   451,   452,   453,  1679,  1680,
     454,   455,  1681,  1682,   456,     0,   457,   458,   459,   460,
    1683,     0,  1684,     0,   461,   462,   463,   464,   465,   142,
     466,   467,   752,     0,   468,   469,   470,   471,   472,   473,
       0,   145,   474,   475,     0,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,   477,   478,   479,   480,   754,   481,  1692,  1693,
     482,  1694,   483,     0,   484,   485,   486,   487,   488,   489,
       0,   490,   491,   492,   493,  2148,     0,   494,   495,  1499,
     497,   498,     0,   499,   500,   501,     0,   502,   503,   504,
       0,   505,   506,   507,   508,  1695,   509,   510,   511,   512,
    1696,  1697,   513,     0,   514,   515,  1698,   516,     0,   517,
       0,   518,   163,     0,   164,   519,   520,   521,   522,     0,
     523,  1699,     0,  1700,   524,   525,     0,   526,   527,   756,
     528,   529,   168,   530,   531,   532,   533,     0,   534,   535,
     536,   537,   538,   539,   540,     0,   541,   170,   171,     0,
     542,   543,   544,  1502,  1701,     0,  1702,     0,   545,   174,
     175,   546,   176,   547,   548,   549,   550,   551,     0,     0,
     552,  1703,   178,   553,   179,     0,   554,   555,   556,  1704,
    1705,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     757,   566,   567,   758,   568,   569,   570,  1706,   185,  1707,
     571,   572,   573,   574,   575,   576,   577,   187,  1708,   578,
    1709,   579,   580,   190,   581,  1710,  1711,   582,  1712,   583,
     584,   585,     0,   586,   587,     0,     0,  1713,   589,   590,
       0,     0,   591,   592,   193,   194,   593,   195,  1714,   594,
     595,   596,   597,   598,   599,   600,   601,   602,     0,   603,
     604,  1715,   605,   198,   606,   607,   608,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,  1716,   619,
     620,   621,   622,     0,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,     0,   635,   636,   207,
     637,   638,   639,   640,   641,  1717,   642,   643,   644,   645,
     646,   647,   648,   759,   649,     0,   650,   651,   652,   653,
     654,  1718,   656,   657,   214,   658,   659,   216,   660,   661,
    1719,   662,     0,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,   674,   675,  1720,   676,     0,   677,
     678,     0,   679,   221,   680,   681,   682,   683,   684,     0,
     685,  1721,  1722,     0,     0,   687,   688,  1723,   689,  1724,
    1725,   690,   691,   692,   693,   694,   695,   696,   697,     0,
    1726,   698,   699,   700,   701,   702,  1727,     0,   703,   704,
     705,   706,   707,   760,  1728,  2149,   708,   233,   709,   710,
     711,   712,     0,     0,   713,     0,     0,   714,   715,   716,
     717,   718,   719,   235,  1729,  1730,  1731,  1732,   240,  1733,
    1734,  1735,  1736,   245,   761,   720,   721,  1737,     0,     0,
       0,     0,     0,     0,  1738,  1739,  2150,     0,     0,     0,
       0,     0,     0,  1741,  2151,   785,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,   786,    98,    99,   740,   787,     0,
     101,   102,   103,   104,   788,   789,   106,   107,   108,     0,
     109,   790,   791,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
     428,     0,     0,    37,     0,    38,    39,     0,  1671,  1672,
    1673,    40,  1674,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,  1675,     0,     0,   440,
     441,     0,   442,   443,   444,   126,   445,   446,   447,   128,
    1676,   130,  1677,  1678,     0,   448,   449,   450,   451,   452,
     453,  1679,  1680,   454,   455,  1681,  1682,   456,     0,   457,
     458,   459,   460,  1683,     0,  1684,     0,   461,   462,   463,
     464,   465,   142,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,   145,   474,   475,     0,  1685,  1686,
    1687,  1688,  1689,  1690,  1691,   477,   478,   479,   480,   754,
     481,  1692,  1693,   482,  1694,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,  1499,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,  1695,   509,
     510,   511,   512,  1696,  1697,   513,     0,   514,   515,  1698,
     516,     0,   517,     0,   518,   163,     0,   164,   519,   520,
     521,   522,     0,   523,  1699,     0,  1700,   524,   525,     0,
     526,   527,   756,   528,   529,   168,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     170,   171,     0,   542,   543,   544,  1502,  1701,     0,  1702,
       0,   545,   174,   175,   546,   176,   547,   548,   549,   550,
     551,     0,     0,   552,  1703,   178,   553,   179,     0,   554,
     555,   556,  1704,  1705,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
    1706,   185,  1707,   571,   572,   573,   574,   575,   576,   577,
     187,  1708,   578,  1709,   579,   580,   190,   581,  1710,  1711,
     582,  1712,   583,   584,   585,     0,   586,   587,     0,     0,
    1713,   589,   590,     0,     0,   591,   592,   193,   194,   593,
     195,  1714,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,  1715,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,  1716,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,   207,   637,   638,   639,   640,   641,  1717,   642,
     643,   644,   645,   646,   647,   648,   759,   649,   212,   650,
     651,   652,   653,   654,  1718,   656,   657,   214,   658,   659,
     216,   660,   661,  1719,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,  1720,
     676,     0,   677,   678,   220,   679,   221,   680,   681,   682,
     683,   684,     0,   685,  1721,  1722,     0,     0,   687,   688,
    1723,   689,  1724,  1725,   690,   691,   692,   693,   694,   695,
     696,   697,     0,  1726,   698,   699,   700,   701,   702,  1727,
       0,   703,   704,   705,   706,   707,  2493,  1728,     0,   708,
     233,   709,   710,   711,   712,     0,     0,   713,     0,   234,
     714,   715,   716,   717,   718,   719,   235,  1729,  1730,  1731,
    1732,   240,  1733,  1734,  1735,  1736,   245,   761,   720,   721,
    1737,     0,   246,     0,     0,     0,     0,  1738,  1739,     0,
       0,     0,     0,     0,     0,     0,  1741,  5734,   785,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,   786,    98,    99,
     740,   787,     0,   101,   102,   103,   104,   788,   789,   106,
     107,   108,     0,   109,   790,   791,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,   428,     0,     0,    37,     0,    38,    39,
       0,  1671,  1672,  1673,    40,  1674,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,  1675,
       0,     0,   440,   441,     0,   442,   443,   444,   126,   445,
     446,   447,   128,  1676,   130,  1677,  1678,     0,   448,   449,
     450,   451,   452,   453,  1679,  1680,   454,   455,  1681,  1682,
     456,     0,   457,   458,   459,   460,  1683,     0,  1684,     0,
     461,   462,   463,   464,   465,   142,   466,   467,   752,     0,
     468,   469,   470,   471,   472,   473,     0,   145,   474,   475,
       0,  1685,  1686,  1687,  1688,  1689,  1690,  1691,   477,   478,
     479,   480,   754,   481,  1692,  1693,   482,  1694,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,  1499,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,  1695,   509,   510,   511,   512,  1696,  1697,   513,     0,
     514,   515,  1698,   516,     0,   517,     0,   518,   163,     0,
     164,   519,   520,   521,   522,     0,   523,  1699,     0,  1700,
     524,   525,     0,   526,   527,   756,   528,   529,   168,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   170,   171,     0,   542,   543,   544,  1502,
    1701,     0,  1702,     0,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,     0,     0,   552,  1703,   178,   553,
     179,     0,   554,   555,   556,  1704,  1705,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,  1706,   185,  1707,   571,   572,   573,   574,
     575,   576,   577,   187,  1708,   578,  1709,   579,   580,   190,
     581,  1710,  1711,   582,  1712,   583,   584,   585,     0,   586,
     587,     0,     0,  1713,   589,   590,     0,     0,   591,   592,
     193,   194,   593,   195,  1714,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,  1715,   605,   198,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,  1716,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,   207,   637,   638,   639,   640,
     641,  1717,   642,   643,   644,   645,   646,   647,   648,   759,
     649,     0,   650,   651,   652,   653,   654,  1718,   656,   657,
     214,   658,   659,   216,   660,   661,  1719,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,  1720,   676,     0,   677,   678,     0,   679,   221,
     680,   681,   682,   683,   684,     0,   685,  1721,  1722,     0,
       0,   687,   688,  1723,   689,  1724,  1725,   690,   691,   692,
     693,   694,   695,   696,   697,     0,  1726,   698,   699,   700,
     701,   702,  1727,     0,   703,   704,   705,   706,   707,   760,
    1728,     0,   708,   233,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,   235,
    1729,  1730,  1731,  1732,   240,  1733,  1734,  1735,  1736,   245,
     761,   720,   721,  1737,     0,     0,     0,     0,     0,     0,
    1738,  1739,     0,     0,     0,     0,     0,     0,     0,  1741,
    3326,   785,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
     786,    98,    99,   740,   787,     0,   101,   102,   103,   104,
     788,   789,   106,   107,   108,     0,   109,   790,   791,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,   428,     0,     0,    37,
       0,    38,    39,     0,  1671,  1672,  1673,    40,  1674,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,  1675,     0,     0,   440,   441,     0,   442,   443,
     444,   126,   445,   446,   447,   128,  1676,   130,  1677,  1678,
       0,   448,   449,   450,   451,   452,   453,  1679,  1680,   454,
     455,  1681,  1682,   456,     0,   457,   458,   459,   460,  1683,
       0,  1684,     0,   461,   462,   463,   464,   465,   142,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
     145,   474,   475,     0,  1685,  1686,  1687,  1688,  1689,  1690,
    1691,   477,   478,   479,   480,   754,   481,  1692,  1693,   482,
    1694,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,  1499,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,  1695,   509,   510,   511,   512,  1696,
    1697,   513,     0,   514,   515,  1698,   516,     0,   517,     0,
     518,   163,     0,   164,   519,   520,   521,   522,     0,   523,
    1699,     0,  1700,   524,   525,     0,   526,   527,   756,   528,
     529,   168,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   170,   171,     0,   542,
     543,   544,  1502,  1701,     0,  1702,     0,   545,   174,   175,
     546,   176,   547,   548,   549,   550,   551,     0,     0,   552,
    1703,   178,   553,   179,     0,   554,   555,   556,  1704,  1705,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,  1706,   185,  1707,   571,
     572,   573,   574,   575,   576,   577,   187,  1708,   578,  1709,
     579,   580,   190,   581,  1710,  1711,   582,  1712,   583,   584,
     585,     0,   586,   587,     0,     0,  1713,   589,   590,     0,
       0,   591,   592,   193,   194,   593,   195,  1714,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
    1715,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,  1716,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,   207,   637,
     638,   639,   640,   641,  1717,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
    1718,   656,   657,   214,   658,   659,   216,   660,   661,  1719,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,  1720,   676,     0,   677,   678,
       0,   679,   221,   680,   681,   682,   683,   684,     0,   685,
    1721,  1722,     0,     0,   687,   688,  1723,   689,  1724,  1725,
     690,   691,   692,   693,   694,   695,   696,   697,     0,  1726,
     698,   699,   700,   701,   702,  1727,     0,   703,   704,   705,
     706,   707,   760,  1728,     0,   708,   233,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,  1729,  1730,  1731,  1732,   240,  1733,  1734,
    1735,  1736,   245,   761,   720,   721,  1737,     0,     0,     0,
       0,     0,     0,  1738,  1739,     0,     0,     0,     0,     0,
       0,     0,  1741,  4680,   785,    81,    82,   737,    84,    85,
      86,   738,     0,   739,    89,     0,     0,    92,    93,    94,
      95,    96,    97,   786,    98,    99,   740,   787,     0,   101,
     102,   103,   104,   788,   789,   106,   107,   108,     0,   109,
     790,   791,   741,   742,     0,     0,     0,   743,   744,     0,
       0,     0,     0,   745,     0,     0,     0,     0,     0,     0,
       0,     0,   746,     0,   747,     0,   748,   749,    35,   428,
       0,     0,    37,     0,    38,    39,     0,  1671,  1672,  1673,
      40,  1674,     0,     0,     0,     0,     0,     0,     0,   429,
     430,   431,   432,   433,   434,   435,   436,     0,   437,   438,
     439,     0,     0,     0,     0,  1675,     0,     0,   440,   441,
       0,   442,   443,   444,   126,   445,   446,   447,   128,  1676,
     130,  1677,  1678,     0,   448,   449,   450,   451,   452,   453,
    1679,  1680,   454,   455,  1681,  1682,   456,     0,   457,   458,
     459,   460,  1683,     0,  1684,     0,   461,   462,   463,   464,
     465,   142,   466,   467,   752,     0,   468,   469,   470,   471,
     472,   473,     0,   145,   474,   475,     0,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,   477,   478,   479,   480,   754,   481,
    1692,  1693,   482,  1694,   483,     0,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,     0,     0,   494,
     495,  1499,   497,   498,     0,   499,   500,   501,     0,   502,
     503,   504,     0,   505,   506,   507,   508,  1695,   509,   510,
     511,   512,  1696,  1697,   513,     0,   514,   515,  1698,   516,
       0,   517,     0,   518,   163,     0,   164,   519,   520,   521,
     522,     0,   523,  1699,     0,  1700,   524,   525,     0,   526,
     527,   756,   528,   529,   168,   530,   531,   532,   533,     0,
     534,   535,   536,   537,   538,   539,   540,     0,   541,   170,
     171,     0,   542,   543,   544,  1502,  1701,     0,  1702,     0,
     545,   174,   175,   546,   176,   547,   548,   549,   550,   551,
       0,     0,   552,  1703,   178,   553,   179,     0,   554,   555,
     556,  1704,  1705,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   757,   566,   567,   758,   568,   569,   570,  1706,
     185,  1707,   571,   572,   573,   574,   575,   576,   577,   187,
    1708,   578,  1709,   579,   580,   190,   581,  1710,  1711,   582,
    1712,   583,   584,   585,     0,   586,   587,     0,     0,  1713,
     589,   590,     0,     0,   591,   592,   193,   194,   593,   195,
    1714,   594,   595,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,  1715,   605,   198,   606,   607,   608,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
    1716,   619,   620,   621,   622,     0,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,     0,   635,
     636,   207,   637,   638,   639,   640,   641,  1717,   642,   643,
     644,   645,   646,   647,   648,   759,   649,     0,   650,   651,
     652,   653,   654,  1718,   656,   657,   214,   658,   659,   216,
     660,   661,  1719,   662,     0,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,   674,   675,  1720,   676,
       0,   677,   678,     0,   679,   221,   680,   681,   682,   683,
     684,     0,   685,  1721,  1722,     0,     0,   687,   688,  1723,
     689,  1724,  1725,   690,   691,   692,   693,   694,   695,   696,
     697,     0,  1726,   698,   699,   700,   701,   702,  1727,     0,
     703,   704,   705,   706,   707,   760,  1728,     0,   708,   233,
     709,   710,   711,   712,     0,     0,   713,     0,     0,   714,
     715,   716,   717,   718,   719,   235,  1729,  1730,  1731,  1732,
     240,  1733,  1734,  1735,  1736,   245,   761,   720,   721,  1737,
       0,     0,     0,     0,     0,     0,  1738,  1739,     0,     0,
       0,     0,     0,     0,     0,  1741,  4753,   785,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,   786,    98,    99,   740,
     787,     0,   101,   102,   103,   104,   788,   789,   106,   107,
     108,     0,   109,   790,   791,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447,     0,  1492,   130,  1493,  1494,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,  1495,  1496,   456,
       0,   457,   458,   459,   460,     0,     0,   139,     0,   461,
     462,   463,   464,   465,   142,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,     0,
       0,     0,     0,   146,     0,     0,     0,   477,   478,   479,
     480,   754,   481,  1497,  1498,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,  1499,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
       0,   509,   510,   511,   512,     0,     0,   513,     0,   514,
     515,  1500,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,     0,     0,     0,   524,
     525,     0,   526,   527,   756,   528,   529,   168,   530,   531,
     532,   533,  2705,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,  2706,     0,   542,   543,   544,  1502,  1503,
       0,  1504,     0,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,     0,   178,   553,   179,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,  1505,   185,  1506,   571,   572,   573,   574,   575,
     576,   577,     0,     0,   578,     0,   579,   580,   190,   581,
       0,     0,   582,  1507,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,  2708,
     194,   593,   195,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,     0,   605,     0,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,  1508,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,  2709,
     658,   659,   216,   660,   661,  1510,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,     0,   676,     0,   677,   678,     0,   679,   221,   680,
     681,   682,   683,   684,     0,   685,  1511,  1512,     0,     0,
     687,   688,     0,   689,     0,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,     0,  1513,
    2710,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   761,
     720,   721,     0,     0,     0,     0,     0,   785,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,  2818,
      92,    93,    94,    95,    96,    97,   786,    98,    99,   740,
     787,     0,   101,   102,   103,   104,   788,   789,   106,   107,
     108,     0,   109,   790,   791,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447,     0,  1492,   130,  1493,  1494,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,  1495,  1496,   456,
       0,   457,   458,   459,   460,     0,     0,   139,     0,   461,
     462,   463,   464,   465,   142,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,     0,
       0,     0,     0,   146,     0,     0,     0,   477,   478,   479,
     480,   754,   481,  1497,  1498,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,  1499,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
       0,   509,   510,   511,   512,     0,     0,   513,     0,   514,
     515,  1500,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,     0,     0,     0,   524,
     525,     0,   526,   527,   756,   528,   529,   168,   530,   531,
     532,   533,  2705,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,  2706,     0,   542,   543,   544,  1502,  1503,
       0,  1504,     0,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,     0,   178,   553,   179,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,  1505,   185,  1506,   571,   572,   573,   574,   575,
     576,   577,     0,     0,   578,     0,   579,   580,   190,   581,
       0,     0,   582,  1507,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,  2708,
     194,   593,   195,     0,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,     0,   605,     0,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,  1508,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
       0,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,  2709,
     658,   659,   216,   660,   661,  1510,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,     0,   676,     0,   677,   678,     0,   679,   221,   680,
     681,   682,   683,   684,     0,   685,  1511,  1512,     0,     0,
     687,   688,     0,   689,     0,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,     0,  1513,
    2710,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   761,
     720,   721,     0,     0,     0,     0,     0,   785,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,  3943,
      92,    93,    94,    95,    96,    97,   786,    98,    99,   740,
     787,     0,   101,   102,   103,   104,   788,   789,   106,   107,
     108,     0,   109,   790,   791,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,   428,     0,     0,    37,     0,    38,    39,     0,
    1671,  1672,  1673,    40,  1674,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,  1675,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447,   128,  1676,   130,  1677,  1678,     0,   448,   449,   450,
     451,   452,   453,  1679,  1680,   454,   455,  1681,  1682,   456,
       0,   457,   458,   459,   460,  1683,     0,  1684,     0,   461,
     462,   463,   464,   465,   142,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,     0,
    1685,  1686,  1687,  1688,  1689,  1690,  1691,   477,   478,   479,
     480,   754,   481,  1692,  1693,   482,  1694,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,  1499,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
    1695,   509,   510,   511,   512,  1696,  1697,   513,     0,   514,
     515,  1698,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,  1699,     0,  1700,   524,
     525,     0,   526,   527,   756,   528,   529,   168,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,   171,     0,   542,   543,   544,  1502,  1701,
       0,  1702,     0,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,  1703,   178,   553,   179,
       0,   554,   555,   556,  1704,  1705,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,  1706,   185,  1707,   571,   572,   573,   574,   575,
     576,   577,   187,  1708,   578,  1709,   579,   580,   190,   581,
    1710,  1711,   582,  1712,   583,   584,   585,     0,   586,   587,
       0,     0,  1713,   589,   590,     0,     0,   591,   592,   193,
     194,   593,   195,  1714,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,  1715,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,  1716,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
    1717,   642,   643,   644,   645,   646,   647,   648,   759,   649,
     212,   650,   651,   652,   653,   654,  1718,   656,   657,   214,
     658,   659,   216,   660,   661,  1719,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,  1720,   676,     0,   677,   678,   220,   679,   221,   680,
     681,   682,   683,   684,     0,   685,  1721,  1722,     0,     0,
     687,   688,  1723,   689,  1724,  1725,   690,   691,   692,   693,
     694,   695,   696,   697,     0,  1726,   698,   699,   700,   701,
     702,  1727,     0,   703,   704,   705,   706,   707,  2493,  1728,
       0,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,   234,   714,   715,   716,   717,   718,   719,   235,  1729,
    1730,  1731,  1732,   240,  1733,  1734,  1735,  1736,   245,   761,
     720,   721,  1737,     0,   246,     0,     0,     0,     0,  1738,
    1739,     0,     0,     0,     0,     0,     0,     0,  1741,   785,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,   786,    98,
      99,   740,   787,     0,   101,   102,   103,   104,   788,   789,
     106,   107,   108,     0,   109,   790,   791,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,   428,     0,     0,    37,     0,    38,
      39,     0,  1671,  1672,  1673,    40,  1674,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
    1675,     0,     0,   440,   441,     0,   442,   443,   444,   126,
     445,   446,   447,   128,  1676,   130,  1677,  1678,  3332,   448,
     449,   450,   451,   452,   453,  1679,  1680,   454,   455,  1681,
    1682,   456,     0,   457,   458,   459,   460,  1683,     0,  1684,
       0,   461,   462,   463,   464,   465,   142,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,   145,   474,
     475,     0,  1685,  1686,  1687,  1688,  1689,  1690,  1691,   477,
     478,   479,   480,   754,   481,  1692,  1693,   482,  1694,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,  1499,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,  1695,   509,   510,   511,   512,  1696,  1697,   513,
       0,   514,   515,  1698,   516,     0,   517,     0,   518,   163,
    3333,   164,   519,   520,   521,   522,     0,   523,  1699,     0,
    1700,   524,   525,     0,   526,   527,   756,   528,   529,   168,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   170,   171,     0,   542,   543,   544,
    1502,  1701,     0,  1702,     0,   545,   174,   175,   546,   176,
     547,   548,   549,   550,   551,     0,  3334,   552,  1703,   178,
     553,   179,     0,   554,   555,   556,  1704,  1705,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,  1706,   185,  1707,   571,   572,   573,
     574,   575,   576,   577,   187,  1708,   578,  1709,   579,   580,
     190,   581,  1710,  1711,   582,  1712,   583,   584,   585,     0,
     586,   587,     0,     0,  1713,   589,   590,     0,     0,   591,
     592,   193,   194,   593,   195,  1714,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,  1715,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,  1716,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,   207,   637,   638,   639,
     640,   641,  1717,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,  1718,   656,
     657,   214,   658,   659,   216,   660,   661,  1719,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,  1720,   676,     0,   677,   678,     0,   679,
     221,   680,   681,   682,   683,   684,     0,   685,  1721,  1722,
       0,  3335,   687,   688,  1723,   689,  1724,  1725,   690,   691,
     692,   693,   694,   695,   696,   697,     0,  1726,   698,   699,
     700,   701,   702,  1727,     0,   703,   704,   705,   706,   707,
     760,  1728,     0,   708,   233,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,  1729,  1730,  1731,  1732,   240,  1733,  1734,  1735,  1736,
     245,   761,   720,   721,  1737,     0,     0,     0,     0,     0,
       0,  1738,  1739,     0,     0,     0,     0,     0,     0,     0,
    1741,   785,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
     786,    98,    99,   740,   787,     0,   101,   102,   103,   104,
     788,   789,   106,   107,   108,     0,   109,   790,   791,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,   428,     0,     0,    37,
       0,    38,    39,     0,  1671,  1672,  1673,    40,  1674,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,  1675,     0,     0,   440,   441,     0,   442,   443,
     444,   126,   445,   446,   447,   128,  1676,   130,  1677,  1678,
       0,   448,   449,   450,   451,   452,   453,  1679,  1680,   454,
     455,  1681,  1682,   456,     0,   457,   458,   459,   460,  1683,
       0,  1684,     0,   461,   462,   463,   464,   465,   142,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
     145,   474,   475,     0,  1685,  1686,  1687,  1688,  1689,  1690,
    1691,   477,   478,   479,   480,   754,   481,  1692,  1693,   482,
    1694,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,  1499,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,  1695,   509,   510,   511,   512,  1696,
    1697,   513,     0,   514,   515,  1698,   516,     0,   517,     0,
     518,   163,     0,   164,   519,   520,   521,   522,     0,   523,
    1699,     0,  1700,   524,   525,     0,   526,   527,   756,   528,
     529,   168,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   170,   171,     0,   542,
     543,   544,  1502,  1701,     0,  1702,     0,   545,   174,   175,
     546,   176,   547,   548,   549,   550,   551,     0,     0,   552,
    1703,   178,   553,   179,     0,   554,   555,   556,  1704,  1705,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,  1706,   185,  1707,   571,
     572,   573,   574,   575,   576,   577,   187,  1708,   578,  1709,
     579,   580,   190,   581,  1710,  1711,   582,  1712,   583,   584,
     585,     0,   586,   587,     0,     0,  1713,   589,   590,     0,
       0,   591,   592,   193,   194,   593,   195,  1714,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
    1715,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,  1716,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,   207,   637,
     638,   639,   640,   641,  1717,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
    1718,   656,   657,   214,   658,   659,   216,   660,   661,  1719,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,  1720,   676,     0,   677,   678,
       0,   679,   221,   680,   681,   682,   683,   684,     0,   685,
    1721,  1722,     0,     0,   687,   688,  1723,   689,  1724,  1725,
     690,   691,   692,   693,   694,   695,   696,   697,     0,  1726,
     698,   699,   700,   701,   702,  1727,     0,   703,   704,   705,
     706,   707,   760,  1728,     0,   708,   233,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,  1729,  1730,  1731,  1732,   240,  1733,  1734,
    1735,  1736,   245,   761,   720,   721,  1737,     0,     0,     0,
       0,     0,     0,  1738,  1739,     0,     0,     0,     0,     0,
    2454,  3286,  1741,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,   428,     0,
       0,    37,     0,    38,    39,     0,  1671,  1672,  1673,    40,
    1674,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,  1675,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,   128,  1676,   130,
    1677,  1678,     0,   448,   449,   450,   451,   452,   453,  1679,
    1680,   454,   455,  1681,  1682,   456,     0,   457,   458,   459,
     460,  1683,     0,  1684,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,  1685,  1686,  1687,  1688,
    1689,  1690,  1691,   477,   478,   479,   480,   754,   481,  1692,
    1693,   482,  1694,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
    1499,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,  1695,   509,   510,   511,
     512,  1696,  1697,   513,     0,   514,   515,  1698,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,  1699,     0,  1700,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,  1502,  1701,     0,  1702,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,  1703,   178,   553,   179,     0,   554,   555,   556,
    1704,  1705,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,  1706,   185,
    1707,   571,   572,   573,   574,   575,   576,   577,   187,  1708,
     578,  1709,   579,   580,   190,   581,  1710,  1711,   582,  1712,
     583,   584,   585,     0,   586,   587,     0,     0,  1713,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,  1714,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,  1715,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,  1716,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,  1717,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,  1718,   656,   657,   214,   658,   659,   216,   660,
     661,  1719,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,  1720,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,  1721,  1722,     0,     0,   687,   688,  1723,   689,
    1724,  1725,   690,   691,   692,   693,   694,   695,   696,   697,
       0,  1726,   698,   699,   700,   701,   702,  1727,     0,   703,
     704,   705,   706,   707,   760,  1728,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,  1729,  1730,  1731,  1732,   240,
    1733,  1734,  1735,  1736,   245,   761,   720,   721,  1737,     0,
       0,     0,     0,     0,     0,  1738,  1739,  1740,     0,     0,
       0,     0,     0,     0,  1741,   785,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,   786,    98,    99,   740,   787,     0,
     101,   102,   103,   104,   788,   789,   106,   107,   108,     0,
     109,   790,   791,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
     428,     0,     0,    37,     0,    38,    39,     0,  1671,  1672,
    1673,    40,  1674,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,  2624,   437,
     438,   439,     0,     0,     0,     0,  1675,     0,     0,   440,
     441,     0,   442,   443,   444,   126,   445,   446,   447,   128,
    1676,   130,  1677,  1678,     0,   448,   449,   450,   451,   452,
     453,  1679,  1680,   454,   455,  1681,  1682,   456,     0,   457,
     458,   459,   460,  1683,     0,  1684,     0,   461,   462,   463,
     464,   465,   142,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,   145,   474,   475,     0,  1685,  1686,
    1687,  1688,  1689,  1690,  1691,   477,   478,   479,   480,   754,
     481,  1692,  1693,   482,  1694,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,  1499,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,  1695,   509,
     510,   511,   512,  1696,  1697,   513,     0,   514,   515,  1698,
     516,     0,   517,     0,   518,   163,     0,   164,   519,   520,
     521,   522,     0,   523,  1699,     0,  1700,   524,   525,     0,
     526,   527,   756,   528,   529,   168,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     170,   171,     0,   542,   543,   544,  1502,  1701,     0,  1702,
       0,   545,   174,   175,   546,   176,   547,   548,   549,   550,
     551,     0,     0,   552,  1703,   178,   553,   179,     0,   554,
     555,   556,  1704,  1705,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
    1706,   185,  1707,   571,   572,   573,   574,   575,   576,   577,
     187,  1708,   578,  1709,   579,   580,   190,   581,  1710,  1711,
     582,  1712,   583,   584,   585,     0,   586,   587,     0,     0,
    1713,   589,   590,     0,     0,   591,   592,   193,   194,   593,
     195,  1714,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,  1715,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,  1716,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,   207,   637,   638,   639,   640,   641,  1717,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,  1718,   656,   657,   214,   658,   659,
     216,   660,   661,  1719,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,  1720,
     676,     0,   677,   678,     0,   679,   221,   680,   681,   682,
     683,   684,     0,   685,  1721,  1722,     0,     0,   687,   688,
    1723,   689,  1724,  1725,   690,   691,   692,   693,   694,   695,
     696,   697,     0,  1726,   698,   699,   700,   701,   702,  1727,
       0,   703,   704,   705,   706,   707,   760,  1728,     0,   708,
     233,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,  1729,  1730,  1731,
    1732,   240,  1733,  1734,  1735,  1736,   245,   761,   720,   721,
    1737,     0,     0,     0,     0,     0,     0,  1738,  1739,     0,
       0,     0,     0,     0,     0,     0,  1741,   785,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,   786,    98,    99,   740,
     787,     0,   101,   102,   103,   104,   788,   789,   106,   107,
     108,     0,   109,   790,   791,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,   428,     0,     0,    37,     0,    38,    39,     0,
    1671,  1672,  1673,    40,  1674,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,  1675,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447,   128,  1676,   130,  1677,  1678,     0,   448,   449,   450,
     451,   452,   453,  1679,  1680,   454,   455,  1681,  1682,   456,
       0,   457,   458,   459,   460,  1683,     0,  1684,     0,   461,
     462,   463,   464,   465,   142,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,     0,
    1685,  1686,  1687,  1688,  1689,  1690,  1691,   477,   478,   479,
     480,   754,   481,  1692,  1693,   482,  1694,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,  1499,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
    1695,   509,   510,   511,   512,  1696,  1697,   513,     0,   514,
     515,  1698,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,  1699,     0,  1700,   524,
     525,     0,   526,   527,   756,   528,   529,   168,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,   171,     0,   542,   543,   544,  1502,  1701,
       0,  1702,     0,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,  1703,   178,   553,   179,
       0,   554,   555,   556,  1704,  1705,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,  1706,   185,  1707,   571,   572,   573,   574,   575,
     576,   577,   187,  1708,   578,  1709,   579,   580,   190,   581,
    1710,  1711,   582,  1712,   583,   584,   585,     0,   586,   587,
       0,     0,  1713,   589,   590,     0,     0,   591,   592,   193,
     194,   593,   195,  1714,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,  1715,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,  1716,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
    1717,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,  1718,   656,   657,   214,
     658,   659,   216,   660,   661,  1719,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,  1720,   676,     0,   677,   678,     0,   679,   221,   680,
     681,   682,   683,   684,     0,   685,  1721,  1722,     0,     0,
     687,   688,  1723,   689,  1724,  1725,   690,   691,   692,   693,
     694,   695,   696,   697,     0,  1726,   698,   699,   700,   701,
     702,  1727,     0,   703,   704,   705,   706,   707,   760,  1728,
    3822,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,  1729,
    1730,  1731,  1732,   240,  1733,  1734,  1735,  1736,   245,   761,
     720,   721,  1737,     0,     0,     0,     0,     0,     0,  1738,
    1739,     0,     0,     0,     0,     0,     0,     0,  1741,   785,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,   786,    98,
      99,   740,   787,     0,   101,   102,   103,   104,   788,   789,
     106,   107,   108,     0,   109,   790,   791,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,   428,     0,     0,    37,     0,    38,
      39,     0,  1671,  1672,  1673,    40,  1674,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
    1675,     0,     0,   440,   441,     0,   442,   443,   444,   126,
     445,   446,   447,   128,  1676,   130,  1677,  1678,     0,   448,
     449,   450,   451,   452,   453,  1679,  1680,   454,   455,  1681,
    1682,   456,     0,   457,   458,   459,   460,  1683,     0,  1684,
       0,   461,   462,   463,   464,   465,   142,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,   145,   474,
     475,     0,  1685,  1686,  1687,  1688,  1689,  1690,  1691,   477,
     478,   479,   480,   754,   481,  1692,  1693,   482,  1694,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,  1499,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,  1695,   509,   510,   511,   512,  1696,  1697,   513,
       0,   514,   515,  1698,   516,     0,   517,     0,   518,   163,
    3333,   164,   519,   520,   521,   522,     0,   523,  1699,     0,
    1700,   524,   525,     0,   526,   527,   756,   528,   529,   168,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   170,   171,     0,   542,   543,   544,
    1502,  1701,     0,  1702,     0,   545,   174,   175,   546,   176,
     547,   548,   549,   550,   551,     0,     0,   552,  1703,   178,
     553,   179,     0,   554,   555,   556,  1704,  1705,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,  1706,   185,  1707,   571,   572,   573,
     574,   575,   576,   577,   187,  1708,   578,  1709,   579,   580,
     190,   581,  1710,  1711,   582,  1712,   583,   584,   585,     0,
     586,   587,     0,     0,  1713,   589,   590,     0,     0,   591,
     592,   193,   194,   593,   195,  1714,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,  1715,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,  1716,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,   207,   637,   638,   639,
     640,   641,  1717,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,  1718,   656,
     657,   214,   658,   659,   216,   660,   661,  1719,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,  1720,   676,     0,   677,   678,     0,   679,
     221,   680,   681,   682,   683,   684,     0,   685,  1721,  1722,
       0,     0,   687,   688,  1723,   689,  1724,  1725,   690,   691,
     692,   693,   694,   695,   696,   697,     0,  1726,   698,   699,
     700,   701,   702,  1727,     0,   703,   704,   705,   706,   707,
     760,  1728,     0,   708,   233,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,  1729,  1730,  1731,  1732,   240,  1733,  1734,  1735,  1736,
     245,   761,   720,   721,  1737,     0,     0,     0,     0,     0,
       0,  1738,  1739,     0,     0,     0,     0,     0,     0,     0,
    1741,   785,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
     786,    98,    99,   740,   787,     0,   101,   102,   103,   104,
     788,   789,   106,   107,   108,     0,   109,   790,   791,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,   428,     0,     0,    37,
       0,    38,    39,     0,  1671,  1672,  1673,    40,  1674,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,  1675,     0,     0,   440,   441,     0,   442,   443,
     444,   126,   445,   446,   447,   128,  1676,   130,  1677,  1678,
       0,   448,   449,   450,   451,   452,   453,  1679,  1680,   454,
     455,  1681,  1682,   456,     0,   457,   458,   459,   460,  1683,
       0,  1684,     0,   461,   462,   463,   464,   465,   142,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
     145,   474,   475,  4810,  1685,  1686,  1687,  1688,  1689,  1690,
    1691,   477,   478,   479,   480,   754,   481,  1692,  1693,   482,
    1694,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,  1499,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,  1695,   509,   510,   511,   512,  1696,
    1697,   513,     0,   514,   515,  1698,   516,     0,   517,     0,
     518,   163,     0,   164,   519,   520,   521,   522,     0,   523,
    1699,     0,  1700,   524,   525,     0,   526,   527,   756,   528,
     529,   168,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   170,   171,     0,   542,
     543,   544,  1502,  1701,     0,  1702,     0,   545,   174,   175,
     546,   176,   547,   548,   549,   550,   551,     0,     0,   552,
    1703,   178,   553,   179,     0,   554,   555,   556,  1704,  1705,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,  1706,   185,  1707,   571,
     572,   573,   574,   575,   576,   577,   187,  1708,   578,  1709,
     579,   580,   190,   581,  1710,  1711,   582,  1712,   583,   584,
     585,     0,   586,   587,     0,     0,  1713,   589,   590,     0,
       0,   591,   592,   193,   194,   593,   195,  1714,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
    1715,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,  1716,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,   207,   637,
     638,   639,   640,   641,  1717,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
    1718,   656,   657,   214,   658,   659,   216,   660,   661,  1719,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,  1720,   676,     0,   677,   678,
       0,   679,   221,   680,   681,   682,   683,   684,     0,   685,
    1721,  1722,     0,     0,   687,   688,  1723,   689,  1724,  1725,
     690,   691,   692,   693,   694,   695,   696,   697,     0,  1726,
     698,   699,   700,   701,   702,  1727,     0,   703,   704,   705,
     706,   707,   760,  1728,     0,   708,   233,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,  1729,  1730,  1731,  1732,   240,  1733,  1734,
    1735,  1736,   245,   761,   720,   721,  1737,     0,     0,     0,
       0,     0,     0,  1738,  1739,     0,     0,     0,     0,     0,
       0,     0,  1741,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,   428,     0,
       0,    37,     0,    38,    39,     0,  1671,  1672,  1673,    40,
    1674,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,  1675,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,  5997,  1676,   130,
    1677,  1678,     0,   448,   449,   450,   451,   452,   453,  1679,
    1680,   454,   455,  1681,  1682,   456,     0,   457,   458,   459,
     460,  1683,     0,  1684,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,  5998,  1685,  1686,  1687,  1688,
    1689,  1690,  1691,   477,   478,   479,   480,   754,   481,  1692,
    1693,   482,  1694,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
    1499,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,  1695,   509,   510,   511,
     512,  1696,  1697,   513,     0,   514,   515,  1698,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,  1699,     0,  1700,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,  1502,  1701,     0,  1702,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,  1703,   178,   553,   179,     0,   554,   555,   556,
    1704,  1705,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,  1706,   185,
    1707,   571,   572,   573,   574,   575,   576,   577,   187,  1708,
     578,  1709,   579,   580,   190,   581,  1710,  1711,   582,  1712,
     583,   584,   585,     0,   586,   587,     0,     0,  1713,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,  1714,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,  1715,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,  1716,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,  1717,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,  1718,   656,   657,   214,   658,   659,   216,   660,
     661,  1719,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,  1720,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,  1721,  1722,     0,     0,   687,   688,  1723,   689,
    1724,  1725,   690,   691,   692,   693,   694,  5999,   696,   697,
       0,  1726,   698,   699,   700,   701,   702,  1727,     0,   703,
     704,   705,   706,   707,   760,  1728,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,  1729,  1730,  1731,  1732,   240,
    1733,  1734,  1735,  1736,   245,   761,   720,   721,  1737,     0,
       0,     0,     0,     0,     0,  1738,  1739,     0,     0,     0,
       0,     0,     0,     0,  1741,   785,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,   786,    98,    99,   740,   787,     0,
     101,   102,   103,   104,   788,   789,   106,   107,   108,     0,
     109,   790,   791,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
     428,     0,     0,    37,     0,    38,    39,     0,  1671,  1672,
    1673,    40,  1674,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,  1675,     0,     0,   440,
     441,     0,   442,   443,   444,   126,   445,   446,   447,   128,
    1676,   130,  1677,  1678,     0,   448,   449,   450,   451,   452,
     453,  1679,  1680,   454,   455,  1681,  1682,   456,     0,   457,
     458,   459,   460,  1683,     0,  1684,     0,   461,   462,   463,
     464,   465,   142,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,   145,   474,   475,  5998,  1685,  1686,
    1687,  1688,  1689,  1690,  1691,   477,   478,   479,   480,   754,
     481,  1692,  1693,   482,  1694,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,  1499,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,  1695,   509,
     510,   511,   512,  1696,  1697,   513,     0,   514,   515,  1698,
     516,     0,   517,     0,   518,   163,     0,   164,   519,   520,
     521,   522,     0,   523,  1699,     0,  1700,   524,   525,     0,
     526,   527,   756,   528,   529,   168,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     170,   171,     0,   542,   543,   544,  1502,  1701,     0,  1702,
       0,   545,   174,   175,   546,   176,   547,   548,   549,   550,
     551,     0,     0,   552,  1703,   178,   553,   179,     0,   554,
     555,   556,  1704,  1705,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
    1706,   185,  1707,   571,   572,   573,   574,   575,   576,   577,
     187,  1708,   578,  1709,   579,   580,   190,   581,  1710,  1711,
     582,  1712,   583,   584,   585,     0,   586,   587,     0,     0,
    1713,   589,   590,     0,     0,   591,   592,   193,   194,   593,
     195,  1714,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,  1715,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,  1716,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,   207,   637,   638,   639,   640,   641,  1717,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,  1718,   656,   657,   214,   658,   659,
     216,   660,   661,  1719,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,  1720,
     676,     0,   677,   678,     0,   679,   221,   680,   681,   682,
     683,   684,     0,   685,  1721,  1722,     0,     0,   687,   688,
    1723,   689,  1724,  1725,   690,   691,   692,   693,   694,  5999,
     696,   697,     0,  1726,   698,   699,   700,   701,   702,  1727,
       0,   703,   704,   705,   706,   707,   760,  1728,     0,   708,
     233,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,  1729,  1730,  1731,
    1732,   240,  1733,  1734,  1735,  1736,   245,   761,   720,   721,
    1737,     0,     0,     0,     0,     0,     0,  1738,  1739,     0,
       0,     0,     0,     0,     0,     0,  1741,   785,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,   786,    98,    99,   740,
     787,     0,   101,   102,   103,   104,   788,   789,   106,   107,
     108,     0,   109,   790,   791,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,   428,     0,     0,    37,     0,    38,    39,     0,
    1671,  1672,  1673,    40,  1674,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,  1675,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447,   128,  1676,   130,  1677,  1678,     0,   448,   449,   450,
     451,   452,   453,  1679,  1680,   454,   455,  1681,  1682,   456,
       0,   457,   458,   459,   460,  1683,     0,  1684,     0,   461,
     462,   463,   464,   465,   142,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,     0,
    1685,  1686,  1687,  1688,  1689,  1690,  1691,   477,   478,   479,
     480,   754,   481,  1692,  1693,   482,  1694,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,  1499,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
    1695,   509,   510,   511,   512,  1696,  1697,   513,     0,   514,
     515,  1698,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,  1699,     0,  1700,   524,
     525,     0,   526,   527,   756,   528,   529,   168,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,   171,     0,   542,   543,   544,  1502,  1701,
       0,  1702,     0,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,  1703,   178,   553,   179,
       0,   554,   555,   556,  1704,  1705,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,  1706,   185,  1707,   571,   572,   573,   574,   575,
     576,   577,   187,  1708,   578,  1709,   579,   580,   190,   581,
    1710,  1711,   582,  1712,   583,   584,   585,     0,   586,   587,
       0,     0,  1713,   589,   590,     0,     0,   591,   592,   193,
     194,   593,   195,  1714,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,  1715,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,  1716,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
    1717,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,  1718,   656,   657,   214,
     658,   659,   216,   660,   661,  1719,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,  1720,   676,     0,   677,   678,     0,   679,   221,   680,
     681,   682,   683,   684,     0,   685,  1721,  1722,     0,     0,
     687,   688,  1723,   689,  1724,  1725,   690,   691,   692,   693,
     694,   695,   696,   697,     0,  1726,   698,   699,   700,   701,
     702,  1727,     0,   703,   704,   705,   706,   707,   760,  1728,
       0,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,  1729,
    1730,  1731,  1732,   240,  1733,  1734,  1735,  1736,   245,   761,
     720,   721,  1737,     0,     0,     0,     0,     0,     0,  1738,
    1739,     0,     0,     0,     0,     0,     0,     0,  1741,   785,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,   786,    98,
      99,   740,   787,     0,   101,   102,   103,   104,   788,   789,
     106,   107,   108,     0,   109,   790,   791,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,   428,     0,     0,    37,     0,    38,
      39,     0,  1671,  1672,  1673,    40,  1674,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
    1675,     0,     0,   440,   441,     0,   442,   443,   444,   126,
     445,   446,   447,   128,  1676,   130,  1677,  1678,     0,   448,
     449,   450,   451,   452,   453,  1679,  1680,   454,   455,  1681,
    1682,   456,     0,   457,   458,   459,   460,  1683,     0,  1684,
       0,   461,   462,   463,   464,   465,   142,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,   145,   474,
     475,     0,  1685,  1686,  1687,  1688,  1689,  1690,  1691,   477,
     478,   479,   480,   754,   481,  1692,  1693,   482,  1694,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,  1499,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,  1695,   509,   510,   511,   512,  1696,  1697,   513,
       0,   514,   515,  1698,   516,     0,   517,     0,   518,   163,
       0,   164,   519,   520,   521,   522,     0,   523,  1699,     0,
    1700,   524,   525,     0,   526,   527,   756,   528,   529,   168,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   170,   171,     0,   542,   543,   544,
    1502,  1701,     0,  1702,     0,   545,   174,   175,   546,   176,
     547,   548,   549,   550,   551,     0,     0,   552,  1703,   178,
     553,   179,     0,   554,   555,   556,  1704,  1705,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,  1706,   185,  1707,   571,   572,   573,
     574,   575,   576,   577,   187,  1708,   578,  1709,   579,   580,
     190,   581,  1710,  1711,   582,  1712,   583,   584,   585,     0,
     586,   587,     0,     0,  1713,   589,   590,     0,     0,   591,
     592,   193,   194,   593,   195,  1714,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,  1715,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,  1716,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,   207,   637,   638,   639,
     640,   641,  1717,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,  1718,   656,
     657,   214,   658,   659,   216,   660,   661,  1719,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,  1720,   676,     0,   677,   678,     0,   679,
     221,   680,   681,   682,   683,   684,     0,   685,  1721,  1722,
       0,     0,   687,   688,  1723,   689,  1724,  1725,   690,   691,
     692,   693,   694,   695,   696,   697,     0,  1726,   698,   699,
     700,   701,   702,  1727,     0,   703,   704,   705,   706,   707,
     760,  1728,     0,   708,   233,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,  1729,  1730,  1731,  1732,   240,  1733,  1734,  1735,  1736,
     245,   761,   720,   721,  1737,     0,     0,     0,     0,     0,
       0,  2627,  2628,     0,     0,     0,     0,     0,     0,     0,
    1741,   785,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
     786,    98,    99,   740,   787,     0,   101,   102,   103,   104,
     788,   789,   106,   107,   108,     0,   109,   790,   791,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,   428,     0,     0,    37,
       0,    38,    39,     0,  1671,  1672,  1673,    40,  1674,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,  1675,     0,     0,   440,   441,     0,   442,   443,
     444,   126,   445,   446,   447,   128,  1676,   130,  1677,  1678,
       0,   448,   449,   450,   451,   452,   453,  1679,  1680,   454,
     455,  1681,  1682,   456,     0,   457,   458,   459,   460,  1683,
       0,  1684,     0,   461,   462,   463,   464,   465,   142,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
     145,   474,   475,     0,  1685,  1686,  1687,  1688,  1689,  1690,
    1691,   477,   478,   479,   480,   754,   481,  1692,  1693,   482,
    1694,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,  1499,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,  1695,   509,   510,   511,   512,  1696,
    1697,   513,     0,   514,   515,  1698,   516,     0,   517,     0,
     518,   163,     0,   164,   519,   520,   521,   522,     0,   523,
    1699,     0,  1700,   524,   525,     0,   526,   527,   756,   528,
     529,   168,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   170,   171,     0,   542,
     543,   544,  1502,  1701,     0,  1702,     0,   545,   174,   175,
     546,   176,   547,   548,   549,   550,   551,     0,     0,   552,
    1703,   178,   553,   179,     0,   554,   555,   556,  1704,  1705,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,  1706,   185,  1707,   571,
     572,   573,   574,   575,   576,   577,   187,  1708,   578,  1709,
     579,   580,   190,   581,  1710,  1711,   582,  1712,   583,   584,
     585,     0,   586,   587,     0,     0,  1713,   589,   590,     0,
       0,   591,   592,   193,   194,   593,   195,  1714,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
    1715,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,  1716,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,   207,   637,
     638,   639,   640,   641,  1717,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
    1718,   656,   657,   214,   658,   659,   216,   660,   661,  1719,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,  1720,   676,     0,   677,   678,
       0,   679,   221,   680,   681,   682,   683,   684,     0,   685,
    1721,  1722,     0,     0,   687,   688,  1723,   689,  1724,  1725,
     690,   691,   692,   693,   694,   695,   696,   697,     0,  1726,
     698,   699,   700,   701,   702,  1727,     0,   703,   704,   705,
     706,   707,   760,  1728,     0,   708,   233,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,  5176,  1729,  1730,  1731,  1732,   240,  1733,  1734,
    1735,  1736,   245,   761,   720,   721,  1737,     0,     0,     0,
       0,     0,     0,  1738,  1739,     0,     0,     0,     0,     0,
       0,     0,  1741,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,   428,     0,
       0,    37,     0,    38,    39,     0,  1671,  1672,  1673,    40,
    1674,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,  1675,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,   128,  1676,   130,
    1677,  1678,     0,   448,   449,   450,   451,   452,   453,  1679,
    1680,   454,   455,  1681,  1682,   456,     0,   457,   458,   459,
     460,  1683,     0,  1684,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,  1685,  1686,  1687,  1688,
    1689,  1690,  1691,   477,   478,   479,   480,   754,   481,  1692,
    1693,   482,  1694,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
    1499,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,  1695,   509,   510,   511,
     512,  1696,  1697,   513,     0,   514,   515,  1698,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,  1699,     0,  1700,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,  1502,  1701,     0,  1702,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,  1703,   178,   553,   179,     0,   554,   555,   556,
    1704,  1705,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,  1706,   185,
    1707,   571,   572,   573,   574,   575,   576,  5188,   187,  1708,
     578,  1709,   579,   580,   190,   581,  1710,  1711,   582,  1712,
     583,   584,   585,     0,   586,   587,     0,     0,  1713,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,  1714,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,  1715,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,  1716,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,  1717,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,  1718,   656,   657,   214,   658,   659,   216,   660,
     661,  1719,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,  1720,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,  1721,  1722,     0,     0,   687,   688,  1723,   689,
    1724,  1725,   690,   691,   692,   693,   694,   695,   696,   697,
       0,  1726,   698,   699,   700,   701,   702,  1727,     0,   703,
     704,   705,   706,   707,   760,  1728,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,  1729,  1730,  1731,  1732,   240,
    1733,  1734,  1735,  1736,   245,   761,   720,   721,  1737,     0,
       0,     0,     0,     0,     0,  1738,  1739,     0,     0,     0,
       0,     0,     0,     0,  1741,   785,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,   786,    98,    99,   740,   787,     0,
     101,   102,   103,   104,   788,   789,   106,   107,   108,     0,
     109,   790,   791,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
     428,     0,     0,    37,     0,    38,    39,     0,  1671,  1672,
    1673,    40,  1674,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,  1675,     0,     0,   440,
     441,     0,   442,   443,   444,   126,   445,   446,   447,   128,
    1676,   130,  1677,  1678,     0,   448,   449,   450,   451,   452,
     453,  1679,  1680,   454,   455,  1681,  1682,   456,     0,   457,
     458,   459,   460,  1683,     0,  1684,     0,   461,   462,   463,
     464,   465,   142,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,   145,   474,  5512,     0,  1685,  1686,
    1687,  1688,  1689,  1690,  1691,   477,   478,   479,   480,   754,
     481,  1692,  1693,   482,  1694,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,  1499,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,  1695,   509,
     510,   511,   512,  1696,  1697,   513,     0,   514,   515,  1698,
     516,     0,   517,     0,   518,   163,     0,   164,   519,   520,
     521,   522,     0,   523,  1699,     0,  5513,   524,   525,     0,
     526,   527,   756,   528,   529,   168,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     170,   171,     0,   542,   543,   544,  1502,  1701,     0,  1702,
       0,   545,   174,   175,   546,   176,   547,   548,   549,   550,
     551,     0,     0,   552,  1703,   178,   553,   179,     0,   554,
     555,   556,  1704,  1705,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
    1706,   185,  1707,   571,   572,   573,   574,   575,   576,   577,
     187,  1708,   578,  1709,   579,   580,   190,   581,  1710,  1711,
     582,  1712,   583,   584,   585,     0,   586,   587,     0,     0,
    1713,   589,   590,     0,     0,   591,   592,   193,   194,   593,
     195,  1714,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,  1715,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,  1716,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,   207,   637,   638,  5514,   640,   641,  1717,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,  1718,   656,   657,   214,   658,   659,
     216,   660,   661,  1719,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,  1720,
     676,     0,   677,   678,     0,   679,   221,   680,   681,   682,
     683,   684,     0,   685,  1721,  1722,     0,     0,   687,   688,
    1723,   689,  1724,  1725,   690,   691,   692,   693,   694,   695,
     696,   697,     0,  1726,   698,   699,   700,   701,   702,  1727,
       0,   703,   704,   705,   706,   707,   760,  1728,     0,   708,
     233,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,  1729,  1730,  1731,
    1732,   240,  1733,  1734,  1735,  1736,   245,   761,   720,   721,
    1737,     0,     0,     0,     0,     0,     0,  1738,  1739,     0,
       0,     0,     0,     0,     0,     0,  5515,   785,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,   786,    98,    99,   740,
     787,     0,   101,   102,   103,   104,   788,   789,   106,   107,
     108,     0,   109,   790,   791,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,   428,     0,     0,    37,     0,    38,    39,     0,
    1671,  1672,  1673,    40,  1674,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,  1675,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447, -3077,  1676,   130,  1677,  1678,     0,   448,   449,   450,
     451,   452,   453,  1679,  1680,   454,   455,  1681,  1682,   456,
       0,   457,   458,   459,   460,  1683,     0,  1684,     0,   461,
     462,   463,   464,   465,   142,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,  5998,
    1685,  1686,  1687,  1688,  1689,  1690,  1691,   477,   478,   479,
     480,   754,   481,  1692,  1693,   482,  1694,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,  1499,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
    1695,   509,   510,   511,   512,  1696,  1697,   513,     0,   514,
     515,  1698,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,  1699,     0,  1700,   524,
     525,     0,   526,   527,   756,   528,   529, -3077,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,   171,     0,   542,   543,   544,  1502,  1701,
       0,  1702,     0,   545,     0,     0,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,  1703,   178,   553, -3077,
       0,   554,   555,   556,  1704,  1705,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,  1706,   185,  1707,   571,   572,   573,   574,   575,
     576,   577,   187,  1708,   578,  1709,   579,   580,     0,   581,
    1710,  1711,   582,  1712,   583,   584,   585,     0,   586,   587,
       0,     0,  1713,   589,   590,     0,     0,   591,   592,   193,
     194,   593,   195,  1714,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,  1715,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,  1716,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
    1717,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,  1718,   656,   657,   214,
     658,   659, -3077,   660,   661,  1719,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,  1720,   676,     0,   677,   678,     0,   679,   221,   680,
     681,   682,   683,   684,     0,   685,  1721,  1722,     0,     0,
     687,   688,  1723,   689,  1724,  1725,   690,   691,   692,   693,
     694,  5999,   696,   697,     0,  1726,   698,   699,   700,   701,
     702,  1727,     0,   703,   704,   705,   706,   707,   760,  1728,
       0,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,  1729,
    1730,  1731,  1732,   240,  1733,  1734,  1735,  1736,   245,   761,
     720,   721, -3077,     0,     0,     0,     0,     0,     0,  1738,
    1739,     0,     0,     0,     0,     0,     0,     0,  1741,   785,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,   786,    98,
      99,   740,   787,     0,   101,   102,   103,   104,   788,   789,
     106,   107,   108,     0,   109,   790,   791,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,   428,     0,     0,    37,     0,    38,
      39,     0,  1671,  1672,  1673,    40,  1674,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
    1675,     0,     0,   440,   441,     0,   442,   443,   444,   126,
     445,   446,   447,   128,  1676,   130,  1677,  1678,     0,   448,
     449,   450,   451,   452,   453,  1679,  1680,   454,   455,  1681,
    1682,   456,     0,   457,   458,   459,   460,  1683,     0,  1684,
       0,   461,   462,   463,   464,   465,   142,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,   145,   474,
     475,     0,  1685,  1686,  1687,  1688,  1689,  1690,  1691,   477,
     478,   479,   480,   754,   481,  1692,  1693,   482,  5716,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,  1499,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,  1695,   509,   510,   511,   512,  1696,  1697,   513,
       0,   514,   515,  1698,   516,     0,   517,     0,   518,   163,
       0,   164,   519,   520,   521,   522,     0,   523,  1699,     0,
    1700,   524,   525,     0,   526,   527,   756,   528,   529,   168,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   170,   171,     0,   542,   543,   544,
    1502,  1701,     0,  1702,     0,   545,   174,   175,   546,   176,
     547,   548,   549,   550,   551,     0,     0,   552,  1703,   178,
     553,   179,     0,   554,   555,   556,  1704,  1705,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,  1706,   185,  1707,   571,   572,   573,
     574,   575,   576,   577,   187,  1708,   578,     0,   579,   580,
     190,   581,  1710,  1711,   582,  1712,   583,   584,   585,     0,
     586,   587,     0,     0,  1713,   589,   590,     0,     0,   591,
     592,   193,   194,   593,   195,  1714,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,  1715,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,  1716,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,   207,   637,   638,   639,
     640,   641,  3318,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,  1718,   656,
     657,   214,   658,   659,   216,   660,   661,  1719,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,  1720,   676,     0,   677,   678,     0,   679,
     221,   680,   681,   682,   683,   684,     0,   685,  1721,  1722,
       0,     0,   687,   688,  1723,   689,  1724,  1725,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,  1727,     0,   703,   704,   705,   706,   707,
     760,  1728,     0,   708,   233,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,  1729,  1730,  1731,  1732,   240,  1733,  1734,  1735,  1736,
     245,   761,   720,   721,     0,     0,     0,     0,     0,     0,
       0,  3319,  3320,     0,     0,     0,     0,     0,     0,     0,
    3321,   785,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
     786,    98,    99,   740,   787,     0,   101,   102,   103,   104,
     788,   789,   106,   107,   108,     0,   109,   790,   791,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,   428,     0,     0,    37,
       0,    38,    39,     0,  1671,  1672,  1673,    40,  1674,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,  1675,     0,     0,   440,   441,     0,   442,   443,
     444,   126,   445,   446,   447,   128,  1676,   130,  1677,  1678,
       0,   448,   449,   450,   451,   452,   453,  1679,  1680,   454,
     455,  1681,  1682,   456,     0,   457,   458,   459,   460,  1683,
       0,  1684,     0,   461,   462,   463,   464,   465,   142,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
     145,   474,   475,     0,  1685,  1686,  1687,  1688,  1689,  1690,
    1691,   477,   478,   479,   480,   754,   481,  1692,  1693,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,  1499,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,  1695,   509,   510,   511,   512,  1696,
    1697,   513,     0,   514,   515,  1698,   516,     0,   517,     0,
     518,   163,     0,   164,   519,   520,   521,   522,     0,   523,
    1699,     0,  1700,   524,   525,     0,   526,   527,   756,   528,
     529,   168,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   170,   171,     0,   542,
     543,   544,  1502,  1701,     0,  1702,     0,   545,   174,   175,
     546,   176,   547,   548,   549,   550,   551,     0,     0,   552,
    1703,   178,   553,   179,     0,   554,   555,   556,  1704,  1705,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,  1706,   185,  1707,   571,
     572,   573,   574,   575,   576,   577,   187,  1708,   578,     0,
     579,   580,   190,   581,  1710,  1711,   582,  1712,   583,   584,
     585,     0,   586,   587,     0,     0,  1713,   589,   590,     0,
       0,   591,   592,   193,   194,   593,   195,  1714,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
    1715,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,  1716,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,   207,   637,
     638,   639,   640,   641,  3318,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
    1718,   656,   657,   214,   658,   659,   216,   660,   661,  1719,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,  1720,   676,     0,   677,   678,
       0,   679,   221,   680,   681,   682,   683,   684,     0,   685,
    1721,  1722,     0,     0,   687,   688,  1723,   689,  1724,  1725,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,  1727,     0,   703,   704,   705,
     706,   707,   760,  1728,     0,   708,   233,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,  1729,  1730,  1731,  1732,   240,  1733,  1734,
    1735,  1736,   245,   761,   720,   721,     0,     0,     0,     0,
       0,     0,     0,  3319,  3320,     0,     0,     0,     0,     0,
       0,     0,  3321,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,   428,     0,
       0,    37,     0,    38,    39,     0,  1671,  1672,     0,    40,
    1674,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,  1675,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,   128,  1676,   130,
    1677,  1678,     0,   448,   449,   450,   451,   452,   453,  1679,
    1680,   454,   455,  1681,  1682,   456,     0,   457,   458,   459,
     460,  1683,     0,  1684,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,  1685,  1686,  1687,  1688,
    1689,  1690,  1691,   477,   478,   479,   480,   754,   481,  1692,
    1693,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
    1499,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,  1695,   509,   510,   511,
     512,  1696,  1697,   513,     0,   514,   515,  1698,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,  1699,     0,  1700,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,  1502,  1701,     0,  1702,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,  1703,   178,   553,   179,     0,   554,   555,   556,
    1704,  1705,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,  1706,   185,
    1707,   571,   572,   573,   574,   575,   576,   577,   187,  1708,
     578,     0,   579,   580,   190,   581,  1710,  1711,   582,  1712,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,  1714,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,  1715,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,  1716,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,  3457,  3458,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,  1718,   656,   657,   214,   658,   659,   216,   660,
     661,  1719,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,  1720,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,  1721,  1722,     0,     0,   687,   688,  1723,   689,
    1724,  1725,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,  1727,     0,   703,
     704,   705,   706,   707,   760,  1728,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,  1729,  1730,  1731,  1732,   240,
    1733,  1734,  1735,  1736,   245,   761,   720,   721,     0,     0,
       0,     0,     0,     0,     0,  3459,  3460,     0,     0,     0,
       0,     0,     0,     0,  3321,   785,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,   786,    98,    99,   740,   787,     0,
     101,   102,   103,   104,   788,   789,   106,   107,   108,     0,
     109,   790,   791,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
     428,     0,     0,    37,     0,    38,    39,     0,  1671,  1672,
    1673,    40,  1674,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,  1675,     0,     0,   440,
     441,     0,   442,   443,   444,   126,   445,   446,   447,   128,
    1676,   130,  1677,  1678,     0,   448,   449,   450,   451,   452,
     453,  1679,  1680,   454,   455,  1681,  1682,   456,     0,   457,
     458,   459,   460,  1683,     0,  1684,     0,   461,   462,   463,
     464,   465,   142,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,   145,   474,   475,     0,  1685,  1686,
    1687,  1688,  1689,  1690,  1691,   477,   478,   479,   480,   754,
     481,  1692,  1693,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,  1499,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,  1695,   509,
     510,   511,   512,  1696,  1697,   513,     0,   514,   515,  1698,
     516,     0,   517,     0,   518,   163,     0,   164,   519,   520,
     521,   522,     0,   523,  1699,     0,  1700,   524,   525,     0,
     526,   527,   756,   528,   529,   168,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     170,   171,     0,   542,   543,   544,  1502,  1701,     0,  1702,
       0,   545,     0,   175,   546,   176,   547,   548,   549,   550,
     551,     0,     0,   552,  1703,   178,   553,   179,     0,   554,
     555,   556,  1704,  1705,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
    1706,   185,  1707,   571,   572,   573,   574,   575,   576,   577,
     187,  1708,   578,     0,   579,   580,   190,   581,  1710,  1711,
     582,  1712,   583,   584,   585,     0,   586,   587,     0,     0,
    1713,   589,   590,     0,     0,   591,   592,   193,   194,   593,
     195,  1714,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,  1715,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,  1716,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,   207,   637,   638,   639,   640,   641,  3318,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,  1718,   656,   657,   214,   658,   659,
     216,   660,   661,  1719,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,  1720,
     676,     0,   677,   678,     0,   679,   221,   680,   681,   682,
     683,   684,     0,   685,  1721,  1722,     0,     0,   687,   688,
    1723,   689,  1724,  1725,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,  1727,
       0,   703,   704,   705,   706,   707,   760,  1728,     0,   708,
     233,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,  1729,  1730,  1731,
    1732,   240,  1733,  1734,  1735,  1736,   245,   761,   720,   721,
       0,     0,     0,     0,     0,     0,     0,  3319,  3320,     0,
       0,     0,     0,     0,     0,     0,  3321,   785,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,   786,    98,    99,   740,
     787,     0,   101,   102,   103,   104,   788,   789,   106,   107,
     108,     0,   109,   790,   791,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,   428,     0,     0,    37,     0,    38,    39,     0,
    1671,  1672,     0,    40,  1674,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,  1675,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447,   128,  1676,   130,  1677,  1678,     0,   448,   449,   450,
     451,   452,   453,  1679,  1680,   454,   455,  1681,  1682,   456,
       0,   457,   458,   459,   460,  1683,     0,  1684,     0,   461,
     462,   463,   464,   465,   142,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,     0,
    1685,  1686,  1687,  1688,  1689,  1690,  1691,   477,   478,   479,
     480,   754,   481,  1692,  1693,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,  1499,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
    1695,   509,   510,   511,   512,  1696,  1697,   513,     0,   514,
     515,  1698,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,  1699,     0,  1700,   524,
     525,     0,   526,   527,   756,   528,   529,   168,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,   171,     0,   542,   543,   544,  1502,  1701,
       0,  1702,     0,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,  1703,   178,   553,   179,
       0,   554,   555,   556,  1704,  1705,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,  1706,   185,  1707,   571,   572,   573,   574,   575,
     576,   577,   187,  1708,   578,     0,   579,   580,   190,   581,
    1710,  1711,   582,  1712,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
     194,   593,   195,  1714,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,  1715,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,  1716,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
    3318,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,  1718,   656,   657,   214,
     658,   659,   216,   660,   661,  1719,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,  1720,   676,     0,   677,   678,     0,   679,   221,   680,
     681,   682,   683,   684,     0,   685,  1721,  1722,     0,     0,
     687,   688,  1723,   689,  1724,  1725,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,  1727,     0,   703,   704,   705,   706,   707,   760,  1728,
       0,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,  1729,
    1730,  1731,  1732,   240,  1733,  1734,  1735,  1736,   245,   761,
     720,   721,     0,     0,     0,     0,   785,    81,    82,   737,
      84,    85,    86,   738,     0,   739,    89,     0,  3321,    92,
      93,    94,    95,    96,    97,   786,    98,    99,   740,   787,
       0,   101,   102,   103,   104,   788,   789,   106,   107,   108,
       0,   109,   790,   791,   741,   742,     0,     0,     0,   743,
     744,     0,     0,     0,     0,   745,     0,     0,     0,     0,
       0,     0,     0,     0,   746,     0,   747,     0,   748,   749,
      35,   428,     0,     0,    37,     0,    38,    39,     0,  1671,
    1672,     0,    40,  1674,     0,     0,     0,     0,     0,     0,
       0,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     437,   438,   439,     0,     0,     0,     0,  1675,     0,     0,
     440,   441,     0,   442,   443,   444,   126,   445,   446,   447,
     128,  1676,   130,  1677,  1678,     0,  4713,   449,   450,   451,
     452,   453,  1679,  1680,   454,   455,  1681,  1682,   456,     0,
     457,   458,   459,   460,  1683,     0,  1684,     0,   461,   462,
     463,   464,   465,   142,   466,   467,   752,     0,   468,   469,
     470,   471,   472,   473,     0,   145,   474,   475,     0,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,   477,   478,   479,   480,
     754,   481,  1692,  1693,   482,     0,   483,     0,   484,   485,
     486,   487,   488,   489,     0,   490,   491,   492,   493,     0,
       0,   494,   495,  1499,   497,   498,     0,   499,   500,   501,
       0,   502,   503,   504,     0,   505,   506,   507,   508,  1695,
     509,   510,   511,   512,  1696,  1697,   513,     0,   514,   515,
    1698,   516,     0,   517,     0,   518,   163,     0,   164,   519,
     520,   521,   522,     0,   523,  1699,     0,  1700,   524,   525,
       0,   526,   527,   756,   528,   529,   168,   530,   531,   532,
     533,     0,   534,   535,   536,   537,   538,   539,   540,     0,
     541,   170,   171,     0,   542,   543,   544,  1502,  1701,     0,
    1702,     0,   545,   174,   175,   546,   176,   547,   548,   549,
     550,   551,     0,     0,   552,  1703,   178,   553,   179,     0,
     554,   555,   556,  1704,  1705,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   757,   566,   567,   758,   568,   569,
     570,  1706,   185,  1707,   571,   572,   573,   574,   575,   576,
     577,   187,  1708,   578,     0,   579,   580,   190,   581,  1710,
    1711,   582,  1712,   583,   584,   585,     0,   586,   587,     0,
       0,   588,   589,   590,     0,     0,   591,   592,   193,   194,
     593,   195,  1714,   594,   595,   596,   597,   598,   599,   600,
     601,   602,     0,   603,   604,  1715,   605,   198,   606,   607,
     608,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,  1716,   619,   620,   621,   622,     0,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
       0,   635,   636,   207,   637,   638,   639,   640,   641,  3318,
     642,   643,   644,   645,   646,   647,   648,   759,   649,     0,
     650,   651,   652,   653,   654,  1718,   656,   657,   214,   658,
     659,   216,   660,   661,  1719,   662,     0,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,   674,   675,
    1720,   676,     0,   677,   678,     0,   679,   221,   680,   681,
     682,   683,   684,     0,   685,  1721,  1722,     0,     0,   687,
     688,  1723,   689,  1724,  1725,   690,   691,   692,   693,   694,
     695,   696,   697,     0,     0,   698,   699,   700,   701,   702,
    1727,     0,   703,   704,   705,   706,   707,   760,  1728,     0,
     708,   233,   709,   710,   711,   712,     0,     0,   713,     0,
       0,   714,   715,   716,   717,   718,   719,   235,  1729,  1730,
    1731,  1732,   240,  1733,  1734,  1735,  1736,   245,   761,   720,
     721,     0,     0,     0,     0,   785,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,  3321,    92,    93,
      94,    95,    96,    97,   786,    98,    99,   740,   787,     0,
     101,   102,   103,   104,   788,   789,   106,   107,   108,     0,
     109,   790,   791,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
     428,     0,     0,    37,     0,    38,    39,     0,  1671,  1672,
       0,    40,  1674,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,  1675,     0,     0,   440,
     441,     0,   442,   443,   444,   126,   445,   446,   447,   128,
    1676,   130,  1677,  1678,     0,   448,   449,   450,   451,   452,
     453,  1679,  1680,   454,   455,  1681,  1682,   456,     0,   457,
     458,   459,   460,  1683,     0,  1684,     0,   461,   462,   463,
     464,   465,   142,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,   145,   474,   475,     0,  1685,  1686,
    1687,  1688,  1689,  1690,  1691,   477,   478,   479,   480,   754,
     481,  1692,  1693,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,  1499,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,  1695,   509,
     510,   511,   512,  1696,  1697,   513,     0,   514,   515,  1698,
     516,     0,   517,     0,   518,   163,     0,   164,   519,   520,
     521,   522,     0,   523,  1699,     0,  1700,   524,   525,     0,
     526,   527,   756,   528,   529,   168,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     170,   171,     0,   542,   543,   544,  1502,  1701,     0,  1702,
       0,   545,   174,   175,   546,   176,   547,   548,   549,   550,
     551,     0,     0,   552,  1703,   178,   553,   179,     0,   554,
     555,   556,  1704,  1705,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
    1706,   185,  1707,   571,   572,   573,   574,   575,   576,   577,
     187,  1708,   578,     0,   579,   580,   190,   581,  1710,  1711,
     582,  1712,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,   194,   593,
     195,  1714,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,  1715,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,  1716,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,   207,   637,   638,   639,   640,   641,  3318,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,  1718,   656,   657,   214,   658,   659,
     216,   660,   661,  1719,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,  1720,
     676,     0,   677,   678,     0,   679,   221,   680,   681,   682,
     683,   684,     0,   685,  1721,  1722,     0,     0,   687,   688,
    1723,   689,  1724,  1725,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,  1727,
       0,   703,   704,   705,   706,   707,   760,  1728,     0,   708,
     233,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,  1729,  1730,  1731,
    1732,  5219,  1733,  1734,  1735,  1736,   245,   761,   720,   721,
       0,     0,     0,     0,   785,    81,    82,   737,    84,    85,
      86,   738,     0,   739,    89,     0,  3321,    92,    93,    94,
      95,    96,    97,   786,    98,    99,   740,   787,     0,   101,
     102,   103,   104,   788,   789,   106,   107,   108,     0,   109,
     790,   791,   741,   742,     0,     0,     0,   743,   744,     0,
       0,     0,     0,   745,     0,     0,     0,     0,     0,     0,
       0,     0,   746,     0,   747,     0,   748,   749,    35,   428,
       0,     0,    37,     0,    38,    39,     0,  1671,  1672,  1673,
      40,  1674,     0,     0,     0,     0,     0,     0,     0,   429,
     430,   431,   432,   433,   434,   435,   436,     0,   437,   438,
     439,     0,     0,     0,     0,  1675,     0,     0,   440,   441,
       0,   442,   443,   444,   126,   445,   446,   447,     0,  1676,
     130,  1677,  1678,     0,   448,   449,   450,   451,   452,   453,
    1679,  1680,   454,   455,  1681,  1682,   456,     0,   457,   458,
     459,   460,  1683,     0,  1684,     0,   461,   462,   463,   464,
     465,   142,   466,   467,   752,     0,   468,   469,   470,   471,
     472,   473,     0,   145,   474,   475,     0,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,   477,   478,   479,   480,   754,   481,
    1692,  1693,   482,  1694,   483,     0,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,     0,     0,   494,
     495,  1499,   497,   498,     0,   499,   500,   501,     0,   502,
       0,   504,     0,   505,   506,   507,   508,  1695,   509,   510,
     511,   512,  1696,  1697,   513,     0,   514,   515,  1698,   516,
       0,   517,     0,   518,   163,     0,   164,   519,   520,   521,
     522,     0,   523,  1699,     0,  1700,   524,   525,     0,   526,
     527,   756,   528,   529,     0,   530,   531,   532,   533,     0,
     534,   535,   536,   537,   538,   539,   540,     0,   541,   170,
     171,     0,   542,   543,   544,  1502,  1701,     0,  1702,     0,
     545,     0,     0,   546,   176,   547,   548,   549,   550,   551,
       0,     0,   552,  1703,   178,   553,     0,     0,   554,   555,
     556,  1704,  1705,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   757,   566,   567,   758,   568,   569,   570,  1706,
     185,  1707,   571,   572,   573,   574,   575,   576,   577,   187,
    1708,   578,  1709,   579,   580,     0,   581,  1710,  1711,   582,
    1712,   583,   584,   585,     0,   586,   587,     0,     0,  1713,
     589,   590,     0,     0,   591,   592,   193,   194,   593,   195,
    1714,   594,   595,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,  1715,   605,   198,   606,   607,   608,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
    1716,   619,   620,   621,   622,     0,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,     0,   635,
     636,   207,   637,   638,   639,   640,   641,  1717,   642,   643,
     644,   645,   646,   647,   648,   759,   649,     0,   650,   651,
     652,   653,   654,  1718,   656,   657,   214,   658,   659,     0,
     660,   661,  1719,   662,     0,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,   674,   675,  1720,   676,
       0,   677,   678,     0,   679,   221,   680,   681,   682,   683,
     684,     0,   685,  1721,  1722,     0,     0,   687,   688,  1723,
     689,  1724,  1725,   690,   691,   692,   693,   694,   695,   696,
     697,     0,  1726,   698,   699,   700,   701,   702,  1727,     0,
     703,   704,   705,   706,   707,   760,  1728,     0,   708,   233,
     709,   710,   711,   712,     0,     0,   713,     0,     0,   714,
     715,   716,   717,   718,   719,   235,  1729,  1730,  1731,  1732,
     240,  1733,  1734,  1735,  1736,   245,   761,   720,   721,     0,
       0,     0,     0,     0,     0,     0,  1738,  1739,     0,     0,
       0,     0,     0,     0,     0,  1741,   785,    81,    82,   737,
      84,    85,    86,   738,     0,   739,    89,     0,     0,    92,
      93,    94,    95,    96,    97,   786,    98,    99,   740,   787,
       0,   101,   102,   103,   104,   788,   789,   106,   107,   108,
       0,   109,   790,   791,   741,   742,     0,     0,     0,   743,
     744,     0,     0,     0,     0,   745,     0,     0,     0,     0,
       0,     0,     0,     0,   746,     0,   747,     0,   748,   749,
      35,     0,     0,     0,    37,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     437,   438,   439,     0,     0,     0,     0,     0,     0,     0,
     440,   441,     0,   442,   443,   444,   126,   445,   446,   447,
     128,   129,   130,   131,   132,     0,   448,   449,   450,   451,
     452,   453,     0,  1680,   454,   455,   751,   134,   456,     0,
     457,   458,   459,   460,  1683,     0,  1684,     0,   461,   462,
     463,   464,   465,   142,   466,   467,   752,     0,   468,   469,
     470,   471,   472,   473,     0,   145,   474,   475,     0,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,   477,   478,   479,   480,
     754,   481,   149,   150,   482,     0,   483,     0,   484,   485,
     486,   487,   488,   489,     0,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,     0,   499,   500,   501,
       0,   502,   503,   504,     0,   505,   506,   507,   508,   158,
     509,   510,   511,   512,  1696,     0,   513,     0,   514,   515,
     162,   516,     0,   517,     0,   518,   163,     0,   164,   519,
     520,   521,   522,     0,   523,  1699,     0,   167,   524,   525,
       0,   526,   527,   756,   528,   529,   168,   530,   531,   532,
     533,     0,   534,   535,   536,   537,   538,   539,   540,     0,
     541,   170,   171,     0,   542,   543,   544,     0,   172,     0,
     173,     0,   545,   174,   175,   546,   176,   547,   548,   549,
     550,   551,  4181,     0,   552,  1703,   178,   553,   179,     0,
     554,   555,   556,  1704,  1705,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   757,   566,   567,   758,   568,   569,
     570,   184,   185,   186,   571,   572,   573,   574,   575,   576,
     577,   187,  1708,   578,     0,   579,   580,   190,   581,     0,
    1711,   582,   192,   583,   584,   585,     0,   586,   587,     0,
    1181,   588,   589,   590,     0,     0,   591,   592,   193,   194,
     593,   195,  1714,   594,   595,   596,   597,   598,   599,   600,
     601,   602,     0,   603,   604,  1715,   605,   198,   606,   607,
     608,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   200,   619,   620,   621,   622,     0,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
       0,   635,   636,   207,   637,   638,   639,   640,   641,   209,
    4182,   643,   644,   645,   646,   647,   648,   759,   649,   212,
     650,   651,   652,   653,   654,  1718,   656,   657,   214,   658,
     659,   216,   660,   661,   217,   662,     0,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,   674,   675,
    1720,   676,     0,   677,   678,   220,   679,   221,   680,   681,
     682,   683,   684,     0,   685,   222,   223,     0,     0,   687,
     688,  1723,   689,  1724,     0,   690,   691,   692,   693,   694,
     695,   696,   697,     0,     0,   698,   699,   700,   701,   702,
    1727,     0,   703,   704,   705,   706,   707,  2493,   232,     0,
     708,   233,   709,   710,   711,   712,     0,     0,   713,     0,
     234,   714,   715,   716,   717,   718,   719,   235,  1729,  1730,
    1731,  1732,   240,  1733,  1734,  1735,  1736,  4183,   761,   720,
     721,     0,     0,   246,     0,   785,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,  4184,    92,    93,
      94,    95,    96,    97,   786,    98,    99,   740,   787,     0,
     101,   102,   103,   104,   788,   789,   106,   107,   108,     0,
     109,   790,   791,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,   126,   445,   446,   447,   128,
     129,   130,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,  1680,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,  1683,     0,  1684,     0,   461,   462,   463,
     464,   465,   142,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,   145,   474,   475,     0,  1685,  1686,
    1687,  1688,  1689,  1690,  1691,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,  1696,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,   163,     0,   164,   519,   520,
     521,   522,     0,   523,  1699,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,   168,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     170,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,   174,   175,   546,   176,   547,   548,   549,   550,
     551,  4181,     0,   552,  1703,   178,   553,   179,     0,   554,
     555,   556,  1704,  1705,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,   185,   186,   571,   572,   573,   574,   575,   576,   577,
     187,  1708,   578,     0,   579,   580,   190,   581,     0,  1711,
     582,   192,   583,   584,   585,     0,   586,   587,     0,  1181,
     588,   589,   590,     0,     0,   591,   592,   193,   194,   593,
     195,  1714,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,  1715,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,   207,   637,   638,   639,   640,   641,   209,  4182,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,  1718,   656,   657,   214,   658,   659,
     216,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,  1720,
     676,     0,   677,   678,     0,   679,   221,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
    1723,   689,  1724,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,  1727,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
     233,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,  1729,  1730,  1731,
    1732,   240,  1733,  1734,  1735,  1736,  4183,   761,   720,   721,
       0,     0,     0,     0,   785,    81,    82,   737,    84,    85,
      86,   738,     0,   739,    89,     0,  4184,    92,    93,    94,
      95,    96,    97,   786,    98,    99,   740,   787,     0,   101,
     102,   103,   104,   788,   789,   106,   107,   108,     0,   109,
     790,   791,   741,   742,     0,     0,     0,   743,   744,     0,
       0,     0,     0,   745,     0,     0,     0,     0,     0,     0,
       0,     0,   746,     0,   747,     0,   748,   749,    35,     0,
       0,     0,    37,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   429,
     430,   431,   432,   433,   434,   435,   436,     0,   437,   438,
     439,     0,     0,     0,     0,     0,     0,     0,   440,   441,
       0,   442,   443,   444,   126,   445,   446,   447,   128,   129,
     130,   131,   132,     0,   448,   449,   450,   451,   452,   453,
       0,  1680,   454,   455,   751,   134,   456,     0,   457,   458,
     459,   460,  1683,     0,  1684,     0,   461,   462,   463,   464,
     465,   142,   466,   467,   752,     0,   468,   469,   470,   471,
     472,   473,     0,   145,   474,   475,     0,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,   477,   478,   479,   480,   754,   481,
     149,   150,   482,     0,   483,     0,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,     0,   499,   500,   501,     0,   502,
     503,   504,     0,   505,   506,   507,   508,   158,   509,   510,
     511,   512,  1696,     0,   513,     0,   514,   515,   162,   516,
       0,   517,     0,   518,   163,     0,   164,   519,   520,   521,
     522,     0,   523,  1699,     0,   167,   524,   525,     0,   526,
     527,   756,   528,   529,   168,   530,   531,   532,   533,     0,
     534,   535,   536,   537,   538,   539,   540,     0,   541,   170,
     171,     0,   542,   543,   544,     0,   172,     0,   173,     0,
     545,   174,   175,   546,   176,   547,   548,   549,   550,   551,
       0,     0,   552,  1703,   178,   553,   179,     0,   554,   555,
     556,  1704,  1705,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   757,   566,   567,   758,   568,   569,   570,   184,
     185,   186,   571,   572,   573,   574,   575,   576,   577,   187,
    1708,   578,     0,   579,   580,   190,   581,     0,  1711,   582,
     192,   583,   584,   585,     0,   586,   587,     0,     0,   588,
     589,   590,     0,     0,   591,   592,   193,   194,   593,   195,
    1714,   594,   595,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,  1715,   605,   198,   606,   607,   608,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     200,   619,   620,   621,   622,     0,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,     0,   635,
     636,   207,   637,   638,   639,   640,   641,   209,  4182,   643,
     644,   645,   646,   647,   648,   759,   649,     0,   650,   651,
     652,   653,   654,  1718,   656,   657,   214,   658,   659,   216,
     660,   661,   217,   662,     0,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,   674,   675,  1720,   676,
       0,   677,   678,     0,   679,   221,   680,   681,   682,   683,
     684,     0,   685,   222,   223,     0,     0,   687,   688,  1723,
     689,  1724,     0,   690,   691,   692,   693,   694,   695,   696,
     697,     0,     0,   698,   699,   700,   701,   702,  1727,     0,
     703,   704,   705,   706,   707,   760,   232,     0,   708,   233,
     709,   710,   711,   712,     0,     0,   713,     0,     0,   714,
     715,   716,   717,   718,   719,   235,  1729,  1730,  1731,  1732,
     240,  1733,  1734,  1735,  1736,  4183,   761,   720,   721,     0,
       0,     0,     0,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,   247,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,   128,   129,   130,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
    1680,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,  1683,     0,  1684,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,  1685,  1686,  1687,  1688,
    1689,  1690,  1691,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,  1696,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,  1699,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,  1703,   178,   553,   179,     0,   554,   555,   556,
    1704,  1705,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,   185,
     186,   571,   572,   573,   574,   575,   576,   577,   187,  1708,
     578,     0,   579,   580,   190,   581,     0,  1711,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,  1714,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,  1715,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,  1718,   656,   657,   214,   658,   659,   216,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,  1720,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,  1723,   689,
    1724,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,  1727,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,  1729,  1730,  1731,  1732,   240,
    1733,  1734,  1735,  1736,   245,   761,   720,   721,     0,     0,
       0,     0,   785,    81,    82,   737,    84,    85,    86,   738,
       0,   739,    89,     0,  4844,    92,    93,    94,    95,    96,
      97,   786,    98,    99,   740,   787,     0,   101,   102,   103,
     104,   788,   789,   106,   107,   108,     0,   109,   790,   791,
     741,   742,     0,     0,     0,   743,   744,     0,     0,     0,
       0,   745,     0,     0,     0,     0,     0,     0,     0,     0,
     746,     0,   747,     0,   748,   749,    35,     0,     0,     0,
      37,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   429,   430,   431,
     432,   433,   434,   435,   436,     0,   437,   438,   439,     0,
       0,     0,     0,     0,     0,     0,   440,   441,     0,   442,
     443,   444,   126,   445,   446,   447,   128,   129,   130,   131,
     132,     0,   448,   449,   450,   451,   452,   453,     0,  1680,
     454,   455,   751,   134,   456,     0,   457,   458,   459,   460,
    1683,     0,  1684,     0,   461,   462,   463,   464,   465,   142,
     466,   467,   752,     0,   468,   469,   470,   471,   472,   473,
       0,   145,   474,   475,     0,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,   477,   478,   479,   480,   754,   481,   149,   150,
     482,     0,   483,     0,   484,   485,   486,   487,   488,   489,
       0,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,     0,   499,   500,   501,     0,   502,   503,   504,
       0,   505,   506,   507,   508,   158,   509,   510,   511,   512,
    1696,     0,   513,     0,   514,   515,   162,   516,     0,   517,
       0,   518,   163,     0,   164,   519,   520,   521,   522,     0,
     523,  1699,     0,   167,   524,   525,     0,   526,   527,   756,
     528,   529,   168,   530,   531,   532,   533,     0,   534,   535,
     536,   537,   538,   539,   540,     0,   541,   170,   171,     0,
     542,   543,   544,     0,   172,     0,   173,     0,   545,   174,
     175,   546,   176,   547,   548,   549,   550,   551,     0,     0,
     552,  1703,   178,   553,   179,     0,   554,   555,   556,  1704,
    1705,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     757,   566,   567,   758,   568,   569,   570,   184,   185,   186,
     571,   572,   573,   574,   575,   576,   577,   187,  1708,   578,
       0,   579,   580,   190,   581,     0,  1711,   582,   192,   583,
     584,   585,     0,   586,   587,     0,     0,   588,   589,   590,
       0,     0,   591,   592,   193,   194,   593,   195,  1714,   594,
     595,   596,   597,   598,   599,   600,   601,   602,     0,   603,
     604,  1715,   605,   198,   606,   607,   608,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   200,   619,
     620,   621,   622,     0,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,     0,   635,   636,   207,
     637,   638,   639,   640,   641,   209,   642,   643,   644,   645,
     646,   647,   648,   759,   649,     0,   650,   651,   652,   653,
     654,  1718,   656,   657,   214,   658,   659,   216,   660,   661,
     217,   662,     0,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,   674,   675,  1720,   676,     0,   677,
     678,     0,   679,   221,   680,   681,   682,   683,   684,     0,
     685,   222,   223,     0,     0,   687,   688,  1723,   689,  1724,
       0,   690,   691,   692,   693,   694,   695,   696,   697,     0,
       0,   698,   699,   700,   701,   702,  1727,     0,   703,   704,
     705,   706,   707,   760,   232,     0,   708,   233,   709,   710,
     711,   712,     0,     0,   713,     0,     0,   714,   715,   716,
     717,   718,   719,   235,  1729,  1730,  1731,  1732,   240,  1733,
    1734,  1735,  1736,   245,   761,   720,   721,     0,     0,     0,
       0,   785,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,  5978,    92,    93,    94,    95,    96,    97,
     786,    98,    99,   740,   787,     0,   101,   102,   103,   104,
     788,   789,   106,   107,   108,     0,   109,   790,   791,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,   126,   445,   446,   447,   128,   129,   130,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,   139,     0,   461,   462,   463,   464,   465,   142,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
     145,   474,   475,     0,     0,     0,     0,   146,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,   163,     0,   164,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
     529,   168,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   170,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,   174,   175,
     546,   176,   547,   548,   549,   550,   551,     0,     0,   552,
     177,   178,   553,   179,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,   185,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,   190,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,   194,   593,   195,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,   207,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,   216,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,   221,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,   233,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,     0,     0,     0,     0,
       0,    81,    82,   737,    84,    85,    86,   738,     0,   739,
      89,     0,  5567,    92,    93,    94,    95,    96,    97,     0,
      98,    99,   740,     0,     0,   101,   102,   103,   104,     0,
       0,   106,   107,   108,     0,   109,     0,     0,   741,   742,
       0,     0,     0,   743,   744,     0,     0,     0,     0,   745,
       0,     0,     0,     0,     0,     0,     0,     0,   746,     0,
     747,     0,   748,   749,    35,     0,     0,     0,    37,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   437,   438,   439,     0,     0,     0,
       0,     0,  4771,     0,   440,   441,     0,   442,   443,   444,
       0,   445,   446,   447,   128,   129,     0,   131,   132,     0,
     448,   449,   450,   451,   452,   453,     0,     0,   454,   455,
     751,   134,   456,     0,   457,   458,   459,   460,   138,     0,
       0,     0,   461,   462,   463,   464,   465,     0,   466,   467,
     752,     0,   468,   469,   470,   471,   472,   473,     0, -1810,
     474,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     477,   478,   479,   480,   754,   481,   149,   150,   482,     0,
     483,     0,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
       0,   499,   500,   501,     0,   502,   503,   504,     0,   505,
     506,   507,   508,   158,   509,   510,   511,   512,   160,     0,
     513,     0,   514,   515,   162,   516,     0,   517,     0,   518,
       0,     0, -1810,   519,   520,   521,   522,     0,   523,   166,
       0,   167,   524,   525,     0,   526,   527,   756,   528,   529,
       0,   530,   531,   532,   533,     0,   534,   535,   536,   537,
     538,   539,   540,     0,   541, -1810,   171,     0,   542,   543,
     544,     0,   172,     0,   173,     0,   545,     0,     0,   546,
   -1810,   547,   548,   549,   550,   551,     0,     0,   552,   177,
   -1810,   553,     0,     0,   554,   555,   556,     0,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   757,   566,
     567,   758,   568,   569,   570,   184, -1810,   186,   571,   572,
     573,   574,   575,   576,   577,   187,   188,   578,     0,   579,
     580,     0,   581,     0,   191,   582,   192,   583,   584,   585,
       0,   586,   587,     0,     0,   588,   589,   590,     0,     0,
     591,   592,   193,     0,   593,     0,   196,   594,   595,   596,
     597,   598,   599,   600,   601,   602,     0,   603,   604,   197,
     605,   198,   606,   607,   608,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   200,   619,   620,   621,
     622,     0,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,     0,   635,   636, -1810,   637,   638,
     639,   640,   641,   209,   642,   643,   644,   645,   646,   647,
     648,   759,   649,     0,   650,   651,   652,   653,   654,     0,
     656,   657,   214,   658,   659,     0,   660,   661,   217,   662,
       0,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   219,   676,     0,   677,   678,     0,
     679,     0,   680,   681,   682,   683,   684,     0,   685,   222,
     223,     0,     0,   687,   688,   224,   689,   225,     0,   690,
     691,   692,   693,   694,   695,   696,   697,     0,     0,   698,
     699,   700,   701,   702,     0,     0,   703,   704,   705,   706,
     707,   760,   232,     0,   708,     0,   709,   710,   711,   712,
       0,     0,   713,     0,     0,   714,   715,   716,   717,   718,
     719,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   761,   720,   721,     0,     0,     0,     0,     0,
       0,    81,    82,   737,    84,    85,    86,   738,     0,   739,
      89,     0,  1832,    92,    93,    94,    95,    96,    97,     0,
      98,    99,   740,     0,     0,   101,   102,   103,   104,     0,
       0,   106,   107,   108,     0,   109,     0,     0,   741,   742,
       0,     0,     0,   743,   744,     0,     0,     0,     0,   745,
       0,     0,     0,     0,     0,     0,     0,     0,   746,     0,
     747,     0,   748,   749,    35,   428,     0,     0,    37,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   437,   438,   439,     0,     0,     0,
       0,     0,     0,     0,   440,   441,     0,   442,   443,   444,
       0,   445,   446,   447,   128,   129,     0,   131,   132,     0,
     448,   449,   450,   451,   452,   453,     0,     0,   454,   455,
     751,   134,   456,     0,   457,   458,   459,   460,   138,     0,
       0,     0,   461,   462,   463,   464,   465,     0,   466,   467,
     752,     0,   468,   469,   470,   471,   472,   473,     0,     0,
     474,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     477,   478,   479,   480,   754,   481,   149,   150,   482,     0,
     483,     0,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
       0,   499,   500,   501,     0,   502,   503,   504,     0,   505,
     506,   507,   508,   158,   509,   510,   511,   512,   160,     0,
     513,     0,   514,   515,   162,   516,     0,   517,     0,   518,
       0,     0,     0,   519,   520,   521,   522,     0,   523,   166,
       0,   167,   524,   525,     0,   526,   527,   756,   528,   529,
       0,   530,   531,   532,   533,     0,   534,   535,   536,   537,
     538,   539,   540,     0,   541,     0,   171,     0,   542,   543,
     544,     0,   172,     0,   173,     0,   545,     0,     0,   546,
       0,   547,   548,   549,   550,   551,     0,     0,   552,   177,
       0,   553,     0,     0,   554,   555,   556,     0,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   757,   566,
     567,   758,   568,   569,   570,   184,     0,   186,   571,   572,
     573,   574,   575,   576,   577,   187,   188,   578,     0,   579,
     580,     0,   581,     0,   191,   582,   192,   583,   584,   585,
       0,   586,   587,     0,     0,   588,   589,   590,     0,     0,
     591,   592,   193,     0,   593,     0,   196,   594,   595,   596,
     597,   598,   599,   600,   601,   602,     0,   603,   604,   197,
     605,   198,   606,   607,   608,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   200,   619,   620,   621,
     622,     0,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,     0,   635,   636,     0,   637,   638,
     639,   640,   641,   209,   642,   643,   644,   645,   646,   647,
     648,   759,   649,   212,   650,   651,   652,   653,   654,     0,
     656,   657,   214,   658,   659,     0,   660,   661,   217,   662,
       0,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   219,   676,     0,   677,   678,   220,
     679,     0,   680,   681,   682,   683,   684,     0,   685,   222,
     223,     0,     0,   687,   688,   224,   689,   225,     0,   690,
     691,   692,   693,   694,   695,   696,   697,     0,     0,   698,
     699,   700,   701,   702,     0,     0,   703,   704,   705,   706,
     707,  2493,   232,     0,   708,     0,   709,   710,   711,   712,
       0,     0,   713,     0,   234,   714,   715,   716,   717,   718,
     719,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   761,   720,   721,     0,     0,   246,     0,     0,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,   247,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,   212,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,   220,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
    2493,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,   234,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,     0,     0,   246,     0,     0,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
     247,    92,    93,    94,    95,    96,    97,     0,    98,    99,
     740,     0,     0,   101,   102,   103,   104,     0,     0,   106,
     107,   108,     0,   109,     0,     0,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,     0,    39,
       0,     0,     0,     0,    40,     0,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,     0,
       0,     0,   440,   441,     0,   442,   443,   444,     0,   445,
     446,   447,   128,   129,     0,   131,   132,     0,   448,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   751,   134,
     456,     0,   457,   458,   459,   460,   138,     0,     0,     0,
     461,   462,   463,   464,   465,     0,   466,   467,   752,     0,
     468,   469,   470,   471,   472,   473,     0,     0,   474,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   477,   478,
     479,   480,   754,   481,   149,   150,   482,     0,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,   158,   509,   510,   511,   512,   160,     0,   513,     0,
     514,   515,   162,   516,     0,   517,     0,   518,     0,     0,
       0,   519,   520,   521,   522,     0,   523,   166,     0,   167,
     524,   525,     0,   526,   527,   756,   528,   529,     0,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,     0,   171,     0,   542,   543,   544,     0,
     172,     0,   173,     0,   545,     0,     0,   546,     0,   547,
     548,   549,   550,   551,     0,     0,   552,   177,     0,   553,
       0,     0,   554,   555,   556,     0,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,   184,     0,   186,   571,   572,   573,   574,
     575,   576,   577,   187,   188,   578,     0,   579,   580,     0,
     581,     0,   191,   582,   192,   583,   584,   585,     0,   586,
     587,     0,     0,   588,   589,   590,     0,     0,   591,   592,
     193,     0,   593,     0,   196,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,   197,   605,   198,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   200,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,     0,   637,   638,   639,   640,
     641,   209,   642,   643,   644,   645,   646,   647,   648,   759,
     649,     0,   650,   651,   652,   653,   654,     0,   656,   657,
     214,   658,   659,     0,   660,   661,   217,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   219,   676,     0,   677,   678,     0,   679,     0,
     680,   681,   682,   683,   684,     0,   685,   222,   223,     0,
       0,   687,   688,   224,   689,   225,     0,   690,   691,   692,
     693,   694,   695,   696,   697,     0,     0,   698,   699,   700,
     701,   702,     0,     0,   703,   704,   705,   706,   707,   760,
     232,     0,   708,     0,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     761,   720,   721,     0,     0,     0,     0,     0,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,  3980,  3981,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,    39,     0,
       0,     0,     0,    40,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,     0,     0,     0,     0,     0,    81,    82,   737,
      84,    85,    86,   738,     0,   739,    89,     0,  3981,    92,
      93,    94,    95,    96,    97,     0,    98,    99,   740,     0,
       0,   101,   102,   103,   104,     0,     0,   106,   107,   108,
       0,   109,     0,     0,   741,   742,     0,     0,     0,   743,
     744,     0,     0,     0,     0,   745,     0,     0,     0,     0,
       0,     0,     0,     0,   746,     0,   747,     0,   748,   749,
      35,     0,     0,     0,    37,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     437,   438,   439,     0,     0,     0,     0,     0,     0,     0,
     440,   441,     0,   442,   443,   444,     0,   445,   446,   447,
     128,   129,     0,   131,   132,     0,   448,   449,   450,   451,
     452,   453,     0,     0,   454,   455,   751,   134,   456,     0,
     457,   458,   459,   460,   138,     0,     0,     0,   461,   462,
     463,   464,   465,     0,   466,   467,   752,     0,   468,   469,
     470,   471,   472,   473,     0,     0,   474,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   477,   478,   479,   480,
     754,   481,   149,   150,   482,     0,   483,     0,   484,   485,
     486,   487,   488,   489,     0,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,     0,   499,   500,   501,
       0,   502,   503,   504,     0,   505,   506,   507,   508,   158,
     509,   510,   511,   512,   160,     0,   513,     0,   514,   515,
     162,   516,     0,   517,     0,   518,     0,     0,     0,   519,
     520,   521,   522,     0,   523,   166,     0,   167,   524,   525,
       0,   526,   527,   756,   528,   529,     0,   530,   531,   532,
     533,     0,   534,   535,   536,   537,   538,   539,   540,     0,
     541,     0,   171,     0,   542,   543,   544,     0,   172,     0,
     173,     0,   545,     0,     0,   546,     0,   547,   548,   549,
     550,   551,     0,     0,   552,   177,     0,   553,     0,     0,
     554,   555,   556,     0,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   757,   566,   567,   758,   568,   569,
     570,   184,     0,   186,   571,   572,   573,   574,   575,   576,
     577,   187,   188,   578,     0,   579,   580,     0,   581,     0,
     191,   582,   192,   583,   584,   585,     0,   586,   587,     0,
       0,   588,   589,   590,     0,     0,   591,   592,   193,     0,
     593,     0,   196,   594,   595,   596,   597,   598,   599,   600,
     601,   602,     0,   603,   604,   197,   605,   198,   606,   607,
     608,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   200,   619,   620,   621,   622,     0,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
       0,   635,   636,     0,   637,   638,   639,   640,   641,   209,
     642,   643,   644,   645,   646,   647,   648,   759,   649,     0,
     650,   651,   652,   653,   654,     0,   656,   657,   214,   658,
     659,     0,   660,   661,   217,   662,     0,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,   674,   675,
     219,   676,     0,   677,   678,     0,   679,     0,   680,   681,
     682,   683,   684,     0,   685,   222,   223,     0,     0,   687,
     688,   224,   689,   225,     0,   690,   691,   692,   693,   694,
     695,   696,   697,     0,     0,   698,   699,   700,   701,   702,
       0,     0,   703,   704,   705,   706,   707,   760,   232,     0,
     708,     0,   709,   710,   711,   712,     0,     0,   713,     0,
       0,   714,   715,   716,   717,   718,   719,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   761,   720,
     721,     0,     0,     0,     0,     0,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,  1813,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
       0,     0,     0,     0,     0,    81,    82,   737,    84,    85,
      86,   738,     0,   739,    89,     0,  3490,    92,    93,    94,
      95,    96,    97,     0,    98,    99,   740,     0,     0,   101,
     102,   103,   104,     0,     0,   106,   107,   108,     0,   109,
       0,     0,   741,   742,     0,     0,     0,   743,   744,     0,
       0,     0,     0,   745,     0,     0,     0,     0,     0,     0,
       0,     0,   746,     0,   747,     0,   748,   749,    35,     0,
       0,     0,    37,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   429,
     430,   431,   432,   433,   434,   435,   436,     0,   437,   438,
     439,     0,     0,     0,     0,     0,     0,     0,   440,   441,
       0,   442,   443,   444,     0,   445,   446,   447,   128,   129,
       0,   131,   132,     0,   448,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   751,   134,   456,     0,   457,   458,
     459,   460,   138,     0,     0,     0,   461,   462,   463,   464,
     465,     0,   466,   467,   752,     0,   468,   469,   470,   471,
     472,   473,     0,     0,   474,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   477,   478,   479,   480,   754,   481,
     149,   150,   482,     0,   483,     0,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,     0,   499,   500,   501,     0,   502,
     503,   504,     0,   505,   506,   507,   508,   158,   509,   510,
     511,   512,   160,     0,   513,     0,   514,   515,   162,   516,
       0,   517,     0,   518,     0,     0,     0,   519,   520,   521,
     522,     0,   523,   166,     0,   167,   524,   525,     0,   526,
     527,   756,   528,   529,     0,   530,   531,   532,   533,     0,
     534,   535,   536,   537,   538,   539,   540,     0,   541,     0,
     171,     0,   542,   543,   544,     0,   172,     0,   173,     0,
     545,     0,     0,   546,     0,   547,   548,   549,   550,   551,
       0,     0,   552,   177,     0,   553,     0,     0,   554,   555,
     556,     0,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   757,   566,   567,   758,   568,   569,   570,   184,
       0,   186,   571,   572,   573,   574,   575,   576,   577,   187,
     188,   578,     0,   579,   580,     0,   581,     0,   191,   582,
     192,   583,   584,   585,     0,   586,   587,     0,     0,   588,
     589,   590,     0,     0,   591,   592,   193,     0,   593,     0,
     196,   594,   595,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,   197,   605,   198,   606,   607,   608,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     200,   619,   620,   621,   622,     0,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,     0,   635,
     636,     0,   637,   638,   639,   640,   641,   209,   642,   643,
     644,   645,   646,   647,   648,   759,   649,     0,   650,   651,
     652,   653,   654,     0,   656,   657,   214,   658,   659,     0,
     660,   661,   217,   662,     0,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,   674,   675,   219,   676,
       0,   677,   678,     0,   679,     0,   680,   681,   682,   683,
     684,     0,   685,   222,   223,     0,     0,   687,   688,   224,
     689,   225,     0,   690,   691,   692,   693,   694,   695,   696,
     697,     0,     0,   698,   699,   700,   701,   702,     0,     0,
     703,   704,   705,   706,   707,   760,   232,     0,   708,     0,
     709,   710,   711,   712,     0,     0,   713,     0,     0,   714,
     715,   716,   717,   718,   719,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   761,   720,   721,     0,
       0,     0,     0,     0,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,  4750,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,     0,     0,
       0,     0,   785,    81,    82,   737,    84,    85,    86,   738,
       0,   739,    89,     0,  5236,    92,    93,    94,    95,    96,
      97,   786,    98,    99,   740,   787,     0,   101,   102,   103,
     104,   788,   789,   106,   107,   108,     0,   109,   790,   791,
     741,   742,     0,     0,     0,   743,   744,     0,     0,     0,
       0,   745,     0,     0,     0,     0,     0,     0,     0,     0,
     746,     0,   747,     0,   748,   749,    35,   428,     0,     0,
      37,     0,    38,    39,     0,     0,     0,  1303,    40,     0,
       0,     0,     0,     0,  1304,  1305,  1306,   429,   430,   431,
     432,   433,   434,   435,   436,   792,   437,   438,   439,   793,
     794,   795,   796,   797,   798,   799,   440,   441,   800,   442,
     443,   444,   126,   445,   446,   447,     0,  1492,   130,  1493,
    1494,   801,   448,   449,   450,   451,   452,   453,   802,   803,
     454,   455,  1495,  1496,   456,   805,   457,   458,   459,   460,
       0,   806,   139,   807,   461,   462,   463,   464,   465,   142,
     466,   467,   752,   809,   468,   469,   470,   471,   472,   473,
     810,   145,   474,   475,     0,   812,   813,   814,   146,   815,
     816,   817,   477,   478,   479,   480,   754,   481,  1497,  1498,
     482,   818,   483,   819,   484,   485,   486,   487,   488,   489,
     820,   490,   491,   492,   493,   821,   822,   494,   495,  1499,
     497,   498,   823,   499,   500,   501,   824,   502,   503,   504,
     825,   505,   506,   507,   508,     0,   509,   510,   511,   512,
       0,   826,   513,   827,   514,   515,  1500,   516,   828,   517,
     829,   518,   163,   830,   164,   519,   520,   521,   522,   831,
     523,     0,   832,     0,   524,   525,   833,   526,   527,   756,
     528,   529,   168,   530,   531,   532,   533,   834,   534,   535,
     536,   537,   538,   539,   540,   835,   541,   170,     0,     0,
     542,   543,   544,  1502,  1503,   838,  1504,   839,   545,   174,
     175,   546,   176,   547,   548,   549,   550,   551,   840,   841,
     552,     0,   178,   553,   179,   842,   554,   555,   556,   843,
     844,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     757,   566,   567,   758,   568,   569,   570,  1505,   185,  1506,
     571,   572,   573,   574,   575,   576,   577,  4490,     0,   578,
     845,   579,   580,   190,   581,   846,     0,   582,  1507,   583,
     584,   585,   847,   586,   587,   848,   849,  4491,   589,   590,
     850,   851,   591,   592,     0,   194,   593,   195,     0,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   852,   603,
     604,     0,   605,     0,   606,   607,   608,   853,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,  1508,   619,
     620,   621,   622,   854,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   855,   635,   636,   207,
     637,   638,   639,   640,   641,     0,   642,   643,   644,   645,
     646,   647,   648,   759,   649,   856,   650,   651,   652,   653,
     654,   857,   656,   657,  2709,   658,   659,   216,   660,   661,
    1510,   662,   858,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,   674,   675,     0,   676,   859,   677,
     678,   860,   679,   221,   680,   681,   682,   683,   684,   861,
     685,  1511,  1512,     0,   863,   687,   688,     0,   689,     0,
     864,   690,   691,   692,   693,   694,   695,   696,   697,     0,
     866,   698,   699,   700,   701,   702,   867,   868,   703,   704,
     705,   706,   707,     0,  1513,   870,   708,   233,   709,   710,
     711,   712,   871,   872,   713,   873,   874,   714,   715,   716,
     717,   718,   719,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   761,   720,   721,     0,     0,     0,
    1309,  1310,  1311,     0,  4492,  4493,  1314,  1315,  1316,  1317,
     785,    81,    82,   737,    84,    85,    86,   738,     0,   739,
      89,     0,     0,    92,    93,    94,    95,    96,    97,   786,
      98,    99,   740,   787,     0,   101,   102,   103,   104,   788,
     789,   106,   107,   108,     0,   109,   790,   791,   741,   742,
       0,     0,     0,   743,   744,     0,     0,     0,     0,   745,
       0,     0,     0,     0,     0,     0,     0,     0,   746,     0,
     747,     0,   748,   749,    35,   428,     0,     0,    37,     0,
      38,    39,     0,     0,     0,  1303,    40,     0,     0,     0,
       0,     0,  1304,  1305,  1306,   429,   430,   431,   432,   433,
     434,   435,   436,   792,   437,   438,   439,   793,   794,   795,
     796,   797,   798,   799,   440,   441,   800,   442,   443,   444,
     126,   445,   446,   447,     0,  1492,   130,  1493,  1494,   801,
     448,   449,   450,   451,   452,   453,   802,   803,   454,   455,
    1495,  1496,   456,   805,   457,   458,   459,   460,     0,   806,
     139,   807,   461,   462,   463,   464,   465,   142,   466,   467,
     752,   809,   468,   469,   470,   471,   472,   473,   810,   145,
     474,   475,     0,   812,   813,   814,   146,   815,   816,   817,
     477,   478,   479,   480,   754,   481,  1497,  1498,   482,   818,
     483,   819,   484,   485,   486,   487,   488,   489,   820,   490,
     491,   492,   493,   821,   822,   494,   495,  1499,   497,   498,
     823,   499,   500,   501,   824,   502,   503,   504,   825,   505,
     506,   507,   508,     0,   509,   510,   511,   512,     0,   826,
     513,   827,   514,   515,  1500,   516,   828,   517,   829,   518,
     163,   830,   164,   519,   520,   521,   522,   831,   523,     0,
     832,     0,   524,   525,   833,   526,   527,   756,   528,   529,
     168,   530,   531,   532,   533,   834,   534,   535,   536,   537,
     538,   539,   540,   835,   541,   170,     0,     0,   542,   543,
     544,  1502,  1503,   838,  1504,   839,   545,   174,   175,   546,
     176,   547,   548,   549,   550,   551,   840,   841,   552,     0,
     178,   553,   179,   842,   554,   555,   556,   843,   844,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   757,   566,
     567,   758,   568,   569,   570,  1505,   185,  1506,   571,   572,
     573,   574,   575,   576,   577,  4939,     0,   578,   845,   579,
     580,   190,   581,   846,     0,   582,  1507,   583,   584,   585,
     847,   586,   587,   848,   849,  4491,   589,   590,   850,   851,
     591,   592,     0,   194,   593,   195,     0,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   852,   603,   604,     0,
     605,     0,   606,   607,   608,   853,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,  1508,   619,   620,   621,
     622,   854,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   855,   635,   636,   207,   637,   638,
     639,   640,   641,     0,   642,   643,   644,   645,   646,   647,
     648,   759,   649,   856,   650,   651,   652,   653,   654,   857,
     656,   657,  2709,   658,   659,   216,   660,   661,  1510,   662,
     858,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,     0,   676,   859,   677,   678,   860,
     679,   221,   680,   681,   682,   683,   684,   861,   685,  1511,
    1512,     0,   863,   687,   688,     0,   689,     0,   864,   690,
     691,   692,   693,   694,   695,   696,   697,     0,   866,   698,
     699,   700,   701,   702,   867,   868,   703,   704,   705,   706,
     707,     0,  1513,   870,   708,   233,   709,   710,   711,   712,
     871,   872,   713,   873,   874,   714,   715,   716,   717,   718,
     719,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   761,   720,   721,     0,     0,     0,  1309,  1310,
    1311,     0,  4492,  4493,  1314,  1315,  1316,  1317,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,  1303,     0,     0,     0,     0,     0,     0,  1304,
    1305,  1306,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,  1307,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,  1308,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,     0,     0,     0,  1309,  1310,  1311,     0,  1312,
    1313,  1314,  1315,  1316,  1317,    81,    82,   737,    84,    85,
      86,   738,     0,   739,    89,     0,     0,    92,    93,    94,
      95,    96,    97,     0,    98,    99,   740,     0,     0,   101,
     102,   103,   104,     0,     0,   106,   107,   108,     0,   109,
       0,     0,   741,   742,     0,     0,     0,   743,   744,     0,
       0,     0,     0,   745,     0,     0,     0,     0,     0,     0,
       0,     0,   746,     0,   747,     0,   748,   749,    35,     0,
       0,     0,    37,     0,     0,     0,     0,     0,     0,  1303,
       0,     0,     0,     0,     0,     0,  1304,  1305,  1306,   429,
     430,   431,   432,   433,   434,   435,   436,     0,   437,   438,
     439,     0,     0,     0,     0,     0,     0,     0,   440,   441,
       0,   442,   443,   444,     0,   445,   446,   447,   128,   129,
       0,   131,   132,     0,   448,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   751,   134,   456,     0,   457,  1435,
     459,   460,   138,     0,     0,     0,   461,   462,   463,   464,
     465,     0,   466,   467,   752,     0,   468,   469,   470,   471,
     472,   473,     0,     0,   474,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   477,   478,   479,   480,   754,   481,
     149,   150,   482,     0,   483,     0,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,     0,   499,   500,   501,     0,   502,
     503,   504,     0,   505,   506,   507,   508,   158,   509,   510,
     511,   512,   160,     0,  1436,     0,   514,   515,   162,   516,
       0,   517,     0,   518,     0,     0,     0,   519,   520,   521,
     522,     0,   523,   166,     0,   167,   524,   525,     0,   526,
     527,   756,   528,   529,     0,   530,   531,   532,   533,     0,
     534,   535,   536,   537,   538,   539,   540,     0,   541,     0,
     171,     0,   542,   543,   544,     0,   172,     0,   173,     0,
     545,     0,     0,   546,     0,   547,   548,   549,   550,   551,
       0,     0,   552,   177,     0,   553,     0,     0,   554,   555,
     556,     0,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   757,   566,   567,   758,   568,   569,   570,   184,
       0,   186,   571,   572,   573,   574,   575,   576,   577,   187,
     188,   578,     0,   579,   580,     0,   581,     0,   191,   582,
     192,   583,   584,   585,     0,   586,   587,     0,     0,   588,
     589,   590,     0,     0,   591,   592,   193,     0,   593,     0,
     196,   594,   595,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,   197,   605,   198,   606,   607,   608,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     200,   619,   620,   621,   622,     0,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,     0,   635,
     636,     0,   637,   638,   639,   640,   641,   209,   642,   643,
     644,   645,   646,   647,   648,   759,   649,     0,   650,   651,
     652,   653,   654,     0,   656,   657,   214,   658,   659,     0,
     660,   661,   217,   662,     0,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,   674,   675,   219,   676,
       0,   677,   678,     0,   679,     0,   680,   681,   682,   683,
     684,     0,   685,   222,   223,     0,     0,   687,   688,   224,
     689,   225,     0,   690,   691,   692,   693,   694,   695,   696,
     697,     0,     0,   698,   699,   700,   701,   702,     0,     0,
     703,   704,   705,   706,   707,   760,   232,     0,   708,     0,
     709,   710,   711,   712,     0,     0,   713,     0,     0,   714,
     715,   716,   717,   718,   719,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   761,   720,   721,     0,
       0,     0,  1309,  1310,  1311,     0,  1312,  1313,  1314,  1315,
    1316,  1317,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,  1303,     0,     0,     0,
       0,     0,     0,  1304,  1305,  1306,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,  1544,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,  1545,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
    1546,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,     0,     0,     0,  1309,
    1310,  1311,     0,  1312,  1313,  1314,  1315,  1316,  1317,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,     0,    98,    99,
     740,     0,     0,   101,   102,   103,   104,     0,     0,   106,
     107,   108,     0,   109,     0,     0,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,     0,     0,
       0,     0,     0,  1303,     0,     0,     0,     0,     0,     0,
    1304,  1305,  1306,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,     0,
       0,     0,   440,   441,     0,   442,   443,   444,     0,   445,
     446,   447,   128,   129,     0,   131,   132,     0,   448,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   751,   134,
     456,     0,   457,  2177,   459,   460,   138,     0,     0,     0,
     461,   462,   463,   464,   465,     0,   466,   467,   752,     0,
     468,   469,   470,   471,   472,   473,     0,     0,   474,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   477,   478,
     479,   480,   754,   481,   149,   150,   482,     0,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,   158,   509,   510,   511,   512,   160,     0,  2178,     0,
     514,   515,   162,   516,     0,   517,     0,   518,     0,     0,
       0,   519,   520,   521,   522,     0,   523,   166,     0,   167,
     524,   525,     0,   526,   527,   756,   528,   529,     0,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,     0,   171,     0,   542,   543,   544,     0,
     172,     0,   173,     0,   545,     0,     0,   546,     0,   547,
     548,   549,   550,   551,     0,     0,   552,   177,     0,   553,
       0,     0,   554,   555,   556,     0,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,   184,     0,   186,   571,   572,   573,   574,
     575,   576,   577,   187,   188,   578,     0,   579,   580,     0,
     581,     0,   191,   582,   192,   583,   584,   585,     0,   586,
     587,     0,     0,   588,   589,   590,     0,     0,   591,   592,
     193,     0,   593,     0,   196,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,   197,   605,   198,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   200,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,     0,   637,   638,   639,   640,
     641,   209,   642,   643,   644,   645,   646,   647,   648,   759,
     649,     0,   650,   651,   652,   653,   654,     0,   656,   657,
     214,   658,   659,     0,   660,   661,   217,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   219,   676,     0,   677,   678,     0,   679,     0,
     680,   681,   682,   683,   684,     0,   685,   222,   223,     0,
       0,   687,   688,   224,   689,   225,     0,   690,   691,   692,
     693,   694,   695,   696,   697,     0,     0,   698,   699,   700,
     701,   702,     0,     0,   703,   704,   705,   706,   707,   760,
     232,     0,   708,     0,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     761,   720,   721,     0,     0,     0,  1309,  1310,  1311,     0,
    1312,  1313,  1314,  1315,  1316,  1317,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
    1303,     0,     0,     0,     0,     0,     0,  1304,  1305,  1306,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
       0,     0,     0,  1309,  1310,  1311,     0,  1312,  1313,  1314,
    1315,  1316,  1317,    81,    82,   737,    84,    85,    86,   738,
       0,   739,    89,     0,     0,    92,    93,    94,    95,    96,
      97,     0,    98,    99,   740,     0,     0,   101,   102,   103,
     104,     0,     0,   106,   107,   108,     0,   109,     0,     0,
     741,   742,     0,     0,     0,   743,   744,     0,     0,     0,
       0,   745,     0,     0,     0,     0,     0,     0,     0,     0,
     746,     0,   747,     0,   748,   749,    35,     0,     0,     0,
      37,     0,     0,     0,     0,     0,     0,  1303,     0,     0,
       0,     0,     0,     0,  1304,  1305,  1306,   429,   430,   431,
     432,   433,   434,   435,   436,     0,   437,   438,   439,     0,
       0,     0,     0,     0,     0,     0,   440,   441,     0,   442,
     443,   444,     0,   445,   446,   447,   128,   129,     0,   131,
     132,     0,   448,   449,   450,   451,   452,   453,     0,     0,
     454,   455,   751,   134,   456,     0,   457,  3591,   459,   460,
     138,     0,     0,     0,   461,   462,   463,   464,   465,     0,
     466,   467,   752,     0,   468,   469,   470,   471,   472,   473,
       0,     0,   474,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   477,   478,   479,   480,   754,   481,   149,   150,
     482,     0,   483,     0,   484,   485,   486,   487,   488,   489,
       0,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,     0,   499,   500,   501,     0,   502,   503,   504,
       0,   505,   506,   507,   508,   158,   509,   510,   511,   512,
     160,     0,  3592,     0,   514,   515,   162,   516,     0,   517,
       0,   518,     0,     0,     0,   519,   520,   521,   522,     0,
     523,   166,     0,   167,   524,   525,     0,   526,   527,   756,
     528,   529,     0,   530,   531,   532,   533,     0,   534,   535,
     536,   537,   538,   539,   540,     0,   541,     0,   171,     0,
     542,   543,   544,     0,   172,     0,   173,     0,   545,     0,
       0,   546,     0,   547,   548,   549,   550,   551,     0,     0,
     552,   177,     0,   553,     0,     0,   554,   555,   556,     0,
       0,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     757,   566,   567,   758,   568,   569,   570,   184,     0,   186,
     571,   572,   573,   574,   575,   576,   577,   187,   188,   578,
       0,   579,   580,     0,   581,     0,   191,   582,   192,   583,
     584,   585,     0,   586,   587,     0,     0,   588,   589,   590,
       0,     0,   591,   592,   193,     0,   593,     0,   196,   594,
     595,   596,   597,   598,   599,   600,   601,   602,     0,   603,
     604,   197,   605,   198,   606,   607,   608,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   200,   619,
     620,   621,   622,     0,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,     0,   635,   636,     0,
     637,   638,   639,   640,   641,   209,   642,   643,   644,   645,
     646,   647,   648,   759,   649,     0,   650,   651,   652,   653,
     654,     0,   656,   657,   214,   658,   659,     0,   660,   661,
     217,   662,     0,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,   674,   675,   219,   676,     0,   677,
     678,     0,   679,     0,   680,   681,   682,   683,   684,     0,
     685,   222,   223,     0,     0,   687,   688,   224,   689,   225,
       0,   690,   691,   692,   693,   694,   695,   696,   697,     0,
       0,   698,   699,   700,   701,   702,     0,     0,   703,   704,
     705,   706,   707,   760,   232,     0,   708,     0,   709,   710,
     711,   712,     0,     0,   713,     0,     0,   714,   715,   716,
     717,   718,   719,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   761,   720,   721,     0,     0,     0,
    1309,  1310,  1311,     0,  1312,  1313,  1314,  1315,  1316,  1317,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,  1303,     0,     0,     0,     0,     0,
       0,  1304,  1305,  1306,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,  5544,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,     0,     0,     0,  1309,  1310,  1311,
       0,  1312,  1313,  1314,  1315,  1316,  1317,   785,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,   786,    98,    99,   740,
     787,     0,   101,   102,   103,   104,   788,   789,   106,   107,
     108,     0,   109,   790,   791,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     792,   437,   438,   439,   793,   794,   795,   796,   797,   798,
     799,   440,   441,   800,   442,   443,   444,   126,   445,   446,
     447,   128,   129,   130,   131,   132,   801,   448,   449,   450,
     451,   452,   453,   802,   803,   454,   455,   804,   134,   456,
     805,   457,   458,   459,   460,   138,   806,   139,   807,   461,
     462,   463,   464,   465,   142,   466,   467,   808,   809,   468,
     469,   470,   471,   472,   473,   810,   145,   474,   475,   811,
     812,   813,   814,   146,   815,   816,   817,   477,   478,   479,
     480,   754,   481,   149,   150,   482,   818,   483,   819,   484,
     485,   486,   487,   488,   489,   820,   490,   491,   492,   493,
     821,   822,   494,   495,   496,   497,   498,   823,   499,   500,
     501,   824,   502,   503,   504,   825,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,   826,   513,   827,   514,
     515,   162,   516,   828,   517,   829,   518,   163,   830,   164,
     519,   520,   521,   522,   831,   523,   166,   832,   167,   524,
     525,   833,   526,   527,   756,   528,   529,   168,   530,   531,
     532,   533,   834,   534,   535,   536,   537,   538,   539,   540,
     835,   541,   170,   171,   836,   542,   543,   544,   837,   172,
     838,   173,   839,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,   840,   841,   552,   177,   178,   553,   179,
     842,   554,   555,   556,   843,   844,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,   185,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,   845,   579,   580,   190,   581,
     846,   191,   582,   192,   583,   584,   585,   847,   586,   587,
     848,   849,   588,   589,   590,   850,   851,   591,   592,   193,
     194,   593,   195,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   852,   603,   604,   197,   605,   198,   606,
     607,   608,   853,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,   854,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   855,   635,   636,   207,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
     856,   650,   651,   652,   653,   654,   857,   656,   657,   214,
     658,   659,   216,   660,   661,   217,   662,   858,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,   859,   677,   678,   860,   679,   221,   680,
     681,   682,   683,   684,   861,   685,   222,   223,   862,   863,
     687,   688,   224,   689,   225,   864,   690,   691,   692,   693,
     694,   695,   696,   697,   865,   866,   698,   699,   700,   701,
     702,   867,   868,   703,   704,   705,   706,   707,   869,   232,
     870,   708,   233,   709,   710,   711,   712,   871,   872,   713,
     873,   874,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,     0,   785,    81,    82,   737,    84,    85,    86,
     738,  2159,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,     0,  1492,   130,
    1493,  1494,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,  1495,  1496,   456,     0,   457,   458,   459,
     460,     0,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,     0,   477,   478,   479,   480,   754,   481,  1497,
    1498,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
    1499,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,     0,   509,   510,   511,
     512,     0,     0,   513,     0,   514,   515,  1500,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,     0,     0,     0,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,  2705,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,  2706,
       0,   542,   543,   544,  1502,  1503,     0,  1504,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,     0,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,  1505,   185,
    1506,   571,   572,   573,   574,   575,   576,   577,     0,     0,
     578,     0,   579,   580,   190,   581,     0,     0,   582,  1507,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,  2707,   591,   592,  2708,   194,   593,   195,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,     0,   605,     0,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,  1508,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,  2709,   658,   659,   216,   660,
     661,  1510,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,     0,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,  1511,  1512,     0,     0,   687,   688,     0,   689,
       0,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,     0,  1513,  2710,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   761,   720,   721,     0,     0,
      81,    82,   737,    84,    85,    86,   738,  2711,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,     0,     0,    81,    82,   737,    84,
      85,    86,   738,  1188,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
       0,     0,    81,    82,   737,    84,    85,    86,   738,  5943,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,   428,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,    40,     0,     0,
       0,     0,     0,     0,     0,     0,   429,  1078,   431,   432,
     433,   434,   435,   436,  1079,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,  1080,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,  1081,   162,   516,     0,   517,     0,
    1082,     0,  1083,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
     529,     0,   530,   531,   532,   533,  1084,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,  1085,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
    1086,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,  1087,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,  1088,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,     0,     0,     0,     0,
       0,     0,     0,  1089,  1090,    81,    82,   737,    84,    85,
      86,   738,     0,   739,    89,     0,     0,    92,    93,    94,
      95,    96,    97,     0,    98,    99,   740,     0,     0,   101,
     102,   103,   104,     0,     0,   106,   107,   108,     0,   109,
       0,     0,   741,   742,     0,     0,     0,   743,   744,     0,
       0,     0,     0,   745,     0,     0,     0,     0,     0,     0,
       0,     0,   746,     0,   747,     0,   748,   749,    35,   428,
       0,     0,    37,     0,     0,     0,     0,     0,     0,     0,
      40,     0,     0,     0,     0,     0,     0,     0,     0,   429,
    1078,   431,   432,   433,   434,   435,   436,  1079,   437,   438,
     439,     0,     0,     0,     0,     0,     0,     0,   440,   441,
       0,   442,   443,   444,     0,  1112,   446,   447,   128,   129,
       0,   131,   132,     0,   448,   449,   450,   451,   452,   453,
       0,     0,   454,   455,   751,   134,   456,     0,   457,   458,
     459,   460,   138,     0,     0,     0,   461,   462,   463,   464,
     465,     0,   466,   467,   752,     0,   468,   469,   470,   471,
     472,   473,     0,     0,   474,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   477,   478,   479,   480,   754,   481,
     149,   150,   482,     0,   483,     0,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,     0,   499,   500,   501,     0,   502,
     503,   504,     0,   505,   506,   507,   508,   158,   509,   510,
     511,   512,   160,     0,   513,     0,   514,  1081,   162,   516,
       0,   517,     0,  1113,     0,  1083,     0,   519,   520,   521,
     522,     0,   523,   166,     0,   167,   524,   525,     0,   526,
     527,   756,   528,   529,     0,   530,   531,   532,   533,  1084,
     534,   535,   536,   537,   538,   539,   540,     0,   541,     0,
     171,     0,   542,   543,   544,     0,   172,     0,   173,     0,
     545,     0,     0,   546,     0,   547,   548,   549,   550,  1085,
       0,     0,   552,   177,     0,   553,     0,     0,   554,   555,
     556,     0,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   757,   566,   567,   758,   568,   569,   570,   184,
       0,   186,   571,  1086,   573,   574,   575,   576,   577,   187,
     188,   578,     0,   579,   580,     0,   581,     0,   191,   582,
     192,   583,   584,   585,     0,   586,   587,     0,     0,   588,
     589,   590,     0,     0,   591,   592,   193,     0,   593,     0,
     196,   594,   595,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,   197,   605,   198,   606,   607,   608,     0,
    1087,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     200,   619,   620,   621,   622,     0,   623,   624,   625,  1088,
     627,   628,   629,   630,   631,   632,   633,   634,     0,   635,
     636,     0,   637,   638,   639,   640,   641,   209,   642,   643,
     644,   645,   646,   647,   648,   759,   649,     0,   650,   651,
     652,   653,   654,     0,   656,   657,   214,   658,   659,     0,
     660,   661,   217,   662,     0,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,   674,   675,   219,   676,
       0,   677,   678,     0,   679,     0,   680,   681,   682,   683,
     684,     0,   685,   222,   223,     0,     0,   687,   688,   224,
     689,   225,     0,   690,   691,   692,   693,   694,   695,   696,
     697,     0,     0,   698,   699,   700,   701,   702,     0,     0,
     703,   704,   705,   706,   707,   760,   232,     0,   708,     0,
     709,   710,   711,   712,     0,     0,   713,     0,     0,   714,
     715,   716,   717,   718,   719,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   761,   720,   721,     0,
       0,     0,     0,     0,     0,     0,  1089,  1090,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,   428,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,    40,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
    1602,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,  1083,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,  1084,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,     0,     0,     0,     0,     0,     0,     0,  1089,
    1090,    81,    82,   737,    84,    85,    86,   738,     0,   739,
      89,     0,     0,    92,    93,    94,    95,    96,    97,     0,
      98,    99,   740,     0,     0,   101,   102,   103,   104,     0,
       0,   106,   107,   108,     0,   109,     0,     0,   741,   742,
       0,     0,     0,   743,   744,     0,     0,     0,     0,   745,
       0,     0,     0,     0,     0,     0,     0,     0,   746,     0,
     747,     0,   748,   749,    35,   428,     0,     0,    37,     0,
       0,     0,     0,     0,     0,     0,    40,     0,     0,     0,
       0,     0,     0,     0,     0,   429,   430,   431,   432,   433,
     434,   435,   436,  1607,   437,   438,   439,     0,     0,     0,
       0,     0,     0,     0,   440,   441,     0,   442,   443,   444,
       0,   445,   446,   447,   128,   129,     0,   131,   132,     0,
     448,   449,   450,   451,   452,   453,     0,     0,   454,   455,
     751,   134,   456,     0,   457,   458,   459,   460,   138,     0,
       0,     0,   461,   462,   463,   464,   465,     0,   466,   467,
     752,     0,   468,   469,   470,   471,   472,   473,     0,     0,
     474,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     477,   478,   479,   480,   754,   481,   149,   150,   482,     0,
     483,     0,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
       0,   499,   500,   501,     0,   502,   503,   504,     0,   505,
     506,   507,   508,   158,   509,   510,   511,   512,   160,     0,
     513,     0,   514,   515,   162,   516,     0,   517,     0,   518,
       0,  1083,     0,   519,   520,   521,   522,     0,   523,   166,
       0,   167,   524,   525,     0,   526,   527,   756,   528,   529,
       0,   530,   531,   532,   533,  1084,   534,   535,   536,   537,
     538,   539,   540,     0,   541,     0,   171,     0,   542,   543,
     544,     0,   172,     0,   173,     0,   545,     0,     0,   546,
       0,   547,   548,   549,   550,   551,     0,     0,   552,   177,
       0,   553,     0,     0,   554,   555,   556,     0,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   757,   566,
     567,   758,   568,   569,   570,   184,     0,   186,   571,   572,
     573,   574,   575,   576,   577,   187,   188,   578,     0,   579,
     580,     0,   581,     0,   191,   582,   192,   583,   584,   585,
       0,   586,   587,     0,     0,   588,   589,   590,     0,     0,
     591,   592,   193,     0,   593,     0,   196,   594,   595,   596,
     597,   598,   599,   600,   601,   602,     0,   603,   604,   197,
     605,   198,   606,   607,   608,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   200,   619,   620,   621,
     622,     0,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,     0,   635,   636,     0,   637,   638,
     639,   640,   641,   209,   642,   643,   644,   645,   646,   647,
     648,   759,   649,     0,   650,   651,   652,   653,   654,     0,
     656,   657,   214,   658,   659,     0,   660,   661,   217,   662,
       0,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   219,   676,     0,   677,   678,     0,
     679,     0,   680,   681,   682,   683,   684,     0,   685,   222,
     223,     0,     0,   687,   688,   224,   689,   225,     0,   690,
     691,   692,   693,   694,   695,   696,   697,     0,     0,   698,
     699,   700,   701,   702,     0,     0,   703,   704,   705,   706,
     707,   760,   232,     0,   708,     0,   709,   710,   711,   712,
       0,     0,   713,     0,     0,   714,   715,   716,   717,   718,
     719,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   761,   720,   721,     0,     0,     0,     0,     0,
       0,     0,  1089,  1090,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,   428,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,   755,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,  1784,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,     0,     0,
       0,     0,  1158,  1785,    81,    82,   737,    84,    85,    86,
     738,  1159,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,  1160,   455,  1131,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,  1161,     0,  1162,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,  1163,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,  1164,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,  1165,   638,   639,   640,   641,   209,   642,   643,   644,
    1166,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,  1167,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,  1168,   223,     0,     0,  1169,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,  1135,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,  1170,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,   785,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,   786,    98,    99,
     740,   787,     0,   101,   102,   103,   104,   788,   789,   106,
     107,   108,     0,   109,   790,   791,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,    38,    39,
       0,     0,     0,     0,    40,     0,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,   792,   437,   438,   439,   793,   794,   795,   796,   797,
     798,   799,   440,   441,   800,   442,   443,   444,   126,   445,
     446,   447,   128,   129,   130,   131,   132,   801,   448,   449,
     450,   451,   452,   453,   802,   803,   454,   455,   804,   134,
     456,   805,   457,   458,   459,   460,   138,   806,   139,   807,
     461,   462,   463,   464,   465,   142,   466,   467,   808,   809,
     468,   469,   470,   471,   472,   473,   810,   145,   474,   475,
     811,   812,   813,   814,   146,   815,   816,   817,   477,   478,
     479,   480,   754,   481,   149,   150,   482,   818,   483,   819,
     484,   485,   486,   487,   488,   489,   820,   490,   491,   492,
     493,   821,   822,   494,   495,   496,   497,   498,   823,   499,
     500,   501,   824,   502,   503,   504,   825,   505,   506,   507,
     508,   158,   509,   510,   511,   512,   160,   826,   513,   827,
     514,   515,   162,   516,   828,   517,   829,   518,   163,   830,
     164,   519,   520,   521,   522,   831,   523,   166,   832,   167,
     524,   525,   833,   526,   527,   756,   528,   529,   168,   530,
     531,   532,   533,   834,   534,   535,   536,   537,   538,   539,
     540,   835,   541,   170,   171,   836,   542,   543,   544,   837,
     172,   838,   173,   839,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,   840,   841,   552,   177,   178,   553,
     179,   842,   554,   555,   556,   843,   844,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,   184,   185,   186,   571,   572,   573,   574,
     575,   576,   577,   187,   188,   578,   845,   579,   580,   190,
     581,   846,   191,   582,   192,   583,   584,   585,   847,   586,
     587,   848,   849,   588,   589,   590,   850,   851,   591,   592,
     193,   194,   593,   195,   196,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   852,   603,   604,   197,   605,   198,
     606,   607,   608,   853,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   200,   619,   620,   621,   622,   854,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   855,   635,   636,   207,   637,   638,   639,   640,
     641,   209,   642,   643,   644,   645,   646,   647,   648,   759,
     649,   856,   650,   651,   652,   653,   654,   857,   656,   657,
     214,   658,   659,   216,   660,   661,   217,   662,   858,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   219,   676,   859,   677,   678,   860,   679,   221,
     680,   681,   682,   683,   684,   861,   685,   222,   223,   862,
     863,   687,   688,   224,   689,   225,   864,   690,   691,   692,
     693,   694,   695,   696,   697,   865,   866,   698,   699,   700,
     701,   702,   867,   868,   703,   704,   705,   706,   707,   869,
     232,   870,   708,   233,   709,   710,   711,   712,   871,   872,
     713,   873,   874,   714,   715,   716,   717,   718,   719,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     761,   720,   721,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,   792,   437,   438,   439,
     793,   794,   795,   796,   797,   798,   799,   440,   441,   800,
     442,   443,   444,   126,   445,   446,   447,   128,   129,   130,
     131,   132,   801,   448,   449,   450,   451,   452,   453,   802,
     803,   454,   455,   804,   134,   456,   805,   457,   458,   459,
     460,   138,   806,   139,   807,   461,   462,   463,   464,   465,
     142,   466,   467,   808,   809,   468,   469,   470,   471,   472,
     473,   810,   145,   474,   475,   811,   812,   813,   814,   146,
     815,   816,   817,   477,   478,   479,   480,   754,   481,   149,
     150,   482,   818,   483,   819,   484,   485,   486,   487,   488,
     489,   820,   490,   491,   492,   493,   821,   822,   494,   495,
     496,   497,   498,   823,   499,   500,   501,   824,   502,   503,
     504,   825,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,   826,   513,   827,   514,   515,   162,   516,   828,
     517,   829,   518,   163,   830,   164,   519,   520,   521,   522,
     831,   523,   166,   832,   167,   524,   525,   833,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,   834,   534,
     535,   536,   537,   538,   539,   540,   835,   541,   170,   171,
     836,   542,   543,   544,   837,   172,   838,   173,   839,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,   840,
     841,   552,   177,   178,   553,   179,   842,   554,   555,   556,
     843,   844,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,   185,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,   845,   579,   580,   190,   581,   846,   191,   582,   192,
     583,   584,   585,   847,   586,   587,   848,   849,   588,   589,
     590,   850,   851,   591,   592,   193,   194,   593,   195,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   852,
     603,   604,   197,   605,   198,   606,   607,   608,   853,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,   854,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   855,   635,   636,
     207,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,   856,   650,   651,   652,
     653,   654,   857,   656,   657,   214,   658,   659,   216,   660,
     661,   217,   662,   858,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,   859,
     677,   678,   860,   679,   221,   680,   681,   682,   683,   684,
     861,   685,   222,   223,   862,   863,   687,   688,   224,   689,
     225,   864,   690,   691,   692,   693,   694,   695,   696,   697,
     865,   866,   698,   699,   700,   701,   702,   867,   868,   703,
     704,   705,   706,   707,   869,   232,   870,   708,   233,   709,
     710,   711,   712,   871,   872,   713,   873,   874,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,   785,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,   786,    98,    99,
     740,   787,     0,   101,   102,   103,   104,   788,   789,   106,
     107,   108,     0,   109,   790,   791,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,  3662,   434,   435,
     436,   792,   437,   438,   439,   793,   794,   795,   796,   797,
     798,   799,   440,   441,   800,   442,   443,   444,   126,   445,
     446,   447,   128,   129,   130,   131,   132,   801,   448,   449,
     450,   451,   452,   453,   802,   803,   454,   455,   804,   134,
     456,   805,   457,   458,   459,   460,   138,   806,   139,   807,
     461,   462,   463,   464,   465,   142,   466,   467,   808,   809,
     468,   469,   470,   471,   472,   473,   810,   145,   474,   475,
     811,   812,   813,   814,   146,   815,   816,   817,   477,   478,
     479,   480,   754,   481,   149,   150,   482,   818,   483,   819,
     484,   485,   486,   487,   488,   489,   820,   490,   491,   492,
     493,   821,   822,   494,   495,   496,  3663,   498,   823,   499,
     500,   501,   824,   502,   503,   504,   825,   505,   506,   507,
     508,   158,   509,   510,   511,   512,   160,   826,   513,   827,
     514,   515,   162,   516,   828,   517,   829,   518,   163,   830,
     164,   519,   520,   521,   522,   831,   523,   166,   832,   167,
     524,   525,   833,   526,   527,   756,   528,   529,   168,   530,
     531,   532,   533,   834,   534,   535,   536,   537,   538,   539,
     540,   835,   541,   170,   171,   836,   542,   543,   544,   837,
     172,   838,   173,   839,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,   840,   841,   552,   177,   178,   553,
     179,   842,   554,   555,   556,   843,   844,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,   184,   185,   186,   571,   572,   573,   574,
     575,   576,   577,   187,   188,   578,   845,   579,   580,   190,
     581,   846,   191,   582,   192,   583,   584,   585,   847,   586,
     587,   848,   849,   588,   589,   590,   850,   851,   591,   592,
     193,   194,   593,   195,   196,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   852,   603,   604,   197,   605,   198,
     606,   607,   608,   853,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   200,   619,   620,   621,   622,   854,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   855,   635,   636,   207,   637,   638,   639,   640,
     641,   209,   642,   643,   644,   645,   646,   647,   648,   759,
     649,   856,   650,   651,   652,   653,   654,   857,  3664,   657,
     214,   658,   659,   216,   660,   661,   217,   662,   858,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   219,   676,   859,   677,   678,   860,   679,   221,
     680,   681,   682,   683,   684,   861,   685,   222,   223,   862,
     863,   687,   688,   224,   689,   225,   864,   690,   691,   692,
     693,   694,   695,   696,   697,   865,   866,   698,   699,   700,
     701,   702,   867,   868,   703,   704,   705,   706,   707,   869,
     232,   870,   708,   233,   709,   710,   711,   712,   871,   872,
     713,   873,   874,   714,   715,   716,   717,   718,   719,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     761,   720,   721,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,   128,   129,   130,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
    1680,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,  1683,     0,  1684,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,  1685,  1686,  1687,  1688,
    1689,  1690,  1691,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,  1696,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,  1699,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,  1703,   178,   553,   179,     0,   554,   555,   556,
    1704,  1705,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,   185,
     186,   571,   572,   573,   574,   575,   576,   577,   187,  1708,
     578,     0,   579,   580,   190,   581,     0,  1711,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,  1714,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,  1715,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,  1718,   656,   657,   214,   658,   659,   216,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,  1720,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,  1723,   689,
    1724,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,  1727,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,  1729,  1730,  1731,  1732,   240,
    1733,  1734,  1735,  1736,   245,   761,   720,   721,   785,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,   786,    98,    99,
     740,   787,     0,   101,   102,   103,   104,   788,   789,   106,
     107,   108,     0,   109,   790,   791,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,     0,
       0,     0,   440,   441,     0,   442,   443,   444,   126,   445,
     446,   447,   128,   129,   130,   131,   132,     0,   448,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   751,   134,
     456,     0,   457,   458,   459,   460,   138,     0,   139,     0,
     461,   462,   463,   464,   465,   142,   466,   467,   752,     0,
     468,   469,   470,   471,   472,   473,     0,   145,   474,   475,
       0,     0,     0,     0,   146,     0,     0,     0,   477,   478,
     479,   480,   754,   481,   149,   150,   482,     0,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,   158,   509,   510,   511,   512,   160,     0,   513,     0,
     514,   515,   162,   516,     0,   517,     0,   518,   163,     0,
     164,   519,   520,   521,   522,     0,   523,   166,     0,   167,
     524,   525,     0,   526,   527,   756,   528,   529,   168,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   170,   171,     0,   542,   543,   544,     0,
     172,     0,   173,     0,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,     0,     0,   552,   177,   178,   553,
     179,     0,   554,   555,   556,     0,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,   184,   185,   186,   571,   572,   573,   574,
     575,   576,   577,   187,   188,   578,     0,   579,   580,   190,
     581,     0,   191,   582,   192,   583,   584,   585,     0,   586,
     587,     0,     0,   588,   589,   590,     0,     0,   591,   592,
     193,   194,   593,   195,   196,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,   197,   605,   198,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   200,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,   207,   637,   638,   639,   640,
     641,   209,   642,   643,   644,   645,   646,   647,   648,   759,
     649,     0,   650,   651,   652,   653,   654,     0,   656,   657,
     214,   658,   659,   216,   660,   661,   217,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   219,   676,     0,   677,   678,     0,   679,   221,
     680,   681,   682,   683,   684,     0,   685,   222,   223,     0,
       0,   687,   688,   224,   689,   225,     0,   690,   691,   692,
     693,   694,   695,   696,   697,     0,     0,   698,   699,   700,
     701,   702,     0,     0,   703,   704,   705,   706,   707,   760,
     232,     0,   708,   233,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     761,   720,   721,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,   128,   129,   130,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,  1485,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,   177,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,   185,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,   190,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,   216,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,   785,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,   786,    98,    99,
     740,   787,     0,   101,   102,   103,   104,   788,   789,   106,
     107,   108,     0,   109,   790,   791,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,     0,
       0,     0,   440,   441,     0,   442,   443,   444,   126,   445,
     446,   447,   128,   129,   130,   131,   132,     0,   448,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   751,   134,
     456,     0,   457,   458,   459,   460,   138,     0,   139,     0,
     461,   462,   463,   464,   465,   142,   466,   467,   752,     0,
     468,   469,   470,   471,   472,   473,     0,   145,   474,   475,
       0,     0,     0,     0,   146,     0,     0,     0,   477,   478,
     479,   480,   754,   481,   149,   150,   482,     0,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,   158,   509,   510,   511,   512,   160,     0,   513,     0,
     514,   515,   162,   516,     0,   517,     0,   518,   163,     0,
     164,   519,   520,   521,   522,     0,   523,   166,     0,   167,
     524,   525,     0,   526,   527,   756,   528,  1536,   168,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   170,   171,     0,   542,   543,   544,     0,
     172,     0,   173,     0,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,     0,     0,   552,   177,   178,   553,
     179,     0,   554,   555,   556,     0,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,   184,   185,   186,   571,   572,   573,   574,
     575,   576,   577,   187,   188,   578,     0,   579,   580,   190,
     581,     0,   191,   582,   192,   583,   584,   585,     0,   586,
     587,     0,     0,   588,   589,   590,     0,     0,   591,   592,
     193,   194,   593,   195,   196,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,   197,   605,   198,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   200,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,   207,   637,   638,   639,   640,
     641,   209,   642,   643,   644,   645,   646,   647,   648,   759,
     649,     0,   650,   651,   652,   653,   654,     0,   656,   657,
     214,   658,   659,   216,   660,   661,   217,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   219,   676,     0,   677,   678,     0,   679,   221,
     680,   681,   682,   683,   684,     0,   685,   222,   223,     0,
       0,   687,   688,   224,   689,   225,     0,   690,   691,   692,
     693,   694,   695,   696,   697,     0,     0,   698,   699,   700,
     701,   702,     0,     0,   703,   704,   705,   706,   707,   760,
     232,     0,   708,   233,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     761,   720,   721,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,   128,   129,   130,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,  1550,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,   177,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,   185,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,   190,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,   216,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,   785,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,   786,    98,    99,
     740,   787,     0,   101,   102,   103,   104,   788,   789,   106,
     107,   108,     0,   109,   790,   791,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,     0,
       0,     0,   440,   441,     0,   442,   443,   444,   126,   445,
     446,   447,   128,   129,   130,   131,   132,     0,   448,   449,
     450,   451,   452,   453,     0,     0,   454,   455,   751,   134,
     456,     0,   457,   458,   459,   460,   138,     0,   139,     0,
     461,   462,   463,   464,   465,   142,   466,   467,   752,     0,
     468,   469,   470,   471,   472,   473,     0,   145,   474,   475,
       0,     0,     0,     0,   146,     0,     0,     0,   477,   478,
     479,   480,   754,   481,   149,   150,   482,     0,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,   158,   509,   510,   511,   512,   160,     0,   513,     0,
     514,   515,   162,   516,     0,   517,     0,   518,   163,     0,
     164,   519,   520,   521,   522,     0,   523,   166,     0,   167,
     524,   525,     0,   526,   527,   756,   528,  1554,   168,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   170,   171,     0,   542,   543,   544,     0,
     172,     0,   173,     0,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,     0,     0,   552,   177,   178,   553,
     179,     0,   554,   555,   556,     0,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,   184,   185,   186,   571,   572,   573,   574,
     575,   576,   577,   187,   188,   578,     0,   579,   580,   190,
     581,     0,   191,   582,   192,   583,   584,   585,     0,   586,
     587,     0,     0,   588,   589,   590,     0,     0,   591,   592,
     193,   194,   593,   195,   196,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,   197,   605,   198,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   200,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,   207,   637,   638,   639,   640,
     641,   209,   642,   643,   644,   645,   646,   647,   648,   759,
     649,     0,   650,   651,   652,   653,   654,     0,   656,   657,
     214,   658,   659,   216,   660,   661,   217,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   219,   676,     0,   677,   678,     0,   679,   221,
     680,   681,   682,   683,   684,     0,   685,   222,   223,     0,
       0,   687,   688,   224,   689,   225,     0,   690,   691,   692,
     693,   694,   695,   696,   697,     0,     0,   698,   699,   700,
     701,   702,     0,     0,   703,   704,   705,   706,   707,   760,
     232,     0,   708,   233,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     761,   720,   721,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,     0,  1492,   130,
    1493,  1494,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,  1495,  1496,   456,     0,   457,   458,   459,
     460,     0,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,     0,   477,   478,   479,   480,   754,   481,  1497,
    1498,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
    1499,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,     0,   509,   510,   511,
     512,     0,     0,   513,     0,   514,   515,  1500,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,     0,     0,     0,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,  2705,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,  2706,
       0,   542,   543,   544,  1502,  1503,     0,  1504,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,     0,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,  1505,   185,
    1506,   571,   572,   573,   574,   575,   576,   577,     0,     0,
     578,     0,   579,   580,   190,   581,     0,     0,   582,  1507,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,  2708,   194,   593,   195,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,     0,   605,     0,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,  1508,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,  2709,   658,   659,   216,   660,
     661,  1510,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,     0,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,  1511,  1512,     0,     0,   687,   688,     0,   689,
       0,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,     0,  1513,  2710,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   761,   720,   721,   785,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,   786,    98,    99,
     740,   787,     0,   101,   102,   103,   104,   788,   789,   106,
     107,   108,     0,   109,   790,   791,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,     0,
       0,     0,   440,   441,     0,   442,   443,   444,   126,   445,
     446,   447,     0,  1492,   130,  1493,  1494,     0,   448,   449,
     450,   451,   452,   453,     0,     0,   454,   455,  1495,  1496,
     456,     0,   457,   458,   459,   460,     0,     0,   139,     0,
     461,   462,   463,   464,   465,   142,   466,   467,   752,     0,
     468,   469,   470,   471,   472,   473,     0,   145,   474,   475,
       0,     0,     0,     0,   146,     0,     0,     0,   477,   478,
     479,   480,   754,   481,  1497,  1498,   482,     0,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,  1499,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,     0,   509,   510,   511,   512,     0,     0,   513,     0,
     514,   515,  1500,   516,     0,   517,     0,   518,   163,     0,
     164,   519,   520,   521,   522,     0,   523,     0,     0,     0,
     524,   525,     0,   526,   527,   756,   528,   529,   168,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   170,     0,     0,   542,   543,   544,  1502,
    1503,     0,  1504,     0,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,     0,     0,   552,     0,   178,   553,
     179,     0,   554,   555,   556,     0,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,  1505,   185,  1506,   571,   572,   573,   574,
     575,   576,   577,     0,     0,   578,     0,   579,   580,   190,
     581,  2804,     0,   582,  1507,   583,   584,   585,     0,   586,
     587,     0,     0,   588,   589,   590,     0,     0,   591,   592,
       0,   194,   593,   195,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,     0,   605,     0,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,  1508,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,   207,   637,   638,   639,   640,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   759,
     649,     0,   650,   651,   652,   653,   654,     0,   656,   657,
    2709,   658,   659,   216,   660,   661,  1510,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,     0,   676,     0,   677,   678,  4591,   679,   221,
     680,   681,   682,   683,   684,     0,   685,  1511,  1512,     0,
       0,   687,   688,     0,   689,     0,     0,   690,   691,   692,
     693,   694,   695,   696,   697,     0,     0,   698,   699,   700,
     701,   702,     0,     0,   703,   704,   705,   706,   707,     0,
    1513,     0,   708,   233,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     761,   720,   721,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,     0,  1492,   130,
    1493,  1494,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,  1495,  1496,   456,     0,   457,   458,   459,
     460,     0,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,     0,   477,   478,   479,   480,   754,   481,  1497,
    1498,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
    1499,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,     0,   509,   510,   511,
     512,     0,     0,   513,     0,   514,   515,  1500,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,     0,     0,     0,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,     0,
       0,   542,   543,   544,  1502,  1503,     0,  1504,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,     0,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,  1505,   185,
    1506,   571,   572,   573,   574,   575,   576,   577,  2875,     0,
     578,     0,   579,   580,   190,   581,     0,     0,   582,  1507,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,     0,   194,   593,   195,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,     0,   605,     0,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,  1508,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,  1509,   658,   659,   216,   660,
     661,  1510,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,     0,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,  1511,  1512,     0,     0,   687,   688,     0,   689,
       0,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,     0,  1513,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   761,   720,   721,   785,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,   786,    98,    99,
     740,   787,     0,   101,   102,   103,   104,   788,   789,   106,
     107,   108,     0,   109,   790,   791,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,     0,
       0,     0,   440,   441,     0,   442,   443,   444,   126,   445,
     446,   447,     0,  1492,   130,  1493,  1494,     0,   448,   449,
     450,   451,   452,   453,     0,     0,   454,   455,  1495,  1496,
     456,     0,   457,   458,   459,   460,     0,     0,   139,     0,
     461,   462,   463,   464,   465,   142,   466,   467,   752,     0,
     468,   469,   470,   471,   472,   473,     0,   145,   474,   475,
       0,     0,     0,     0,   146,     0,     0,     0,   477,   478,
     479,   480,   754,   481,  1497,  1498,   482,     0,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,  1499,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,     0,   509,   510,   511,   512,     0,     0,   513,     0,
     514,   515,  1500,   516,     0,   517,     0,   518,   163,     0,
     164,   519,   520,   521,   522,     0,   523,     0,     0,     0,
     524,   525,     0,   526,   527,   756,   528,   529,   168,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   170,     0,     0,   542,   543,   544,  1502,
    1503,     0,  1504,     0,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,     0,     0,   552,     0,   178,   553,
     179,     0,   554,   555,   556,     0,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,  1505,   185,  1506,   571,   572,   573,   574,
     575,   576,   577,  4395,     0,   578,     0,   579,   580,   190,
     581,     0,     0,   582,  1507,   583,   584,   585,     0,   586,
     587,     0,     0,   588,   589,   590,     0,     0,   591,   592,
       0,   194,   593,   195,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,     0,   605,     0,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,  1508,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,   207,   637,   638,   639,   640,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   759,
     649,     0,   650,   651,   652,   653,   654,     0,   656,   657,
    1509,   658,   659,   216,   660,   661,  1510,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,     0,   676,     0,   677,   678,     0,   679,   221,
     680,   681,   682,   683,   684,     0,   685,  1511,  1512,     0,
       0,   687,   688,     0,   689,     0,     0,   690,   691,   692,
     693,   694,   695,   696,   697,     0,     0,   698,   699,   700,
     701,   702,     0,     0,   703,   704,   705,   706,   707,     0,
    1513,     0,   708,   233,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     761,   720,   721,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,     0,  1492,   130,
    1493,  1494,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,  1495,  1496,   456,     0,   457,   458,   459,
     460,     0,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,     0,   477,   478,   479,   480,   754,   481,  1497,
    1498,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
    1499,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,     0,   509,   510,   511,
     512,     0,     0,   513,     0,   514,   515,  1500,   516,  6012,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,     0,     0,     0,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,     0,
       0,   542,   543,   544,  1502,  1503,     0,  1504,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,     0,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,  1505,   185,
    1506,   571,   572,   573,   574,   575,   576,   577,     0,     0,
     578,     0,   579,   580,   190,   581,     0,     0,   582,  1507,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,     0,   194,   593,   195,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,     0,   605,     0,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,  1508,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,  1509,   658,   659,   216,   660,
     661,  1510,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,     0,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,  1511,  1512,     0,     0,   687,   688,     0,   689,
       0,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,     0,  1513,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   761,   720,   721,   785,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,   786,    98,    99,
     740,   787,     0,   101,   102,   103,   104,   788,   789,   106,
     107,   108,     0,   109,   790,   791,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,     0,
       0,     0,   440,   441,     0,   442,   443,   444,   126,   445,
     446,   447,     0,  1492,   130,  1493,  1494,     0,   448,   449,
     450,   451,   452,   453,     0,     0,   454,   455,  1495,  1496,
     456,     0,   457,   458,   459,   460,     0,     0,   139,     0,
     461,   462,   463,   464,   465,   142,   466,   467,   752,     0,
     468,   469,   470,   471,   472,   473,     0,   145,   474,   475,
       0,     0,     0,     0,   146,     0,     0,     0,   477,   478,
     479,   480,   754,   481,  1497,  1498,   482,     0,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,  1499,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,     0,   509,   510,   511,   512,     0,     0,   513,     0,
     514,   515,  1500,   516,     0,   517,     0,   518,   163,     0,
     164,   519,   520,   521,   522,     0,   523,     0,     0,     0,
     524,   525,     0,   526,   527,   756,   528,  1501,   168,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   170,     0,     0,   542,   543,   544,  1502,
    1503,     0,  1504,     0,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,     0,     0,   552,     0,   178,   553,
     179,     0,   554,   555,   556,     0,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,  1505,   185,  1506,   571,   572,   573,   574,
     575,   576,   577,     0,     0,   578,     0,   579,   580,   190,
     581,     0,     0,   582,  1507,   583,   584,   585,     0,   586,
     587,     0,     0,   588,   589,   590,     0,     0,   591,   592,
       0,   194,   593,   195,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,     0,   605,     0,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,  1508,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,   207,   637,   638,   639,   640,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   759,
     649,     0,   650,   651,   652,   653,   654,     0,   656,   657,
    1509,   658,   659,   216,   660,   661,  1510,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,     0,   676,     0,   677,   678,     0,   679,   221,
     680,   681,   682,   683,   684,     0,   685,  1511,  1512,     0,
       0,   687,   688,     0,   689,     0,     0,   690,   691,   692,
     693,   694,   695,   696,   697,     0,     0,   698,   699,   700,
     701,   702,     0,     0,   703,   704,   705,   706,   707,     0,
    1513,     0,   708,   233,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     761,   720,   721,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,     0,  1492,   130,
    1493,  1494,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,  1495,  1496,   456,     0,   457,   458,   459,
     460,     0,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,     0,   477,   478,   479,   480,   754,   481,  1497,
    1498,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
    1499,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,     0,   509,   510,   511,
     512,     0,     0,   513,     0,   514,   515,  1500,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,     0,     0,     0,   524,   525,     0,   526,   527,
     756,   528,  1562,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,     0,
       0,   542,   543,   544,  1502,  1503,     0,  1504,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,     0,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,  1505,   185,
    1506,   571,   572,   573,   574,   575,   576,   577,     0,     0,
     578,     0,   579,   580,   190,   581,     0,     0,   582,  1507,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,     0,   194,   593,   195,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,     0,   605,     0,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,  1508,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,  1509,   658,   659,   216,   660,
     661,  1510,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,     0,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,  1511,  1512,     0,     0,   687,   688,     0,   689,
       0,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,     0,  1513,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   761,   720,   721,   785,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,   786,    98,    99,
     740,   787,     0,   101,   102,   103,   104,   788,   789,   106,
     107,   108,     0,   109,   790,   791,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,     0,
       0,     0,   440,   441,     0,   442,   443,   444,   126,   445,
     446,   447,     0,  1492,   130,  1493,  1494,     0,   448,   449,
     450,   451,   452,   453,     0,     0,   454,   455,  1495,  1496,
     456,     0,   457,   458,   459,   460,     0,     0,   139,     0,
     461,   462,   463,   464,   465,   142,   466,   467,   752,     0,
     468,   469,   470,   471,   472,   473,     0,   145,   474,   475,
       0,     0,     0,     0,   146,     0,     0,     0,   477,   478,
     479,   480,   754,   481,  1497,  1498,   482,     0,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,  1499,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,     0,   509,   510,   511,   512,     0,     0,   513,     0,
     514,   515,  1500,   516,     0,   517,     0,   518,   163,     0,
     164,   519,   520,   521,   522,     0,   523,     0,     0,     0,
     524,   525,     0,   526,   527,   756,   528,   529,   168,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   170,     0,     0,   542,   543,   544,  1502,
    1503,     0,  1504,     0,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,     0,     0,   552,     0,   178,   553,
     179,     0,   554,   555,   556,     0,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,  1505,   185,  1506,   571,   572,   573,   574,
     575,   576,   577,     0,     0,   578,     0,   579,   580,   190,
     581,     0,     0,   582,  1507,   583,   584,   585,     0,   586,
     587,     0,     0,   588,   589,   590,     0,     0,   591,   592,
       0,   194,   593,   195,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,     0,   605,     0,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,  1508,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,   207,   637,   638,   639,   640,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   759,
     649,     0,   650,   651,   652,   653,   654,     0,   656,   657,
    1509,   658,   659,   216,   660,   661,  1510,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,     0,   676,     0,   677,   678,     0,   679,   221,
     680,   681,   682,   683,   684,     0,   685,  1511,  1512,     0,
       0,   687,   688,     0,   689,     0,     0,   690,   691,   692,
     693,   694,   695,   696,   697,     0,     0,   698,   699,   700,
     701,   702,     0,     0,   703,   704,   705,   706,   707,     0,
    1513,     0,   708,   233,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     761,   720,   721,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,     0,  1492,   130,
    1493,  1494,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,  1495,  1496,   456,     0,   457,   458,   459,
     460,     0,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,     0,   477,   478,   479,   480,   754,   481,  1497,
    1498,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
    1499,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,     0,   509,   510,   511,
     512,     0,     0,   513,     0,   514,   515,  1500,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,     0,     0,     0,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,     0,
       0,   542,   543,   544,  1502,  1503,     0,  1504,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,     0,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,  1505,   185,
    1506,   571,   572,   573,   574,   575,   576,   577,     0,     0,
     578,     0,   579,   580,   190,   581,     0,     0,   582,  1507,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,     0,   194,   593,   195,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,     0,   605,     0,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,  1508,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,  2709,   658,   659,   216,   660,
     661,  1510,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,     0,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,  1511,  1512,     0,     0,   687,   688,     0,   689,
       0,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,     0,  1513,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   761,   720,   721,   785,    81,
      82,   737,    84,    85,    86,   738,     0,   739,    89,     0,
       0,    92,    93,    94,    95,    96,    97,   786,    98,    99,
     740,   787,     0,   101,   102,   103,   104,   788,   789,   106,
     107,   108,     0,   109,   790,   791,   741,   742,     0,     0,
       0,   743,   744,     0,     0,     0,     0,   745,     0,     0,
       0,     0,     0,     0,     0,     0,   746,     0,   747,     0,
     748,   749,    35,     0,     0,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,     0,
       0,     0,   440,   441,     0,   442,   443,   444,   126,   445,
     446,   447,     0,  1492,   130,  1493,  1494,     0,   448,   449,
     450,   451,   452,   453,     0,     0,   454,   455,  1495,  1496,
     456,     0,   457,   458,   459,   460,     0,     0,   139,     0,
     461,   462,   463,   464,   465,   142,   466,   467,   752,     0,
     468,   469,   470,   471,   472,   473,     0,   145,   474,   475,
       0,     0,     0,     0,   146,     0,     0,     0,   477,   478,
     479,   480,   754,   481,  1497,  1498,   482,     0,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,  1499,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,     0,   509,   510,   511,   512,     0,     0,   513,     0,
     514,   515,  1500,   516,     0,   517,     0,   518,   163,     0,
     164,   519,   520,   521,   522,     0,   523,     0,     0,     0,
     524,   525,     0,   526,   527,   756,   528,   529,   168,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   170,     0,     0,   542,   543,   544,  1502,
    1503,     0,  1504,     0,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,     0,     0,   552,     0,   178,   553,
     179,     0,   554,   555,   556,     0,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   757,   566,   567,   758,
     568,   569,   570,  1505,   185,  1506,   571,   572,   573,   574,
     575,   576,   577,     0,     0,   578,     0,   579,   580,   190,
     581,     0,     0,   582,  1507,   583,   584,   585,     0,   586,
     587,     0,     0,   588,   589,   590,     0,     0,   591,   592,
       0,   194,   593,   195,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,     0,   605,     0,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,  1508,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,   207,   637,   638,   639,   640,
     641,     0,   642,   643,   644,   645,   646,   647,   648,   759,
     649,     0,   650,   651,   652,   653,   654,     0,   656,   657,
       0,   658,   659,   216,   660,   661,  1510,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,     0,   676,     0,   677,   678,     0,   679,   221,
     680,   681,   682,   683,   684,     0,   685,  1511,  1512,     0,
       0,   687,   688,     0,   689,     0,     0,   690,   691,   692,
     693,   694,   695,   696,   697,     0,     0,   698,   699,   700,
     701,   702,     0,     0,   703,   704,   705,   706,   707,     0,
    1513,     0,   708,   233,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     761,   720,   721,   785,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,   786,    98,    99,   740,   787,     0,   101,   102,
     103,   104,   788,   789,   106,   107,   108,     0,   109,   790,
     791,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,     0,     0,   130,
       0,     0,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,     0,     0,   456,     0,   457,   458,   459,
     460,     0,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,     0,   477,   478,   479,   480,   754,   481,     0,
       0,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,     0,   509,   510,   511,
     512,     0,     0,   513,     0,   514,   515,     0,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,     0,     0,     0,   524,   525,     0,   526,   527,
     756,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,     0,
       0,   542,   543,   544,     0,     0,     0,     0,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,     0,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,     0,   185,
       0,   571,   572,   573,   574,   575,   576,   577,     0,     0,
     578,     0,   579,   580,   190,   581,     0,     0,   582,     0,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,     0,   194,   593,   195,     0,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,     0,   605,     0,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,     0,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,     0,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,     0,   658,   659,   216,   660,
     661,     0,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,     0,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,     0,     0,     0,     0,   687,   688,     0,   689,
       0,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,     0,     0,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     792,   437,   438,   439,   793,   794,   795,   796,   797,   798,
     799,   440,   441,   800,   442,   443,   444,   126,   445,   446,
     447,   128,   129,   130,   131,   132,   801,   448,   449,   450,
     451,   452,   453,   802,   803,   454,   455,     0,   134,   456,
     805,   457,   458,   459,   460,   138,   806,   139,   807,   461,
     462,   463,   464,   465,   142,   466,   467,   808,   809,   468,
     469,   470,   471,   472,   473,   810,   145,   474,   475,     0,
     812,   813,   814,   146,   815,   816,   817,   477,   478,   479,
     480,     0,   481,   149,   150,   482,   818,   483,   819,   484,
     485,   486,   487,   488,   489,   820,   490,   491,   492,   493,
     821,   822,   494,   495,   496,   497,   498,   823,   499,   500,
     501,   824,   502,   503,   504,   825,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,   826,   513,   827,   514,
     515,   162,   516,   828,   517,   829,   518,   163,   830,   164,
     519,   520,   521,   522,   831,   523,   166,   832,   167,   524,
     525,   833,   526,   527,     0,   528,   529,   168,   530,   531,
     532,   533,   834,   534,   535,   536,   537,   538,   539,   540,
     835,   541,   170,   171,     0,   542,   543,   544,     0,   172,
     838,   173,   839,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,   840,   841,   552,   177,   178,   553,   179,
     842,   554,   555,   556,   843,   844,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,     0,   568,
     569,   570,   184,   185,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,   845,   579,   580,   190,   581,
     846,   191,   582,   192,   583,   584,   585,   847,   586,   587,
     848,   849,   588,   589,   590,   850,   851,   591,   592,   193,
     194,   593,   195,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   852,   603,   604,   197,   605,   198,   606,
     607,   608,   853,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,   854,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   855,   635,   636,   207,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,     0,   649,
     856,   650,   651,   652,   653,   654,   857,   656,   657,   214,
     658,   659,   216,   660,   661,   217,   662,   858,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,   859,   677,   678,   860,   679,   221,   680,
     681,   682,   683,   684,   861,   685,   222,   223,     0,   863,
     687,   688,   224,   689,   225,   864,   690,   691,   692,   693,
     694,   695,   696,   697,     0,   866,   698,   699,   700,   701,
     702,   867,   868,   703,   704,   705,   706,   707,     0,   232,
     870,   708,   233,   709,   710,   711,   712,   871,   872,   713,
     873,   874,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,     0,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,  2745,   457,   458,   459,   460,   138,
       0,     0,  2825,   461,   462,   463,   464,   465,     0,   466,
     467,   752,  2746,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
    2826,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,  2748,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
    2827,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,  2749,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,  2750,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,  2745,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,  2746,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,  2826,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,  2748,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,  3873,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
    2749,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,  2750,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,  1146,
     435,   436,  1098,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,  1099,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,  1147,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
    1100,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,  1101,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,  1098,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,  1099,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
    3552,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,  1100,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,  1101,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
    2745,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,  2746,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,  2826,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,  2748,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,  2749,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,  2750,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,   428,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,   750,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,   753,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
     755,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
     529,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,  1098,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,  1099,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,  1100,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,  1101,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,  1000,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,   428,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,  1001,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,  1002,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,   428,     0,
       0,    37,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,  1251,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
    2408,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
    2409,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,  2410,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,  2411,   518,     0,     0,     0,
    2412,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
    2413,  2414,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,  2415,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,  2416,   641,
     209,   642,   643,   644,  2417,   646,   647,   648,   759,   649,
       0,  2418,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,  2419,   679,     0,  2420,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,  2421,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,  1099,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
     529,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,  1100,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,  1101,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,  2397,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
     428,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,  3411,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,  3412,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,  2683,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,  3413,   679,     0,   680,  3414,   682,
    3415,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,  3416,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,   428,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,   777,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,   428,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,   755,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,   428,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
     946,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,   428,     0,     0,    37,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
     529,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,  1341,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,  1342,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,  1181,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,   428,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,  1476,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,  3643,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,  3644,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
    3656,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,  3657,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,   428,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
     529,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
     428,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
    1006,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,   428,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
    1060,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,   428,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,  1116,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,  1181,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,  1298,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
    1299,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,  1787,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,  1974,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,  1181,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,  2031,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,  2032,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,  2261,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,  2397,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
     529,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,  2683,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,    40,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,  4771,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,  4785,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
     529,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,  1128,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,  1130,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,  1131,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,     0,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,  1132,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,  1133,   223,
       0,     0,  1134,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
    1135,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,  1175,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,  1131,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,     0,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,  1176,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,  1177,   223,     0,     0,  1178,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,  1135,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,  1194,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
    1323,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,  1333,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,  1336,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,  1352,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,  1420,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
    1426,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,  1442,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,  1445,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,  1447,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,  1490,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
    1556,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,  1558,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,  1568,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,  1571,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,  1574,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,  1798,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,  1160,
     455,  1131,   134,  1799,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,     0,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
     529,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,  1164,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,  1165,
     638,   639,   640,   641,   209,   642,   643,   644,  1166,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,  1791,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
    1168,   223,     0,     0,  1169,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,  1135,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,  1170,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,  1922,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,  1923,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,  1130,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,  1131,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,     0,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
    1135,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,  2208,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,  2246,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
    2248,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,  2321,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,  2323,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,  2325,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,  2449,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,  2648,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
     529,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,     0,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,  3106,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,  3110,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,  3192,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,  3563,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
    3632,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,   751,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,   752,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,  3646,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,   570,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,   760,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,   751,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,   752,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,  3648,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
     760,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,  3793,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,   751,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,   752,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,  3831,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,   570,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   760,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,   751,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,   752,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
    5064,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,   570,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,   760,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,  1160,   455,  1131,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,     0,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,  1164,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,  1165,   638,   639,   640,   641,   209,   642,
     643,   644,  1166,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,  1791,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,  1168,   223,     0,     0,  1169,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,  1135,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,  1170,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,  1131,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,     0,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,   570,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
    1135,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,  1160,   455,  1131,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,     0,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,  1164,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,  1165,   638,   639,   640,   641,   209,   642,   643,   644,
    1166,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,  1791,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,  2732,   681,   682,   683,   684,
       0,   685,  1168,   223,     0,     0,  1169,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,  1135,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,  1170,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
     737,    84,    85,    86,   738,     0,   739,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,   740,
       0,     0,   101,   102,   103,   104,     0,     0,   106,   107,
     108,     0,   109,     0,     0,   741,   742,     0,     0,     0,
     743,   744,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,   746,     0,   747,     0,   748,
     749,    35,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,     0,   445,   446,
     447,   128,   129,     0,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,  1160,   455,  1131,   134,   456,
       0,   457,   458,   459,   460,   138,     0,     0,     0,   461,
     462,   463,   464,   465,     0,   466,   467,     0,     0,   468,
     469,   470,   471,   472,   473,     0,     0,   474,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   477,   478,   479,
     480,   754,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,     0,     0,     0,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,   756,   528,   529,     0,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,     0,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,     0,     0,   546,     0,   547,   548,
     549,   550,   551,     0,     0,   552,   177,     0,   553,     0,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   757,   566,   567,   758,   568,
     569,  1164,   184,     0,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,     0,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
       0,   593,     0,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,     0,  1165,   638,   639,   640,   641,
     209,   642,   643,   644,  2808,   646,   647,   648,   759,   649,
       0,   650,   651,   652,   653,  2809,     0,   656,   657,   214,
     658,   659,     0,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,     0,   680,
     681,   682,   683,   684,     0,   685,  1168,   223,     0,     0,
    2810,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,  1135,   232,
       0,   708,     0,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,  1170,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   761,
     720,   721,    81,    82,   737,    84,    85,    86,   738,     0,
     739,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,   740,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,   741,
     742,     0,     0,     0,   743,   744,     0,     0,     0,     0,
     745,     0,     0,     0,     0,     0,     0,     0,     0,   746,
       0,   747,     0,   748,   749,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,     0,   445,   446,   447,   128,   129,     0,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,  1160,
     455,  1131,   134,   456,     0,   457,   458,   459,   460,   138,
       0,     0,     0,   461,   462,   463,   464,   465,     0,   466,
     467,     0,     0,   468,   469,   470,   471,   472,   473,     0,
       0,   474,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   754,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,     0,     0,     0,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,   756,   528,
     529,     0,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,     0,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,     0,     0,
     546,     0,   547,   548,   549,   550,   551,     0,     0,   552,
     177,     0,   553,     0,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   757,
     566,   567,   758,   568,   569,  1164,   184,     0,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,     0,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,     0,   593,     0,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,     0,  1165,
     638,   639,   640,   641,   209,   642,   643,   644,  2885,   646,
     647,   648,   759,   649,     0,   650,   651,   652,   653,  2809,
       0,   656,   657,   214,   658,   659,     0,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,     0,   680,   681,   682,   683,   684,     0,   685,
    1168,   223,     0,     0,  2810,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,  1135,   232,     0,   708,     0,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,  1170,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   761,   720,   721,    81,    82,   737,    84,
      85,    86,   738,     0,   739,    89,     0,     0,    92,    93,
      94,    95,    96,    97,     0,    98,    99,   740,     0,     0,
     101,   102,   103,   104,     0,     0,   106,   107,   108,     0,
     109,     0,     0,   741,   742,     0,     0,     0,   743,   744,
       0,     0,     0,     0,   745,     0,     0,     0,     0,     0,
       0,     0,     0,   746,     0,   747,     0,   748,   749,    35,
       0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,     0,   445,   446,   447,   128,
     129,     0,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,  1160,   455,  1131,   134,   456,     0,   457,
     458,   459,   460,   138,     0,     0,     0,   461,   462,   463,
     464,   465,     0,   466,   467,     0,     0,   468,   469,   470,
     471,   472,   473,     0,     0,   474,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   477,   478,   479,   480,   754,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,     0,     0,     0,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,   756,   528,   529,     0,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
       0,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,     0,     0,   546,     0,   547,   548,   549,   550,
     551,     0,     0,   552,   177,     0,   553,     0,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   757,   566,   567,   758,   568,   569,  1164,
     184,     0,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,     0,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,     0,   593,
       0,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,     0,  1165,   638,   639,   640,   641,   209,   642,
     643,   644,  2902,   646,   647,   648,   759,   649,     0,   650,
     651,   652,   653,  2809,     0,   656,   657,   214,   658,   659,
       0,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,     0,   680,   681,   682,
     683,   684,     0,   685,  1168,   223,     0,     0,  2810,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,  1135,   232,     0,   708,
       0,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,  1170,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   761,   720,   721,
      81,    82,   737,    84,    85,    86,   738,     0,   739,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,   740,     0,     0,   101,   102,   103,   104,     0,     0,
     106,   107,   108,     0,   109,     0,     0,   741,   742,     0,
       0,     0,   743,   744,     0,     0,     0,     0,   745,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   747,
       0,   748,   749,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,     0,
     445,   446,   447,   128,   129,     0,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,  1160,   455,  1131,
     134,   456,     0,   457,   458,   459,   460,   138,     0,     0,
       0,   461,   462,   463,   464,   465,     0,   466,   467,     0,
       0,   468,   469,   470,   471,   472,   473,     0,     0,   474,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   754,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,     0,
       0,     0,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,   756,   528,   529,     0,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,     0,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,     0,     0,   546,     0,
     547,   548,   549,   550,   551,     0,     0,   552,   177,     0,
     553,     0,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   757,   566,   567,
     758,   568,   569,  1164,   184,     0,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
       0,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,     0,   593,     0,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,     0,  1165,   638,   639,
     640,   641,   209,   642,   643,   644,  1166,   646,   647,   648,
     759,   649,     0,   650,   651,   652,   653,  2809,     0,   656,
     657,   214,   658,   659,     0,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
       0,   680,   681,   682,   683,   684,     0,   685,  1168,   223,
       0,     0,  2810,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
    1135,   232,     0,   708,     0,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,  1170,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   761,   720,   721,    81,    82,   737,    84,    85,    86,
     738,     0,   739,    89,     0,     0,    92,    93,    94,    95,
      96,    97,     0,    98,    99,   740,     0,     0,   101,   102,
     103,   104,     0,     0,   106,   107,   108,     0,   109,     0,
       0,   741,   742,     0,     0,     0,   743,   744,     0,     0,
       0,     0,   745,     0,     0,     0,     0,     0,     0,     0,
       0,   746,     0,   747,     0,   748,   749,    35,     0,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,     0,   445,   446,   447,   128,   129,     0,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,   751,   134,   456,     0,   457,   458,   459,
     460,   138,     0,     0,     0,   461,   462,   463,   464,   465,
       0,   466,   467,   752,     0,   468,   469,   470,   471,   472,
     473,     0,     0,   474,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   477,   478,   479,   480,   754,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,     0,     0,     0,   519,   520,   521,   522,
       0,   523,   166,     0,   167,     0,   525,     0,   526,   527,
     756,   528,   529,     0,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,     0,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
       0,     0,   546,     0,   547,   548,   549,   550,   551,     0,
       0,   552,   177,     0,   553,     0,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   757,   566,   567,   758,   568,   569,   570,   184,     0,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,     0,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,     0,   593,     0,   196,
     594,   595,   596,   597,   598,   599,     0,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
       0,   637,   638,   639,   640,   641,   209,     0,   643,   644,
     645,   646,   647,   648,   759,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,     0,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,     0,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,   760,   232,     0,   708,     0,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   761,   720,   721,    81,    82,
       0,    84,    85,    86,     0,     0,     0,    89,     0,     0,
      92,    93,    94,    95,    96,    97,     0,    98,    99,     0,
       0,     0,   101,   102,   103,   104,     0,   105,   106,   107,
     108, -2832,   109,   110,   111,     0,     0,     0,     0,     0,
     114,   115,     0,     0,     0,     0,   116,     0,     0,     0,
       0,     0,     0,     0,     0,   117,     0,   118,     0,   119,
     120,    35,     0,   423,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   126,     0,     0,
       0,   128,   129,   130,   131,   132,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   134,     0,
       0,     0,     0,     0,     0,   138,     0,   139,     0,     0,
       0,     0,     0,     0,   142,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   145,     0,     0,     0,
       0,     0,     0,   146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   149,   150,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   156,     0,     0,     0,     0,     0,     0,     0,
     158,     0,     0,     0,     0,   160,     0,     0,     0,     0,
       0,   162,     0,     0,     0,     0,     0,   163,     0,   164,
       0,     0,     0,     0,     0,     0,   166,     0,   167,     0,
       0,     0,     0,     0,     0,     0,     0,   168,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   170,   171,     0,     0,     0,     0,     0,   172,
       0,   173,     0,     0,   174,   175,     0,   176,     0,     0,
       0,     0,     0,     0,     0,     0,   177,   178,     0,   179,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   184,   185,   186,     0,     0,     0,     0,     0,
       0,     0,   187,   188,     0,     0,     0,     0,   190,     0,
       0,   191,     0,   192,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   193,
     194,     0,   195,   196,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   197,     0,   198,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   207,     0,     0,     0,     0,     0,
     209,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   214,
       0,     0,   216,     0,     0,   217,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   219,     0,     0,     0,     0,     0,     0,   221,     0,
       0,     0,     0,     0,     0,     0,   222,   223,     0,     0,
       0,     0,   224,     0,   225,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   228,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   232,
       0,     0,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    81,
      82,     0,    84,    85,    86,     0,     0,     0,    89,     0,
       0,    92,    93,    94,    95,    96,    97,     0,    98,    99,
       0,     0,     0,   101,   102,   103,   104,     0,   105,   106,
     107,   108, -2833,   109,   110,   111,     0,     0,     0,     0,
       0,   114,   115,     0,     0,     0,     0,   116,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,   118,     0,
     119,   120,    35,     0,  1246,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   126,     0,
       0,     0,   128,   129,   130,   131,   132,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   134,
       0,     0,     0,     0,     0,     0,   138,     0,   139,     0,
       0,     0,     0,     0,     0,   142,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   145,     0,     0,
       0,     0,     0,     0,   146,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   149,   150,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   156,     0,     0,     0,     0,     0,     0,
       0,   158,     0,     0,     0,     0,   160,     0,     0,     0,
       0,     0,   162,     0,     0,     0,     0,     0,   163,     0,
     164,     0,     0,     0,     0,     0,     0,   166,     0,   167,
       0,     0,     0,     0,     0,     0,     0,     0,   168,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   170,   171,     0,     0,     0,     0,     0,
     172,     0,   173,     0,     0,   174,   175,     0,   176,     0,
       0,     0,     0,     0,     0,     0,     0,   177,   178,     0,
     179,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   184,   185,   186,     0,     0,     0,     0,
       0,     0,     0,   187,   188,     0,     0,     0,     0,   190,
       0,     0,   191,     0,   192,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   194,     0,   195,   196,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   197,     0,   198,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   207,     0,     0,     0,     0,
       0,   209,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     214,     0,     0,   216,     0,     0,   217,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   219,     0,     0,     0,     0,     0,     0,   221,
       0,     0,     0,     0,     0,     0,     0,   222,   223,     0,
       0,     0,     0,   224,     0,   225,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   228,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     232,     0,     0,   233,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      81,    82,     0,    84,    85,    86,     0,     0,     0,    89,
       0,     0,    92,    93,    94,    95,    96,    97,     0,    98,
      99,     0,     0,     0,   101,   102,   103,   104,     0,   105,
     106,   107,   108,     0,   109,   110,   111,     0,     0,     0,
       0,     0,   114,   115,     0,     0,     0,     0,   116,     0,
       0,     0,     0,     0,     0,     0,     0,   117,     0,   118,
       0,   119,     0,    35,     0,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   126,
       0,     0,     0,   128,   129,   130,   131,   132,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     134,     0,     0,     0,     0,     0,     0,   138,     0,   139,
       0,     0,     0,     0,     0,     0,   142,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   145,     0,
       0,     0,     0,     0,     0,   146,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   149,   150,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   156,     0,     0,     0,     0,     0,
       0,     0,   158,     0,     0,     0,     0,   160,     0,     0,
       0,     0,     0,   162,     0,     0,     0,     0,     0,   163,
       0,   164,     0,     0,     0,     0,     0,     0,   166,     0,
     167,     0,     0,     0,     0,     0,     0,     0,     0,   168,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   170,   171,     0,     0,     0,     0,
       0,   172,     0,   173,     0,     0,   174,   175,     0,   176,
       0,     0,     0,     0,     0,     0,     0,     0,   177,   178,
       0,   179,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   184,   185,   186,     0,     0,     0,
       0,     0,     0,     0,   187,   188,     0,     0,     0,     0,
     190,     0,     0,   191,     0,   192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   193,   194,     0,   195,   196,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   197,     0,
     198,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   207,     0,     0,     0,
       0,     0,   209,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   214,     0,     0,   216,     0,     0,   217,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   219,     0,     0,     0,     0,     0,     0,
     221,     0,     0,     0,     0,     0,     0,     0,   222,   223,
       0,     0,     0,     0,   224,     0,   225,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   228,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   232,     0,     0,   233,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    81,    82,     0,    84,    85,    86,     0,     0,     0,
      89,     0,     0,    92,    93,    94,    95,    96,    97,     0,
      98,    99,     0,     0,     0,   101,   102,   103,   104,     0,
     105,   106,   107,   108,     0,   109,   110,   111,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,     0,     0,     0,    37,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     126,     0,     0,     0,   128,   129,   130,   131,   132,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   134,     0,     0,     0,     0,     0,     0,   138,     0,
     139,     0,     0,     0,     0,     0,     0,   142,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   145,
       0,     0,     0,     0,     0,     0,   146,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   149,   150,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   156,     0,     0,     0,     0,
       0,     0,     0,   158,     0,     0,     0,     0,   160,     0,
       0,     0,     0,     0,   162,     0,     0,     0,     0,     0,
     163,     0,   164,     0,     0,     0,     0,     0,     0,   166,
       0,   167,     0,     0,     0,     0,     0,     0,     0,     0,
     168,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   170,   171,     0,     0,     0,
       0,     0,   172,     0,   173,     0,     0,   174,   175,     0,
     176,     0,     0,     0,     0,     0,     0,     0,     0,   177,
     178,     0,   179,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   184,   185,   186,     0,     0,
       0,     0,     0,     0,     0,   187,   188,     0,     0,     0,
       0,   190,     0,     0,   191,     0,   192,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   194,     0,   195,   196,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   197,
       0,   198,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   207,     0,     0,
       0,     0,     0,   209,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   214,     0,     0,   216,     0,     0,   217,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   219,     0,     0,     0,     0,     0,
       0,   221,     0,     0,     0,     0,     0,     0,     0,   222,
     223,     0,     0,     0,     0,   224,     0,   225,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   228,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   232,     0,     0,   233,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    81,    82,     0,    84,    85,    86,     0,     0,
       0,    89,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,    99,     0,     0,     0,   101,   102,   103,   104,
       0,     0,   106,   107,   108,     0,   109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    35,     0,     0,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   126,     0,     0,     0,   128,   129,   130,   131,   132,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   134,     0,     0,     0,     0,     0,     0,   138,
       0,   139,     0,     0,     0,     0,     0,     0,   142,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     145,     0,     0,     0,     0,     0,     0,   146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   149,   150,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   158,     0,     0,     0,     0,   160,
       0,     0,     0,     0,     0,   162,     0,     0,     0,     0,
       0,   163,     0,   164,     0,     0,     0,     0,     0,     0,
     166,     0,   167,     0,     0,     0,     0,     0,     0,     0,
       0,   168,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   170,   171,     0,     0,
       0,     0,     0,   172,     0,   173,     0,     0,   174,   175,
       0,   176,     0,     0,     0,     0,     0,     0,     0,     0,
     177,   178,     0,   179,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   184,   185,   186,     0,
       0,     0,     0,     0,     0,     0,   187,   188,     0,     0,
       0,     0,   190,     0,     0,   191,     0,   192,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   193,   194,     0,   195,   196,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     197,     0,   198,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   207,     0,
       0,     0,     0,     0,   209,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   214,     0,     0,   216,     0,     0,   217,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   219,     0,     0,     0,     0,
       0,     0,   221,     0,     0,     0,     0,     0,     0,     0,
     222,   223,     0,     0,     0,     0,   224,     0,   225,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   232,     0,     0,   233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    35,   428,     0,     0,    37,     0,    38,
      39,     0,     0,     0,     0,    40,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,   126,
     445,   446,   447,   128,   129,   130,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,     0,
     134,   456,     0,   457,   458,   459,   460,   138,     0,   139,
       0,   461,   462,   463,   464,   465,   142,   466,   467,     0,
       0,   468,   469,   470,   471,   472,   473,     0,   145,   474,
     475,     0,     0,     0,     0,   146,     0,     0,     0,   477,
     478,   479,   480,     0,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,  2373,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,   163,
       0,   164,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,     0,   528,   529,   168,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   170,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,   174,   175,   546,   176,
     547,   548,   549,   550,   551,     0,     0,   552,   177,   178,
     553,   179,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
       0,   568,   569,   570,   184,   185,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
     190,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,  2374,     0,   588,   589,   590,     0,     0,   591,
     592,   193,   194,   593,   195,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,   207,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
       0,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,   216,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
     221,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,  2375,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
       0,   232,     0,   708,   233,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    35,   720,   721,     0,    37,     0,     0,     0,     0,
       0,  1880,  1881,  5787,     0,     0,     0,     0,     0,     0,
    5788,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   123,   124,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447,   128,   129,   130,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,     0,   134,   456,
       0,   457,   458,   459,   460,   138,     0,   139,     0,   461,
     462,   463,   464,   465,   142,   466,   467,     0,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,     0,
       0,     0,     0,   146,     0,     0,     0,   477,   478,   479,
     480,     0,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,     0,   528,   529,   168,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,   177,   178,   553,   179,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,     0,   568,
     569,   570,   184,   185,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,   190,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
     194,   593,   195,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,     0,   649,
     212,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,   216,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,   220,   679,   221,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,   231,   232,
       0,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,   234,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,     0,
     720,   721,    35,   428,   246,     0,    37,     0,    38,    39,
       0,     0,     0,     0,    40,     0,     0,     0,   247,     0,
       0,     0,     0,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   437,   438,   439,     0,     0,     0,     0,     0,
       0,     0,   440,   441,     0,   442,   443,   444,   126,   445,
     446,   447,   128,   129,   130,   131,   132,     0,   448,   449,
     450,   451,   452,   453,     0,     0,   454,   455,     0,   134,
     456,     0,   457,   458,   459,   460,   138,     0,   139,     0,
     461,   462,   463,   464,   465,   142,   466,   467,     0,     0,
     468,   469,   470,   471,   472,   473,     0,   145,   474,   475,
       0,     0,     0,     0,   146,     0,     0,     0,   477,   478,
     479,   480,     0,   481,   149,   150,   482,  2581,   483,     0,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,     0,   499,
     500,   501,     0,   502,   503,   504,     0,   505,   506,   507,
     508,   158,   509,   510,   511,   512,   160,  2373,   513,     0,
     514,   515,   162,   516,     0,   517,     0,   518,   163,     0,
     164,   519,   520,   521,   522,     0,   523,   166,     0,   167,
     524,   525,     0,   526,   527,     0,   528,   529,   168,   530,
     531,   532,   533,     0,   534,   535,   536,   537,   538,   539,
     540,     0,   541,   170,   171,     0,   542,   543,   544,     0,
     172,     0,   173,     0,   545,   174,   175,   546,   176,   547,
     548,   549,   550,   551,     0,     0,   552,   177,   178,   553,
     179,     0,   554,   555,   556,     0,     0,   557,   558,   559,
     560,   561,   562,   563,   564,   565,     0,   566,   567,     0,
     568,   569,   570,   184,   185,   186,   571,   572,   573,   574,
     575,   576,   577,   187,   188,   578,     0,   579,   580,   190,
     581,     0,   191,   582,   192,   583,   584,   585,     0,   586,
     587,  2374,     0,   588,   589,   590,     0,     0,   591,   592,
     193,   194,   593,   195,   196,   594,   595,   596,   597,   598,
     599,   600,   601,   602,     0,   603,   604,   197,   605,   198,
     606,   607,   608,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   200,   619,   620,   621,   622,     0,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,     0,   635,   636,   207,   637,   638,   639,   640,
     641,   209,   642,   643,   644,   645,   646,   647,   648,     0,
     649,     0,   650,   651,   652,   653,   654,     0,   656,   657,
     214,   658,   659,   216,   660,   661,   217,   662,     0,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   219,   676,     0,   677,   678,     0,   679,   221,
     680,   681,   682,   683,   684,     0,   685,   222,   223,     0,
       0,   687,   688,   224,   689,   225,  2375,   690,   691,   692,
     693,   694,   695,   696,   697,     0,     0,   698,   699,   700,
     701,   702,     0,     0,   703,   704,   705,   706,   707,     0,
     232,     0,   708,   233,   709,   710,   711,   712,     0,     0,
     713,     0,     0,   714,   715,   716,   717,   718,   719,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
       0,   720,   721,     0,     0,     0,     0,     0,    35,   428,
    1880,  1881,    37,     0,    38,    39,     0,     0,     0,     0,
      40,     0,     0,     0,     0,     0,     0,     0,     0,   429,
     430,   431,   432,   433,   434,   435,   436,     0,   437,   438,
     439,     0,     0,     0,     0,     0,     0,     0,   440,   441,
       0,   442,   443,   444,   126,   445,   446,   447,   128,   129,
     130,   131,   132,     0,   448,   449,   450,   451,   452,   453,
       0,     0,   454,   455,     0,   134,   456,     0,   457,   458,
     459,   460,   138,     0,   139,     0,   461,   462,   463,   464,
     465,   142,   466,   467,     0,     0,   468,   469,   470,   471,
     472,   473,     0,   145,   474,   475,     0,     0,     0,     0,
     146,     0,     0,     0,   477,   478,   479,   480,     0,   481,
     149,   150,   482,  2586,   483,     0,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,     0,   499,   500,   501,     0,   502,
     503,   504,     0,   505,   506,   507,   508,   158,   509,   510,
     511,   512,   160,  2373,   513,     0,   514,   515,   162,   516,
       0,   517,     0,   518,   163,     0,   164,   519,   520,   521,
     522,     0,   523,   166,     0,   167,   524,   525,     0,   526,
     527,     0,   528,   529,   168,   530,   531,   532,   533,     0,
     534,   535,   536,   537,   538,   539,   540,     0,   541,   170,
     171,     0,   542,   543,   544,     0,   172,     0,   173,     0,
     545,   174,   175,   546,   176,   547,   548,   549,   550,   551,
       0,     0,   552,   177,   178,   553,   179,     0,   554,   555,
     556,     0,     0,   557,   558,   559,   560,   561,   562,   563,
     564,   565,     0,   566,   567,     0,   568,   569,   570,   184,
     185,   186,   571,   572,   573,   574,   575,   576,   577,   187,
     188,   578,     0,   579,   580,   190,   581,     0,   191,   582,
     192,   583,   584,   585,     0,   586,   587,  2374,     0,   588,
     589,   590,     0,     0,   591,   592,   193,   194,   593,   195,
     196,   594,   595,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,   197,   605,   198,   606,   607,   608,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     200,   619,   620,   621,   622,     0,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,     0,   635,
     636,   207,   637,   638,   639,   640,   641,   209,   642,   643,
     644,   645,   646,   647,   648,     0,   649,     0,   650,   651,
     652,   653,   654,     0,   656,   657,   214,   658,   659,   216,
     660,   661,   217,   662,     0,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,   674,   675,   219,   676,
       0,   677,   678,     0,   679,   221,   680,   681,   682,   683,
     684,     0,   685,   222,   223,     0,     0,   687,   688,   224,
     689,   225,  2375,   690,   691,   692,   693,   694,   695,   696,
     697,     0,     0,   698,   699,   700,   701,   702,     0,     0,
     703,   704,   705,   706,   707,     0,   232,     0,   708,   233,
     709,   710,   711,   712,     0,     0,   713,     0,     0,   714,
     715,   716,   717,   718,   719,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,     0,   720,   721,     0,
       0,     0,     0,     0,    35,   428,  1880,  1881,    37,     0,
      38,    39,     0,     0,     0,     0,    40,     0,     0,     0,
       0,     0,     0,     0,     0,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   437,   438,   439,     0,     0,     0,
       0,     0,     0,     0,   440,   441,     0,   442,   443,   444,
     126,   445,   446,   447,   128,   129,   130,   131,   132,     0,
     448,   449,   450,   451,   452,   453,     0,     0,   454,   455,
       0,   134,   456,     0,   457,   458,   459,   460,   138,     0,
     139,     0,   461,   462,   463,   464,   465,   142,   466,   467,
       0,     0,   468,   469,   470,   471,   472,   473,     0,   145,
     474,   475,     0,     0,     0,     0,   146,     0,     0,     0,
     477,   478,   479,   480,     0,   481,   149,   150,   482,     0,
     483,     0,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
       0,   499,   500,   501,     0,   502,   503,   504,     0,   505,
     506,   507,   508,   158,   509,   510,   511,   512,   160,  2373,
     513,     0,   514,   515,   162,   516,     0,   517,     0,   518,
     163,     0,   164,   519,   520,   521,   522,     0,   523,   166,
       0,   167,   524,   525,     0,   526,   527,     0,   528,   529,
     168,   530,   531,   532,   533,     0,   534,   535,   536,   537,
     538,   539,   540,     0,   541,   170,   171,     0,   542,   543,
     544,     0,   172,     0,   173,     0,   545,   174,   175,   546,
     176,   547,   548,   549,   550,   551,     0,     0,   552,   177,
     178,   553,   179,     0,   554,   555,   556,     0,     0,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,     0,   568,   569,   570,   184,   185,   186,   571,   572,
     573,   574,   575,   576,   577,   187,   188,   578,     0,   579,
     580,   190,   581,     0,   191,   582,   192,   583,   584,   585,
       0,   586,   587,  2374,     0,   588,   589,   590,     0,     0,
     591,   592,   193,   194,   593,   195,   196,   594,   595,   596,
     597,   598,   599,   600,   601,   602,     0,   603,   604,   197,
     605,   198,   606,   607,   608,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   200,   619,   620,   621,
     622,     0,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,     0,   635,   636,   207,   637,   638,
     639,   640,   641,   209,   642,   643,   644,   645,   646,   647,
     648,     0,   649,     0,   650,   651,   652,   653,   654,     0,
     656,   657,   214,   658,   659,   216,   660,   661,   217,   662,
       0,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   219,   676,     0,   677,   678,     0,
     679,   221,   680,   681,   682,   683,   684,     0,   685,   222,
     223,     0,     0,   687,   688,   224,   689,   225,  2375,   690,
     691,   692,   693,   694,   695,   696,   697,     0,     0,   698,
     699,   700,   701,   702,     0,     0,   703,   704,   705,   706,
     707,     0,   232,     0,   708,   233,   709,   710,   711,   712,
       0,     0,   713,     0,     0,   714,   715,   716,   717,   718,
     719,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,     0,   720,   721,     0,     0,    35,   428,     0,
       0,    37,  1880,  1881,    39,     0,     0,     0,     0,    40,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,   128,   129,   130,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,     0,   134,   456,     0,   457,   458,   459,
     460,   138,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,     0,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,     0,   477,   478,   479,   480,     0,   481,   149,
     150,   482,  3545,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,  2373,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
       0,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,   177,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,     0,   568,   569,   570,   184,   185,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,   190,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,  2374,     0,   588,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,     0,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,   216,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,  2375,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,     0,   232,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,     0,   720,   721,     0,     0,
      35,   428,     0,     0,    37,  1089,  1090,    39,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     437,   438,   439,     0,     0,     0,     0,     0,     0,     0,
     440,   441,     0,   442,   443,   444,   126,   445,   446,   447,
     128,   129,   130,   131,   132,     0,   448,   449,   450,   451,
     452,   453,     0,     0,   454,   455,     0,   134,   456,     0,
     457,   458,   459,   460,   138,     0,   139,     0,   461,   462,
     463,   464,   465,   142,   466,   467,     0,     0,   468,   469,
     470,   471,   472,   473,     0,   145,   474,   475,     0,     0,
       0,     0,   146,     0,     0,   476,   477,   478,   479,   480,
       0,   481,   149,   150,   482,     0,   483,     0,   484,   485,
     486,   487,   488,   489,     0,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,     0,   499,   500,   501,
       0,   502,   503,   504,     0,   505,   506,   507,   508,   158,
     509,   510,   511,   512,   160,     0,   513,     0,   514,   515,
     162,   516,     0,   517,     0,   518,   163,     0,   164,   519,
     520,   521,   522,     0,   523,   166,     0,   167,   524,   525,
       0,   526,   527,     0,   528,   529,   168,   530,   531,   532,
     533,     0,   534,   535,   536,   537,   538,   539,   540,     0,
     541,   170,   171,     0,   542,   543,   544,     0,   172,     0,
     173,     0,   545,   174,   175,   546,   176,   547,   548,   549,
     550,   551,     0,     0,   552,   177,   178,   553,   179,     0,
     554,   555,   556,     0,     0,   557,   558,   559,   560,   561,
     562,   563,   564,   565,     0,   566,   567,     0,   568,   569,
     570,   184,   185,   186,   571,   572,   573,   574,   575,   576,
     577,   187,   188,   578,     0,   579,   580,   190,   581,     0,
     191,   582,   192,   583,   584,   585,     0,   586,   587,     0,
       0,   588,   589,   590,     0,     0,   591,   592,   193,   194,
     593,   195,   196,   594,   595,   596,   597,   598,   599,   600,
     601,   602,     0,   603,   604,   197,   605,   198,   606,   607,
     608,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   200,   619,   620,   621,   622,     0,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
       0,   635,   636,   207,   637,   638,   639,   640,   641,   209,
     642,   643,   644,   645,   646,   647,   648,     0,   649,     0,
     650,   651,   652,   653,   654,   655,   656,   657,   214,   658,
     659,   216,   660,   661,   217,   662,     0,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,   674,   675,
     219,   676,     0,   677,   678,     0,   679,   221,   680,   681,
     682,   683,   684,     0,   685,   222,   223,   686,     0,   687,
     688,   224,   689,   225,     0,   690,   691,   692,   693,   694,
     695,   696,   697,     0,     0,   698,   699,   700,   701,   702,
       0,     0,   703,   704,   705,   706,   707,     0,   232,     0,
     708,   233,   709,   710,   711,   712,     0,     0,   713,     0,
       0,   714,   715,   716,   717,   718,   719,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,     0,   720,
     721,    35,   428,     0,     0,    37,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447,   128,   129,   130,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,     0,   134,   456,
       0,   457,   458,   459,   460,   138,     0,   139,     0,   461,
     462,   463,   464,   465,   142,   466,   467,     0,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,     0,
       0,     0,     0,   146,     0,     0,   476,   477,   478,   479,
     480,     0,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,     0,   528,   529,   168,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,   177,   178,   553,   179,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,     0,   568,
     569,   570,   184,   185,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,   190,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
     194,   593,   195,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,     0,   649,
       0,   650,   651,   652,   653,   654,   655,   656,   657,   214,
     658,   659,   216,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,   221,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,     0,   232,
       0,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    35,
     720,   721,     0,    37,     0,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,   126,   445,   446,   447,   128,
     129,   130,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,     0,   134,   456,     0,   457,
     458,   459,   460,   138,     0,   139,     0,   461,   462,   463,
     464,   465,   142,   466,   467,     0,     0,   468,   469,   470,
     471,   472,   473,     0,   145,   474,   475,     0,     0,     0,
       0,   146,     0,     0,     0,   477,   478,   479,   480,     0,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,  2373,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,   163,     0,   164,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,     0,   528,   529,   168,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     170,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,   174,   175,   546,   176,   547,   548,   549,   550,
     551,     0,     0,   552,   177,   178,   553,   179,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,   568,   569,   570,
     184,   185,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,   190,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,  2374,     0,
     588,   589,   590,     0,     0,   591,   592,   193,   194,   593,
     195,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,   207,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,     0,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
     216,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,   221,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,  2375,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,     0,   232,     0,   708,
     233,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    35,   720,   721,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,  1327,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,   128,   129,   130,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,     0,   134,   456,     0,   457,   458,   459,
     460,   138,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,     0,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,   476,   477,   478,   479,   480,     0,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
       0,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,   177,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,     0,   568,   569,   570,   184,   185,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,   190,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,     0,   649,     0,   650,   651,   652,
     653,   654,   655,   656,   657,   214,   658,   659,   216,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,     0,   232,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    35,   720,   721,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,  1348,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,   126,   445,   446,   447,   128,   129,   130,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,     0,   134,   456,     0,   457,   458,   459,   460,   138,
       0,   139,     0,   461,   462,   463,   464,   465,   142,   466,
     467,     0,     0,   468,   469,   470,   471,   472,   473,     0,
     145,   474,   475,     0,     0,     0,     0,   146,     0,     0,
     476,   477,   478,   479,   480,     0,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,   163,     0,   164,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,     0,   528,
     529,   168,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   170,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,   174,   175,
     546,   176,   547,   548,   549,   550,   551,     0,     0,   552,
     177,   178,   553,   179,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,  1349,   562,   563,   564,   565,     0,
     566,   567,     0,   568,   569,   570,   184,   185,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,   190,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,   194,   593,   195,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,   207,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,     0,   649,     0,   650,   651,   652,   653,   654,
     655,   656,   657,   214,   658,   659,   216,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,   221,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,     0,   232,     0,   708,   233,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    35,   720,   721,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,   126,
     445,   446,   447,   128,   129,   130,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,     0,
     134,   456,     0,   457,   458,   459,   460,   138,     0,   139,
       0,   461,   462,   463,   464,   465,   142,   466,   467,     0,
       0,   468,   469,   470,   471,   472,   473,     0,   145,   474,
     475,     0,     0,     0,     0,   146,     0,     0,   476,   477,
     478,   479,   480,     0,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,   163,
       0,   164,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,     0,   528,   529,   168,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   170,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,   174,   175,   546,   176,
     547,   548,   549,   550,   551,     0,     0,   552,   177,   178,
     553,   179,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
       0,   568,   569,   570,   184,   185,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
     190,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,   194,   593,   195,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,   207,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
       0,   649,     0,   650,   651,   652,   653,   654,   655,   656,
     657,   214,   658,   659,   216,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
     221,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,  2971,     0,   703,   704,   705,   706,   707,
       0,   232,     0,   708,   233,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    35,   720,   721,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447,   128,   129,   130,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,     0,   134,   456,
       0,   457,   458,   459,   460,   138,     0,   139,     0,   461,
     462,   463,   464,   465,   142,   466,   467,     0,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,     0,
       0,     0,     0,   146,     0,     0,   476,   477,   478,   479,
     480,     0,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,   166,  4022,   167,   524,
     525,     0,   526,   527,     0,   528,   529,   168,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,   177,   178,   553,   179,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,     0,   568,
     569,   570,   184,   185,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,   190,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
     194,   593,   195,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,     0,   649,
       0,   650,   651,   652,   653,   654,   655,   656,   657,   214,
     658,   659,   216,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,   221,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,     0,   232,
       0,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    35,
     720,   721,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,     0,     0,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,   126,   445,   446,   447,   128,
     129,   130,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,     0,   134,   456,     0,   457,
     458,   459,   460,   138,     0,   139,     0,   461,   462,   463,
     464,   465,   142,   466,   467,     0,     0,   468,   469,   470,
     471,   472,   473,     0,   145,   474,   475,     0,     0,     0,
       0,   146,     0,     0,   476,   477,   478,   479,   480,     0,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,   163,     0,   164,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,     0,   528,   529,   168,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     170,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,   174,   175,   546,   176,   547,   548,   549,   550,
     551,     0,     0,   552,   177,   178,   553,   179,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,   568,   569,   570,
     184,   185,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,   190,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,   194,   593,
     195,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,   207,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,     0,   649,     0,   650,
     651,   652,   653,   654,   655,   656,   657,   214,   658,   659,
     216,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,   221,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,     0,   232,     0,   708,
     233,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    35,   720,   721,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,   128,   129,   130,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,     0,   134,   456,     0,   457,   458,   459,
     460,   138,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,     0,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,   476,   477,   478,   479,   480,     0,   481,   149,
     150,   482,     0,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
       0,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,   177,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,  1454,   562,   563,   564,
     565,     0,   566,   567,     0,   568,   569,   570,   184,   185,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,   190,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,     0,   649,     0,   650,   651,   652,
     653,   654,   655,   656,   657,   214,   658,   659,   216,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,     0,   232,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    35,   720,   721,     0,    37,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,   126,   445,   446,   447,   128,   129,   130,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,     0,   134,   456,     0,   457,   458,   459,   460,   138,
       0,   139,     0,   461,   462,   463,   464,   465,   142,   466,
     467,     0,     0,   468,   469,   470,   471,   472,   473,     0,
     145,   474,   475,     0,     0,     0,     0,   146,     0,     0,
     476,   477,   478,   479,   480,     0,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,   163,     0,   164,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,     0,   528,
    1539,   168,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   170,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,   174,   175,
     546,   176,   547,   548,   549,   550,   551,     0,     0,   552,
     177,   178,   553,   179,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,     0,
     566,   567,     0,   568,   569,   570,   184,   185,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,   190,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,   194,   593,   195,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,   207,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,     0,   649,     0,   650,   651,   652,   653,   654,
     655,   656,   657,   214,   658,   659,   216,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,   221,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,     0,   232,     0,   708,   233,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    35,   720,   721,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,   126,
     445,   446,   447,   128,   129,   130,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,     0,
     134,   456,     0,   457,   458,   459,   460,   138,     0,   139,
       0,   461,   462,   463,   464,   465,   142,   466,   467,     0,
       0,   468,   469,   470,   471,   472,   473,     0,   145,   474,
     475,     0,     0,     0,     0,   146,     0,     0,   476,   477,
     478,   479,   480,     0,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,   163,
       0,   164,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,     0,   528,  1552,   168,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   170,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,   174,   175,   546,   176,
     547,   548,   549,   550,   551,     0,     0,   552,   177,   178,
     553,   179,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
       0,   568,   569,   570,   184,   185,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
     190,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,   194,   593,   195,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,   207,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
       0,   649,     0,   650,   651,   652,   653,   654,   655,   656,
     657,   214,   658,   659,   216,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
     221,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
       0,   232,     0,   708,   233,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    35,   720,   721,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447,   128,   129,   130,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,     0,   134,   456,
       0,   457,   458,   459,   460,   138,     0,   139,     0,   461,
     462,   463,   464,   465,   142,   466,   467,     0,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,     0,
       0,     0,     0,   146,     0,     0,   476,   477,   478,   479,
     480,     0,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,     0,   528,  1564,   168,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,   177,   178,   553,   179,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
    1565,   562,   563,   564,   565,     0,   566,   567,     0,   568,
     569,   570,   184,   185,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,   190,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
     194,   593,   195,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,     0,   649,
       0,   650,   651,   652,   653,   654,   655,   656,   657,   214,
     658,   659,   216,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,   221,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,     0,   232,
       0,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    35,
     720,   721,     0,    37,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   123,   124,     0,     0,     0,     0,     0,   440,
     441,     0,   442,   443,   444,   126,   445,   446,   447,   128,
     129,   130,   131,   132,     0,   448,   449,   450,   451,   452,
     453,     0,     0,   454,   455,     0,   134,   456,     0,   457,
     458,   459,   460,   138,     0,   139,     0,   461,   462,   463,
     464,   465,   142,   466,   467,     0,     0,   468,   469,   470,
     471,   472,   473,     0,   145,   474,   475,     0,     0,     0,
       0,   146,     0,     0,     0,   477,   478,   479,   480,     0,
     481,   149,   150,   482,     0,   483,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,     0,   499,   500,   501,     0,
     502,   503,   504,     0,   505,   506,   507,   508,   158,   509,
     510,   511,   512,   160,     0,   513,     0,   514,   515,   162,
     516,     0,   517,     0,   518,   163,     0,   164,   519,   520,
     521,   522,     0,   523,   166,     0,   167,   524,   525,     0,
     526,   527,     0,   528,   529,   168,   530,   531,   532,   533,
       0,   534,   535,   536,   537,   538,   539,   540,     0,   541,
     170,   171,     0,   542,   543,   544,     0,   172,     0,   173,
       0,   545,   174,   175,   546,   176,   547,   548,   549,   550,
     551,     0,     0,   552,   177,   178,   553,   179,     0,   554,
     555,   556,     0,     0,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,   568,   569,   570,
     184,   185,   186,   571,   572,   573,   574,   575,   576,   577,
     187,   188,   578,     0,   579,   580,   190,   581,     0,   191,
     582,   192,   583,   584,   585,     0,   586,   587,     0,     0,
     588,   589,   590,     0,     0,   591,   592,   193,   194,   593,
     195,   196,   594,   595,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   197,   605,   198,   606,   607,   608,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   200,   619,   620,   621,   622,     0,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,     0,
     635,   636,   207,   637,   638,   639,   640,   641,   209,   642,
     643,   644,   645,   646,   647,   648,     0,   649,     0,   650,
     651,   652,   653,   654,     0,   656,   657,   214,   658,   659,
     216,   660,   661,   217,   662,     0,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   219,
     676,     0,   677,   678,     0,   679,   221,   680,   681,   682,
     683,   684,     0,   685,   222,   223,     0,     0,   687,   688,
     224,   689,   225,     0,   690,   691,   692,   693,   694,   695,
     696,   697,     0,     0,   698,   699,   700,   701,   702,     0,
       0,   703,   704,   705,   706,   707,     0,   232,     0,   708,
     233,   709,   710,   711,   712,     0,     0,   713,     0,     0,
     714,   715,   716,   717,   718,   719,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    35,   720,   721,
       0,    37,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   437,   438,   439,
       0,     0,     0,     0,     0,     0,     0,   440,   441,     0,
     442,   443,   444,   126,   445,   446,   447,   128,   129,   130,
     131,   132,     0,   448,   449,   450,   451,   452,   453,     0,
       0,   454,   455,     0,   134,   456,     0,   457,   458,   459,
     460,   138,     0,   139,     0,   461,   462,   463,   464,   465,
     142,   466,   467,     0,     0,   468,   469,   470,   471,   472,
     473,     0,   145,   474,   475,     0,     0,     0,     0,   146,
       0,     0,     0,   477,   478,   479,   480,     0,   481,   149,
     150,   482,  2566,   483,     0,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,     0,   499,   500,   501,     0,   502,   503,
     504,     0,   505,   506,   507,   508,   158,   509,   510,   511,
     512,   160,     0,   513,     0,   514,   515,   162,   516,     0,
     517,     0,   518,   163,     0,   164,   519,   520,   521,   522,
       0,   523,   166,     0,   167,   524,   525,     0,   526,   527,
       0,   528,   529,   168,   530,   531,   532,   533,     0,   534,
     535,   536,   537,   538,   539,   540,     0,   541,   170,   171,
       0,   542,   543,   544,     0,   172,     0,   173,     0,   545,
     174,   175,   546,   176,   547,   548,   549,   550,   551,     0,
       0,   552,   177,   178,   553,   179,     0,   554,   555,   556,
       0,     0,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,     0,   568,   569,   570,   184,   185,
     186,   571,   572,   573,   574,   575,   576,   577,   187,   188,
     578,     0,   579,   580,   190,   581,     0,   191,   582,   192,
     583,   584,   585,     0,   586,   587,     0,     0,   588,   589,
     590,     0,     0,   591,   592,   193,   194,   593,   195,   196,
     594,   595,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   197,   605,   198,   606,   607,   608,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   200,
     619,   620,   621,   622,     0,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,     0,   635,   636,
     207,   637,   638,   639,   640,   641,   209,   642,   643,   644,
     645,   646,   647,   648,     0,   649,     0,   650,   651,   652,
     653,   654,     0,   656,   657,   214,   658,   659,   216,   660,
     661,   217,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   219,   676,     0,
     677,   678,     0,   679,   221,   680,   681,   682,   683,   684,
       0,   685,   222,   223,     0,     0,   687,   688,   224,   689,
     225,     0,   690,   691,   692,   693,   694,   695,   696,   697,
       0,     0,   698,   699,   700,   701,   702,     0,     0,   703,
     704,   705,   706,   707,     0,   232,     0,   708,   233,   709,
     710,   711,   712,     0,     0,   713,     0,     0,   714,   715,
     716,   717,   718,   719,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    35,   720,   721,     0,    37,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   437,   438,   439,     0,     0,
       0,     0,     0,     0,     0,   440,   441,     0,   442,   443,
     444,   126,   445,   446,   447,   128,   129,   130,   131,   132,
       0,   448,   449,   450,   451,   452,   453,     0,     0,   454,
     455,     0,   134,   456,     0,   457,   458,   459,   460,   138,
       0,   139,     0,   461,   462,   463,   464,   465,   142,   466,
     467,     0,     0,   468,   469,   470,   471,   472,   473,     0,
     145,   474,   475,     0,     0,     0,     0,   146,     0,     0,
       0,   477,   478,   479,   480,     0,   481,   149,   150,   482,
       0,   483,     0,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,     0,   499,   500,   501,     0,   502,   503,   504,     0,
     505,   506,   507,   508,   158,   509,   510,   511,   512,   160,
       0,   513,     0,   514,   515,   162,   516,     0,   517,     0,
     518,   163,     0,   164,   519,   520,   521,   522,     0,   523,
     166,     0,   167,   524,   525,     0,   526,   527,     0,   528,
     529,   168,   530,   531,   532,   533,     0,   534,   535,   536,
     537,   538,   539,   540,     0,   541,   170,   171,     0,   542,
     543,   544,     0,   172,     0,   173,     0,   545,   174,   175,
     546,   176,   547,   548,   549,   550,   551,     0,     0,   552,
     177,   178,   553,   179,     0,   554,   555,   556,     0,     0,
     557,   558,   559,   560,   561,   562,   563,   564,   565,     0,
     566,   567,     0,   568,   569,   570,   184,   185,   186,   571,
     572,   573,   574,   575,   576,   577,   187,   188,   578,     0,
     579,   580,   190,   581,     0,   191,   582,   192,   583,   584,
     585,     0,   586,   587,     0,     0,   588,   589,   590,     0,
       0,   591,   592,   193,   194,   593,   195,   196,   594,   595,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     197,   605,   198,   606,   607,   608,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   200,   619,   620,
     621,   622,     0,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,     0,   635,   636,   207,   637,
     638,   639,   640,   641,   209,   642,   643,   644,   645,   646,
     647,   648,     0,   649,     0,   650,   651,   652,   653,   654,
       0,   656,   657,   214,   658,   659,   216,   660,   661,   217,
     662,     0,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   219,   676,     0,   677,   678,
       0,   679,   221,   680,   681,   682,   683,   684,     0,   685,
     222,   223,     0,     0,   687,   688,   224,   689,   225,     0,
     690,   691,   692,   693,   694,   695,   696,   697,     0,     0,
     698,   699,   700,   701,   702,     0,     0,   703,   704,   705,
     706,   707,     0,   232,     0,   708,   233,   709,   710,   711,
     712,     0,     0,   713,     0,     0,   714,   715,   716,   717,
     718,   719,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    35,   720,   721,     0,    37,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,     0,   440,   441,     0,   442,   443,   444,   126,
     445,   446,   447,   128,   129,   130,   131,   132,     0,   448,
     449,   450,   451,   452,   453,     0,     0,   454,   455,     0,
     134,   456,     0,   457,   458,   459,   460,   138,     0,   139,
       0,   461,   462,   463,   464,   465,   142,   466,   467,     0,
       0,   468,   469,   470,   471,   472,   473,     0,   145,   474,
     475,     0,     0,     0,     0,   146,     0,     0,     0,   477,
     478,   479,   480,     0,   481,   149,   150,   482,     0,   483,
       0,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,     0,
     499,   500,   501,     0,   502,   503,   504,     0,   505,   506,
     507,   508,   158,   509,   510,   511,   512,   160,     0,   513,
       0,   514,   515,   162,   516,     0,   517,     0,   518,   163,
       0,   164,   519,   520,   521,   522,     0,   523,   166,     0,
     167,   524,   525,     0,   526,   527,     0,   528,  2349,   168,
     530,   531,   532,   533,     0,   534,   535,   536,   537,   538,
     539,   540,     0,   541,   170,   171,     0,   542,   543,   544,
       0,   172,     0,   173,     0,   545,   174,   175,   546,   176,
     547,   548,   549,   550,   551,     0,     0,   552,   177,   178,
     553,   179,     0,   554,   555,   556,     0,     0,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
       0,   568,   569,   570,   184,   185,   186,   571,   572,   573,
     574,   575,   576,   577,   187,   188,   578,     0,   579,   580,
     190,   581,     0,   191,   582,   192,   583,   584,   585,     0,
     586,   587,     0,     0,   588,   589,   590,     0,     0,   591,
     592,   193,   194,   593,   195,   196,   594,   595,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   197,   605,
     198,   606,   607,   608,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   200,   619,   620,   621,   622,
       0,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,     0,   635,   636,   207,   637,   638,   639,
     640,   641,   209,   642,   643,   644,   645,   646,   647,   648,
       0,   649,     0,   650,   651,   652,   653,   654,     0,   656,
     657,   214,   658,   659,   216,   660,   661,   217,   662,     0,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   219,   676,     0,   677,   678,     0,   679,
     221,   680,   681,   682,   683,   684,     0,   685,   222,   223,
       0,     0,   687,   688,   224,   689,   225,     0,   690,   691,
     692,   693,   694,   695,   696,   697,     0,     0,   698,   699,
     700,   701,   702,     0,     0,   703,   704,   705,   706,   707,
       0,   232,     0,   708,   233,   709,   710,   711,   712,     0,
       0,   713,     0,     0,   714,   715,   716,   717,   718,   719,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    35,   720,   721,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   437,   438,   439,     0,     0,     0,     0,     0,     0,
       0,   440,   441,     0,   442,   443,   444,   126,   445,   446,
     447,   128,   129,   130,   131,   132,     0,   448,   449,   450,
     451,   452,   453,     0,     0,   454,   455,     0,   134,   456,
       0,   457,   458,   459,   460,   138,     0,   139,     0,   461,
     462,   463,   464,   465,   142,   466,   467,     0,     0,   468,
     469,   470,   471,   472,   473,     0,   145,   474,   475,     0,
       0,     0,     0,   146,     0,     0,     0,   477,   478,   479,
     480,     0,   481,   149,   150,   482,     0,   483,     0,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,     0,   499,   500,
     501,     0,   502,   503,   504,     0,   505,   506,   507,   508,
     158,   509,   510,   511,   512,   160,     0,   513,     0,   514,
     515,   162,   516,     0,   517,     0,   518,   163,     0,   164,
     519,   520,   521,   522,     0,   523,   166,     0,   167,   524,
     525,     0,   526,   527,     0,   528,   529,   168,   530,   531,
     532,   533,     0,   534,   535,   536,   537,   538,   539,   540,
       0,   541,   170,   171,     0,   542,   543,   544,     0,   172,
       0,   173,     0,   545,   174,   175,   546,   176,   547,   548,
     549,   550,   551,     0,     0,   552,   177,   178,   553,   179,
       0,   554,   555,   556,     0,     0,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,     0,   568,
     569,   570,   184,   185,   186,   571,   572,   573,   574,   575,
     576,   577,   187,   188,   578,     0,   579,   580,   190,   581,
       0,   191,   582,   192,   583,   584,   585,     0,   586,   587,
       0,     0,   588,   589,   590,     0,     0,   591,   592,   193,
     194,   593,   195,   196,   594,   595,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   197,   605,   198,   606,
     607,   608,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   200,   619,   620,   621,   622,     0,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,     0,   635,   636,   207,   637,   638,   639,   640,   641,
     209,   642,   643,   644,   645,   646,   647,   648,     0,   649,
       0,   650,   651,   652,   653,   654,     0,   656,   657,   214,
     658,   659,   216,   660,   661,   217,   662,     0,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   219,   676,     0,   677,   678,     0,   679,   221,   680,
     681,   682,   683,   684,     0,   685,   222,   223,     0,     0,
     687,   688,   224,   689,   225,     0,   690,   691,   692,   693,
     694,   695,   696,   697,     0,     0,   698,   699,   700,   701,
     702,     0,     0,   703,   704,   705,   706,   707,     0,   232,
       0,   708,   233,   709,   710,   711,   712,     0,     0,   713,
       0,     0,   714,   715,   716,   717,   718,   719,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,     0,
     720,   721
};

static const yytype_int16 yycheck[] =
{
       2,  1013,   970,  1334,    88,   247,   148,   391,  1596,   911,
     161,  1179,    73,    73,   110,  1162,    73,    73,    73,   206,
     911,  1099,  1100,  1101,  1283,  1626,   391,  1105,   226,    73,
    2083,   375,   183,  1335,  1960,    79,   906,  1351,  1157,  1212,
     144,   125,  1240,  3046,   914,  1509,  1367,   917,   147,  2022,
    1185,  2006,  3118,  1013,  1066,  2874,  1448,   199,  1361,  1363,
     156,  3258,  1184,   147,   148,  1512,  1497,  1498,  3426,  2363,
    1999,    73,   220,   157,  2938,  1542,  1507,    79,  2163,   970,
    2006,    83,   165,   783,  1169,  1663,    73,  3481,   897,  2242,
    3905,  2011,   154,  3636,  2713,  2714,  2555,  3059,  3609,  1127,
    4287,  3935,    73,  1301,   159,  1054,  2436,  1334,   110,  1423,
    1527,  3952,  4231,  1427,  3955,   199,  1343,  3662,  1432,  3664,
    1437,  2454,   125,   206,  2149,   784,  1353,  1441,   363,  3859,
    1259,   133,   228,  2959,    90,  1259,  1453,  3234,  1259,  4339,
    1031,  1455,  2115,  2116,   100,   147,   110,   907,  3490,  3005,
    1091,  3007,  1065,  1165,   156,  3011,   916,  3013,  3014,   377,
    4283,  4524,  1049,  1300,  4184,  2296,  3022,  3023,  3024,  2254,
     930,  4580,   159,  1295,  4154,   377,   205,  1491,  4563,  1191,
     136,  4568,   246,  1874,  1875,  1876,   215,  4564,  1325,  2109,
     213,  1203,   156,  1330,  2347,   151,  2549,  4190,  2596,  4576,
    3349,  5045,  4374,   205,  4567,  1165,  5220,  3455,   968,  2607,
    2628,   213,  1609,   215,   974,  1989,  2136,  1580,  1034,  2630,
    5095,  1037,  1938,  5389,  1869,  1870,   228,   987,  3376,  5103,
    3049,  1495,  1496,  3922,  1822,  1292,  3523,  4253,  4849,  1209,
    4115,  5236,  1506,  5238,  1254,  1255,  5424,  5430,  1370,  4189,
    5094,  4191,  5442,  1209,    20,    29,   161,  1057,     9,  5672,
      76,  1692,  1693,    76,   228,  3870,    76,  4714,  1325,    76,
    1529,  2045,  4287,  1330,   107,  1722,  5647,    76,   183,  1081,
      76,  1712,   133,  1085,  1086,  1087,    85,    86,  2062,    85,
      86,    70,    13,  1095,  5301,    76,    76,    83,   121,   144,
    1000,    76,    81,  4661,  4662,    76,  4664,  4665,  4666,  4667,
    4668,    76,   891,   101,   114,  1256,  1257,    70,    13,    83,
      85,    86,   383,   383,   159,    73,   383,   383,   383,    76,
     114,    79,   146,    76,   129,    76,  5343,    76,  1416,    76,
     129,    76,  3161,   427,  3163,  3494,   186,   391,   112,    70,
      85,    86,   129,   183,    75,    76,    76,    78,    79,   104,
      81,   151,   110,    94,    98,    85,    86,   184,   184,    69,
      70,   231,    70,    73,  2476,    75,    76,    75,    76,    70,
     144,    81,   426,    81,    75,    76,    70,    78,    79,   391,
      81,    75,  5350,  5351,   111,    13,   383,    81,  1596,   110,
     205,   243,   129,   129,   210,    73,  3611,   129,   156,   236,
     129,  4583,   383,   189,   248,   111,    98,  1681,  1682,  1193,
     236,  1589,  3981,   105,   426,    70,    98,    79,   146,    73,
      75,   354,   348,   105,  1462,   129,    81,  1036,  5851,   129,
     349,   236,   343,  1707,   284,   156,  1838,    28,   129,   156,
     329,  1050,    70,   238,    69,   252,  1951,   186,    73,  1159,
     280,    76,   231,   110,  2147,  2148,   436,   368,  5997,    98,
    5841,   395,   203,   394,   435,   313,   105,   184,   316,   228,
     228,   464,   313,   188,   184,  1387,  6065,  6066,   413,   188,
      76,  5674,   108,   333,   205,  1816,  1387,   476,   274,   163,
    1803,    98,   213,   418,   215,   420,   420,    83,   418,   893,
     158,   191,    21,  1383,  5509,    92,   313,   228,   478,  1389,
     406,   146,  1392,   463,   236,  2656,   521,    49,   893,  2046,
    5275,    97,   236,    70,  2486,   551,   112,  2489,  5283,   268,
     556,   146,   558,   146,    81,    67,  2063,   542,   260,   435,
     390,   156,   200,   156,   464,  1567,  5431,   236,  5565,   499,
     236,    70,   522,  1372,   179,  2696,   481,   481,   144,  2700,
      94,  5984,   407,   556,   499,   324,   281,   193,   242,   279,
     559,   505,   281,   389,  1596,    83,   556,   686,   426,  6168,
     236,   512,   189,   735,   736,   426,  1764,   236,   559,   384,
     329,   301,   686,  1801,   333,  2069,   146,  1567,  1806,  1807,
    1778,   258,   156,   236,  6143,   524,   146,   405,   146,   408,
    1742,  1649,   101,   186,  1822,   504,   333,   422,   236,   426,
     418,   408,   420,   364,   557,   404,   559,   252,   554,   216,
    1808,  1809,   558,   391,  4374,   236,  6059,  1769,   478,   476,
      80,   735,   736,    83,    73,   556,  1668,    87,    88,    89,
     476,   260,   476,  1604,  3869,    83,   177,  5850,  1609,  4399,
     504,   402,   238,  5839,    73,   237,   476,   274,   426,   203,
    2001,   408,   408,  6054,   686,  1598,   408,   189,   217,   408,
      73,   272,   522,   481,   112,    73,   556,  1276,   313,   783,
     490,   316,   509,    83,   435,   505,  2201,  5084,  1668,   554,
     515,   521,  6125,   558,   408,   383,   511,   559,   408,   559,
    4535,   505,   498,   556,   559,   446,   144,   408,   545,   545,
     464,   476,   542,   556,   500,  2052,  5183,  3556,   558,   383,
     521,   554,   558,   556,   461,   558,   556,  4290,  1975,   556,
     556,   446,   505,  6166,   505,  4775,  4736,   556,   476,  4779,
     556,   542,  4577,   445,  2078,   461,   552,  2081,   547,   548,
     559,  4764,   503,   445,   426,   556,   556,   925,  1578,  1977,
     554,   556,   559,  2100,   550,   556,  1798,  2089,   552,  1987,
    5665,   556,  5975,   889,  1806,  1807,  5974,  1599,  5988,  5157,
    1602,   900,  2403,  1605,  4679,  1607,  2033,  4823,  1610,   556,
    1822,   426,  1614,   556,  1588,   556,   445,   556,   384,   556,
     500,   556,  5780,  4763,  1066,  4765,   547,   548,   446,  5383,
     260,   428,   559,   559,  1069,   519,   556,   559,  1798,   110,
     559,   418,  2145,  2147,  2148,  2149,   106,   547,   548,   893,
     548,   476,   282,  4583,   420,   559,   547,   548,   542,  2542,
    1002,   438,   961,   547,   548,   559,   452,   453,  1212,   559,
    2825,   476,  2070,   476,  2794,  2073,  2074,    83,  6061,  1889,
     559,  1830,  2313,   559,  2351,   156,  1856,   889,   950,  5884,
    5090,   893,  3756,   954,   954,   897,  2033,   954,   954,   954,
    1856,   498,   547,   548,   906,   907,   112,  3526,  5915,  3528,
     556,   435,   914,   479,   916,   917,  1000,   556,  1002,   485,
     350,  5928,   537,  1022,   184,   889,   405,  1078,   930,  1080,
    5541,  1082,   476,   556,  3896,  4083,   476,  1088,   144,   502,
    1997,  6124,  4485,  2410,   178,  4634,   476,    98,   476,  2869,
    1549,   559,  4557,   464,  2421,    69,   236,   228,  1062,    73,
     559,  1112,  1113,  1111,   383,    94,   968,  1741,   559,  2994,
    3429,  5846,   974,  4484,   498,  5849,  1060,  2175,  5822,  3835,
    1064,  2154,    73,  1201,   383,   987,   515,  2384,  4275,  2046,
     329,  6157,    73,  2390,   556,   138,   498,  2360,  5552,  1201,
     383,  5845,    76,   177,  1006,   383,  2063,    94,   177,  2725,
    1065,  1013,  2657,   156,  2659,   104,  1018,  3836,  3837,    73,
     253,  1023,   334,  6030,   163,  1027,  1028,   236,  2292,  2293,
     264,   153,  1034,  1632,  1036,  1037,   177,  1185,  5548,     0,
    2814,   155,  3460,   236,    73,  3098,  3444,  1049,  1050,  1648,
    3461,   549,   550,   551,   552,  1057,    24,   363,  5421,  4618,
    4619,  4620,  4621,  4622,  1066,  1664,   216,   260,  1216,    73,
     177,   214,  2040,   195,   203,  1159,   184,  1161,   248,  1066,
    6094,     7,   177,  2500,    10,    11,   138,   280,  1862,  5276,
     233,    13,  4603,   207,   354,    21,    22,    23,   119,    25,
      26,  5976,  4251,   242,    30,    31,    32,  1063,   435,   337,
    3929,  5985,   280,   543,   544,   545,   203,   547,   548,   549,
     550,   551,   552,    36,  1080,    38,  1082,   163,   217,   435,
    1194,   549,   550,   551,   552,    73,  1092,    76,  3491,   178,
    1163,   889,  1186,  1291,  1167,   893,  5318,   179,    76,  2040,
    2738,  4399,  4546,   280,  1156,  1157,  1112,  1113,  1161,   329,
    5375,  1163,   214,  1165,   280,  1167,    76,   547,   548,   549,
     550,   551,   552,  2251,   216,  1080,  2497,  1082,   889,    69,
     236,   233,    99,    73,  1186,   382,   498,  3116,   422,  1191,
     304,  1193,   348,  6067,  5174,  5749,   476,  6071,  2366,   538,
    5754,  1203,    24,  5218,   260,  5225,   242,  1112,  1113,   348,
    5230,   280,   236,  5233,   442,   184,   189,  3319,  3320,   142,
     252,   372,  3324,  2544,   280,   264,    94,  2548,  5221,   463,
     464,   179,   559,   236,   255,   364,   260,   380,  2542,   260,
    3859,  5751,   189,  5630,   366,  2709,   167,  5262,   179,  6123,
     364,   177,  1254,  1255,   362,    76,   280,   260,  5092,  3361,
    3362,  5276,    94,  5078,   338,   155,  5629,   476,   100,  1365,
     409,  2418,  2419,   402,  5115,  5684,   297,   364,  5663,   430,
    5667,   313,   264,  1285,   316,   545,   138,  5664,   438,   153,
     464,   432,   383,  6167,   554,   464,   556,   557,   558,   559,
    4843,   274,   383,  5666,   252,  5682,   435,   500,   276,  3440,
    1339,  1340,   348,  6187,  1285,   402,  6190,   468,   208,   470,
     428,   252,   556,   556,   245,   102,   103,   274,   380,   383,
    3949,   195,   184,   153,   504,   203,   545,  1339,  1340,    13,
    4885,   547,   548,   549,   550,   551,   552,   469,   435,   558,
     493,   153,   241,   467,   383,   469,   464,   464,   275,   556,
    2372,  1363,  1364,  1365,   333,   313,   164,   560,   316,   464,
    1372,   203,  2494,   409,   134,   195,   266,  1379,   177,   383,
     519,  1383,   313,   422,   500,   316,   163,  1389,   240,   236,
    1392,   559,   318,   195,   426,   230,   438,  5612,   506,   338,
     556,  1365,  1404,   349,  2291,  2354,   183,  1469,   329,  2713,
     338,   519,   301,   260,   280,   280,  5539,  1419,   557,   440,
     333,   560,  2590,   346,   463,   464,  2328,  5442,   338,   213,
     184,   500,   559,   280,   542,   510,  2327,  2328,  1186,   237,
     217,   493,   418,  2384,   500,   383,   156,  2317,   556,  2390,
     376,   153,  1163,   422,   276,   428,  1167,  2344,  2371,  3150,
    2409,  1463,  1464,  1465,  2413,  5842,  2275,   288,  2417,   354,
    5670,  2420,   270,   354,   406,   248,   500,  2675,   426,  4821,
     370,   333,   464,   519,   352,  5505,   338,   285,   241,   129,
     238,   560,  5472,   195,  2641,   426,   387,   295,   422,  1741,
    2316,   237,   366,   435,   560,   537,  2474,  1509,   280,   163,
     343,  2285,   476,   554,   298,  2331,   519,   146,  2334,   184,
     561,   557,   498,   321,   560,   498,  4592,   156,   380,   183,
     329,   241,   364,  4087,  1918,   368,   560,   484,   406,   407,
     375,   349,   349,  1598,   396,    69,   366,  1549,   301,    73,
     348,   498,   473,  1918,   264,  5742,   329,   310,   418,  4656,
     486,  1645,  4116,   217,   366,  1567,  2695,   435,   348,   329,
     402,  2695,   237,   519,  2695,  1577,  1578,  2908,  1580,   468,
     307,   470,   368,  2474,   338,  2597,  1588,  5567,  5318,   537,
    1825,   301,  5572,  5573,  1596,   559,  2412,  2824,  5432,  2415,
    2416,   491,   350,   435,   121,   469,   537,   496,   556,   499,
      94,     2,   502,   189,   412,  4471,   100,  1365,   889,  4475,
    4476,   398,  4478,  1841,  1842,   556,  1844,   203,  1339,  1340,
    1632,   367,   556,  5752,   500,   500,   343,   186,  2955,  1841,
    1842,   493,  1844,   353,  1646,  1601,  1648,  1603,  4512,   469,
    1606,   428,  1608,   500,  1365,  1611,  1612,  1613,   175,   213,
     184,   368,  1664,    80,   366,   556,  1668,   469,  1624,   334,
      87,    88,    89,   179,   559,   368,   245,  1679,   559,  2453,
    2454,  2908,  1638,  4547,  1640,  3738,  2460,   464,   349,   329,
    2994,  3158,  2466,  2467,  2468,   422,   556,  3626,  5713,   238,
    1784,  1785,   500,  2477,  2478,   441,   454,  1709,  2482,  2368,
    1858,   519,   519,   560,  2912,   468,  2943,   470,   239,   203,
    2319,   121,  2920,   556,   278,  2923,  2738,  5742,   500,   506,
    4556,   504,  4065,   510,  2333,  1737,  1738,  1739,  3055,  1741,
     467,    69,   519,   496,   398,    73,   252,  2346,   556,   422,
    2977,  1753,   343,  2888,  2889,  4374,   273,  2892,   468,  1761,
     470,  3078,  3079,  3080,  3081,   542,   196,   469,   408,   496,
     556,   481,  1868,  3090,   428,   175,   206,   368,   451,   556,
    4399,  1784,  1785,   493,   329,   130,   496,   560,   248,   338,
    5909,  3816,   379,   138,   521,   435,  1798,  3822,  3115,  1801,
     354,   377,  5407,  1887,  1806,  1807,  4625,   313,  4627,   333,
     464,   350,   329,   435,   338,  2988,  2989,  2990,  3132,   186,
    1822,  2958,  5981,  5982,   186,  1869,  1870,   155,    98,   556,
     198,  5646,   200,  5848,  5377,   500,   500,    24,   213,  5673,
    3760,  1843,  1938,   952,   413,  1847,  1848,    34,  4001,   556,
    2898,   226,   506,   138,    98,   422,   231,   402,   519,   144,
    1862,    98,   107,   556,   385,   519,  1868,  1869,  1870,   329,
     228,   156,    96,   273,  1918,   519,   101,   545,  2780,   207,
     364,   126,  1926,  6070,  1887,  3805,   233,  1889,   542,  2780,
     558,   478,   556,   117,   176,    76,   417,  4227,   247,   184,
     125,   186,   556,   278,   364,   149,   464,   424,  2778,   430,
    1972,  2781,  2782,   157,   364,   559,  1918,   284,   402,  3054,
     426,  3420,   284,   298,  1926,   363,   241,  2975,   198,   329,
    1932,   176,   290,   350,   364,   522,  1938,   559,   492,   260,
     226,   185,   402,  5454,   465,   286,  1948,  1056,   135,  1951,
     213,   435,   402,  1955,  5151,   240,   301,  2105,  3931,   363,
    3561,   198,  2771,   226,  4583,   556,   333,  6126,   231,   379,
     345,   333,   402,  5988,  1938,   343,   304,    94,   198,   354,
     200,   364,  3481,   268,  6171,   435,   301,  1989,   329,   556,
    2690,   402,  4094,  4095,  4096,  4097,   240,  1999,  4100,  4101,
    4102,  4103,  4104,  4105,  4106,  4107,  4108,  4109,     5,   253,
    5844,    75,   298,  5558,   237,   278,  3433,    81,   263,  5860,
     286,   265,   354,   390,   424,   510,  3224,    24,   390,   311,
    3108,   435,   314,   307,  2036,   298,   364,    34,   310,  5644,
     389,  5044,  1151,  2045,   504,  4864,  4865,   270,   333,  6064,
     476,   275,   435,   338,   420,  6070,  5661,  4159,  4160,   155,
    2062,  2821,   285,   329,   363,   476,   311,  2069,   478,   314,
     419,   556,   295,  5270,   402,  5272,   231,   444,   406,   394,
    5083,   402,   345,  2054,   329,   406,   203,   242,  2059,   276,
     287,   354,  5450,   425,  1365,   380,  5701,   438,   187,   156,
     196,  5063,  2198,  3534,   184,   260,   556,   435,   187,  3121,
     206,   396,   522,   333,   435,   481,   404,   492,   363,   545,
    1868,  1869,  1870,   343,   390,   402,   543,   544,   545,  2131,
     547,   548,   549,   550,   551,   552,   435,  2897,   135,   467,
     220,   469,    83,  5977,   226,  2147,  2148,  2149,  5004,   231,
    5006,  5007,   352,   468,  5010,   470,  6171,   498,   435,  2130,
     307,  3121,   407,  2134,   364,  3177,  2168,   256,   184,  5033,
    1918,   228,   438,   253,   121,  5990,   478,   256,  1926,    80,
    2279,   496,    83,  2185,   429,  5696,    87,    88,    89,   412,
    1938,   519,   476,   467,   226,   500,  2198,   512,   519,  2201,
     556,  2203,   402,   144,   449,   202,  4291,   451,   493,   428,
     454,  2595,   187,  5756,  2974,   231,   298,  3177,   165,  5824,
    2222,   542,   496,  2822,  3252,  3253,  6060,  1938,  2230,   492,
    2595,   519,   498,   232,  2198,   121,  3434,  1948,    94,   519,
    2242,   186,   500,   190,   100,   464,   554,   521,   556,  3422,
     558,   556,  5610,   333,   542,   141,   411,  2259,  5652,  2446,
     207,   545,   542,   345,   211,  3524,   298,   266,   364,   155,
    2272,   559,  3221,  2275,   558,   422,  2278,   407,  1989,   276,
    2428,   256,   556,  2285,   519,   232,   231,   506,   235,  2291,
     516,   554,   364,  4346,   557,   558,   560,   364,   556,   348,
    3074,  2303,   398,   250,   353,   435,   402,   542,   394,  3910,
    3612,   511,   557,   345,  2316,  2317,  2371,  2319,  2320,  3920,
     467,  5315,   208,   268,   394,   560,   334,   335,   307,  2331,
     402,  2333,  2334,   559,  2045,   402,  3638,   556,   559,   435,
    4799,  2343,  2344,   429,  2346,  2347,  3431,   203,  2054,   496,
     215,  2062,   333,  2059,  6169,   307,   519,   338,  2360,   429,
    3134,  2363,  2445,  5968,  5358,   115,   519,   560,   435,  5912,
    2372,  4344,   226,  4346,   521,  2436,  2436,   231,   464,  2436,
    2436,  2436,  4337,  5741,   329,  2372,  3613,   137,   333,   519,
    2452,   338,   562,  5601,   464,  5603,   559,   262,  3268,  5607,
    5608,  3271,  4504,  4323,  3274,  4558,   559,   388,   364,   556,
    2412,  2507,   542,  2415,  2416,  3383,   107,    96,   348,   390,
     428,  5285,  3434,   353,  2130,  2381,   512,  2383,  2134,   559,
     560,  2387,   403,  2389,   557,   126,  2392,   560,   117,    39,
    2396,   388,   512,   422,   298,   307,   402,  6052,  5656,   350,
    2198,  2453,  2454,  3262,   500,   364,   464,  2459,  2460,  4379,
     431,  3688,   402,  2465,  2466,  2467,  2468,  4045,   407,  2471,
     422,  2473,   176,  2475,  2476,  2477,  2478,  2479,  2480,   435,
    2482,  6024,  2484,  2485,   239,   176,  2488,  2198,   467,   146,
     276,   345,  3383,   402,  4579,   435,   435,   364,   506,   156,
    2502,  2503,  2504,  2505,  2506,  2507,  3206,  5363,   238,  2511,
    3902,   519,  3816,  2515,  6119,   467,  2518,   496,  3822,  2521,
    2522,  2523,  2524,  2525,  2526,  2527,  2528,  2529,   232,  2531,
    3977,  3978,  4826,   557,   542,   402,   560,  2539,   418,  3856,
    2542,   271,   521,  2507,   496,  4888,   428,  3321,   556,  3863,
     231,  2595,  4895,  2740,   323,  2742,   364,   519,   164,  3333,
     422,   307,   266,    15,  3455,   364,  3578,  6110,   435,   521,
     450,   104,   263,   254,   198,   307,   200,   556,   347,  5398,
     542,   554,   464,   481,  2220,   558,  2646,  2738,   519,   382,
     398,  3365,    69,  2595,   402,  2597,    73,  4570,   560,   231,
     224,  2603,  3551,   402,   556,   467,  2690,   311,  2244,   342,
     314,   542,   307,  2657,  2601,  2659,  2618,   512,  3578,   521,
     311,  5687,   254,   314,   506,  2627,  2628,   435,   559,  2725,
     425,   237,  2731,   288,   496,  3409,   435,   519,   329,  4565,
     542,    33,   543,   544,   545,  2793,   547,   548,   549,   550,
     551,   552,   556,     2,   556,  2657,  4585,  2659,   310,   521,
     542,   231,   417,  6021,   270,   312,  1057,  1938,   423,    69,
     519,   521,   363,    73,   556,   430,   422,  2679,  5542,   285,
     556,   333,  4181,   481,   254,  4184,  5550,  4288,  4289,   295,
     422,   364,   542,   542,   556,    95,  2698,  2699,   307,  5318,
    2702,   325,   326,   327,   328,   481,   556,  2709,   332,  5906,
     465,  2713,  2714,   425,   338,   321,   407,  1325,  2720,   343,
     554,   467,  1330,  2725,  2726,   310,   560,   422,  2730,   402,
    1329,   310,   487,   406,    83,   467,  2738,   404,   429,    80,
    2888,  2889,    83,   468,  2892,   470,    87,    88,    89,  1348,
     496,   468,  1351,   470,  2756,   155,  2852,  2759,   449,  2507,
    2856,  2725,   435,   104,   496,   160,    69,    70,   264,  2771,
      73,   307,   467,  2775,    80,   521,  2778,  6135,    81,  2781,
    2782,   559,   344,  2879,  2935,   563,   348,  2789,  4287,   521,
     547,   548,   549,   550,   551,  2894,  2507,   561,   147,  2801,
     557,   496,   551,   556,   153,   558,   412,   556,   208,   558,
     556,  3889,  2814,   422,   557,  4136,   559,   559,   362,  2821,
    2822,   563,    69,    70,   556,  5444,   521,    70,  2830,   555,
     481,    94,   181,   559,  1848,    80,   555,   100,    83,   312,
     559,  4272,  6200,  3332,  2940,  3334,  3335,  2595,  4901,  1240,
    2852,  2853,   254,  3865,  2856,  3867,  4054,   152,   467,   483,
     260,   556,   325,   326,   327,   328,   266,   112,  1259,   557,
     494,   559,  2968,   512,   119,  2877,   554,  2879,   556,   142,
     557,  2883,   559,   557,   428,   559,   422,   496,  2890,   549,
     550,   551,  2856,  2895,  4029,  2897,  2898,   125,  2900,   144,
     519,   557,   521,   559,  2906,  3865,  3054,  3867,   425,  2657,
    1301,  2659,   521,   288,   556,  2879,   558,  4220,   562,   557,
     464,   559,    81,   557,  2926,   559,   556,  2198,  4883,   556,
    2932,   467,   557,   196,   559,  2937,  3948,   348,  2940,  4260,
     203,   282,   422,   206,  3040,   135,   136,   556,  2950,  3548,
    3549,   559,   560,   557,    80,   559,  3060,    83,    85,    86,
     496,  2963,   506,   557,  5967,   559,  2968,   559,  3859,   232,
     370,    80,  2974,  2975,    83,   519,  2940,  2725,    87,    88,
      89,   557,   557,   559,   559,   521,   112,   468,  3948,   470,
    2992,  2993,  2994,   119,   125,   104,  2998,   557,   542,   559,
     557,   512,   559,   266,  2968,   557,   557,   559,   559,   350,
     255,   510,   556,   413,  2725,   260,   152,   557,   144,   559,
     556,   102,   103,   557,   198,   559,   200,   115,  3030,  3031,
     539,  4345,   547,   548,   549,   550,   551,   557,  3040,   559,
     555,    18,    19,   284,   557,  3047,   559,  4546,   558,   557,
     224,   559,   297,   418,   419,  3057,  4315,   557,   351,   559,
      37,   351,   462,    40,   418,   419,   329,   107,  5170,  4018,
     333,   348,  3074,  4195,   348,   557,  3040,   559,   231,  3321,
     343,   557,   468,   559,   470,   211,   126,   351,   557,   352,
     559,   491,  3094,   557,   539,   559,   557,   115,   559,   499,
     284,   364,   502,  2814,  2852,   350,   549,  3706,  2856,   539,
     557,  3113,   559,   519,  3116,   521,   557,   235,   559,  3121,
     559,   560,  3206,  3365,   557,  3724,   559,   559,   557,   255,
     559,  2879,  3134,   557,   260,   559,   176,   557,   557,   402,
     559,  2852,   405,   406,   557,  2856,   559,   557,   556,   559,
     127,   325,   326,   327,   328,  4457,   418,   419,   332,   333,
     557,   557,   559,   559,   338,   418,   419,  4481,  2879,   343,
     557,   297,   435,   282,   557,  3177,   559,   557,   557,   559,
     559,   519,   159,   521,  2895,   125,  1577,  1578,   557,  1580,
     559,   557,  2940,   559,   557,   440,   559,   557,   236,   559,
     240,  4399,   543,   544,   545,  1596,   547,   548,   549,   550,
     551,   552,   557,   557,   559,   559,  3414,  3415,  3416,  1206,
    2968,  1208,   199,   263,   350,   557,   557,   559,   559,  2940,
    3232,   557,   557,   559,   559,   557,  2507,   559,  5879,  5880,
     503,   350,   556,  3485,  3340,   557,  3248,   559,  3250,   557,
    3346,   559,   557,   557,   559,   559,  3258,  2968,   280,   557,
    3262,   559,  4726,  3265,   560,   557,  3268,   559,   557,  3271,
     559,   311,  3274,   557,   314,   559,  4775,   335,  3280,   549,
    4779,  3880,   557,  3882,   559,   557,   562,   559,  3290,   329,
    6003,  6004,  3040,  3295,  4467,   540,   557,   557,   559,   559,
     276,   476,   547,   548,   549,   550,   551,   552,   557,   483,
     559,   557,   562,   559,   440,  4089,   476,  3319,  3320,  3321,
     494,   476,  3324,   363,   557,   557,   559,   559,   476,  3040,
    3332,  3333,  3334,  3335,   557,   556,   559,   686,  3340,   557,
     557,   559,   559,  3345,  3346,   557,  3348,   559,  3350,  4123,
     557,   557,   559,   559,   557,   557,   559,   559,   209,  3361,
    3362,   476,   557,  3365,   559,   107,   557,   407,   559,  5471,
     428,   557,   557,   559,   559,   557,  3340,   559,   557,   557,
     559,   559,  3346,  3385,   557,  3387,   559,  3389,   557,   429,
     559,   557,   557,   559,   559,   125,   557,  4171,   559,   557,
     557,   559,   559,   557,   276,   559,   464,  3409,   282,   449,
    1801,   557,   476,   559,   540,  1806,  1807,   557,  3420,   559,
     558,   547,   548,   549,   550,   551,   552,   557,   557,   559,
     559,  1822,  3434,   556,   543,   544,   545,   523,   547,   548,
     549,   550,   551,   552,  4642,  4044,   556,  4780,   506,  4782,
    3452,   556,  5053,   402,  2725,   260,   218,   556,   558,   218,
     348,   519,  2476,   260,   402,  3467,   348,   218,   218,   260,
    2484,  4792,   218,   348,   231,   402,   560,   218,   296,  3481,
     186,   500,   348,  4374,   542,   312,   556,   481,   342,  1880,
    1881,   512,   425,   231,   288,   557,  4817,   138,   556,   557,
    5426,   333,   560,   107,   333,   556,   523,   348,  4399,   231,
     333,   333,   115,   115,  1905,  1906,   486,   333,   155,   364,
     512,  3523,   512,   231,  3526,   383,  3528,   561,   218,   218,
     556,  3533,   218,   556,   509,   218,   376,   106,   523,   218,
     556,   556,   218,   218,   218,   559,  3548,  3549,   218,   218,
     218,   218,  3554,   231,   218,   218,   218,   218,   218,   348,
     464,   556,   107,   296,   348,   231,  3662,  3663,  3664,  3420,
     556,    76,   231,  3575,  5547,   556,  3578,    76,   556,    80,
    3582,  2852,    83,   231,   556,  2856,  1977,   556,   556,   556,
     556,   556,  3340,    76,   556,   556,  1987,   556,  3346,  3601,
     556,   556,   951,   556,  2618,   556,   556,    76,  2879,   556,
      76,   112,   556,   556,  5716,   556,   360,   556,   119,   556,
     556,   556,   556,   520,  3626,   556,   556,   556,   280,  3340,
    3481,   559,   107,   559,   167,  3346,   280,   282,   296,   107,
     559,   231,   345,   144,    73,   231,   343,   435,   549,   276,
     426,   316,   559,   183,   559,   499,   545,    13,   556,   559,
    3662,  3663,  3664,   556,  1013,  1014,   560,   134,   476,  2940,
     556,   558,   476,   422,   476,   511,   476,   422,   476,  2070,
     476,   298,  2073,  2074,  3686,   422,   476,  4636,  4637,  4638,
    4639,  4640,  4583,  4812,  3696,  4893,  3698,  2968,   476,   545,
    5014,   476,   156,   422,  3706,   218,   348,   427,  1057,   293,
     211,   476,   476,   338,   192,   476,   499,   368,   348,  5218,
      80,   343,  3724,    83,   467,   418,  5225,    87,    88,    89,
     159,  5230,   556,   253,  5233,   556,   476,   476,   156,    80,
     559,   192,    83,   364,   104,   260,    87,    88,    89,   476,
     476,   476,   500,   218,   255,   192,   178,   464,   476,   260,
     464,   476,  3858,  5262,   500,   476,   107,  1116,   192,  3040,
     125,   476,   125,   352,   476,   476,   476,  5276,   476,   318,
     476,  3923,   476,   467,  2175,   476,   387,  3789,   476,   476,
    3938,   476,   368,   368,   476,   476,   297,   114,   114,   476,
     282,  1150,   557,   559,   476,   348,   282,   561,  3904,  3811,
    5114,  1160,   282,   523,  3816,  1164,  1165,  1166,   247,   282,
    3822,  3963,   348,  4167,   282,   282,   348,   348,  3830,   282,
     282,   486,   282,   476,   107,  4803,   218,    96,   348,  3923,
     556,   218,   333,   500,   184,   218,   519,   218,   218,   350,
     348,   343,   333,   333,   333,   511,  3858,  3859,   304,   107,
     107,  3960,   231,  3865,  3924,  3867,   558,   288,   424,   106,
     476,   476,   218,   218,  3934,   474,   556,   474,  3880,  3963,
    3882,  4029,   500,   218,   500,   556,   218,   218,  3890,    13,
     337,   476,   236,   342,  3858,   515,  5949,    83,   318,   318,
     554,   554,  3904,  3963,   474,  1254,  1255,   556,   476,   556,
    1259,   245,  4803,   559,  3662,  3663,  3664,   556,   556,   559,
     556,   227,   282,  4165,   236,   559,  3928,   478,   559,   557,
    4529,  4530,   545,   253,   253,   278,   559,   286,  4712,   440,
    3904,   282,  4184,  5442,   438,   349,  3948,  3949,   377,   559,
    5551,  3662,  3663,  3664,   383,   107,  5034,   557,   500,   557,
      33,     9,   357,  3965,   125,   557,   422,   556,   128,  2360,
     338,   500,  2363,   286,   338,  4173,  4174,  4175,  4176,   286,
     476,   476,   312,   476,   556,   512,   425,   231,   288,   348,
     350,   481,   115,   296,   348,  6097,   338,   333,   296,  4001,
    6102,   444,   162,   296,   418,   476,  5505,   467,   192,   350,
    5598,   348,   559,   402,   254,   348,   432,   476,   435,   348,
    4022,   348,  4971,  4972,   390,  4974,   354,   107,    80,   557,
     282,    83,   476,  4129,   288,    87,    88,    89,   500,   540,
     218,   545,  4044,   231,   343,  4047,   547,   548,   549,   550,
     551,   552,   104,   107,   465,   500,   233,   512,   343,   556,
     386,   218,   222,   387,   218,  4067,   217,   432,  4070,  3340,
     556,   218,   343,   500,  4076,  3346,   333,   519,   107,   348,
     333,   348,  4084,   288,  4086,   251,   550,  4089,  5256,   251,
     231,  4093,  4094,  4095,  4096,  4097,   107,   257,  4100,  4101,
    4102,  4103,  4104,  4105,  4106,  4107,  4108,  4109,   539,   557,
    3858,  4113,  4114,   232,   554,   316,  4118,   288,   432,   557,
    5587,  4123,  5589,   557,   539,  4127,   231,  4129,   348,  4131,
     333,   557,   557,   293,   260,   260,    80,  4139,   260,    83,
    4142,    95,  4144,    87,    88,    89,   260,  3858,   260,   559,
     559,   523,  4154,  5652,  4156,   243,  3904,  4159,  4160,   559,
     556,   476,  4164,  4165,   236,  4129,  4227,  4227,   519,  4171,
    4227,  4227,  4227,   333,   348,   315,   559,   125,   464,  4181,
     481,   288,  4184,   543,   544,   545,   342,   547,   548,   549,
     550,   551,   552,  3904,  4196,  5796,  5797,   236,   559,   557,
    5788,   512,   543,   544,   545,   365,   547,   548,   549,   550,
     551,   552,   360,   236,  5713,   332,   369,   556,  1567,   557,
     476,   359,   498,   310,   306,   506,   516,   516,  1577,  1578,
     282,  1580,   557,  4617,   557,   557,  2627,  2628,   348,   557,
     545,  4243,   125,  5742,   348,     2,   406,  1596,   408,  5396,
     410,   539,  4617,   557,   556,  4406,  5424,  4259,   541,   419,
     557,   557,   557,   557,   556,   556,  4417,   427,   545,   556,
     351,   348,  4368,  4275,   556,   435,   556,  4373,   264,  4375,
     559,  4880,   560,   557,  2675,  4287,   556,   447,   218,    80,
     556,   559,    83,  1642,  5068,   557,   456,   476,   350,   523,
     460,   476,  4398,   476,  2695,  3319,  3320,  2698,  2699,  5277,
    3324,   272,   338,   221,   333,   218,  4318,  5490,   476,  1668,
     352,   112,  4418,   218,   435,   427,   218,   427,   119,   427,
    4181,   296,   264,  4184,   221,   348,   545,   476,   282,   221,
    5941,   500,   559,   298,   221,   370,   370,  3361,  3362,  5848,
     451,   497,   308,   144,   514,   476,   476,   308,   476,   308,
     476,   476,  5330,  4962,   422,   422,  4368,   476,   476,   422,
     476,  4373,  4374,  4375,   192,   422,   333,   476,   218,   476,
     476,  4129,   476,   476,  5688,   435,  5277,   114,   557,   557,
     476,  3662,  3663,  3664,  1743,   248,  4398,  4399,   282,   231,
    5598,   282,   557,  1752,   161,   555,   350,   282,   282,  4373,
     486,  4375,   557,   557,   115,   404,  4418,  1766,  4129,   177,
     211,   231,    80,   559,   557,    83,   183,  5318,  5330,    87,
      88,    89,  4434,   107,  4398,  4437,  4287,   218,   476,  5330,
     218,   231,   545,   248,   500,   500,   559,   218,   231,  1798,
    6038,   422,  1801,  1802,  4418,   422,   422,  1806,  1807,  5329,
     422,   556,  5061,   422,   255,   557,   556,   556,   559,   260,
     555,   351,   432,  1822,   216,   216,  5807,   209,   282,   282,
     282,   282,   282,   282,   282,   282,   554,   236,    83,  5988,
     559,   543,   544,   545,   360,   547,   548,   549,   550,   551,
     552,   231,  4504,  5373,   511,   236,   297,   332,   557,   542,
     516,   557,   557,   557,  4574,   556,   559,   557,   236,   556,
     245,  2912,   557,   559,   409,   954,   557,  4529,  4530,  2920,
     545,  4533,  2923,   473,   556,   505,   154,  4539,   559,   486,
    1889,   545,   231,   107,  4546,   288,   272,   500,   500,  5498,
     476,   125,   467,   218,   556,   451,  4558,   240,   486,   350,
    5509,   221,   427,   476,   476,  6064,   476,   422,   422,   476,
     476,  6070,  5584,  4617,   557,  4635,   557,   557,   402,   556,
    4582,  4583,   519,  4585,  4586,  4587,  5598,  3858,   125,   467,
     506,   231,    94,   348,   144,   218,   177,   486,   100,   543,
     544,   545,   282,   547,   548,   549,   550,   551,   552,   282,
     282,   557,   282,   556,   267,  4617,   476,   286,   556,   523,
    4368,   397,   557,   559,   282,  4373,   348,  4375,   559,   107,
     368,   346,   348,  3904,   559,   556,  1065,  1066,   486,   559,
     142,   476,  5591,  4645,    80,   556,   432,   177,   557,   440,
    4398,   242,   236,   555,  4841,   282,   557,  4368,   557,   236,
     557,   125,  4373,   556,  4375,   517,   517,   557,  4670,   360,
    4418,   559,  6171,   285,   358,  5753,   285,   466,   557,   355,
    4682,   557,   125,   556,   556,   556,   249,  4398,   557,   473,
     486,   343,   350,   107,   196,  4546,   545,   476,   236,   519,
     144,   203,  5476,   261,   206,   266,   254,  4418,   254,   338,
    4712,   545,   126,  4715,   338,   125,   467,   559,   559,   138,
    5319,  4723,  4724,   476,  4726,   218,   476,   221,  4730,  4731,
     232,   476,   476,  4735,  4736,   557,  4887,   282,  2087,  4741,
     556,  5515,  4744,  4745,   191,  2094,  4897,  4749,   238,   540,
     236,   184,   107,  4755,  4814,  4815,   547,   548,   549,   550,
     551,   552,   176,   177,   266,  4767,   500,   343,   260,   556,
     184,   432,  1201,  4775,   107,  5724,  5788,  4779,   333,   500,
     233,    80,  5750,   231,    83,   432,   217,   343,    83,  4885,
     519,   125,   150,   107,   236,   519,   467,   348,   269,   231,
     556,   280,   351,   557,   556,   505,  5974,   236,  5582,  5583,
    4812,   448,   285,   112,   368,   518,   556,   156,   557,   556,
     119,   557,   557,   556,  4826,   199,   240,   329,   556,   348,
     396,   333,   476,  3224,   557,   107,   556,   218,   218,   556,
     476,   343,  4844,   556,   556,   144,   556,   556,   556,   263,
     352,   107,   231,   338,   309,   264,   218,   556,  4129,  5750,
    4862,   556,   364,   557,   432,   177,   161,   204,   107,  4617,
     515,   557,   352,   486,   446,   446,  2225,   545,  4880,   557,
    2229,   125,   107,  4885,   147,   543,   544,   545,   183,   547,
     548,   549,   550,   551,   552,   559,   253,   311,   505,   556,
     314,  4903,   556,   405,   406,   556,   556,   556,   467,   231,
     500,   329,   211,   556,   467,   329,   557,    76,  4920,   333,
    5932,   348,   225,  4925,  4775,   467,   523,   217,  4779,   138,
    4932,   556,   419,   435,   556,   419,  5710,   138,   351,   199,
     519,   519,   504,    80,   559,   505,  4948,   107,   556,   363,
     556,   236,   435,  5727,   467,   393,   255,  5731,   204,  5733,
    4962,   260,   338,   348,    80,   266,   348,    83,   556,   432,
     556,    87,    88,    89,   107,   107,   351,   261,   351,   238,
     238,   516,   557,   125,   418,   476,   559,   556,   104,   455,
     557,  4993,   189,   407,   498,    76,   112,   432,   297,   214,
     557,   503,   418,   119,   556,   355,   403,    93,   104,   556,
     338,  2360,   556,   556,  2363,   429,   476,   556,   559,   559,
    5022,   217,   236,   418,   356,   147,  6038,   556,   144,   446,
     519,   446,   238,   238,   383,   449,  5038,   451,   519,  2133,
     454,  3058,  1297,  3434,  1807,  3434,  2943,  2864,  3638,  5919,
    4373,   350,  4348,  5932,  2969,  3850,  1340,  5371,  3028,  5061,
    5786,  6038,  4527,  5426,  1339,  5024,  5068,  5395,  3459,  3460,
    3211,  5911,  3555,  5276,  6027,  5816,  5815,  5952,  6064,  3559,
    4094,  4095,  4096,  4097,  4575,  4560,  4100,  4101,  4102,  4103,
    4104,  4105,  4106,  4107,  4108,  4109,  5760,  4368,  4518,  3043,
    3043,  4368,  4373,  3663,  4375,  1335,  3900,  4543,  5062,  5402,
    3037,  3912,  5114,  4127,  5116,  5411,  2465,  6040,  6204,  6186,
    5388,  3858,  4582,  5965,  5994,  5995,  5332,  4398,  2211,  5570,
    5769,  5335,   183,  1633,  5538,  4645,  6132,  4885,  2257,   255,
    2714,   440,   556,  4585,   260,  4159,  4160,  4418,  3533,  5151,
    2272,  2255,  5688,  1014,  2439,  2327,  1047,  2439,  3792,  2440,
    4398,  2968,  3904,  4418,  5993,  6174,   282,   283,  5170,  1598,
    1180,  4608,  5174,  1955,  4885,  4610,  1203,  2608,  2372,  2597,
    5258,   297,  4816,  5905,  4257,  1591,  2644,  3194,  3467,  4199,
    1778,  3452,  2618,  5897,  1829,  5735,  4797,  5199,  5200,  2643,
    1850,  5203,  4781,  4184,  4764,  5506,  4181,  5713,  5712,  4258,
    4181,  6180,  6011,  5887,  6100,  5474,  5218,  4131,  1851,  5244,
     336,  1853,  5900,  5225,  2573,  5901,  2536,  3388,  5230,  1858,
    3291,  5233,  5234,  2998,   350,  3386,   686,   353,  5240,  5241,
    2539,   540,  3960,  3122,  1473,  2679,  1675,  5871,   547,   548,
     549,   550,   551,   552,  2266,  1870,   392,  1864,  1645,  1277,
    5262,  2654,  5264,  1257,  1059,  1257,  1695,  2695,  5270,  3428,
    5272,  2687,  5368,  5515,  5276,  4264,  2688,  5419,  4798,  4265,
    4224,  1868,   425,  3207,  2699,  2401,     2,  5256,    -1,    -1,
      -1,    -1,  1781,  5441,    -1,    -1,    -1,  1726,  1091,  5255,
    1057,    -1,    -1,    -1,    -1,  1577,    80,    -1,    -1,    83,
      -1,    -1,  1741,    87,    88,    89,  5318,  5319,    -1,    -1,
      -1,  1078,    -1,  1080,   440,  1082,    -1,  5329,    -1,    -1,
    2679,  1088,  1089,  1090,    -1,  5419,  6206,  6207,   112,  6113,
    5400,    -1,    -1,    -1,    -1,   119,  2695,    -1,    -1,  2698,
    2699,    -1,    -1,    -1,    -1,  1112,  1113,    -1,    -1,    -1,
    5420,    -1,    -1,    -1,    -1,  1514,  5368,  5218,    -1,    -1,
     144,  5373,    -1,    -1,  5225,    -1,    -1,    -1,  5438,  5230,
      -1,    -1,  5233,    -1,    -1,    -1,    -1,    -1,  1537,  2738,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1547,    -1,
      -1,    -1,  1551,    -1,  5368,    -1,  1555,    -1,  1557,    -1,
      -1,  5262,  1841,  1842,  1563,  1844,    -1,    -1,    -1,    -1,
    1569,    -1,    -1,  1572,   540,  5276,    -1,   543,   544,   545,
      -1,   547,   548,   549,   550,   551,   552,    -1,    -1,    -1,
    5442,   557,  5444,   559,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2808,
      -1,    -1,  5558,    -1,    -1,    -1,    -1,    -1,  3859,  5471,
    5472,    -1,  5474,    -1,  5476,    -1,    -1,    -1,    -1,    -1,
      -1,   255,    -1,  1240,    -1,    -1,   260,    -1,    -1,    -1,
    4504,    -1,    -1,  5495,    -1,    -1,    -1,    -1,    -1,  5501,
      -1,    -1,  1259,  5505,    -1,    -1,    -1,    -1,    -1,  5511,
      -1,    -1,    -1,  5515,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2885,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1301,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2902,    -1,    -1,  5558,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5567,    -1,    -1,    -1,    -1,
    5572,  5573,    -1,    -1,    -1,  5577,   350,    -1,    -1,    -1,
    5582,  5583,  5584,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      83,  5442,    -1,    -1,    -1,    -1,  5598,    -1,    -1,    -1,
      -1,    -1,  5662,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4885,    -1,    -1,  2966,  5620,   112,
    5368,    -1,    -1,    -1,    -1,  5627,   119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5652,   144,    -1,  3002,  5505,    -1,  3005,  5368,  3007,    -1,
      -1,    -1,  3011,  4054,  3013,  3014,   440,    -1,    -1,    -1,
      -1,    -1,    -1,  3022,  3023,  3024,    -1,    -1,    -1,  5739,
      -1,    -1,    -1,    -1,    -1,    -1,  5688,  5689,    -1,    -1,
    5786,    -1,    -1,    -1,    -1,    -1,    -1,  5699,    -1,    -1,
      -1,  4715,    -1,    -1,    -1,    -1,    -1,    -1,  5710,    -1,
      -1,  5713,    -1,    -1,  5716,    -1,    -1,    -1,   211,    -1,
      -1,    -1,    -1,    -1,    -1,  5727,    -1,    -1,  3077,  5731,
      -1,  5733,    -1,  5735,    -1,    -1,    -1,    -1,    -1,    -1,
    5742,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4767,    -1,    -1,    -1,    -1,    -1,  5761,
    3109,    -1,   255,    -1,    -1,    -1,   540,   260,    -1,   543,
     544,   545,  3121,   547,   548,   549,   550,   551,   552,    -1,
      -1,    -1,    -1,  1078,  5786,  1080,  5788,  1082,    -1,    -1,
      -1,    -1,  5888,  1088,    -1,    -1,    -1,    -1,    -1,  3148,
      -1,  5652,    -1,   133,   297,    -1,    -1,    -1,    -1,    -1,
    5558,    -1,    -1,    -1,    -1,    -1,    -1,  1112,  1113,    -1,
    1577,  1578,  5786,  1580,    -1,    -1,    -1,    -1,  3177,    -1,
      -1,  6073,    -1,    -1,    -1,    -1,  5838,    -1,    -1,  1596,
      -1,    -1,    -1,    -1,    -1,    -1,  5848,  5558,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,    -1,    -1,
      -1,    -1,  5713,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5878,  5879,  5880,    -1,
      -1,    -1,    -1,    -1,    -1,  5887,  5888,    -1,    -1,  5891,
      -1,  5742,    -1,    -1,    -1,  5897,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5906,    -1,  5966,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5919,    -1,    -1,
      -1,    -1,    -1,    -1,  5888,    -1,    -1,    -1,    -1,    -1,
    5932,    -1,  5993,  5993,    -1,    -1,  5993,  5993,  5993,    -1,
      -1,    -1,  2371,    -1,    -1,  1240,    -1,   440,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    83,  1254,
    1255,    -1,    -1,    -1,  1259,    -1,    -1,    -1,    -1,    -1,
    5972,    -1,    -1,    -1,    -1,    -1,  5978,    -1,    -1,    -1,
      -1,    -1,    -1,  4374,    -1,    -1,  5988,   112,    -1,    -1,
      -1,    -1,  5994,  5995,   119,  5997,    -1,  5848,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6007,  1301,  2436,  4399,    -1,
      -1,  6013,  6073,  6073,    -1,    -1,  6073,  6073,  6073,   144,
      -1,    -1,    -1,    -1,    -1,    -1,  6122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6038,    -1,  5786,    -1,
      -1,    -1,    -1,    -1,  1801,    -1,    -1,   540,    -1,  1806,
    1807,    -1,    -1,    -1,   547,   548,   549,   550,   551,   552,
      -1,    -1,  6064,    -1,    -1,  1822,    -1,    -1,  6070,    -1,
      -1,    -1,    -1,    -1,    -1,  5786,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2512,    -1,  3434,   211,    -1,    -1,    -1,
    6186,    -1,    -1,    -1,    -1,  6097,    -1,  5368,  6100,    -1,
    6102,  4492,  4493,    -1,    -1,    -1,  6108,    -1,  6204,    -1,
      -1,  6113,    -1,  6174,  6174,    -1,    -1,  6174,  6174,  6174,
    6122,  1878,    -1,  1880,  1881,    -1,    -1,    -1,    -1,    -1,
     255,    -1,    -1,    -1,    -1,   260,    -1,  5988,    -1,    -1,
    5888,  6143,  1899,    -1,    -1,    -1,    -1,    -1,  1905,  1906,
      -1,  6153,    -1,    -1,    -1,    -1,  5170,    -1,  6122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6171,
      -1,    -1,   297,  2322,    -1,    -1,    -1,  5888,    -1,    -1,
      -1,  2330,  6184,    -1,  6186,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4583,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2350,  6204,    -1,  6206,  6207,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6064,    -1,    -1,    -1,  2646,    -1,  6070,
    1977,    -1,  6186,    -1,    -1,   350,    -1,    -1,    -1,  3578,
    1987,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6204,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      -1,  4642,    -1,    -1,    79,    69,    -1,    -1,    83,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    83,
      -1,    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,    -1,  5558,    -1,    -1,
     104,    -1,    -1,   107,    -1,    -1,    -1,    -1,   112,    -1,
      -1,  1596,    -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2070,    -1,   440,  2073,  2074,    -1,  3668,
    6171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     144,   156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    83,    -1,
      -1,    -1,    87,    88,    89,    -1,    -1,    -1,    80,    -1,
      -1,    83,    -1,  3722,  6122,    87,    88,    89,    -1,   104,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,
      -1,    -1,   104,    -1,   119,    -1,    -1,    -1,    -1,    -1,
     112,    -1,    -1,   228,    -1,    -1,    -1,   119,  4799,    -1,
      -1,  6122,    -1,    -1,    -1,   540,    -1,    -1,  2175,   144,
      -1,    -1,   547,   548,   549,   550,   551,   552,    -1,    -1,
      -1,    -1,   144,    -1,    -1,  4826,    -1,    -1,  6186,    -1,
      80,   255,  3791,    83,    -1,  2594,   260,    87,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,  6204,  5471,    -1,    83,
      -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,   282,   283,
      -1,    -1,   112,    -1,    -1,  6186,    -1,    -1,    -1,   119,
      -1,  5495,    -1,   297,    -1,    -1,  3835,    -1,    -1,    -1,
      -1,    -1,    -1,  6204,    -1,    -1,    -1,    -1,    -1,    -1,
    3849,  3850,  4893,    -1,   144,    -1,  1801,  2264,    -1,    -1,
    3859,  1806,  1807,    -1,    -1,  5786,  3865,    -1,  3867,    -1,
      -1,    -1,   336,    -1,    -1,    -1,    -1,  1822,    -1,    -1,
     255,    -1,  2289,    -1,    -1,   260,   350,    -1,    -1,   353,
      -1,    -1,  2299,   255,  2301,    -1,    -1,    -1,   260,    -1,
    2307,    -1,    -1,    -1,  2311,    -1,    -1,   282,   283,    97,
      -1,    -1,    -1,    -1,  3913,    -1,   391,   897,    -1,    -1,
     282,   283,   297,    -1,    -1,    -1,   906,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   914,   297,    -1,   917,    -1,    -1,
      -1,    -1,    -1,    -1,  1889,    -1,    -1,    -1,  3947,  3948,
      -1,   426,    -1,  2360,    -1,    -1,  2363,    -1,   146,    -1,
      -1,   336,    -1,    -1,    -1,   255,    -1,  5888,    -1,    -1,
     260,    -1,    -1,    -1,   336,   350,   440,    -1,   353,    -1,
      -1,    -1,  3981,    -1,    -1,    -1,    -1,    -1,   350,    -1,
     178,   353,   282,   283,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,
      -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   212,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1977,    -1,    -1,    -1,    -1,    -1,  1018,    -1,
      -1,    -1,  1987,    -1,    -1,   233,   336,  1027,    -1,    -1,
     238,    -1,  5716,    -1,  1034,  2462,  2463,  1037,    -1,    -1,
     350,    -1,  2469,  2470,    -1,   440,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   540,    -1,   440,   543,
     544,   545,    -1,   547,   548,   549,   550,   551,   552,    -1,
      -1,    -1,  2499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   310,    -1,    -1,  2070,    -1,    -1,  2073,  2074,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4138,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2555,    -1,
     440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   540,    -1,    -1,   543,   544,
     545,    -1,   547,   548,   549,   550,   551,   552,   540,    -1,
      -1,   543,   544,   545,   559,   547,   548,   549,   550,   551,
     552,    -1,    -1,    -1,    -1,   383,   384,   559,    -1,   387,
      -1,  6122,    -1,    -1,    -1,  5246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2627,  2628,    -1,  5887,    -1,   413,    -1,    -1,   416,    -1,
    2175,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,
      -1,   429,  3321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     540,    -1,    -1,   543,   544,   545,    -1,   547,   548,   549,
     550,   551,   552,    -1,    92,  6186,    -1,    -1,  2675,    97,
     458,    -1,    -1,    -1,    -1,    -1,   464,  5318,    -1,   467,
      -1,    -1,    -1,  6204,    -1,    -1,  3365,    -1,  2695,    -1,
      -1,  2698,  2699,    -1,    -1,    -1,    -1,    -1,   486,    -1,
      -1,    -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,  3388,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,
      -1,    -1,    -1,    -1,   512,  3404,    -1,    -1,    -1,    -1,
    3129,  2738,   160,    -1,    -1,    -1,    -1,    -1,  3137,    -1,
      -1,  3420,    -1,  6007,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3154,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3164,    -1,    -1,  3167,    -1,
    3169,  3170,    -1,   201,  3173,  4374,    -1,    -1,    -1,    -1,
    3179,    -1,  3181,    -1,   212,  3184,    -1,    -1,    -1,    -1,
      -1,    -1,  1372,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4399,    -1,  3481,  1383,    -1,   233,  3485,    -1,  4407,  1389,
     238,  4410,  1392,  4412,   889,    -1,    -1,    -1,   893,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2833,    -1,    -1,    -1,
      -1,   906,   907,  6097,    -1,    -1,    -1,    -1,  6102,   914,
      -1,   916,   917,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   930,  4455,    -1,    -1,    -1,
      -1,  3260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4471,    -1,    -1,    -1,  4475,  4476,    -1,  4478,
      -1,    -1,   310,  1463,  1464,  1465,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   968,    -1,    -1,    -1,    -1,    -1,   974,
      -1,    -1,    -1,    -1,    -1,  2912,    -1,    -1,    -1,    -1,
      -1,    -1,   987,  2920,    -1,    -1,  2923,    -1,    -1,    -1,
      -1,    -1,   350,    -1,    -1,    -1,    -1,    -1,  2935,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1013,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1027,  1028,    -1,   383,   384,  5598,    -1,  1034,
      -1,  1036,  1037,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,  1050,    83,    -1,    -1,  4578,
      87,    88,    89,    -1,  4583,    -1,    -1,    -1,   416,    -1,
      -1,  1066,    -1,    -1,   422,    -1,    -1,   104,    -1,    -1,
      -1,   429,    -1,    -1,   432,   112,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,    -1,  4618,
    4619,  4620,  4621,  4622,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   907,    -1,    -1,   464,   144,    -1,    -1,
      -1,    -1,   916,   471,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   479,    -1,    -1,    -1,    -1,   930,    -1,   486,    -1,
      -1,  4660,  4661,  4662,    -1,  4664,  4665,  4666,  4667,  4668,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   512,    -1,    -1,    -1,    -1,    -1,
    1165,    -1,    -1,    -1,   968,    -1,    -1,    -1,    -1,    -1,
     974,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1186,    -1,   987,    -1,    -1,  1191,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1203,    -1,
    2675,    -1,    -1,    -1,  2679,    -1,    -1,    -1,    -1,    -1,
    3147,  3148,    -1,    -1,    -1,    -1,    -1,    -1,   255,    -1,
    2695,    -1,    -1,   260,    -1,    -1,    -1,    -1,    -1,    80,
     107,    -1,    83,    -1,    -1,  3564,    87,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,   282,   283,    -1,    -1,  1254,
    1255,   128,    -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,
     297,   112,    -1,  2738,    -1,    -1,    -1,  4796,   119,    80,
    4799,  4800,    83,    -1,    -1,    -1,    87,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,   162,    -1,  3224,    -1,    -1,
      -1,    -1,    -1,   144,    -1,    -1,    -1,  4826,    -1,   336,
      -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,    -1,    -1,   350,    -1,  3924,   353,    -1,  3647,    -1,
    3649,    -1,    -1,    -1,    -1,  3934,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3963,    -1,    -1,    -1,    -1,    -1,
    1365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1383,    -1,
     257,    -1,    -1,    -1,  1389,    -1,    -1,  1392,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   440,   255,    -1,    -1,    -1,    -1,   260,
      -1,   288,    -1,    -1,    -1,    -1,   293,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   282,   283,    -1,    -1,    -1,    -1,  2912,    -1,    -1,
      -1,    -1,    -1,    -1,   255,  2920,   297,    -1,  2923,   260,
    1254,  1255,    -1,    -1,    -1,    -1,   333,    -1,    -1,  3788,
    2935,    -1,  4991,  4992,    -1,  3794,    -1,    -1,    -1,    -1,
      -1,   282,   283,    -1,    -1,  5004,    -1,  5006,  5007,    -1,
      -1,  5010,    -1,    -1,    -1,   336,   297,    -1,   365,    -1,
      -1,    -1,  3429,    -1,    -1,  3432,    -1,  3434,    -1,   350,
      -1,    -1,   353,   540,    -1,    -1,   543,   544,   545,    -1,
     547,   548,   549,   550,   551,   552,    -1,    -1,    -1,    -1,
     557,    -1,  3459,  3460,    -1,   336,    -1,   107,    -1,   406,
      -1,    -1,    -1,   410,    -1,    -1,    -1,    -1,    -1,   350,
      -1,    -1,   419,    -1,  1549,  5074,    -1,    -1,   128,    -1,
     427,  6122,    -1,    -1,   128,    -1,  4165,    -1,   435,    -1,
      -1,    -1,  1567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     447,    -1,  4181,    -1,    -1,  4184,    -1,    -1,    -1,   456,
      -1,    -1,   162,   460,  5113,    -1,    -1,    -1,   162,   440,
      -1,  1596,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6186,    -1,    -1,  4227,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1632,  5157,   440,
      -1,    -1,    -1,  6204,    -1,    -1,    -1,   514,    -1,    -1,
      -1,   518,   222,  1648,    -1,    -1,    -1,    -1,   222,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1664,
    3989,    -1,  3991,  1668,  3993,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4002,    -1,    -1,    -1,   257,    -1,    -1,
      -1,    -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,   540,
      -1,    -1,   543,   544,   545,    -1,   547,   548,   549,   550,
     551,   552,    -1,    -1,    -1,    -1,   557,    -1,   288,    -1,
      -1,    -1,    -1,   293,    -1,    -1,    -1,  4046,    -1,   293,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   540,
      -1,    -1,   543,   544,   545,    -1,   547,   548,   549,   550,
     551,   552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3224,
      -1,    -1,    -1,   333,    -1,   329,    -1,    -1,    -1,   333,
      -1,    -1,  2272,    -1,    -1,  2275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   365,    -1,    -1,    -1,  5318,
     364,   365,    -1,  1798,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1806,  1807,    -1,    -1,    -1,  2316,  2317,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1822,    -1,    -1,
      -1,  2331,    -1,    -1,  2334,    -1,   406,    -1,   402,    -1,
     410,    -1,   406,    -1,  5363,    -1,   410,    -1,    -1,   419,
      -1,    -1,    -1,  5372,    -1,   419,    -1,   427,    -1,    -1,
      -1,    -1,    -1,   427,    -1,   435,    -1,    -1,    -1,    -1,
      -1,   435,    -1,  1868,  1869,  1870,    -1,   447,    -1,    -1,
      -1,    -1,    -1,   447,    -1,    -1,   456,    -1,    -1,    -1,
     460,    -1,   456,    73,  1889,    -1,   460,    80,    -1,    79,
      83,    -1,    -1,    83,    87,    88,    89,    -1,    -1,   479,
      -1,    -1,  2412,    -1,    -1,  2415,  2416,    -1,    -1,    -1,
      -1,   104,    -1,  1918,    -1,    -1,    -1,    -1,    -1,   112,
     110,  1926,  3859,    -1,    -1,    -1,   119,    -1,    -1,    -1,
      -1,    -1,    -1,  1938,   514,    -1,    -1,  4546,   518,    -1,
     514,     5,    -1,    -1,    -1,    -1,  3883,    -1,    -1,    -1,
      -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3434,
      24,    -1,    -1,    -1,    -1,  4574,   156,    -1,    -1,    -1,
      34,    35,    -1,    -1,    -1,    39,    -1,    41,    42,    -1,
    1023,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,  1049,    71,    -1,    73,
      -1,    75,    76,    -1,    -1,   205,    -1,    81,    -1,    -1,
      -1,    -1,    -1,   213,    -1,   215,  4635,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3974,   228,    -1,
      -1,    -1,    -1,    80,  3981,    -1,    83,    -1,    -1,    -1,
      87,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   255,    -1,    -1,    -1,    -1,   260,    -1,  5598,
      -1,   135,    -1,  5602,    -1,   112,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,  1889,    -1,    -1,    -1,   282,
     283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   297,    -1,    -1,   144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4054,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2131,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   336,    -1,    -1,   210,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,    -1,    -1,
     353,    -1,    -1,    -1,    -1,   229,  4775,    -1,    -1,    -1,
    4779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,
      -1,    -1,    -1,  2198,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   391,    -1,    -1,    -1,  4814,  4815,    -1,    -1,    -1,
      -1,    -1,   276,    -1,    -1,    -1,    -1,  2222,   255,    -1,
      -1,    -1,    -1,   260,    -1,  2230,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,  2242,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   282,   283,   440,    -1,   313,
      -1,    -1,   316,    -1,    -1,    -1,    -1,    -1,    -1,  5788,
     297,  2771,    -1,  5792,    -1,  5794,    -1,    -1,  2778,  5798,
    5799,  2781,  2782,    -1,   338,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    -1,
      -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,   336,
    4629,    -1,    -1,    -1,  4633,    -1,   113,    -1,    -1,    -1,
      -1,  2316,  2317,   350,  2319,  2320,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4261,    -1,  2331,  2131,  2333,  2334,
      -1,    -1,    -1,    -1,    -1,   142,  1379,    -1,    -1,    -1,
      -1,  2346,  2347,    -1,    -1,    -1,    -1,   540,    -1,    -1,
     543,   544,   545,    -1,   547,   548,   549,   550,   551,   552,
      -1,  1404,   426,    -1,   557,    -1,    -1,  2372,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3859,    -1,    -1,   194,    -1,   196,
      -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,    -1,   206,
      -1,    -1,    -1,   440,    -1,    -1,    -1,  2412,    -1,    -1,
    2415,  2416,   476,    -1,    -1,    -1,    -1,    -1,  2222,    -1,
      -1,    -1,    -1,    -1,    -1,   232,  2230,    -1,   492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4374,  2242,    -1,
      -1,    -1,    -1,   507,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,
      -1,    -1,  4399,    -1,    -1,    -1,    -1,    -1,    -1,  4406,
      -1,    -1,    -1,   537,    -1,    -1,    -1,    -1,    -1,    -1,
    4417,   545,    -1,   547,   548,   549,   550,   551,    -1,    -1,
     554,   555,   556,   557,    -1,   559,   560,   561,   562,   563,
      -1,    -1,  2507,   540,    -1,    -1,   543,   544,   545,  6038,
     547,   548,   549,   550,   551,   552,  2320,    -1,    -1,    -1,
      -1,    -1,   329,    -1,    -1,    -1,   333,    -1,    -1,    -1,
      -1,  4860,    94,    -1,    -1,    -1,   343,    -1,   100,    -1,
      -1,    -1,    -1,  2347,    -1,   352,    -1,    -1,    -1,    -1,
      -1,   113,    -1,    -1,    -1,  4492,  4493,   364,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4904,  4905,    -1,    -1,  4054,
     142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2595,    -1,  2597,  6122,    -1,   402,    -1,    -1,   405,   406,
      -1,    -1,    -1,  1646,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5225,    -1,    -1,    -1,
      -1,  5230,    -1,    -1,  5233,    -1,    -1,    -1,   435,    -1,
      -1,    -1,   194,    -1,   196,    -1,    -1,    -1,    -1,    -1,
      -1,   203,    -1,    -1,   206,    -1,  4583,    -1,    -1,    -1,
      -1,    -1,  2657,    -1,  2659,    -1,    -1,  6186,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4994,  4995,    -1,    -1,    -1,
     232,    -1,    -1,    -1,  2679,  6204,    -1,    -1,    -1,    -1,
      -1,  4618,  4619,  4620,  4621,  4622,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   503,  2702,    -1,   889,
      -1,    -1,    -1,   893,   266,  4642,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2720,    -1,   907,    -1,    -1,
    2725,  2726,    -1,    -1,    -1,  2730,   916,    -1,    -1,    -1,
      -1,    -1,    -1,  2738,    -1,    -1,    -1,    -1,    -1,    -1,
     930,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2756,  3262,    -1,    -1,    -1,    -1,    -1,  3268,    -1,
      -1,  3271,    -1,    -1,  3274,    -1,    -1,   329,    -1,    -1,
      -1,   333,    -1,  2778,    -1,    -1,  2781,  2782,   968,    -1,
      -1,   343,    -1,    -1,   974,    -1,    -1,    -1,    -1,    -1,
     352,  5400,    -1,    -1,  5123,    -1,  2801,   987,    -1,    -1,
      -1,    -1,   364,    -1,    -1,  5134,  5135,    -1,    -1,    -1,
      -1,  5420,    -1,    -1,    -1,    -1,  2821,  2822,    -1,    -1,
      -1,  5150,    -1,  1013,    -1,    -1,    -1,    -1,    -1,  5438,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1028,    -1,
     402,    -1,    -1,   405,   406,    -1,  1036,  2852,  2853,    -1,
      -1,  2856,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1050,    -1,  4799,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2877,   435,  2879,  2679,  1066,    -1,  2883,    -1,
      -1,    -1,    -1,    -1,    -1,  2890,    -1,    -1,    -1,  4826,
      -1,    -1,  2897,    -1,    -1,  2900,  5505,    -1,  2702,  4374,
      -1,  2906,    -1,    -1,    -1,    -1,  5515,    -1,    -1,    -1,
    3420,    -1,    -1,    -1,    -1,    -1,  2720,    -1,    -1,    -1,
      -1,  2926,  2726,    -1,  4399,    -1,  2730,  2932,    -1,    -1,
      -1,  4406,  2937,    -1,    -1,  2940,    -1,    -1,    -1,    -1,
      -1,   503,  4417,    -1,    -1,  2950,    -1,    -1,    -1,    -1,
    4887,    -1,  2756,    -1,    -1,    -1,  4893,    -1,  2963,    -1,
    4897,    -1,    -1,  2968,    -1,    -1,    -1,    -1,    -1,  2974,
      -1,  3481,    -1,  1163,    -1,  1165,    -1,  1167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4923,  4924,    -1,    -1,
      -1,  4928,  4929,  2036,    -1,    -1,  1186,  2801,    -1,    -1,
      -1,  1191,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    80,  1203,    -1,    83,    -1,  2821,    -1,    87,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3040,   104,    -1,    -1,    -1,
      -1,    -1,    -1,  5652,   112,    -1,    -1,    -1,    -1,  2853,
      -1,   119,    -1,  5662,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    83,    -1,  1254,  1255,    87,    88,    89,    -1,
      -1,    -1,    -1,  2877,    -1,    -1,   144,    -1,    -1,  2883,
      -1,    -1,    -1,   104,    94,    -1,  2890,    -1,    -1,    -1,
     100,   112,    -1,  2897,    -1,    -1,  2900,    -1,   119,    -1,
      -1,    -1,  2906,   113,    -1,    -1,    -1,    -1,  4583,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3121,    -1,    -1,    -1,
      -1,    -1,  2926,   144,    -1,  2168,    -1,    -1,  2932,    -1,
    5739,    -1,   142,  2937,    -1,    -1,    -1,    -1,  5467,    -1,
      -1,    -1,  2185,    -1,    -1,    -1,  2950,    -1,    -1,  1339,
    1340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2963,
    2203,    -1,    -1,    -1,    -1,    -1,    -1,  4642,    -1,    -1,
    2974,    -1,  3177,    -1,    -1,  1365,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   196,   255,    -1,    -1,
      -1,    -1,   260,   203,    -1,    -1,   206,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5540,    -1,    -1,   282,   283,  2259,    -1,    -1,    -1,
      -1,    -1,   232,    -1,    -1,    -1,    -1,  3232,    -1,   297,
      -1,    -1,    -1,    -1,   255,  2278,    -1,    -1,    -1,   260,
      -1,    -1,    -1,    -1,    -1,  3250,    -1,    -1,  2291,    -1,
      -1,    -1,    -1,  3258,    -1,    -1,   266,    -1,    -1,    -1,
    2303,   282,   283,  3268,  5593,    -1,  3271,    -1,   336,  3274,
      -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,
      -1,    -1,   350,    -1,    -1,   353,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,
    2343,  2344,    -1,    -1,   100,    -1,    -1,    -1,    -1,  5246,
      -1,   107,    -1,    -1,    94,   336,    -1,    -1,    -1,   329,
     100,    -1,    -1,   333,    -1,    -1,    -1,    -1,    -1,   350,
     126,    -1,   353,   343,    -1,  3340,    -1,    -1,    -1,    -1,
      -1,  3346,   352,    -1,    -1,    -1,   142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   364,    -1,    -1,  5966,    -1,  1549,
      -1,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   440,    -1,    -1,    -1,    -1,  1567,    -1,    -1,
     176,  5318,    -1,    -1,  5993,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   402,    -1,    -1,   405,   406,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,    -1,  1596,   203,    -1,    -1,
     206,    -1,  4887,    -1,    -1,    -1,   196,    -1,  4893,   440,
      -1,    -1,  4897,   203,    -1,   435,   206,    -1,  3232,  3434,
      -1,    -1,    -1,    -1,    -1,    -1,   232,    -1,    -1,    -1,
      -1,    -1,  1632,    -1,    -1,    -1,  3250,    -1,    -1,    -1,
      -1,    -1,   232,    -1,  3258,    -1,    -1,    -1,  1648,  2502,
      -1,    -1,    -1,    -1,  6073,    -1,    -1,   263,    -1,    -1,
     266,    -1,   540,    -1,  1664,   543,   544,   545,  1668,   547,
     548,   549,   550,   551,   552,    -1,   266,    -1,    -1,   557,
      -1,    -1,    -1,   503,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,   314,   540,
      -1,    -1,   543,   544,   545,    -1,   547,   548,   549,   550,
     551,   552,    -1,   329,    -1,    -1,   557,   333,    -1,    94,
      -1,    -1,    -1,  3548,  3549,   100,    -1,   343,    -1,   329,
      -1,    80,   107,   333,    83,    -1,   352,    -1,    87,    88,
      89,    -1,    -1,   343,    -1,  6174,    -1,   363,   364,    -1,
    3575,   126,   352,  3578,    -1,   104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   112,   364,    -1,    -1,   142,    -1,    -1,
     119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   402,    -1,  1798,   405,
     406,   407,    -1,    -1,    -1,   144,  1806,  1807,    -1,    -1,
      -1,   176,   402,    -1,    -1,   405,   406,    -1,    -1,    -1,
      -1,    -1,  1822,   429,    -1,    -1,    -1,    -1,    -1,   435,
      -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,
      -1,   206,    -1,   449,    -1,   435,    -1,  3662,  3663,  3664,
      -1,  5598,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4181,    -1,    -1,  4184,    -1,    -1,   232,  1868,  1869,
    1870,  3686,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6022,    -1,    -1,    -1,    -1,    -1,  1889,
      -1,  3706,    -1,    -1,    -1,    -1,    -1,   503,   263,    -1,
      -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3724,
      -1,    -1,    -1,   503,    -1,    -1,   255,    -1,  1918,    -1,
      -1,   260,  2775,    -1,    -1,    -1,  1926,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2789,    -1,  1938,    -1,
      -1,    -1,    -1,   282,   283,    -1,   311,    -1,  1948,   314,
      -1,    -1,  5699,    -1,    -1,    -1,    -1,    -1,   297,    -1,
      -1,  3575,    -1,    -1,   329,    -1,    83,  4287,   333,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2830,   343,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,  1989,
      -1,    -1,    -1,   110,    -1,    -1,  3811,   336,   363,   364,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   163,    -1,
      -1,   350,    -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5778,    -1,  5318,    -1,    -1,    -1,   402,    -1,   156,
     405,   406,   407,  3858,    -1,  2045,    -1,    -1,    -1,    -1,
    3865,    -1,  3867,    -1,    -1,    -1,    -1,    -1,   213,    -1,
      -1,    -1,  2062,    -1,   429,  3880,    -1,  3882,    -1,    -1,
     435,   226,  3686,    -1,    -1,    -1,   231,    -1,    -1,    -1,
      -1,   236,    -1,    -1,   449,    -1,    -1,   242,   205,  3904,
     245,    -1,    -1,    -1,   249,    -1,   213,    -1,   215,    -1,
      -1,   440,    -1,    -1,    -1,    -1,    -1,    -1,   898,   899,
      -1,   228,   902,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    80,    -1,   278,    83,    -1,    -1,    -1,    87,    88,
      89,  2131,   922,  3948,    -1,    -1,    -1,    -1,   503,   929,
      -1,    -1,    -1,   298,    -1,   104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,    -1,    -1,    -1,    -1,   957,    -1,   959,
      -1,    -1,    -1,   963,    -1,    -1,    -1,    -1,  3031,    -1,
      -1,    -1,    -1,    -1,    -1,   144,  4001,   977,    -1,    -1,
     345,    -1,    -1,   348,   984,    -1,    -1,  3811,  2198,   354,
      -1,   540,    -1,    -1,   543,   544,   545,  4022,   547,   548,
     549,   550,   551,   552,    -1,    -1,    -1,    -1,   557,     5,
      -1,    -1,  2222,    -1,    -1,    -1,  4546,    -1,    -1,  4044,
    2230,    -1,  4047,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      -1,    -1,  2242,    -1,    -1,    -1,    -1,    -1,    34,    35,
      -1,    -1,    -1,    -1,   409,    41,    42,    -1,    -1,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    75,
      76,    -1,    -1,    -1,    -1,    81,   255,    -1,    -1,    -1,
      -1,   260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   464,
      -1,    -1,    -1,  5598,  4129,    -1,    -1,    -1,    -1,  2319,
    2320,    -1,    -1,   282,   283,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2333,    -1,    -1,    -1,   492,   297,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2346,  2347,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   516,    -1,   518,   519,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2372,    -1,    -1,  6122,    -1,   336,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4001,    -1,    -1,
      -1,   350,    -1,    -1,   353,  3248,    -1,    -1,    -1,   554,
      -1,    -1,   557,   558,    -1,   560,    -1,    -1,  4022,    -1,
      -1,    -1,  3265,    -1,  5699,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   210,    -1,    -1,  3280,    -1,    -1,
      -1,    -1,    -1,  4047,    -1,    -1,    -1,    -1,    94,  6186,
      -1,    -1,    -1,   229,   100,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4775,    -1,  6204,    -1,  4779,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   440,    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,
     276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4318,    -1,    -1,    -1,  2507,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1307,  1308,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   313,    -1,    -1,
     316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,    -1,
     206,    -1,   338,  4368,    -1,    -1,    -1,    -1,  4373,    -1,
    4375,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   232,    -1,    -1,    -1,
      -1,   540,    -1,  4398,   543,   544,   545,    -1,   547,   548,
     549,   550,   551,   552,    -1,  2595,    -1,  2597,   557,    -1,
      -1,    -1,    -1,  4418,    -1,    -1,    -1,    -1,    -1,    -1,
     266,    -1,    -1,    -1,    -1,    -1,    -1,  1407,    -1,  4434,
      -1,    -1,  4437,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    83,    -1,    -1,    -1,    87,    88,    89,    -1,
     426,    -1,    -1,    -1,    -1,  1435,  1436,    -1,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,    -1,  2657,    -1,  2659,
      -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,  1461,    -1,   329,    -1,    -1,    -1,   333,    -1,  2679,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   343,    -1,    -1,
     476,    -1,    -1,   144,    -1,    -1,   352,    -1,    -1,    -1,
      -1,    -1,  2702,    -1,  4318,    -1,   492,    -1,   364,    -1,
      -1,    -1,    -1,    -1,  4529,  4530,    -1,    -1,  5038,    -1,
    2720,   507,    -1,    -1,  4539,  2725,  2726,    -1,    80,  3582,
    2730,    83,    -1,    -1,    -1,    87,    88,    89,  2738,    -1,
      -1,    -1,    -1,  4558,    -1,    -1,   402,    -1,  3601,   405,
     406,   537,   104,    -1,  1544,  1545,  2756,    -1,    -1,   545,
     112,   547,   548,   549,   550,   551,    -1,   119,   554,   555,
     556,    -1,   889,    -1,    -1,   561,   562,    -1,    -1,   435,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     907,    -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,   916,
      -1,  2801,  4617,    80,   255,    -1,    83,    -1,    -1,   260,
      87,    88,    89,   930,  2814,    -1,    -1,    -1,    -1,    -1,
    4434,  2821,  2822,  4437,    -1,    -1,    -1,   104,    -1,    -1,
    4645,   282,   283,    -1,    -1,   112,    -1,    -1,    -1,    -1,
      -1,    -1,   119,  3696,    -1,  3698,   297,   503,    -1,    -1,
      -1,   968,  2852,  2853,    -1,    -1,  2856,   974,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,    -1,
     987,    -1,    -1,    -1,    -1,    -1,    -1,  2877,    -1,  2879,
      -1,    -1,    -1,  2883,    -1,   336,    -1,    -1,    -1,    -1,
    2890,    -1,    -1,    -1,    -1,  2895,  1013,  2897,  5218,   350,
    2900,    -1,   353,   255,    -1,  5225,  2906,    -1,   260,    -1,
    5230,  1028,    -1,  5233,  5234,    -1,    -1,    -1,    -1,  1036,
      -1,    -1,    -1,    -1,    -1,  4539,  2926,    -1,    -1,    -1,
     282,   283,  2932,  1050,    -1,    -1,  3789,  2937,    -1,    -1,
    2940,    -1,  5262,    -1,  4558,   297,    -1,    -1,    -1,  1066,
    2950,    -1,    -1,    -1,    -1,    -1,  5276,    -1,    -1,    -1,
      -1,    -1,    -1,  2963,    -1,    -1,    -1,    -1,  2968,    -1,
      -1,    -1,    -1,    -1,  2974,    -1,    -1,  3830,   255,    -1,
      -1,    -1,    -1,   260,   336,    -1,    -1,    -1,    -1,   440,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,    -1,
      -1,   353,    -1,    -1,    -1,   282,   283,    -1,    -1,  5329,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4645,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3040,    -1,    -1,    -1,    -1,    -1,  1163,    -1,  1165,    -1,
    1167,    -1,    -1,  5373,    -1,    -1,    94,    -1,    -1,   336,
      -1,    -1,   100,    -1,    -1,  4880,    -1,    -1,    -1,    -1,
    4885,    -1,    -1,   350,  1191,  3928,   353,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1203,    -1,   440,   540,
      -1,    -1,   543,   544,   545,    -1,   547,   548,   549,   550,
     551,   552,    -1,    -1,   142,  4920,   557,    -1,    -1,    -1,
      -1,    -1,  3965,    -1,    -1,    -1,    -1,  4932,    -1,    -1,
      -1,  3121,  5442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1254,  1255,    -1,
      -1,    -1,    80,    -1,    -1,    83,    -1,  4962,    -1,    87,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    -1,   440,    -1,   203,   104,    -1,   206,    -1,
      -1,    -1,    -1,    -1,   112,    -1,    -1,  3177,    -1,    -1,
      -1,   119,    -1,    -1,    -1,  5505,    -1,    -1,   540,    -1,
      -1,   543,   544,   545,   232,   547,   548,   549,   550,   551,
     552,    -1,  1992,    -1,    -1,   557,   144,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4070,    -1,    -1,
      -1,    -1,  1339,  1340,    -1,    -1,    -1,  2017,   266,    -1,
      -1,    -1,  3232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4093,    -1,    -1,    -1,    -1,    -1,  5061,    -1,  1365,    -1,
    3250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3258,    -1,
      -1,    -1,    -1,   540,    -1,  4118,   543,   544,   545,    -1,
     547,   548,   549,   550,   551,   552,    -1,    -1,    -1,    -1,
     557,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   329,    -1,    -1,    -1,   333,    -1,    -1,    -1,    -1,
    2090,  4154,    -1,    -1,    -1,   343,  4920,  5627,    -1,    -1,
      -1,    -1,    -1,    -1,   352,    -1,    -1,   255,  4932,    -1,
      -1,    -1,   260,    -1,    -1,    -1,   364,  2117,  2118,  2119,
    2120,    -1,  5652,    -1,    -1,    -1,  5151,    -1,    -1,    -1,
    3340,    -1,    -1,    -1,   282,   283,  3346,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,
      -1,    -1,    -1,    -1,   402,    -1,    -1,   405,   406,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      83,    -1,    -1,    -1,    87,    88,    89,  2177,  2178,    -1,
      -1,    -1,    -1,  5713,    -1,    -1,    -1,   435,   336,    -1,
      -1,   104,    -1,    -1,    -1,    -1,    -1,  2197,    -1,   112,
      -1,    -1,   350,    -1,    -1,   353,   119,    -1,    94,    -1,
      -1,    -1,  5742,    -1,   100,    -1,    -1,    -1,    80,    -1,
      -1,    83,  1549,    -1,  3434,    87,    88,    89,    -1,    -1,
      -1,   144,  2232,  2233,  2234,  2235,    -1,    -1,    -1,    -1,
    1567,    -1,   104,    -1,    -1,  5270,    -1,  5272,    -1,    -1,
     112,    -1,    -1,    -1,    -1,   503,   142,   119,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1596,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   440,    -1,  5319,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5329,  1632,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,    -1,    -1,   203,  5848,    -1,
     206,  1648,    -1,    -1,    -1,    -1,    -1,  5151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1664,  3548,  3549,
      -1,  1668,   255,  5368,    -1,    -1,   232,   260,  5373,    -1,
      -1,    -1,  2352,    -1,    -1,    -1,    -1,    -1,  2358,    -1,
      -1,    -1,    -1,    -1,    -1,  3575,    -1,    -1,  3578,   282,
     283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     266,    -1,    -1,    -1,   297,    -1,    -1,    -1,    -1,  5919,
      -1,    -1,   540,   255,    -1,   543,   544,   545,   260,   547,
     548,   549,   550,   551,   552,    -1,    -1,    -1,    -1,   557,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     282,   283,    -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   297,    -1,   350,    -1,    -1,
     353,    -1,  5972,   329,    -1,    -1,  5270,   333,  5272,    -1,
      -1,    -1,  3662,  3663,  3664,    -1,    -1,   343,  5988,    -1,
      -1,    -1,    -1,    -1,  5994,  5995,   352,    -1,    -1,    -1,
    4533,  1798,    -1,    -1,   336,    -1,  3686,    -1,   364,  1806,
    1807,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,    -1,
      -1,   353,    -1,    -1,    -1,  1822,  3706,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    -1,
    2510,    -1,    -1,   100,  3724,    -1,   402,    -1,    -1,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,   440,    -1,    -1,
      -1,    -1,    -1,  5558,  6064,    -1,    -1,    -1,    -1,    -1,
    6070,  1868,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,
      -1,    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,  5584,
      -1,    -1,  1889,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5598,    -1,    -1,    -1,    -1,   440,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    -1,    -1,    -1,    -1,    -1,
     100,  3811,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,
      -1,  1938,    -1,    -1,    -1,    -1,   203,   503,    -1,   206,
      -1,  1948,    -1,    -1,    -1,    -1,    -1,   540,    -1,    -1,
     543,   544,   545,    -1,   547,   548,   549,   550,   551,   552,
      -1,  6171,   142,    -1,   557,   232,    -1,    -1,  3858,    -1,
      -1,    -1,    -1,    -1,  6184,  3865,    -1,  3867,    -1,    -1,
      -1,    -1,  1989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3880,    -1,  3882,  4736,    -1,    -1,  6206,  6207,   540,   266,
      -1,   543,   544,   545,    -1,   547,   548,   549,   550,   551,
     552,    -1,    -1,    -1,  3904,   557,   196,    -1,    -1,    -1,
      -1,    -1,    -1,   203,    -1,    -1,   206,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2045,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   232,    -1,    -1,  2062,    -1,    -1,  3948,    -1,
      -1,    -1,   329,    -1,    -1,    -1,   333,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   343,    -1,    -1,    -1,
      -1,  5786,    -1,  5788,    -1,   352,   266,    -1,    -1,    -1,
      -1,    -1,    -1,  2773,  2774,    -1,    -1,   364,    -1,    -1,
      -1,    -1,    -1,    -1,  2784,    80,  2786,    -1,    83,    -1,
    2790,  4001,    87,    88,    89,    -1,    -1,    -1,    -1,  4862,
      -1,    -1,    -1,    -1,  2131,    -1,    -1,    -1,    -1,   104,
      -1,    -1,  4022,    -1,    -1,   402,    -1,   112,   405,   406,
      -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,   329,
      -1,    -1,    -1,   333,  4044,    -1,    -1,  4047,    -1,    -1,
    4903,    -1,    -1,   343,    -1,    -1,    -1,    -1,   435,   144,
      -1,    -1,   352,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4925,  5888,   364,    -1,    -1,    -1,    -1,    -1,
      -1,  2198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5906,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5919,  2222,    -1,    -1,    -1,     3,
      -1,    -1,   402,  2230,     8,   405,   406,  5932,    12,    -1,
      14,    -1,    16,    17,    -1,  2242,   503,    -1,  2918,  4129,
      -1,  2921,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,
    4993,    -1,    -1,    -1,    -1,   435,    -1,    -1,    -1,    43,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     255,    -1,    -1,    -1,    -1,   260,    -1,    -1,    -1,  5994,
    5995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,   282,   283,    -1,
      -1,    -1,  2319,  2320,    -1,    -1,   100,    -1,   102,   103,
      -1,    -1,   297,   503,  3004,    -1,  2333,    -1,    -1,    -1,
      -1,    -1,  3012,  6038,   118,  3015,    -1,    -1,    -1,  2346,
    2347,  3021,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3032,    -1,    -1,   139,    -1,   141,   142,    -1,
      -1,   336,    -1,    -1,   148,  2372,   150,    -1,    -1,    -1,
      -1,    -1,    -1,  5116,    -1,   350,    -1,   161,   353,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3073,   178,    -1,   180,    -1,    -1,   183,
      -1,    -1,  5906,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   197,    -1,   199,    -1,  6122,    -1,   203,
      -1,  3101,    -1,    -1,    -1,   209,    -1,    -1,  4318,    -1,
      -1,  5174,    -1,   217,    -1,   219,    -1,    -1,    -1,    -1,
      -1,    -1,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,    -1,   163,    -1,   440,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   259,    -1,    -1,  4368,    -1,
    3160,  6186,  3162,  4373,    -1,  4375,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6204,
    2507,  6206,  6207,    -1,    -1,    -1,    -1,    -1,  4398,    -1,
      -1,    -1,    -1,   213,    -1,   299,   300,    -1,    -1,    -1,
      -1,   305,    -1,    -1,    -1,    -1,   226,    -1,  4418,    -1,
      -1,   231,    -1,   317,    -1,    -1,   236,    -1,    -1,    -1,
      -1,    -1,   242,    -1,  4434,   245,    -1,  4437,    -1,   249,
      -1,   335,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   540,    -1,    -1,   543,   544,
     545,    -1,   547,   548,   549,   550,   551,   552,   278,    -1,
      -1,    -1,   557,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2597,    -1,    -1,    -1,   378,    -1,    -1,    -1,   298,    -1,
      -1,    -1,    -1,  3283,    -1,    -1,    -1,    -1,   392,    -1,
      -1,    -1,    -1,    -1,   398,   399,    -1,   401,    -1,    -1,
      -1,    -1,   406,    -1,    -1,    -1,    -1,   411,    -1,    -1,
     414,    -1,    -1,    -1,    -1,    -1,    -1,   421,    -1,  4529,
    4530,    -1,    -1,   427,   428,   345,    -1,    -1,   348,  4539,
      -1,   435,    -1,    -1,   354,   439,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   449,    -1,    -1,  4558,    -1,
      -1,    -1,  2679,    -1,    -1,    80,    -1,    -1,    83,    -1,
     464,    -1,    87,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2702,    -1,    -1,    -1,   104,
     484,    -1,   486,    -1,    -1,    -1,    -1,   112,    -1,   409,
      -1,   495,    -1,  2720,   119,    -1,    -1,   501,  2725,  2726,
      -1,    -1,   506,  2730,    -1,    -1,    -1,  4617,    -1,  5472,
      -1,  2738,    -1,    -1,    -1,   519,    -1,    -1,    80,   144,
      -1,    83,    -1,    -1,    -1,    87,    88,    89,    -1,  2756,
      -1,    -1,    -1,    -1,    -1,  4645,    -1,    -1,   542,    -1,
      -1,    -1,   104,    -1,   464,    -1,    -1,    -1,  5511,    -1,
     112,    -1,   556,    -1,    -1,    -1,   560,   119,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,    -1,  2801,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   144,    80,    -1,    -1,    83,  2814,    -1,    -1,
      87,    88,    89,    -1,  2821,  2822,   516,    -1,   518,   519,
      -1,    -1,    -1,    -1,  5567,    -1,    -1,   104,    -1,  5572,
    5573,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,  2852,  2853,    -1,    -1,  2856,
     255,    -1,    -1,    -1,   554,   260,    -1,   557,   558,    -1,
     560,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,    -1,
    2877,    -1,  2879,    -1,    -1,    -1,  2883,   282,   283,    -1,
      -1,    -1,    -1,  2890,    -1,    -1,    -1,    -1,  2895,    -1,
    2897,    -1,   297,  2900,    -1,    -1,    -1,    -1,    -1,  2906,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3588,    -1,
    3590,  3591,  3592,   255,    -1,    -1,    -1,    -1,   260,  2926,
      -1,    -1,    -1,    -1,    -1,  2932,    -1,    -1,    -1,    -1,
    2937,   336,    -1,  2940,    -1,    -1,    -1,    -1,    -1,    -1,
     282,   283,    -1,  2950,    -1,   350,  5689,    -1,   353,    -1,
      -1,    -1,    -1,    -1,    -1,   297,  2963,   128,    -1,    -1,
      -1,  2968,    -1,    -1,    -1,    -1,    -1,  2974,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   255,    -1,
      -1,    -1,    -1,   260,    -1,    -1,    -1,    -1,    -1,    -1,
    4880,   162,    -1,    -1,   336,  4885,    -1,    -1,   163,    -1,
      -1,    -1,    -1,    -1,    -1,   282,   283,    -1,   350,    -1,
      -1,   353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4920,    -1,    -1,  3040,    -1,   440,    -1,    -1,    -1,    -1,
      -1,    -1,  4932,    -1,    -1,    -1,    -1,    -1,   213,    -1,
      -1,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,
      -1,   226,    -1,    -1,    -1,    -1,   231,    -1,    -1,    -1,
      -1,   236,  4962,   350,    -1,    -1,   353,   242,    -1,    -1,
     245,    -1,    -1,    -1,   249,    -1,   257,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   440,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   278,  3121,    -1,    -1,    80,    -1,    -1,
      83,    -1,   293,   128,    87,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,   298,    -1,   540,    -1,    -1,   543,   544,
     545,   104,   547,   548,   549,   550,   551,   552,  5891,   112,
      -1,  3831,   557,    -1,    -1,    -1,   119,   162,   329,    -1,
      -1,    -1,   333,   440,    -1,    -1,    -1,    -1,    -1,    -1,
    3177,  5061,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     345,   144,    -1,   348,    -1,    -1,    -1,    -1,    -1,   354,
      -1,    -1,    -1,   364,   365,    -1,    -1,    -1,   540,    -1,
      -1,   543,   544,   545,    -1,   547,   548,   549,   550,   551,
     552,    -1,    -1,    -1,    -1,   557,    -1,   222,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3232,    -1,    -1,    -1,    -1,
      -1,   402,    -1,    -1,    -1,   406,    -1,    -1,    -1,   410,
      -1,    -1,    -1,  3250,   409,    -1,    -1,    -1,   419,    -1,
      -1,  3258,   257,    -1,    -1,    -1,   427,    -1,    -1,    -1,
      -1,  5151,    -1,   540,   435,    -1,   543,   544,   545,    -1,
     547,   548,   549,   550,   551,   552,   447,    -1,    88,    -1,
     557,    -1,    -1,    -1,    -1,   456,    -1,    -1,   293,   460,
      -1,    -1,   255,    -1,    -1,    -1,    -1,   260,    -1,   464,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,   282,
     283,    -1,    -1,   133,   329,  4005,    -1,   492,   333,    -1,
      -1,    -1,    -1,  3340,   297,    -1,    -1,   147,    -1,  3346,
      -1,    -1,    -1,   514,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   516,    -1,   518,   519,   165,    -1,    -1,    -1,   364,
     365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     180,    -1,    -1,   336,    -1,    -1,    -1,    -1,    -1,   189,
    5270,    -1,  5272,    -1,    -1,    -1,    -1,   350,    -1,   554,
     353,    -1,   557,   558,   204,   560,   206,   402,    -1,    -1,
     210,   406,    -1,    -1,    -1,   410,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,   419,    -1,    -1,    -1,    -1,   229,
      -1,    -1,   427,    -1,    -1,    -1,    -1,  3434,    -1,  5319,
     435,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   447,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   456,    -1,    -1,    -1,   460,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   440,  5368,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     6,     7,    -1,     9,    10,    11,    -1,   514,
      -1,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    -1,    -1,    -1,    30,    31,    32,    33,
      -1,    35,    36,    37,    38,    -1,    40,    41,    42,    -1,
      -1,  3548,  3549,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    -1,    69,    -1,    -1,  3575,    73,
      -1,  3578,    -1,    -1,    -1,    -1,    -1,   540,    -1,    -1,
     543,   544,   545,    -1,   547,   548,   549,   550,   551,   552,
      -1,    -1,    -1,    -1,   557,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   115,    -1,    -1,    -1,   119,   120,   121,   122,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4308,  4309,
    4310,  4311,   136,    -1,    -1,    -1,    -1,    -1,    -1,   143,
      -1,   145,    -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,
      -1,    -1,    -1,    -1,    -1,  3662,  3663,  3664,    -1,    -1,
     164,    -1,    -1,    -1,    -1,    -1,    -1,   171,  5558,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   181,   182,  3686,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5584,    -1,    -1,    -1,    -1,  3706,
      -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,  5598,    -1,
      -1,    -1,    -1,    -1,   218,    -1,    -1,  3724,    -1,   223,
      -1,    -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,
      -1,   235,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,
     244,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   270,   271,    -1,    -1,
      -1,    -1,    -1,   277,    -1,   279,    -1,    -1,   282,   283,
      -1,   285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     294,   295,    -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3811,    -1,    -1,  4487,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   320,   321,   322,    -1,
      -1,    -1,  4502,    -1,    -1,    -1,   330,   331,    -1,    -1,
      -1,    -1,   336,    -1,    -1,   339,    -1,   341,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3858,    -1,   357,   358,    -1,   360,   361,  3865,    -1,
    3867,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     374,    -1,   376,  3880,    -1,  3882,   686,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   391,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5786,  3904,  5788,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,    -1,
      -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   437,    -1,    -1,   440,    -1,    -1,   443,
      -1,  3948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   459,    -1,    -1,    -1,    -1,
      -1,    -1,   466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     474,   475,    -1,    -1,    -1,    -1,   480,    -1,   482,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,    -1,
      -1,    -1,    -1,    -1,  4001,    -1,    -1,    -1,  5888,    -1,
      -1,    -1,    -1,   507,    -1,    -1,   510,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4022,  5906,    -1,    -1,    -1,
      -1,    -1,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    -1,    -1,    -1,    -1,  4044,    -1,    -1,
    4047,    -1,  5932,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   563,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   897,   898,   899,
     900,    -1,   902,    -1,    -1,    -1,   906,    -1,   908,    -1,
      -1,   911,    -1,    -1,   914,    -1,    -1,   917,    -1,    -1,
     920,    -1,   922,    -1,    -1,   925,    -1,    -1,    -1,   929,
      -1,   931,  4129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   949,
      -1,    -1,    -1,     5,    -1,   955,    -1,   957,  6038,   959,
      -1,   961,    -1,   963,    -1,    -1,    -1,    -1,    -1,    -1,
     970,    -1,    24,    -1,    -1,   975,    -1,   977,    -1,    -1,
      -1,    -1,    34,    35,   984,    -1,    -1,    -1,    -1,    41,
      42,    -1,    -1,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,  1018,    -1,
      -1,    73,  1022,    75,    76,    -1,    -1,  1027,    -1,    81,
      -1,  1031,    -1,    -1,  1034,    -1,    -1,  1037,    -1,    -1,
      -1,    -1,  6122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1053,    -1,    80,    -1,    -1,    83,    -1,
      -1,    -1,    87,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,
      -1,    -1,    -1,   135,    -1,    -1,    -1,   112,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4973,    -1,    -1,  6186,    -1,    -1,    -1,
      -1,  1111,    -1,    -1,    -1,    -1,    -1,    -1,  4988,   144,
      -1,  4318,    -1,    -1,  6204,    -1,    -1,    -1,  1128,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    80,    -1,    -1,    83,    -1,    -1,    -1,    87,    88,
      89,    -1,    -1,    -1,    -1,    -1,  1156,  1157,   210,    -1,
      -1,  1161,  1162,    -1,    -1,   104,    -1,    -1,    -1,    -1,
      -1,  4368,    -1,   112,    -1,    -1,  4373,   229,  4375,    -1,
     119,  1181,    -1,    -1,    -1,  1185,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1193,    -1,    -1,    -1,    -1,    -1,    -1,
     252,  4398,    -1,    -1,  1204,   144,    -1,    -1,    -1,    -1,
      -1,  5081,    -1,    -1,    -1,    -1,  1216,    -1,    -1,    -1,
      -1,  4418,    -1,    -1,   276,    -1,    -1,    -1,    -1,    -1,
     255,    -1,    -1,    -1,    -1,   260,    -1,  4434,    -1,    -1,
    4437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,   283,    -1,
      -1,   313,    -1,    -1,   316,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   338,    -1,    -1,    -1,
      -1,  1291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1302,    -1,    -1,    -1,    -1,  1307,  1308,    -1,
      -1,   336,    -1,    -1,    -1,    -1,   255,    -1,    -1,    -1,
      -1,   260,    -1,    -1,    -1,   350,    -1,    -1,   353,    -1,
      -1,    -1,  4529,  4530,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4539,   282,   283,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,
      -1,  4558,    -1,  1363,  1364,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1372,    -1,   426,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1383,    -1,    -1,    -1,  1387,    -1,  1389,
      -1,    -1,  1392,    -1,    -1,    -1,    -1,   336,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1407,  5278,    -1,
    5280,   350,    -1,    -1,   353,   440,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   476,    -1,    -1,    -1,    -1,  1429,
      -1,    -1,    -1,    -1,    -1,  1435,  1436,    -1,    -1,    -1,
     492,    -1,    80,    -1,    -1,    83,    -1,    -1,  4645,    87,
      88,    89,    -1,    -1,    -1,   507,    -1,  1457,  1458,  1459,
      -1,  1461,    -1,  1463,  1464,  1465,   104,    -1,    -1,    -1,
    1470,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,
      -1,   119,    -1,    -1,    -1,   537,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   545,    -1,   547,   548,   549,   550,   551,
      -1,   440,   554,   555,   556,   557,   144,    -1,    -1,   561,
      -1,    -1,    -1,    -1,    -1,   540,    -1,    -1,   543,   544,
     545,    -1,   547,   548,   549,   550,   551,   552,    -1,    -1,
      80,    -1,   557,    83,    -1,    -1,    -1,    87,    88,    89,
      -1,    -1,  1542,    -1,  1544,  1545,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,   108,    -1,
      -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,   119,
    5440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1588,    -1,
      -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,
      -1,   540,    -1,    -1,   543,   544,   545,    -1,   547,   548,
     549,   550,   551,   552,    -1,    -1,    80,   255,   557,    83,
      -1,    -1,   260,    87,    88,    89,  1626,  1627,    -1,    -1,
      -1,  1631,    -1,  1633,    -1,    -1,    -1,    -1,    -1,    -1,
     104,    -1,    -1,   193,   282,   283,    -1,    -1,   112,    -1,
      -1,    -1,    -1,    -1,  1654,   119,    -1,    -1,    -1,   297,
    1660,    -1,    -1,  1663,    -1,    -1,  1666,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1679,
     144,    -1,    -1,  4880,    -1,    -1,    -1,    -1,  4885,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,    -1,
      -1,    -1,    -1,    -1,    -1,   255,    -1,    -1,    -1,  1709,
     260,    -1,   350,    -1,    -1,   353,    -1,    -1,  5588,    -1,
    5590,    -1,    -1,  4920,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   282,   283,    -1,  4932,    -1,  1737,  1738,  1739,
      -1,  1741,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1761,    -1,    -1,    -1,  4962,    -1,   231,    -1,    -1,
      -1,    -1,   236,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1784,  1785,   336,    -1,    -1,    -1,
      -1,   255,    -1,    -1,    -1,    -1,   260,    -1,    -1,    -1,
     350,    -1,   440,   353,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1813,    -1,    -1,    -1,    -1,   282,   283,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1843,    -1,    -1,    -1,  1847,  1848,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1858,  1859,
    1860,    -1,  1862,    -1,  5061,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   350,  1887,    -1,   353,
     440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   540,    -1,    -1,   543,   544,   545,    -1,   547,
     548,   549,   550,   551,   552,    -1,    -1,   555,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     500,    -1,    -1,    -1,  5151,    -1,    -1,  5827,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   440,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1984,    -1,    -1,    -1,    -1,    -1,
     540,    -1,  1992,   543,   544,   545,    -1,   547,   548,   549,
     550,   551,   552,    -1,    -1,  2005,  2006,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2014,    -1,    -1,  2017,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2040,    -1,  2042,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5934,  2065,    -1,    -1,  2068,    -1,
      -1,    -1,    -1,  5270,    -1,  5272,   540,    -1,    -1,   543,
     544,   545,    -1,   547,   548,   549,   550,   551,   552,    -1,
    2090,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2105,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2117,  2118,  2119,
    2120,  2121,  5319,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2147,  2148,  2149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6032,  2163,    -1,  2165,    -1,    -1,    -1,    -1,
      -1,  5368,    -1,    -1,    -1,    -1,    -1,  2177,  2178,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6065,  6066,  2197,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2216,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2232,  2233,  2234,  2235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2245,    -1,    -1,    -1,    -1,
      -1,    -1,  2252,    -1,  2254,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2272,    -1,    -1,  2275,    -1,    -1,    -1,  2279,
      -1,    -1,    -1,    -1,    -1,  2285,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6168,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2316,  2317,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2327,  2328,    -1,
      -1,  2331,    -1,    -1,  2334,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2351,  2352,    -1,    -1,    -1,    -1,    -1,  2358,    -1,
      -1,  5558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2369,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5584,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5598,    -1,  2403,    -1,    -1,    -1,    -1,    -1,    -1,
    2410,    -1,  2412,    -1,    -1,  2415,  2416,    -1,  2418,  2419,
      -1,  2421,    -1,    -1,    -1,    -1,    -1,    -1,  2428,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2438,    -1,
      -1,    -1,    -1,    -1,    -1,  2445,  2446,    -1,    -1,  2449,
      -1,    -1,    -1,  2453,  2454,    -1,    -1,    -1,    -1,  2459,
    2460,    -1,    -1,    -1,    -1,    -1,  2466,  2467,  2468,    -1,
      -1,  2471,    -1,  2473,  2474,  2475,  2476,  2477,  2478,  2479,
    2480,    -1,  2482,    -1,  2484,  2485,    -1,    -1,  2488,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2503,  2504,  2505,  2506,    -1,    -1,    -1,
    2510,  2511,    -1,    -1,    -1,  2515,    -1,    -1,  2518,    -1,
      -1,  2521,  2522,  2523,  2524,  2525,  2526,  2527,  2528,  2529,
      -1,  2531,    -1,    -1,    -1,    -1,    -1,    -1,  2538,  2539,
      -1,    -1,  2542,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2564,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5786,
      -1,  5788,    -1,    -1,  1023,    -1,  2596,    -1,    -1,    -1,
      -1,    -1,    -1,  2603,    -1,    -1,    -1,  2607,  2608,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2618,    -1,
    1049,    -1,    -1,    -1,     5,    -1,    -1,  2627,  2628,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2641,    -1,    24,    -1,    -1,    -1,    -1,  2648,    -1,
    2650,    -1,    -1,    34,    35,    -1,    -1,    -1,    -1,    -1,
      41,    42,    -1,    -1,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      -1,  5888,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5906,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2731,    -1,    -1,    -1,  5932,    -1,    -1,    -1,    -1,
    2740,    -1,  2742,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,  2759,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2771,    -1,  2773,  2774,    -1,    -1,    -1,  2778,    -1,
    2780,  2781,  2782,    -1,  2784,    -1,  2786,    -1,    -1,    -1,
    2790,    -1,    -1,  2793,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2825,    -1,    -1,    -1,   210,
      -1,    -1,    -1,  2833,  2834,    -1,    -1,    -1,    -1,    -1,
    2840,  6038,    -1,    -1,    -1,    -1,    -1,    -1,   229,  2849,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2868,    -1,
      -1,   252,    -1,  2873,  2874,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2888,  2889,
      -1,    -1,  2892,    -1,  2894,   276,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2918,    -1,
      -1,  2921,    -1,    -1,    -1,  6122,    -1,    -1,    -1,    -1,
      -1,    -1,   313,    -1,    -1,   316,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2944,  2945,    -1,    -1,    -1,    -1,
    1379,    -1,    -1,    -1,    -1,    -1,    -1,   338,    -1,  2959,
      -1,  2961,  2962,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1404,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6186,
    1419,    -1,  2992,  2993,  2994,    -1,    -1,    -1,  2998,    -1,
      -1,    -1,    -1,    -1,  3004,    -1,    -1,  6204,    -1,    -1,
      -1,    -1,  3012,    -1,    -1,  3015,    -1,    -1,    -1,    -1,
      -1,  3021,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3030,    -1,  3032,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   426,  3046,    -1,    -1,  3049,
      -1,  3051,    -1,    -1,  3054,    -1,    -1,    -1,  3058,    -1,
      -1,  3061,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3073,  3074,    -1,    -1,    -1,    -1,    -1,
    1509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3091,    -1,    -1,    -1,   476,    -1,    -1,    -1,    -1,
      -1,  3101,    -1,  3103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3122,    -1,    -1,    -1,   507,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3148,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   537,    -1,  3158,    -1,
    3160,  3161,  3162,  3163,   545,    -1,   547,   548,   549,   550,
     551,    -1,    -1,   554,   555,   556,   557,    -1,    -1,    -1,
     561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    83,    -1,    -1,    -1,    87,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3211,    -1,   104,    -1,    -1,    -1,  1646,    -1,    -1,
      -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3262,    -1,    -1,    -1,    -1,    -1,  3268,    -1,
      -1,  3271,    -1,    -1,  3274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3283,    -1,    -1,    -1,    -1,    -1,    -1,
    3290,    -1,    -1,    -1,    -1,  3295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3319,
    3320,  3321,    -1,    -1,  3324,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3332,  3333,  3334,  3335,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3345,    -1,    -1,  3348,    -1,
    3350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3361,  3362,    -1,   255,  3365,    -1,    -1,    -1,   260,
      -1,    -1,  1801,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3383,    -1,  3385,    -1,  3387,    -1,  3389,
      -1,   282,   283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,    -1,  3409,
      -1,    -1,    -1,  3413,    -1,    -1,    -1,    -1,    -1,    -1,
    3420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,    83,    -1,    -1,    -1,
      87,    88,    89,    -1,  3444,   336,    -1,    -1,    -1,    -1,
      -1,    -1,  3452,    -1,    -1,    -1,    -1,   104,    -1,   350,
      -1,    -1,   353,    -1,     5,   112,    -1,  3467,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3481,    -1,    24,    -1,  3485,   377,    -1,  3488,    -1,
    3490,    -1,    -1,    34,    35,    -1,    -1,   144,    -1,    -1,
      41,    42,    -1,  1932,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   440,
      -1,    -1,    -1,    -1,  3554,    -1,  3556,    -1,    -1,    -1,
      -1,  3561,    -1,    -1,    -1,    -1,   457,    -1,    -1,    -1,
    1999,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,    -1,    -1,    -1,    -1,  3588,    -1,
    3590,  3591,  3592,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2036,   255,    -1,
      -1,    -1,    -1,   260,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   282,   283,    -1,    -1,    -1,
    2069,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   540,
     297,    -1,   543,   544,   545,    -1,   547,   548,   549,   550,
     551,   552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,   336,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   350,  3704,    -1,   353,    -1,    -1,    -1,
      -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   375,    -1,
      -1,    -1,    -1,    -1,    -1,   276,    -1,    -1,    -1,  2168,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2185,    -1,    -1,    -1,
      -1,    -1,    80,    -1,    -1,    83,    -1,    -1,    -1,    87,
      88,    89,   313,    -1,  2203,   316,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,    -1,   440,   112,    -1,    -1,   338,    -1,    -1,
      -1,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3816,    -1,    -1,    -1,
      -1,    -1,  3822,    -1,    -1,    -1,   144,    -1,    -1,    -1,
    2259,  3831,    -1,    -1,    -1,    -1,  3836,  3837,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3871,  3872,  3873,  2303,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   426,    -1,    -1,  3888,    -1,
      -1,    -1,    -1,   540,    -1,    -1,   543,   544,   545,    -1,
     547,   548,   549,   550,   551,   552,    -1,    -1,    -1,    -1,
    3910,  3911,    -1,    -1,  2343,  2344,    -1,    -1,    -1,    -1,
    3920,  3921,  3922,    -1,    -1,    -1,  3926,    -1,    -1,  3929,
      -1,    -1,    -1,    -1,    -1,   476,    -1,   255,  3938,    -1,
      -1,    -1,   260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3960,    -1,    -1,    -1,   282,   283,   507,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,
      -1,  3981,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   537,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   545,  4005,   547,   548,   549,   550,
     551,    -1,    -1,   554,   555,   556,    -1,    -1,   336,    -1,
     561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4029,
      -1,    -1,   350,    -1,    -1,   353,    -1,    -1,    -1,    -1,
      -1,    -1,  4042,    -1,    -1,  4045,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4067,    -1,    -1,
      -1,    -1,    -1,  2502,    -1,    -1,  4076,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4084,    -1,  4086,    -1,    -1,  4089,
      -1,    -1,    -1,    -1,  4094,  4095,  4096,  4097,    -1,    -1,
    4100,  4101,  4102,  4103,  4104,  4105,  4106,  4107,  4108,  4109,
      -1,    -1,    -1,  4113,  4114,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   440,  4123,    -1,    -1,    -1,  4127,    -1,    -1,
      -1,  4131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4139,
      -1,    -1,  4142,    -1,  4144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4156,    -1,    -1,  4159,
    4160,    -1,    -1,    -1,  4164,  4165,    -1,    -1,    -1,  4169,
      -1,  4171,    -1,    -1,    -1,    -1,    -1,    -1,  4178,  4179,
    4180,  4181,    -1,    -1,  4184,  4185,    -1,    -1,    -1,  4189,
    4190,  4191,    -1,    -1,    -1,    -1,  4196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   540,    -1,    -1,   543,   544,   545,    -1,   547,
     548,   549,   550,   551,   552,    -1,    -1,    80,    -1,    -1,
      83,    -1,    -1,  4243,    87,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4257,    -1,  4259,
      -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,
    2709,    -1,    -1,    -1,  2713,  2714,    -1,  4287,  4288,  4289,
      -1,  4291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,  4308,  4309,
    4310,  4311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2775,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4355,    -1,    -1,    -1,    -1,
    2789,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   255,    -1,    -1,    -1,    -1,   260,    -1,    -1,
      -1,    80,    -1,    -1,    83,    -1,    -1,    -1,    87,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,
     283,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,    -1,
     110,    -1,  4452,   112,   297,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   144,    -1,  4487,    -1,    -1,
      -1,    -1,    -1,   336,    -1,    -1,   156,    -1,    -1,    -1,
    4500,    -1,  4502,    -1,  4504,    -1,    -1,   350,    -1,    -1,
     353,  4511,    -1,    -1,    -1,    -1,    -1,  4517,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4527,   371,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4542,    -1,    -1,   205,  4546,    -1,    -1,    -1,
      -1,    -1,    -1,   213,    -1,   215,  4556,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4565,    -1,    -1,   228,    -1,
      -1,    -1,    -1,    -1,    -1,  4575,    -1,    -1,    -1,  4579,
      -1,    -1,    -1,    -1,    -1,    -1,  4586,  4587,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   255,   440,    -1,    -1,
      -1,   260,  3031,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4618,  4619,
    4620,  4621,  4622,   282,   283,  4625,    -1,  4627,    -1,    -1,
      -1,    -1,    -1,    -1,  4634,    -1,    -1,    -1,   297,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4670,    -1,    -1,    -1,    -1,    -1,    -1,   336,    -1,    -1,
      -1,    -1,  4682,    -1,  3113,    -1,    -1,  3116,    -1,    -1,
      -1,   350,    -1,    -1,   353,    -1,    -1,   540,    -1,    -1,
     543,   544,   545,    -1,   547,   548,   549,   550,   551,   552,
      -1,    -1,  4712,    -1,    -1,  4715,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4723,  4724,    -1,    -1,    -1,    -1,    -1,
    4730,  4731,    -1,    -1,    -1,  4735,    -1,    -1,    -1,    -1,
      -1,  4741,    -1,    -1,  4744,  4745,    -1,    -1,    -1,  4749,
    4750,    -1,    -1,    -1,    -1,  4755,  4756,  4757,  4758,  4759,
      -1,    -1,    -1,  4763,  4764,  4765,    -1,  4767,  4768,    -1,
      -1,  4771,    -1,    -1,    -1,  4775,    -1,    -1,    -1,  4779,
      -1,   440,    -1,    -1,    -1,  4785,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4803,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4812,    -1,    -1,    -1,  4816,    -1,    -1,  3248,
      -1,  4821,    -1,    80,    -1,    -1,    83,    -1,    -1,    -1,
      87,    88,    89,    -1,    -1,    -1,  3265,    -1,    -1,    -1,
      -1,  4841,    -1,    -1,  4844,    -1,    -1,   104,    -1,    -1,
      -1,  3280,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,  4864,  4865,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   540,    -1,  4883,   543,   544,   545,   144,   547,   548,
     549,   550,   551,   552,    -1,    -1,    -1,    -1,  4898,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4948,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4973,    -1,    -1,    -1,    -1,    -1,   236,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4988,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   255,    -1,
      -1,    -1,    -1,   260,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5022,    -1,    -1,   282,   283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5038,    -1,
     297,    -1,    -1,    -1,  5044,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5053,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5068,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,
      -1,  5081,    -1,  5083,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   350,  3523,    -1,   353,  3526,    -1,  3528,
      -1,    -1,    -1,    -1,  3533,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5118,    -1,
      -1,  5121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    80,    -1,    -1,    83,    -1,    -1,
      -1,    87,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3582,    -1,    -1,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,
    5170,    -1,  3601,   119,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   440,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3626,   144,  5199,
    5200,    -1,    -1,  5203,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5218,    -1,
      -1,  5221,    -1,    -1,    -1,  5225,    -1,    -1,    -1,   889,
    5230,    -1,    -1,  5233,  5234,    -1,  5236,   897,  5238,    -1,
    5240,  5241,    -1,    -1,    -1,    -1,   906,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   914,    -1,    -1,   917,    -1,    -1,
      -1,    -1,  5262,    -1,  5264,    -1,    -1,  3696,    -1,  3698,
      -1,    -1,    -1,    -1,    -1,    -1,  5276,  5277,  5278,    -1,
    5280,    -1,    -1,   540,    -1,    -1,   543,   544,   545,    -1,
     547,   548,   549,   550,   551,   552,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,   255,
      -1,    83,    -1,    -1,   260,    87,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5329,
    5330,    -1,   104,    -1,    -1,    -1,   282,   283,    -1,    -1,
     112,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,
      -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,  1018,    -1,
    3789,    -1,    -1,  1023,    -1,    -1,    -1,  1027,    -1,    -1,
      -1,    -1,   144,  5373,  1034,    -1,  5376,  1037,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5388,  1049,
     336,  5391,    -1,    -1,    -1,    -1,  5396,    -1,  5398,    -1,
      -1,  3830,    -1,    -1,   350,  5405,    -1,   353,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5422,    -1,    -1,    -1,  5426,    -1,    -1,  5429,
    3859,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5440,  5441,  5442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5471,    -1,    -1,  5474,    -1,  5476,    -1,    -1,    -1,
      -1,    -1,    -1,   255,    -1,    -1,    -1,    -1,   260,    -1,
      -1,    -1,    -1,    -1,   440,  5495,  1156,  1157,    -1,  3928,
      -1,  5501,    -1,  1163,    -1,  5505,    -1,  1167,    -1,  5509,
     282,   283,    -1,    -1,    -1,  5515,    -1,    -1,    -1,    -1,
    3949,    -1,    -1,    -1,  5524,   297,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1193,    -1,    -1,  3965,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5549,
      -1,  5551,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   336,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5577,   350,    -1,
      -1,   353,  5582,  5583,    -1,    -1,    -1,  5587,  5588,  5589,
    5590,    -1,    -1,    -1,   540,    -1,    -1,   543,   544,   545,
      -1,   547,   548,   549,   550,   551,   552,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5620,    -1,    -1,    -1,    -1,    -1,    -1,  5627,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4070,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5649,
      -1,    -1,  5652,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4093,    -1,    -1,    -1,   440,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1339,
    1340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4118,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     472,    -1,    -1,  1363,  1364,  1365,    -1,    -1,    -1,    -1,
    5710,    -1,  1372,  5713,    -1,    -1,  5716,    -1,    -1,  1379,
    5720,    -1,    -1,  1383,    -1,  4154,    -1,  5727,    -1,  1389,
      -1,  5731,  1392,  5733,    -1,  5735,    -1,    -1,    -1,    -1,
      -1,    -1,  5742,    -1,  1404,    -1,    -1,    -1,    -1,    -1,
    5750,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1419,
      -1,  5761,    -1,    -1,    -1,    -1,    -1,    -1,   540,    -1,
      -1,   543,   544,   545,    -1,   547,   548,   549,   550,   551,
     552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5796,  5797,    -1,    -1,
      -1,    -1,    -1,  1463,  1464,  1465,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5827,    -1,    -1,
      -1,    -1,    -1,    -1,  5834,    -1,    -1,    -1,  5838,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4275,    -1,  5848,  1509,
      80,    -1,    -1,    83,    -1,    -1,    -1,    87,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5871,    -1,    -1,   104,    -1,    -1,   107,  5878,  5879,
    5880,    -1,   112,    -1,  5884,    -1,    -1,  5887,    -1,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5897,    -1,    -1,
    5900,    -1,    -1,    -1,    -1,  5905,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,  5919,
      -1,    -1,    -1,    80,    -1,    -1,    83,    -1,  1588,    -1,
      87,    88,    89,    -1,  5934,    -1,    -1,    -1,    -1,    -1,
      -1,  5941,    -1,    -1,    -1,  4374,    -1,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    -1,    -1,  5967,    -1,    -1,
    4399,    -1,  5972,    -1,    -1,    -1,    -1,    -1,  5978,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1646,   144,  5988,    -1,
      -1,    -1,    -1,    -1,  5994,  5995,    -1,  5997,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6007,    -1,    -1,
      -1,  6011,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1679,
      -1,    -1,    -1,    -1,    -1,   255,    -1,    -1,    -1,    -1,
     260,    -1,  6032,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1709,
      -1,    -1,   282,   283,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6064,  6065,  6066,   297,    -1,    -1,
    6070,    -1,    -1,    -1,    -1,    -1,    -1,  1737,  1738,  1739,
      -1,  1741,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6097,   255,    -1,
      -1,  1761,  6102,   260,  4533,    -1,   336,    -1,  6108,    -1,
      -1,    -1,    -1,  6113,    -1,    -1,    -1,    -1,    -1,    -1,
     350,    -1,    -1,   353,    -1,   282,   283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     297,    -1,    -1,  6143,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6153,  4583,    92,  4585,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6168,    -1,
      -1,  6171,   109,    -1,    -1,    -1,    -1,    -1,    -1,   336,
    6180,    -1,    -1,  1843,  6184,    -1,    -1,  1847,  1848,    -1,
      -1,    -1,    -1,   350,    -1,   132,   353,    -1,    -1,    -1,
      -1,    -1,  1862,    -1,    -1,    -1,  6206,  6207,   145,    -1,
     440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   156,
      -1,    -1,    -1,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   178,    -1,    -1,    -1,    -1,    -1,   184,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1932,    -1,    -1,   212,    -1,    -1,  1938,    -1,
      -1,    -1,    -1,   440,   221,    -1,    -1,    -1,  1948,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,  4726,    -1,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,  4736,   245,    -1,
     540,    -1,    -1,   543,   544,   545,    -1,   547,   548,   549,
     550,   551,   552,    -1,    -1,    -1,    -1,   264,    -1,  1989,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1999,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   310,    -1,    -1,  2036,    -1,    -1,    -1,
      -1,    -1,    -1,   540,    -1,  2045,   543,   544,   545,    -1,
     547,   548,   549,   550,   551,   552,    -1,    -1,    -1,    -1,
      -1,    -1,  2062,    -1,    -1,    -1,    -1,    -1,    -1,  2069,
      -1,    -1,    -1,   350,    -1,    -1,   353,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4862,    -1,    -1,   373,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     387,    -1,    -1,    -1,    -1,    -1,    -1,   394,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4903,    -1,   413,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   422,    -1,  2147,  2148,  2149,
      -1,    -1,   429,    -1,    -1,   432,  4925,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2168,    -1,
      -1,    -1,    -1,    -1,   451,    -1,    -1,    -1,    -1,    -1,
      -1,   458,    -1,    -1,    -1,  2185,    -1,   464,    -1,    -1,
     467,   468,    -1,   470,   471,    -1,    -1,    -1,  2198,    -1,
      -1,    -1,    -1,  2203,   481,    -1,    -1,    -1,    -1,   486,
      -1,    -1,    -1,    -1,    -1,    -1,   493,    -1,    -1,   496,
      -1,    -1,   499,    -1,  4993,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   512,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1023,    -1,    -1,    -1,    -1,  2259,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2272,    -1,    -1,  2275,    -1,    -1,  2278,    -1,
    1049,    -1,    -1,    -1,    -1,  2285,    -1,    -1,    -1,    -1,
      -1,  2291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2303,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2316,  2317,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2331,    -1,    -1,  2334,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2343,  2344,    -1,    -1,  5116,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5174,    -1,    -1,    -1,    -1,
      -1,    -1,  2412,    -1,    -1,  2415,  2416,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2453,  2454,    -1,    -1,    -1,    -1,  2459,
    2460,    -1,    -1,    -1,    -1,    -1,  2466,  2467,  2468,    -1,
      -1,  2471,    -1,  2473,    -1,  2475,  2476,  2477,  2478,  2479,
    2480,    -1,  2482,    -1,  2484,  2485,    -1,    -1,  2488,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2502,  2503,  2504,  2505,  2506,  2507,    -1,    -1,
      -1,  2511,    -1,    -1,    92,  2515,    -1,    -1,  2518,    97,
      -1,  2521,  2522,  2523,  2524,  2525,  2526,  2527,  2528,  2529,
      -1,  2531,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2539,
      -1,    -1,  2542,    -1,    -1,    -1,    -1,    -1,    -1,  5318,
      -1,    -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,
      -1,    97,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1363,    -1,    -1,    -1,    -1,    -1,
     178,    -1,    -1,  2603,    -1,    -1,    -1,    -1,    -1,    -1,
    1379,    -1,    -1,    -1,    -1,    -1,   132,    -1,  2618,    -1,
      -1,    -1,    -1,   201,    -1,    -1,    -1,  2627,  2628,   145,
     146,    -1,    -1,    -1,   212,  1404,    -1,    -1,    -1,    -1,
     156,    -1,    -1,   221,   160,    -1,    -1,    -1,    -1,    -1,
    1419,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,
     238,    -1,   178,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5444,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   264,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   212,    -1,    -1,    -1,
      -1,    -1,    -1,  5472,    -1,   221,    -1,    -1,    -1,  2709,
      -1,    -1,    -1,  2713,  2714,    -1,    -1,   233,    -1,    -1,
      -1,    -1,   238,    -1,    -1,  2725,    -1,    -1,    -1,    -1,
      -1,    -1,   310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1509,    -1,  5511,    -1,    -1,    -1,    -1,    -1,   264,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2759,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2771,   350,   289,    -1,  2775,    -1,    -1,  2778,    -1,
      -1,  2781,  2782,    -1,    -1,   363,    -1,    -1,    -1,  2789,
      -1,    -1,    -1,    -1,   310,   373,    -1,    -1,  5567,    -1,
      -1,    -1,    -1,  5572,  5573,   383,   384,    -1,    -1,   387,
      -1,    -1,    -1,    -1,  2814,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2830,    -1,    -1,    -1,   350,   413,    -1,    -1,   416,    -1,
      -1,    -1,   420,    -1,   422,    -1,    -1,    -1,    -1,    -1,
      -1,   429,  2852,    -1,   432,    -1,  2856,   373,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   383,   384,    -1,
      -1,   387,    -1,   451,    -1,    -1,    -1,  1646,    -1,  2879,
     458,    -1,    -1,    -1,    -1,    -1,   464,    -1,    -1,   467,
      -1,    -1,    -1,   471,    -1,  2895,    -1,   413,    -1,    -1,
     416,   479,    -1,   481,   420,    -1,   422,    -1,   486,    -1,
      -1,    -1,    -1,   429,    -1,    -1,   432,    -1,    -1,    -1,
    5689,   499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   512,   451,    -1,    -1,    -1,    -1,
    2940,    -1,   458,    -1,    -1,    -1,    -1,    -1,   464,    -1,
      -1,   467,    -1,    -1,    -1,   471,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   479,    -1,   481,    -1,    -1,  2968,    -1,
     486,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2992,  2993,  2994,    -1,   512,    -1,  2998,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3030,  3031,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3040,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3074,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3113,   160,    -1,  3116,    -1,    -1,    -1,
      -1,    -1,  5891,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   178,    -1,  3134,    -1,    -1,    -1,   184,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1932,    -1,    -1,   212,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,
      -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,   245,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1999,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   289,    -1,    -1,    -1,    -1,  3248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3262,    -1,   310,  3265,    -1,  2036,  3268,    -1,
      -1,  3271,    -1,    -1,  3274,    -1,    -1,    -1,    -1,    -1,
    3280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3290,    -1,    -1,    -1,    -1,  3295,    -1,    -1,    -1,    -1,
    2069,    -1,    -1,    -1,   350,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3319,
    3320,  3321,    -1,    -1,  3324,    -1,    -1,   373,    -1,    -1,
      -1,    -1,  3332,  3333,  3334,  3335,    -1,   383,   384,    -1,
    3340,   387,    -1,    -1,    -1,  3345,  3346,    -1,  3348,    -1,
    3350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3361,  3362,    -1,    -1,  3365,    -1,   413,    -1,    -1,
     416,    -1,    -1,    -1,   420,    -1,   422,    -1,  2147,  2148,
    2149,    -1,    -1,   429,    -1,  3385,   432,  3387,    -1,  3389,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2168,
      -1,    -1,    -1,    -1,    -1,   451,    -1,    -1,    -1,  3409,
      -1,    -1,   458,    -1,    -1,    -1,  2185,   463,   464,    -1,
    3420,   467,    -1,    -1,    -1,   471,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2203,   481,    -1,    -1,    -1,    -1,
     486,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3452,   499,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   512,  3467,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2291,  3523,    -1,    -1,  3526,    -1,  3528,    -1,
      -1,    -1,    -1,  3533,  2303,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3554,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2343,  2344,    -1,    -1,    -1,    -1,
      -1,    -1,  3582,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3626,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3662,  3663,  3664,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3696,    -1,  3698,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2502,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2542,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3789,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3816,    -1,    -1,    -1,
      -1,    -1,  3822,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3858,  3859,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3904,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3928,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2709,    -1,    -1,    -1,  2713,  2714,    -1,    -1,    -1,  3949,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3965,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2775,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2789,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2830,    -1,    -1,    -1,    -1,    -1,  4067,    -1,    -1,
    4070,    -1,    -1,    -1,    -1,    -1,  4076,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4084,    -1,  4086,    -1,    -1,  4089,
      -1,    -1,    -1,  4093,  4094,  4095,  4096,  4097,    -1,    -1,
    4100,  4101,  4102,  4103,  4104,  4105,  4106,  4107,  4108,  4109,
      -1,    -1,    -1,  4113,  4114,   133,    -1,    -1,  4118,    -1,
      -1,    -1,    -1,  4123,    -1,    -1,    -1,  4127,    -1,  4129,
      -1,  4131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4139,
      -1,    -1,  4142,    -1,  4144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4154,    -1,  4156,    -1,    -1,  4159,
    4160,    -1,    -1,    -1,  4164,  4165,    -1,    -1,    -1,    -1,
      -1,  4171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4181,    -1,    -1,  4184,    -1,    -1,   205,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   213,  4196,   215,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2994,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4243,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4259,
      -1,    -1,  3031,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4287,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3113,    -1,    -1,  3116,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4368,    -1,
      -1,    -1,    -1,  4373,  4374,  4375,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4398,  4399,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4418,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3248,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4504,    -1,    -1,    -1,    -1,    -1,
      -1,  3280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4533,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4546,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4583,    -1,  4585,  4586,  4587,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1023,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1049,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4670,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4682,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4712,    -1,    -1,  4715,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4723,  4724,    -1,  4726,    -1,    -1,    -1,
    4730,  4731,    -1,    -1,    -1,  4735,  4736,    -1,    -1,    -1,
      -1,  4741,    -1,    -1,  4744,  4745,    -1,    -1,    -1,  4749,
      -1,    -1,    -1,    -1,  3523,  4755,    -1,  3526,    -1,  3528,
      -1,    -1,    -1,    -1,  3533,    -1,    -1,  4767,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4775,    -1,    -1,    -1,  4779,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4812,  3582,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4844,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3626,    -1,    -1,
      -1,    -1,  4862,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   897,
      -1,    -1,    -1,    -1,    -1,  4885,    -1,    -1,   906,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   914,    -1,    -1,   917,
      -1,    -1,    -1,  4903,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4925,    -1,  3696,    -1,  3698,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4948,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1379,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4993,    -1,    -1,    -1,    -1,    -1,    -1,
    1018,    -1,  1404,    -1,    -1,  1023,    -1,    -1,    -1,  1027,
      -1,    -1,    -1,    -1,    -1,    -1,  1034,  1419,    -1,  1037,
    3789,    -1,  5022,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1049,    -1,    -1,    -1,    -1,    -1,    -1,  5038,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3816,    -1,    -1,
      -1,    -1,    -1,  3822,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3830,    -1,    -1,    -1,    -1,    -1,    -1,  5068,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3859,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1509,    -1,    -1,
      -1,    -1,    -1,    -1,  5114,    -1,  5116,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1156,  1157,
      -1,    -1,    -1,    -1,    -1,  1163,    -1,    -1,    -1,  1167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3928,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5170,    -1,    -1,    -1,  5174,  1193,    -1,    -1,    -1,    -1,
    3949,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3965,    -1,    -1,  5199,
    5200,    -1,    -1,  5203,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5218,    -1,
      -1,    -1,    -1,    -1,    -1,  5225,    -1,    -1,    -1,    -1,
    5230,    -1,    -1,  5233,  5234,    -1,    -1,    -1,    -1,    -1,
    5240,  5241,    -1,    -1,  1646,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5262,    -1,  5264,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5276,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4070,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5318,    -1,
      -1,  1339,  1340,    -1,  4093,    -1,    -1,    -1,    -1,  5329,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1363,  1364,    -1,    -1,  4118,
      -1,    -1,    -1,    -1,  1372,    -1,    -1,    -1,    -1,    -1,
      -1,  1379,    -1,    -1,    -1,  1383,    -1,    -1,  5368,    -1,
      -1,  1389,    -1,  5373,  1392,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4154,  1404,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5442,    -1,  5444,  1463,  1464,  1465,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5471,  5472,    -1,  5474,    -1,  5476,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1509,    -1,    -1,    -1,  5495,    -1,    -1,    -1,    -1,
      -1,  5501,    -1,    -1,    -1,  5505,  4275,    -1,    -1,    -1,
      -1,  5511,    -1,    -1,    -1,  5515,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1932,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5558,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5567,    -1,    -1,
    1588,    -1,  5572,  5573,    -1,    -1,    -1,  5577,    -1,    -1,
      -1,    -1,  5582,  5583,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1999,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4374,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5620,    -1,    -1,    -1,    -1,    -1,    -1,  5627,  1646,    -1,
    4399,    -1,    -1,    -1,  2036,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5652,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1679,    -1,    -1,    -1,    -1,    -1,  2069,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5688,  5689,
      -1,  1709,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5710,    -1,    -1,  5713,    -1,    -1,  5716,    -1,    -1,  1737,
    1738,  1739,    -1,  1741,    -1,    -1,    -1,  5727,    -1,    -1,
      -1,  5731,    -1,  5733,    -1,  5735,    -1,    -1,    -1,    -1,
      -1,    -1,  5742,  1761,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5761,    -1,    -1,  4533,    -1,  2168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2185,    -1,    -1,  5786,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4583,    -1,  4585,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1843,    -1,    -1,    -1,  1847,
    1848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5838,    -1,
      -1,    -1,    -1,    -1,  1862,    -1,    -1,    -1,  5848,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2259,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2278,    -1,  5878,  5879,
    5880,    -1,    -1,    -1,    -1,    -1,    -1,  5887,  5888,  2291,
      -1,  5891,    -1,    -1,    -1,    -1,    -1,  5897,    -1,    -1,
      -1,  2303,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1932,    -1,    -1,    -1,    -1,  5919,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2343,  2344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4726,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4736,    -1,    -1,
      -1,  1989,  5972,    -1,    -1,    -1,    -1,    -1,  5978,    -1,
      -1,  1999,    -1,    -1,    -1,    -1,    -1,    -1,  5988,    -1,
      -1,    -1,    -1,    -1,  5994,  5995,    -1,  5997,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6007,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2036,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2045,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2062,    -1,    -1,    -1,    -1,    -1,
      -1,  2069,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6064,    -1,    -1,    -1,    -1,    -1,
    6070,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4862,    -1,    -1,    -1,  6097,    -1,    -1,
    2502,    -1,  6102,    -1,    -1,    -1,    -1,    -1,  6108,    -1,
      -1,    -1,    -1,  6113,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6122,    -1,    -1,    -1,    -1,    -1,    -1,  2147,
    2148,  2149,    -1,    -1,  4903,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6143,    -1,    -1,    -1,    -1,    -1,    -1,
    2168,    -1,    -1,  6153,    -1,    -1,  4925,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2185,    -1,    -1,
      -1,  6171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6184,  2203,  6186,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6204,    -1,  6206,  6207,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4993,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2272,    -1,    -1,  2275,    -1,    -1,
    2278,    -1,    -1,    -1,    -1,    -1,    -1,  2285,    -1,    -1,
      -1,    -1,    -1,  2291,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2303,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2316,  2317,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2709,    -1,    -1,
      -1,  2713,  2714,  2331,    -1,    -1,  2334,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2343,  2344,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5114,    -1,  5116,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2775,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2789,    -1,    -1,
      -1,    -1,    -1,    -1,  2412,    -1,    -1,  2415,  2416,    -1,
      -1,    -1,    -1,    -1,    -1,  5174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2830,    -1,
      -1,    -1,    -1,    -1,    -1,  2453,  2454,    -1,    -1,    -1,
      -1,  2459,  2460,    -1,    -1,    -1,    -1,    -1,  2466,  2467,
    2468,    -1,    -1,  2471,    -1,  2473,    -1,  2475,  2476,  2477,
    2478,  2479,  2480,    -1,  2482,    -1,  2484,  2485,    -1,    -1,
    2488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2502,  2503,  2504,  2505,  2506,    -1,
      -1,    -1,    -1,  2511,    -1,    -1,    -1,  2515,    -1,    -1,
    2518,    -1,    -1,  2521,  2522,  2523,  2524,  2525,  2526,  2527,
    2528,  2529,    -1,  2531,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2539,    -1,    -1,  2542,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5318,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2603,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2618,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2627,
    2628,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3031,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5444,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2709,    -1,    -1,    -1,  2713,  2714,    -1,    -1,    -1,
      -1,    -1,    -1,  5472,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3113,    -1,    -1,  3116,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2759,  5511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2771,    -1,    -1,    -1,  2775,    -1,    -1,
    2778,    -1,    -1,  2781,  2782,    -1,    -1,    -1,    -1,    -1,
      -1,  2789,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2814,    -1,  5567,    -1,
      -1,    -1,    -1,  5572,  5573,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2895,  3280,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5688,
    5689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2992,  2993,  2994,    -1,    -1,    -1,
    2998,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3030,  3031,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3074,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3113,    -1,    -1,  3116,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3134,    -1,    -1,    -1,
      -1,  3523,  5891,    -1,  3526,    -1,  3528,    -1,    -1,    -1,
      -1,  3533,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3582,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3601,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3626,    -1,    -1,    -1,    -1,    -1,
    3248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3262,    -1,    -1,  3265,    -1,    -1,
    3268,    -1,    -1,  3271,    -1,    -1,  3274,    -1,    -1,    -1,
      -1,    -1,  3280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3290,    -1,    -1,    -1,    -1,  3295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3696,    -1,  3698,    -1,    -1,    -1,
      -1,  3319,  3320,  3321,    -1,    -1,  3324,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3332,  3333,  3334,  3335,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3345,    -1,    -1,
    3348,    -1,  3350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3361,  3362,    -1,    -1,  3365,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3385,    -1,  3387,
      -1,  3389,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3789,    -1,    -1,
      -1,  3409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3420,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3830,    -1,
      -1,    -1,    -1,    -1,  3452,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3467,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3859,    -1,    -1,
      -1,    -1,    -1,  3481,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3523,    -1,    -1,  3526,    -1,
    3528,    -1,    -1,    -1,    -1,  3533,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3928,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3554,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3949,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1023,  3965,  3582,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3601,    -1,    -1,    -1,    -1,  1049,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3626,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4070,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3696,    -1,
    3698,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4093,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3789,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3816,    -1,
      -1,    -1,    -1,    -1,  3822,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3859,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1023,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1049,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3928,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1379,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3949,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1404,    -1,    -1,    -1,  3965,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1419,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4399,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1509,  4067,
      -1,    -1,  4070,    -1,    -1,    -1,    -1,    -1,  4076,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4084,    -1,  4086,    -1,
      -1,  4089,    -1,    -1,    -1,  4093,  4094,  4095,  4096,  4097,
      -1,    -1,  4100,  4101,  4102,  4103,  4104,  4105,  4106,  4107,
    4108,  4109,    -1,    -1,    -1,  4113,  4114,    -1,    -1,    -1,
    4118,    -1,    -1,    -1,    -1,  4123,    -1,    -1,    -1,  4127,
      -1,    -1,    -1,  4131,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4139,    -1,    -1,  4142,    -1,  4144,    -1,    -1,    -1,
      -1,  4533,    -1,    -1,    -1,    -1,  4154,    -1,  4156,    -1,
      -1,  4159,  4160,    -1,    -1,    -1,  4164,  4165,    -1,    -1,
      -1,    -1,    -1,  4171,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4181,    -1,    -1,  4184,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4196,    -1,
      -1,  4583,    -1,  4585,    -1,  1646,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4243,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1404,    -1,    -1,    -1,
      -1,  4259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1419,    -1,    -1,    -1,    -1,    -1,  4275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4726,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4736,    -1,    -1,    -1,    -1,    -1,
      -1,  1509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4374,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4862,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1932,    -1,    -1,    -1,    -1,    -1,    -1,  1646,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4504,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4903,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4533,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4925,    -1,    -1,    -1,    -1,  4546,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1999,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4583,    -1,  4585,  4586,  4587,
      -1,    -1,    -1,    -1,    -1,  2036,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4993,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2069,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4670,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   897,    -1,  4682,    -1,    -1,    -1,    -1,    -1,
      -1,   906,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   914,
      -1,    -1,   917,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4712,    -1,    -1,  4715,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4723,  4724,  2168,  4726,    -1,
      -1,    -1,  4730,  4731,  5116,    -1,    -1,  4735,  4736,    -1,
      -1,    -1,    -1,  4741,  2185,    -1,  4744,  4745,    -1,    -1,
      -1,  4749,    -1,    -1,    -1,    -1,    -1,  4755,    -1,    -1,
      -1,    -1,  2203,    -1,    -1,    -1,    -1,    -1,    -1,  4767,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4775,    -1,    -1,
      -1,  4779,    -1,    -1,  1932,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1018,    -1,    -1,    -1,    -1,  1023,    -1,
      -1,    -1,  1027,    -1,  4812,    -1,    -1,    -1,  2259,  1034,
      -1,    -1,  1037,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1049,    -1,    -1,  2278,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4844,    -1,    -1,    -1,
    2291,  1999,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2303,    -1,  4862,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2036,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2343,  2344,    -1,  4903,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2069,    -1,    -1,    -1,    -1,    -1,  4925,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5318,    -1,    -1,    -1,
      -1,  1156,  1157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4993,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2168,    -1,    -1,    -1,  5022,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2185,    -1,    -1,
    5038,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2203,    -1,    -1,    -1,    -1,
      -1,  2502,  5444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5068,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2259,    -1,    -1,    -1,    -1,  5114,    -1,  5116,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5511,
    2278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2291,    -1,    -1,    -1,    -1,  1363,  1364,
      -1,    -1,    -1,    -1,    -1,  2303,    -1,  1372,    -1,    -1,
      -1,    -1,    -1,    -1,  1379,    -1,    -1,    -1,  1383,    -1,
      -1,    -1,  5170,    -1,  1389,    -1,  5174,  1392,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5567,    -1,    -1,    -1,  1404,
    5572,  5573,    -1,    -1,    -1,  2343,  2344,    -1,    -1,    -1,
      -1,  5199,  5200,    -1,  1419,  5203,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5218,    -1,    -1,    -1,    -1,    -1,    -1,  5225,    -1,    -1,
      -1,    -1,  5230,    -1,    -1,  5233,  5234,    -1,    -1,    -1,
      -1,    -1,  5240,  5241,    -1,    -1,    -1,    -1,  1463,  1464,
    1465,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5262,    -1,  5264,    -1,  2709,    -1,
      -1,    -1,  2713,  2714,    -1,    -1,    -1,    -1,  5276,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1509,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5689,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5329,    -1,    -1,  2775,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2789,    -1,
      -1,    -1,    -1,    -1,  2502,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1588,    -1,  5373,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2830,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5442,    -1,  5444,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1679,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5471,  5472,    -1,  5474,    -1,  5476,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1709,    -1,    -1,  5495,    -1,    -1,
      -1,    -1,    -1,  5501,    -1,    -1,    -1,  5505,    -1,  5891,
      -1,    -1,    -1,  5511,    -1,    -1,    -1,  5515,    -1,    -1,
      -1,    -1,  1737,  1738,  1739,    -1,  1741,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1761,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2709,    -1,    -1,    -1,  2713,  2714,    -1,    -1,  5567,
      -1,    -1,    -1,    -1,  5572,  5573,    -1,    -1,    -1,  5577,
      -1,    -1,    -1,    -1,  5582,  5583,    -1,    -1,    -1,    -1,
    3031,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5620,    -1,    -1,    -1,    -1,  2775,  1843,  5627,
      -1,    -1,  1847,  1848,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2789,    -1,    -1,    -1,    -1,    -1,  1862,    -1,    -1,
      -1,    -1,    -1,    -1,  5652,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3113,    -1,    -1,  3116,    -1,    -1,    -1,    -1,
      -1,    -1,  2830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5688,  5689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5710,    -1,    -1,  5713,    -1,  1932,  5716,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5727,
      -1,    -1,    -1,  5731,    -1,  5733,    -1,  5735,    -1,    -1,
      -1,    -1,    -1,    -1,  5742,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5761,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1999,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3248,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2036,    -1,    -1,  3265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3280,
    5838,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5848,    -1,    -1,    -1,  2069,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5878,  5879,  5880,  3031,    -1,    -1,    -1,    -1,    -1,  5887,
      -1,    -1,    -1,  5891,    -1,    -1,    -1,    -1,    -1,  5897,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5919,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2147,  2148,  2149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3113,    -1,    -1,  3116,    -1,
    2185,    -1,    -1,    -1,  5972,    -1,    -1,    -1,    -1,    -1,
    5978,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2203,    -1,
    5988,    -1,    -1,    -1,    -1,    -1,  5994,  5995,    -1,  5997,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6007,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2259,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2272,    -1,    -1,
    2275,    -1,    -1,  2278,    -1,    -1,  6064,    -1,    -1,    -1,
    2285,    -1,  6070,    -1,    -1,    -1,  2291,    -1,    -1,    -1,
      -1,    -1,  3523,    -1,    -1,  3526,    -1,  3528,  2303,    -1,
      -1,    -1,  3533,    -1,    -1,    -1,    -1,    -1,    -1,  6097,
    3248,  2316,  2317,    -1,  6102,    -1,    -1,    -1,    -1,    -1,
    6108,    -1,    -1,    -1,    -1,  6113,  2331,  3265,    -1,  2334,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2343,  2344,
      -1,    -1,  3280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3582,    -1,    -1,    -1,  6143,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6153,    -1,    -1,    -1,    -1,
    3601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6171,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3626,  6184,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2412,    -1,    -1,
    2415,  2416,    -1,    -1,    -1,    -1,    -1,    -1,  6206,  6207,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2453,  2454,
      -1,    -1,    -1,    -1,  2459,  2460,    -1,    -1,    -1,    -1,
      -1,  2466,  2467,  2468,    -1,  3696,  2471,  3698,  2473,    -1,
    2475,  2476,  2477,  2478,  2479,  2480,    -1,  2482,    -1,  2484,
    2485,    -1,    -1,  2488,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2502,  2503,  2504,
    2505,  2506,    -1,    -1,    -1,    -1,  2511,    -1,    -1,    -1,
    2515,    -1,    -1,  2518,    -1,    -1,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,  2528,  2529,    -1,  2531,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2539,    -1,    -1,  2542,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3789,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3523,    -1,    -1,  3526,    -1,
    3528,    -1,    -1,    -1,    -1,  3533,    -1,    -1,  2603,  3830,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2618,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2627,  2628,    -1,    -1,    -1,    -1,  3859,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3582,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3601,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3626,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3928,    -1,    -1,
      -1,    -1,    -1,    -1,  2709,    -1,    -1,    -1,  2713,  2714,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3949,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3965,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2759,    -1,    -1,    -1,  3696,    -1,
    3698,    -1,    -1,    -1,    -1,    -1,  2771,    -1,    -1,    -1,
    2775,    -1,    -1,  2778,    -1,    -1,  2781,  2782,    -1,    -1,
      -1,    -1,    -1,    -1,  2789,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2830,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4070,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3789,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4093,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4118,    -1,    -1,
      -1,    -1,  3830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3859,    -1,  4154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2992,  2993,  2994,
    3928,    -1,    -1,  2998,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3949,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3030,  3031,  3965,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3074,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3113,    -1,
      -1,  3116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3134,
      -1,    -1,  4070,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4374,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4093,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4399,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4154,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3248,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3262,    -1,    -1,
    3265,    -1,    -1,  3268,    -1,    -1,  3271,    -1,    -1,  3274,
      -1,    -1,    -1,    -1,    -1,  3280,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3290,    -1,    -1,    -1,    -1,
    3295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4533,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3319,  3320,  3321,    -1,    -1,  3324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3332,  3333,  3334,
    3335,    -1,    -1,    -1,    -1,    -1,    -1,  4275,    -1,    -1,
    3345,    -1,    -1,  3348,    -1,  3350,    -1,    -1,    -1,    -1,
      -1,    -1,  4583,    -1,  4585,    -1,  3361,  3362,    -1,    -1,
    3365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3385,    -1,  3387,    -1,  3389,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3420,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4374,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3452,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4399,  3467,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3481,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4726,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4736,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3523,    -1,
      -1,  3526,    -1,  3528,    -1,    -1,    -1,    -1,  3533,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3554,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3582,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4533,  3601,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   199,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3626,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4862,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4583,   234,  4585,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4903,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3696,    -1,  3698,  4925,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4993,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3789,    -1,    -1,    -1,  4726,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4736,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3816,    -1,    -1,    -1,    -1,    -1,  3822,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3830,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3859,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5116,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3928,  4862,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5174,  3949,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3965,    -1,    -1,    -1,    -1,  4903,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4925,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4993,    -1,    -1,    -1,    -1,
      -1,    -1,  4067,    -1,    -1,  4070,    -1,    -1,    -1,    -1,
      -1,  4076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4084,
      -1,  4086,    -1,    -1,  4089,    -1,    -1,  5318,  4093,  4094,
    4095,  4096,  4097,    -1,    -1,  4100,  4101,  4102,  4103,  4104,
    4105,  4106,  4107,  4108,  4109,    -1,    -1,    -1,  4113,  4114,
      -1,    -1,    -1,  4118,    -1,    -1,    -1,    -1,  4123,    -1,
      -1,    -1,  4127,    -1,    -1,    -1,  4131,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4139,    -1,    -1,  4142,    -1,  4144,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   735,   736,  4154,
      -1,  4156,    -1,    -1,  4159,  4160,    -1,    -1,    -1,  4164,
    4165,    -1,    -1,    -1,    -1,    -1,  4171,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4181,    -1,  5116,  4184,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4196,    -1,    -1,    -1,   783,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5444,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5174,    -1,  4243,    -1,
      -1,  5472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4259,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5511,    -1,  4287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   904,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   912,    -1,    -1,   915,    -1,    -1,
     918,   919,    -1,   921,    -1,   923,  5567,    -1,   926,    -1,
     928,  5572,  5573,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4374,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   965,    -1,    -1,
    5318,    -1,    -1,    -1,   972,   973,    -1,    -1,   976,    -1,
     978,   979,    -1,    -1,  4399,   983,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1000,    -1,  1002,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1043,    -1,  1045,  5689,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1054,  1055,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1064,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4504,
      -1,    -1,    -1,    -1,    -1,    -1,  5444,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4533,    -1,
      -1,    -1,    -1,    -1,  5472,  1023,    -1,    -1,    -1,    -1,
      -1,  4546,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1049,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1159,    -1,  5511,    -1,    -1,    -1,    -1,  4583,    -1,
    4585,  4586,  4587,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5567,
      -1,    -1,    -1,    -1,  5572,  5573,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5891,    -1,    -1,    -1,    -1,  4670,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4682,    -1,    -1,
    1268,    -1,    -1,  1271,    -1,  1273,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1288,    -1,    -1,    -1,    -1,    -1,    -1,  4712,    -1,    -1,
    4715,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4723,  4724,
      -1,  4726,    -1,    -1,    -1,  4730,  4731,    -1,    -1,    -1,
    4735,  4736,    -1,    -1,    -1,    -1,  4741,    -1,    -1,  4744,
    4745,    -1,    -1,    -1,  4749,    -1,    -1,    -1,    -1,    -1,
    4755,  5689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4767,    -1,    -1,    -1,  1354,    -1,    -1,    -1,
    4775,    -1,    -1,    -1,  4779,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1376,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1388,    -1,    -1,    -1,    -1,  1393,    -1,  4812,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1403,    -1,    -1,    -1,    -1,
    1408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1417,
      -1,    -1,    -1,    -1,  1422,    -1,    -1,  1425,    -1,  4844,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4862,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1466,    -1,
      -1,    -1,    83,    -1,    -1,    -1,    -1,    88,    -1,    90,
      -1,  1379,    -1,    -1,    -1,    -1,    -1,    -1,  4903,   100,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1404,    -1,    -1,    -1,
    4925,    -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,    -1,
      -1,  1419,    -1,    -1,    -1,   136,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4948,    -1,    -1,   147,   148,    -1,    -1,
     151,    -1,    -1,  5891,    -1,    -1,   157,    -1,    -1,    -1,
     161,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   183,    -1,    -1,    -1,    -1,    -1,  4993,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   199,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5022,    -1,    -1,
      -1,  1509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5038,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1635,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5068,    -1,    -1,    -1,  1655,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5114,
      -1,  5116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1646,    -1,
      -1,    -1,    -1,    -1,    -1,  5170,    -1,    -1,    -1,  5174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5199,  5200,    -1,    -1,  5203,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5218,    -1,    -1,    -1,    -1,    -1,    -1,
    5225,    -1,    -1,    -1,    -1,  5230,   427,    -1,  5233,  5234,
      -1,    -1,    -1,    -1,    -1,  5240,  5241,    -1,    -1,    -1,
      -1,  1829,  1830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5262,    -1,  5264,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1892,    -1,    -1,  1895,    -1,    -1,
      -1,    -1,    -1,  5318,    -1,  1903,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5329,    -1,    -1,    -1,    -1,    -1,
      -1,  1919,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5373,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1156,  1157,    -1,    -1,    -1,  1973,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5442,    -1,  5444,
      -1,    -1,    -1,    -1,  1932,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2041,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5471,  5472,    -1,  5474,
      -1,  5476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   686,    -1,    -1,    -1,    -1,
    5495,    -1,    -1,    -1,    -1,    -1,  5501,    -1,    -1,    -1,
    5505,    -1,    -1,    -1,    -1,    -1,  5511,    -1,    -1,    -1,
    5515,  1999,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   735,   736,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2036,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5567,    -1,    -1,    -1,    -1,  5572,  5573,    -1,
      -1,    -1,  5577,    -1,    -1,    -1,    -1,  5582,  5583,    -1,
      -1,  2069,   783,    -1,    -1,    -1,    -1,  1363,  1364,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5620,    -1,    -1,    -1,  2207,
      -1,    -1,  5627,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5652,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2168,    -1,    -1,  5688,  5689,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2185,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5710,    -1,    -1,  5713,    -1,
      -1,  5716,    -1,    -1,    -1,  2203,    -1,    -1,    -1,    -1,
      -1,    -1,  5727,    -1,    -1,    -1,  5731,    -1,  5733,    -1,
    5735,    -1,    -1,    -1,    -1,    -1,    -1,  5742,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2336,    -1,
    2338,    -1,    -1,    -1,    -1,    -1,  5761,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2354,  2355,    -1,  2357,
      -1,  2259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2278,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   999,  1000,
      -1,  1002,    -1,  2291,    -1,    -1,    -1,    -1,    -1,  2397,
      -1,    -1,    -1,    -1,    -1,  2303,    -1,    -1,    -1,    -1,
      -1,  2409,    -1,    -1,    -1,  2413,    -1,    -1,    -1,  2417,
      -1,    -1,  2420,  5838,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5848,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2343,  2344,    -1,    -1,  1060,
      -1,    -1,  1063,  1064,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5878,  5879,  5880,    -1,  1078,    -1,  1080,
      -1,  1082,  5887,    -1,    -1,    -1,  5891,  1088,    -1,    -1,
      -1,  1092,  5897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1679,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1112,  1113,    -1,  5919,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1023,
      -1,    -1,    -1,  1709,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1049,    -1,  2545,  1159,    -1,
    1161,  1737,  1738,  1739,    -1,  1741,    -1,  5972,    -1,    -1,
      -1,    -1,    -1,  5978,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5988,    -1,  1761,    -1,    -1,    -1,  5994,
    5995,    -1,  5997,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6007,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2502,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1240,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1254,  1255,    -1,    -1,  1258,    -1,  6064,
      -1,    -1,    -1,    -1,    -1,  6070,    -1,  1843,    -1,    -1,
      -1,  1847,  1848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6097,    -1,    -1,    -1,    -1,  6102,    -1,    -1,
    1301,    -1,  2690,  6108,    -1,    -1,    -1,    -1,  6113,    -1,
      -1,    -1,    -1,    -1,    -1,  2703,  2704,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2722,  2723,    -1,    -1,  6143,  2727,
    2728,    -1,    -1,    -1,  2732,    -1,    -1,    -1,  6153,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2746,    -1,
      -1,    -1,    -1,    -1,    -1,  2753,  6171,    -1,    -1,  2757,
    2758,    -1,    -1,  2761,  2762,    -1,    -1,    -1,    -1,  6184,
    2768,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2783,    -1,  2785,    -1,    -1,
      -1,  6206,  6207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2803,    -1,    -1,    -1,    -1,
    2808,  2709,    -1,    -1,    -1,  2713,  2714,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2823,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2832,    -1,    -1,  2835,    -1,  2837,
    2838,  2839,    -1,    -1,    -1,    -1,  2844,  2845,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2854,    -1,    -1,    -1,
      -1,  2859,    -1,    -1,    -1,  2863,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1379,    -1,  2775,    -1,    -1,
    2878,    -1,    -1,    -1,    -1,    -1,  2884,  2885,    -1,    -1,
      -1,  2789,    -1,  2891,    -1,    -1,    -1,    -1,    -1,    -1,
    1404,    -1,    -1,  2901,  2902,    -1,    -1,    -1,    -1,  2907,
      -1,    -1,    -1,    -1,    -1,  1419,    -1,    -1,    -1,    -1,
      -1,  2919,    -1,    -1,  2922,    -1,    -1,    -1,    -1,  2927,
      -1,    -1,  2830,    -1,    -1,  2933,  2934,    -1,    -1,    -1,
      -1,  2939,    -1,    -1,  2942,    -1,    -1,    -1,  2946,  2947,
    2948,  2949,    -1,  2951,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2147,  2148,  2149,    -1,    -1,  2964,  2965,    -1,  2967,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2978,  2979,  2980,    -1,    -1,  1596,    -1,    -1,    -1,    -1,
    1601,    -1,  1603,    -1,    -1,  1606,    -1,  1608,    -1,    -1,
    1611,  1612,  1613,    -1,    -1,  1509,  1617,    -1,    -1,    -1,
      -1,    -1,    -1,  1624,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1638,    -1,  1640,
      -1,    -1,    -1,    -1,  1645,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3041,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3069,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3031,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1784,  1785,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1801,    -1,    -1,    -1,    -1,  1806,  1807,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3206,    -1,
      -1,  1822,    -1,    -1,    -1,  3113,    -1,    -1,  3116,    -1,
      -1,    -1,    -1,  3221,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2459,    -1,    -1,  1887,    -1,  1889,    -1,
      -1,    -1,    -1,    -1,    -1,  2471,  3284,  2473,  1899,  2475,
      -1,    -1,  2478,  2479,  2480,    -1,    -1,    -1,    -1,  2485,
      -1,    -1,  2488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2503,  2504,  2505,
    2506,    -1,    -1,    -1,    -1,  2511,    -1,    -1,    -1,  2515,
      -1,    -1,  2518,    -1,    -1,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,  2528,  2529,    -1,  2531,    -1,    -1,    -1,    -1,
    3248,    -1,    -1,  2539,    -1,    -1,  2542,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1977,  3265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1987,    -1,    -1,    -1,
      -1,    -1,  3280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2603,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1932,    -1,
      -1,    -1,    -1,   908,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2627,  2628,    -1,    -1,   920,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   931,    -1,    -1,  2070,
      -1,    -1,  2073,  2074,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   949,    -1,    -1,    -1,    -1,    -1,
     955,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1999,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2036,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3551,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2175,  2069,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2759,    -1,    -1,    -1,    -1,  3576,    -1,
      -1,    -1,  3580,    -1,    -1,    -1,    -1,    -1,  3586,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3604,  3605,    -1,    -1,
      -1,  3609,    -1,    -1,    -1,    -1,  3614,  3615,  3616,    -1,
      -1,    -1,    -1,    -1,    -1,  3523,    -1,    -1,  3526,    -1,
    3528,    -1,    -1,    -1,    -1,  3533,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3650,  3651,  3652,  3653,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2185,    -1,    -1,  3582,    -1,    -1,  1162,    -1,  3687,
      -1,  3689,  3690,  3691,    -1,    -1,    -1,    -1,    -1,  2203,
      -1,    -1,    -1,  3601,    -1,    -1,  1181,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3626,  1204,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2259,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2381,    -1,  2383,    -1,  2278,    -1,  2387,    -1,  2389,    -1,
      -1,  2392,    -1,    -1,    -1,  2396,    -1,  2291,    -1,    -1,
    2401,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3696,  2303,
    3698,    -1,    -1,    -1,    -1,  3803,  2992,  2993,  2994,    -1,
      -1,    -1,  2998,    -1,  3812,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1302,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2343,
    2344,    -1,    -1,    -1,  3030,  3843,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3866,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3789,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3918,    -1,    -1,    -1,    -1,  3923,    -1,  2538,    -1,    -1,
      -1,    -1,  3830,    -1,  2545,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2555,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1429,    -1,    -1,    -1,    -1,  3957,
      -1,  3859,    -1,    -1,    -1,  3963,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1457,  1458,  1459,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2502,    -1,
    3998,    -1,  4000,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4018,    -1,    -1,    -1,  1023,    -1,    -1,    -1,    -1,    -1,
    3928,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4043,    -1,    -1,    -1,    -1,
    1049,  3949,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2675,    -1,    -1,  3965,  2679,    -1,
      -1,    -1,    -1,    -1,  2685,    -1,  2687,    -1,    -1,  2690,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3290,    -1,    -1,    -1,    -1,  3295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2738,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3321,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3332,    -1,  3334,  3335,
      -1,    -1,    -1,    -1,    -1,    -1,  1631,    -1,    -1,  3345,
      -1,    -1,  3348,    -1,  3350,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4070,    -1,    -1,    -1,    -1,    -1,    -1,  1654,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1663,    -1,
      -1,    -1,    -1,    -1,    -1,  4093,    -1,    -1,    -1,  3385,
      -1,  3387,    -1,  3389,    -1,  2709,    -1,    -1,    -1,  2713,
    2714,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4154,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3452,    -1,    -1,    -1,
      -1,  2775,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3467,    -1,    -1,    -1,  2789,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4294,    -1,  4296,    -1,
      -1,  2912,    -1,    -1,    -1,  4303,    -1,    -1,    -1,  2920,
      -1,    -1,  2923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4319,    -1,    -1,  2935,    -1,  2830,    -1,    -1,    -1,
      -1,    -1,    -1,  4331,    -1,    -1,    -1,  4335,  1813,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4353,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3554,    -1,
      -1,    -1,    -1,  4371,    -1,    -1,    -1,  4275,  4376,    -1,
    1379,    -1,    -1,    -1,  1859,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4401,    -1,  1404,    -1,  4405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4413,  4414,  4415,  4416,    -1,
    1419,    -1,    -1,    -1,  4422,  4423,  4424,  4425,    -1,    -1,
      -1,  4429,  4430,    -1,    -1,    -1,    -1,  4435,  4436,    -1,
    4438,  4439,  4440,  4441,  4442,  4443,  4444,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4454,    -1,    -1,    -1,
    4458,  4459,  4460,  4461,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4374,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4484,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1753,    -1,    -1,
      -1,  4399,    -1,    -1,    -1,  4503,    -1,    -1,    -1,    -1,
    1509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3031,    -1,    -1,
    2005,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2014,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2042,    -1,    -1,
    1826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2065,    -1,    -1,  2068,    -1,  3206,  3207,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4603,    -1,    -1,    -1,  3113,
      -1,    -1,  3116,  3224,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3816,    -1,    -1,    -1,    -1,  4533,  3822,    -1,  4636,  4637,
    4638,  4639,  4640,    -1,    -1,    -1,  2121,  1646,    -1,    -1,
      -1,  4649,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4583,    -1,  4585,    -1,    -1,
    2165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2216,    -1,    -1,  3248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2245,    -1,    -1,    -1,    -1,    -1,  3280,  2252,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3429,    -1,
      -1,    -1,    -1,  3434,    -1,    -1,    -1,    -1,  4726,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4736,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4870,    -1,    -1,    -1,  4874,  4875,  4876,  4877,
      -1,  4067,    -1,  4881,    -1,    -1,    -1,    -1,    -1,    -1,
    4076,    -1,    -1,    -1,  2369,    -1,    -1,  2153,  4084,    -1,
    4086,  2157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4915,  4916,  4917,
    4918,  4919,    -1,  4921,  4922,    -1,    -1,  4113,  4114,    -1,
      -1,    -1,    -1,  1932,    -1,  4933,  4934,    -1,    -1,    -1,
      -1,    -1,    -1,  2418,  2419,  4131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4139,    -1,    -1,  4142,    -1,  4144,    -1,
      -1,    -1,    -1,  2438,  4862,  4963,    -1,    -1,    -1,    -1,
    4156,    -1,    -1,  4971,  4972,    -1,  4974,    -1,  4164,  4165,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1999,    -1,    -1,    -1,    -1,  4903,    -1,    -1,    -1,    -1,
    4196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3523,
      -1,    -1,  3526,    -1,  3528,    -1,    -1,  4925,    -1,  3533,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2036,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4243,    -1,    -1,
      -1,    -1,    -1,  2538,    -1,    -1,    -1,    -1,    -1,  5067,
    2069,    -1,    -1,  4259,    -1,    -1,    -1,    -1,  3582,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2564,
      -1,    -1,    -1,    -1,    -1,  4993,    -1,  3601,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2596,  3626,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2607,  2608,    -1,    -1,    -1,    -1,    -1,  5137,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2641,    -1,    -1,  2168,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2185,    -1,    -1,    -1,
      -1,    -1,  3696,    -1,  3698,    -1,    -1,    -1,    -1,    -1,
      -1,  2457,    -1,    -1,  2203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2472,    -1,  5116,    -1,
    2476,    -1,    -1,    -1,    -1,  5223,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2490,  2491,  2492,    -1,    -1,  2495,
    5238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3859,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5174,    -1,    -1,  2278,
      -1,  2537,    -1,    -1,    -1,  3789,    -1,    -1,    -1,    -1,
      -1,    -1,  2291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2303,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5320,    -1,    -1,    -1,  3830,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5339,    -1,    -1,  2343,  2344,  5344,  5345,    -1,    -1,
      -1,    -1,  3963,    -1,    -1,  3859,  5354,    -1,  2614,  2834,
      -1,    -1,    -1,  5361,    -1,    -1,    -1,    -1,    -1,    -1,
    2626,    -1,    -1,    -1,  2849,  2631,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2868,    -1,    -1,    -1,    -1,    -1,  5397,
    4586,  4587,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5417,
    5318,  5419,    -1,    -1,  3928,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5434,    -1,    -1,    -1,
      -1,    -1,    -1,  4054,    -1,  3949,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5454,    -1,    -1,    -1,
      -1,  3965,    -1,    -1,    -1,    -1,    -1,  5465,    -1,  2944,
    2945,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4670,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4682,    -1,    -1,    -1,
    5498,    -1,    -1,  2502,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5533,    -1,  4723,  4724,    -1,
      -1,    -1,    -1,    -1,  4730,  4731,  5444,    -1,    -1,  4735,
      -1,    -1,    -1,    -1,    -1,  4741,  5554,    -1,  4744,  4745,
      -1,    -1,    -1,  4749,    -1,    -1,  4070,    -1,  5566,  4755,
      -1,    -1,    -1,    -1,  5472,    -1,  3051,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4093,
      -1,    -1,    -1,  5591,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5511,  4118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4812,    -1,    -1,    -1,
      -1,    -1,    -1,  5631,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4154,    -1,    -1,  4264,    -1,    -1,    -1,    -1,  4844,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5567,
      -1,    -1,    -1,    -1,  5572,  5573,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5696,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2709,    -1,    -1,    -1,  2713,  2714,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5724,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5758,    -1,  4948,  4374,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4275,    -1,    -1,    -1,  5773,  2775,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4399,    -1,
    2789,  5689,    -1,    -1,    -1,  4406,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4417,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5817,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2830,    -1,    -1,  5832,    -1,  5022,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4399,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5918,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3413,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5962,    -1,    -1,    -1,    -1,  3444,
      -1,    -1,  4583,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5891,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5199,  5200,    -1,    -1,  5203,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4533,
      -1,  4642,  3031,    -1,    -1,    -1,    -1,  3293,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6051,  5240,  5241,    -1,  3313,  3314,    -1,
    3316,    -1,    -1,  3319,  3320,    -1,  3322,    -1,  3324,    -1,
      -1,    -1,  3328,    -1,    -1,  3331,    -1,    -1,  5264,  4583,
    3336,  4585,    -1,    -1,    -1,    -1,  3342,    -1,    -1,    -1,
      -1,  3347,    -1,    -1,    -1,    -1,    -1,    -1,  3354,  3355,
    3356,  3357,    -1,    -1,    -1,  3361,  3362,    -1,  3364,    -1,
      -1,    -1,    -1,    -1,  3113,    -1,    -1,  3116,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3382,    -1,  3384,    -1,
      -1,    -1,    -1,    -1,    -1,  3391,  3392,  3393,  3394,  3395,
    3396,  3397,  3398,  3399,  3400,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4799,  3445,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4726,    -1,    -1,    -1,    -1,    -1,    -1,  3704,
      -1,    -1,  4736,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3248,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4887,    -1,    -1,    -1,
      -1,  3280,  4893,    -1,    -1,    -1,  4897,    -1,  5474,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3569,    -1,  5501,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5515,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4862,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5577,    -1,    -1,    -1,    -1,  3871,  3872,  3873,  4903,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3888,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4925,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5620,    -1,  3911,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3921,  3922,    -1,    -1,
      -1,  3926,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4993,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3523,    -1,    -1,  3526,    -1,  3528,
      -1,    -1,    -1,    -1,  3533,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5735,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3820,  3821,    -1,  4042,    -1,  3825,
    4045,    -1,    -1,    -1,    -1,  5761,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3582,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3854,    -1,
      -1,    -1,  3601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3626,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5255,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5838,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5878,  5879,  5880,    -1,    -1,  3696,    -1,  3698,
      -1,    -1,    -1,  4178,  4179,  4180,    -1,  5318,    -1,    -1,
      -1,  5897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3789,    -1,  5978,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5419,    -1,
    4066,  5997,    -1,    -1,  5318,    -1,  4072,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3830,    -1,    -1,  4090,  4091,    -1,    -1,  4094,  4095,
    4096,  4097,    -1,    -1,  4100,  4101,  4102,  4103,  4104,  4105,
    4106,  4107,  4108,  4109,  4110,    -1,    -1,    -1,    -1,    -1,
    3859,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4132,    -1,    -1,  4135,
      -1,  4137,    -1,    -1,  4140,  4141,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4158,  4159,  4160,  4161,    -1,  4163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6108,    -1,    -1,    -1,    -1,    -1,    -1,  3928,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3949,    -1,    -1,    -1,    -1,    -1,    -1,  6143,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3965,  6153,  5472,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5598,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5511,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4500,    -1,    -1,  4284,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4511,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5567,    -1,    -1,    -1,  4542,  5572,  5573,
      -1,  4070,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5699,    -1,
      -1,    -1,    -1,    -1,  4093,    -1,    -1,    -1,    -1,    -1,
    4575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4118,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4154,    -1,    -1,    -1,  4634,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5689,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4504,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4275,    -1,    -1,    -1,
      -1,  4756,  4757,  4758,  4759,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4374,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5891,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4671,    -1,    -1,    -1,  4675,
      -1,  4677,  4678,    -1,    -1,    -1,    -1,    -1,  4684,  4685,
    4686,  4687,    -1,    -1,    -1,    -1,  4692,  4693,  4694,  4695,
    4696,  4697,  4698,  4699,  4700,  4701,  4702,  4703,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4729,    -1,    -1,  4732,    -1,  4734,    -1,
      -1,    -1,    -1,  4739,    -1,    -1,  4742,  4743,    -1,    -1,
    4746,  4747,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4533,    -1,    -1,  4793,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4811,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4824,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4583,    -1,  4585,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5118,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4726,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4736,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5025,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5111,  5112,    -1,    -1,    -1,
      -1,    -1,    -1,  4862,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5376,    -1,    -1,  4903,    -1,    -1,  5163,    -1,    -1,
      -1,    -1,    -1,  5169,  5170,    -1,  5391,    -1,    -1,    -1,
      -1,  5396,    -1,    -1,    -1,    -1,  4925,    -1,    -1,    -1,
      -1,  5187,    -1,  5189,    -1,    -1,    -1,  5193,  5194,  5195,
      -1,    -1,  5198,    -1,    -1,  5201,  5202,  5422,    -1,    -1,
    5206,    -1,    -1,    -1,  5210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4993,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5274,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     6,     7,    -1,     9,    10,    11,
      -1,    -1,    -1,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    -1,    -1,    -1,    30,    31,
      32,    33,    -1,    35,    36,    37,    38,    -1,    40,    41,
      42,    -1,    -1,    -1,  5549,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,  5340,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    -1,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5116,    -1,    -1,
      -1,    -1,  5378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   115,    -1,    -1,    -1,   119,   120,   121,
     122,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   136,    -1,    -1,    -1,    -1,    -1,
      -1,   143,    -1,   145,  5649,  5174,    -1,    -1,    -1,    -1,
     152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   164,    -1,    -1,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   181,
     182,    -1,    -1,    -1,  5470,  5471,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5485,
    5486,  5487,    -1,    -1,    -1,    -1,    -1,    -1,   210,  5495,
      -1,    -1,    -1,    -1,    -1,    -1,   218,    -1,    -1,    -1,
      -1,   223,    -1,    -1,    -1,    -1,    -1,   229,    -1,    -1,
      -1,    -1,    -1,   235,    -1,   237,  5522,  5523,    -1,    -1,
      -1,    -1,   244,    -1,   246,    -1,    -1,    -1,    -1,    -1,
      -1,  5537,    -1,   255,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   270,   271,
      -1,    -1,    -1,    -1,    -1,   277,    -1,   279,    -1,    -1,
     282,   283,    -1,   285,    -1,    -1,    -1,    -1,    -1,  5318,
      -1,    -1,   294,   295,    -1,   297,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,
     322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   330,   331,
      -1,    -1,    -1,    -1,   336,    -1,    -1,   339,    -1,   341,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   357,   358,    -1,   360,   361,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   374,    -1,   376,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   391,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     412,    -1,    -1,    -1,    -1,  5444,   418,  5703,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5716,    -1,    -1,  5719,    -1,   437,    -1,  5723,   440,    -1,
      -1,   443,    -1,  5472,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   459,    -1,    -1,
      -1,    -1,    -1,    -1,   466,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   474,   475,    -1,    -1,    -1,    -1,   480,    -1,
     482,    -1,  5511,    -1,    -1,    -1,  5772,    -1,    -1,    -1,
     492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   507,    -1,    -1,   510,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5809,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    -1,    -1,    -1,  5567,    -1,
      -1,    -1,    -1,  5572,  5573,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   563,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5885,
      -1,  5887,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5917,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5971,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6000,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6062,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6097,    -1,    -1,    -1,    -1,  6102,    -1,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,  5891,  6149,    48,    49,  6152,    -1,  6154,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,  6181,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,    -1,     3,    -1,    -1,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,   562,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    35,
      36,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,    -1,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,   115,
      -1,    -1,   118,   119,   120,   121,   122,   123,    -1,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     136,    -1,    -1,   139,    -1,   141,   142,   143,    -1,   145,
      -1,    -1,   148,    -1,   150,    -1,   152,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   161,    -1,   163,   164,    -1,
      -1,    -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,    -1,
      -1,    -1,   178,    -1,   180,   181,   182,   183,    -1,    -1,
      -1,    -1,    -1,   189,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   197,    -1,   199,    -1,    -1,    -1,   203,    -1,    -1,
      -1,    -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,
      -1,   217,   218,   219,    -1,    -1,    -1,   223,    -1,    -1,
     226,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,   235,
      -1,   237,    -1,    -1,    -1,    -1,   242,    -1,   244,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   255,
      -1,    -1,    -1,   259,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   270,   271,    -1,    -1,   274,    -1,
      -1,   277,    -1,   279,    -1,    -1,   282,   283,    -1,   285,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   294,   295,
      -1,   297,    -1,   299,   300,    -1,    -1,    -1,    -1,   305,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   317,    -1,    -1,   320,   321,   322,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   330,   331,    -1,    -1,    -1,   335,
     336,    -1,    -1,   339,    -1,   341,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   357,   358,    -1,   360,   361,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,    -1,
     376,    -1,   378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   391,   392,    -1,    -1,    -1,
      -1,    -1,   398,   399,    -1,   401,    -1,    -1,    -1,    -1,
     406,    -1,    -1,    -1,    -1,   411,   412,    -1,   414,    -1,
      -1,    -1,   418,    -1,    -1,   421,    -1,    -1,    -1,    -1,
      -1,   427,   428,    -1,    -1,    -1,    -1,    -1,    -1,   435,
      -1,   437,    -1,   439,   440,    -1,    -1,   443,    -1,    -1,
      -1,    -1,    -1,   449,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   459,    -1,    -1,    -1,    -1,   464,    -1,
     466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,
      -1,    -1,    -1,    -1,   480,    -1,   482,    -1,   484,    -1,
     486,    -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,   495,
      -1,    -1,   498,    -1,    -1,   501,    -1,    -1,    -1,    -1,
     506,   507,    -1,    -1,   510,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   519,    -1,    -1,    -1,    -1,    -1,    -1,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,    -1,    -1,    -1,    -1,   542,    -1,    -1,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    10,    11,    12,
     556,    14,    15,    -1,   560,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    -1,    65,    -1,    67,    68,    69,    70,    -1,    -1,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,    -1,
      -1,    -1,    -1,   106,    -1,    -1,   109,   110,    -1,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,    -1,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,    -1,   139,   140,   141,   142,
     143,    -1,   145,    -1,   147,   148,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,   161,   162,
      -1,   164,   165,   166,    -1,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,    -1,   187,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,   198,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
      -1,   234,   235,    -1,   237,   238,   239,   240,   241,    -1,
     243,   244,    -1,   246,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,    -1,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,    -1,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,    -1,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,    -1,    -1,   350,   351,   352,
      -1,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,    -1,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,    -1,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,    -1,
     473,   474,   475,    -1,    -1,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,   499,    -1,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,    -1,    -1,
      -1,    -1,    -1,    -1,   547,   548,   549,    -1,    -1,    -1,
      -1,    -1,    -1,   556,   557,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      70,    -1,    -1,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,   106,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,    -1,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,   499,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,    -1,    -1,   517,    -1,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,    -1,   542,    -1,    -1,    -1,    -1,   547,   548,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   556,   557,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    70,    -1,    -1,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,   106,
      -1,    -1,   109,   110,    -1,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,   143,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
      -1,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,   244,    -1,   246,
     247,   248,    -1,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,    -1,   293,   294,   295,   296,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,    -1,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,   493,   494,   495,   496,
     497,   498,   499,    -1,   501,   502,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,    -1,    -1,    -1,    -1,    -1,    -1,
     547,   548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   556,
     557,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    70,    -1,    -1,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,   106,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,    -1,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,   499,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
      -1,    -1,    -1,   547,   548,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   556,   557,     5,     6,     7,     8,     9,    10,
      11,    12,    -1,    14,    15,    -1,    -1,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,    70,
      -1,    -1,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,   106,    -1,    -1,   109,   110,
      -1,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,    -1,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,    -1,   139,   140,
     141,   142,   143,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,    -1,   164,   165,   166,    -1,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,    -1,   187,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,    -1,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,    -1,   246,   247,   248,    -1,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,    -1,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,    -1,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
      -1,    -1,   293,   294,   295,   296,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,    -1,    -1,   350,
     351,   352,    -1,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,    -1,    -1,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,   499,    -1,
     501,   502,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
      -1,    -1,    -1,    -1,    -1,    -1,   547,   548,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   556,   557,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,    -1,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,    -1,
      -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,    -1,    -1,    -1,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,    -1,   295,   296,   297,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,    -1,   332,    -1,   334,   335,   336,   337,
      -1,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,    -1,   375,    -1,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,    -1,   481,    -1,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,    -1,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   537,
     538,   539,    -1,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,   557,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,    -1,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,    -1,
      -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
      -1,   219,   220,   221,   222,    -1,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,    -1,    -1,    -1,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,    -1,   295,   296,   297,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,    -1,   332,    -1,   334,   335,   336,   337,
      -1,    -1,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,    -1,   375,    -1,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,    -1,   481,    -1,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,    -1,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   537,
     538,   539,    -1,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,   557,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    70,    -1,    -1,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,   106,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,    -1,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,   499,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,    -1,   542,    -1,    -1,    -1,    -1,   547,
     548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   556,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    70,    -1,    -1,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
     106,    -1,    -1,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,    -1,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,    -1,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,   493,   494,   495,
     496,   497,   498,   499,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,    -1,    -1,    -1,    -1,    -1,
      -1,   547,   548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     556,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    70,    -1,    -1,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,   106,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,    -1,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,   499,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
      -1,    -1,    -1,   547,   548,    -1,    -1,    -1,    -1,    -1,
     554,   555,   556,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    70,    -1,
      -1,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,   106,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,   499,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,    -1,
      -1,    -1,    -1,    -1,    -1,   547,   548,   549,    -1,    -1,
      -1,    -1,    -1,    -1,   556,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      70,    -1,    -1,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,    -1,    -1,    -1,   106,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,    -1,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,   499,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,    -1,    -1,    -1,   547,   548,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   556,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    70,    -1,    -1,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,   106,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,    -1,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,   499,    -1,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,    -1,    -1,    -1,   547,
     548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   556,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    70,    -1,    -1,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
     106,    -1,    -1,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,    -1,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,    -1,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,   493,   494,   495,
     496,   497,   498,   499,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,    -1,    -1,    -1,    -1,    -1,
      -1,   547,   548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     556,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    70,    -1,    -1,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,   106,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,   499,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
      -1,    -1,    -1,   547,   548,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   556,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    70,    -1,
      -1,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,   106,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,   499,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,    -1,
      -1,    -1,    -1,    -1,    -1,   547,   548,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   556,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      70,    -1,    -1,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,   106,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,   499,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,    -1,    -1,    -1,   547,   548,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   556,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    70,    -1,    -1,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,   106,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,    -1,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,   499,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,    -1,    -1,    -1,   547,
     548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   556,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    70,    -1,    -1,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
     106,    -1,    -1,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,    -1,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,    -1,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,   493,   494,   495,
     496,   497,   498,   499,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,    -1,    -1,    -1,    -1,    -1,
      -1,   547,   548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     556,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    70,    -1,    -1,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,   106,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,    -1,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,   499,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,    -1,    -1,    -1,
      -1,    -1,    -1,   547,   548,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   556,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    70,    -1,
      -1,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,   106,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,   499,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,    -1,
      -1,    -1,    -1,    -1,    -1,   547,   548,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   556,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      70,    -1,    -1,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,   106,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,    -1,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,   499,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,    -1,    -1,    -1,    -1,    -1,    -1,   547,   548,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   556,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    70,    -1,    -1,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,   106,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,   499,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,    -1,    -1,    -1,    -1,    -1,    -1,   547,
     548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   556,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    70,    -1,    -1,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
     106,    -1,    -1,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,    -1,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,    -1,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   547,   548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     556,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    70,    -1,    -1,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,   106,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,    -1,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,   499,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   547,   548,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   556,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    70,    -1,
      -1,    73,    -1,    75,    76,    -1,    78,    79,    -1,    81,
      82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,   106,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   547,   548,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   556,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      70,    -1,    -1,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,   106,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,    -1,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   547,   548,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   556,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    70,    -1,    -1,    73,    -1,    75,    76,    -1,
      78,    79,    -1,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,   106,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,    -1,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,    -1,    -1,    -1,    -1,     5,     6,     7,     8,
       9,    10,    11,    12,    -1,    14,    15,    -1,   556,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,    48,
      49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,
      69,    70,    -1,    -1,    73,    -1,    75,    76,    -1,    78,
      79,    -1,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    91,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,    -1,    -1,    -1,    -1,   106,    -1,    -1,
     109,   110,    -1,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,    -1,
     139,   140,   141,   142,   143,    -1,   145,    -1,   147,   148,
     149,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,    -1,   164,   165,   166,    -1,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,    -1,   185,    -1,   187,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,    -1,   234,   235,    -1,   237,   238,
     239,   240,   241,    -1,   243,   244,    -1,   246,   247,   248,
      -1,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,    -1,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,    -1,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,    -1,
      -1,   350,   351,   352,    -1,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,    -1,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,    -1,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,    -1,    -1,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,    -1,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,    -1,    -1,   517,    -1,
      -1,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,    -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,   556,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      70,    -1,    -1,    73,    -1,    75,    76,    -1,    78,    79,
      -1,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,   106,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,    -1,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
      -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      11,    12,    -1,    14,    15,    -1,   556,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,    70,
      -1,    -1,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,   106,    -1,    -1,   109,   110,
      -1,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
     121,   122,   123,    -1,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,    -1,   139,   140,
     141,   142,   143,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,    -1,   164,   165,   166,    -1,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,    -1,   187,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
      -1,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,    -1,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,    -1,   246,   247,   248,    -1,   250,
     251,   252,   253,   254,    -1,   256,   257,   258,   259,    -1,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,    -1,   279,    -1,
     281,    -1,    -1,   284,   285,   286,   287,   288,   289,   290,
      -1,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,    -1,    -1,   350,
     351,   352,    -1,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,    -1,    -1,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,   499,    -1,
     501,   502,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   547,   548,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   556,     5,     6,     7,     8,
       9,    10,    11,    12,    -1,    14,    15,    -1,    -1,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,    48,
      49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,
      69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    91,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,   110,    -1,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,    -1,
     139,   140,   141,   142,   143,    -1,   145,    -1,   147,   148,
     149,   150,   151,   152,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,    -1,   164,   165,   166,    -1,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,    -1,   185,    -1,   187,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,    -1,   225,    -1,   227,   228,
     229,   230,    -1,   232,    -1,   234,   235,    -1,   237,   238,
     239,   240,   241,    -1,   243,   244,    -1,   246,   247,   248,
      -1,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,    -1,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,    -1,   273,   274,   275,    -1,   277,    -1,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,    -1,
     349,   350,   351,   352,    -1,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,    -1,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,    -1,    -1,   478,
     479,   480,   481,   482,    -1,   484,   485,   486,   487,   488,
     489,   490,   491,    -1,    -1,   494,   495,   496,   497,   498,
     499,    -1,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,    -1,    -1,   517,    -1,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,    -1,    -1,   542,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,   556,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,    -1,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,   349,
     350,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,   499,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
      -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      11,    12,    -1,    14,    15,    -1,   556,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,
      -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
      -1,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,    -1,   125,   126,   127,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,    -1,   139,   140,
     141,   142,   143,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,    -1,   164,   165,   166,    -1,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,    -1,   185,    -1,   187,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,    -1,   225,    -1,   227,   228,   229,   230,
      -1,   232,    -1,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,    -1,   246,   247,   248,    -1,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,    -1,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,    -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
      -1,    -1,   293,   294,   295,   296,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,    -1,    -1,   350,
     351,   352,    -1,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,    -1,    -1,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,   494,   495,   496,   497,   498,   499,    -1,
     501,   502,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,    -1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,   556,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,    -1,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    10,    11,    12,
      -1,    14,    15,    -1,   556,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,    -1,   125,   126,   127,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,    -1,   139,   140,   141,   142,
     143,    -1,   145,    -1,   147,   148,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,   161,   162,
      -1,   164,   165,   166,    -1,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,    -1,   185,    -1,   187,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,    -1,   225,    -1,   227,   228,   229,   230,    -1,   232,
      -1,   234,   235,    -1,   237,   238,   239,   240,   241,    -1,
     243,   244,    -1,   246,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,    -1,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,    -1,
     273,   274,   275,    -1,   277,    -1,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,    -1,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,    -1,    -1,   350,   351,   352,
      -1,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,    -1,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,    -1,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,    -1,
     473,   474,   475,    -1,    -1,   478,   479,   480,   481,   482,
      -1,   484,   485,   486,   487,   488,   489,   490,   491,    -1,
      -1,   494,   495,   496,   497,   498,   499,    -1,   501,   502,
     503,   504,   505,   506,   507,    -1,   509,   510,   511,   512,
     513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,    -1,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,   556,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,    -1,    -1,    -1,    -1,   171,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,    -1,    -1,    -1,    -1,
      -1,     6,     7,     8,     9,    10,    11,    12,    -1,    14,
      15,    -1,   556,    18,    19,    20,    21,    22,    23,    -1,
      25,    26,    27,    -1,    -1,    30,    31,    32,    33,    -1,
      -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,    44,
      -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,
      65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,   107,    -1,   109,   110,    -1,   112,   113,   114,
      -1,   116,   117,   118,   119,   120,    -1,   122,   123,    -1,
     125,   126,   127,   128,   129,   130,    -1,    -1,   133,   134,
     135,   136,   137,    -1,   139,   140,   141,   142,   143,    -1,
      -1,    -1,   147,   148,   149,   150,   151,    -1,   153,   154,
     155,    -1,   157,   158,   159,   160,   161,   162,    -1,   164,
     165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,    -1,
     185,    -1,   187,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,    -1,
     225,    -1,   227,   228,   229,   230,    -1,   232,    -1,   234,
      -1,    -1,   237,   238,   239,   240,   241,    -1,   243,   244,
      -1,   246,   247,   248,    -1,   250,   251,   252,   253,   254,
      -1,   256,   257,   258,   259,    -1,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,    -1,   273,   274,
     275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,
     285,   286,   287,   288,   289,   290,    -1,    -1,   293,   294,
     295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,    -1,   337,    -1,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,
     355,   356,   357,    -1,   359,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,    -1,   429,   430,   431,   432,   433,    -1,
     435,   436,   437,   438,   439,    -1,   441,   442,   443,   444,
      -1,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,    -1,   462,   463,    -1,
     465,    -1,   467,   468,   469,   470,   471,    -1,   473,   474,
     475,    -1,    -1,   478,   479,   480,   481,   482,    -1,   484,
     485,   486,   487,   488,   489,   490,   491,    -1,    -1,   494,
     495,   496,   497,   498,    -1,    -1,   501,   502,   503,   504,
     505,   506,   507,    -1,   509,    -1,   511,   512,   513,   514,
      -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,    -1,    -1,    -1,    -1,    -1,
      -1,     6,     7,     8,     9,    10,    11,    12,    -1,    14,
      15,    -1,   557,    18,    19,    20,    21,    22,    23,    -1,
      25,    26,    27,    -1,    -1,    30,    31,    32,    33,    -1,
      -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,    44,
      -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,
      65,    -1,    67,    68,    69,    70,    -1,    -1,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,
      -1,   116,   117,   118,   119,   120,    -1,   122,   123,    -1,
     125,   126,   127,   128,   129,   130,    -1,    -1,   133,   134,
     135,   136,   137,    -1,   139,   140,   141,   142,   143,    -1,
      -1,    -1,   147,   148,   149,   150,   151,    -1,   153,   154,
     155,    -1,   157,   158,   159,   160,   161,   162,    -1,    -1,
     165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,    -1,
     185,    -1,   187,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,    -1,
     225,    -1,   227,   228,   229,   230,    -1,   232,    -1,   234,
      -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,   244,
      -1,   246,   247,   248,    -1,   250,   251,   252,   253,   254,
      -1,   256,   257,   258,   259,    -1,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,    -1,   271,    -1,   273,   274,
     275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,
      -1,   286,   287,   288,   289,   290,    -1,    -1,   293,   294,
      -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,    -1,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,    -1,   337,    -1,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,
     355,   356,   357,    -1,   359,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
     435,   436,   437,   438,   439,    -1,   441,   442,   443,   444,
      -1,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,    -1,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,    -1,   473,   474,
     475,    -1,    -1,   478,   479,   480,   481,   482,    -1,   484,
     485,   486,   487,   488,   489,   490,   491,    -1,    -1,   494,
     495,   496,   497,   498,    -1,    -1,   501,   502,   503,   504,
     505,   506,   507,    -1,   509,    -1,   511,   512,   513,   514,
      -1,    -1,   517,    -1,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,    -1,    -1,   542,    -1,    -1,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,   556,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,    -1,    -1,   542,    -1,    -1,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
     556,    18,    19,    20,    21,    22,    23,    -1,    25,    26,
      27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,
      37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,    76,
      -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,   116,
     117,   118,   119,   120,    -1,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,
     147,   148,   149,   150,   151,    -1,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,    -1,   165,   166,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,    -1,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,
      -1,   238,   239,   240,   241,    -1,   243,   244,    -1,   246,
     247,   248,    -1,   250,   251,   252,   253,   254,    -1,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,
     287,   288,   289,   290,    -1,    -1,   293,   294,    -1,   296,
      -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,    -1,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,    -1,
     337,    -1,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,
     357,    -1,   359,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,    -1,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,    -1,   462,   463,    -1,   465,    -1,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,   480,   481,   482,    -1,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,   494,   495,   496,
     497,   498,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,    -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,    -1,    -1,    -1,    -1,    -1,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,   555,   556,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    76,    -1,
      -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,    -1,    -1,    -1,    -1,    -1,     6,     7,     8,
       9,    10,    11,    12,    -1,    14,    15,    -1,   556,    18,
      19,    20,    21,    22,    23,    -1,    25,    26,    27,    -1,
      -1,    30,    31,    32,    33,    -1,    -1,    36,    37,    38,
      -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,
      49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,
      69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    91,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,   110,    -1,   112,   113,   114,    -1,   116,   117,   118,
     119,   120,    -1,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,    -1,    -1,   133,   134,   135,   136,   137,    -1,
     139,   140,   141,   142,   143,    -1,    -1,    -1,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,    -1,   157,   158,
     159,   160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,
     179,   180,   181,   182,   183,    -1,   185,    -1,   187,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,    -1,   225,    -1,   227,   228,
     229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,
     239,   240,   241,    -1,   243,   244,    -1,   246,   247,   248,
      -1,   250,   251,   252,   253,   254,    -1,   256,   257,   258,
     259,    -1,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,    -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,
     279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,
     289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,
     299,   300,   301,    -1,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,    -1,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,    -1,   337,    -1,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,    -1,
      -1,   350,   351,   352,    -1,    -1,   355,   356,   357,    -1,
     359,    -1,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,    -1,
     429,   430,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,    -1,   441,   442,   443,   444,    -1,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,    -1,   462,   463,    -1,   465,    -1,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,    -1,    -1,   478,
     479,   480,   481,   482,    -1,   484,   485,   486,   487,   488,
     489,   490,   491,    -1,    -1,   494,   495,   496,   497,   498,
      -1,    -1,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,    -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,
      -1,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,    -1,    -1,    -1,    -1,    -1,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,   556,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
      -1,    -1,    -1,    -1,    -1,     6,     7,     8,     9,    10,
      11,    12,    -1,    14,    15,    -1,   556,    18,    19,    20,
      21,    22,    23,    -1,    25,    26,    27,    -1,    -1,    30,
      31,    32,    33,    -1,    -1,    36,    37,    38,    -1,    40,
      -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,
      -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
      -1,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
      -1,   122,   123,    -1,   125,   126,   127,   128,   129,   130,
      -1,    -1,   133,   134,   135,   136,   137,    -1,   139,   140,
     141,   142,   143,    -1,    -1,    -1,   147,   148,   149,   150,
     151,    -1,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,    -1,   185,    -1,   187,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,    -1,   225,    -1,   227,   228,   229,   230,
      -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,
     241,    -1,   243,   244,    -1,   246,   247,   248,    -1,   250,
     251,   252,   253,   254,    -1,   256,   257,   258,   259,    -1,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,    -1,
     271,    -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,
     281,    -1,    -1,   284,    -1,   286,   287,   288,   289,   290,
      -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,    -1,   337,    -1,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,    -1,    -1,   350,
     351,   352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,   430,
     431,   432,   433,    -1,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,    -1,   465,    -1,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,    -1,    -1,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,
     501,   502,   503,   504,   505,   506,   507,    -1,   509,    -1,
     511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,    -1,
      -1,    -1,    -1,    -1,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,   556,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,    -1,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    10,    11,    12,
      -1,    14,    15,    -1,   556,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    -1,    65,    -1,    67,    68,    69,    70,    -1,    -1,
      73,    -1,    75,    76,    -1,    -1,    -1,    80,    81,    -1,
      -1,    -1,    -1,    -1,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
      -1,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,   222,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,    -1,   245,    -1,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,    -1,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,    -1,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,    -1,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,   487,   488,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,    -1,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   537,   538,   539,    -1,    -1,    -1,
     543,   544,   545,    -1,   547,   548,   549,   550,   551,   552,
       5,     6,     7,     8,     9,    10,    11,    12,    -1,    14,
      15,    -1,    -1,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,
      65,    -1,    67,    68,    69,    70,    -1,    -1,    73,    -1,
      75,    76,    -1,    -1,    -1,    80,    81,    -1,    -1,    -1,
      -1,    -1,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,   222,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,    -1,
     245,    -1,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,    -1,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,    -1,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,    -1,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,   487,   488,   489,   490,   491,    -1,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,    -1,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   537,   538,   539,    -1,    -1,    -1,   543,   544,
     545,    -1,   547,   548,   549,   550,   551,   552,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,    -1,    -1,    -1,   543,   544,   545,    -1,   547,
     548,   549,   550,   551,   552,     6,     7,     8,     9,    10,
      11,    12,    -1,    14,    15,    -1,    -1,    18,    19,    20,
      21,    22,    23,    -1,    25,    26,    27,    -1,    -1,    30,
      31,    32,    33,    -1,    -1,    36,    37,    38,    -1,    40,
      -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,
      -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
      -1,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
      -1,   122,   123,    -1,   125,   126,   127,   128,   129,   130,
      -1,    -1,   133,   134,   135,   136,   137,    -1,   139,   140,
     141,   142,   143,    -1,    -1,    -1,   147,   148,   149,   150,
     151,    -1,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,    -1,   185,    -1,   187,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,    -1,   225,    -1,   227,   228,   229,   230,
      -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,
     241,    -1,   243,   244,    -1,   246,   247,   248,    -1,   250,
     251,   252,   253,   254,    -1,   256,   257,   258,   259,    -1,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,    -1,
     271,    -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,
     281,    -1,    -1,   284,    -1,   286,   287,   288,   289,   290,
      -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,    -1,   337,    -1,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,    -1,    -1,   350,
     351,   352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,   430,
     431,   432,   433,    -1,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,    -1,   465,    -1,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,    -1,    -1,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,
     501,   502,   503,   504,   505,   506,   507,    -1,   509,    -1,
     511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,    -1,
      -1,    -1,   543,   544,   545,    -1,   547,   548,   549,   550,
     551,   552,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,    -1,    -1,    -1,   543,
     544,   545,    -1,   547,   548,   549,   550,   551,   552,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    -1,    25,    26,
      27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,
      37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,   116,
     117,   118,   119,   120,    -1,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,
     147,   148,   149,   150,   151,    -1,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,    -1,   165,   166,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,    -1,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,
      -1,   238,   239,   240,   241,    -1,   243,   244,    -1,   246,
     247,   248,    -1,   250,   251,   252,   253,   254,    -1,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,
     287,   288,   289,   290,    -1,    -1,   293,   294,    -1,   296,
      -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,    -1,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,    -1,
     337,    -1,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,
     357,    -1,   359,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,    -1,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,    -1,   462,   463,    -1,   465,    -1,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,   480,   481,   482,    -1,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,   494,   495,   496,
     497,   498,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,    -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,    -1,    -1,    -1,   543,   544,   545,    -1,
     547,   548,   549,   550,   551,   552,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
      -1,    -1,    -1,   543,   544,   545,    -1,   547,   548,   549,
     550,   551,   552,     6,     7,     8,     9,    10,    11,    12,
      -1,    14,    15,    -1,    -1,    18,    19,    20,    21,    22,
      23,    -1,    25,    26,    27,    -1,    -1,    30,    31,    32,
      33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,
      43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,
     113,   114,    -1,   116,   117,   118,   119,   120,    -1,   122,
     123,    -1,   125,   126,   127,   128,   129,   130,    -1,    -1,
     133,   134,   135,   136,   137,    -1,   139,   140,   141,   142,
     143,    -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,
     153,   154,   155,    -1,   157,   158,   159,   160,   161,   162,
      -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   175,   176,   177,   178,   179,   180,   181,   182,
     183,    -1,   185,    -1,   187,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,    -1,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,    -1,   225,    -1,   227,   228,   229,   230,    -1,   232,
      -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,
     243,   244,    -1,   246,   247,   248,    -1,   250,   251,   252,
     253,   254,    -1,   256,   257,   258,   259,    -1,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,    -1,   271,    -1,
     273,   274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,
      -1,   284,    -1,   286,   287,   288,   289,   290,    -1,    -1,
     293,   294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,    -1,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,    -1,   337,    -1,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,    -1,    -1,   350,   351,   352,
      -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,    -1,   429,   430,   431,   432,
     433,    -1,   435,   436,   437,   438,   439,    -1,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,    -1,   462,
     463,    -1,   465,    -1,   467,   468,   469,   470,   471,    -1,
     473,   474,   475,    -1,    -1,   478,   479,   480,   481,   482,
      -1,   484,   485,   486,   487,   488,   489,   490,   491,    -1,
      -1,   494,   495,   496,   497,   498,    -1,    -1,   501,   502,
     503,   504,   505,   506,   507,    -1,   509,    -1,   511,   512,
     513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,    -1,    -1,    -1,
     543,   544,   545,    -1,   547,   548,   549,   550,   551,   552,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,    -1,    -1,    -1,   543,   544,   545,
      -1,   547,   548,   549,   550,   551,   552,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,    -1,     5,     6,     7,     8,     9,    10,    11,
      12,   549,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,    -1,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,    -1,    -1,    -1,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,    -1,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,    -1,
     332,    -1,   334,   335,   336,   337,    -1,    -1,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,    -1,   375,    -1,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,    -1,   481,
      -1,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   537,   538,   539,    -1,    -1,
       6,     7,     8,     9,    10,    11,    12,   549,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,    -1,    -1,     6,     7,     8,     9,
      10,    11,    12,   549,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
      -1,    -1,     6,     7,     8,     9,    10,    11,    12,   549,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    70,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,   236,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   547,   548,     6,     7,     8,     9,    10,
      11,    12,    -1,    14,    15,    -1,    -1,    18,    19,    20,
      21,    22,    23,    -1,    25,    26,    27,    -1,    -1,    30,
      31,    32,    33,    -1,    -1,    36,    37,    38,    -1,    40,
      -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,    70,
      -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
      -1,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
      -1,   122,   123,    -1,   125,   126,   127,   128,   129,   130,
      -1,    -1,   133,   134,   135,   136,   137,    -1,   139,   140,
     141,   142,   143,    -1,    -1,    -1,   147,   148,   149,   150,
     151,    -1,   153,   154,   155,    -1,   157,   158,   159,   160,
     161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,   180,
     181,   182,   183,    -1,   185,    -1,   187,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,    -1,   225,    -1,   227,   228,   229,   230,
      -1,   232,    -1,   234,    -1,   236,    -1,   238,   239,   240,
     241,    -1,   243,   244,    -1,   246,   247,   248,    -1,   250,
     251,   252,   253,   254,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,    -1,
     271,    -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,
     281,    -1,    -1,   284,    -1,   286,   287,   288,   289,   290,
      -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,    -1,   337,    -1,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,    -1,    -1,   350,
     351,   352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,   430,
     431,   432,   433,    -1,   435,   436,   437,   438,   439,    -1,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,    -1,   465,    -1,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,    -1,    -1,   478,   479,   480,
     481,   482,    -1,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,
     501,   502,   503,   504,   505,   506,   507,    -1,   509,    -1,
     511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   547,   548,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    70,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,   236,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   547,
     548,     6,     7,     8,     9,    10,    11,    12,    -1,    14,
      15,    -1,    -1,    18,    19,    20,    21,    22,    23,    -1,
      25,    26,    27,    -1,    -1,    30,    31,    32,    33,    -1,
      -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,    44,
      -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,
      65,    -1,    67,    68,    69,    70,    -1,    -1,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,
      -1,   116,   117,   118,   119,   120,    -1,   122,   123,    -1,
     125,   126,   127,   128,   129,   130,    -1,    -1,   133,   134,
     135,   136,   137,    -1,   139,   140,   141,   142,   143,    -1,
      -1,    -1,   147,   148,   149,   150,   151,    -1,   153,   154,
     155,    -1,   157,   158,   159,   160,   161,   162,    -1,    -1,
     165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     175,   176,   177,   178,   179,   180,   181,   182,   183,    -1,
     185,    -1,   187,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,    -1,
     225,    -1,   227,   228,   229,   230,    -1,   232,    -1,   234,
      -1,   236,    -1,   238,   239,   240,   241,    -1,   243,   244,
      -1,   246,   247,   248,    -1,   250,   251,   252,   253,   254,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,    -1,   271,    -1,   273,   274,
     275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,
      -1,   286,   287,   288,   289,   290,    -1,    -1,   293,   294,
      -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,    -1,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,    -1,   337,    -1,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,
     355,   356,   357,    -1,   359,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,    -1,   429,   430,   431,   432,   433,    -1,
     435,   436,   437,   438,   439,    -1,   441,   442,   443,   444,
      -1,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,    -1,   462,   463,    -1,
     465,    -1,   467,   468,   469,   470,   471,    -1,   473,   474,
     475,    -1,    -1,   478,   479,   480,   481,   482,    -1,   484,
     485,   486,   487,   488,   489,   490,   491,    -1,    -1,   494,
     495,   496,   497,   498,    -1,    -1,   501,   502,   503,   504,
     505,   506,   507,    -1,   509,    -1,   511,   512,   513,   514,
      -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   547,   548,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    70,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,    -1,    -1,
      -1,    -1,     4,   545,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,   143,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
      -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,    -1,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,   244,    -1,   246,
     247,   248,    -1,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,    -1,   273,   274,   275,    -1,
     277,    -1,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,    -1,   293,   294,   295,   296,
     297,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,    -1,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,   480,   481,   482,    -1,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,   494,   495,   496,
     497,   498,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,   143,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
      -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,    -1,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,   244,    -1,   246,
     247,   248,    -1,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,    -1,   273,   274,   275,    -1,
     277,    -1,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,    -1,   293,   294,   295,   296,
     297,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,    -1,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,   480,   481,   482,    -1,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,   494,   495,   496,
     497,   498,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,   143,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
      -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,    -1,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,   244,    -1,   246,
     247,   248,    -1,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,    -1,   273,   274,   275,    -1,
     277,    -1,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,    -1,   293,   294,   295,   296,
     297,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,    -1,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,   480,   481,   482,    -1,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,   494,   495,   496,
     497,   498,    -1,    -1,   501,   502,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,    -1,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,    -1,    -1,    -1,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,    -1,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,    -1,
     332,    -1,   334,   335,   336,   337,    -1,    -1,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,    -1,   375,    -1,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,    -1,   481,
      -1,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,    -1,   507,   508,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   537,   538,   539,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,    -1,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
      -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,    -1,    -1,    -1,
     247,   248,    -1,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,    -1,   293,    -1,   295,   296,
     297,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,    -1,   332,    -1,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,    -1,   346,
     347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,
      -1,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,    -1,   375,    -1,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,    -1,   481,    -1,    -1,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,   494,   495,   496,
     497,   498,    -1,    -1,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     537,   538,   539,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,    -1,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,    -1,    -1,    -1,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,    -1,
      -1,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,    -1,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,    -1,   334,   335,   336,   337,    -1,    -1,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,    -1,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,    -1,   375,    -1,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,    -1,   481,
      -1,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   537,   538,   539,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,    -1,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
      -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,    -1,    -1,    -1,
     247,   248,    -1,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,    -1,   293,    -1,   295,   296,
     297,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,    -1,   332,    -1,   334,   335,   336,
     337,    -1,    -1,   340,   341,   342,   343,   344,    -1,   346,
     347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,
      -1,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,    -1,   375,    -1,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,    -1,   481,    -1,    -1,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,   494,   495,   496,
     497,   498,    -1,    -1,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     537,   538,   539,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,    -1,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,    -1,    -1,    -1,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,    -1,
      -1,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,    -1,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,    -1,
     332,    -1,   334,   335,   336,   337,    -1,    -1,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,    -1,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,    -1,   375,    -1,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,    -1,   481,
      -1,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   537,   538,   539,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,    -1,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
      -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,    -1,    -1,    -1,
     247,   248,    -1,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,    -1,   293,    -1,   295,   296,
     297,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,    -1,   332,    -1,   334,   335,   336,
     337,    -1,    -1,   340,   341,   342,   343,   344,    -1,   346,
     347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,
      -1,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,    -1,   375,    -1,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,    -1,   481,    -1,    -1,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,   494,   495,   496,
     497,   498,    -1,    -1,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     537,   538,   539,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,    -1,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,    -1,    -1,    -1,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,    -1,
      -1,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,    -1,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,    -1,
     332,    -1,   334,   335,   336,   337,    -1,    -1,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,    -1,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,    -1,   375,    -1,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,    -1,   481,
      -1,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   537,   538,   539,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,    -1,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
      -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,    -1,    -1,    -1,
     247,   248,    -1,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,    -1,   293,    -1,   295,   296,
     297,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,    -1,   332,    -1,   334,   335,   336,
     337,    -1,    -1,   340,   341,   342,   343,   344,    -1,   346,
     347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,
      -1,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,    -1,   375,    -1,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,    -1,   481,    -1,    -1,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,   494,   495,   496,
     497,   498,    -1,    -1,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     537,   538,   539,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,    -1,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,    -1,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,    -1,    -1,    -1,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,    -1,
      -1,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,    -1,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,    -1,
     332,    -1,   334,   335,   336,   337,    -1,    -1,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,    -1,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,    -1,   375,    -1,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,    -1,   481,
      -1,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   537,   538,   539,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,    -1,   139,   140,   141,   142,    -1,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
      -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,
     177,   178,   179,   180,   181,   182,   183,    -1,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,    -1,   219,   220,   221,   222,    -1,    -1,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,    -1,    -1,    -1,
     247,   248,    -1,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,    -1,    -1,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,    -1,   293,    -1,   295,   296,
     297,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,    -1,   332,    -1,   334,   335,   336,
     337,    -1,    -1,   340,   341,   342,   343,   344,    -1,   346,
     347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,
      -1,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,    -1,   375,    -1,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,    -1,   419,   420,   421,   422,   423,   424,   425,   426,
     427,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
      -1,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,    -1,   481,    -1,    -1,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,   494,   495,   496,
     497,   498,    -1,    -1,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     537,   538,   539,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,    -1,    -1,   121,
      -1,    -1,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,    -1,    -1,   137,    -1,   139,   140,   141,
     142,    -1,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,    -1,
      -1,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,    -1,   219,   220,   221,
     222,    -1,    -1,   225,    -1,   227,   228,    -1,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,    -1,    -1,    -1,   247,   248,    -1,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,    -1,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,   329,    -1,    -1,
     332,    -1,   334,   335,   336,   337,    -1,    -1,   340,    -1,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,    -1,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,    -1,   375,    -1,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,    -1,   438,   439,   440,   441,
     442,    -1,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,    -1,    -1,    -1,    -1,   478,   479,    -1,   481,
      -1,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,    -1,    -1,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,    -1,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,    -1,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,    -1,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    -1,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
      -1,    -1,   146,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,   233,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,   233,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,   297,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,   233,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    70,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,   163,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    70,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    70,    -1,
      -1,    73,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,   233,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      70,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    70,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    70,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    70,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    70,    -1,    -1,    73,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,   349,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    70,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,   499,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,   499,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    70,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      70,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    70,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    70,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,   349,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,   349,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    72,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,   107,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,   107,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,    -1,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,    -1,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,    -1,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,    -1,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,   107,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,   155,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,   155,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,   155,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,    -1,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,    -1,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,    -1,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    36,    37,
      38,    -1,    40,    -1,    -1,    43,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,    -1,    -1,   157,
     158,   159,   160,   161,   162,    -1,    -1,   165,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   176,   177,
     178,   179,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,    -1,    -1,    -1,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,   252,   253,   254,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,    -1,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,    -1,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,    -1,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
      -1,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,    -1,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,    -1,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    43,
      44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    65,    -1,    67,    68,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,    -1,    -1,   157,   158,   159,   160,   161,   162,    -1,
      -1,   165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,   176,   177,   178,   179,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,    -1,    -1,    -1,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,   252,   253,
     254,    -1,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,    -1,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,    -1,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,    -1,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,    -1,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,    -1,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,    -1,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,    -1,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    15,    -1,    -1,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    36,    37,    38,    -1,
      40,    -1,    -1,    43,    44,    -1,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,    -1,    -1,   157,   158,   159,
     160,   161,   162,    -1,    -1,   165,   166,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,   176,   177,   178,   179,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,    -1,    -1,    -1,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,   252,   253,   254,    -1,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,    -1,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,    -1,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,    -1,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,    -1,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
      -1,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      36,    37,    38,    -1,    40,    -1,    -1,    43,    44,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    68,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,    -1,
      -1,   157,   158,   159,   160,   161,   162,    -1,    -1,   165,
     166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,    -1,
      -1,    -1,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,   252,   253,   254,    -1,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,    -1,    -1,   284,    -1,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,    -1,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
      -1,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,    -1,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
      -1,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,    -1,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    15,    -1,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    26,    27,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    36,    37,    38,    -1,    40,    -1,
      -1,    43,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    65,    -1,    67,    68,    69,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,   155,    -1,   157,   158,   159,   160,   161,
     162,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   175,   176,   177,   178,   179,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,    -1,    -1,    -1,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,    -1,   248,    -1,   250,   251,
     252,   253,   254,    -1,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,    -1,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,    -1,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,    -1,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,    -1,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,    -1,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,    -1,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,    -1,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,    -1,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,     6,     7,
      -1,     9,    10,    11,    -1,    -1,    -1,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    -1,
      -1,    -1,    30,    31,    32,    33,    -1,    35,    36,    37,
      38,    39,    40,    41,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    71,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,    -1,
      -1,   119,   120,   121,   122,   123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   136,    -1,
      -1,    -1,    -1,    -1,    -1,   143,    -1,   145,    -1,    -1,
      -1,    -1,    -1,    -1,   152,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,    -1,    -1,
      -1,    -1,    -1,   171,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   181,   182,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     218,    -1,    -1,    -1,    -1,   223,    -1,    -1,    -1,    -1,
      -1,   229,    -1,    -1,    -1,    -1,    -1,   235,    -1,   237,
      -1,    -1,    -1,    -1,    -1,    -1,   244,    -1,   246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   255,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   270,   271,    -1,    -1,    -1,    -1,    -1,   277,
      -1,   279,    -1,    -1,   282,   283,    -1,   285,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   294,   295,    -1,   297,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   320,   321,   322,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,    -1,
      -1,   339,    -1,   341,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   357,
     358,    -1,   360,   361,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   374,    -1,   376,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   412,    -1,    -1,    -1,    -1,    -1,
     418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,
      -1,    -1,   440,    -1,    -1,   443,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   459,    -1,    -1,    -1,    -1,    -1,    -1,   466,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   474,   475,    -1,    -1,
      -1,    -1,   480,    -1,   482,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,
      -1,    -1,   510,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,     6,
       7,    -1,     9,    10,    11,    -1,    -1,    -1,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    -1,    25,    26,
      -1,    -1,    -1,    30,    31,    32,    33,    -1,    35,    36,
      37,    38,    39,    40,    41,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,    -1,
      67,    68,    69,    -1,    71,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,
      -1,    -1,   119,   120,   121,   122,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   136,
      -1,    -1,    -1,    -1,    -1,    -1,   143,    -1,   145,    -1,
      -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,    -1,
      -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   181,   182,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   218,    -1,    -1,    -1,    -1,   223,    -1,    -1,    -1,
      -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,   235,    -1,
     237,    -1,    -1,    -1,    -1,    -1,    -1,   244,    -1,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   255,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   270,   271,    -1,    -1,    -1,    -1,    -1,
     277,    -1,   279,    -1,    -1,   282,   283,    -1,   285,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   294,   295,    -1,
     297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   320,   321,   322,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   330,   331,    -1,    -1,    -1,    -1,   336,
      -1,    -1,   339,    -1,   341,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     357,   358,    -1,   360,   361,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,    -1,   376,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   412,    -1,    -1,    -1,    -1,
      -1,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     437,    -1,    -1,   440,    -1,    -1,   443,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   459,    -1,    -1,    -1,    -1,    -1,    -1,   466,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,    -1,
      -1,    -1,    -1,   480,    -1,   482,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     507,    -1,    -1,   510,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
       6,     7,    -1,     9,    10,    11,    -1,    -1,    -1,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    -1,    -1,    -1,    30,    31,    32,    33,    -1,    35,
      36,    37,    38,    -1,    40,    41,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      -1,    67,    -1,    69,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,
      -1,    -1,    -1,   119,   120,   121,   122,   123,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     136,    -1,    -1,    -1,    -1,    -1,    -1,   143,    -1,   145,
      -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   164,    -1,
      -1,    -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   181,   182,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   218,    -1,    -1,    -1,    -1,   223,    -1,    -1,
      -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,   235,
      -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,   244,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   255,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   270,   271,    -1,    -1,    -1,    -1,
      -1,   277,    -1,   279,    -1,    -1,   282,   283,    -1,   285,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   294,   295,
      -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   320,   321,   322,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   330,   331,    -1,    -1,    -1,    -1,
     336,    -1,    -1,   339,    -1,   341,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   357,   358,    -1,   360,   361,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,    -1,
     376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   391,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   412,    -1,    -1,    -1,
      -1,    -1,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   437,    -1,    -1,   440,    -1,    -1,   443,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   459,    -1,    -1,    -1,    -1,    -1,    -1,
     466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,   475,
      -1,    -1,    -1,    -1,   480,    -1,   482,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,    -1,    -1,   510,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,     6,     7,    -1,     9,    10,    11,    -1,    -1,    -1,
      15,    -1,    -1,    18,    19,    20,    21,    22,    23,    -1,
      25,    26,    -1,    -1,    -1,    30,    31,    32,    33,    -1,
      35,    36,    37,    38,    -1,    40,    41,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     115,    -1,    -1,    -1,   119,   120,   121,   122,   123,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,   143,    -1,
     145,    -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   164,
      -1,    -1,    -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   181,   182,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   218,    -1,    -1,    -1,    -1,   223,    -1,
      -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,    -1,
     235,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,   244,
      -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   270,   271,    -1,    -1,    -1,
      -1,    -1,   277,    -1,   279,    -1,    -1,   282,   283,    -1,
     285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   294,
     295,    -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   320,   321,   322,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   330,   331,    -1,    -1,    -1,
      -1,   336,    -1,    -1,   339,    -1,   341,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   357,   358,    -1,   360,   361,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,
      -1,   376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   391,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,    -1,    -1,
      -1,    -1,    -1,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,    -1,    -1,   440,    -1,    -1,   443,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   459,    -1,    -1,    -1,    -1,    -1,
      -1,   466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,
     475,    -1,    -1,    -1,    -1,   480,    -1,   482,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   492,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   507,    -1,    -1,   510,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,     6,     7,    -1,     9,    10,    11,    -1,    -1,
      -1,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    -1,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    36,    37,    38,    -1,    40,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   115,    -1,    -1,    -1,   119,   120,   121,   122,   123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,   143,
      -1,   145,    -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     164,    -1,    -1,    -1,    -1,    -1,    -1,   171,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   181,   182,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   218,    -1,    -1,    -1,    -1,   223,
      -1,    -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,    -1,
      -1,   235,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,
     244,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   270,   271,    -1,    -1,
      -1,    -1,    -1,   277,    -1,   279,    -1,    -1,   282,   283,
      -1,   285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     294,   295,    -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   320,   321,   322,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   330,   331,    -1,    -1,
      -1,    -1,   336,    -1,    -1,   339,    -1,   341,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   357,   358,    -1,   360,   361,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     374,    -1,   376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   391,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,    -1,
      -1,    -1,    -1,    -1,   418,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   437,    -1,    -1,   440,    -1,    -1,   443,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   459,    -1,    -1,    -1,    -1,
      -1,    -1,   466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     474,   475,    -1,    -1,    -1,    -1,   480,    -1,   482,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   507,    -1,    -1,   510,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    69,    70,    -1,    -1,    73,    -1,    75,
      76,    -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,    -1,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,    -1,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,    -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,   175,
     176,   177,   178,    -1,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    69,   538,   539,    -1,    73,    -1,    -1,    -1,    -1,
      -1,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,    -1,
     556,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,    -1,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,    -1,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,    -1,
      -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,   177,
     178,    -1,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
     428,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    -1,
     538,   539,    69,    70,   542,    -1,    73,    -1,    75,    76,
      -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,   556,    -1,
      -1,    -1,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,   133,   134,    -1,   136,
     137,    -1,   139,   140,   141,   142,   143,    -1,   145,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,    -1,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
      -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,
     177,   178,    -1,   180,   181,   182,   183,   184,   185,    -1,
     187,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,    -1,   200,   201,   202,   203,   204,    -1,   206,
     207,   208,    -1,   210,   211,   212,    -1,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,    -1,   234,   235,    -1,
     237,   238,   239,   240,   241,    -1,   243,   244,    -1,   246,
     247,   248,    -1,   250,   251,    -1,   253,   254,   255,   256,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,    -1,   273,   274,   275,    -1,
     277,    -1,   279,    -1,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,    -1,    -1,   293,   294,   295,   296,
     297,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,    -1,   350,   351,   352,    -1,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
     427,    -1,   429,   430,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,    -1,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,    -1,
      -1,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,    -1,   494,   495,   496,
     497,   498,    -1,    -1,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,    -1,    -1,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
      -1,   538,   539,    -1,    -1,    -1,    -1,    -1,    69,    70,
     547,   548,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
      -1,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,    -1,   125,   126,   127,   128,   129,   130,
      -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,   140,
     141,   142,   143,    -1,   145,    -1,   147,   148,   149,   150,
     151,   152,   153,   154,    -1,    -1,   157,   158,   159,   160,
     161,   162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,
     171,    -1,    -1,    -1,   175,   176,   177,   178,    -1,   180,
     181,   182,   183,   184,   185,    -1,   187,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,    -1,   200,
     201,   202,   203,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,    -1,   234,   235,    -1,   237,   238,   239,   240,
     241,    -1,   243,   244,    -1,   246,   247,   248,    -1,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,    -1,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,    -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
      -1,    -1,   293,   294,   295,   296,   297,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,    -1,   350,
     351,   352,    -1,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,    -1,   427,    -1,   429,   430,
     431,   432,   433,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,    -1,    -1,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,
     501,   502,   503,   504,   505,    -1,   507,    -1,   509,   510,
     511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,    -1,   538,   539,    -1,
      -1,    -1,    -1,    -1,    69,    70,   547,   548,    73,    -1,
      75,    76,    -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,    -1,
     125,   126,   127,   128,   129,   130,    -1,    -1,   133,   134,
      -1,   136,   137,    -1,   139,   140,   141,   142,   143,    -1,
     145,    -1,   147,   148,   149,   150,   151,   152,   153,   154,
      -1,    -1,   157,   158,   159,   160,   161,   162,    -1,   164,
     165,   166,    -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,
     175,   176,   177,   178,    -1,   180,   181,   182,   183,    -1,
     185,    -1,   187,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,    -1,   200,   201,   202,   203,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,    -1,   234,
     235,    -1,   237,   238,   239,   240,   241,    -1,   243,   244,
      -1,   246,   247,   248,    -1,   250,   251,    -1,   253,   254,
     255,   256,   257,   258,   259,    -1,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,    -1,   273,   274,
     275,    -1,   277,    -1,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,    -1,    -1,   293,   294,
     295,   296,   297,    -1,   299,   300,   301,    -1,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,    -1,   350,   351,   352,    -1,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,   427,    -1,   429,   430,   431,   432,   433,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,    -1,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,    -1,   473,   474,
     475,    -1,    -1,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,    -1,    -1,   494,
     495,   496,   497,   498,    -1,    -1,   501,   502,   503,   504,
     505,    -1,   507,    -1,   509,   510,   511,   512,   513,   514,
      -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,    -1,   538,   539,    -1,    -1,    69,    70,    -1,
      -1,    73,   547,   548,    76,    -1,    -1,    -1,    -1,    81,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,    -1,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,   175,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    -1,   538,   539,    -1,    -1,
      69,    70,    -1,    -1,    73,   547,   548,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    91,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,   110,    -1,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,    -1,    -1,   133,   134,    -1,   136,   137,    -1,
     139,   140,   141,   142,   143,    -1,   145,    -1,   147,   148,
     149,   150,   151,   152,   153,   154,    -1,    -1,   157,   158,
     159,   160,   161,   162,    -1,   164,   165,   166,    -1,    -1,
      -1,    -1,   171,    -1,    -1,   174,   175,   176,   177,   178,
      -1,   180,   181,   182,   183,    -1,   185,    -1,   187,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
      -1,   200,   201,   202,   203,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,    -1,   225,    -1,   227,   228,
     229,   230,    -1,   232,    -1,   234,   235,    -1,   237,   238,
     239,   240,   241,    -1,   243,   244,    -1,   246,   247,   248,
      -1,   250,   251,    -1,   253,   254,   255,   256,   257,   258,
     259,    -1,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,    -1,   273,   274,   275,    -1,   277,    -1,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,    -1,    -1,   293,   294,   295,   296,   297,    -1,
     299,   300,   301,    -1,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,    -1,
      -1,   350,   351,   352,    -1,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,   427,    -1,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,    -1,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,    -1,   478,
     479,   480,   481,   482,    -1,   484,   485,   486,   487,   488,
     489,   490,   491,    -1,    -1,   494,   495,   496,   497,   498,
      -1,    -1,   501,   502,   503,   504,   505,    -1,   507,    -1,
     509,   510,   511,   512,   513,   514,    -1,    -1,   517,    -1,
      -1,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    -1,   538,
     539,    69,    70,    -1,    -1,    73,    -1,    -1,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,    -1,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,    -1,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,    -1,
      -1,    -1,    -1,   171,    -1,    -1,   174,   175,   176,   177,
     178,    -1,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    69,
     538,   539,    -1,    73,    -1,    -1,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,    -1,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,    -1,    -1,    -1,
      -1,   171,    -1,    -1,    -1,   175,   176,   177,   178,    -1,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,    69,   538,   539,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,    -1,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,   174,   175,   176,   177,   178,    -1,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    69,   538,   539,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,    -1,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,    -1,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,    -1,    -1,    -1,    -1,   171,    -1,    -1,
     174,   175,   176,   177,   178,    -1,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,    -1,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    69,   538,   539,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,    -1,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,    -1,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,    -1,    -1,    -1,    -1,   171,    -1,    -1,   174,   175,
     176,   177,   178,    -1,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,   499,    -1,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    69,   538,   539,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,    -1,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,    -1,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,    -1,
      -1,    -1,    -1,   171,    -1,    -1,   174,   175,   176,   177,
     178,    -1,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    69,
     538,   539,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,    -1,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,    -1,    -1,    -1,
      -1,   171,    -1,    -1,   174,   175,   176,   177,   178,    -1,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,    -1,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,    69,   538,   539,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,    -1,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,   174,   175,   176,   177,   178,    -1,   180,   181,
     182,   183,    -1,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    69,   538,   539,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,    -1,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,    -1,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,    -1,    -1,    -1,    -1,   171,    -1,    -1,
     174,   175,   176,   177,   178,    -1,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,    -1,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    69,   538,   539,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,    -1,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,    -1,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,    -1,    -1,    -1,    -1,   171,    -1,    -1,   174,   175,
     176,   177,   178,    -1,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,    -1,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    69,   538,   539,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,    -1,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,    -1,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,    -1,
      -1,    -1,    -1,   171,    -1,    -1,   174,   175,   176,   177,
     178,    -1,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
      -1,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    69,
     538,   539,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,   133,   134,    -1,   136,   137,    -1,   139,
     140,   141,   142,   143,    -1,   145,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,    -1,    -1,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,    -1,    -1,    -1,
      -1,   171,    -1,    -1,    -1,   175,   176,   177,   178,    -1,
     180,   181,   182,   183,    -1,   185,    -1,   187,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,    -1,
     200,   201,   202,   203,   204,    -1,   206,   207,   208,    -1,
     210,   211,   212,    -1,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,    -1,   225,    -1,   227,   228,   229,
     230,    -1,   232,    -1,   234,   235,    -1,   237,   238,   239,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,    -1,   277,    -1,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,    -1,    -1,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,    -1,    -1,
     350,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,   427,    -1,   429,
     430,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,    -1,    -1,   478,   479,
     480,   481,   482,    -1,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,   494,   495,   496,   497,   498,    -1,
      -1,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,    -1,    -1,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,    69,   538,   539,
      -1,    73,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,    -1,
      -1,   133,   134,    -1,   136,   137,    -1,   139,   140,   141,
     142,   143,    -1,   145,    -1,   147,   148,   149,   150,   151,
     152,   153,   154,    -1,    -1,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,    -1,    -1,   175,   176,   177,   178,    -1,   180,   181,
     182,   183,   184,   185,    -1,   187,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,    -1,   200,   201,
     202,   203,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,    -1,   225,    -1,   227,   228,   229,   230,    -1,
     232,    -1,   234,   235,    -1,   237,   238,   239,   240,   241,
      -1,   243,   244,    -1,   246,   247,   248,    -1,   250,   251,
      -1,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,    -1,   277,    -1,   279,    -1,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,    -1,
      -1,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,    -1,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,    -1,    -1,   350,   351,
     352,    -1,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,   427,    -1,   429,   430,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,    -1,    -1,   478,   479,   480,   481,
     482,    -1,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,   494,   495,   496,   497,   498,    -1,    -1,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,    -1,    -1,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    69,   538,   539,    -1,    73,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,    -1,    -1,   133,
     134,    -1,   136,   137,    -1,   139,   140,   141,   142,   143,
      -1,   145,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,    -1,    -1,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,    -1,    -1,    -1,    -1,   171,    -1,    -1,
      -1,   175,   176,   177,   178,    -1,   180,   181,   182,   183,
      -1,   185,    -1,   187,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,    -1,   200,   201,   202,   203,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
      -1,   225,    -1,   227,   228,   229,   230,    -1,   232,    -1,
     234,   235,    -1,   237,   238,   239,   240,   241,    -1,   243,
     244,    -1,   246,   247,   248,    -1,   250,   251,    -1,   253,
     254,   255,   256,   257,   258,   259,    -1,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,    -1,   273,
     274,   275,    -1,   277,    -1,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,    -1,    -1,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,    -1,    -1,   350,   351,   352,    -1,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,    -1,   429,   430,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,    -1,    -1,   478,   479,   480,   481,   482,    -1,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
     494,   495,   496,   497,   498,    -1,    -1,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,    -1,    -1,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    69,   538,   539,    -1,    73,    -1,    -1,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,    -1,    -1,   133,   134,    -1,
     136,   137,    -1,   139,   140,   141,   142,   143,    -1,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,    -1,
      -1,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,    -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,   175,
     176,   177,   178,    -1,   180,   181,   182,   183,    -1,   185,
      -1,   187,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,    -1,   200,   201,   202,   203,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,    -1,   225,
      -1,   227,   228,   229,   230,    -1,   232,    -1,   234,   235,
      -1,   237,   238,   239,   240,   241,    -1,   243,   244,    -1,
     246,   247,   248,    -1,   250,   251,    -1,   253,   254,   255,
     256,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
      -1,   277,    -1,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,    -1,    -1,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
      -1,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,    -1,    -1,   350,   351,   352,    -1,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,    -1,   429,   430,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
      -1,    -1,   478,   479,   480,   481,   482,    -1,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,   494,   495,
     496,   497,   498,    -1,    -1,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,    -1,
      -1,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    69,   538,   539,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,   133,   134,    -1,   136,   137,
      -1,   139,   140,   141,   142,   143,    -1,   145,    -1,   147,
     148,   149,   150,   151,   152,   153,   154,    -1,    -1,   157,
     158,   159,   160,   161,   162,    -1,   164,   165,   166,    -1,
      -1,    -1,    -1,   171,    -1,    -1,    -1,   175,   176,   177,
     178,    -1,   180,   181,   182,   183,    -1,   185,    -1,   187,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,    -1,   200,   201,   202,   203,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,    -1,   225,    -1,   227,
     228,   229,   230,    -1,   232,    -1,   234,   235,    -1,   237,
     238,   239,   240,   241,    -1,   243,   244,    -1,   246,   247,
     248,    -1,   250,   251,    -1,   253,   254,   255,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,    -1,   277,
      -1,   279,    -1,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,    -1,    -1,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,    -1,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
      -1,    -1,   350,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,   427,
      -1,   429,   430,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,    -1,    -1,
     478,   479,   480,   481,   482,    -1,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,   494,   495,   496,   497,
     498,    -1,    -1,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,    -1,    -1,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    -1,
     538,   539
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   565,  1230,     0,     5,    24,    34,    35,    39,    41,
      42,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    71,    73,    75,    76,
      81,   135,   210,   229,   252,   276,   313,   316,   338,   426,
     476,   492,   507,   537,   545,   547,   548,   549,   550,   551,
     554,   555,   556,   557,   559,   560,   561,   562,   563,  1220,
    1231,  1260,  1262,  1353,  1363,  1364,  1366,  1372,  1373,  1261,
       3,     6,     7,     8,     9,    10,    11,    12,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    25,    26,
      27,    30,    31,    32,    33,    35,    36,    37,    38,    40,
      41,    42,    43,    44,    48,    49,    54,    63,    65,    67,
      68,    90,   100,   102,   103,   112,   115,   118,   119,   120,
     121,   122,   123,   127,   136,   139,   141,   142,   143,   145,
     148,   150,   152,   161,   163,   164,   171,   178,   180,   181,
     182,   183,   197,   199,   203,   209,   210,   217,   218,   219,
     223,   226,   229,   235,   237,   242,   244,   246,   255,   259,
     270,   271,   277,   279,   282,   283,   285,   294,   295,   297,
     299,   300,   305,   317,   320,   321,   322,   330,   331,   335,
     336,   339,   341,   357,   358,   360,   361,   374,   376,   378,
     391,   392,   398,   399,   401,   406,   411,   412,   414,   418,
     421,   427,   428,   435,   437,   439,   440,   443,   449,   459,
     464,   466,   474,   475,   480,   482,   484,   486,   492,   495,
     501,   506,   507,   510,   519,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   542,   556,   566,   567,
     568,   574,   575,   577,   578,   579,   580,   582,   586,   598,
     603,   604,   607,   608,   609,   628,   631,   632,   647,   691,
     692,   695,   698,   699,   700,   708,   714,   716,   718,   719,
     722,   725,   726,   730,   739,   743,   744,   745,   746,   749,
     751,   752,   753,   754,   762,   764,   784,   788,   790,   791,
     801,   803,   810,   811,   814,   815,   816,   817,   818,   826,
     828,   832,   837,   841,   842,   850,   851,   854,   859,   873,
     900,   903,   904,   905,   910,   913,   915,   917,   919,   920,
     925,   926,   929,   931,   932,   936,   937,   938,   941,   942,
     945,   946,   947,   954,   956,   957,   958,   964,   966,   967,
     973,   974,   975,   978,   979,   980,   981,   983,   984,   986,
     987,   989,   990,   992,  1004,  1010,  1013,  1015,  1024,  1026,
    1031,  1036,  1040,  1041,  1042,  1043,  1044,  1045,  1049,  1084,
    1227,  1228,  1232,  1235,  1236,  1253,  1254,  1255,  1256,  1267,
    1269,  1273,  1274,  1275,  1276,  1277,  1279,  1281,  1283,  1284,
    1285,  1286,  1288,  1293,  1294,  1298,  1299,  1308,  1310,  1311,
    1312,  1315,  1320,  1323,  1328,  1330,  1331,  1334,  1336,  1339,
    1348,  1366,  1374,    71,  1256,  1264,  1265,    13,    70,    90,
      91,    92,    93,    94,    95,    96,    97,    99,   100,   101,
     109,   110,   112,   113,   114,   116,   117,   118,   125,   126,
     127,   128,   129,   130,   133,   134,   137,   139,   140,   141,
     142,   147,   148,   149,   150,   151,   153,   154,   157,   158,
     159,   160,   161,   162,   165,   166,   174,   175,   176,   177,
     178,   180,   183,   185,   187,   188,   189,   190,   191,   192,
     194,   195,   196,   197,   200,   201,   202,   203,   204,   206,
     207,   208,   210,   211,   212,   214,   215,   216,   217,   219,
     220,   221,   222,   225,   227,   228,   230,   232,   234,   238,
     239,   240,   241,   243,   247,   248,   250,   251,   253,   254,
     256,   257,   258,   259,   261,   262,   263,   264,   265,   266,
     267,   269,   273,   274,   275,   281,   284,   286,   287,   288,
     289,   290,   293,   296,   299,   300,   301,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   314,   315,   317,   318,
     319,   323,   324,   325,   326,   327,   328,   329,   332,   334,
     335,   337,   340,   342,   343,   344,   346,   347,   350,   351,
     352,   355,   356,   359,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   372,   373,   375,   377,   378,   379,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   392,
     393,   394,   395,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   410,   411,   413,   414,   415,
     416,   417,   419,   420,   421,   422,   423,   424,   425,   427,
     429,   430,   431,   432,   433,   434,   435,   436,   438,   439,
     441,   442,   444,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   460,   462,   463,   465,
     467,   468,   469,   470,   471,   473,   476,   478,   479,   481,
     484,   485,   486,   487,   488,   489,   490,   491,   494,   495,
     496,   497,   498,   501,   502,   503,   504,   505,   509,   511,
     512,   513,   514,   517,   520,   521,   522,   523,   524,   525,
     538,   539,  1222,  1223,  1225,  1226,  1227,  1228,  1246,  1247,
    1358,  1360,  1364,  1366,    28,   272,  1309,     8,    12,    14,
      27,    43,    44,    48,    49,    54,    63,    65,    67,    68,
      98,   135,   155,   167,   179,   184,   252,   313,   316,   426,
     506,   537,  1213,  1226,  1227,  1248,  1295,  1296,  1338,  1339,
    1340,  1344,  1349,  1350,  1351,  1360,  1366,    98,  1037,  1212,
    1248,  1344,  1357,    13,  1037,     5,    24,    28,    34,    35,
      41,    42,    98,   102,   103,   104,   105,   106,   107,   108,
     111,   124,   131,   132,   135,   138,   144,   146,   155,   156,
     163,   167,   168,   169,   170,   172,   173,   174,   184,   186,
     193,   198,   199,   205,   209,   213,   224,   226,   231,   233,
     236,   242,   245,   249,   260,   268,   272,   276,   278,   280,
     291,   292,   298,   302,   303,   333,   338,   345,   348,   349,
     353,   354,   371,   380,   396,   409,   428,   434,   445,   461,
     464,   472,   476,   477,   483,   492,   493,   499,   500,   506,
     508,   515,   516,   518,   519,  1226,  1229,  1340,  1341,  1342,
    1346,  1347,  1348,  1349,  1351,    24,    34,   135,   276,  1335,
      36,    38,   333,  1268,   478,   522,   959,    97,   145,   160,
     178,   184,   201,   212,   221,   233,   238,   245,   264,   289,
     310,   350,   373,   383,   384,   387,   413,   416,   420,   422,
     429,   432,   451,   458,   463,   464,   467,   471,   481,   486,
     499,   512,   715,  1296,   183,   959,  1143,  1218,  1228,  1338,
    1341,  1344,  1345,  1349,  1350,  1366,    98,  1037,   510,   997,
     348,   379,   959,   121,   556,   639,    92,   109,   132,   145,
     156,   178,   184,   201,   212,   221,   233,   241,   245,   301,
     350,   353,   373,   387,   413,   422,   432,   451,   458,   467,
     468,   470,   471,   481,   486,   493,   496,   499,   648,   697,
     806,   860,   874,  1213,  1237,  1238,  1239,  1248,  1364,  1366,
      13,    98,   378,  1212,  1248,  1252,   450,  1037,    98,   372,
     430,   468,   470,   288,   911,   912,  1364,    92,    97,   132,
     145,   160,   178,   201,   212,   221,   233,   238,   245,   264,
     310,   350,   363,   373,   384,   387,   413,   416,   420,   422,
     429,   432,   451,   458,   464,   467,   471,   479,   481,   486,
     499,   512,   715,   819,   820,   821,   959,   562,  1278,  1342,
     256,  1252,   163,   183,   217,   510,   556,   695,   698,   992,
    1005,  1013,  1015,  1024,  1031,  1036,  1040,  1232,    91,    98,
     116,   228,   234,   236,   260,   290,   324,   381,   400,   547,
     548,   838,   839,  1037,  1220,  1221,  1358,  1360,    98,   163,
     396,   428,   843,   844,   845,  1344,   233,  1344,  1217,  1364,
     464,  1052,   116,   234,   838,  1344,   478,  1252,   363,   310,
     178,   264,   422,   463,   464,   556,   921,   922,   421,  1344,
      98,   135,   433,   474,   478,   506,   590,   599,   600,  1226,
    1227,  1338,  1343,  1349,  1351,  1366,    95,   242,   843,   844,
     379,   959,  1344,   287,    98,   198,  1054,  1055,     4,    13,
     133,   155,   157,   301,   319,   413,   422,   433,   474,   478,
     525,   587,   588,   589,   590,    98,   433,   474,   478,   590,
     478,   349,  1095,  1210,  1344,  1052,  1332,  1342,   549,  1344,
     237,   556,   998,   556,   394,  1046,  1047,  1212,  1046,  1041,
    1042,  1045,   560,   556,   997,   213,   278,   354,   492,  1056,
    1057,  1041,  1043,  1044,   189,   274,   498,   559,   118,   566,
    1276,  1279,  1275,  1271,   560,  1280,  1282,     5,    24,    34,
     135,   202,   276,  1287,   179,   252,   313,   316,   426,   537,
     556,  1138,  1139,  1259,  1263,  1353,    71,  1256,  1212,  1248,
    1367,   184,  1237,    20,   500,   550,  1252,  1252,  1367,   500,
    1300,  1301,  1302,    24,   276,   276,  1346,    18,    19,    37,
      40,   127,   159,   199,  1337,  1337,    15,  1276,   104,   963,
     890,  1218,   823,  1344,   823,  1213,   382,   823,   481,  1212,
     177,   464,   878,  1218,  1228,  1344,  1222,  1223,    98,   254,
    1210,   342,   512,    80,    87,    88,    89,   140,   225,   543,
     544,   545,   547,   548,   549,   550,   551,   552,   907,   909,
    1173,  1174,  1344,   254,  1212,   878,  1212,    98,  1222,  1223,
     878,  1212,  1212,   254,  1210,  1212,   254,   823,  1212,   406,
     435,    98,   254,  1095,  1212,   425,  1212,   823,    98,   308,
    1222,  1223,   254,  1210,   288,    33,   186,   284,   333,   390,
     960,   961,   962,   556,   554,   558,  1201,  1203,  1210,  1216,
    1344,    92,    97,   132,   145,   146,   156,   160,   178,   201,
     212,   221,   233,   238,   264,   289,   310,   350,   373,   384,
     387,   413,   416,   420,   422,   429,   432,   451,   458,   464,
     467,   471,   479,   481,   486,   512,   715,   829,   830,  1364,
     963,  1012,  1015,  1024,  1031,  1040,  1210,   312,   823,   556,
     254,   823,   481,  1213,   823,   481,   254,  1212,   177,   464,
     468,   470,  1222,   468,   470,   140,   225,   907,   404,  1212,
    1212,  1222,   254,   583,  1344,   254,  1212,   254,   823,  1212,
    1212,   425,  1212,   823,   308,  1222,   394,   429,   464,   512,
     310,   160,   264,    97,   238,   384,   420,   479,   485,   709,
      80,  1240,  1241,   561,  1360,  1367,    98,  1252,  1366,  1038,
     597,  1225,  1364,   912,   312,   254,   890,   891,   254,   916,
     254,  1213,   120,   122,   123,   135,   136,   181,   182,   202,
     229,   254,   276,   277,   279,   320,   322,   341,   391,   437,
     443,   474,   475,   507,   825,  1117,  1119,  1121,  1123,  1125,
    1127,  1128,  1129,  1131,  1132,  1133,  1135,  1136,  1338,  1345,
    1349,  1350,  1366,   481,   177,   464,   254,   877,   878,   254,
    1223,  1224,   152,   512,   140,   225,   254,   908,   909,   125,
     254,   877,   254,  1224,   254,   877,   254,  1212,   254,  1212,
     425,   916,   254,   825,   254,   308,  1224,   288,   254,   822,
     823,   254,  1211,  1212,   254,  1212,   963,   556,   562,  1368,
    1369,  1370,  1371,  1373,  1278,    69,  1248,  1297,   556,  1014,
     648,  1037,  1005,   992,  1006,  1007,  1008,  1225,   997,  1221,
     839,   840,    98,   839,  1037,  1221,   840,    98,   839,  1037,
    1221,   840,   840,   840,  1221,  1220,  1220,   280,   500,  1302,
    1303,  1377,  1379,  1037,   840,   382,   556,   556,   668,   668,
     668,   348,   476,   559,   668,   422,  1095,  1096,   839,  1037,
     839,  1037,   559,   955,  1364,   236,   556,  1011,   125,   512,
     510,   923,   924,   152,   861,   861,  1344,   115,   539,   284,
     558,   351,   351,   348,   236,  1364,   476,   963,   231,   833,
     348,    78,    79,    80,    82,   106,   120,   122,   123,   131,
     132,   135,   136,   143,   145,   168,   169,   170,   171,   172,
     173,   174,   181,   182,   184,   218,   223,   224,   229,   244,
     246,   277,   279,   294,   302,   303,   320,   322,   331,   333,
     338,   339,   341,   350,   361,   374,   391,   418,   434,   443,
     459,   474,   475,   480,   482,   483,   493,   499,   507,   527,
     528,   529,   530,   532,   533,   534,   535,   540,   547,   548,
     549,   556,  1041,  1120,  1123,  1126,  1127,  1128,  1130,  1131,
    1132,  1135,  1136,  1140,  1142,  1143,  1144,  1146,  1169,  1170,
    1171,  1175,  1195,  1200,  1207,  1208,  1218,  1219,  1220,  1344,
    1356,  1358,  1360,  1361,  1362,  1363,  1364,  1365,  1206,  1207,
     476,   545,  1367,  1364,   476,   545,  1296,    98,   605,  1209,
    1210,   433,   587,   184,   596,  1364,   597,  1364,   115,   137,
     587,   539,   444,   961,   351,   236,   476,   545,   115,   539,
     284,  1377,   962,   556,  1210,   549,  1203,  1096,  1348,   991,
     992,   993,   994,  1225,   235,   999,  1140,  1178,  1046,   559,
     556,  1000,   557,   557,   991,  1001,  1002,  1003,  1210,    98,
     198,  1053,  1053,   125,  1053,   226,   231,   298,   345,  1060,
    1062,  1063,  1078,  1080,  1081,  1082,  1056,  1057,   236,   280,
    1095,  1097,   556,   560,  1270,   549,  1289,  1290,  1292,   562,
     562,    24,   276,   276,   476,   476,   476,   476,   556,   476,
     547,   548,   706,  1221,  1257,  1363,   209,   107,  1244,   125,
    1247,  1247,   280,  1302,  1304,   280,  1302,  1303,  1304,   505,
    1313,  1314,  1360,    13,   446,   547,   548,  1220,  1305,  1306,
    1307,  1356,  1358,  1362,  1363,  1364,  1365,   276,   282,   476,
    1212,  1212,     6,   159,  1212,  1337,  1292,   134,   329,   364,
     402,   435,   556,   888,   364,   398,   402,   435,   558,   824,
     364,   402,   435,   155,   207,   304,   364,   402,   435,   467,
     469,   519,   598,   601,   968,   969,   970,   971,  1366,   855,
      94,   203,   364,   402,   435,   503,   614,  1212,    94,   203,
     435,   498,   581,   523,   254,  1095,   128,   162,   222,   257,
     293,   329,   333,   364,   365,   402,   410,   419,   427,   435,
     447,   456,   460,   514,   598,   602,   893,   901,   930,   556,
     875,  1203,   402,   581,   260,   218,    94,   100,   113,   142,
     196,   203,   206,   232,   266,   329,   333,   343,   352,   364,
     402,   405,   406,   435,   503,   610,   612,   613,   733,   930,
     706,    98,   254,  1210,   823,   823,   556,   906,   364,   435,
     558,   218,   348,   364,   402,   435,   901,   930,    94,   203,
     364,   402,   435,   260,   576,   402,   519,   542,   569,   576,
     364,   402,   435,   901,   930,   348,   364,   402,   218,   107,
     126,   176,   263,   311,   314,   329,   363,   402,   407,   429,
     435,   449,   610,   703,   704,   364,   402,   511,   733,   741,
     218,   364,   402,   435,   155,   196,   206,   364,   398,   402,
     435,   600,   588,   590,   260,   218,   113,   194,   329,   402,
     435,   610,   611,   364,   402,   406,   435,   153,   195,   366,
     469,   348,    94,   100,   203,   364,   402,   435,   629,   630,
     576,   231,   402,   569,   576,   218,   402,   435,   610,  1212,
     560,   296,   186,   349,   524,   559,   960,    98,   198,   508,
     549,   557,   883,  1140,  1179,  1180,  1345,  1140,  1202,   549,
    1215,  1346,  1201,   500,   988,   348,   312,   890,   556,  1212,
    1117,   481,   177,   464,   878,   342,   512,   140,   225,   909,
    1212,   878,   878,  1212,   425,   231,  1212,  1117,   288,   823,
    1212,   557,   668,  1212,   138,  1117,   333,   236,   556,   792,
    1212,   569,   107,   982,  1212,   333,   569,   523,   254,  1210,
     569,   823,   823,   792,   496,   648,   348,   231,   939,   940,
     569,   333,   115,   584,   333,   486,   740,   333,  1000,   155,
     364,   717,   153,   195,   366,   469,    96,   117,   275,   765,
     107,   792,   231,   254,   569,   512,   254,  1210,   254,   693,
    1210,  1210,   512,   823,   861,  1218,  1218,  1218,  1212,   231,
     715,    72,  1242,  1344,   561,  1243,  1240,   121,   175,   273,
     329,   424,   218,   129,   408,   559,   615,   218,   556,   218,
     569,   509,  1134,  1134,  1134,   556,  1122,  1122,   376,   556,
    1124,   218,   135,   136,  1134,  1122,  1119,   521,   542,   556,
    1137,   556,  1137,   559,   615,   106,  1118,   556,   179,   316,
     537,   556,  1138,   824,  1122,   523,   218,   559,   615,   218,
     559,   254,   822,   254,   823,   254,   823,   218,   559,   615,
    1224,   218,   615,   218,   218,   615,   218,   615,   218,   153,
     195,   366,   469,   231,   218,   615,   218,   231,   254,   254,
     597,   218,   559,   615,   218,   559,   615,   218,   348,   557,
    1369,  1370,  1368,   559,   563,  1178,  1301,  1376,  1377,   464,
    1038,   557,   559,   224,   348,   483,   594,   597,   706,  1009,
    1005,   840,  1037,   840,  1037,  1379,  1380,   840,  1037,   840,
    1037,  1380,   840,  1037,  1037,  1037,   840,    13,   446,  1352,
    1355,  1360,  1037,   556,   669,   670,  1344,   669,    98,   178,
     201,   233,   238,   288,   289,   384,   416,   422,   429,   464,
     467,   486,   846,  1209,  1224,   845,  1212,   260,   559,  1027,
    1037,  1037,  1364,  1297,  1117,  1181,   107,  1224,   861,   557,
     559,  1210,  1212,   296,  1344,   231,   231,   846,  1224,   421,
    1344,   597,   348,   556,   554,  1041,  1182,  1140,  1199,   556,
     556,   231,   556,   556,  1041,   556,   556,   556,   556,   556,
     556,   556,  1140,   556,   556,   556,   556,   556,   556,   556,
     556,  1041,   556,   556,   556,   556,   556,   556,   556,   556,
    1140,  1140,  1140,   506,  1041,  1140,  1178,  1203,  1364,   556,
    1364,    80,    83,    87,    88,    89,   104,   107,   112,   119,
     144,   255,   260,   282,   283,   297,   336,   350,   353,   440,
     540,   543,   544,   545,   547,   548,   549,   550,   551,   552,
    1173,  1175,  1177,  1366,   520,  1156,   360,  1140,   280,   559,
    1050,  1377,   556,  1364,  1203,    21,  1359,  1360,  1204,  1050,
     344,   348,  1329,  1329,     9,   505,  1316,  1317,  1319,  1296,
    1296,   187,   256,   606,   559,   137,   184,   597,   107,   184,
     301,   595,   706,  1136,  1364,  1366,  1364,   158,   200,  1152,
     167,   184,   591,   592,   594,   706,   184,   591,  1377,  1377,
     296,  1210,   159,   407,   827,   282,   557,   559,   594,   706,
     995,   997,   557,   559,  1047,  1211,   107,   557,   559,  1000,
    1043,  1043,  1058,  1059,  1140,  1043,   228,   324,  1069,   286,
     329,   390,   438,   498,    98,  1064,  1140,   547,   548,  1065,
    1066,  1140,  1142,  1078,  1079,  1063,  1062,  1060,  1061,   231,
    1081,   343,  1083,  1060,  1078,  1097,  1016,  1210,   107,  1344,
     435,  1178,  1289,   549,   559,   560,  1347,  1266,  1269,  1266,
     276,   179,   252,   313,  1139,   313,  1139,  1139,   316,  1220,
     313,   316,   426,  1363,  1363,   559,  1258,   183,  1296,   499,
    1245,  1247,  1212,   446,  1220,  1318,  1360,   559,   545,  1212,
      13,  1220,  1363,  1220,  1363,   559,  1276,  1212,   556,   556,
    1348,   134,   476,   476,   422,   260,   271,   354,   357,   437,
     508,   549,   881,   882,   883,   885,   887,   889,  1117,  1345,
     476,   511,   476,   422,  1215,   558,   476,   476,   422,   298,
     476,   476,   467,   587,   364,   968,   970,   545,   972,   231,
     242,   260,   411,   856,   857,   138,   156,   214,   233,   380,
     493,   665,   666,   156,   184,   333,   476,   156,   476,   184,
     333,   422,   156,   196,   206,   364,   402,   789,   422,   723,
      92,    97,   132,   145,   160,   201,   212,   233,   238,   310,
     350,   384,   416,   422,   429,   432,   464,   471,   479,   486,
     512,   715,  1212,   218,   402,   435,   610,   348,   706,   427,
     293,   476,  1344,   476,   338,   706,   188,   281,   422,   433,
     478,   589,   823,   408,   435,   893,   902,   192,   557,   876,
     881,   476,   499,   467,  1210,   146,   214,   254,   655,   665,
    1344,   146,   156,   927,   368,   348,   418,   420,   481,   156,
     927,   101,   405,   418,   420,   481,   418,  1210,   232,   266,
     343,   823,   556,   476,   476,   253,   556,   619,   307,   467,
     496,   521,   619,   156,   559,   192,   364,   260,   218,   402,
     435,   610,   930,   500,   500,   330,  1117,   476,   422,   556,
     907,  1212,  1210,   476,   476,   422,   902,   192,   464,   464,
     476,   476,   464,   792,   178,   435,   601,   476,   571,   601,
     476,   476,   422,   902,   192,  1210,   476,   476,  1210,  1119,
     706,   125,   705,   706,   706,   176,   311,   314,   125,   476,
     569,   318,   422,   569,   329,   704,   476,   476,   338,  1364,
     733,   823,   476,   476,   422,   451,  1364,   476,   387,   476,
     387,   792,   467,  1095,   368,   368,   156,   476,   927,   422,
     476,   476,   619,   619,   823,   823,   823,   823,  1210,   114,
     505,   114,   114,   476,   114,   476,   505,   422,   556,   559,
     601,   499,   750,  1223,   476,   571,   601,  1210,   476,   927,
     422,   364,   402,   390,   403,   431,   593,   960,  1179,  1179,
    1180,   557,    85,    86,   559,  1056,  1057,   555,   561,  1216,
    1344,  1210,   282,  1117,   348,   282,   523,   282,   706,   823,
     823,   282,   348,   282,   282,   348,   153,   195,   366,   469,
    1117,   348,   282,   282,   282,   476,   236,   476,   633,   486,
     556,   107,   218,   823,   793,   794,  1346,    96,   968,  1117,
     348,   218,   720,  1212,   333,   368,   556,   570,   806,   500,
     394,   512,  1210,    98,   464,   519,   897,   570,   218,  1223,
     163,   242,   585,   647,   699,   764,   841,   859,   964,   218,
    1364,   741,   742,   218,   348,  1364,  1223,   304,   823,   823,
     823,   823,   343,   189,   274,   484,   498,   766,   767,   210,
     389,   556,   750,   333,   570,  1210,   333,   701,   703,   333,
     107,   343,   368,   556,   668,   668,   254,   696,  1210,   231,
     254,   862,  1216,   556,   796,   888,   556,   879,   879,   107,
    1117,   288,   558,  1220,  1243,   519,   521,  1039,   424,   891,
     890,  1117,  1213,   556,   556,  1178,  1220,   825,  1134,  1134,
     106,  1118,   474,   474,  1220,  1220,  1117,   554,   554,  1220,
     476,   476,  1220,  1122,   877,   878,  1224,  1223,   218,   615,
     218,   500,   218,   500,   908,   909,   615,   877,  1224,   877,
    1212,  1212,  1117,   825,  1224,   750,   218,   218,   615,   822,
     823,  1211,  1212,  1212,   823,   557,   563,  1371,   557,  1377,
    1378,  1301,   254,  1210,   175,  1005,  1007,  1037,  1037,  1380,
    1037,  1037,  1380,  1037,  1037,  1212,    13,   559,  1359,   669,
     557,   559,   557,   239,   385,   417,   430,   465,  1211,   822,
     177,   432,   877,  1211,   342,   877,   877,  1211,  1209,  1209,
    1211,   822,   476,   519,   852,   213,   298,   747,   748,    92,
     216,   418,   438,  1028,  1095,   337,  1029,   557,   559,  1012,
     476,  1210,   921,   922,   924,   844,   843,   844,   236,   243,
     853,  1344,    97,   146,   178,   201,   212,   233,   238,   289,
     310,   384,   387,   413,   416,   422,   429,   458,   464,   467,
     486,   512,   715,   834,   835,  1178,   555,  1178,  1182,  1183,
     515,  1196,  1197,  1140,  1178,   556,  1220,  1220,   179,   252,
     313,   316,   426,   537,  1184,  1185,  1364,  1366,  1178,  1178,
    1178,  1220,  1220,  1140,  1140,   907,  1140,  1187,   418,   547,
     548,   556,  1141,  1142,  1175,  1189,   557,  1178,  1140,  1178,
    1190,  1140,   124,   236,   292,   477,  1140,  1178,  1193,  1178,
     318,  1142,  1140,  1150,  1151,  1152,   318,  1140,  1152,   557,
     559,  1220,  1138,  1117,  1140,  1140,  1140,  1140,  1346,   474,
     111,   461,  1205,   823,  1140,   556,  1041,  1194,   198,   200,
     224,   325,   326,   327,   328,   332,   333,   338,   343,   483,
     494,  1186,  1140,   556,  1140,   476,   119,   255,   260,   297,
     440,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,
    1140,    98,   105,   445,  1172,   245,   227,  1157,   418,   556,
    1169,   241,   301,   464,   468,   470,   496,  1051,  1210,  1208,
     236,  1085,  1179,  1212,  1360,  1201,  1085,  1318,   559,   545,
    1210,   478,   556,  1364,   559,  1377,   557,   253,   253,   615,
    1276,  1003,   993,   992,   996,  1140,   557,   310,   333,  1048,
    1003,  1001,   559,   108,   193,   500,   871,   418,   419,   547,
     548,  1066,  1068,  1142,   438,   286,   349,   559,  1067,  1220,
    1363,  1067,   418,   419,  1068,  1209,   337,   442,  1030,  1079,
    1061,   500,  1025,   184,   362,   556,  1017,  1040,   107,  1344,
     556,  1032,  1033,  1034,  1344,   557,   560,  1290,  1118,   563,
    1269,   563,   557,   706,   557,    33,  1246,  1321,  1322,  1360,
    1314,  1319,  1367,  1305,  1118,  1354,  1370,  1354,  1118,  1223,
    1212,  1212,   357,   125,  1345,   557,   883,   885,   882,   885,
    1345,   354,   557,   559,   824,  1223,  1212,  1212,  1215,  1223,
    1212,  1212,  1223,  1213,  1212,   184,   594,  1221,   413,   499,
     843,   422,   242,   843,   556,  1212,   500,   863,   286,   286,
     500,   556,   690,   254,  1212,   338,  1223,  1212,  1212,  1140,
     338,  1212,  1212,   101,   405,   476,   476,  1212,   476,   724,
     312,   890,   556,   823,   823,  1117,   481,   177,   464,   878,
     512,   140,   225,   909,   878,   878,  1212,   823,  1212,   823,
     425,   231,  1117,   823,   288,   248,   329,   364,   402,   504,
     727,   728,   729,  1095,   476,   927,   422,   338,   188,   281,
    1223,  1212,   348,  1212,   348,   557,   559,  1222,  1224,  1212,
     402,   610,   254,   655,   333,  1117,  1212,  1220,  1344,  1210,
    1212,   296,  1212,    98,   499,  1212,   254,  1212,   254,  1344,
     420,   481,   420,   481,   296,  1212,    98,   499,  1212,   296,
     418,  1210,    94,   203,   435,   734,   735,   736,   737,  1346,
    1223,  1212,   184,   237,   334,   500,   618,   621,   622,  1346,
    1212,   142,   346,  1212,   613,   348,   476,   467,  1210,   476,
     927,   422,   192,  1214,  1344,  1214,   559,   557,   559,  1223,
    1212,   933,   934,  1346,   348,   402,   476,   758,  1223,  1212,
    1212,   348,  1096,  1096,  1223,  1212,  1096,  1213,  1222,   155,
     208,   266,   370,   491,   499,   502,   572,  1366,  1223,  1212,
    1212,   348,   402,  1223,  1212,   402,   435,   610,   703,   706,
     823,  1212,   706,   823,  1212,   706,  1223,  1212,   435,  1223,
    1212,  1212,  1221,  1223,   897,  1212,   943,   944,  1346,  1212,
     402,   435,   610,   611,  1210,  1210,  1212,  1212,  1212,  1212,
    1223,  1212,    94,   100,   203,   364,   402,   435,   364,   402,
     435,   792,   402,   435,   402,   435,   402,   930,  1109,  1344,
     254,   802,  1344,   254,  1344,  1223,  1212,  1212,  1364,  1212,
     933,    94,   630,   432,  1222,   402,   435,   610,  1212,  1212,
    1212,   476,   476,   151,   490,   390,   559,  1056,  1056,  1056,
    1140,  1140,   508,  1180,   557,  1140,  1202,   338,   831,  1364,
     107,   201,   823,   831,   831,   282,   500,   500,   831,   823,
     831,   831,   823,   288,   823,   831,   831,   831,   386,   634,
     634,   264,   464,   763,  1140,  1117,   823,   557,   559,   545,
     766,   657,  1346,  1212,   129,   236,   422,   511,   721,   728,
     729,   218,   343,   297,   649,   651,   653,   655,   662,   665,
      95,   260,   413,   462,   572,   573,   231,  1214,   512,  1210,
     107,   759,   465,  1096,   792,   583,  1344,   584,   353,   648,
    1212,   233,   823,  1178,   387,  1364,   792,   792,   792,   792,
     343,   348,   353,   556,   792,  1107,  1108,  1109,   432,   218,
     556,   218,   218,   217,  1233,   823,   343,   649,  1344,   500,
     685,   519,   620,   333,   107,   668,  1364,   333,   348,   797,
     798,  1366,   792,   557,   880,   881,   886,   107,   288,   410,
     479,   518,   892,   893,   894,   892,   348,   288,   597,  1242,
     550,   251,   251,   231,   615,   107,   569,   232,   976,   977,
    1178,   557,   557,   615,   554,   539,   539,   557,   557,  1220,
     555,   556,  1220,  1344,  1364,  1375,   557,   557,   615,   822,
     823,  1214,   823,  1214,   615,   615,   615,   615,   288,   615,
     432,   231,   597,   615,   615,   348,   615,   333,  1039,  1367,
    1355,   557,   670,   260,   260,   260,   260,   260,   523,  1211,
     706,   707,   245,   847,   848,  1223,    95,   853,   476,   556,
     236,   216,   438,   216,   438,   418,   498,   315,  1117,  1223,
     519,   694,   861,   861,   236,   348,   847,   125,   615,   890,
    1117,   481,   464,   878,   342,   512,   878,   878,  1117,   288,
     823,  1212,   557,   555,   555,   559,  1140,   205,  1197,  1198,
     107,   557,  1140,   557,   557,   557,   236,   557,   557,   557,
     557,   557,   557,   559,   559,   557,   371,  1188,   557,   556,
    1141,  1141,  1178,    83,    87,    88,    89,   260,   282,   350,
     543,   544,   545,   547,   548,   549,   550,   551,   552,  1175,
    1141,   557,   557,   231,   236,  1191,  1192,   557,   107,  1193,
    1178,  1193,  1193,   236,   557,   557,  1346,   369,  1154,   107,
     557,   559,  1140,  1346,   559,  1140,  1204,  1140,   557,   539,
    1141,  1141,   211,  1178,   236,   198,   200,   224,   332,   338,
     343,   483,   494,  1186,   556,   332,   211,   907,  1140,   461,
    1205,  1140,  1194,  1140,   476,   556,  1041,   556,   556,   359,
    1161,   556,  1178,   468,   470,   468,   470,  1210,  1052,  1052,
    1052,   291,   419,   536,   556,  1041,  1086,  1087,  1088,  1095,
    1100,  1110,  1143,  1145,  1146,  1344,   516,  1105,  1056,  1105,
       7,    10,    11,    21,    22,    23,    25,    26,    30,    31,
      32,   177,   318,   376,   486,  1324,  1325,  1327,  1317,  1318,
     961,  1220,  1138,   592,  1118,  1003,   310,   556,  1059,   350,
    1173,  1176,   541,   872,  1220,  1363,  1068,   349,   519,   498,
    1065,   306,  1086,   516,  1106,   506,   463,   499,  1018,  1019,
    1020,  1344,   348,  1021,  1344,  1034,  1035,   559,  1085,   545,
    1204,   561,  1272,   560,   559,   545,    29,  1333,   557,   557,
     560,   889,   824,   885,   885,   125,   887,   551,  1224,  1224,
     348,  1211,   351,   348,  1140,   666,  1214,   556,   556,   556,
     690,   264,   669,   782,   218,   615,   476,  1223,  1212,   597,
    1212,  1117,  1212,   523,   823,   823,   823,   823,   153,   195,
     366,   469,  1117,  1212,   710,  1212,   248,   504,   476,   476,
     710,   727,   733,   402,   435,   610,  1212,  1212,  1212,   272,
     338,   221,   881,   363,   435,   476,   333,   218,   352,   731,
     782,   435,    94,   203,   406,   407,   435,   614,   623,   624,
     733,   928,   427,   218,   615,   218,   615,  1212,  1212,  1212,
    1212,   427,   427,   296,   736,   737,   736,   557,   559,   738,
    1364,   264,   557,   559,   545,   558,   221,  1223,  1212,   402,
     435,   610,  1212,  1212,  1212,   348,   364,   402,   435,    94,
     203,   364,   402,   435,  1117,   330,  1117,   557,   559,   545,
    1210,   476,  1224,   500,   755,   221,   298,   370,   338,  1364,
     370,  1224,   497,   221,   476,   476,   422,   451,   559,   897,
     363,   435,   156,   476,   927,   422,   184,   231,   625,   476,
     476,   308,   308,   308,   476,   476,   422,   476,   476,   422,
     476,   422,   476,   422,   476,   192,   615,  1117,   333,  1364,
     435,   928,   218,   615,   476,   476,   557,  1212,   476,   927,
     422,   476,  1223,  1212,   557,   557,   557,  1180,   555,  1117,
     823,   282,   831,  1214,  1214,   282,   282,  1212,   282,   452,
     453,   635,  1364,   635,   248,   557,   557,   236,   792,   794,
     330,   350,   547,   548,   706,   795,   885,  1176,  1229,  1364,
     348,   138,   144,   156,   184,   186,   240,   268,   333,   338,
     380,   396,   493,   658,   659,   661,   217,   515,   569,   597,
    1212,   597,   731,  1210,  1210,  1210,   557,   559,  1224,   245,
     413,  1224,  1220,   486,  1210,   668,  1366,   231,   760,   115,
     584,   404,   464,   740,   177,  1000,   236,   943,   620,   669,
    1210,   767,   799,   800,  1364,   557,   559,  1212,   231,   669,
    1210,   693,  1210,  1252,  1040,   556,   650,  1210,   557,  1214,
     519,   521,   686,   619,   107,   218,  1040,   685,   476,   218,
    1095,   557,   559,   545,   557,   559,   184,   545,   895,  1364,
     597,   464,   884,   885,   231,   896,   894,   189,   274,   428,
     498,   952,  1212,   248,  1238,  1040,  1252,  1117,   556,   557,
     559,   557,  1220,  1137,  1137,   555,  1375,   556,   547,   548,
     549,   550,   551,   555,   615,   500,   615,   500,   615,  1212,
    1212,   750,   615,   823,   218,   231,   422,   422,   422,   422,
     422,  1211,   559,  1223,   519,   559,   849,   351,  1096,   432,
     216,   216,   177,   329,  1210,  1212,  1224,   846,   615,  1223,
     282,   282,   282,   706,   282,   282,   282,   282,   282,  1182,
     472,  1140,   209,  1117,   557,  1140,  1186,  1140,  1140,  1191,
     557,  1178,   559,  1117,  1141,  1141,  1141,  1141,   198,   200,
     333,   343,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,
    1141,  1141,  1140,  1140,  1192,  1191,  1117,   557,   557,   557,
    1178,   557,   559,   125,  1142,  1155,   557,  1346,  1151,   377,
     457,  1153,   557,   559,   511,  1147,   107,   557,  1364,  1140,
     104,   104,  1140,   557,  1140,   236,   556,   332,  1181,  1140,
     557,   211,  1141,  1141,   211,   211,  1140,  1140,  1057,   516,
     556,  1162,  1344,   557,  1178,   559,  1052,  1052,  1052,  1052,
    1210,  1210,  1210,  1041,  1100,  1110,   236,   556,  1041,  1087,
    1088,   107,  1089,  1090,  1344,   559,   164,   237,   270,   285,
     295,   321,   412,  1092,  1090,   107,  1089,  1091,  1344,  1090,
     542,  1104,  1203,  1140,   245,  1070,   557,  1070,   559,   545,
     557,  1333,  1012,   556,   872,   228,   290,   349,   519,   473,
     167,  1140,   409,  1023,   505,   557,   559,  1204,   154,  1023,
     557,   559,  1033,  1106,  1140,  1220,   545,  1291,  1322,  1327,
     557,   551,   889,   486,   239,   417,   423,   430,   465,   487,
     858,   231,   858,   557,   556,   673,   674,   866,  1145,  1344,
     669,   669,   782,  1216,   557,   186,   268,   329,   333,   783,
    1212,  1212,   107,  1212,   500,   500,   823,   823,   823,   823,
     288,   824,  1223,  1212,   476,   927,   422,   476,   272,  1212,
     125,   467,  1212,   218,   655,   556,   657,   451,   240,   220,
     253,   333,   619,   569,   177,   240,   333,   451,   454,   619,
     704,   435,   624,   486,  1212,  1344,   427,   735,  1212,   622,
     795,  1346,  1212,   363,   435,   476,   927,   422,   476,   221,
     476,   476,   422,   238,   350,   454,   804,   805,   238,   350,
     812,   813,   476,   476,   422,   557,   557,   557,   934,   330,
     706,   885,   935,  1176,  1229,  1364,   402,  1212,   556,   519,
     756,  1212,  1221,  1364,  1364,  1364,  1212,  1212,  1212,  1212,
    1221,   944,   125,   467,  1212,  1212,  1212,  1212,   506,  1212,
    1212,   231,   231,   404,   231,   254,  1223,  1212,  1212,  1223,
    1212,  1212,  1212,  1212,  1212,  1212,  1212,   348,   144,   616,
     218,    96,   117,   486,  1344,  1212,  1364,   733,  1212,  1212,
    1212,  1212,  1056,   557,   282,   831,   282,   282,   831,   831,
     282,   831,   569,   500,   640,   641,   710,   782,   519,   521,
     823,  1210,   556,   823,  1212,  1141,   101,   125,   660,   187,
     256,   186,   338,   286,  1210,   897,   238,   384,   778,   785,
     786,  1344,   720,   368,   556,   650,   663,   267,   680,   653,
    1224,  1224,  1117,   556,   620,    98,   189,   274,   428,   498,
     761,   476,   757,  1223,   254,  1210,   742,   523,   348,  1086,
     897,   397,   768,   557,   559,  1109,   731,   750,   557,   701,
     107,   343,   368,   556,  1014,   694,   652,   654,   656,   665,
    1344,   368,   681,   682,   650,   680,   619,   346,   348,   687,
    1040,   696,   694,   620,  1364,  1216,   863,   798,  1366,   795,
     886,  1140,  1140,   559,   556,   892,   486,   559,   476,   556,
     710,    80,  1249,   557,   976,   977,   555,   557,  1276,  1375,
    1375,  1375,  1375,  1375,  1214,  1214,   615,   432,   615,  1211,
    1211,  1211,  1211,  1211,   706,   242,   848,   557,  1212,   177,
     853,   236,   338,   836,  1364,   836,   836,   282,   836,   836,
     836,   836,   836,  1140,   557,   557,   557,  1192,   557,  1140,
     236,   198,   200,   343,   556,   557,   526,  1149,  1178,   395,
     505,   125,  1155,  1142,   517,   517,   557,  1140,   329,  1140,
     559,  1148,  1119,  1140,  1140,  1140,  1181,   557,  1140,   104,
     104,  1140,  1140,   211,   557,   557,  1140,  1163,  1344,   557,
    1140,  1210,  1210,  1210,  1210,  1090,  1091,  1090,   556,   531,
    1142,   557,  1344,   556,  1087,   285,   358,  1093,  1087,  1093,
     285,  1092,  1093,   285,   466,  1098,   556,  1344,   556,   355,
     125,   249,  1077,  1364,  1077,  1325,   548,  1318,  1326,  1363,
    1364,  1364,   557,   907,   473,   343,  1207,  1040,   362,  1040,
    1020,   348,   556,  1022,   545,  1034,  1023,  1371,   486,   557,
     476,   843,   236,   782,  1140,   557,   559,   519,   144,   865,
     869,   865,   557,   557,   261,   671,   187,   256,   266,   186,
     502,   615,  1117,  1214,  1214,  1212,  1212,  1212,  1212,  1212,
    1224,  1212,   655,   732,   736,  1221,   660,   254,   254,   338,
     706,   660,   338,  1221,  1344,  1117,   615,   615,   545,   125,
     467,  1212,  1212,  1212,  1212,  1212,  1223,  1212,  1212,  1220,
    1220,  1117,   559,  1220,  1220,   559,  1223,  1212,  1212,   476,
    1140,   138,  1224,  1212,   476,   476,   236,   260,   519,  1211,
    1211,   823,  1211,   218,   221,   823,  1364,  1364,  1117,   615,
     615,   476,   557,   282,   831,   831,   831,   831,   556,   636,
     637,   569,   191,   238,   271,   238,   236,   781,  1140,   333,
     659,   184,   107,   897,   668,   500,   689,  1218,   104,   217,
     260,   343,   649,   625,   215,   262,   556,   432,   500,   669,
     107,  1224,   755,   584,   333,   556,   233,  1212,  1178,   323,
     347,   769,   770,   771,   231,   774,  1364,   432,   620,   217,
    1234,   823,   343,   649,   694,   557,   559,   519,   657,   125,
     685,   625,   681,   150,   467,   688,   519,   965,   107,   688,
     236,   348,   556,  1364,   883,   898,   899,  1345,  1117,   231,
    1210,   236,   476,   918,   269,   711,  1250,  1344,   615,   557,
     557,   615,   615,  1212,   351,   280,   615,   847,   836,   557,
    1141,   236,   556,  1181,   556,   557,   559,   557,  1155,   557,
     505,   448,   557,   557,   557,  1140,  1140,  1140,   557,   368,
    1164,   557,  1101,  1102,  1145,   556,  1154,  1089,   556,  1211,
    1087,   348,   500,  1094,  1087,   285,  1087,  1218,  1108,   556,
    1108,  1344,   166,   246,   415,   556,  1071,  1072,  1073,  1074,
    1075,  1076,  1140,  1140,   518,  1158,  1158,  1220,  1363,   557,
    1037,  1378,  1018,   156,   864,   866,   199,  1140,   847,   348,
     847,   557,   671,   674,   350,   907,   823,   823,   870,   396,
     671,   556,   897,   557,   476,   435,  1029,   557,   559,   107,
     218,   218,   616,   795,  1224,  1212,   476,   556,   878,   907,
     909,   805,   556,   556,   813,  1212,   557,   556,   435,  1029,
    1212,  1212,   556,   556,   556,   519,   542,   985,   404,   985,
     985,   231,  1212,   616,  1212,   831,   642,   643,  1346,   121,
     165,   190,   207,   211,   232,   235,   250,   338,   388,   638,
     636,  1364,   878,   107,   914,   914,  1210,   782,   557,   253,
     556,   689,   309,   672,   264,   556,   786,   778,   556,  1210,
     557,   432,    98,   149,   157,   185,   240,   253,   265,   451,
     454,   664,   664,  1209,  1212,  1214,   557,  1040,   756,   218,
     177,   731,   236,   770,   418,   464,   772,   204,   775,   515,
     777,  1212,   107,  1252,  1040,   650,  1210,   557,  1376,   654,
     352,  1344,   686,   681,   685,   189,   203,   377,  1212,   130,
     138,   301,  1040,   823,  1095,   864,   885,   557,   559,   486,
    1105,   446,   446,   557,   710,   329,   504,   712,   713,   545,
    1251,  1212,   615,  1141,  1181,   557,  1150,  1178,   329,   538,
     125,  1056,   557,   559,   107,  1103,   184,  1115,  1116,  1141,
     147,  1211,   557,  1140,   556,  1087,  1094,   556,   557,  1108,
     557,   556,   436,   556,   557,   559,  1159,  1160,  1344,   505,
    1212,   557,   559,   334,   498,   849,   858,   615,   865,   897,
     556,   619,   871,  1210,   897,   669,   689,  1212,   467,   736,
     253,   500,   617,   435,  1029,  1212,  1181,   231,   808,   808,
    1181,  1181,  1140,   467,  1178,  1178,   626,   627,  1225,   822,
     823,   822,   823,  1211,   615,   557,   559,   549,   556,   594,
     644,   706,   982,  1364,   982,   333,   338,   388,   982,   982,
    1105,   914,   110,   258,   231,   329,   667,   556,   702,  1140,
     237,   367,   441,   348,   676,   677,   678,   467,   557,  1218,
      76,   787,   650,   680,  1212,   557,   731,   225,   807,   620,
     965,  1210,   523,  1086,   982,   418,   450,   776,   556,   217,
     731,  1040,  1014,   694,   681,   650,   680,   657,   556,   687,
     685,   686,   419,   419,   138,   351,   138,   694,   863,   557,
     892,   898,  1117,   199,   519,   519,   504,   710,  1220,  1358,
    1366,    80,   731,   557,   557,   557,   505,  1178,   247,   389,
     419,  1165,  1104,  1101,   556,  1141,   557,   559,   107,  1111,
    1112,  1344,   557,  1211,  1178,   557,  1178,   556,  1178,  1072,
     559,   107,  1040,  1105,   866,   435,   236,   689,   907,   871,
     872,   668,   689,   557,   782,  1212,   702,  1140,   467,   557,
     354,   425,   393,   809,   809,   557,   557,   557,  1212,   557,
     557,   557,   559,  1220,   985,   643,   594,   645,   646,  1364,
    1364,   338,   669,   549,   669,  1364,  1364,   204,   266,   703,
     557,   189,   498,   348,   678,   348,   677,  1212,   556,   557,
     559,   625,   432,   731,   823,   107,   107,   556,  1212,   773,
    1344,  1140,   778,   965,   694,   685,   625,   681,   556,   683,
     684,  1145,  1344,   688,   686,   687,   351,   351,   556,   261,
     867,    99,   275,   953,   238,   238,  1250,   119,   167,   489,
    1140,  1166,  1167,  1166,  1166,   557,  1108,   559,  1116,  1346,
     557,   559,   231,  1117,   557,   557,   557,  1071,   557,  1160,
    1162,  1032,   847,   516,   675,   557,   872,   672,   782,  1029,
    1212,   878,   125,  1029,   476,   626,   823,   557,   559,   669,
     418,   557,   455,   129,   329,   408,   435,   679,   679,   557,
      76,   432,  1212,   804,  1040,   731,   557,  1218,  1376,   686,
     681,   685,  1140,   557,   559,   869,   869,   687,   688,   864,
     556,   620,   334,   556,   948,   950,   954,  1015,  1024,  1031,
    1040,   878,   878,  1167,   418,   230,   375,   230,   375,   214,
    1168,  1168,  1168,   557,  1142,  1112,   355,   184,   333,   338,
    1113,  1114,  1366,   403,  1099,   557,  1105,   615,   556,   782,
     676,  1029,   823,   556,   646,   777,    93,   184,   338,  1212,
     731,   965,   556,   687,   685,   686,   557,   684,   823,   870,
     870,   688,   557,   866,   868,   688,   949,   950,   951,  1041,
    1042,   559,   559,   104,   167,   245,   329,   473,  1154,  1141,
     338,  1114,  1141,   556,  1140,   782,  1178,   217,   731,   779,
     780,  1220,  1346,  1363,  1364,   688,   686,   687,   869,   867,
     557,   559,  1105,   557,   560,   476,   236,  1167,   418,   356,
     147,  1140,   557,   557,   778,   557,   559,   687,   688,   870,
     620,   866,   951,   446,   446,  1111,   557,  1218,   780,   688,
     688,   519,   519,   557,   556,  1105,   238,   238,   779,   878,
     878,   557
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   564,   565,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   567,   568,
     569,   569,   569,   570,   570,   571,   571,   572,   572,   572,
     572,   572,   572,   572,   572,   572,   573,   573,   573,   573,
     573,   573,   574,   575,   575,   576,   576,   577,   577,   577,
     577,   578,   578,   578,   578,   578,   578,   579,   580,   581,
     581,   582,   582,   582,   582,   583,   583,   584,   584,   585,
     585,   585,   585,   585,   585,   586,   586,   586,   587,   587,
     587,   588,   588,   588,   588,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   590,   590,   591,   591,
     592,   592,   593,   593,   593,   593,   594,   594,   594,   594,
     595,   595,   595,   595,   595,   595,   595,   596,   596,   596,
     597,   597,   598,   599,   599,   599,   599,   600,   600,   601,
     601,   602,   602,   603,   603,   603,   603,   603,   604,   605,
     605,   606,   606,   607,   608,   608,   608,   608,   608,   609,
     609,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   609,   609,   609,   609,   609,   609,   610,   610,
     611,   611,   612,   613,   613,   613,   613,   613,   613,   613,
     613,   613,   613,   613,   613,   613,   613,   613,   613,   613,
     613,   613,   613,   613,   613,   613,   613,   613,   613,   613,
     613,   613,   613,   613,   613,   613,   613,   613,   613,   613,
     613,   613,   613,   613,   613,   613,   613,   613,   613,   613,
     613,   613,   613,   613,   613,   613,   613,   613,   613,   613,
     613,   614,   614,   615,   615,   615,   616,   616,   617,   617,
     618,   618,   618,   618,   619,   620,   620,   621,   621,   622,
     622,   622,   622,   623,   623,   624,   624,   624,   624,   625,
     625,   625,   625,   626,   627,   627,   628,   629,   629,   630,
     630,   630,   630,   631,   631,   632,   632,   633,   633,   634,
     634,   635,   635,   635,   636,   636,   637,   637,   638,   638,
     638,   638,   638,   638,   638,   638,   638,   638,   638,   638,
     638,   639,   639,   640,   640,   641,   641,   642,   642,   643,
     644,   644,   644,   644,   644,   645,   645,   646,   647,   647,
     647,   647,   647,   647,   648,   648,   648,   648,   648,   648,
     648,   648,   649,   649,   650,   650,   651,   651,   652,   652,
     653,   653,   653,   654,   654,   655,   656,   656,   657,   657,
     658,   658,   658,   658,   659,   659,   659,   659,   659,   659,
     659,   659,   659,   660,   660,   661,   661,   661,   661,   662,
     663,   663,   663,   664,   664,   664,   664,   664,   664,   664,
     664,   664,   665,   665,   666,   666,   666,   666,   666,   666,
     666,   667,   667,   668,   668,   669,   669,   670,   671,   671,
     672,   672,   672,   672,   673,   673,   674,   674,   675,   675,
     676,   676,   676,   676,   676,   677,   678,   679,   679,   679,
     679,   679,   680,   680,   681,   681,   682,   683,   683,   684,
     684,   684,   685,   685,   686,   686,   686,   687,   687,   687,
     687,   688,   688,   689,   689,   690,   691,   691,   692,   692,
     693,   694,   694,   694,   695,   695,   696,   697,   697,   698,
     699,   699,   700,   700,   701,   701,   702,   702,   703,   703,
     704,   704,   704,   704,   704,   704,   704,   704,   704,   704,
     704,   704,   704,   704,   705,   705,   706,   706,   706,   706,
     707,   707,   708,   708,   709,   709,   710,   710,   711,   711,
     712,   712,   713,   713,   714,   714,   715,   715,   716,   717,
     717,   718,   718,   719,   719,   720,   720,   721,   721,   721,
     721,   722,   723,   723,   724,   725,   725,   725,   725,   725,
     725,   725,   725,   725,   725,   725,   725,   725,   725,   725,
     725,   725,   725,   725,   725,   725,   725,   725,   725,   725,
     725,   725,   725,   726,   727,   727,   727,   727,   728,   728,
     729,   729,   730,   730,   731,   731,   732,   732,   733,   734,
     734,   735,   735,   735,   735,   736,   737,   738,   739,   739,
     740,   740,   741,   741,   742,   742,   743,   743,   743,   744,
     744,   744,   744,   745,   745,   746,   747,   747,   748,   748,
     749,   749,   750,   750,   751,   751,   752,   753,   754,   755,
     755,   756,   756,   757,   757,   758,   758,   759,   759,   760,
     760,   761,   761,   761,   761,   761,   762,   763,   763,   764,
     764,   765,   765,   765,   766,   766,   767,   767,   767,   767,
     767,   768,   768,   769,   769,   770,   771,   771,   772,   772,
     773,   774,   774,   775,   775,   776,   776,   777,   777,   778,
     778,   779,   779,   779,   780,   780,   780,   780,   781,   781,
     782,   782,   783,   783,   783,   783,   783,   783,   784,   784,
     785,   785,   786,   787,   787,   788,   789,   789,   789,   789,
     790,   791,   791,   791,   791,   791,   791,   791,   791,   791,
     791,   791,   791,   791,   791,   791,   791,   792,   793,   793,
     794,   794,   795,   795,   795,   795,   795,   795,   796,   797,
     797,   798,   799,   799,   800,   800,   801,   801,   801,   801,
     802,   802,   803,   804,   804,   805,   805,   805,   805,   805,
     806,   806,   807,   807,   808,   808,   808,   809,   809,   810,
     811,   811,   812,   812,   813,   813,   814,   814,   815,   815,
     816,   817,   818,   818,   818,   818,   818,   818,   818,   818,
     818,   818,   818,   818,   819,   819,   819,   819,   819,   819,
     819,   819,   819,   819,   819,   819,   819,   820,   820,   820,
     820,   820,   820,   820,   821,   821,   821,   822,   822,   823,
     823,   824,   824,   825,   825,   826,   827,   827,   827,   828,
     828,   828,   828,   828,   828,   828,   828,   828,   828,   828,
     828,   828,   828,   828,   828,   828,   828,   828,   829,   829,
     829,   829,   829,   829,   829,   829,   829,   829,   829,   829,
     829,   829,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   831,   831,   832,   832,   832,   832,
     832,   832,   832,   832,   832,   833,   833,   834,   834,   834,
     834,   834,   834,   835,   835,   835,   835,   835,   835,   835,
     835,   836,   836,   837,   837,   837,   837,   837,   837,   837,
     837,   837,   837,   837,   838,   838,   838,   838,   838,   838,
     838,   838,   838,   838,   838,   838,   838,   838,   839,   839,
     840,   840,   841,   842,   842,   843,   843,   843,   843,   843,
     844,   844,   845,   845,   845,   845,   846,   846,   846,   846,
     846,   846,   846,   846,   846,   846,   846,   846,   846,   846,
     846,   846,   846,   846,   846,   846,   847,   847,   848,   848,
     849,   849,   850,   851,   851,   852,   852,   853,   853,   854,
     855,   855,   856,   856,   856,   857,   857,   857,   858,   858,
     858,   858,   858,   858,   859,   859,   860,   860,   861,   861,
     862,   862,   863,   863,   864,   864,   865,   865,   866,   866,
     866,   867,   867,   868,   868,   869,   869,   870,   870,   871,
     871,   871,   872,   872,   872,   873,   873,   873,   873,   874,
     874,   875,   875,   876,   876,   877,   877,   878,   878,   878,
     878,   879,   879,   880,   880,   881,   881,   881,   881,   881,
     882,   882,   882,   882,   882,   883,   884,   885,   885,   885,
     886,   886,   886,   887,   888,   888,   888,   888,   889,   889,
     890,   891,   891,   892,   892,   893,   893,   893,   893,   893,
     893,   893,   893,   893,   893,   893,   893,   893,   893,   893,
     893,   893,   894,   894,   894,   894,   894,   895,   895,   896,
     896,   897,   897,   898,   899,   899,   900,   900,   900,   901,
     901,   902,   902,   903,   903,   903,   903,   903,   903,   904,
     904,   905,   905,   906,   906,   906,   906,   907,   907,   908,
     908,   909,   910,   911,   911,   912,   912,   913,   913,   913,
     914,   914,   914,   915,   916,   916,   917,   918,   918,   918,
     918,   919,   920,   920,   920,   920,   921,   921,   922,   922,
     922,   923,   923,   924,   925,   925,   926,   926,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   926,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   926,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   926,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   926,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   926,   926,   926,
     926,   927,   927,   928,   928,   929,   929,   929,   929,   929,
     929,   930,   930,   931,   931,   931,   931,   931,   931,   931,
     931,   931,   931,   931,   931,   931,   931,   931,   931,   931,
     931,   931,   931,   931,   931,   931,   931,   931,   931,   931,
     932,   933,   933,   934,   934,   935,   935,   935,   935,   935,
     936,   937,   937,   937,   937,   937,   937,   937,   937,   937,
     937,   937,   937,   937,   937,   937,   937,   937,   937,   937,
     937,   937,   937,   937,   937,   938,   939,   939,   940,   940,
     941,   941,   941,   941,   942,   943,   943,   944,   945,   945,
     945,   945,   945,   945,   946,   946,   947,   948,   948,   948,
     949,   949,   950,   950,   950,   950,   950,   951,   951,   952,
     952,   952,   952,   953,   953,   953,   954,   955,   955,   956,
     957,   957,   958,   958,   958,   958,   958,   958,   958,   958,
     958,   958,   958,   958,   958,   958,   959,   959,   959,   960,
     960,   960,   960,   960,   961,   961,   961,   962,   962,   963,
     963,   963,   964,   964,   964,   964,   965,   965,   965,   965,
     966,   967,   968,   968,   969,   969,   970,   970,   970,   971,
     971,   971,   971,   971,   971,   971,   972,   972,   973,   973,
     973,   974,   975,   975,   975,   975,   976,   976,   977,   978,
     979,   979,   980,   981,   981,   981,   981,   981,   981,   981,
     982,   982,   983,   984,   984,   984,   984,   984,   984,   985,
     985,   986,   987,   987,   987,   988,   988,   989,   989,   990,
     990,   991,   991,   992,   992,   993,   994,   994,   995,   995,
     995,   996,   996,   997,   997,   998,   998,   999,   999,  1000,
    1000,  1001,  1002,  1002,  1003,  1003,  1004,  1004,  1004,  1004,
    1005,  1005,  1005,  1005,  1005,  1005,  1005,  1005,  1005,  1006,
    1006,  1007,  1008,  1008,  1009,  1009,  1009,  1010,  1010,  1011,
    1011,  1012,  1012,  1012,  1012,  1013,  1013,  1013,  1014,  1014,
    1015,  1016,  1016,  1017,  1017,  1017,  1017,  1017,  1018,  1018,
    1019,  1019,  1020,  1021,  1021,  1021,  1022,  1022,  1022,  1023,
    1023,  1024,  1025,  1025,  1026,  1027,  1027,  1028,  1028,  1028,
    1028,  1028,  1028,  1028,  1028,  1029,  1029,  1030,  1030,  1030,
    1031,  1032,  1032,  1033,  1033,  1034,  1035,  1035,  1036,  1037,
    1037,  1038,  1038,  1038,  1038,  1038,  1039,  1039,  1039,  1040,
    1040,  1041,  1041,  1042,  1042,  1042,  1042,  1042,  1042,  1042,
    1042,  1043,  1043,  1044,  1044,  1044,  1044,  1044,  1044,  1044,
    1045,  1045,  1045,  1046,  1046,  1047,  1048,  1048,  1048,  1049,
    1049,  1050,  1050,  1050,  1051,  1051,  1051,  1051,  1051,  1051,
    1051,  1051,  1051,  1052,  1052,  1053,  1053,  1053,  1054,  1054,
    1055,  1055,  1056,  1056,  1057,  1058,  1058,  1059,  1059,  1060,
    1060,  1060,  1060,  1061,  1061,  1062,  1062,  1062,  1062,  1062,
    1062,  1063,  1063,  1064,  1064,  1065,  1066,  1066,  1066,  1067,
    1067,  1068,  1068,  1069,  1069,  1070,  1070,  1071,  1071,  1072,
    1072,  1072,  1072,  1072,  1073,  1074,  1075,  1076,  1077,  1077,
    1078,  1078,  1079,  1079,  1080,  1080,  1081,  1082,  1082,  1082,
    1082,  1083,  1083,  1084,  1084,  1085,  1085,  1086,  1086,  1087,
    1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1088,
    1088,  1088,  1088,  1088,  1088,  1089,  1089,  1089,  1089,  1090,
    1090,  1091,  1091,  1091,  1091,  1091,  1092,  1092,  1092,  1092,
    1093,  1093,  1094,  1094,  1095,  1095,  1095,  1095,  1096,  1096,
    1097,  1097,  1097,  1098,  1099,  1099,  1100,  1100,  1101,  1102,
    1102,  1103,  1103,  1104,  1104,  1105,  1105,  1106,  1106,  1106,
    1107,  1107,  1108,  1108,  1109,  1110,  1110,  1111,  1111,  1112,
    1112,  1112,  1113,  1113,  1114,  1114,  1114,  1114,  1115,  1115,
    1116,  1116,  1117,  1117,  1117,  1117,  1117,  1117,  1118,  1118,
    1118,  1119,  1119,  1119,  1119,  1119,  1119,  1119,  1120,  1120,
    1120,  1120,  1121,  1121,  1122,  1122,  1123,  1123,  1123,  1123,
    1123,  1123,  1123,  1123,  1123,  1123,  1123,  1124,  1124,  1125,
    1125,  1126,  1126,  1127,  1128,  1129,  1129,  1130,  1130,  1131,
    1132,  1133,  1133,  1133,  1133,  1133,  1133,  1134,  1134,  1135,
    1135,  1135,  1135,  1136,  1137,  1137,  1137,  1138,  1138,  1138,
    1138,  1138,  1138,  1138,  1138,  1138,  1138,  1138,  1138,  1138,
    1138,  1139,  1139,  1140,  1140,  1140,  1140,  1140,  1140,  1140,
    1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,
    1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,
    1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,
    1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,
    1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,
    1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,
    1140,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,
    1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,  1141,
    1141,  1141,  1141,  1141,  1141,  1141,  1142,  1142,  1142,  1142,
    1142,  1142,  1142,  1142,  1142,  1142,  1142,  1142,  1142,  1142,
    1143,  1143,  1143,  1143,  1143,  1143,  1143,  1144,  1144,  1145,
    1145,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,
    1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,
    1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,
    1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,
    1146,  1146,  1146,  1146,  1146,  1147,  1147,  1148,  1148,  1148,
    1148,  1149,  1150,  1150,  1151,  1151,  1152,  1152,  1153,  1153,
    1153,  1154,  1154,  1154,  1154,  1155,  1155,  1156,  1156,  1157,
    1157,  1158,  1158,  1159,  1159,  1160,  1161,  1161,  1161,  1162,
    1163,  1163,  1164,  1164,  1165,  1165,  1165,  1165,  1166,  1166,
    1167,  1167,  1167,  1167,  1167,  1168,  1168,  1168,  1168,  1168,
    1169,  1169,  1169,  1170,  1170,  1171,  1172,  1172,  1172,  1173,
    1173,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,  1174,
    1174,  1174,  1174,  1175,  1175,  1176,  1176,  1177,  1177,  1177,
    1177,  1177,  1177,  1178,  1178,  1179,  1179,  1180,  1180,  1180,
    1181,  1181,  1182,  1182,  1182,  1183,  1183,  1184,  1184,  1185,
    1185,  1185,  1185,  1185,  1185,  1185,  1185,  1186,  1186,  1186,
    1186,  1187,  1187,  1188,  1189,  1189,  1190,  1190,  1190,  1190,
    1190,  1190,  1191,  1192,  1193,  1193,  1193,  1194,  1194,  1195,
    1196,  1196,  1197,  1198,  1198,  1199,  1199,  1200,  1200,  1201,
    1201,  1201,  1201,  1202,  1202,  1203,  1203,  1204,  1204,  1205,
    1205,  1206,  1206,  1207,  1207,  1208,  1208,  1208,  1208,  1209,
    1209,  1210,  1210,  1211,  1211,  1212,  1213,  1214,  1215,  1216,
    1217,  1218,  1218,  1219,  1219,  1219,  1219,  1219,  1219,  1219,
    1219,  1219,  1219,  1219,  1219,  1219,  1219,  1219,  1220,  1221,
    1221,  1221,  1221,  1222,  1223,  1223,  1223,  1224,  1224,  1225,
    1225,  1225,  1225,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1227,  1227,  1227,  1227,  1227,  1227,  1227,
    1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,
    1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,
    1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,
    1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,
    1227,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1230,
    1230,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1231,  1233,
    1232,  1234,  1232,  1235,  1236,  1236,  1236,  1236,  1237,  1237,
    1237,  1237,  1238,  1238,  1239,  1240,  1241,  1241,  1242,  1242,
    1242,  1243,  1243,  1244,  1244,  1245,  1245,  1246,  1246,  1246,
    1246,  1247,  1247,  1247,  1248,  1249,  1249,  1250,  1250,  1251,
    1251,  1251,  1251,  1252,  1252,  1253,  1254,  1255,  1256,  1256,
    1257,  1258,  1258,  1259,  1259,  1259,  1259,  1259,  1261,  1260,
    1262,  1263,  1264,  1264,  1265,  1265,  1265,  1265,  1266,  1266,
    1268,  1267,  1270,  1269,  1271,  1269,  1269,  1272,  1272,  1273,
    1273,  1273,  1274,  1274,  1274,  1274,  1275,  1275,  1276,  1276,
    1276,  1276,  1276,  1276,  1277,  1277,  1277,  1278,  1280,  1279,
    1281,  1282,  1281,  1283,  1283,  1284,  1284,  1285,  1285,  1286,
    1286,  1286,  1286,  1286,  1286,  1286,  1286,  1286,  1287,  1287,
    1287,  1287,  1287,  1287,  1287,  1287,  1287,  1287,  1288,  1288,
    1289,  1289,  1290,  1291,  1291,  1292,  1292,  1292,  1293,  1294,
    1295,  1295,  1295,  1295,  1296,  1296,  1296,  1297,  1297,  1298,
    1298,  1299,  1300,  1300,  1301,  1301,  1302,  1302,  1303,  1303,
    1304,  1305,  1305,  1306,  1306,  1306,  1307,  1307,  1307,  1307,
    1307,  1307,  1307,  1307,  1307,  1308,  1308,  1308,  1308,  1308,
    1309,  1309,  1310,  1311,  1312,  1313,  1313,  1314,  1315,  1316,
    1316,  1317,  1318,  1318,  1319,  1320,  1321,  1321,  1322,  1323,
    1324,  1324,  1325,  1326,  1326,  1326,  1326,  1326,  1327,  1327,
    1327,  1327,  1327,  1327,  1327,  1327,  1327,  1327,  1327,  1327,
    1327,  1327,  1327,  1328,  1328,  1329,  1329,  1330,  1330,  1330,
    1332,  1331,  1333,  1333,  1335,  1334,  1336,  1336,  1336,  1337,
    1337,  1337,  1337,  1337,  1337,  1337,  1337,  1337,  1337,  1338,
    1338,  1339,  1339,  1339,  1339,  1339,  1339,  1339,  1339,  1339,
    1339,  1339,  1339,  1339,  1339,  1339,  1339,  1339,  1339,  1339,
    1339,  1339,  1339,  1340,  1340,  1340,  1340,  1340,  1340,  1341,
    1341,  1341,  1341,  1341,  1341,  1341,  1342,  1343,  1343,  1343,
    1343,  1343,  1343,  1343,  1343,  1344,  1344,  1344,  1344,  1344,
    1344,  1344,  1345,  1345,  1345,  1345,  1345,  1345,  1346,  1346,
    1346,  1346,  1346,  1346,  1346,  1346,  1346,  1346,  1346,  1347,
    1347,  1347,  1347,  1347,  1348,  1348,  1348,  1348,  1349,  1349,
    1349,  1349,  1349,  1349,  1349,  1350,  1350,  1350,  1351,  1351,
    1351,  1351,  1351,  1351,  1352,  1352,  1353,  1354,  1354,  1355,
    1355,  1356,  1357,  1358,  1359,  1359,  1359,  1360,  1361,  1362,
    1363,  1364,  1365,  1366,  1366,  1367,  1367,  1368,  1368,  1368,
    1369,  1369,  1370,  1370,  1371,  1371,  1372,  1372,  1372,  1372,
    1372,  1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,
    1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,
    1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,
    1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,
    1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373,
    1373,  1373,  1373,  1373,  1373,  1373,  1373,  1374,  1374,  1374,
    1374,  1375,  1375,  1375,  1375,  1375,  1375,  1375,  1375,  1375,
    1375,  1376,  1376,  1376,  1376,  1377,  1377,  1378,  1378,  1379,
    1379,  1380,  1380
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     2,     5,
       1,     1,     0,     2,     0,     2,     0,     2,     2,     3,
       3,     1,     3,     3,     2,     1,     1,     2,     2,     2,
       3,     3,     5,     5,     5,     0,     3,     5,     5,     5,
       5,     3,     5,     3,     5,     3,     5,     5,     6,     1,
       1,     6,     4,     9,     7,     1,     0,     2,     0,     1,
       1,     1,     1,     1,     1,     2,     3,     3,     2,     5,
       1,     3,     3,     3,     3,     1,     3,     3,     2,     2,
       2,     2,     3,     3,     3,     3,     1,     3,     1,     3,
       1,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     3,     5,     1,     1,     1,     1,     1,     0,
       1,     1,     2,     1,     2,     3,     2,     1,     1,     2,
       1,     2,     1,     3,     4,     5,     4,     2,     4,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     4,
       6,     4,     6,    10,    13,     4,     6,     4,    10,    13,
       4,     6,     4,     6,     5,     7,    11,    14,     1,     3,
       4,     3,     3,     2,     5,     3,     6,     4,     6,     6,
       5,     7,     6,     6,     5,     5,     6,     9,     4,     5,
       7,     6,     4,     8,     4,     2,     4,     3,     6,     4,
       3,     3,     3,     2,     2,     3,     4,     4,     3,     3,
       3,     3,     3,     3,     4,     4,     3,     2,     3,     2,
       2,     3,     3,     2,     2,     3,     4,     4,     4,     5,
       1,     3,     2,     1,     1,     0,     2,     0,     2,     0,
       1,     1,     1,     3,     3,     2,     0,     1,     3,     3,
       1,     5,     3,     1,     2,     1,     3,     2,     3,     6,
       6,    10,     1,     2,     1,     3,     4,     1,     3,     4,
       6,     4,     8,     2,     2,    11,     9,     1,     1,     1,
       0,     1,     1,     1,     1,     3,     2,     0,     1,     1,
       3,     3,     1,     1,     3,     3,     3,     3,     4,     3,
       2,     1,     0,     3,     0,     1,     0,     1,     3,     2,
       1,     1,     1,     3,     0,     1,     3,     1,    13,    16,
      12,    15,    14,    17,     1,     1,     2,     2,     2,     2,
       1,     0,     1,     0,     3,     0,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     4,     2,     4,     2,     0,
       3,     1,     1,     2,     2,     1,     3,     4,     5,     2,
       5,     7,     5,     1,     2,     1,     2,     2,     2,     3,
       3,     3,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     5,     8,     3,     9,     4,    10,
      11,     2,     0,     3,     0,     1,     3,     1,     4,     0,
       2,     2,     2,     0,     1,     3,     3,     6,     4,     0,
       1,     1,     2,     2,     0,     3,     3,     2,     1,     1,
       2,     2,     4,     0,     1,     0,     6,     1,     3,     3,
       3,     5,     2,     0,     2,     2,     0,     3,     4,     4,
       0,     2,     0,     4,     0,     3,     8,    11,     6,     8,
       6,     2,     3,     0,     8,    11,     5,     1,     0,     6,
       5,     8,     4,     6,     1,     0,     3,     0,     1,     2,
       2,     2,     1,     2,     3,     2,     2,     2,     2,     3,
       3,     3,     1,     3,     1,     0,     1,     2,     2,     1,
       1,     3,     6,    10,     1,     0,     1,     2,     2,     0,
       2,     2,     1,     0,     5,     7,     1,     0,     7,     2,
       0,     3,     5,     5,     8,     2,     0,     2,     2,     2,
       1,     5,     2,     0,     2,     7,     6,    10,     6,     6,
       6,     6,     7,     6,     9,     9,     6,     6,     6,     7,
       6,     8,     8,     8,     8,     6,     6,     7,     7,     8,
       6,     9,     6,     7,     2,     2,     2,     2,     1,     2,
       1,     0,     7,     6,     4,     0,     1,     3,     4,     1,
       3,     1,     2,     2,     2,     2,     1,     1,    10,    13,
       2,     0,     2,     2,     1,     0,     5,     4,     4,    11,
      14,    12,    15,     5,     7,    11,     2,     1,     4,     0,
       8,    11,     1,     1,     7,     9,     8,    10,     8,     4,
       0,     5,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     1,     1,     1,     1,     1,     8,     1,     1,    16,
      20,     1,     1,     2,     1,     3,     1,     1,     1,     3,
       1,     2,     0,     1,     2,     4,     1,     1,     1,     1,
       1,     3,     0,     1,     0,     1,     1,     4,     0,     1,
       1,     1,     3,     0,     1,     1,     1,     1,     2,     0,
       0,     2,     2,     1,     2,     2,     2,     2,    11,    13,
       1,     3,     5,     1,     3,     5,     1,     2,     2,     1,
       8,     6,     5,     4,     4,     3,     7,     8,     6,     6,
       6,     6,     6,     4,     7,     5,     8,     3,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     3,     1,     0,     1,     3,     7,     9,     9,     8,
       3,     0,    13,     1,     3,     5,     5,     3,     6,     2,
       1,     0,     2,     0,     2,     4,     0,     1,     0,     6,
       8,     8,     1,     3,     5,     5,     7,     9,     7,     9,
       5,     6,     6,     4,     6,     4,     6,     8,     4,     6,
       4,     6,     5,     7,     1,     1,     1,     2,     1,     2,
       1,     1,     1,     3,     3,     3,     3,     2,     2,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       2,     2,     3,     1,     3,     5,     2,     2,     0,     6,
       6,     6,     6,     6,     6,     6,     8,     9,     8,     6,
       6,     8,     9,     8,     9,     9,     7,    10,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     2,     3,     3,
       3,     3,     2,     1,     2,     1,     3,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     8,     8,     8,     8,
       8,     8,     9,     8,     8,     2,     0,     1,     2,     1,
       1,     1,     2,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     3,     4,     5,     4,     5,
       3,     4,     3,     4,     1,     2,     3,     3,     3,     3,
       4,     4,     3,     3,     4,     4,     4,     4,     1,     1,
       1,     0,     7,     7,    10,     1,     1,     2,     4,     5,
       1,     3,     2,     2,     2,     2,     1,     2,     2,     4,
       3,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       2,     5,     5,     5,     5,     5,     1,     3,     1,     2,
       3,     0,     6,     6,     9,     3,     0,     3,     0,     5,
       2,     0,     3,     3,     3,     7,     7,    10,     1,     1,
       1,     1,     1,     1,    15,    18,     1,     0,     1,     0,
       1,     0,     2,     0,     1,     3,     4,     5,     2,     2,
       4,     4,     0,     1,     3,     2,     0,     1,     0,     1,
       1,     0,     2,     2,     0,     8,    11,     6,     6,     2,
       0,     3,     2,     1,     3,     1,     3,     2,     1,     1,
       2,     3,     2,     1,     3,     3,     3,     2,     2,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     4,     5,
       1,     3,     3,     1,     3,     3,     5,     6,     1,     3,
       2,     1,     3,     1,     2,     4,     5,     1,     1,     1,
       1,     3,     3,     2,     2,     1,     2,     2,     2,     2,
       1,     2,     2,     2,     2,     1,     1,     1,     3,     3,
       5,     2,     0,     2,     1,     3,     5,     5,     5,     1,
       2,     1,     0,     4,     6,     4,     6,     4,     6,     4,
       6,     4,     6,     3,     5,     5,     5,     1,     3,     1,
       3,     2,     2,     1,     2,     1,     2,    11,    10,    10,
       2,     2,     0,     9,     2,     0,    10,    11,    11,     5,
       5,     8,     4,     4,     7,     7,     1,     1,     1,     1,
       1,     1,     3,     1,     5,     5,     6,     6,     6,     6,
       6,     8,     8,     6,     6,     7,     9,     9,     8,    10,
       6,     6,     6,     6,     6,     6,     6,     8,     6,     8,
       6,     8,     7,     9,     6,     8,     7,     9,     8,    10,
       8,    10,     9,    11,     8,    10,     9,    11,     8,     8,
       7,     6,     6,     6,     6,     8,     8,     8,     8,     6,
       9,     1,     0,     2,     0,     8,     8,     8,    10,     9,
       8,     1,     0,     6,     6,     6,     6,     6,     6,     6,
       9,     9,     6,     6,     6,     8,     6,     8,     8,     8,
       8,     6,     8,     6,     8,     7,     9,     7,     9,     6,
       7,     1,     3,     3,     3,     1,     1,     1,     1,     1,
       7,     6,     6,     6,     6,     6,     6,     7,     7,     6,
       9,     9,     6,     6,     6,     6,     6,     6,     8,     8,
       8,     6,     7,     6,     6,     5,     1,     0,     3,     3,
       5,     6,     6,     6,     8,     1,     3,     1,     5,     5,
       6,     7,     4,     4,     4,     6,    13,     1,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     0,     3,     2,     0,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     2,     3,
       2,     5,     4,     3,     3,     3,     1,     1,     0,     3,
       2,     2,     1,     2,     1,     3,     2,     1,     0,     2,
       3,     0,     9,    11,    12,    14,     3,     4,     4,     0,
       2,     5,     1,     0,     1,     2,     3,     3,     3,     1,
       2,     1,     1,     1,     1,     1,     1,     0,     5,     4,
       6,     4,     3,     5,     7,     9,     1,     3,     1,     5,
       4,     4,     6,     4,     6,     6,     5,     7,     9,     6,
       1,     0,     6,    11,    11,    11,    13,     9,    11,     1,
       1,    10,     4,     2,     5,     2,     0,     6,     5,     3,
       5,     1,     3,     1,     1,     2,     1,     1,     1,     1,
       0,     1,     0,     1,     0,     1,     0,     1,     0,     3,
       0,     2,     1,     3,     1,     0,     2,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     2,     1,     1,     1,     1,     0,     5,     4,     3,
       0,     1,     1,     1,     1,     4,    10,    13,     3,     0,
       7,     1,     3,     1,     4,     4,     7,     2,     1,     1,
       1,     3,     2,     8,     5,     0,     4,     3,     0,     3,
       0,     7,     2,     0,     5,     3,     0,     2,     2,     2,
       3,     1,     3,     1,     2,     1,     0,     1,     2,     0,
       8,     1,     3,     3,     5,     2,     1,     3,     7,     1,
       1,     0,     3,     2,     2,     2,     0,     2,     2,     1,
       1,     3,     3,     1,     2,     4,     4,     2,     3,     5,
       5,     1,     1,     9,     9,     1,     2,     4,     4,     4,
       2,     2,     3,     1,     3,     7,     1,     2,     0,     1,
       0,     2,     1,     0,     3,     3,     4,     4,     4,     4,
       3,     2,     1,     1,     0,     1,     1,     0,     1,     5,
       1,     0,     1,     0,     3,     1,     3,     4,     3,     2,
       2,     1,     1,     1,     0,     2,     4,     5,     6,     4,
       5,     2,     3,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     3,     0,     1,     3,     1,
       1,     1,     1,     1,     2,     4,     4,     5,     2,     0,
       1,     3,     1,     0,     1,     2,     3,     2,     4,     2,
       3,     2,     0,     4,     5,     2,     0,     1,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     1,     4,     3,
       4,     5,     4,     5,     4,     5,     2,     4,     1,     1,
       0,     1,     4,     5,     4,     0,     2,     2,     2,     1,
       1,     0,     4,     2,     1,     2,     2,     4,     1,     3,
       1,     2,     3,     6,     4,     0,     2,     6,     2,     1,
       3,     4,     0,     2,     0,     2,     0,     2,     4,     0,
       1,     0,     1,     3,     3,     7,    12,     1,     3,     2,
       3,     3,     1,     2,     2,     2,     2,     1,     1,     3,
       3,     2,     2,     3,     5,     6,     2,     3,     3,     4,
       0,     1,     1,     1,     1,     1,     2,     4,     1,     1,
       1,     1,     2,     3,     3,     0,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     1,     3,     0,     1,
       1,     1,     1,     5,     2,     1,     1,     1,     1,     4,
       1,     2,     2,     1,     3,     3,     2,     1,     0,     5,
       2,     5,     2,     1,     3,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     4,     1,     3,     3,     5,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     3,     3,     2,     2,     3,     5,
       4,     6,     3,     5,     4,     6,     4,     6,     5,     7,
       3,     2,     4,     2,     3,     3,     4,     3,     4,     3,
       4,     5,     6,     6,     7,     6,     7,     6,     7,     3,
       4,     4,     6,     2,     3,     4,     3,     4,     4,     5,
       1,     1,     3,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       5,     6,     6,     7,     3,     4,     1,     1,     2,     4,
       1,     1,     1,     2,     2,     2,     2,     1,     1,     4,
       3,     5,     6,     8,     6,     6,     4,     4,     1,     1,
       1,     5,     1,     1,     4,     1,     4,     1,     4,     1,
       4,     1,     1,     1,     1,     1,     1,     6,     4,     4,
       6,     4,     4,     4,     6,     5,     5,     5,     4,     6,
       4,     4,     4,     4,     5,     7,     7,     9,     5,     4,
       6,     5,     7,     7,     7,     2,     3,     3,     3,     4,
       0,     4,     1,     3,     3,     1,     1,     1,     2,     2,
       0,     2,     3,     3,     4,     2,     2,     5,     0,     5,
       0,     2,     0,     1,     3,     3,     2,     2,     0,     6,
       1,     0,     3,     0,     3,     3,     3,     0,     1,     4,
       2,     2,     2,     2,     2,     3,     2,     2,     3,     0,
       4,     3,     5,     4,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     1,     4,     1,     4,     1,
       2,     1,     2,     1,     3,     1,     3,     1,     3,     3,
       1,     3,     3,     3,     2,     1,     3,     3,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     3,     2,     3,     0,     3,     3,     2,     2,
       1,     0,     2,     2,     3,     2,     1,     1,     3,     5,
       1,     2,     4,     2,     0,     1,     0,     1,     2,     2,
       2,     3,     5,     1,     0,     1,     2,     0,     2,     1,
       0,     1,     0,     1,     3,     3,     2,     1,     1,     1,
       3,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     2,     6,
       2,     3,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     4,     3,     2,     1,     1,     1,     1,     1,     0,
       8,     0,    11,     2,     5,     3,     2,     2,     3,     7,
       1,     1,     1,     0,     2,     2,     1,     0,     1,     3,
       1,     2,     0,     2,     0,     2,     0,     1,     3,     4,
       3,     1,     1,     1,     1,     2,     0,     2,     4,     0,
       2,     2,     2,     1,     1,     7,     3,     1,     1,     1,
       1,     2,     0,     1,     3,     3,     3,     3,     0,     4,
       5,     5,     0,     1,     1,     1,     2,     2,     1,     2,
       0,     7,     0,     5,     0,     4,     2,     2,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     2,     1,     3,     2,     2,     3,     0,     5,
       1,     0,     5,     2,     2,     1,     1,     1,     2,     2,
       3,     1,     2,     2,     3,     3,     4,     2,     1,     2,
       1,     1,     2,     2,     3,     1,     1,     1,     1,     0,
       1,     3,     5,     0,     2,     0,     1,     2,     3,     2,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     2,
       2,     3,     0,     1,     2,     1,     4,     3,     4,     3,
       2,     1,     3,     1,     1,     1,     1,     2,     2,     1,
       2,     2,     1,     1,     1,     4,     4,     4,     4,     4,
       1,     0,     3,     3,     4,     1,     3,     3,     4,     1,
       3,     3,     1,     1,     1,     6,     1,     3,     3,     6,
       1,     3,     3,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     4,     1,     1,     4,     4,     3,
       0,     7,     1,     0,     0,     7,     3,     4,     3,     1,
       1,     1,     2,     3,     5,     2,     2,     5,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     0,     1,     2,
       1,     2,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     3,
       1,     2,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     3,     2,
       3,     1,     3,     3,     3,     3,     3,     3,     1,     1,
       4,     0,     2,     2,     1,     2,     1,     0,     1,     1,
       1,     0,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 1628 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34580 "preproc.c" /* yacc.c:1652  */
    break;

  case 4:
#line 1630 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34586 "preproc.c" /* yacc.c:1652  */
    break;

  case 5:
#line 1632 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34592 "preproc.c" /* yacc.c:1652  */
    break;

  case 6:
#line 1634 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34598 "preproc.c" /* yacc.c:1652  */
    break;

  case 7:
#line 1636 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34604 "preproc.c" /* yacc.c:1652  */
    break;

  case 8:
#line 1638 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34610 "preproc.c" /* yacc.c:1652  */
    break;

  case 9:
#line 1640 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34616 "preproc.c" /* yacc.c:1652  */
    break;

  case 10:
#line 1642 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34622 "preproc.c" /* yacc.c:1652  */
    break;

  case 11:
#line 1644 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34628 "preproc.c" /* yacc.c:1652  */
    break;

  case 12:
#line 1646 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34634 "preproc.c" /* yacc.c:1652  */
    break;

  case 13:
#line 1648 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34640 "preproc.c" /* yacc.c:1652  */
    break;

  case 14:
#line 1650 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34646 "preproc.c" /* yacc.c:1652  */
    break;

  case 15:
#line 1652 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34652 "preproc.c" /* yacc.c:1652  */
    break;

  case 16:
#line 1654 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34658 "preproc.c" /* yacc.c:1652  */
    break;

  case 17:
#line 1656 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34664 "preproc.c" /* yacc.c:1652  */
    break;

  case 18:
#line 1658 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34670 "preproc.c" /* yacc.c:1652  */
    break;

  case 19:
#line 1660 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34676 "preproc.c" /* yacc.c:1652  */
    break;

  case 20:
#line 1662 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34682 "preproc.c" /* yacc.c:1652  */
    break;

  case 21:
#line 1664 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34688 "preproc.c" /* yacc.c:1652  */
    break;

  case 22:
#line 1666 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34694 "preproc.c" /* yacc.c:1652  */
    break;

  case 23:
#line 1668 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34700 "preproc.c" /* yacc.c:1652  */
    break;

  case 24:
#line 1670 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34706 "preproc.c" /* yacc.c:1652  */
    break;

  case 25:
#line 1672 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34712 "preproc.c" /* yacc.c:1652  */
    break;

  case 26:
#line 1674 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34718 "preproc.c" /* yacc.c:1652  */
    break;

  case 27:
#line 1676 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34724 "preproc.c" /* yacc.c:1652  */
    break;

  case 28:
#line 1678 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34730 "preproc.c" /* yacc.c:1652  */
    break;

  case 29:
#line 1680 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34736 "preproc.c" /* yacc.c:1652  */
    break;

  case 30:
#line 1682 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34742 "preproc.c" /* yacc.c:1652  */
    break;

  case 31:
#line 1684 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34748 "preproc.c" /* yacc.c:1652  */
    break;

  case 32:
#line 1686 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34754 "preproc.c" /* yacc.c:1652  */
    break;

  case 33:
#line 1688 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34760 "preproc.c" /* yacc.c:1652  */
    break;

  case 34:
#line 1690 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34766 "preproc.c" /* yacc.c:1652  */
    break;

  case 35:
#line 1692 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34772 "preproc.c" /* yacc.c:1652  */
    break;

  case 36:
#line 1694 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34778 "preproc.c" /* yacc.c:1652  */
    break;

  case 37:
#line 1696 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34784 "preproc.c" /* yacc.c:1652  */
    break;

  case 38:
#line 1698 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34790 "preproc.c" /* yacc.c:1652  */
    break;

  case 39:
#line 1700 "preproc.y" /* yacc.c:1652  */
    {
		if (INFORMIX_MODE)
		{
			if (pg_strcasecmp((yyvsp[0].str)+strlen("close "), "database") == 0)
			{
				if (connection)
					mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CLOSE DATABASE statement");

				fprintf(base_yyout, "{ ECPGdisconnect(__LINE__, \"CURRENT\");");
				whenever_action(2);
				free((yyvsp[0].str));
				break;
			}
		}

		output_statement((yyvsp[0].str), 0, ECPGst_normal);
	}
#line 34812 "preproc.c" /* yacc.c:1652  */
    break;

  case 40:
#line 1718 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34818 "preproc.c" /* yacc.c:1652  */
    break;

  case 41:
#line 1720 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34824 "preproc.c" /* yacc.c:1652  */
    break;

  case 42:
#line 1722 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34830 "preproc.c" /* yacc.c:1652  */
    break;

  case 43:
#line 1724 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34836 "preproc.c" /* yacc.c:1652  */
    break;

  case 44:
#line 1726 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34842 "preproc.c" /* yacc.c:1652  */
    break;

  case 45:
#line 1728 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34848 "preproc.c" /* yacc.c:1652  */
    break;

  case 46:
#line 1730 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34854 "preproc.c" /* yacc.c:1652  */
    break;

  case 47:
#line 1732 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34860 "preproc.c" /* yacc.c:1652  */
    break;

  case 48:
#line 1734 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34866 "preproc.c" /* yacc.c:1652  */
    break;

  case 49:
#line 1736 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34872 "preproc.c" /* yacc.c:1652  */
    break;

  case 50:
#line 1738 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34878 "preproc.c" /* yacc.c:1652  */
    break;

  case 51:
#line 1740 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34884 "preproc.c" /* yacc.c:1652  */
    break;

  case 52:
#line 1742 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34890 "preproc.c" /* yacc.c:1652  */
    break;

  case 53:
#line 1744 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34896 "preproc.c" /* yacc.c:1652  */
    break;

  case 54:
#line 1746 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34902 "preproc.c" /* yacc.c:1652  */
    break;

  case 55:
#line 1748 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34908 "preproc.c" /* yacc.c:1652  */
    break;

  case 56:
#line 1750 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34914 "preproc.c" /* yacc.c:1652  */
    break;

  case 57:
#line 1752 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34920 "preproc.c" /* yacc.c:1652  */
    break;

  case 58:
#line 1754 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34926 "preproc.c" /* yacc.c:1652  */
    break;

  case 59:
#line 1756 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34932 "preproc.c" /* yacc.c:1652  */
    break;

  case 60:
#line 1758 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34938 "preproc.c" /* yacc.c:1652  */
    break;

  case 61:
#line 1760 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34944 "preproc.c" /* yacc.c:1652  */
    break;

  case 62:
#line 1762 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34950 "preproc.c" /* yacc.c:1652  */
    break;

  case 63:
#line 1764 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34956 "preproc.c" /* yacc.c:1652  */
    break;

  case 64:
#line 1766 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34962 "preproc.c" /* yacc.c:1652  */
    break;

  case 65:
#line 1768 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34968 "preproc.c" /* yacc.c:1652  */
    break;

  case 66:
#line 1770 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34974 "preproc.c" /* yacc.c:1652  */
    break;

  case 67:
#line 1772 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34980 "preproc.c" /* yacc.c:1652  */
    break;

  case 68:
#line 1774 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34986 "preproc.c" /* yacc.c:1652  */
    break;

  case 69:
#line 1776 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34992 "preproc.c" /* yacc.c:1652  */
    break;

  case 70:
#line 1778 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 34998 "preproc.c" /* yacc.c:1652  */
    break;

  case 71:
#line 1780 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35004 "preproc.c" /* yacc.c:1652  */
    break;

  case 72:
#line 1782 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35010 "preproc.c" /* yacc.c:1652  */
    break;

  case 73:
#line 1784 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35016 "preproc.c" /* yacc.c:1652  */
    break;

  case 74:
#line 1786 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35022 "preproc.c" /* yacc.c:1652  */
    break;

  case 75:
#line 1788 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35028 "preproc.c" /* yacc.c:1652  */
    break;

  case 76:
#line 1790 "preproc.y" /* yacc.c:1652  */
    {
		output_deallocate_prepare_statement((yyvsp[0].str));
	}
#line 35036 "preproc.c" /* yacc.c:1652  */
    break;

  case 77:
#line 1794 "preproc.y" /* yacc.c:1652  */
    { output_simple_statement((yyvsp[0].str), (strncmp((yyvsp[0].str), "ECPGset_var", strlen("ECPGset_var")) == 0) ? 4 : 0); }
#line 35042 "preproc.c" /* yacc.c:1652  */
    break;

  case 78:
#line 1796 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35048 "preproc.c" /* yacc.c:1652  */
    break;

  case 79:
#line 1798 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 35054 "preproc.c" /* yacc.c:1652  */
    break;

  case 80:
#line 1800 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_normal); }
#line 35060 "preproc.c" /* yacc.c:1652  */
    break;

  case 81:
#line 1802 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35066 "preproc.c" /* yacc.c:1652  */
    break;

  case 82:
#line 1804 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35072 "preproc.c" /* yacc.c:1652  */
    break;

  case 83:
#line 1806 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35078 "preproc.c" /* yacc.c:1652  */
    break;

  case 84:
#line 1808 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35084 "preproc.c" /* yacc.c:1652  */
    break;

  case 85:
#line 1810 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35090 "preproc.c" /* yacc.c:1652  */
    break;

  case 86:
#line 1812 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35096 "preproc.c" /* yacc.c:1652  */
    break;

  case 87:
#line 1814 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35102 "preproc.c" /* yacc.c:1652  */
    break;

  case 88:
#line 1816 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35108 "preproc.c" /* yacc.c:1652  */
    break;

  case 89:
#line 1818 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35114 "preproc.c" /* yacc.c:1652  */
    break;

  case 90:
#line 1820 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35120 "preproc.c" /* yacc.c:1652  */
    break;

  case 91:
#line 1822 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35126 "preproc.c" /* yacc.c:1652  */
    break;

  case 92:
#line 1824 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35132 "preproc.c" /* yacc.c:1652  */
    break;

  case 93:
#line 1826 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35138 "preproc.c" /* yacc.c:1652  */
    break;

  case 94:
#line 1828 "preproc.y" /* yacc.c:1652  */
    {
		if ((yyvsp[0].exec).type == NULL || strlen((yyvsp[0].exec).type) == 0)
			output_statement((yyvsp[0].exec).name, 1, ECPGst_execute);
		else
		{
			if ((yyvsp[0].exec).name[0] != '"')
				/* case of char_variable */
				add_variable_to_tail(&argsinsert, find_variable((yyvsp[0].exec).name), &no_indicator);
			else
			{
				/* case of ecpg_ident or CSTRING */
				char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
				char *str = mm_strdup((yyvsp[0].exec).name + 1);

				/* It must be cut off double quotation because new_variable() double-quotes. */
				str[strlen(str) - 1] = '\0';
				sprintf(length, "%zu", strlen(str));
				add_variable_to_tail(&argsinsert, new_variable(str, ECPGmake_simple_type(ECPGt_const, length, 0), 0), &no_indicator);
			}
			output_statement(cat_str(3, mm_strdup("execute"), mm_strdup("$0"), (yyvsp[0].exec).type), 0, ECPGst_exec_with_exprlist);
		}
	}
#line 35165 "preproc.c" /* yacc.c:1652  */
    break;

  case 95:
#line 1851 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35171 "preproc.c" /* yacc.c:1652  */
    break;

  case 96:
#line 1853 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_normal); }
#line 35177 "preproc.c" /* yacc.c:1652  */
    break;

  case 97:
#line 1855 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35183 "preproc.c" /* yacc.c:1652  */
    break;

  case 98:
#line 1857 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35189 "preproc.c" /* yacc.c:1652  */
    break;

  case 99:
#line 1859 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35195 "preproc.c" /* yacc.c:1652  */
    break;

  case 100:
#line 1861 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35201 "preproc.c" /* yacc.c:1652  */
    break;

  case 101:
#line 1863 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 35207 "preproc.c" /* yacc.c:1652  */
    break;

  case 102:
#line 1865 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35213 "preproc.c" /* yacc.c:1652  */
    break;

  case 103:
#line 1867 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35219 "preproc.c" /* yacc.c:1652  */
    break;

  case 104:
#line 1869 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35225 "preproc.c" /* yacc.c:1652  */
    break;

  case 105:
#line 1871 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35231 "preproc.c" /* yacc.c:1652  */
    break;

  case 106:
#line 1873 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35237 "preproc.c" /* yacc.c:1652  */
    break;

  case 107:
#line 1875 "preproc.y" /* yacc.c:1652  */
    {
		if ((yyvsp[0].prep).type == NULL)
			output_prepare_statement((yyvsp[0].prep).name, (yyvsp[0].prep).stmt);
		else if (strlen((yyvsp[0].prep).type) == 0)
		{
			char *stmt = cat_str(3, mm_strdup("\""), (yyvsp[0].prep).stmt, mm_strdup("\""));
			output_prepare_statement((yyvsp[0].prep).name, stmt);
		}
		else
		{
			if ((yyvsp[0].prep).name[0] != '"')
				/* case of char_variable */
				add_variable_to_tail(&argsinsert, find_variable((yyvsp[0].prep).name), &no_indicator);
			else
			{
				char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
				char *str = mm_strdup((yyvsp[0].prep).name + 1);

				/* It must be cut off double quotation because new_variable() double-quotes. */
				str[strlen(str) - 1] = '\0';
				sprintf(length, "%zu", strlen(str));
				add_variable_to_tail(&argsinsert, new_variable(str, ECPGmake_simple_type(ECPGt_const, length, 0), 0), &no_indicator);
			}
			output_statement(cat_str(5, mm_strdup("prepare"), mm_strdup("$0"), (yyvsp[0].prep).type, mm_strdup("as"), (yyvsp[0].prep).stmt), 0, ECPGst_prepare);
		}
	}
#line 35268 "preproc.c" /* yacc.c:1652  */
    break;

  case 108:
#line 1902 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35274 "preproc.c" /* yacc.c:1652  */
    break;

  case 109:
#line 1904 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35280 "preproc.c" /* yacc.c:1652  */
    break;

  case 110:
#line 1906 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35286 "preproc.c" /* yacc.c:1652  */
    break;

  case 111:
#line 1908 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35292 "preproc.c" /* yacc.c:1652  */
    break;

  case 112:
#line 1910 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35298 "preproc.c" /* yacc.c:1652  */
    break;

  case 113:
#line 1912 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35304 "preproc.c" /* yacc.c:1652  */
    break;

  case 114:
#line 1914 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35310 "preproc.c" /* yacc.c:1652  */
    break;

  case 115:
#line 1916 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35316 "preproc.c" /* yacc.c:1652  */
    break;

  case 116:
#line 1918 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35322 "preproc.c" /* yacc.c:1652  */
    break;

  case 117:
#line 1920 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35328 "preproc.c" /* yacc.c:1652  */
    break;

  case 118:
#line 1922 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 35334 "preproc.c" /* yacc.c:1652  */
    break;

  case 119:
#line 1924 "preproc.y" /* yacc.c:1652  */
    {
		fprintf(base_yyout, "{ ECPGtrans(__LINE__, %s, \"%s\");", connection ? connection : "NULL", (yyvsp[0].str));
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 35344 "preproc.c" /* yacc.c:1652  */
    break;

  case 120:
#line 1930 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35350 "preproc.c" /* yacc.c:1652  */
    break;

  case 121:
#line 1932 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35356 "preproc.c" /* yacc.c:1652  */
    break;

  case 122:
#line 1934 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 35362 "preproc.c" /* yacc.c:1652  */
    break;

  case 123:
#line 1936 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35368 "preproc.c" /* yacc.c:1652  */
    break;

  case 124:
#line 1938 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35374 "preproc.c" /* yacc.c:1652  */
    break;

  case 125:
#line 1940 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35380 "preproc.c" /* yacc.c:1652  */
    break;

  case 126:
#line 1942 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35386 "preproc.c" /* yacc.c:1652  */
    break;

  case 127:
#line 1944 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35392 "preproc.c" /* yacc.c:1652  */
    break;

  case 128:
#line 1946 "preproc.y" /* yacc.c:1652  */
    {
		fprintf(base_yyout,"ECPGallocate_desc(__LINE__, %s);",(yyvsp[0].str));
		whenever_action(0);
		free((yyvsp[0].str));
	}
#line 35402 "preproc.c" /* yacc.c:1652  */
    break;

  case 129:
#line 1952 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CONNECT statement");

		fprintf(base_yyout, "{ ECPGconnect(__LINE__, %d, %s, %d); ", compat, (yyvsp[0].str), autocommit);
		reset_variables();
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 35416 "preproc.c" /* yacc.c:1652  */
    break;

  case 130:
#line 1962 "preproc.y" /* yacc.c:1652  */
    {
		 output_simple_statement((yyvsp[0].str), (strncmp((yyvsp[0].str), "ECPGset_var", strlen("ECPGset_var")) == 0) ? 4 : 0);
	}
#line 35424 "preproc.c" /* yacc.c:1652  */
    break;

  case 131:
#line 1966 "preproc.y" /* yacc.c:1652  */
    {
		fprintf(base_yyout,"ECPGdeallocate_desc(__LINE__, %s);",(yyvsp[0].str));
		whenever_action(0);
		free((yyvsp[0].str));
	}
#line 35434 "preproc.c" /* yacc.c:1652  */
    break;

  case 132:
#line 1972 "preproc.y" /* yacc.c:1652  */
    {
		output_simple_statement((yyvsp[0].str), 0);
	}
#line 35442 "preproc.c" /* yacc.c:1652  */
    break;

  case 133:
#line 1976 "preproc.y" /* yacc.c:1652  */
    {
		fprintf(base_yyout, "{ ECPGdescribe(__LINE__, %d, %s,", compat, (yyvsp[0].str));
		dump_variables(argsresult, 1);
		fputs("ECPGt_EORT);", base_yyout);
		fprintf(base_yyout, "}");
		output_line_number();

		free((yyvsp[0].str));
	}
#line 35456 "preproc.c" /* yacc.c:1652  */
    break;

  case 134:
#line 1986 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in DISCONNECT statement");

		fprintf(base_yyout, "{ ECPGdisconnect(__LINE__, %s);",
				(yyvsp[0].str) ? (yyvsp[0].str) : "\"CURRENT\"");
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 35470 "preproc.c" /* yacc.c:1652  */
    break;

  case 135:
#line 1995 "preproc.y" /* yacc.c:1652  */
    { output_statement((yyvsp[0].str), 0, ECPGst_exec_immediate); }
#line 35476 "preproc.c" /* yacc.c:1652  */
    break;

  case 136:
#line 1997 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";

		if (strcmp((yyvsp[0].str), "all") == 0)
			fprintf(base_yyout, "{ ECPGdeallocate_all(__LINE__, %d, %s);", compat, con);
		else if ((yyvsp[0].str)[0] == ':')
			fprintf(base_yyout, "{ ECPGdeallocate(__LINE__, %d, %s, %s);", compat, con, (yyvsp[0].str)+1);
		else
			fprintf(base_yyout, "{ ECPGdeallocate(__LINE__, %d, %s, \"%s\");", compat, con, (yyvsp[0].str));

		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 35494 "preproc.c" /* yacc.c:1652  */
    break;

  case 137:
#line 2011 "preproc.y" /* yacc.c:1652  */
    {
		lookup_descriptor((yyvsp[0].descriptor).name, connection);
		output_get_descr((yyvsp[0].descriptor).name, (yyvsp[0].descriptor).str);
		free((yyvsp[0].descriptor).name);
		free((yyvsp[0].descriptor).str);
	}
#line 35505 "preproc.c" /* yacc.c:1652  */
    break;

  case 138:
#line 2018 "preproc.y" /* yacc.c:1652  */
    {
		lookup_descriptor((yyvsp[0].str), connection);
		output_get_descr_header((yyvsp[0].str));
		free((yyvsp[0].str));
	}
#line 35515 "preproc.c" /* yacc.c:1652  */
    break;

  case 139:
#line 2024 "preproc.y" /* yacc.c:1652  */
    {
		struct cursor *ptr;

		if ((ptr = add_additional_variables((yyvsp[0].str), true)) != NULL)
		{
			connection = ptr->connection ? mm_strdup(ptr->connection) : NULL;
			output_statement(mm_strdup(ptr->command), 0, ECPGst_normal);
			ptr->opened = true;
		}
	}
#line 35530 "preproc.c" /* yacc.c:1652  */
    break;

  case 140:
#line 2035 "preproc.y" /* yacc.c:1652  */
    {
		fprintf(base_yyout, "{ ECPGsetcommit(__LINE__, \"%s\", %s);", (yyvsp[0].str), connection ? connection : "NULL");
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 35540 "preproc.c" /* yacc.c:1652  */
    break;

  case 141:
#line 2041 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in SET CONNECTION statement");

		fprintf(base_yyout, "{ ECPGsetconn(__LINE__, %s);", (yyvsp[0].str));
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 35553 "preproc.c" /* yacc.c:1652  */
    break;

  case 142:
#line 2050 "preproc.y" /* yacc.c:1652  */
    {
		lookup_descriptor((yyvsp[0].descriptor).name, connection);
		output_set_descr((yyvsp[0].descriptor).name, (yyvsp[0].descriptor).str);
		free((yyvsp[0].descriptor).name);
		free((yyvsp[0].descriptor).str);
	}
#line 35564 "preproc.c" /* yacc.c:1652  */
    break;

  case 143:
#line 2057 "preproc.y" /* yacc.c:1652  */
    {
		lookup_descriptor((yyvsp[0].str), connection);
		output_set_descr_header((yyvsp[0].str));
		free((yyvsp[0].str));
	}
#line 35574 "preproc.c" /* yacc.c:1652  */
    break;

  case 144:
#line 2063 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in TYPE statement");

		fprintf(base_yyout, "%s", (yyvsp[0].str));
		free((yyvsp[0].str));
		output_line_number();
	}
#line 35587 "preproc.c" /* yacc.c:1652  */
    break;

  case 145:
#line 2072 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in VAR statement");

		output_simple_statement((yyvsp[0].str), 0);
	}
#line 35598 "preproc.c" /* yacc.c:1652  */
    break;

  case 146:
#line 2079 "preproc.y" /* yacc.c:1652  */
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in WHENEVER statement");

		output_simple_statement((yyvsp[0].str), 0);
	}
#line 35609 "preproc.c" /* yacc.c:1652  */
    break;

  case 147:
#line 2086 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = NULL; }
#line 35615 "preproc.c" /* yacc.c:1652  */
    break;

  case 148:
#line 2092 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("call"),(yyvsp[0].str));
}
#line 35623 "preproc.c" /* yacc.c:1652  */
    break;

  case 149:
#line 2100 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35631 "preproc.c" /* yacc.c:1652  */
    break;

  case 150:
#line 2108 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with");
}
#line 35639 "preproc.c" /* yacc.c:1652  */
    break;

  case 151:
#line 2112 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with");
}
#line 35647 "preproc.c" /* yacc.c:1652  */
    break;

  case 152:
#line 2116 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35654 "preproc.c" /* yacc.c:1652  */
    break;

  case 153:
#line 2123 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35662 "preproc.c" /* yacc.c:1652  */
    break;

  case 154:
#line 2127 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35669 "preproc.c" /* yacc.c:1652  */
    break;

  case 155:
#line 2134 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35677 "preproc.c" /* yacc.c:1652  */
    break;

  case 156:
#line 2138 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35684 "preproc.c" /* yacc.c:1652  */
    break;

  case 157:
#line 2145 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("password"),(yyvsp[0].str));
}
#line 35692 "preproc.c" /* yacc.c:1652  */
    break;

  case 158:
#line 2149 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("password null");
}
#line 35700 "preproc.c" /* yacc.c:1652  */
    break;

  case 159:
#line 2153 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("encrypted password"),(yyvsp[0].str));
}
#line 35708 "preproc.c" /* yacc.c:1652  */
    break;

  case 160:
#line 2157 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("unencrypted password"),(yyvsp[0].str));
}
#line 35717 "preproc.c" /* yacc.c:1652  */
    break;

  case 161:
#line 2162 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inherit");
}
#line 35725 "preproc.c" /* yacc.c:1652  */
    break;

  case 162:
#line 2166 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("connection limit"),(yyvsp[0].str));
}
#line 35733 "preproc.c" /* yacc.c:1652  */
    break;

  case 163:
#line 2170 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("valid until"),(yyvsp[0].str));
}
#line 35741 "preproc.c" /* yacc.c:1652  */
    break;

  case 164:
#line 2174 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("user"),(yyvsp[0].str));
}
#line 35749 "preproc.c" /* yacc.c:1652  */
    break;

  case 165:
#line 2178 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35757 "preproc.c" /* yacc.c:1652  */
    break;

  case 166:
#line 2186 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35765 "preproc.c" /* yacc.c:1652  */
    break;

  case 167:
#line 2190 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("sysid"),(yyvsp[0].str));
}
#line 35773 "preproc.c" /* yacc.c:1652  */
    break;

  case 168:
#line 2194 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("admin"),(yyvsp[0].str));
}
#line 35781 "preproc.c" /* yacc.c:1652  */
    break;

  case 169:
#line 2198 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("role"),(yyvsp[0].str));
}
#line 35789 "preproc.c" /* yacc.c:1652  */
    break;

  case 170:
#line 2202 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("in role"),(yyvsp[0].str));
}
#line 35797 "preproc.c" /* yacc.c:1652  */
    break;

  case 171:
#line 2206 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("in group"),(yyvsp[0].str));
}
#line 35805 "preproc.c" /* yacc.c:1652  */
    break;

  case 172:
#line 2214 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35813 "preproc.c" /* yacc.c:1652  */
    break;

  case 173:
#line 2222 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35821 "preproc.c" /* yacc.c:1652  */
    break;

  case 174:
#line 2226 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35829 "preproc.c" /* yacc.c:1652  */
    break;

  case 175:
#line 2234 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 35836 "preproc.c" /* yacc.c:1652  */
    break;

  case 176:
#line 2237 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("in database"),(yyvsp[0].str));
}
#line 35844 "preproc.c" /* yacc.c:1652  */
    break;

  case 177:
#line 2245 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35852 "preproc.c" /* yacc.c:1652  */
    break;

  case 178:
#line 2249 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter role all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35860 "preproc.c" /* yacc.c:1652  */
    break;

  case 179:
#line 2253 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35868 "preproc.c" /* yacc.c:1652  */
    break;

  case 180:
#line 2257 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter user all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35876 "preproc.c" /* yacc.c:1652  */
    break;

  case 181:
#line 2265 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop role"),(yyvsp[0].str));
}
#line 35884 "preproc.c" /* yacc.c:1652  */
    break;

  case 182:
#line 2269 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop role if exists"),(yyvsp[0].str));
}
#line 35892 "preproc.c" /* yacc.c:1652  */
    break;

  case 183:
#line 2273 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop user"),(yyvsp[0].str));
}
#line 35900 "preproc.c" /* yacc.c:1652  */
    break;

  case 184:
#line 2277 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop user if exists"),(yyvsp[0].str));
}
#line 35908 "preproc.c" /* yacc.c:1652  */
    break;

  case 185:
#line 2281 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop group"),(yyvsp[0].str));
}
#line 35916 "preproc.c" /* yacc.c:1652  */
    break;

  case 186:
#line 2285 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop group if exists"),(yyvsp[0].str));
}
#line 35924 "preproc.c" /* yacc.c:1652  */
    break;

  case 187:
#line 2293 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create group"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35932 "preproc.c" /* yacc.c:1652  */
    break;

  case 188:
#line 2301 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter group"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("user"),(yyvsp[0].str));
}
#line 35940 "preproc.c" /* yacc.c:1652  */
    break;

  case 189:
#line 2309 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("add");
}
#line 35948 "preproc.c" /* yacc.c:1652  */
    break;

  case 190:
#line 2313 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("drop");
}
#line 35956 "preproc.c" /* yacc.c:1652  */
    break;

  case 191:
#line 2321 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create schema"),(yyvsp[-3].str),mm_strdup("authorization"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35964 "preproc.c" /* yacc.c:1652  */
    break;

  case 192:
#line 2325 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create schema"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35972 "preproc.c" /* yacc.c:1652  */
    break;

  case 193:
#line 2329 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(5,mm_strdup("create schema if not exists"),(yyvsp[-3].str),mm_strdup("authorization"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35981 "preproc.c" /* yacc.c:1652  */
    break;

  case 194:
#line 2334 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(3,mm_strdup("create schema if not exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 35990 "preproc.c" /* yacc.c:1652  */
    break;

  case 195:
#line 2343 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 35998 "preproc.c" /* yacc.c:1652  */
    break;

  case 196:
#line 2347 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36005 "preproc.c" /* yacc.c:1652  */
    break;

  case 197:
#line 2354 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36013 "preproc.c" /* yacc.c:1652  */
    break;

  case 198:
#line 2358 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36020 "preproc.c" /* yacc.c:1652  */
    break;

  case 199:
#line 2365 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36028 "preproc.c" /* yacc.c:1652  */
    break;

  case 200:
#line 2369 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36036 "preproc.c" /* yacc.c:1652  */
    break;

  case 201:
#line 2373 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36044 "preproc.c" /* yacc.c:1652  */
    break;

  case 202:
#line 2377 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36052 "preproc.c" /* yacc.c:1652  */
    break;

  case 203:
#line 2381 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36060 "preproc.c" /* yacc.c:1652  */
    break;

  case 204:
#line 2385 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36068 "preproc.c" /* yacc.c:1652  */
    break;

  case 205:
#line 2393 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 36076 "preproc.c" /* yacc.c:1652  */
    break;

  case 206:
#line 2397 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set local"),(yyvsp[0].str));
}
#line 36084 "preproc.c" /* yacc.c:1652  */
    break;

  case 207:
#line 2401 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set session"),(yyvsp[0].str));
}
#line 36092 "preproc.c" /* yacc.c:1652  */
    break;

  case 208:
#line 2409 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("transaction"),(yyvsp[0].str));
}
#line 36100 "preproc.c" /* yacc.c:1652  */
    break;

  case 209:
#line 2413 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("session characteristics as transaction"),(yyvsp[0].str));
}
#line 36108 "preproc.c" /* yacc.c:1652  */
    break;

  case 210:
#line 2417 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36116 "preproc.c" /* yacc.c:1652  */
    break;

  case 211:
#line 2425 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 36124 "preproc.c" /* yacc.c:1652  */
    break;

  case 212:
#line 2429 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 36132 "preproc.c" /* yacc.c:1652  */
    break;

  case 213:
#line 2433 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("to default"));
}
#line 36140 "preproc.c" /* yacc.c:1652  */
    break;

  case 214:
#line 2437 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("= default"));
}
#line 36148 "preproc.c" /* yacc.c:1652  */
    break;

  case 215:
#line 2445 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36156 "preproc.c" /* yacc.c:1652  */
    break;

  case 216:
#line 2449 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("from current"));
}
#line 36164 "preproc.c" /* yacc.c:1652  */
    break;

  case 217:
#line 2453 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("time zone"),(yyvsp[0].str));
}
#line 36172 "preproc.c" /* yacc.c:1652  */
    break;

  case 218:
#line 2457 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("catalog"),(yyvsp[0].str));
}
#line 36181 "preproc.c" /* yacc.c:1652  */
    break;

  case 219:
#line 2462 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 36189 "preproc.c" /* yacc.c:1652  */
    break;

  case 220:
#line 2466 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("names"),(yyvsp[0].str));
}
#line 36197 "preproc.c" /* yacc.c:1652  */
    break;

  case 221:
#line 2470 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("role"),(yyvsp[0].str));
}
#line 36205 "preproc.c" /* yacc.c:1652  */
    break;

  case 222:
#line 2474 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("session authorization"),(yyvsp[0].str));
}
#line 36213 "preproc.c" /* yacc.c:1652  */
    break;

  case 223:
#line 2478 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session authorization default");
}
#line 36221 "preproc.c" /* yacc.c:1652  */
    break;

  case 224:
#line 2482 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("xml option"),(yyvsp[0].str));
}
#line 36229 "preproc.c" /* yacc.c:1652  */
    break;

  case 225:
#line 2486 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("transaction snapshot"),(yyvsp[0].str));
}
#line 36237 "preproc.c" /* yacc.c:1652  */
    break;

  case 226:
#line 2494 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36245 "preproc.c" /* yacc.c:1652  */
    break;

  case 227:
#line 2498 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 36253 "preproc.c" /* yacc.c:1652  */
    break;

  case 228:
#line 2506 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36261 "preproc.c" /* yacc.c:1652  */
    break;

  case 229:
#line 2510 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 36269 "preproc.c" /* yacc.c:1652  */
    break;

  case 230:
#line 2518 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36277 "preproc.c" /* yacc.c:1652  */
    break;

  case 231:
#line 2522 "preproc.y" /* yacc.c:1652  */
    { 
		if ((yyvsp[0].str)[0] == '$')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = (yyvsp[0].str);
}
#line 36291 "preproc.c" /* yacc.c:1652  */
    break;

  case 232:
#line 2536 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("read uncommitted");
}
#line 36299 "preproc.c" /* yacc.c:1652  */
    break;

  case 233:
#line 2540 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("read committed");
}
#line 36307 "preproc.c" /* yacc.c:1652  */
    break;

  case 234:
#line 2544 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("repeatable read");
}
#line 36315 "preproc.c" /* yacc.c:1652  */
    break;

  case 235:
#line 2548 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("serializable");
}
#line 36323 "preproc.c" /* yacc.c:1652  */
    break;

  case 236:
#line 2556 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("true");
}
#line 36331 "preproc.c" /* yacc.c:1652  */
    break;

  case 237:
#line 2560 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("false");
}
#line 36339 "preproc.c" /* yacc.c:1652  */
    break;

  case 238:
#line 2564 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("on");
}
#line 36347 "preproc.c" /* yacc.c:1652  */
    break;

  case 239:
#line 2568 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36355 "preproc.c" /* yacc.c:1652  */
    break;

  case 240:
#line 2576 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36363 "preproc.c" /* yacc.c:1652  */
    break;

  case 241:
#line 2580 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36371 "preproc.c" /* yacc.c:1652  */
    break;

  case 242:
#line 2584 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36379 "preproc.c" /* yacc.c:1652  */
    break;

  case 243:
#line 2588 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 36387 "preproc.c" /* yacc.c:1652  */
    break;

  case 244:
#line 2592 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36395 "preproc.c" /* yacc.c:1652  */
    break;

  case 245:
#line 2596 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 36403 "preproc.c" /* yacc.c:1652  */
    break;

  case 246:
#line 2600 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("local");
}
#line 36411 "preproc.c" /* yacc.c:1652  */
    break;

  case 247:
#line 2608 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36419 "preproc.c" /* yacc.c:1652  */
    break;

  case 248:
#line 2612 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 36427 "preproc.c" /* yacc.c:1652  */
    break;

  case 249:
#line 2616 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 36434 "preproc.c" /* yacc.c:1652  */
    break;

  case 250:
#line 2623 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36442 "preproc.c" /* yacc.c:1652  */
    break;

  case 251:
#line 2627 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36450 "preproc.c" /* yacc.c:1652  */
    break;

  case 252:
#line 2635 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("reset"),(yyvsp[0].str));
}
#line 36458 "preproc.c" /* yacc.c:1652  */
    break;

  case 253:
#line 2643 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36466 "preproc.c" /* yacc.c:1652  */
    break;

  case 254:
#line 2647 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("time zone");
}
#line 36474 "preproc.c" /* yacc.c:1652  */
    break;

  case 255:
#line 2651 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("transaction isolation level");
}
#line 36482 "preproc.c" /* yacc.c:1652  */
    break;

  case 256:
#line 2655 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session authorization");
}
#line 36490 "preproc.c" /* yacc.c:1652  */
    break;

  case 257:
#line 2663 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36498 "preproc.c" /* yacc.c:1652  */
    break;

  case 258:
#line 2667 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 36506 "preproc.c" /* yacc.c:1652  */
    break;

  case 259:
#line 2675 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 36514 "preproc.c" /* yacc.c:1652  */
    break;

  case 260:
#line 2679 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36522 "preproc.c" /* yacc.c:1652  */
    break;

  case 261:
#line 2687 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 36530 "preproc.c" /* yacc.c:1652  */
    break;

  case 262:
#line 2691 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36538 "preproc.c" /* yacc.c:1652  */
    break;

  case 263:
#line 2699 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("show"),(yyvsp[-1].str));
}
#line 36546 "preproc.c" /* yacc.c:1652  */
    break;

  case 264:
#line 2703 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("show time zone");
}
#line 36554 "preproc.c" /* yacc.c:1652  */
    break;

  case 265:
#line 2707 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("show transaction isolation level");
}
#line 36562 "preproc.c" /* yacc.c:1652  */
    break;

  case 266:
#line 2711 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("show session authorization");
}
#line 36570 "preproc.c" /* yacc.c:1652  */
    break;

  case 267:
#line 2715 "preproc.y" /* yacc.c:1652  */
    {
		mmerror(PARSE_ERROR, ET_ERROR, "SHOW ALL is not implemented");
		(yyval.str) = EMPTY;
	}
#line 36579 "preproc.c" /* yacc.c:1652  */
    break;

  case 268:
#line 2724 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("set constraints"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36587 "preproc.c" /* yacc.c:1652  */
    break;

  case 269:
#line 2732 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 36595 "preproc.c" /* yacc.c:1652  */
    break;

  case 270:
#line 2736 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36603 "preproc.c" /* yacc.c:1652  */
    break;

  case 271:
#line 2744 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferred");
}
#line 36611 "preproc.c" /* yacc.c:1652  */
    break;

  case 272:
#line 2748 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("immediate");
}
#line 36619 "preproc.c" /* yacc.c:1652  */
    break;

  case 273:
#line 2756 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("checkpoint");
}
#line 36627 "preproc.c" /* yacc.c:1652  */
    break;

  case 274:
#line 2764 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard all");
}
#line 36635 "preproc.c" /* yacc.c:1652  */
    break;

  case 275:
#line 2768 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard temp");
}
#line 36643 "preproc.c" /* yacc.c:1652  */
    break;

  case 276:
#line 2772 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard temporary");
}
#line 36651 "preproc.c" /* yacc.c:1652  */
    break;

  case 277:
#line 2776 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard plans");
}
#line 36659 "preproc.c" /* yacc.c:1652  */
    break;

  case 278:
#line 2780 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard sequences");
}
#line 36667 "preproc.c" /* yacc.c:1652  */
    break;

  case 279:
#line 2788 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36675 "preproc.c" /* yacc.c:1652  */
    break;

  case 280:
#line 2792 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter table if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36683 "preproc.c" /* yacc.c:1652  */
    break;

  case 281:
#line 2796 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36691 "preproc.c" /* yacc.c:1652  */
    break;

  case 282:
#line 2800 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter table if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36699 "preproc.c" /* yacc.c:1652  */
    break;

  case 283:
#line 2804 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter table all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36707 "preproc.c" /* yacc.c:1652  */
    break;

  case 284:
#line 2808 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter table all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36715 "preproc.c" /* yacc.c:1652  */
    break;

  case 285:
#line 2812 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter index"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36723 "preproc.c" /* yacc.c:1652  */
    break;

  case 286:
#line 2816 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter index if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36731 "preproc.c" /* yacc.c:1652  */
    break;

  case 287:
#line 2820 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter index"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36739 "preproc.c" /* yacc.c:1652  */
    break;

  case 288:
#line 2824 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter index all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36747 "preproc.c" /* yacc.c:1652  */
    break;

  case 289:
#line 2828 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter index all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36755 "preproc.c" /* yacc.c:1652  */
    break;

  case 290:
#line 2832 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36763 "preproc.c" /* yacc.c:1652  */
    break;

  case 291:
#line 2836 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36771 "preproc.c" /* yacc.c:1652  */
    break;

  case 292:
#line 2840 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter view"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36779 "preproc.c" /* yacc.c:1652  */
    break;

  case 293:
#line 2844 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter view if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36787 "preproc.c" /* yacc.c:1652  */
    break;

  case 294:
#line 2848 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter materialized view"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36795 "preproc.c" /* yacc.c:1652  */
    break;

  case 295:
#line 2852 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter materialized view if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36803 "preproc.c" /* yacc.c:1652  */
    break;

  case 296:
#line 2856 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter materialized view all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36811 "preproc.c" /* yacc.c:1652  */
    break;

  case 297:
#line 2860 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36819 "preproc.c" /* yacc.c:1652  */
    break;

  case 298:
#line 2868 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36827 "preproc.c" /* yacc.c:1652  */
    break;

  case 299:
#line 2872 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 36835 "preproc.c" /* yacc.c:1652  */
    break;

  case 300:
#line 2880 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("attach partition"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36843 "preproc.c" /* yacc.c:1652  */
    break;

  case 301:
#line 2884 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("detach partition"),(yyvsp[0].str));
}
#line 36851 "preproc.c" /* yacc.c:1652  */
    break;

  case 302:
#line 2892 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("attach partition"),(yyvsp[0].str));
}
#line 36859 "preproc.c" /* yacc.c:1652  */
    break;

  case 303:
#line 2900 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 36867 "preproc.c" /* yacc.c:1652  */
    break;

  case 304:
#line 2904 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add if not exists"),(yyvsp[0].str));
}
#line 36875 "preproc.c" /* yacc.c:1652  */
    break;

  case 305:
#line 2908 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add column"),(yyvsp[0].str));
}
#line 36883 "preproc.c" /* yacc.c:1652  */
    break;

  case 306:
#line 2912 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add column if not exists"),(yyvsp[0].str));
}
#line 36891 "preproc.c" /* yacc.c:1652  */
    break;

  case 307:
#line 2916 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36899 "preproc.c" /* yacc.c:1652  */
    break;

  case 308:
#line 2920 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("drop not null"));
}
#line 36907 "preproc.c" /* yacc.c:1652  */
    break;

  case 309:
#line 2924 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set not null"));
}
#line 36915 "preproc.c" /* yacc.c:1652  */
    break;

  case 310:
#line 2928 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("drop expression"));
}
#line 36923 "preproc.c" /* yacc.c:1652  */
    break;

  case 311:
#line 2932 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("drop expression if exists"));
}
#line 36931 "preproc.c" /* yacc.c:1652  */
    break;

  case 312:
#line 2936 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set statistics"),(yyvsp[0].str));
}
#line 36939 "preproc.c" /* yacc.c:1652  */
    break;

  case 313:
#line 2940 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set statistics"),(yyvsp[0].str));
}
#line 36947 "preproc.c" /* yacc.c:1652  */
    break;

  case 314:
#line 2944 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 36955 "preproc.c" /* yacc.c:1652  */
    break;

  case 315:
#line 2948 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("reset"),(yyvsp[0].str));
}
#line 36963 "preproc.c" /* yacc.c:1652  */
    break;

  case 316:
#line 2952 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set storage"),(yyvsp[0].str));
}
#line 36971 "preproc.c" /* yacc.c:1652  */
    break;

  case 317:
#line 2956 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("add generated"),(yyvsp[-3].str),mm_strdup("as identity"),(yyvsp[0].str));
}
#line 36979 "preproc.c" /* yacc.c:1652  */
    break;

  case 318:
#line 2960 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36987 "preproc.c" /* yacc.c:1652  */
    break;

  case 319:
#line 2964 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("drop identity"));
}
#line 36995 "preproc.c" /* yacc.c:1652  */
    break;

  case 320:
#line 2968 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("drop identity if exists"));
}
#line 37003 "preproc.c" /* yacc.c:1652  */
    break;

  case 321:
#line 2972 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-4].str),mm_strdup("if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37011 "preproc.c" /* yacc.c:1652  */
    break;

  case 322:
#line 2976 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37019 "preproc.c" /* yacc.c:1652  */
    break;

  case 323:
#line 2980 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("alter"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("type"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37027 "preproc.c" /* yacc.c:1652  */
    break;

  case 324:
#line 2984 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37035 "preproc.c" /* yacc.c:1652  */
    break;

  case 325:
#line 2988 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 37043 "preproc.c" /* yacc.c:1652  */
    break;

  case 326:
#line 2992 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37051 "preproc.c" /* yacc.c:1652  */
    break;

  case 327:
#line 2996 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("validate constraint"),(yyvsp[0].str));
}
#line 37059 "preproc.c" /* yacc.c:1652  */
    break;

  case 328:
#line 3000 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop constraint if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37067 "preproc.c" /* yacc.c:1652  */
    break;

  case 329:
#line 3004 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37075 "preproc.c" /* yacc.c:1652  */
    break;

  case 330:
#line 3008 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set without oids");
}
#line 37083 "preproc.c" /* yacc.c:1652  */
    break;

  case 331:
#line 3012 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("cluster on"),(yyvsp[0].str));
}
#line 37091 "preproc.c" /* yacc.c:1652  */
    break;

  case 332:
#line 3016 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set without cluster");
}
#line 37099 "preproc.c" /* yacc.c:1652  */
    break;

  case 333:
#line 3020 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set logged");
}
#line 37107 "preproc.c" /* yacc.c:1652  */
    break;

  case 334:
#line 3024 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set unlogged");
}
#line 37115 "preproc.c" /* yacc.c:1652  */
    break;

  case 335:
#line 3028 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable trigger"),(yyvsp[0].str));
}
#line 37123 "preproc.c" /* yacc.c:1652  */
    break;

  case 336:
#line 3032 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable always trigger"),(yyvsp[0].str));
}
#line 37131 "preproc.c" /* yacc.c:1652  */
    break;

  case 337:
#line 3036 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable replica trigger"),(yyvsp[0].str));
}
#line 37139 "preproc.c" /* yacc.c:1652  */
    break;

  case 338:
#line 3040 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable trigger all");
}
#line 37147 "preproc.c" /* yacc.c:1652  */
    break;

  case 339:
#line 3044 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable trigger user");
}
#line 37155 "preproc.c" /* yacc.c:1652  */
    break;

  case 340:
#line 3048 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("disable trigger"),(yyvsp[0].str));
}
#line 37163 "preproc.c" /* yacc.c:1652  */
    break;

  case 341:
#line 3052 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("disable trigger all");
}
#line 37171 "preproc.c" /* yacc.c:1652  */
    break;

  case 342:
#line 3056 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("disable trigger user");
}
#line 37179 "preproc.c" /* yacc.c:1652  */
    break;

  case 343:
#line 3060 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable rule"),(yyvsp[0].str));
}
#line 37187 "preproc.c" /* yacc.c:1652  */
    break;

  case 344:
#line 3064 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable always rule"),(yyvsp[0].str));
}
#line 37195 "preproc.c" /* yacc.c:1652  */
    break;

  case 345:
#line 3068 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("enable replica rule"),(yyvsp[0].str));
}
#line 37203 "preproc.c" /* yacc.c:1652  */
    break;

  case 346:
#line 3072 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("disable rule"),(yyvsp[0].str));
}
#line 37211 "preproc.c" /* yacc.c:1652  */
    break;

  case 347:
#line 3076 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("inherit"),(yyvsp[0].str));
}
#line 37219 "preproc.c" /* yacc.c:1652  */
    break;

  case 348:
#line 3080 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("no inherit"),(yyvsp[0].str));
}
#line 37227 "preproc.c" /* yacc.c:1652  */
    break;

  case 349:
#line 3084 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("of"),(yyvsp[0].str));
}
#line 37235 "preproc.c" /* yacc.c:1652  */
    break;

  case 350:
#line 3088 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not of");
}
#line 37243 "preproc.c" /* yacc.c:1652  */
    break;

  case 351:
#line 3092 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("owner to"),(yyvsp[0].str));
}
#line 37251 "preproc.c" /* yacc.c:1652  */
    break;

  case 352:
#line 3096 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set tablespace"),(yyvsp[0].str));
}
#line 37259 "preproc.c" /* yacc.c:1652  */
    break;

  case 353:
#line 3100 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 37267 "preproc.c" /* yacc.c:1652  */
    break;

  case 354:
#line 3104 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("reset"),(yyvsp[0].str));
}
#line 37275 "preproc.c" /* yacc.c:1652  */
    break;

  case 355:
#line 3108 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("replica identity"),(yyvsp[0].str));
}
#line 37283 "preproc.c" /* yacc.c:1652  */
    break;

  case 356:
#line 3112 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable row level security");
}
#line 37291 "preproc.c" /* yacc.c:1652  */
    break;

  case 357:
#line 3116 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("disable row level security");
}
#line 37299 "preproc.c" /* yacc.c:1652  */
    break;

  case 358:
#line 3120 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("force row level security");
}
#line 37307 "preproc.c" /* yacc.c:1652  */
    break;

  case 359:
#line 3124 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no force row level security");
}
#line 37315 "preproc.c" /* yacc.c:1652  */
    break;

  case 360:
#line 3128 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37323 "preproc.c" /* yacc.c:1652  */
    break;

  case 361:
#line 3136 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set default"),(yyvsp[0].str));
}
#line 37331 "preproc.c" /* yacc.c:1652  */
    break;

  case 362:
#line 3140 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("drop default");
}
#line 37339 "preproc.c" /* yacc.c:1652  */
    break;

  case 363:
#line 3148 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cascade");
}
#line 37347 "preproc.c" /* yacc.c:1652  */
    break;

  case 364:
#line 3152 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restrict");
}
#line 37355 "preproc.c" /* yacc.c:1652  */
    break;

  case 365:
#line 3156 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37362 "preproc.c" /* yacc.c:1652  */
    break;

  case 366:
#line 3163 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 37370 "preproc.c" /* yacc.c:1652  */
    break;

  case 367:
#line 3167 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37377 "preproc.c" /* yacc.c:1652  */
    break;

  case 368:
#line 3174 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 37385 "preproc.c" /* yacc.c:1652  */
    break;

  case 369:
#line 3178 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37392 "preproc.c" /* yacc.c:1652  */
    break;

  case 370:
#line 3185 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nothing");
}
#line 37400 "preproc.c" /* yacc.c:1652  */
    break;

  case 371:
#line 3189 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("full");
}
#line 37408 "preproc.c" /* yacc.c:1652  */
    break;

  case 372:
#line 3193 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 37416 "preproc.c" /* yacc.c:1652  */
    break;

  case 373:
#line 3197 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using index"),(yyvsp[0].str));
}
#line 37424 "preproc.c" /* yacc.c:1652  */
    break;

  case 374:
#line 3205 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37432 "preproc.c" /* yacc.c:1652  */
    break;

  case 375:
#line 3213 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 37440 "preproc.c" /* yacc.c:1652  */
    break;

  case 376:
#line 3217 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37447 "preproc.c" /* yacc.c:1652  */
    break;

  case 377:
#line 3224 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37455 "preproc.c" /* yacc.c:1652  */
    break;

  case 378:
#line 3228 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37463 "preproc.c" /* yacc.c:1652  */
    break;

  case 379:
#line 3236 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 37471 "preproc.c" /* yacc.c:1652  */
    break;

  case 380:
#line 3240 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37479 "preproc.c" /* yacc.c:1652  */
    break;

  case 381:
#line 3244 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("."),(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 37487 "preproc.c" /* yacc.c:1652  */
    break;

  case 382:
#line 3248 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 37495 "preproc.c" /* yacc.c:1652  */
    break;

  case 383:
#line 3256 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37503 "preproc.c" /* yacc.c:1652  */
    break;

  case 384:
#line 3260 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37511 "preproc.c" /* yacc.c:1652  */
    break;

  case 385:
#line 3268 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restart");
}
#line 37519 "preproc.c" /* yacc.c:1652  */
    break;

  case 386:
#line 3272 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("restart"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37527 "preproc.c" /* yacc.c:1652  */
    break;

  case 387:
#line 3276 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 37535 "preproc.c" /* yacc.c:1652  */
    break;

  case 388:
#line 3280 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set generated"),(yyvsp[0].str));
}
#line 37543 "preproc.c" /* yacc.c:1652  */
    break;

  case 389:
#line 3288 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("for values with ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37551 "preproc.c" /* yacc.c:1652  */
    break;

  case 390:
#line 3292 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("for values in ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37559 "preproc.c" /* yacc.c:1652  */
    break;

  case 391:
#line 3296 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("for values from ("),(yyvsp[-5].str),mm_strdup(") to ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37567 "preproc.c" /* yacc.c:1652  */
    break;

  case 392:
#line 3300 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 37575 "preproc.c" /* yacc.c:1652  */
    break;

  case 393:
#line 3308 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37583 "preproc.c" /* yacc.c:1652  */
    break;

  case 394:
#line 3316 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37591 "preproc.c" /* yacc.c:1652  */
    break;

  case 395:
#line 3320 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37599 "preproc.c" /* yacc.c:1652  */
    break;

  case 396:
#line 3328 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter type"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37607 "preproc.c" /* yacc.c:1652  */
    break;

  case 397:
#line 3336 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37615 "preproc.c" /* yacc.c:1652  */
    break;

  case 398:
#line 3340 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37623 "preproc.c" /* yacc.c:1652  */
    break;

  case 399:
#line 3348 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("add attribute"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37631 "preproc.c" /* yacc.c:1652  */
    break;

  case 400:
#line 3352 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop attribute if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37639 "preproc.c" /* yacc.c:1652  */
    break;

  case 401:
#line 3356 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop attribute"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37647 "preproc.c" /* yacc.c:1652  */
    break;

  case 402:
#line 3360 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter attribute"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("type"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37655 "preproc.c" /* yacc.c:1652  */
    break;

  case 403:
#line 3368 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		(yyval.str) = cat2_str(mm_strdup("close"), cursor_marker);
	}
#line 37664 "preproc.c" /* yacc.c:1652  */
    break;

  case 404:
#line 3373 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("close all");
}
#line 37672 "preproc.c" /* yacc.c:1652  */
    break;

  case 405:
#line 3381 "preproc.y" /* yacc.c:1652  */
    { 
			if (strcmp((yyvsp[-5].str), "from") == 0 &&
			   (strcmp((yyvsp[-4].str), "stdin") == 0 || strcmp((yyvsp[-4].str), "stdout") == 0))
				mmerror(PARSE_ERROR, ET_WARNING, "COPY FROM STDIN is not implemented");

 (yyval.str) = cat_str(11,mm_strdup("copy"),(yyvsp[-9].str),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37684 "preproc.c" /* yacc.c:1652  */
    break;

  case 406:
#line 3389 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("copy ("),(yyvsp[-6].str),mm_strdup(") to"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37692 "preproc.c" /* yacc.c:1652  */
    break;

  case 407:
#line 3397 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("from");
}
#line 37700 "preproc.c" /* yacc.c:1652  */
    break;

  case 408:
#line 3401 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("to");
}
#line 37708 "preproc.c" /* yacc.c:1652  */
    break;

  case 409:
#line 3409 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("program");
}
#line 37716 "preproc.c" /* yacc.c:1652  */
    break;

  case 410:
#line 3413 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37723 "preproc.c" /* yacc.c:1652  */
    break;

  case 411:
#line 3420 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37731 "preproc.c" /* yacc.c:1652  */
    break;

  case 412:
#line 3424 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stdin");
}
#line 37739 "preproc.c" /* yacc.c:1652  */
    break;

  case 413:
#line 3428 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stdout");
}
#line 37747 "preproc.c" /* yacc.c:1652  */
    break;

  case 414:
#line 3436 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37755 "preproc.c" /* yacc.c:1652  */
    break;

  case 415:
#line 3440 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37763 "preproc.c" /* yacc.c:1652  */
    break;

  case 416:
#line 3448 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37771 "preproc.c" /* yacc.c:1652  */
    break;

  case 417:
#line 3452 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37778 "preproc.c" /* yacc.c:1652  */
    break;

  case 418:
#line 3459 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("binary");
}
#line 37786 "preproc.c" /* yacc.c:1652  */
    break;

  case 419:
#line 3463 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("freeze");
}
#line 37794 "preproc.c" /* yacc.c:1652  */
    break;

  case 420:
#line 3467 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("delimiter"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37802 "preproc.c" /* yacc.c:1652  */
    break;

  case 421:
#line 3471 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("null"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37810 "preproc.c" /* yacc.c:1652  */
    break;

  case 422:
#line 3475 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("csv");
}
#line 37818 "preproc.c" /* yacc.c:1652  */
    break;

  case 423:
#line 3479 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("header");
}
#line 37826 "preproc.c" /* yacc.c:1652  */
    break;

  case 424:
#line 3483 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("quote"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37834 "preproc.c" /* yacc.c:1652  */
    break;

  case 425:
#line 3487 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("escape"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37842 "preproc.c" /* yacc.c:1652  */
    break;

  case 426:
#line 3491 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("force quote"),(yyvsp[0].str));
}
#line 37850 "preproc.c" /* yacc.c:1652  */
    break;

  case 427:
#line 3495 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("force quote *");
}
#line 37858 "preproc.c" /* yacc.c:1652  */
    break;

  case 428:
#line 3499 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("force not null"),(yyvsp[0].str));
}
#line 37866 "preproc.c" /* yacc.c:1652  */
    break;

  case 429:
#line 3503 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("force null"),(yyvsp[0].str));
}
#line 37874 "preproc.c" /* yacc.c:1652  */
    break;

  case 430:
#line 3507 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("encoding"),(yyvsp[0].str));
}
#line 37882 "preproc.c" /* yacc.c:1652  */
    break;

  case 431:
#line 3515 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("binary");
}
#line 37890 "preproc.c" /* yacc.c:1652  */
    break;

  case 432:
#line 3519 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37897 "preproc.c" /* yacc.c:1652  */
    break;

  case 433:
#line 3526 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("delimiters"),(yyvsp[0].str));
}
#line 37905 "preproc.c" /* yacc.c:1652  */
    break;

  case 434:
#line 3530 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37912 "preproc.c" /* yacc.c:1652  */
    break;

  case 435:
#line 3537 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("using");
}
#line 37920 "preproc.c" /* yacc.c:1652  */
    break;

  case 436:
#line 3541 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37927 "preproc.c" /* yacc.c:1652  */
    break;

  case 437:
#line 3548 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37935 "preproc.c" /* yacc.c:1652  */
    break;

  case 438:
#line 3552 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37943 "preproc.c" /* yacc.c:1652  */
    break;

  case 439:
#line 3560 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37951 "preproc.c" /* yacc.c:1652  */
    break;

  case 440:
#line 3568 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37959 "preproc.c" /* yacc.c:1652  */
    break;

  case 441:
#line 3572 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37967 "preproc.c" /* yacc.c:1652  */
    break;

  case 442:
#line 3576 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("*");
}
#line 37975 "preproc.c" /* yacc.c:1652  */
    break;

  case 443:
#line 3580 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37983 "preproc.c" /* yacc.c:1652  */
    break;

  case 444:
#line 3584 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 37990 "preproc.c" /* yacc.c:1652  */
    break;

  case 445:
#line 3591 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37998 "preproc.c" /* yacc.c:1652  */
    break;

  case 446:
#line 3595 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 38006 "preproc.c" /* yacc.c:1652  */
    break;

  case 447:
#line 3603 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38014 "preproc.c" /* yacc.c:1652  */
    break;

  case 448:
#line 3611 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(13,mm_strdup("create"),(yyvsp[-11].str),mm_strdup("table"),(yyvsp[-9].str),mm_strdup("("),(yyvsp[-7].str),mm_strdup(")"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38022 "preproc.c" /* yacc.c:1652  */
    break;

  case 449:
#line 3615 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(13,mm_strdup("create"),(yyvsp[-14].str),mm_strdup("table if not exists"),(yyvsp[-9].str),mm_strdup("("),(yyvsp[-7].str),mm_strdup(")"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38030 "preproc.c" /* yacc.c:1652  */
    break;

  case 450:
#line 3619 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(12,mm_strdup("create"),(yyvsp[-10].str),mm_strdup("table"),(yyvsp[-8].str),mm_strdup("of"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38038 "preproc.c" /* yacc.c:1652  */
    break;

  case 451:
#line 3623 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(12,mm_strdup("create"),(yyvsp[-13].str),mm_strdup("table if not exists"),(yyvsp[-8].str),mm_strdup("of"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38046 "preproc.c" /* yacc.c:1652  */
    break;

  case 452:
#line 3627 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(13,mm_strdup("create"),(yyvsp[-12].str),mm_strdup("table"),(yyvsp[-10].str),mm_strdup("partition of"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38054 "preproc.c" /* yacc.c:1652  */
    break;

  case 453:
#line 3631 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(13,mm_strdup("create"),(yyvsp[-15].str),mm_strdup("table if not exists"),(yyvsp[-10].str),mm_strdup("partition of"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38062 "preproc.c" /* yacc.c:1652  */
    break;

  case 454:
#line 3639 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("temporary");
}
#line 38070 "preproc.c" /* yacc.c:1652  */
    break;

  case 455:
#line 3643 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("temp");
}
#line 38078 "preproc.c" /* yacc.c:1652  */
    break;

  case 456:
#line 3647 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("local temporary");
}
#line 38086 "preproc.c" /* yacc.c:1652  */
    break;

  case 457:
#line 3651 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("local temp");
}
#line 38094 "preproc.c" /* yacc.c:1652  */
    break;

  case 458:
#line 3655 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("global temporary");
}
#line 38102 "preproc.c" /* yacc.c:1652  */
    break;

  case 459:
#line 3659 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("global temp");
}
#line 38110 "preproc.c" /* yacc.c:1652  */
    break;

  case 460:
#line 3663 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 38118 "preproc.c" /* yacc.c:1652  */
    break;

  case 461:
#line 3667 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38125 "preproc.c" /* yacc.c:1652  */
    break;

  case 462:
#line 3674 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38133 "preproc.c" /* yacc.c:1652  */
    break;

  case 463:
#line 3678 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38140 "preproc.c" /* yacc.c:1652  */
    break;

  case 464:
#line 3685 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 38148 "preproc.c" /* yacc.c:1652  */
    break;

  case 465:
#line 3689 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38155 "preproc.c" /* yacc.c:1652  */
    break;

  case 466:
#line 3696 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38163 "preproc.c" /* yacc.c:1652  */
    break;

  case 467:
#line 3700 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 38171 "preproc.c" /* yacc.c:1652  */
    break;

  case 468:
#line 3708 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38179 "preproc.c" /* yacc.c:1652  */
    break;

  case 469:
#line 3712 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 38187 "preproc.c" /* yacc.c:1652  */
    break;

  case 470:
#line 3720 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38195 "preproc.c" /* yacc.c:1652  */
    break;

  case 471:
#line 3724 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38203 "preproc.c" /* yacc.c:1652  */
    break;

  case 472:
#line 3728 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38211 "preproc.c" /* yacc.c:1652  */
    break;

  case 473:
#line 3736 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38219 "preproc.c" /* yacc.c:1652  */
    break;

  case 474:
#line 3740 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38227 "preproc.c" /* yacc.c:1652  */
    break;

  case 475:
#line 3748 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38235 "preproc.c" /* yacc.c:1652  */
    break;

  case 476:
#line 3756 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38243 "preproc.c" /* yacc.c:1652  */
    break;

  case 477:
#line 3760 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("with options"),(yyvsp[0].str));
}
#line 38251 "preproc.c" /* yacc.c:1652  */
    break;

  case 478:
#line 3768 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38259 "preproc.c" /* yacc.c:1652  */
    break;

  case 479:
#line 3772 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38266 "preproc.c" /* yacc.c:1652  */
    break;

  case 480:
#line 3779 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38274 "preproc.c" /* yacc.c:1652  */
    break;

  case 481:
#line 3783 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38282 "preproc.c" /* yacc.c:1652  */
    break;

  case 482:
#line 3787 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38290 "preproc.c" /* yacc.c:1652  */
    break;

  case 483:
#line 3791 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 38298 "preproc.c" /* yacc.c:1652  */
    break;

  case 484:
#line 3799 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not null");
}
#line 38306 "preproc.c" /* yacc.c:1652  */
    break;

  case 485:
#line 3803 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("null");
}
#line 38314 "preproc.c" /* yacc.c:1652  */
    break;

  case 486:
#line 3807 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("unique"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38322 "preproc.c" /* yacc.c:1652  */
    break;

  case 487:
#line 3811 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("primary key"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38330 "preproc.c" /* yacc.c:1652  */
    break;

  case 488:
#line 3815 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 38338 "preproc.c" /* yacc.c:1652  */
    break;

  case 489:
#line 3819 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("default"),(yyvsp[0].str));
}
#line 38346 "preproc.c" /* yacc.c:1652  */
    break;

  case 490:
#line 3823 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("generated"),(yyvsp[-3].str),mm_strdup("as identity"),(yyvsp[0].str));
}
#line 38354 "preproc.c" /* yacc.c:1652  */
    break;

  case 491:
#line 3827 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("generated"),(yyvsp[-5].str),mm_strdup("as ("),(yyvsp[-2].str),mm_strdup(") stored"));
}
#line 38362 "preproc.c" /* yacc.c:1652  */
    break;

  case 492:
#line 3831 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("references"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38370 "preproc.c" /* yacc.c:1652  */
    break;

  case 493:
#line 3839 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("always");
}
#line 38378 "preproc.c" /* yacc.c:1652  */
    break;

  case 494:
#line 3843 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("by default");
}
#line 38386 "preproc.c" /* yacc.c:1652  */
    break;

  case 495:
#line 3851 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 38394 "preproc.c" /* yacc.c:1652  */
    break;

  case 496:
#line 3855 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 38402 "preproc.c" /* yacc.c:1652  */
    break;

  case 497:
#line 3859 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("initially deferred");
}
#line 38410 "preproc.c" /* yacc.c:1652  */
    break;

  case 498:
#line 3863 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("initially immediate");
}
#line 38418 "preproc.c" /* yacc.c:1652  */
    break;

  case 499:
#line 3871 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("like"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38426 "preproc.c" /* yacc.c:1652  */
    break;

  case 500:
#line 3879 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("including"),(yyvsp[0].str));
}
#line 38434 "preproc.c" /* yacc.c:1652  */
    break;

  case 501:
#line 3883 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("excluding"),(yyvsp[0].str));
}
#line 38442 "preproc.c" /* yacc.c:1652  */
    break;

  case 502:
#line 3887 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38449 "preproc.c" /* yacc.c:1652  */
    break;

  case 503:
#line 3894 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("comments");
}
#line 38457 "preproc.c" /* yacc.c:1652  */
    break;

  case 504:
#line 3898 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("constraints");
}
#line 38465 "preproc.c" /* yacc.c:1652  */
    break;

  case 505:
#line 3902 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("defaults");
}
#line 38473 "preproc.c" /* yacc.c:1652  */
    break;

  case 506:
#line 3906 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("identity");
}
#line 38481 "preproc.c" /* yacc.c:1652  */
    break;

  case 507:
#line 3910 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("generated");
}
#line 38489 "preproc.c" /* yacc.c:1652  */
    break;

  case 508:
#line 3914 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("indexes");
}
#line 38497 "preproc.c" /* yacc.c:1652  */
    break;

  case 509:
#line 3918 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("statistics");
}
#line 38505 "preproc.c" /* yacc.c:1652  */
    break;

  case 510:
#line 3922 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("storage");
}
#line 38513 "preproc.c" /* yacc.c:1652  */
    break;

  case 511:
#line 3926 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 38521 "preproc.c" /* yacc.c:1652  */
    break;

  case 512:
#line 3934 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38529 "preproc.c" /* yacc.c:1652  */
    break;

  case 513:
#line 3938 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38537 "preproc.c" /* yacc.c:1652  */
    break;

  case 514:
#line 3946 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 38545 "preproc.c" /* yacc.c:1652  */
    break;

  case 515:
#line 3950 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("unique ("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38553 "preproc.c" /* yacc.c:1652  */
    break;

  case 516:
#line 3954 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("unique"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38561 "preproc.c" /* yacc.c:1652  */
    break;

  case 517:
#line 3958 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("primary key ("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38569 "preproc.c" /* yacc.c:1652  */
    break;

  case 518:
#line 3962 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("primary key"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38577 "preproc.c" /* yacc.c:1652  */
    break;

  case 519:
#line 3966 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(10,mm_strdup("exclude"),(yyvsp[-8].str),mm_strdup("("),(yyvsp[-6].str),mm_strdup(")"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38585 "preproc.c" /* yacc.c:1652  */
    break;

  case 520:
#line 3970 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("foreign key ("),(yyvsp[-7].str),mm_strdup(") references"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38593 "preproc.c" /* yacc.c:1652  */
    break;

  case 521:
#line 3978 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no inherit");
}
#line 38601 "preproc.c" /* yacc.c:1652  */
    break;

  case 522:
#line 3982 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38608 "preproc.c" /* yacc.c:1652  */
    break;

  case 523:
#line 3989 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 38616 "preproc.c" /* yacc.c:1652  */
    break;

  case 524:
#line 3993 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38623 "preproc.c" /* yacc.c:1652  */
    break;

  case 525:
#line 4000 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38631 "preproc.c" /* yacc.c:1652  */
    break;

  case 526:
#line 4004 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 38639 "preproc.c" /* yacc.c:1652  */
    break;

  case 527:
#line 4012 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38647 "preproc.c" /* yacc.c:1652  */
    break;

  case 528:
#line 4020 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("include ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 38655 "preproc.c" /* yacc.c:1652  */
    break;

  case 529:
#line 4024 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38662 "preproc.c" /* yacc.c:1652  */
    break;

  case 530:
#line 4031 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("match full");
}
#line 38670 "preproc.c" /* yacc.c:1652  */
    break;

  case 531:
#line 4035 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = mm_strdup("match partial");
}
#line 38679 "preproc.c" /* yacc.c:1652  */
    break;

  case 532:
#line 4040 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("match simple");
}
#line 38687 "preproc.c" /* yacc.c:1652  */
    break;

  case 533:
#line 4044 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38694 "preproc.c" /* yacc.c:1652  */
    break;

  case 534:
#line 4051 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38702 "preproc.c" /* yacc.c:1652  */
    break;

  case 535:
#line 4055 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 38710 "preproc.c" /* yacc.c:1652  */
    break;

  case 536:
#line 4063 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 38718 "preproc.c" /* yacc.c:1652  */
    break;

  case 537:
#line 4067 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("with operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 38726 "preproc.c" /* yacc.c:1652  */
    break;

  case 538:
#line 4075 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("where ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 38734 "preproc.c" /* yacc.c:1652  */
    break;

  case 539:
#line 4079 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38741 "preproc.c" /* yacc.c:1652  */
    break;

  case 540:
#line 4086 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38749 "preproc.c" /* yacc.c:1652  */
    break;

  case 541:
#line 4090 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38757 "preproc.c" /* yacc.c:1652  */
    break;

  case 542:
#line 4094 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38765 "preproc.c" /* yacc.c:1652  */
    break;

  case 543:
#line 4098 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38773 "preproc.c" /* yacc.c:1652  */
    break;

  case 544:
#line 4102 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38780 "preproc.c" /* yacc.c:1652  */
    break;

  case 545:
#line 4109 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("on update"),(yyvsp[0].str));
}
#line 38788 "preproc.c" /* yacc.c:1652  */
    break;

  case 546:
#line 4117 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("on delete"),(yyvsp[0].str));
}
#line 38796 "preproc.c" /* yacc.c:1652  */
    break;

  case 547:
#line 4125 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no action");
}
#line 38804 "preproc.c" /* yacc.c:1652  */
    break;

  case 548:
#line 4129 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restrict");
}
#line 38812 "preproc.c" /* yacc.c:1652  */
    break;

  case 549:
#line 4133 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cascade");
}
#line 38820 "preproc.c" /* yacc.c:1652  */
    break;

  case 550:
#line 4137 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set null");
}
#line 38828 "preproc.c" /* yacc.c:1652  */
    break;

  case 551:
#line 4141 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set default");
}
#line 38836 "preproc.c" /* yacc.c:1652  */
    break;

  case 552:
#line 4149 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("inherits ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 38844 "preproc.c" /* yacc.c:1652  */
    break;

  case 553:
#line 4153 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38851 "preproc.c" /* yacc.c:1652  */
    break;

  case 554:
#line 4160 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38859 "preproc.c" /* yacc.c:1652  */
    break;

  case 555:
#line 4164 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38866 "preproc.c" /* yacc.c:1652  */
    break;

  case 556:
#line 4171 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("partition by"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 38874 "preproc.c" /* yacc.c:1652  */
    break;

  case 557:
#line 4179 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38882 "preproc.c" /* yacc.c:1652  */
    break;

  case 558:
#line 4183 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 38890 "preproc.c" /* yacc.c:1652  */
    break;

  case 559:
#line 4191 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38898 "preproc.c" /* yacc.c:1652  */
    break;

  case 560:
#line 4195 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38906 "preproc.c" /* yacc.c:1652  */
    break;

  case 561:
#line 4199 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38914 "preproc.c" /* yacc.c:1652  */
    break;

  case 562:
#line 4207 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 38922 "preproc.c" /* yacc.c:1652  */
    break;

  case 563:
#line 4211 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38929 "preproc.c" /* yacc.c:1652  */
    break;

  case 564:
#line 4218 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 38937 "preproc.c" /* yacc.c:1652  */
    break;

  case 565:
#line 4222 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("without oids");
}
#line 38945 "preproc.c" /* yacc.c:1652  */
    break;

  case 566:
#line 4226 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38952 "preproc.c" /* yacc.c:1652  */
    break;

  case 567:
#line 4233 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("on commit drop");
}
#line 38960 "preproc.c" /* yacc.c:1652  */
    break;

  case 568:
#line 4237 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("on commit delete rows");
}
#line 38968 "preproc.c" /* yacc.c:1652  */
    break;

  case 569:
#line 4241 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("on commit preserve rows");
}
#line 38976 "preproc.c" /* yacc.c:1652  */
    break;

  case 570:
#line 4245 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38983 "preproc.c" /* yacc.c:1652  */
    break;

  case 571:
#line 4252 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("tablespace"),(yyvsp[0].str));
}
#line 38991 "preproc.c" /* yacc.c:1652  */
    break;

  case 572:
#line 4256 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 38998 "preproc.c" /* yacc.c:1652  */
    break;

  case 573:
#line 4263 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using index tablespace"),(yyvsp[0].str));
}
#line 39006 "preproc.c" /* yacc.c:1652  */
    break;

  case 574:
#line 4267 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39013 "preproc.c" /* yacc.c:1652  */
    break;

  case 575:
#line 4274 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using index"),(yyvsp[0].str));
}
#line 39021 "preproc.c" /* yacc.c:1652  */
    break;

  case 576:
#line 4282 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create statistics"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 39029 "preproc.c" /* yacc.c:1652  */
    break;

  case 577:
#line 4286 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create statistics if not exists"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 39037 "preproc.c" /* yacc.c:1652  */
    break;

  case 578:
#line 4294 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter statistics"),(yyvsp[-3].str),mm_strdup("set statistics"),(yyvsp[0].str));
}
#line 39045 "preproc.c" /* yacc.c:1652  */
    break;

  case 579:
#line 4298 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter statistics if exists"),(yyvsp[-3].str),mm_strdup("set statistics"),(yyvsp[0].str));
}
#line 39053 "preproc.c" /* yacc.c:1652  */
    break;

  case 580:
#line 4306 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39061 "preproc.c" /* yacc.c:1652  */
    break;

  case 581:
#line 4314 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with data");
}
#line 39069 "preproc.c" /* yacc.c:1652  */
    break;

  case 582:
#line 4318 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with no data");
}
#line 39077 "preproc.c" /* yacc.c:1652  */
    break;

  case 583:
#line 4322 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39084 "preproc.c" /* yacc.c:1652  */
    break;

  case 584:
#line 4329 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create"),(yyvsp[-6].str),mm_strdup("materialized view"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39092 "preproc.c" /* yacc.c:1652  */
    break;

  case 585:
#line 4333 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create"),(yyvsp[-9].str),mm_strdup("materialized view if not exists"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39100 "preproc.c" /* yacc.c:1652  */
    break;

  case 586:
#line 4341 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39108 "preproc.c" /* yacc.c:1652  */
    break;

  case 587:
#line 4349 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 39116 "preproc.c" /* yacc.c:1652  */
    break;

  case 588:
#line 4353 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39123 "preproc.c" /* yacc.c:1652  */
    break;

  case 589:
#line 4360 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("refresh materialized view"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39131 "preproc.c" /* yacc.c:1652  */
    break;

  case 590:
#line 4368 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create"),(yyvsp[-3].str),mm_strdup("sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39139 "preproc.c" /* yacc.c:1652  */
    break;

  case 591:
#line 4372 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create"),(yyvsp[-6].str),mm_strdup("sequence if not exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39147 "preproc.c" /* yacc.c:1652  */
    break;

  case 592:
#line 4380 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39155 "preproc.c" /* yacc.c:1652  */
    break;

  case 593:
#line 4384 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39163 "preproc.c" /* yacc.c:1652  */
    break;

  case 594:
#line 4392 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39171 "preproc.c" /* yacc.c:1652  */
    break;

  case 595:
#line 4396 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39178 "preproc.c" /* yacc.c:1652  */
    break;

  case 596:
#line 4403 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39186 "preproc.c" /* yacc.c:1652  */
    break;

  case 597:
#line 4407 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39193 "preproc.c" /* yacc.c:1652  */
    break;

  case 598:
#line 4414 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39201 "preproc.c" /* yacc.c:1652  */
    break;

  case 599:
#line 4418 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39209 "preproc.c" /* yacc.c:1652  */
    break;

  case 600:
#line 4426 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 39217 "preproc.c" /* yacc.c:1652  */
    break;

  case 601:
#line 4430 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("cache"),(yyvsp[0].str));
}
#line 39225 "preproc.c" /* yacc.c:1652  */
    break;

  case 602:
#line 4434 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cycle");
}
#line 39233 "preproc.c" /* yacc.c:1652  */
    break;

  case 603:
#line 4438 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no cycle");
}
#line 39241 "preproc.c" /* yacc.c:1652  */
    break;

  case 604:
#line 4442 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("increment"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39249 "preproc.c" /* yacc.c:1652  */
    break;

  case 605:
#line 4446 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("maxvalue"),(yyvsp[0].str));
}
#line 39257 "preproc.c" /* yacc.c:1652  */
    break;

  case 606:
#line 4450 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("minvalue"),(yyvsp[0].str));
}
#line 39265 "preproc.c" /* yacc.c:1652  */
    break;

  case 607:
#line 4454 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no maxvalue");
}
#line 39273 "preproc.c" /* yacc.c:1652  */
    break;

  case 608:
#line 4458 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no minvalue");
}
#line 39281 "preproc.c" /* yacc.c:1652  */
    break;

  case 609:
#line 4462 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("owned by"),(yyvsp[0].str));
}
#line 39289 "preproc.c" /* yacc.c:1652  */
    break;

  case 610:
#line 4466 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("sequence name"),(yyvsp[0].str));
}
#line 39297 "preproc.c" /* yacc.c:1652  */
    break;

  case 611:
#line 4470 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("start"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39305 "preproc.c" /* yacc.c:1652  */
    break;

  case 612:
#line 4474 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restart");
}
#line 39313 "preproc.c" /* yacc.c:1652  */
    break;

  case 613:
#line 4478 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("restart"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39321 "preproc.c" /* yacc.c:1652  */
    break;

  case 614:
#line 4486 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("by");
}
#line 39329 "preproc.c" /* yacc.c:1652  */
    break;

  case 615:
#line 4490 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39336 "preproc.c" /* yacc.c:1652  */
    break;

  case 616:
#line 4497 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39344 "preproc.c" /* yacc.c:1652  */
    break;

  case 617:
#line 4501 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 39352 "preproc.c" /* yacc.c:1652  */
    break;

  case 618:
#line 4505 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 39360 "preproc.c" /* yacc.c:1652  */
    break;

  case 619:
#line 4509 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39368 "preproc.c" /* yacc.c:1652  */
    break;

  case 620:
#line 4517 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39376 "preproc.c" /* yacc.c:1652  */
    break;

  case 621:
#line 4521 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39384 "preproc.c" /* yacc.c:1652  */
    break;

  case 622:
#line 4529 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("language"),(yyvsp[0].str));
}
#line 39392 "preproc.c" /* yacc.c:1652  */
    break;

  case 623:
#line 4533 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("language"),(yyvsp[-4].str),mm_strdup("handler"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39400 "preproc.c" /* yacc.c:1652  */
    break;

  case 624:
#line 4541 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("trusted");
}
#line 39408 "preproc.c" /* yacc.c:1652  */
    break;

  case 625:
#line 4545 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39415 "preproc.c" /* yacc.c:1652  */
    break;

  case 626:
#line 4552 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39423 "preproc.c" /* yacc.c:1652  */
    break;

  case 627:
#line 4556 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39431 "preproc.c" /* yacc.c:1652  */
    break;

  case 628:
#line 4564 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("inline"),(yyvsp[0].str));
}
#line 39439 "preproc.c" /* yacc.c:1652  */
    break;

  case 629:
#line 4568 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39446 "preproc.c" /* yacc.c:1652  */
    break;

  case 630:
#line 4575 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("validator"),(yyvsp[0].str));
}
#line 39454 "preproc.c" /* yacc.c:1652  */
    break;

  case 631:
#line 4579 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no validator");
}
#line 39462 "preproc.c" /* yacc.c:1652  */
    break;

  case 632:
#line 4587 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39470 "preproc.c" /* yacc.c:1652  */
    break;

  case 633:
#line 4591 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39477 "preproc.c" /* yacc.c:1652  */
    break;

  case 634:
#line 4598 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-3].str),mm_strdup("language"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39485 "preproc.c" /* yacc.c:1652  */
    break;

  case 635:
#line 4602 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-5].str),mm_strdup("language if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39493 "preproc.c" /* yacc.c:1652  */
    break;

  case 636:
#line 4610 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("procedural");
}
#line 39501 "preproc.c" /* yacc.c:1652  */
    break;

  case 637:
#line 4614 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39508 "preproc.c" /* yacc.c:1652  */
    break;

  case 638:
#line 4621 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create tablespace"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("location"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39516 "preproc.c" /* yacc.c:1652  */
    break;

  case 639:
#line 4629 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("owner"),(yyvsp[0].str));
}
#line 39524 "preproc.c" /* yacc.c:1652  */
    break;

  case 640:
#line 4633 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39531 "preproc.c" /* yacc.c:1652  */
    break;

  case 641:
#line 4640 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop tablespace"),(yyvsp[0].str));
}
#line 39539 "preproc.c" /* yacc.c:1652  */
    break;

  case 642:
#line 4644 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop tablespace if exists"),(yyvsp[0].str));
}
#line 39547 "preproc.c" /* yacc.c:1652  */
    break;

  case 643:
#line 4652 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create extension"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39555 "preproc.c" /* yacc.c:1652  */
    break;

  case 644:
#line 4656 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create extension if not exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39563 "preproc.c" /* yacc.c:1652  */
    break;

  case 645:
#line 4664 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39571 "preproc.c" /* yacc.c:1652  */
    break;

  case 646:
#line 4668 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39578 "preproc.c" /* yacc.c:1652  */
    break;

  case 647:
#line 4675 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 39586 "preproc.c" /* yacc.c:1652  */
    break;

  case 648:
#line 4679 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 39594 "preproc.c" /* yacc.c:1652  */
    break;

  case 649:
#line 4683 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 39603 "preproc.c" /* yacc.c:1652  */
    break;

  case 650:
#line 4688 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cascade");
}
#line 39611 "preproc.c" /* yacc.c:1652  */
    break;

  case 651:
#line 4696 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter extension"),(yyvsp[-2].str),mm_strdup("update"),(yyvsp[0].str));
}
#line 39619 "preproc.c" /* yacc.c:1652  */
    break;

  case 652:
#line 4704 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39627 "preproc.c" /* yacc.c:1652  */
    break;

  case 653:
#line 4708 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39634 "preproc.c" /* yacc.c:1652  */
    break;

  case 654:
#line 4715 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("to"),(yyvsp[0].str));
}
#line 39642 "preproc.c" /* yacc.c:1652  */
    break;

  case 655:
#line 4723 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("access method"),(yyvsp[0].str));
}
#line 39650 "preproc.c" /* yacc.c:1652  */
    break;

  case 656:
#line 4727 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("aggregate"),(yyvsp[0].str));
}
#line 39658 "preproc.c" /* yacc.c:1652  */
    break;

  case 657:
#line 4731 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("alter extension"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("cast ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39666 "preproc.c" /* yacc.c:1652  */
    break;

  case 658:
#line 4735 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("collation"),(yyvsp[0].str));
}
#line 39674 "preproc.c" /* yacc.c:1652  */
    break;

  case 659:
#line 4739 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("conversion"),(yyvsp[0].str));
}
#line 39682 "preproc.c" /* yacc.c:1652  */
    break;

  case 660:
#line 4743 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("domain"),(yyvsp[0].str));
}
#line 39690 "preproc.c" /* yacc.c:1652  */
    break;

  case 661:
#line 4747 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("function"),(yyvsp[0].str));
}
#line 39698 "preproc.c" /* yacc.c:1652  */
    break;

  case 662:
#line 4751 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("language"),(yyvsp[0].str));
}
#line 39706 "preproc.c" /* yacc.c:1652  */
    break;

  case 663:
#line 4755 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("operator"),(yyvsp[0].str));
}
#line 39714 "preproc.c" /* yacc.c:1652  */
    break;

  case 664:
#line 4759 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter extension"),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("operator class"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 39722 "preproc.c" /* yacc.c:1652  */
    break;

  case 665:
#line 4763 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter extension"),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("operator family"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 39730 "preproc.c" /* yacc.c:1652  */
    break;

  case 666:
#line 4767 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("procedure"),(yyvsp[0].str));
}
#line 39738 "preproc.c" /* yacc.c:1652  */
    break;

  case 667:
#line 4771 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("routine"),(yyvsp[0].str));
}
#line 39746 "preproc.c" /* yacc.c:1652  */
    break;

  case 668:
#line 4775 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("schema"),(yyvsp[0].str));
}
#line 39754 "preproc.c" /* yacc.c:1652  */
    break;

  case 669:
#line 4779 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("event trigger"),(yyvsp[0].str));
}
#line 39762 "preproc.c" /* yacc.c:1652  */
    break;

  case 670:
#line 4783 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("table"),(yyvsp[0].str));
}
#line 39770 "preproc.c" /* yacc.c:1652  */
    break;

  case 671:
#line 4787 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search parser"),(yyvsp[0].str));
}
#line 39778 "preproc.c" /* yacc.c:1652  */
    break;

  case 672:
#line 4791 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search dictionary"),(yyvsp[0].str));
}
#line 39786 "preproc.c" /* yacc.c:1652  */
    break;

  case 673:
#line 4795 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search template"),(yyvsp[0].str));
}
#line 39794 "preproc.c" /* yacc.c:1652  */
    break;

  case 674:
#line 4799 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search configuration"),(yyvsp[0].str));
}
#line 39802 "preproc.c" /* yacc.c:1652  */
    break;

  case 675:
#line 4803 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("sequence"),(yyvsp[0].str));
}
#line 39810 "preproc.c" /* yacc.c:1652  */
    break;

  case 676:
#line 4807 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("view"),(yyvsp[0].str));
}
#line 39818 "preproc.c" /* yacc.c:1652  */
    break;

  case 677:
#line 4811 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("materialized view"),(yyvsp[0].str));
}
#line 39826 "preproc.c" /* yacc.c:1652  */
    break;

  case 678:
#line 4815 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("foreign table"),(yyvsp[0].str));
}
#line 39834 "preproc.c" /* yacc.c:1652  */
    break;

  case 679:
#line 4819 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("foreign data wrapper"),(yyvsp[0].str));
}
#line 39842 "preproc.c" /* yacc.c:1652  */
    break;

  case 680:
#line 4823 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 39850 "preproc.c" /* yacc.c:1652  */
    break;

  case 681:
#line 4827 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter extension"),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("transform for"),(yyvsp[-2].str),mm_strdup("language"),(yyvsp[0].str));
}
#line 39858 "preproc.c" /* yacc.c:1652  */
    break;

  case 682:
#line 4831 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("type"),(yyvsp[0].str));
}
#line 39866 "preproc.c" /* yacc.c:1652  */
    break;

  case 683:
#line 4839 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create foreign data wrapper"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39874 "preproc.c" /* yacc.c:1652  */
    break;

  case 684:
#line 4847 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("handler"),(yyvsp[0].str));
}
#line 39882 "preproc.c" /* yacc.c:1652  */
    break;

  case 685:
#line 4851 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no handler");
}
#line 39890 "preproc.c" /* yacc.c:1652  */
    break;

  case 686:
#line 4855 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("validator"),(yyvsp[0].str));
}
#line 39898 "preproc.c" /* yacc.c:1652  */
    break;

  case 687:
#line 4859 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no validator");
}
#line 39906 "preproc.c" /* yacc.c:1652  */
    break;

  case 688:
#line 4867 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39914 "preproc.c" /* yacc.c:1652  */
    break;

  case 689:
#line 4871 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39922 "preproc.c" /* yacc.c:1652  */
    break;

  case 690:
#line 4879 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39930 "preproc.c" /* yacc.c:1652  */
    break;

  case 691:
#line 4883 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39937 "preproc.c" /* yacc.c:1652  */
    break;

  case 692:
#line 4890 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39945 "preproc.c" /* yacc.c:1652  */
    break;

  case 693:
#line 4894 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39953 "preproc.c" /* yacc.c:1652  */
    break;

  case 694:
#line 4902 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("options ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39961 "preproc.c" /* yacc.c:1652  */
    break;

  case 695:
#line 4906 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 39968 "preproc.c" /* yacc.c:1652  */
    break;

  case 696:
#line 4913 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39976 "preproc.c" /* yacc.c:1652  */
    break;

  case 697:
#line 4917 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39984 "preproc.c" /* yacc.c:1652  */
    break;

  case 698:
#line 4925 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("options ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39992 "preproc.c" /* yacc.c:1652  */
    break;

  case 699:
#line 4933 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40000 "preproc.c" /* yacc.c:1652  */
    break;

  case 700:
#line 4937 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40008 "preproc.c" /* yacc.c:1652  */
    break;

  case 701:
#line 4945 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40016 "preproc.c" /* yacc.c:1652  */
    break;

  case 702:
#line 4949 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 40024 "preproc.c" /* yacc.c:1652  */
    break;

  case 703:
#line 4953 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 40032 "preproc.c" /* yacc.c:1652  */
    break;

  case 704:
#line 4957 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop"),(yyvsp[0].str));
}
#line 40040 "preproc.c" /* yacc.c:1652  */
    break;

  case 705:
#line 4965 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40048 "preproc.c" /* yacc.c:1652  */
    break;

  case 706:
#line 4973 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40056 "preproc.c" /* yacc.c:1652  */
    break;

  case 707:
#line 4981 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40064 "preproc.c" /* yacc.c:1652  */
    break;

  case 708:
#line 4989 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create server"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40072 "preproc.c" /* yacc.c:1652  */
    break;

  case 709:
#line 4993 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create server if not exists"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40080 "preproc.c" /* yacc.c:1652  */
    break;

  case 710:
#line 5001 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("type"),(yyvsp[0].str));
}
#line 40088 "preproc.c" /* yacc.c:1652  */
    break;

  case 711:
#line 5005 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40095 "preproc.c" /* yacc.c:1652  */
    break;

  case 712:
#line 5012 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 40103 "preproc.c" /* yacc.c:1652  */
    break;

  case 713:
#line 5016 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("version null");
}
#line 40111 "preproc.c" /* yacc.c:1652  */
    break;

  case 714:
#line 5024 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40119 "preproc.c" /* yacc.c:1652  */
    break;

  case 715:
#line 5028 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40126 "preproc.c" /* yacc.c:1652  */
    break;

  case 716:
#line 5035 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40134 "preproc.c" /* yacc.c:1652  */
    break;

  case 717:
#line 5039 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40142 "preproc.c" /* yacc.c:1652  */
    break;

  case 718:
#line 5043 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40150 "preproc.c" /* yacc.c:1652  */
    break;

  case 719:
#line 5051 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create foreign table"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40158 "preproc.c" /* yacc.c:1652  */
    break;

  case 720:
#line 5055 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create foreign table if not exists"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40166 "preproc.c" /* yacc.c:1652  */
    break;

  case 721:
#line 5059 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create foreign table"),(yyvsp[-8].str),mm_strdup("partition of"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40174 "preproc.c" /* yacc.c:1652  */
    break;

  case 722:
#line 5063 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create foreign table if not exists"),(yyvsp[-8].str),mm_strdup("partition of"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40182 "preproc.c" /* yacc.c:1652  */
    break;

  case 723:
#line 5071 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40190 "preproc.c" /* yacc.c:1652  */
    break;

  case 724:
#line 5075 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign table if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40198 "preproc.c" /* yacc.c:1652  */
    break;

  case 725:
#line 5083 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("import foreign schema"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("from server"),(yyvsp[-3].str),mm_strdup("into"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40206 "preproc.c" /* yacc.c:1652  */
    break;

  case 726:
#line 5091 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("limit to");
}
#line 40214 "preproc.c" /* yacc.c:1652  */
    break;

  case 727:
#line 5095 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("except");
}
#line 40222 "preproc.c" /* yacc.c:1652  */
    break;

  case 728:
#line 5103 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40230 "preproc.c" /* yacc.c:1652  */
    break;

  case 729:
#line 5107 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40237 "preproc.c" /* yacc.c:1652  */
    break;

  case 730:
#line 5114 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create user mapping for"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40245 "preproc.c" /* yacc.c:1652  */
    break;

  case 731:
#line 5118 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create user mapping if not exists for"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40253 "preproc.c" /* yacc.c:1652  */
    break;

  case 732:
#line 5126 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40261 "preproc.c" /* yacc.c:1652  */
    break;

  case 733:
#line 5130 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("user");
}
#line 40269 "preproc.c" /* yacc.c:1652  */
    break;

  case 734:
#line 5138 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop user mapping for"),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 40277 "preproc.c" /* yacc.c:1652  */
    break;

  case 735:
#line 5142 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop user mapping if exists for"),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 40285 "preproc.c" /* yacc.c:1652  */
    break;

  case 736:
#line 5150 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter user mapping for"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40293 "preproc.c" /* yacc.c:1652  */
    break;

  case 737:
#line 5158 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create policy"),(yyvsp[-7].str),mm_strdup("on"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40301 "preproc.c" /* yacc.c:1652  */
    break;

  case 738:
#line 5166 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter policy"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40309 "preproc.c" /* yacc.c:1652  */
    break;

  case 739:
#line 5174 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("using ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40317 "preproc.c" /* yacc.c:1652  */
    break;

  case 740:
#line 5178 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40324 "preproc.c" /* yacc.c:1652  */
    break;

  case 741:
#line 5185 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("with check ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40332 "preproc.c" /* yacc.c:1652  */
    break;

  case 742:
#line 5189 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40339 "preproc.c" /* yacc.c:1652  */
    break;

  case 743:
#line 5196 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("to"),(yyvsp[0].str));
}
#line 40347 "preproc.c" /* yacc.c:1652  */
    break;

  case 744:
#line 5200 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40354 "preproc.c" /* yacc.c:1652  */
    break;

  case 745:
#line 5207 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("to"),(yyvsp[0].str));
}
#line 40362 "preproc.c" /* yacc.c:1652  */
    break;

  case 746:
#line 5211 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40369 "preproc.c" /* yacc.c:1652  */
    break;

  case 747:
#line 5218 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 40377 "preproc.c" /* yacc.c:1652  */
    break;

  case 748:
#line 5222 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40384 "preproc.c" /* yacc.c:1652  */
    break;

  case 749:
#line 5229 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 40392 "preproc.c" /* yacc.c:1652  */
    break;

  case 750:
#line 5233 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40399 "preproc.c" /* yacc.c:1652  */
    break;

  case 751:
#line 5240 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 40407 "preproc.c" /* yacc.c:1652  */
    break;

  case 752:
#line 5244 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("select");
}
#line 40415 "preproc.c" /* yacc.c:1652  */
    break;

  case 753:
#line 5248 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("insert");
}
#line 40423 "preproc.c" /* yacc.c:1652  */
    break;

  case 754:
#line 5252 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("update");
}
#line 40431 "preproc.c" /* yacc.c:1652  */
    break;

  case 755:
#line 5256 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delete");
}
#line 40439 "preproc.c" /* yacc.c:1652  */
    break;

  case 756:
#line 5264 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create access method"),(yyvsp[-4].str),mm_strdup("type"),(yyvsp[-2].str),mm_strdup("handler"),(yyvsp[0].str));
}
#line 40447 "preproc.c" /* yacc.c:1652  */
    break;

  case 757:
#line 5272 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("index");
}
#line 40455 "preproc.c" /* yacc.c:1652  */
    break;

  case 758:
#line 5276 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 40463 "preproc.c" /* yacc.c:1652  */
    break;

  case 759:
#line 5284 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(15,mm_strdup("create trigger"),(yyvsp[-13].str),(yyvsp[-12].str),(yyvsp[-11].str),mm_strdup("on"),(yyvsp[-9].str),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("execute"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40471 "preproc.c" /* yacc.c:1652  */
    break;

  case 760:
#line 5288 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(16,mm_strdup("create constraint trigger"),(yyvsp[-16].str),mm_strdup("after"),(yyvsp[-14].str),mm_strdup("on"),(yyvsp[-12].str),(yyvsp[-11].str),(yyvsp[-10].str),mm_strdup("for each row"),(yyvsp[-6].str),mm_strdup("execute"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40479 "preproc.c" /* yacc.c:1652  */
    break;

  case 761:
#line 5296 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("before");
}
#line 40487 "preproc.c" /* yacc.c:1652  */
    break;

  case 762:
#line 5300 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("after");
}
#line 40495 "preproc.c" /* yacc.c:1652  */
    break;

  case 763:
#line 5304 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("instead of");
}
#line 40503 "preproc.c" /* yacc.c:1652  */
    break;

  case 764:
#line 5312 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40511 "preproc.c" /* yacc.c:1652  */
    break;

  case 765:
#line 5316 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("or"),(yyvsp[0].str));
}
#line 40519 "preproc.c" /* yacc.c:1652  */
    break;

  case 766:
#line 5324 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("insert");
}
#line 40527 "preproc.c" /* yacc.c:1652  */
    break;

  case 767:
#line 5328 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delete");
}
#line 40535 "preproc.c" /* yacc.c:1652  */
    break;

  case 768:
#line 5332 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("update");
}
#line 40543 "preproc.c" /* yacc.c:1652  */
    break;

  case 769:
#line 5336 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("update of"),(yyvsp[0].str));
}
#line 40551 "preproc.c" /* yacc.c:1652  */
    break;

  case 770:
#line 5340 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("truncate");
}
#line 40559 "preproc.c" /* yacc.c:1652  */
    break;

  case 771:
#line 5348 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("referencing"),(yyvsp[0].str));
}
#line 40567 "preproc.c" /* yacc.c:1652  */
    break;

  case 772:
#line 5352 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40574 "preproc.c" /* yacc.c:1652  */
    break;

  case 773:
#line 5359 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40582 "preproc.c" /* yacc.c:1652  */
    break;

  case 774:
#line 5363 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40590 "preproc.c" /* yacc.c:1652  */
    break;

  case 775:
#line 5371 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40598 "preproc.c" /* yacc.c:1652  */
    break;

  case 776:
#line 5379 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("new");
}
#line 40606 "preproc.c" /* yacc.c:1652  */
    break;

  case 777:
#line 5383 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("old");
}
#line 40614 "preproc.c" /* yacc.c:1652  */
    break;

  case 778:
#line 5391 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 40622 "preproc.c" /* yacc.c:1652  */
    break;

  case 779:
#line 5395 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row");
}
#line 40630 "preproc.c" /* yacc.c:1652  */
    break;

  case 780:
#line 5403 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40638 "preproc.c" /* yacc.c:1652  */
    break;

  case 781:
#line 5411 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("for"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40646 "preproc.c" /* yacc.c:1652  */
    break;

  case 782:
#line 5415 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40653 "preproc.c" /* yacc.c:1652  */
    break;

  case 783:
#line 5422 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("each");
}
#line 40661 "preproc.c" /* yacc.c:1652  */
    break;

  case 784:
#line 5426 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40668 "preproc.c" /* yacc.c:1652  */
    break;

  case 785:
#line 5433 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row");
}
#line 40676 "preproc.c" /* yacc.c:1652  */
    break;

  case 786:
#line 5437 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("statement");
}
#line 40684 "preproc.c" /* yacc.c:1652  */
    break;

  case 787:
#line 5445 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("when ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40692 "preproc.c" /* yacc.c:1652  */
    break;

  case 788:
#line 5449 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40699 "preproc.c" /* yacc.c:1652  */
    break;

  case 789:
#line 5456 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("function");
}
#line 40707 "preproc.c" /* yacc.c:1652  */
    break;

  case 790:
#line 5460 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("procedure");
}
#line 40715 "preproc.c" /* yacc.c:1652  */
    break;

  case 791:
#line 5468 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40723 "preproc.c" /* yacc.c:1652  */
    break;

  case 792:
#line 5472 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40731 "preproc.c" /* yacc.c:1652  */
    break;

  case 793:
#line 5476 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40738 "preproc.c" /* yacc.c:1652  */
    break;

  case 794:
#line 5483 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40746 "preproc.c" /* yacc.c:1652  */
    break;

  case 795:
#line 5487 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40754 "preproc.c" /* yacc.c:1652  */
    break;

  case 796:
#line 5491 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40762 "preproc.c" /* yacc.c:1652  */
    break;

  case 797:
#line 5495 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40770 "preproc.c" /* yacc.c:1652  */
    break;

  case 798:
#line 5503 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 40778 "preproc.c" /* yacc.c:1652  */
    break;

  case 799:
#line 5507 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40785 "preproc.c" /* yacc.c:1652  */
    break;

  case 800:
#line 5514 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 40792 "preproc.c" /* yacc.c:1652  */
    break;

  case 801:
#line 5517 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40800 "preproc.c" /* yacc.c:1652  */
    break;

  case 802:
#line 5525 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 40808 "preproc.c" /* yacc.c:1652  */
    break;

  case 803:
#line 5529 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 40816 "preproc.c" /* yacc.c:1652  */
    break;

  case 804:
#line 5533 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("initially immediate");
}
#line 40824 "preproc.c" /* yacc.c:1652  */
    break;

  case 805:
#line 5537 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("initially deferred");
}
#line 40832 "preproc.c" /* yacc.c:1652  */
    break;

  case 806:
#line 5541 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not valid");
}
#line 40840 "preproc.c" /* yacc.c:1652  */
    break;

  case 807:
#line 5545 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no inherit");
}
#line 40848 "preproc.c" /* yacc.c:1652  */
    break;

  case 808:
#line 5553 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("create event trigger"),(yyvsp[-7].str),mm_strdup("on"),(yyvsp[-5].str),mm_strdup("execute"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("( )"));
}
#line 40856 "preproc.c" /* yacc.c:1652  */
    break;

  case 809:
#line 5557 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(10,mm_strdup("create event trigger"),(yyvsp[-9].str),mm_strdup("on"),(yyvsp[-7].str),mm_strdup("when"),(yyvsp[-5].str),mm_strdup("execute"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("( )"));
}
#line 40864 "preproc.c" /* yacc.c:1652  */
    break;

  case 810:
#line 5565 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40872 "preproc.c" /* yacc.c:1652  */
    break;

  case 811:
#line 5569 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 40880 "preproc.c" /* yacc.c:1652  */
    break;

  case 812:
#line 5577 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup("in ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40888 "preproc.c" /* yacc.c:1652  */
    break;

  case 813:
#line 5585 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sconst");
}
#line 40896 "preproc.c" /* yacc.c:1652  */
    break;

  case 814:
#line 5589 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup(", sconst"));
}
#line 40904 "preproc.c" /* yacc.c:1652  */
    break;

  case 815:
#line 5597 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter event trigger"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40912 "preproc.c" /* yacc.c:1652  */
    break;

  case 816:
#line 5605 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable");
}
#line 40920 "preproc.c" /* yacc.c:1652  */
    break;

  case 817:
#line 5609 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable replica");
}
#line 40928 "preproc.c" /* yacc.c:1652  */
    break;

  case 818:
#line 5613 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable always");
}
#line 40936 "preproc.c" /* yacc.c:1652  */
    break;

  case 819:
#line 5617 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("disable");
}
#line 40944 "preproc.c" /* yacc.c:1652  */
    break;

  case 820:
#line 5625 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(6,mm_strdup("create assertion"),(yyvsp[-5].str),mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 40953 "preproc.c" /* yacc.c:1652  */
    break;

  case 821:
#line 5634 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create"),(yyvsp[-4].str),mm_strdup("aggregate"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40961 "preproc.c" /* yacc.c:1652  */
    break;

  case 822:
#line 5638 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create"),(yyvsp[-3].str),mm_strdup("aggregate"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40969 "preproc.c" /* yacc.c:1652  */
    break;

  case 823:
#line 5642 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create operator"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40977 "preproc.c" /* yacc.c:1652  */
    break;

  case 824:
#line 5646 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create type"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40985 "preproc.c" /* yacc.c:1652  */
    break;

  case 825:
#line 5650 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("create type"),(yyvsp[0].str));
}
#line 40993 "preproc.c" /* yacc.c:1652  */
    break;

  case 826:
#line 5654 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create type"),(yyvsp[-4].str),mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41001 "preproc.c" /* yacc.c:1652  */
    break;

  case 827:
#line 5658 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create type"),(yyvsp[-5].str),mm_strdup("as enum ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41009 "preproc.c" /* yacc.c:1652  */
    break;

  case 828:
#line 5662 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create type"),(yyvsp[-3].str),mm_strdup("as range"),(yyvsp[0].str));
}
#line 41017 "preproc.c" /* yacc.c:1652  */
    break;

  case 829:
#line 5666 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create text search parser"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41025 "preproc.c" /* yacc.c:1652  */
    break;

  case 830:
#line 5670 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create text search dictionary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41033 "preproc.c" /* yacc.c:1652  */
    break;

  case 831:
#line 5674 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create text search template"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41041 "preproc.c" /* yacc.c:1652  */
    break;

  case 832:
#line 5678 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create text search configuration"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41049 "preproc.c" /* yacc.c:1652  */
    break;

  case 833:
#line 5682 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create collation"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41057 "preproc.c" /* yacc.c:1652  */
    break;

  case 834:
#line 5686 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("create collation if not exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41065 "preproc.c" /* yacc.c:1652  */
    break;

  case 835:
#line 5690 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create collation"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 41073 "preproc.c" /* yacc.c:1652  */
    break;

  case 836:
#line 5694 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create collation if not exists"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 41081 "preproc.c" /* yacc.c:1652  */
    break;

  case 837:
#line 5702 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41089 "preproc.c" /* yacc.c:1652  */
    break;

  case 838:
#line 5710 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41097 "preproc.c" /* yacc.c:1652  */
    break;

  case 839:
#line 5714 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41105 "preproc.c" /* yacc.c:1652  */
    break;

  case 840:
#line 5722 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 41113 "preproc.c" /* yacc.c:1652  */
    break;

  case 841:
#line 5726 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41121 "preproc.c" /* yacc.c:1652  */
    break;

  case 842:
#line 5734 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41129 "preproc.c" /* yacc.c:1652  */
    break;

  case 843:
#line 5738 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41137 "preproc.c" /* yacc.c:1652  */
    break;

  case 844:
#line 5742 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41145 "preproc.c" /* yacc.c:1652  */
    break;

  case 845:
#line 5746 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41153 "preproc.c" /* yacc.c:1652  */
    break;

  case 846:
#line 5750 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41161 "preproc.c" /* yacc.c:1652  */
    break;

  case 847:
#line 5754 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("none");
}
#line 41169 "preproc.c" /* yacc.c:1652  */
    break;

  case 848:
#line 5762 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41177 "preproc.c" /* yacc.c:1652  */
    break;

  case 849:
#line 5770 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41185 "preproc.c" /* yacc.c:1652  */
    break;

  case 850:
#line 5774 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41193 "preproc.c" /* yacc.c:1652  */
    break;

  case 851:
#line 5782 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 41201 "preproc.c" /* yacc.c:1652  */
    break;

  case 852:
#line 5790 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41209 "preproc.c" /* yacc.c:1652  */
    break;

  case 853:
#line 5794 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41216 "preproc.c" /* yacc.c:1652  */
    break;

  case 854:
#line 5801 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41224 "preproc.c" /* yacc.c:1652  */
    break;

  case 855:
#line 5805 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41232 "preproc.c" /* yacc.c:1652  */
    break;

  case 856:
#line 5813 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter type"),(yyvsp[-4].str),mm_strdup("add value"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41240 "preproc.c" /* yacc.c:1652  */
    break;

  case 857:
#line 5817 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("add value"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("before"),(yyvsp[0].str));
}
#line 41248 "preproc.c" /* yacc.c:1652  */
    break;

  case 858:
#line 5821 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("add value"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("after"),(yyvsp[0].str));
}
#line 41256 "preproc.c" /* yacc.c:1652  */
    break;

  case 859:
#line 5825 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter type"),(yyvsp[-5].str),mm_strdup("rename value"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 41264 "preproc.c" /* yacc.c:1652  */
    break;

  case 860:
#line 5833 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("if not exists");
}
#line 41272 "preproc.c" /* yacc.c:1652  */
    break;

  case 861:
#line 5837 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41279 "preproc.c" /* yacc.c:1652  */
    break;

  case 862:
#line 5844 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(10,mm_strdup("create operator class"),(yyvsp[-9].str),(yyvsp[-8].str),mm_strdup("for type"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 41287 "preproc.c" /* yacc.c:1652  */
    break;

  case 863:
#line 5852 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41295 "preproc.c" /* yacc.c:1652  */
    break;

  case 864:
#line 5856 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41303 "preproc.c" /* yacc.c:1652  */
    break;

  case 865:
#line 5864 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("operator"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41311 "preproc.c" /* yacc.c:1652  */
    break;

  case 866:
#line 5868 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("operator"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41319 "preproc.c" /* yacc.c:1652  */
    break;

  case 867:
#line 5872 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("function"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41327 "preproc.c" /* yacc.c:1652  */
    break;

  case 868:
#line 5876 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("function"),(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 41335 "preproc.c" /* yacc.c:1652  */
    break;

  case 869:
#line 5880 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("storage"),(yyvsp[0].str));
}
#line 41343 "preproc.c" /* yacc.c:1652  */
    break;

  case 870:
#line 5888 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 41351 "preproc.c" /* yacc.c:1652  */
    break;

  case 871:
#line 5892 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41358 "preproc.c" /* yacc.c:1652  */
    break;

  case 872:
#line 5899 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("family"),(yyvsp[0].str));
}
#line 41366 "preproc.c" /* yacc.c:1652  */
    break;

  case 873:
#line 5903 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41373 "preproc.c" /* yacc.c:1652  */
    break;

  case 874:
#line 5910 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for search");
}
#line 41381 "preproc.c" /* yacc.c:1652  */
    break;

  case 875:
#line 5914 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for order by"),(yyvsp[0].str));
}
#line 41389 "preproc.c" /* yacc.c:1652  */
    break;

  case 876:
#line 5918 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41396 "preproc.c" /* yacc.c:1652  */
    break;

  case 877:
#line 5925 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = mm_strdup("recheck");
}
#line 41405 "preproc.c" /* yacc.c:1652  */
    break;

  case 878:
#line 5930 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41412 "preproc.c" /* yacc.c:1652  */
    break;

  case 879:
#line 5937 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create operator family"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 41420 "preproc.c" /* yacc.c:1652  */
    break;

  case 880:
#line 5945 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("add"),(yyvsp[0].str));
}
#line 41428 "preproc.c" /* yacc.c:1652  */
    break;

  case 881:
#line 5949 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("drop"),(yyvsp[0].str));
}
#line 41436 "preproc.c" /* yacc.c:1652  */
    break;

  case 882:
#line 5957 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41444 "preproc.c" /* yacc.c:1652  */
    break;

  case 883:
#line 5961 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41452 "preproc.c" /* yacc.c:1652  */
    break;

  case 884:
#line 5969 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("operator"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41460 "preproc.c" /* yacc.c:1652  */
    break;

  case 885:
#line 5973 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("function"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41468 "preproc.c" /* yacc.c:1652  */
    break;

  case 886:
#line 5981 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator class"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41476 "preproc.c" /* yacc.c:1652  */
    break;

  case 887:
#line 5985 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator class if exists"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41484 "preproc.c" /* yacc.c:1652  */
    break;

  case 888:
#line 5993 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator family"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41492 "preproc.c" /* yacc.c:1652  */
    break;

  case 889:
#line 5997 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator family if exists"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41500 "preproc.c" /* yacc.c:1652  */
    break;

  case 890:
#line 6005 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop owned by"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41508 "preproc.c" /* yacc.c:1652  */
    break;

  case 891:
#line 6013 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("reassign owned by"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 41516 "preproc.c" /* yacc.c:1652  */
    break;

  case 892:
#line 6021 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-4].str),mm_strdup("if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41524 "preproc.c" /* yacc.c:1652  */
    break;

  case 893:
#line 6025 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41532 "preproc.c" /* yacc.c:1652  */
    break;

  case 894:
#line 6029 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-4].str),mm_strdup("if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41540 "preproc.c" /* yacc.c:1652  */
    break;

  case 895:
#line 6033 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("drop"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41548 "preproc.c" /* yacc.c:1652  */
    break;

  case 896:
#line 6037 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("drop"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41556 "preproc.c" /* yacc.c:1652  */
    break;

  case 897:
#line 6041 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("drop"),(yyvsp[-6].str),mm_strdup("if exists"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41564 "preproc.c" /* yacc.c:1652  */
    break;

  case 898:
#line 6045 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop type"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41572 "preproc.c" /* yacc.c:1652  */
    break;

  case 899:
#line 6049 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop type if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41580 "preproc.c" /* yacc.c:1652  */
    break;

  case 900:
#line 6053 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop domain"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41588 "preproc.c" /* yacc.c:1652  */
    break;

  case 901:
#line 6057 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop domain if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41596 "preproc.c" /* yacc.c:1652  */
    break;

  case 902:
#line 6061 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop index concurrently"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41604 "preproc.c" /* yacc.c:1652  */
    break;

  case 903:
#line 6065 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop index concurrently if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41612 "preproc.c" /* yacc.c:1652  */
    break;

  case 904:
#line 6073 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 41620 "preproc.c" /* yacc.c:1652  */
    break;

  case 905:
#line 6077 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequence");
}
#line 41628 "preproc.c" /* yacc.c:1652  */
    break;

  case 906:
#line 6081 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("view");
}
#line 41636 "preproc.c" /* yacc.c:1652  */
    break;

  case 907:
#line 6085 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 41644 "preproc.c" /* yacc.c:1652  */
    break;

  case 908:
#line 6089 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("index");
}
#line 41652 "preproc.c" /* yacc.c:1652  */
    break;

  case 909:
#line 6093 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 41660 "preproc.c" /* yacc.c:1652  */
    break;

  case 910:
#line 6097 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("collation");
}
#line 41668 "preproc.c" /* yacc.c:1652  */
    break;

  case 911:
#line 6101 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("conversion");
}
#line 41676 "preproc.c" /* yacc.c:1652  */
    break;

  case 912:
#line 6105 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("statistics");
}
#line 41684 "preproc.c" /* yacc.c:1652  */
    break;

  case 913:
#line 6109 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search parser");
}
#line 41692 "preproc.c" /* yacc.c:1652  */
    break;

  case 914:
#line 6113 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search dictionary");
}
#line 41700 "preproc.c" /* yacc.c:1652  */
    break;

  case 915:
#line 6117 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search template");
}
#line 41708 "preproc.c" /* yacc.c:1652  */
    break;

  case 916:
#line 6121 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search configuration");
}
#line 41716 "preproc.c" /* yacc.c:1652  */
    break;

  case 917:
#line 6129 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("access method");
}
#line 41724 "preproc.c" /* yacc.c:1652  */
    break;

  case 918:
#line 6133 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 41732 "preproc.c" /* yacc.c:1652  */
    break;

  case 919:
#line 6137 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("extension");
}
#line 41740 "preproc.c" /* yacc.c:1652  */
    break;

  case 920:
#line 6141 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("foreign data wrapper");
}
#line 41748 "preproc.c" /* yacc.c:1652  */
    break;

  case 921:
#line 6145 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("publication");
}
#line 41756 "preproc.c" /* yacc.c:1652  */
    break;

  case 922:
#line 6149 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schema");
}
#line 41764 "preproc.c" /* yacc.c:1652  */
    break;

  case 923:
#line 6153 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("server");
}
#line 41772 "preproc.c" /* yacc.c:1652  */
    break;

  case 924:
#line 6161 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("policy");
}
#line 41780 "preproc.c" /* yacc.c:1652  */
    break;

  case 925:
#line 6165 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rule");
}
#line 41788 "preproc.c" /* yacc.c:1652  */
    break;

  case 926:
#line 6169 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("trigger");
}
#line 41796 "preproc.c" /* yacc.c:1652  */
    break;

  case 927:
#line 6177 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41804 "preproc.c" /* yacc.c:1652  */
    break;

  case 928:
#line 6181 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41812 "preproc.c" /* yacc.c:1652  */
    break;

  case 929:
#line 6189 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41820 "preproc.c" /* yacc.c:1652  */
    break;

  case 930:
#line 6193 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41828 "preproc.c" /* yacc.c:1652  */
    break;

  case 931:
#line 6201 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("."),(yyvsp[0].str));
}
#line 41836 "preproc.c" /* yacc.c:1652  */
    break;

  case 932:
#line 6205 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 41844 "preproc.c" /* yacc.c:1652  */
    break;

  case 933:
#line 6213 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41852 "preproc.c" /* yacc.c:1652  */
    break;

  case 934:
#line 6217 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41860 "preproc.c" /* yacc.c:1652  */
    break;

  case 935:
#line 6225 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("truncate"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41868 "preproc.c" /* yacc.c:1652  */
    break;

  case 936:
#line 6233 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("continue identity");
}
#line 41876 "preproc.c" /* yacc.c:1652  */
    break;

  case 937:
#line 6237 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restart identity");
}
#line 41884 "preproc.c" /* yacc.c:1652  */
    break;

  case 938:
#line 6241 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 41891 "preproc.c" /* yacc.c:1652  */
    break;

  case 939:
#line 6248 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("comment on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41899 "preproc.c" /* yacc.c:1652  */
    break;

  case 940:
#line 6252 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("comment on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41907 "preproc.c" /* yacc.c:1652  */
    break;

  case 941:
#line 6256 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on type"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41915 "preproc.c" /* yacc.c:1652  */
    break;

  case 942:
#line 6260 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on domain"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41923 "preproc.c" /* yacc.c:1652  */
    break;

  case 943:
#line 6264 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on aggregate"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41931 "preproc.c" /* yacc.c:1652  */
    break;

  case 944:
#line 6268 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on function"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41939 "preproc.c" /* yacc.c:1652  */
    break;

  case 945:
#line 6272 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on operator"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41947 "preproc.c" /* yacc.c:1652  */
    break;

  case 946:
#line 6276 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on constraint"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41955 "preproc.c" /* yacc.c:1652  */
    break;

  case 947:
#line 6280 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on constraint"),(yyvsp[-5].str),mm_strdup("on domain"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41963 "preproc.c" /* yacc.c:1652  */
    break;

  case 948:
#line 6284 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on policy"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41971 "preproc.c" /* yacc.c:1652  */
    break;

  case 949:
#line 6288 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on procedure"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41979 "preproc.c" /* yacc.c:1652  */
    break;

  case 950:
#line 6292 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on routine"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41987 "preproc.c" /* yacc.c:1652  */
    break;

  case 951:
#line 6296 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on rule"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 41995 "preproc.c" /* yacc.c:1652  */
    break;

  case 952:
#line 6300 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on transform for"),(yyvsp[-4].str),mm_strdup("language"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42003 "preproc.c" /* yacc.c:1652  */
    break;

  case 953:
#line 6304 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on trigger"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42011 "preproc.c" /* yacc.c:1652  */
    break;

  case 954:
#line 6308 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on operator class"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42019 "preproc.c" /* yacc.c:1652  */
    break;

  case 955:
#line 6312 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42027 "preproc.c" /* yacc.c:1652  */
    break;

  case 956:
#line 6316 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("comment on large object"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42035 "preproc.c" /* yacc.c:1652  */
    break;

  case 957:
#line 6320 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("comment on cast ("),(yyvsp[-5].str),mm_strdup("as"),(yyvsp[-3].str),mm_strdup(") is"),(yyvsp[0].str));
}
#line 42043 "preproc.c" /* yacc.c:1652  */
    break;

  case 958:
#line 6328 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("column");
}
#line 42051 "preproc.c" /* yacc.c:1652  */
    break;

  case 959:
#line 6332 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("index");
}
#line 42059 "preproc.c" /* yacc.c:1652  */
    break;

  case 960:
#line 6336 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequence");
}
#line 42067 "preproc.c" /* yacc.c:1652  */
    break;

  case 961:
#line 6340 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("statistics");
}
#line 42075 "preproc.c" /* yacc.c:1652  */
    break;

  case 962:
#line 6344 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 42083 "preproc.c" /* yacc.c:1652  */
    break;

  case 963:
#line 6348 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("view");
}
#line 42091 "preproc.c" /* yacc.c:1652  */
    break;

  case 964:
#line 6352 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 42099 "preproc.c" /* yacc.c:1652  */
    break;

  case 965:
#line 6356 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("collation");
}
#line 42107 "preproc.c" /* yacc.c:1652  */
    break;

  case 966:
#line 6360 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("conversion");
}
#line 42115 "preproc.c" /* yacc.c:1652  */
    break;

  case 967:
#line 6364 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 42123 "preproc.c" /* yacc.c:1652  */
    break;

  case 968:
#line 6368 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search configuration");
}
#line 42131 "preproc.c" /* yacc.c:1652  */
    break;

  case 969:
#line 6372 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search dictionary");
}
#line 42139 "preproc.c" /* yacc.c:1652  */
    break;

  case 970:
#line 6376 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search parser");
}
#line 42147 "preproc.c" /* yacc.c:1652  */
    break;

  case 971:
#line 6380 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text search template");
}
#line 42155 "preproc.c" /* yacc.c:1652  */
    break;

  case 972:
#line 6388 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("access method");
}
#line 42163 "preproc.c" /* yacc.c:1652  */
    break;

  case 973:
#line 6392 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("database");
}
#line 42171 "preproc.c" /* yacc.c:1652  */
    break;

  case 974:
#line 6396 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 42179 "preproc.c" /* yacc.c:1652  */
    break;

  case 975:
#line 6400 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("extension");
}
#line 42187 "preproc.c" /* yacc.c:1652  */
    break;

  case 976:
#line 6404 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("foreign data wrapper");
}
#line 42195 "preproc.c" /* yacc.c:1652  */
    break;

  case 977:
#line 6408 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("language"));
}
#line 42203 "preproc.c" /* yacc.c:1652  */
    break;

  case 978:
#line 6412 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("publication");
}
#line 42211 "preproc.c" /* yacc.c:1652  */
    break;

  case 979:
#line 6416 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("role");
}
#line 42219 "preproc.c" /* yacc.c:1652  */
    break;

  case 980:
#line 6420 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schema");
}
#line 42227 "preproc.c" /* yacc.c:1652  */
    break;

  case 981:
#line 6424 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("server");
}
#line 42235 "preproc.c" /* yacc.c:1652  */
    break;

  case 982:
#line 6428 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("subscription");
}
#line 42243 "preproc.c" /* yacc.c:1652  */
    break;

  case 983:
#line 6432 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 42251 "preproc.c" /* yacc.c:1652  */
    break;

  case 984:
#line 6440 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42259 "preproc.c" /* yacc.c:1652  */
    break;

  case 985:
#line 6444 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("null");
}
#line 42267 "preproc.c" /* yacc.c:1652  */
    break;

  case 986:
#line 6452 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42275 "preproc.c" /* yacc.c:1652  */
    break;

  case 987:
#line 6456 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42283 "preproc.c" /* yacc.c:1652  */
    break;

  case 988:
#line 6460 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on type"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42291 "preproc.c" /* yacc.c:1652  */
    break;

  case 989:
#line 6464 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on domain"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42299 "preproc.c" /* yacc.c:1652  */
    break;

  case 990:
#line 6468 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on aggregate"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42307 "preproc.c" /* yacc.c:1652  */
    break;

  case 991:
#line 6472 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on function"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42315 "preproc.c" /* yacc.c:1652  */
    break;

  case 992:
#line 6476 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-6].str),mm_strdup("on large object"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42323 "preproc.c" /* yacc.c:1652  */
    break;

  case 993:
#line 6480 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on procedure"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42331 "preproc.c" /* yacc.c:1652  */
    break;

  case 994:
#line 6484 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on routine"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 42339 "preproc.c" /* yacc.c:1652  */
    break;

  case 995:
#line 6492 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 42347 "preproc.c" /* yacc.c:1652  */
    break;

  case 996:
#line 6496 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42354 "preproc.c" /* yacc.c:1652  */
    break;

  case 997:
#line 6503 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("column");
}
#line 42362 "preproc.c" /* yacc.c:1652  */
    break;

  case 998:
#line 6507 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 42370 "preproc.c" /* yacc.c:1652  */
    break;

  case 999:
#line 6511 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequence");
}
#line 42378 "preproc.c" /* yacc.c:1652  */
    break;

  case 1000:
#line 6515 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 42386 "preproc.c" /* yacc.c:1652  */
    break;

  case 1001:
#line 6519 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("view");
}
#line 42394 "preproc.c" /* yacc.c:1652  */
    break;

  case 1002:
#line 6523 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 42402 "preproc.c" /* yacc.c:1652  */
    break;

  case 1003:
#line 6531 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("database");
}
#line 42410 "preproc.c" /* yacc.c:1652  */
    break;

  case 1004:
#line 6535 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 42418 "preproc.c" /* yacc.c:1652  */
    break;

  case 1005:
#line 6539 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("language"));
}
#line 42426 "preproc.c" /* yacc.c:1652  */
    break;

  case 1006:
#line 6543 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("publication");
}
#line 42434 "preproc.c" /* yacc.c:1652  */
    break;

  case 1007:
#line 6547 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("role");
}
#line 42442 "preproc.c" /* yacc.c:1652  */
    break;

  case 1008:
#line 6551 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schema");
}
#line 42450 "preproc.c" /* yacc.c:1652  */
    break;

  case 1009:
#line 6555 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("subscription");
}
#line 42458 "preproc.c" /* yacc.c:1652  */
    break;

  case 1010:
#line 6559 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 42466 "preproc.c" /* yacc.c:1652  */
    break;

  case 1011:
#line 6567 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42474 "preproc.c" /* yacc.c:1652  */
    break;

  case 1012:
#line 6571 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("null");
}
#line 42482 "preproc.c" /* yacc.c:1652  */
    break;

  case 1013:
#line 6579 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("fetch"),(yyvsp[0].str));
}
#line 42490 "preproc.c" /* yacc.c:1652  */
    break;

  case 1014:
#line 6583 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("move"),(yyvsp[0].str));
}
#line 42498 "preproc.c" /* yacc.c:1652  */
    break;

  case 1015:
#line 6587 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.str) = cat2_str(mm_strdup("fetch"), (yyvsp[-1].str));
	}
#line 42506 "preproc.c" /* yacc.c:1652  */
    break;

  case 1016:
#line 6591 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch forward"), cursor_marker);
	}
#line 42516 "preproc.c" /* yacc.c:1652  */
    break;

  case 1017:
#line 6597 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch forward from"), cursor_marker);
	}
#line 42526 "preproc.c" /* yacc.c:1652  */
    break;

  case 1018:
#line 6603 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch backward"), cursor_marker);
	}
#line 42536 "preproc.c" /* yacc.c:1652  */
    break;

  case 1019:
#line 6609 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch backward from"), cursor_marker);
	}
#line 42546 "preproc.c" /* yacc.c:1652  */
    break;

  case 1020:
#line 6615 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move forward"), cursor_marker);
	}
#line 42556 "preproc.c" /* yacc.c:1652  */
    break;

  case 1021:
#line 6621 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move forward from"), cursor_marker);
	}
#line 42566 "preproc.c" /* yacc.c:1652  */
    break;

  case 1022:
#line 6627 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move backward"), cursor_marker);
	}
#line 42576 "preproc.c" /* yacc.c:1652  */
    break;

  case 1023:
#line 6633 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move backward from"), cursor_marker);
	}
#line 42586 "preproc.c" /* yacc.c:1652  */
    break;

  case 1024:
#line 6643 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = (yyvsp[0].str);
}
#line 42601 "preproc.c" /* yacc.c:1652  */
    break;

  case 1025:
#line 6654 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42616 "preproc.c" /* yacc.c:1652  */
    break;

  case 1026:
#line 6665 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("next"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42631 "preproc.c" /* yacc.c:1652  */
    break;

  case 1027:
#line 6676 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("prior"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42646 "preproc.c" /* yacc.c:1652  */
    break;

  case 1028:
#line 6687 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("first"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42661 "preproc.c" /* yacc.c:1652  */
    break;

  case 1029:
#line 6698 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("last"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42676 "preproc.c" /* yacc.c:1652  */
    break;

  case 1030:
#line 6709 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("absolute"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42696 "preproc.c" /* yacc.c:1652  */
    break;

  case 1031:
#line 6725 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("relative"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42716 "preproc.c" /* yacc.c:1652  */
    break;

  case 1032:
#line 6741 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42736 "preproc.c" /* yacc.c:1652  */
    break;

  case 1033:
#line 6757 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42751 "preproc.c" /* yacc.c:1652  */
    break;

  case 1034:
#line 6768 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("forward"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42771 "preproc.c" /* yacc.c:1652  */
    break;

  case 1035:
#line 6784 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("forward all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42786 "preproc.c" /* yacc.c:1652  */
    break;

  case 1036:
#line 6795 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("backward"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42806 "preproc.c" /* yacc.c:1652  */
    break;

  case 1037:
#line 6811 "preproc.y" /* yacc.c:1652  */
    { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("backward all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42821 "preproc.c" /* yacc.c:1652  */
    break;

  case 1038:
#line 6826 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("from");
}
#line 42829 "preproc.c" /* yacc.c:1652  */
    break;

  case 1039:
#line 6830 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("in");
}
#line 42837 "preproc.c" /* yacc.c:1652  */
    break;

  case 1040:
#line 6838 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42845 "preproc.c" /* yacc.c:1652  */
    break;

  case 1041:
#line 6842 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 42852 "preproc.c" /* yacc.c:1652  */
    break;

  case 1042:
#line 6849 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("grant"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42860 "preproc.c" /* yacc.c:1652  */
    break;

  case 1043:
#line 6857 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("revoke"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42868 "preproc.c" /* yacc.c:1652  */
    break;

  case 1044:
#line 6861 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("revoke grant option for"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42876 "preproc.c" /* yacc.c:1652  */
    break;

  case 1045:
#line 6869 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42884 "preproc.c" /* yacc.c:1652  */
    break;

  case 1046:
#line 6873 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 42892 "preproc.c" /* yacc.c:1652  */
    break;

  case 1047:
#line 6877 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all privileges");
}
#line 42900 "preproc.c" /* yacc.c:1652  */
    break;

  case 1048:
#line 6881 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("all ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42908 "preproc.c" /* yacc.c:1652  */
    break;

  case 1049:
#line 6885 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("all privileges ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42916 "preproc.c" /* yacc.c:1652  */
    break;

  case 1050:
#line 6893 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42924 "preproc.c" /* yacc.c:1652  */
    break;

  case 1051:
#line 6897 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 42932 "preproc.c" /* yacc.c:1652  */
    break;

  case 1052:
#line 6905 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("select"),(yyvsp[0].str));
}
#line 42940 "preproc.c" /* yacc.c:1652  */
    break;

  case 1053:
#line 6909 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("references"),(yyvsp[0].str));
}
#line 42948 "preproc.c" /* yacc.c:1652  */
    break;

  case 1054:
#line 6913 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("create"),(yyvsp[0].str));
}
#line 42956 "preproc.c" /* yacc.c:1652  */
    break;

  case 1055:
#line 6917 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42964 "preproc.c" /* yacc.c:1652  */
    break;

  case 1056:
#line 6925 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42972 "preproc.c" /* yacc.c:1652  */
    break;

  case 1057:
#line 6929 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 42980 "preproc.c" /* yacc.c:1652  */
    break;

  case 1058:
#line 6933 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("sequence"),(yyvsp[0].str));
}
#line 42988 "preproc.c" /* yacc.c:1652  */
    break;

  case 1059:
#line 6937 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("foreign data wrapper"),(yyvsp[0].str));
}
#line 42996 "preproc.c" /* yacc.c:1652  */
    break;

  case 1060:
#line 6941 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("foreign server"),(yyvsp[0].str));
}
#line 43004 "preproc.c" /* yacc.c:1652  */
    break;

  case 1061:
#line 6945 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("function"),(yyvsp[0].str));
}
#line 43012 "preproc.c" /* yacc.c:1652  */
    break;

  case 1062:
#line 6949 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("procedure"),(yyvsp[0].str));
}
#line 43020 "preproc.c" /* yacc.c:1652  */
    break;

  case 1063:
#line 6953 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("routine"),(yyvsp[0].str));
}
#line 43028 "preproc.c" /* yacc.c:1652  */
    break;

  case 1064:
#line 6957 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("database"),(yyvsp[0].str));
}
#line 43036 "preproc.c" /* yacc.c:1652  */
    break;

  case 1065:
#line 6961 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("domain"),(yyvsp[0].str));
}
#line 43044 "preproc.c" /* yacc.c:1652  */
    break;

  case 1066:
#line 6965 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 43052 "preproc.c" /* yacc.c:1652  */
    break;

  case 1067:
#line 6969 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("large object"),(yyvsp[0].str));
}
#line 43060 "preproc.c" /* yacc.c:1652  */
    break;

  case 1068:
#line 6973 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 43068 "preproc.c" /* yacc.c:1652  */
    break;

  case 1069:
#line 6977 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("tablespace"),(yyvsp[0].str));
}
#line 43076 "preproc.c" /* yacc.c:1652  */
    break;

  case 1070:
#line 6981 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("type"),(yyvsp[0].str));
}
#line 43084 "preproc.c" /* yacc.c:1652  */
    break;

  case 1071:
#line 6985 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("all tables in schema"),(yyvsp[0].str));
}
#line 43092 "preproc.c" /* yacc.c:1652  */
    break;

  case 1072:
#line 6989 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("all sequences in schema"),(yyvsp[0].str));
}
#line 43100 "preproc.c" /* yacc.c:1652  */
    break;

  case 1073:
#line 6993 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("all functions in schema"),(yyvsp[0].str));
}
#line 43108 "preproc.c" /* yacc.c:1652  */
    break;

  case 1074:
#line 6997 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("all procedures in schema"),(yyvsp[0].str));
}
#line 43116 "preproc.c" /* yacc.c:1652  */
    break;

  case 1075:
#line 7001 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("all routines in schema"),(yyvsp[0].str));
}
#line 43124 "preproc.c" /* yacc.c:1652  */
    break;

  case 1076:
#line 7009 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43132 "preproc.c" /* yacc.c:1652  */
    break;

  case 1077:
#line 7013 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43140 "preproc.c" /* yacc.c:1652  */
    break;

  case 1078:
#line 7021 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43148 "preproc.c" /* yacc.c:1652  */
    break;

  case 1079:
#line 7025 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("group"),(yyvsp[0].str));
}
#line 43156 "preproc.c" /* yacc.c:1652  */
    break;

  case 1080:
#line 7033 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with grant option");
}
#line 43164 "preproc.c" /* yacc.c:1652  */
    break;

  case 1081:
#line 7037 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43171 "preproc.c" /* yacc.c:1652  */
    break;

  case 1082:
#line 7044 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("grant"),(yyvsp[-4].str),mm_strdup("to"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43179 "preproc.c" /* yacc.c:1652  */
    break;

  case 1083:
#line 7052 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("revoke"),(yyvsp[-4].str),mm_strdup("from"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43187 "preproc.c" /* yacc.c:1652  */
    break;

  case 1084:
#line 7056 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("revoke admin option for"),(yyvsp[-4].str),mm_strdup("from"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43195 "preproc.c" /* yacc.c:1652  */
    break;

  case 1085:
#line 7064 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with admin option");
}
#line 43203 "preproc.c" /* yacc.c:1652  */
    break;

  case 1086:
#line 7068 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43210 "preproc.c" /* yacc.c:1652  */
    break;

  case 1087:
#line 7075 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("granted by"),(yyvsp[0].str));
}
#line 43218 "preproc.c" /* yacc.c:1652  */
    break;

  case 1088:
#line 7079 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43225 "preproc.c" /* yacc.c:1652  */
    break;

  case 1089:
#line 7086 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter default privileges"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43233 "preproc.c" /* yacc.c:1652  */
    break;

  case 1090:
#line 7094 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43241 "preproc.c" /* yacc.c:1652  */
    break;

  case 1091:
#line 7098 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43248 "preproc.c" /* yacc.c:1652  */
    break;

  case 1092:
#line 7105 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("in schema"),(yyvsp[0].str));
}
#line 43256 "preproc.c" /* yacc.c:1652  */
    break;

  case 1093:
#line 7109 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for role"),(yyvsp[0].str));
}
#line 43264 "preproc.c" /* yacc.c:1652  */
    break;

  case 1094:
#line 7113 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for user"),(yyvsp[0].str));
}
#line 43272 "preproc.c" /* yacc.c:1652  */
    break;

  case 1095:
#line 7121 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("grant"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43280 "preproc.c" /* yacc.c:1652  */
    break;

  case 1096:
#line 7125 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("revoke"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43288 "preproc.c" /* yacc.c:1652  */
    break;

  case 1097:
#line 7129 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("revoke grant option for"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43296 "preproc.c" /* yacc.c:1652  */
    break;

  case 1098:
#line 7137 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tables");
}
#line 43304 "preproc.c" /* yacc.c:1652  */
    break;

  case 1099:
#line 7141 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("functions");
}
#line 43312 "preproc.c" /* yacc.c:1652  */
    break;

  case 1100:
#line 7145 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("routines");
}
#line 43320 "preproc.c" /* yacc.c:1652  */
    break;

  case 1101:
#line 7149 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequences");
}
#line 43328 "preproc.c" /* yacc.c:1652  */
    break;

  case 1102:
#line 7153 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("types");
}
#line 43336 "preproc.c" /* yacc.c:1652  */
    break;

  case 1103:
#line 7157 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schemas");
}
#line 43344 "preproc.c" /* yacc.c:1652  */
    break;

  case 1104:
#line 7165 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(15,mm_strdup("create"),(yyvsp[-13].str),mm_strdup("index"),(yyvsp[-11].str),(yyvsp[-10].str),mm_strdup("on"),(yyvsp[-8].str),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43352 "preproc.c" /* yacc.c:1652  */
    break;

  case 1105:
#line 7169 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(16,mm_strdup("create"),(yyvsp[-16].str),mm_strdup("index"),(yyvsp[-14].str),mm_strdup("if not exists"),(yyvsp[-10].str),mm_strdup("on"),(yyvsp[-8].str),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43360 "preproc.c" /* yacc.c:1652  */
    break;

  case 1106:
#line 7177 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unique");
}
#line 43368 "preproc.c" /* yacc.c:1652  */
    break;

  case 1107:
#line 7181 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43375 "preproc.c" /* yacc.c:1652  */
    break;

  case 1108:
#line 7188 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("concurrently");
}
#line 43383 "preproc.c" /* yacc.c:1652  */
    break;

  case 1109:
#line 7192 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43390 "preproc.c" /* yacc.c:1652  */
    break;

  case 1110:
#line 7199 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43398 "preproc.c" /* yacc.c:1652  */
    break;

  case 1111:
#line 7203 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43405 "preproc.c" /* yacc.c:1652  */
    break;

  case 1112:
#line 7210 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 43413 "preproc.c" /* yacc.c:1652  */
    break;

  case 1113:
#line 7214 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43420 "preproc.c" /* yacc.c:1652  */
    break;

  case 1114:
#line 7221 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43428 "preproc.c" /* yacc.c:1652  */
    break;

  case 1115:
#line 7225 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43436 "preproc.c" /* yacc.c:1652  */
    break;

  case 1116:
#line 7233 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43444 "preproc.c" /* yacc.c:1652  */
    break;

  case 1117:
#line 7237 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43452 "preproc.c" /* yacc.c:1652  */
    break;

  case 1118:
#line 7245 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43460 "preproc.c" /* yacc.c:1652  */
    break;

  case 1119:
#line 7249 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43468 "preproc.c" /* yacc.c:1652  */
    break;

  case 1120:
#line 7253 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 43476 "preproc.c" /* yacc.c:1652  */
    break;

  case 1121:
#line 7261 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("include ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43484 "preproc.c" /* yacc.c:1652  */
    break;

  case 1122:
#line 7265 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43491 "preproc.c" /* yacc.c:1652  */
    break;

  case 1123:
#line 7272 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43499 "preproc.c" /* yacc.c:1652  */
    break;

  case 1124:
#line 7276 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43507 "preproc.c" /* yacc.c:1652  */
    break;

  case 1125:
#line 7284 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 43515 "preproc.c" /* yacc.c:1652  */
    break;

  case 1126:
#line 7288 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43522 "preproc.c" /* yacc.c:1652  */
    break;

  case 1127:
#line 7295 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43530 "preproc.c" /* yacc.c:1652  */
    break;

  case 1128:
#line 7299 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43537 "preproc.c" /* yacc.c:1652  */
    break;

  case 1129:
#line 7306 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("asc");
}
#line 43545 "preproc.c" /* yacc.c:1652  */
    break;

  case 1130:
#line 7310 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("desc");
}
#line 43553 "preproc.c" /* yacc.c:1652  */
    break;

  case 1131:
#line 7314 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43560 "preproc.c" /* yacc.c:1652  */
    break;

  case 1132:
#line 7321 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nulls first");
}
#line 43568 "preproc.c" /* yacc.c:1652  */
    break;

  case 1133:
#line 7325 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nulls last");
}
#line 43576 "preproc.c" /* yacc.c:1652  */
    break;

  case 1134:
#line 7329 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43583 "preproc.c" /* yacc.c:1652  */
    break;

  case 1135:
#line 7336 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("create"),(yyvsp[-6].str),mm_strdup("function"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("returns"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43591 "preproc.c" /* yacc.c:1652  */
    break;

  case 1136:
#line 7340 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create"),(yyvsp[-9].str),mm_strdup("function"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("returns table ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 43599 "preproc.c" /* yacc.c:1652  */
    break;

  case 1137:
#line 7344 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create"),(yyvsp[-4].str),mm_strdup("function"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43607 "preproc.c" /* yacc.c:1652  */
    break;

  case 1138:
#line 7348 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create"),(yyvsp[-4].str),mm_strdup("procedure"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43615 "preproc.c" /* yacc.c:1652  */
    break;

  case 1139:
#line 7356 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("or replace");
}
#line 43623 "preproc.c" /* yacc.c:1652  */
    break;

  case 1140:
#line 7360 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 43630 "preproc.c" /* yacc.c:1652  */
    break;

  case 1141:
#line 7367 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43638 "preproc.c" /* yacc.c:1652  */
    break;

  case 1142:
#line 7371 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("( )");
}
#line 43646 "preproc.c" /* yacc.c:1652  */
    break;

  case 1143:
#line 7379 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43654 "preproc.c" /* yacc.c:1652  */
    break;

  case 1144:
#line 7383 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43662 "preproc.c" /* yacc.c:1652  */
    break;

  case 1145:
#line 7391 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43670 "preproc.c" /* yacc.c:1652  */
    break;

  case 1146:
#line 7395 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43678 "preproc.c" /* yacc.c:1652  */
    break;

  case 1147:
#line 7403 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43686 "preproc.c" /* yacc.c:1652  */
    break;

  case 1148:
#line 7407 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43694 "preproc.c" /* yacc.c:1652  */
    break;

  case 1149:
#line 7411 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43702 "preproc.c" /* yacc.c:1652  */
    break;

  case 1150:
#line 7415 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43710 "preproc.c" /* yacc.c:1652  */
    break;

  case 1151:
#line 7423 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43718 "preproc.c" /* yacc.c:1652  */
    break;

  case 1152:
#line 7427 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("( )");
}
#line 43726 "preproc.c" /* yacc.c:1652  */
    break;

  case 1153:
#line 7435 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43734 "preproc.c" /* yacc.c:1652  */
    break;

  case 1154:
#line 7439 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43742 "preproc.c" /* yacc.c:1652  */
    break;

  case 1155:
#line 7447 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43750 "preproc.c" /* yacc.c:1652  */
    break;

  case 1156:
#line 7451 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43758 "preproc.c" /* yacc.c:1652  */
    break;

  case 1157:
#line 7455 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43766 "preproc.c" /* yacc.c:1652  */
    break;

  case 1158:
#line 7459 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43774 "preproc.c" /* yacc.c:1652  */
    break;

  case 1159:
#line 7463 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43782 "preproc.c" /* yacc.c:1652  */
    break;

  case 1160:
#line 7471 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("in");
}
#line 43790 "preproc.c" /* yacc.c:1652  */
    break;

  case 1161:
#line 7475 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("out");
}
#line 43798 "preproc.c" /* yacc.c:1652  */
    break;

  case 1162:
#line 7479 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inout");
}
#line 43806 "preproc.c" /* yacc.c:1652  */
    break;

  case 1163:
#line 7483 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("in out");
}
#line 43814 "preproc.c" /* yacc.c:1652  */
    break;

  case 1164:
#line 7487 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("variadic");
}
#line 43822 "preproc.c" /* yacc.c:1652  */
    break;

  case 1165:
#line 7495 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43830 "preproc.c" /* yacc.c:1652  */
    break;

  case 1166:
#line 7503 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43838 "preproc.c" /* yacc.c:1652  */
    break;

  case 1167:
#line 7511 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43846 "preproc.c" /* yacc.c:1652  */
    break;

  case 1168:
#line 7515 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("% type"));
}
#line 43854 "preproc.c" /* yacc.c:1652  */
    break;

  case 1169:
#line 7519 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("setof"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("% type"));
}
#line 43862 "preproc.c" /* yacc.c:1652  */
    break;

  case 1170:
#line 7527 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43870 "preproc.c" /* yacc.c:1652  */
    break;

  case 1171:
#line 7531 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("default"),(yyvsp[0].str));
}
#line 43878 "preproc.c" /* yacc.c:1652  */
    break;

  case 1172:
#line 7535 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 43886 "preproc.c" /* yacc.c:1652  */
    break;

  case 1173:
#line 7543 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = (yyvsp[0].str);
}
#line 43895 "preproc.c" /* yacc.c:1652  */
    break;

  case 1174:
#line 7552 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("( * )");
}
#line 43903 "preproc.c" /* yacc.c:1652  */
    break;

  case 1175:
#line 7556 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43911 "preproc.c" /* yacc.c:1652  */
    break;

  case 1176:
#line 7560 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("( order by"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43919 "preproc.c" /* yacc.c:1652  */
    break;

  case 1177:
#line 7564 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-4].str),mm_strdup("order by"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43927 "preproc.c" /* yacc.c:1652  */
    break;

  case 1178:
#line 7572 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43935 "preproc.c" /* yacc.c:1652  */
    break;

  case 1179:
#line 7576 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43943 "preproc.c" /* yacc.c:1652  */
    break;

  case 1180:
#line 7584 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43951 "preproc.c" /* yacc.c:1652  */
    break;

  case 1181:
#line 7592 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43959 "preproc.c" /* yacc.c:1652  */
    break;

  case 1182:
#line 7596 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43967 "preproc.c" /* yacc.c:1652  */
    break;

  case 1183:
#line 7604 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43975 "preproc.c" /* yacc.c:1652  */
    break;

  case 1184:
#line 7608 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43983 "preproc.c" /* yacc.c:1652  */
    break;

  case 1185:
#line 7616 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("called on null input");
}
#line 43991 "preproc.c" /* yacc.c:1652  */
    break;

  case 1186:
#line 7620 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("returns null on null input");
}
#line 43999 "preproc.c" /* yacc.c:1652  */
    break;

  case 1187:
#line 7624 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("strict");
}
#line 44007 "preproc.c" /* yacc.c:1652  */
    break;

  case 1188:
#line 7628 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("immutable");
}
#line 44015 "preproc.c" /* yacc.c:1652  */
    break;

  case 1189:
#line 7632 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stable");
}
#line 44023 "preproc.c" /* yacc.c:1652  */
    break;

  case 1190:
#line 7636 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("volatile");
}
#line 44031 "preproc.c" /* yacc.c:1652  */
    break;

  case 1191:
#line 7640 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("external security definer");
}
#line 44039 "preproc.c" /* yacc.c:1652  */
    break;

  case 1192:
#line 7644 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("external security invoker");
}
#line 44047 "preproc.c" /* yacc.c:1652  */
    break;

  case 1193:
#line 7648 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("security definer");
}
#line 44055 "preproc.c" /* yacc.c:1652  */
    break;

  case 1194:
#line 7652 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("security invoker");
}
#line 44063 "preproc.c" /* yacc.c:1652  */
    break;

  case 1195:
#line 7656 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("leakproof");
}
#line 44071 "preproc.c" /* yacc.c:1652  */
    break;

  case 1196:
#line 7660 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not leakproof");
}
#line 44079 "preproc.c" /* yacc.c:1652  */
    break;

  case 1197:
#line 7664 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("cost"),(yyvsp[0].str));
}
#line 44087 "preproc.c" /* yacc.c:1652  */
    break;

  case 1198:
#line 7668 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("rows"),(yyvsp[0].str));
}
#line 44095 "preproc.c" /* yacc.c:1652  */
    break;

  case 1199:
#line 7672 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("support"),(yyvsp[0].str));
}
#line 44103 "preproc.c" /* yacc.c:1652  */
    break;

  case 1200:
#line 7676 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44111 "preproc.c" /* yacc.c:1652  */
    break;

  case 1201:
#line 7680 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("parallel"),(yyvsp[0].str));
}
#line 44119 "preproc.c" /* yacc.c:1652  */
    break;

  case 1202:
#line 7688 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 44127 "preproc.c" /* yacc.c:1652  */
    break;

  case 1203:
#line 7692 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 44135 "preproc.c" /* yacc.c:1652  */
    break;

  case 1204:
#line 7696 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("transform"),(yyvsp[0].str));
}
#line 44143 "preproc.c" /* yacc.c:1652  */
    break;

  case 1205:
#line 7700 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("window");
}
#line 44151 "preproc.c" /* yacc.c:1652  */
    break;

  case 1206:
#line 7704 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44159 "preproc.c" /* yacc.c:1652  */
    break;

  case 1207:
#line 7712 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44167 "preproc.c" /* yacc.c:1652  */
    break;

  case 1208:
#line 7716 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44175 "preproc.c" /* yacc.c:1652  */
    break;

  case 1209:
#line 7724 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for type"),(yyvsp[0].str));
}
#line 44183 "preproc.c" /* yacc.c:1652  */
    break;

  case 1210:
#line 7728 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup(", for type"),(yyvsp[0].str));
}
#line 44191 "preproc.c" /* yacc.c:1652  */
    break;

  case 1211:
#line 7736 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 44199 "preproc.c" /* yacc.c:1652  */
    break;

  case 1212:
#line 7740 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44206 "preproc.c" /* yacc.c:1652  */
    break;

  case 1213:
#line 7747 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44214 "preproc.c" /* yacc.c:1652  */
    break;

  case 1214:
#line 7755 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44222 "preproc.c" /* yacc.c:1652  */
    break;

  case 1215:
#line 7759 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44230 "preproc.c" /* yacc.c:1652  */
    break;

  case 1216:
#line 7767 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44238 "preproc.c" /* yacc.c:1652  */
    break;

  case 1217:
#line 7771 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter procedure"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44246 "preproc.c" /* yacc.c:1652  */
    break;

  case 1218:
#line 7775 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter routine"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44254 "preproc.c" /* yacc.c:1652  */
    break;

  case 1219:
#line 7783 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44262 "preproc.c" /* yacc.c:1652  */
    break;

  case 1220:
#line 7787 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44270 "preproc.c" /* yacc.c:1652  */
    break;

  case 1221:
#line 7795 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restrict");
}
#line 44278 "preproc.c" /* yacc.c:1652  */
    break;

  case 1222:
#line 7799 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44285 "preproc.c" /* yacc.c:1652  */
    break;

  case 1223:
#line 7806 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop function"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44293 "preproc.c" /* yacc.c:1652  */
    break;

  case 1224:
#line 7810 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop function if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44301 "preproc.c" /* yacc.c:1652  */
    break;

  case 1225:
#line 7814 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop procedure"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44309 "preproc.c" /* yacc.c:1652  */
    break;

  case 1226:
#line 7818 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop procedure if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44317 "preproc.c" /* yacc.c:1652  */
    break;

  case 1227:
#line 7822 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop routine"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44325 "preproc.c" /* yacc.c:1652  */
    break;

  case 1228:
#line 7826 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop routine if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44333 "preproc.c" /* yacc.c:1652  */
    break;

  case 1229:
#line 7834 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop aggregate"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44341 "preproc.c" /* yacc.c:1652  */
    break;

  case 1230:
#line 7838 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop aggregate if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44349 "preproc.c" /* yacc.c:1652  */
    break;

  case 1231:
#line 7846 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop operator"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44357 "preproc.c" /* yacc.c:1652  */
    break;

  case 1232:
#line 7850 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop operator if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44365 "preproc.c" /* yacc.c:1652  */
    break;

  case 1233:
#line 7858 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44373 "preproc.c" /* yacc.c:1652  */
    break;

  case 1234:
#line 7862 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44381 "preproc.c" /* yacc.c:1652  */
    break;

  case 1235:
#line 7866 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("( none ,"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44389 "preproc.c" /* yacc.c:1652  */
    break;

  case 1236:
#line 7870 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-3].str),mm_strdup(", none )"));
}
#line 44397 "preproc.c" /* yacc.c:1652  */
    break;

  case 1237:
#line 7878 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44405 "preproc.c" /* yacc.c:1652  */
    break;

  case 1238:
#line 7882 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 44413 "preproc.c" /* yacc.c:1652  */
    break;

  case 1239:
#line 7890 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44421 "preproc.c" /* yacc.c:1652  */
    break;

  case 1240:
#line 7894 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44429 "preproc.c" /* yacc.c:1652  */
    break;

  case 1241:
#line 7902 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44437 "preproc.c" /* yacc.c:1652  */
    break;

  case 1242:
#line 7910 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("do"),(yyvsp[0].str));
}
#line 44445 "preproc.c" /* yacc.c:1652  */
    break;

  case 1243:
#line 7918 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44453 "preproc.c" /* yacc.c:1652  */
    break;

  case 1244:
#line 7922 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44461 "preproc.c" /* yacc.c:1652  */
    break;

  case 1245:
#line 7930 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44469 "preproc.c" /* yacc.c:1652  */
    break;

  case 1246:
#line 7934 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 44477 "preproc.c" /* yacc.c:1652  */
    break;

  case 1247:
#line 7942 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create cast ("),(yyvsp[-7].str),mm_strdup("as"),(yyvsp[-5].str),mm_strdup(") with function"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44485 "preproc.c" /* yacc.c:1652  */
    break;

  case 1248:
#line 7946 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create cast ("),(yyvsp[-6].str),mm_strdup("as"),(yyvsp[-4].str),mm_strdup(") without function"),(yyvsp[0].str));
}
#line 44493 "preproc.c" /* yacc.c:1652  */
    break;

  case 1249:
#line 7950 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("create cast ("),(yyvsp[-6].str),mm_strdup("as"),(yyvsp[-4].str),mm_strdup(") with inout"),(yyvsp[0].str));
}
#line 44501 "preproc.c" /* yacc.c:1652  */
    break;

  case 1250:
#line 7958 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("as implicit");
}
#line 44509 "preproc.c" /* yacc.c:1652  */
    break;

  case 1251:
#line 7962 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("as assignment");
}
#line 44517 "preproc.c" /* yacc.c:1652  */
    break;

  case 1252:
#line 7966 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44524 "preproc.c" /* yacc.c:1652  */
    break;

  case 1253:
#line 7973 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("drop cast"),(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup("as"),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 44532 "preproc.c" /* yacc.c:1652  */
    break;

  case 1254:
#line 7981 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("if exists");
}
#line 44540 "preproc.c" /* yacc.c:1652  */
    break;

  case 1255:
#line 7985 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 44547 "preproc.c" /* yacc.c:1652  */
    break;

  case 1256:
#line 7992 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create"),(yyvsp[-8].str),mm_strdup("transform for"),(yyvsp[-5].str),mm_strdup("language"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44555 "preproc.c" /* yacc.c:1652  */
    break;

  case 1257:
#line 8000 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("from sql with function"),(yyvsp[-6].str),mm_strdup(", to sql with function"),(yyvsp[0].str));
}
#line 44563 "preproc.c" /* yacc.c:1652  */
    break;

  case 1258:
#line 8004 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("to sql with function"),(yyvsp[-6].str),mm_strdup(", from sql with function"),(yyvsp[0].str));
}
#line 44571 "preproc.c" /* yacc.c:1652  */
    break;

  case 1259:
#line 8008 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("from sql with function"),(yyvsp[0].str));
}
#line 44579 "preproc.c" /* yacc.c:1652  */
    break;

  case 1260:
#line 8012 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("to sql with function"),(yyvsp[0].str));
}
#line 44587 "preproc.c" /* yacc.c:1652  */
    break;

  case 1261:
#line 8020 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("drop transform"),(yyvsp[-5].str),mm_strdup("for"),(yyvsp[-3].str),mm_strdup("language"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44595 "preproc.c" /* yacc.c:1652  */
    break;

  case 1262:
#line 8028 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("reindex"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44603 "preproc.c" /* yacc.c:1652  */
    break;

  case 1263:
#line 8032 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("reindex"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44611 "preproc.c" /* yacc.c:1652  */
    break;

  case 1264:
#line 8036 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("reindex ("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44619 "preproc.c" /* yacc.c:1652  */
    break;

  case 1265:
#line 8040 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("reindex ("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44627 "preproc.c" /* yacc.c:1652  */
    break;

  case 1266:
#line 8048 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("index");
}
#line 44635 "preproc.c" /* yacc.c:1652  */
    break;

  case 1267:
#line 8052 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 44643 "preproc.c" /* yacc.c:1652  */
    break;

  case 1268:
#line 8060 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schema");
}
#line 44651 "preproc.c" /* yacc.c:1652  */
    break;

  case 1269:
#line 8064 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("system");
}
#line 44659 "preproc.c" /* yacc.c:1652  */
    break;

  case 1270:
#line 8068 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("database");
}
#line 44667 "preproc.c" /* yacc.c:1652  */
    break;

  case 1271:
#line 8076 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44675 "preproc.c" /* yacc.c:1652  */
    break;

  case 1272:
#line 8080 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 44683 "preproc.c" /* yacc.c:1652  */
    break;

  case 1273:
#line 8088 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("verbose");
}
#line 44691 "preproc.c" /* yacc.c:1652  */
    break;

  case 1274:
#line 8096 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 44699 "preproc.c" /* yacc.c:1652  */
    break;

  case 1275:
#line 8100 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-2].str),mm_strdup("reset"),(yyvsp[0].str));
}
#line 44707 "preproc.c" /* yacc.c:1652  */
    break;

  case 1276:
#line 8108 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter aggregate"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44715 "preproc.c" /* yacc.c:1652  */
    break;

  case 1277:
#line 8112 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44723 "preproc.c" /* yacc.c:1652  */
    break;

  case 1278:
#line 8116 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44731 "preproc.c" /* yacc.c:1652  */
    break;

  case 1279:
#line 8120 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44739 "preproc.c" /* yacc.c:1652  */
    break;

  case 1280:
#line 8124 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44747 "preproc.c" /* yacc.c:1652  */
    break;

  case 1281:
#line 8128 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter domain"),(yyvsp[-5].str),mm_strdup("rename constraint"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 44755 "preproc.c" /* yacc.c:1652  */
    break;

  case 1282:
#line 8132 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44763 "preproc.c" /* yacc.c:1652  */
    break;

  case 1283:
#line 8136 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44771 "preproc.c" /* yacc.c:1652  */
    break;

  case 1284:
#line 8140 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter group"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44779 "preproc.c" /* yacc.c:1652  */
    break;

  case 1285:
#line 8144 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter"),(yyvsp[-5].str),mm_strdup("language"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44787 "preproc.c" /* yacc.c:1652  */
    break;

  case 1286:
#line 8148 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44795 "preproc.c" /* yacc.c:1652  */
    break;

  case 1287:
#line 8152 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44803 "preproc.c" /* yacc.c:1652  */
    break;

  case 1288:
#line 8156 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter policy"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44811 "preproc.c" /* yacc.c:1652  */
    break;

  case 1289:
#line 8160 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter policy if exists"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44819 "preproc.c" /* yacc.c:1652  */
    break;

  case 1290:
#line 8164 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter procedure"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44827 "preproc.c" /* yacc.c:1652  */
    break;

  case 1291:
#line 8168 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44835 "preproc.c" /* yacc.c:1652  */
    break;

  case 1292:
#line 8172 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter routine"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44843 "preproc.c" /* yacc.c:1652  */
    break;

  case 1293:
#line 8176 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter schema"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44851 "preproc.c" /* yacc.c:1652  */
    break;

  case 1294:
#line 8180 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44859 "preproc.c" /* yacc.c:1652  */
    break;

  case 1295:
#line 8184 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter subscription"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44867 "preproc.c" /* yacc.c:1652  */
    break;

  case 1296:
#line 8188 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter table"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44875 "preproc.c" /* yacc.c:1652  */
    break;

  case 1297:
#line 8192 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter table if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44883 "preproc.c" /* yacc.c:1652  */
    break;

  case 1298:
#line 8196 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44891 "preproc.c" /* yacc.c:1652  */
    break;

  case 1299:
#line 8200 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44899 "preproc.c" /* yacc.c:1652  */
    break;

  case 1300:
#line 8204 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter view"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44907 "preproc.c" /* yacc.c:1652  */
    break;

  case 1301:
#line 8208 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter view if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44915 "preproc.c" /* yacc.c:1652  */
    break;

  case 1302:
#line 8212 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44923 "preproc.c" /* yacc.c:1652  */
    break;

  case 1303:
#line 8216 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44931 "preproc.c" /* yacc.c:1652  */
    break;

  case 1304:
#line 8220 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter index"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44939 "preproc.c" /* yacc.c:1652  */
    break;

  case 1305:
#line 8224 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter index if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44947 "preproc.c" /* yacc.c:1652  */
    break;

  case 1306:
#line 8228 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44955 "preproc.c" /* yacc.c:1652  */
    break;

  case 1307:
#line 8232 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 44963 "preproc.c" /* yacc.c:1652  */
    break;

  case 1308:
#line 8236 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter table"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 44971 "preproc.c" /* yacc.c:1652  */
    break;

  case 1309:
#line 8240 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter table if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 44979 "preproc.c" /* yacc.c:1652  */
    break;

  case 1310:
#line 8244 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter view"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 44987 "preproc.c" /* yacc.c:1652  */
    break;

  case 1311:
#line 8248 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter view if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 44995 "preproc.c" /* yacc.c:1652  */
    break;

  case 1312:
#line 8252 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 45003 "preproc.c" /* yacc.c:1652  */
    break;

  case 1313:
#line 8256 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 45011 "preproc.c" /* yacc.c:1652  */
    break;

  case 1314:
#line 8260 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter table"),(yyvsp[-5].str),mm_strdup("rename constraint"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 45019 "preproc.c" /* yacc.c:1652  */
    break;

  case 1315:
#line 8264 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter table if exists"),(yyvsp[-5].str),mm_strdup("rename constraint"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 45027 "preproc.c" /* yacc.c:1652  */
    break;

  case 1316:
#line 8268 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter foreign table"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 45035 "preproc.c" /* yacc.c:1652  */
    break;

  case 1317:
#line 8272 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter foreign table if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 45043 "preproc.c" /* yacc.c:1652  */
    break;

  case 1318:
#line 8276 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter rule"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45051 "preproc.c" /* yacc.c:1652  */
    break;

  case 1319:
#line 8280 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter trigger"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45059 "preproc.c" /* yacc.c:1652  */
    break;

  case 1320:
#line 8284 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter event trigger"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45067 "preproc.c" /* yacc.c:1652  */
    break;

  case 1321:
#line 8288 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45075 "preproc.c" /* yacc.c:1652  */
    break;

  case 1322:
#line 8292 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45083 "preproc.c" /* yacc.c:1652  */
    break;

  case 1323:
#line 8296 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45091 "preproc.c" /* yacc.c:1652  */
    break;

  case 1324:
#line 8300 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter statistics"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45099 "preproc.c" /* yacc.c:1652  */
    break;

  case 1325:
#line 8304 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search parser"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45107 "preproc.c" /* yacc.c:1652  */
    break;

  case 1326:
#line 8308 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45115 "preproc.c" /* yacc.c:1652  */
    break;

  case 1327:
#line 8312 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search template"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45123 "preproc.c" /* yacc.c:1652  */
    break;

  case 1328:
#line 8316 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45131 "preproc.c" /* yacc.c:1652  */
    break;

  case 1329:
#line 8320 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 45139 "preproc.c" /* yacc.c:1652  */
    break;

  case 1330:
#line 8324 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("rename attribute"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45147 "preproc.c" /* yacc.c:1652  */
    break;

  case 1331:
#line 8332 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("column");
}
#line 45155 "preproc.c" /* yacc.c:1652  */
    break;

  case 1332:
#line 8336 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 45162 "preproc.c" /* yacc.c:1652  */
    break;

  case 1333:
#line 8343 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set data");
}
#line 45170 "preproc.c" /* yacc.c:1652  */
    break;

  case 1334:
#line 8347 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 45177 "preproc.c" /* yacc.c:1652  */
    break;

  case 1335:
#line 8354 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter function"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 45185 "preproc.c" /* yacc.c:1652  */
    break;

  case 1336:
#line 8358 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter procedure"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 45193 "preproc.c" /* yacc.c:1652  */
    break;

  case 1337:
#line 8362 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter routine"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 45201 "preproc.c" /* yacc.c:1652  */
    break;

  case 1338:
#line 8366 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("alter trigger"),(yyvsp[-7].str),mm_strdup("on"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 45209 "preproc.c" /* yacc.c:1652  */
    break;

  case 1339:
#line 8370 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter materialized view"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 45217 "preproc.c" /* yacc.c:1652  */
    break;

  case 1340:
#line 8374 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter index"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("depends on extension"),(yyvsp[0].str));
}
#line 45225 "preproc.c" /* yacc.c:1652  */
    break;

  case 1341:
#line 8382 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no");
}
#line 45233 "preproc.c" /* yacc.c:1652  */
    break;

  case 1342:
#line 8386 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 45240 "preproc.c" /* yacc.c:1652  */
    break;

  case 1343:
#line 8393 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter aggregate"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45248 "preproc.c" /* yacc.c:1652  */
    break;

  case 1344:
#line 8397 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45256 "preproc.c" /* yacc.c:1652  */
    break;

  case 1345:
#line 8401 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45264 "preproc.c" /* yacc.c:1652  */
    break;

  case 1346:
#line 8405 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45272 "preproc.c" /* yacc.c:1652  */
    break;

  case 1347:
#line 8409 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter extension"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45280 "preproc.c" /* yacc.c:1652  */
    break;

  case 1348:
#line 8413 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45288 "preproc.c" /* yacc.c:1652  */
    break;

  case 1349:
#line 8417 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter operator"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45296 "preproc.c" /* yacc.c:1652  */
    break;

  case 1350:
#line 8421 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45304 "preproc.c" /* yacc.c:1652  */
    break;

  case 1351:
#line 8425 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45312 "preproc.c" /* yacc.c:1652  */
    break;

  case 1352:
#line 8429 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter procedure"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45320 "preproc.c" /* yacc.c:1652  */
    break;

  case 1353:
#line 8433 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter routine"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45328 "preproc.c" /* yacc.c:1652  */
    break;

  case 1354:
#line 8437 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter table"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45336 "preproc.c" /* yacc.c:1652  */
    break;

  case 1355:
#line 8441 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter table if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45344 "preproc.c" /* yacc.c:1652  */
    break;

  case 1356:
#line 8445 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter statistics"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45352 "preproc.c" /* yacc.c:1652  */
    break;

  case 1357:
#line 8449 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search parser"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45360 "preproc.c" /* yacc.c:1652  */
    break;

  case 1358:
#line 8453 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45368 "preproc.c" /* yacc.c:1652  */
    break;

  case 1359:
#line 8457 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search template"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45376 "preproc.c" /* yacc.c:1652  */
    break;

  case 1360:
#line 8461 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45384 "preproc.c" /* yacc.c:1652  */
    break;

  case 1361:
#line 8465 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45392 "preproc.c" /* yacc.c:1652  */
    break;

  case 1362:
#line 8469 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45400 "preproc.c" /* yacc.c:1652  */
    break;

  case 1363:
#line 8473 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter view"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45408 "preproc.c" /* yacc.c:1652  */
    break;

  case 1364:
#line 8477 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter view if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45416 "preproc.c" /* yacc.c:1652  */
    break;

  case 1365:
#line 8481 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45424 "preproc.c" /* yacc.c:1652  */
    break;

  case 1366:
#line 8485 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45432 "preproc.c" /* yacc.c:1652  */
    break;

  case 1367:
#line 8489 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45440 "preproc.c" /* yacc.c:1652  */
    break;

  case 1368:
#line 8493 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45448 "preproc.c" /* yacc.c:1652  */
    break;

  case 1369:
#line 8497 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 45456 "preproc.c" /* yacc.c:1652  */
    break;

  case 1370:
#line 8505 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter operator"),(yyvsp[-4].str),mm_strdup("set ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45464 "preproc.c" /* yacc.c:1652  */
    break;

  case 1371:
#line 8513 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45472 "preproc.c" /* yacc.c:1652  */
    break;

  case 1372:
#line 8517 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 45480 "preproc.c" /* yacc.c:1652  */
    break;

  case 1373:
#line 8525 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("= none"));
}
#line 45488 "preproc.c" /* yacc.c:1652  */
    break;

  case 1374:
#line 8529 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 45496 "preproc.c" /* yacc.c:1652  */
    break;

  case 1375:
#line 8537 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45504 "preproc.c" /* yacc.c:1652  */
    break;

  case 1376:
#line 8541 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45512 "preproc.c" /* yacc.c:1652  */
    break;

  case 1377:
#line 8545 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45520 "preproc.c" /* yacc.c:1652  */
    break;

  case 1378:
#line 8549 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45528 "preproc.c" /* yacc.c:1652  */
    break;

  case 1379:
#line 8553 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45536 "preproc.c" /* yacc.c:1652  */
    break;

  case 1380:
#line 8561 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter type"),(yyvsp[-4].str),mm_strdup("set ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45544 "preproc.c" /* yacc.c:1652  */
    break;

  case 1381:
#line 8569 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter aggregate"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45552 "preproc.c" /* yacc.c:1652  */
    break;

  case 1382:
#line 8573 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45560 "preproc.c" /* yacc.c:1652  */
    break;

  case 1383:
#line 8577 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45568 "preproc.c" /* yacc.c:1652  */
    break;

  case 1384:
#line 8581 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45576 "preproc.c" /* yacc.c:1652  */
    break;

  case 1385:
#line 8585 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45584 "preproc.c" /* yacc.c:1652  */
    break;

  case 1386:
#line 8589 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45592 "preproc.c" /* yacc.c:1652  */
    break;

  case 1387:
#line 8593 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter"),(yyvsp[-5].str),mm_strdup("language"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45600 "preproc.c" /* yacc.c:1652  */
    break;

  case 1388:
#line 8597 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter large object"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45608 "preproc.c" /* yacc.c:1652  */
    break;

  case 1389:
#line 8601 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter operator"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45616 "preproc.c" /* yacc.c:1652  */
    break;

  case 1390:
#line 8605 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45624 "preproc.c" /* yacc.c:1652  */
    break;

  case 1391:
#line 8609 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45632 "preproc.c" /* yacc.c:1652  */
    break;

  case 1392:
#line 8613 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter procedure"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45640 "preproc.c" /* yacc.c:1652  */
    break;

  case 1393:
#line 8617 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter routine"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45648 "preproc.c" /* yacc.c:1652  */
    break;

  case 1394:
#line 8621 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter schema"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45656 "preproc.c" /* yacc.c:1652  */
    break;

  case 1395:
#line 8625 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45664 "preproc.c" /* yacc.c:1652  */
    break;

  case 1396:
#line 8629 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45672 "preproc.c" /* yacc.c:1652  */
    break;

  case 1397:
#line 8633 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter statistics"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45680 "preproc.c" /* yacc.c:1652  */
    break;

  case 1398:
#line 8637 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45688 "preproc.c" /* yacc.c:1652  */
    break;

  case 1399:
#line 8641 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45696 "preproc.c" /* yacc.c:1652  */
    break;

  case 1400:
#line 8645 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45704 "preproc.c" /* yacc.c:1652  */
    break;

  case 1401:
#line 8649 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45712 "preproc.c" /* yacc.c:1652  */
    break;

  case 1402:
#line 8653 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter event trigger"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45720 "preproc.c" /* yacc.c:1652  */
    break;

  case 1403:
#line 8657 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45728 "preproc.c" /* yacc.c:1652  */
    break;

  case 1404:
#line 8661 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter subscription"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 45736 "preproc.c" /* yacc.c:1652  */
    break;

  case 1405:
#line 8669 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create publication"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45744 "preproc.c" /* yacc.c:1652  */
    break;

  case 1406:
#line 8677 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45752 "preproc.c" /* yacc.c:1652  */
    break;

  case 1407:
#line 8681 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 45759 "preproc.c" /* yacc.c:1652  */
    break;

  case 1408:
#line 8688 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for table"),(yyvsp[0].str));
}
#line 45767 "preproc.c" /* yacc.c:1652  */
    break;

  case 1409:
#line 8692 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for all tables");
}
#line 45775 "preproc.c" /* yacc.c:1652  */
    break;

  case 1410:
#line 8700 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 45783 "preproc.c" /* yacc.c:1652  */
    break;

  case 1411:
#line 8704 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-3].str),mm_strdup("add table"),(yyvsp[0].str));
}
#line 45791 "preproc.c" /* yacc.c:1652  */
    break;

  case 1412:
#line 8708 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-3].str),mm_strdup("set table"),(yyvsp[0].str));
}
#line 45799 "preproc.c" /* yacc.c:1652  */
    break;

  case 1413:
#line 8712 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter publication"),(yyvsp[-3].str),mm_strdup("drop table"),(yyvsp[0].str));
}
#line 45807 "preproc.c" /* yacc.c:1652  */
    break;

  case 1414:
#line 8720 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("create subscription"),(yyvsp[-5].str),mm_strdup("connection"),(yyvsp[-3].str),mm_strdup("publication"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45815 "preproc.c" /* yacc.c:1652  */
    break;

  case 1415:
#line 8728 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45823 "preproc.c" /* yacc.c:1652  */
    break;

  case 1416:
#line 8732 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 45831 "preproc.c" /* yacc.c:1652  */
    break;

  case 1417:
#line 8740 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45839 "preproc.c" /* yacc.c:1652  */
    break;

  case 1418:
#line 8748 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter subscription"),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 45847 "preproc.c" /* yacc.c:1652  */
    break;

  case 1419:
#line 8752 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter subscription"),(yyvsp[-2].str),mm_strdup("connection"),(yyvsp[0].str));
}
#line 45855 "preproc.c" /* yacc.c:1652  */
    break;

  case 1420:
#line 8756 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter subscription"),(yyvsp[-3].str),mm_strdup("refresh publication"),(yyvsp[0].str));
}
#line 45863 "preproc.c" /* yacc.c:1652  */
    break;

  case 1421:
#line 8760 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter subscription"),(yyvsp[-4].str),mm_strdup("set publication"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45871 "preproc.c" /* yacc.c:1652  */
    break;

  case 1422:
#line 8764 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter subscription"),(yyvsp[-1].str),mm_strdup("enable"));
}
#line 45879 "preproc.c" /* yacc.c:1652  */
    break;

  case 1423:
#line 8768 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter subscription"),(yyvsp[-1].str),mm_strdup("disable"));
}
#line 45887 "preproc.c" /* yacc.c:1652  */
    break;

  case 1424:
#line 8776 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop subscription"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45895 "preproc.c" /* yacc.c:1652  */
    break;

  case 1425:
#line 8780 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("drop subscription if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45903 "preproc.c" /* yacc.c:1652  */
    break;

  case 1426:
#line 8788 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(12,mm_strdup("create"),(yyvsp[-11].str),mm_strdup("rule"),(yyvsp[-9].str),mm_strdup("as on"),(yyvsp[-6].str),mm_strdup("to"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("do"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45911 "preproc.c" /* yacc.c:1652  */
    break;

  case 1427:
#line 8796 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nothing");
}
#line 45919 "preproc.c" /* yacc.c:1652  */
    break;

  case 1428:
#line 8800 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45927 "preproc.c" /* yacc.c:1652  */
    break;

  case 1429:
#line 8804 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45935 "preproc.c" /* yacc.c:1652  */
    break;

  case 1430:
#line 8812 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(";"),(yyvsp[0].str));
}
#line 45943 "preproc.c" /* yacc.c:1652  */
    break;

  case 1431:
#line 8816 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45951 "preproc.c" /* yacc.c:1652  */
    break;

  case 1432:
#line 8824 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45959 "preproc.c" /* yacc.c:1652  */
    break;

  case 1433:
#line 8828 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45967 "preproc.c" /* yacc.c:1652  */
    break;

  case 1434:
#line 8832 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45975 "preproc.c" /* yacc.c:1652  */
    break;

  case 1435:
#line 8836 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45983 "preproc.c" /* yacc.c:1652  */
    break;

  case 1436:
#line 8840 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45991 "preproc.c" /* yacc.c:1652  */
    break;

  case 1437:
#line 8848 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45999 "preproc.c" /* yacc.c:1652  */
    break;

  case 1438:
#line 8852 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46006 "preproc.c" /* yacc.c:1652  */
    break;

  case 1439:
#line 8859 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("select");
}
#line 46014 "preproc.c" /* yacc.c:1652  */
    break;

  case 1440:
#line 8863 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("update");
}
#line 46022 "preproc.c" /* yacc.c:1652  */
    break;

  case 1441:
#line 8867 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delete");
}
#line 46030 "preproc.c" /* yacc.c:1652  */
    break;

  case 1442:
#line 8871 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("insert");
}
#line 46038 "preproc.c" /* yacc.c:1652  */
    break;

  case 1443:
#line 8879 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("instead");
}
#line 46046 "preproc.c" /* yacc.c:1652  */
    break;

  case 1444:
#line 8883 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("also");
}
#line 46054 "preproc.c" /* yacc.c:1652  */
    break;

  case 1445:
#line 8887 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46061 "preproc.c" /* yacc.c:1652  */
    break;

  case 1446:
#line 8894 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("notify"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46069 "preproc.c" /* yacc.c:1652  */
    break;

  case 1447:
#line 8902 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup(","),(yyvsp[0].str));
}
#line 46077 "preproc.c" /* yacc.c:1652  */
    break;

  case 1448:
#line 8906 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46084 "preproc.c" /* yacc.c:1652  */
    break;

  case 1449:
#line 8913 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("listen"),(yyvsp[0].str));
}
#line 46092 "preproc.c" /* yacc.c:1652  */
    break;

  case 1450:
#line 8921 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("unlisten"),(yyvsp[0].str));
}
#line 46100 "preproc.c" /* yacc.c:1652  */
    break;

  case 1451:
#line 8925 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unlisten *");
}
#line 46108 "preproc.c" /* yacc.c:1652  */
    break;

  case 1452:
#line 8933 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("abort"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46116 "preproc.c" /* yacc.c:1652  */
    break;

  case 1453:
#line 8937 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("begin"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46124 "preproc.c" /* yacc.c:1652  */
    break;

  case 1454:
#line 8941 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("start transaction"),(yyvsp[0].str));
}
#line 46132 "preproc.c" /* yacc.c:1652  */
    break;

  case 1455:
#line 8945 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("commit"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46140 "preproc.c" /* yacc.c:1652  */
    break;

  case 1456:
#line 8949 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("end"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46148 "preproc.c" /* yacc.c:1652  */
    break;

  case 1457:
#line 8953 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("rollback"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46156 "preproc.c" /* yacc.c:1652  */
    break;

  case 1458:
#line 8957 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("savepoint"),(yyvsp[0].str));
}
#line 46164 "preproc.c" /* yacc.c:1652  */
    break;

  case 1459:
#line 8961 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("release savepoint"),(yyvsp[0].str));
}
#line 46172 "preproc.c" /* yacc.c:1652  */
    break;

  case 1460:
#line 8965 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("release"),(yyvsp[0].str));
}
#line 46180 "preproc.c" /* yacc.c:1652  */
    break;

  case 1461:
#line 8969 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("rollback"),(yyvsp[-3].str),mm_strdup("to savepoint"),(yyvsp[0].str));
}
#line 46188 "preproc.c" /* yacc.c:1652  */
    break;

  case 1462:
#line 8973 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("rollback"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 46196 "preproc.c" /* yacc.c:1652  */
    break;

  case 1463:
#line 8977 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("prepare transaction"),(yyvsp[0].str));
}
#line 46204 "preproc.c" /* yacc.c:1652  */
    break;

  case 1464:
#line 8981 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("commit prepared"),(yyvsp[0].str));
}
#line 46212 "preproc.c" /* yacc.c:1652  */
    break;

  case 1465:
#line 8985 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("rollback prepared"),(yyvsp[0].str));
}
#line 46220 "preproc.c" /* yacc.c:1652  */
    break;

  case 1466:
#line 8993 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("work");
}
#line 46228 "preproc.c" /* yacc.c:1652  */
    break;

  case 1467:
#line 8997 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("transaction");
}
#line 46236 "preproc.c" /* yacc.c:1652  */
    break;

  case 1468:
#line 9001 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46243 "preproc.c" /* yacc.c:1652  */
    break;

  case 1469:
#line 9008 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("isolation level"),(yyvsp[0].str));
}
#line 46251 "preproc.c" /* yacc.c:1652  */
    break;

  case 1470:
#line 9012 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("read only");
}
#line 46259 "preproc.c" /* yacc.c:1652  */
    break;

  case 1471:
#line 9016 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("read write");
}
#line 46267 "preproc.c" /* yacc.c:1652  */
    break;

  case 1472:
#line 9020 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 46275 "preproc.c" /* yacc.c:1652  */
    break;

  case 1473:
#line 9024 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 46283 "preproc.c" /* yacc.c:1652  */
    break;

  case 1474:
#line 9032 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46291 "preproc.c" /* yacc.c:1652  */
    break;

  case 1475:
#line 9036 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46299 "preproc.c" /* yacc.c:1652  */
    break;

  case 1476:
#line 9040 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46307 "preproc.c" /* yacc.c:1652  */
    break;

  case 1477:
#line 9048 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46315 "preproc.c" /* yacc.c:1652  */
    break;

  case 1478:
#line 9052 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46322 "preproc.c" /* yacc.c:1652  */
    break;

  case 1479:
#line 9059 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("and chain");
}
#line 46330 "preproc.c" /* yacc.c:1652  */
    break;

  case 1480:
#line 9063 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("and no chain");
}
#line 46338 "preproc.c" /* yacc.c:1652  */
    break;

  case 1481:
#line 9067 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46345 "preproc.c" /* yacc.c:1652  */
    break;

  case 1482:
#line 9074 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create"),(yyvsp[-7].str),mm_strdup("view"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46353 "preproc.c" /* yacc.c:1652  */
    break;

  case 1483:
#line 9078 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("create or replace"),(yyvsp[-7].str),mm_strdup("view"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46361 "preproc.c" /* yacc.c:1652  */
    break;

  case 1484:
#line 9082 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(11,mm_strdup("create"),(yyvsp[-10].str),mm_strdup("recursive view"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46370 "preproc.c" /* yacc.c:1652  */
    break;

  case 1485:
#line 9087 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(11,mm_strdup("create or replace"),(yyvsp[-10].str),mm_strdup("recursive view"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46379 "preproc.c" /* yacc.c:1652  */
    break;

  case 1486:
#line 9096 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with check option");
}
#line 46387 "preproc.c" /* yacc.c:1652  */
    break;

  case 1487:
#line 9100 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with cascaded check option");
}
#line 46395 "preproc.c" /* yacc.c:1652  */
    break;

  case 1488:
#line 9104 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with local check option");
}
#line 46403 "preproc.c" /* yacc.c:1652  */
    break;

  case 1489:
#line 9108 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46410 "preproc.c" /* yacc.c:1652  */
    break;

  case 1490:
#line 9115 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("load"),(yyvsp[0].str));
}
#line 46418 "preproc.c" /* yacc.c:1652  */
    break;

  case 1491:
#line 9123 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("create database"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46426 "preproc.c" /* yacc.c:1652  */
    break;

  case 1492:
#line 9131 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46434 "preproc.c" /* yacc.c:1652  */
    break;

  case 1493:
#line 9135 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46441 "preproc.c" /* yacc.c:1652  */
    break;

  case 1494:
#line 9142 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46449 "preproc.c" /* yacc.c:1652  */
    break;

  case 1495:
#line 9146 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46457 "preproc.c" /* yacc.c:1652  */
    break;

  case 1496:
#line 9154 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46465 "preproc.c" /* yacc.c:1652  */
    break;

  case 1497:
#line 9158 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46473 "preproc.c" /* yacc.c:1652  */
    break;

  case 1498:
#line 9162 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("default"));
}
#line 46481 "preproc.c" /* yacc.c:1652  */
    break;

  case 1499:
#line 9170 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46489 "preproc.c" /* yacc.c:1652  */
    break;

  case 1500:
#line 9174 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("connection limit");
}
#line 46497 "preproc.c" /* yacc.c:1652  */
    break;

  case 1501:
#line 9178 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("encoding");
}
#line 46505 "preproc.c" /* yacc.c:1652  */
    break;

  case 1502:
#line 9182 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("location");
}
#line 46513 "preproc.c" /* yacc.c:1652  */
    break;

  case 1503:
#line 9186 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("owner");
}
#line 46521 "preproc.c" /* yacc.c:1652  */
    break;

  case 1504:
#line 9190 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 46529 "preproc.c" /* yacc.c:1652  */
    break;

  case 1505:
#line 9194 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("template");
}
#line 46537 "preproc.c" /* yacc.c:1652  */
    break;

  case 1506:
#line 9202 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("=");
}
#line 46545 "preproc.c" /* yacc.c:1652  */
    break;

  case 1507:
#line 9206 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46552 "preproc.c" /* yacc.c:1652  */
    break;

  case 1508:
#line 9213 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 46560 "preproc.c" /* yacc.c:1652  */
    break;

  case 1509:
#line 9217 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter database"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46568 "preproc.c" /* yacc.c:1652  */
    break;

  case 1510:
#line 9221 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("set tablespace"),(yyvsp[0].str));
}
#line 46576 "preproc.c" /* yacc.c:1652  */
    break;

  case 1511:
#line 9229 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter database"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46584 "preproc.c" /* yacc.c:1652  */
    break;

  case 1512:
#line 9237 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop database"),(yyvsp[0].str));
}
#line 46592 "preproc.c" /* yacc.c:1652  */
    break;

  case 1513:
#line 9241 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("drop database if exists"),(yyvsp[0].str));
}
#line 46600 "preproc.c" /* yacc.c:1652  */
    break;

  case 1514:
#line 9245 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("drop database"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46608 "preproc.c" /* yacc.c:1652  */
    break;

  case 1515:
#line 9249 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("drop database if exists"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46616 "preproc.c" /* yacc.c:1652  */
    break;

  case 1516:
#line 9257 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46624 "preproc.c" /* yacc.c:1652  */
    break;

  case 1517:
#line 9261 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46632 "preproc.c" /* yacc.c:1652  */
    break;

  case 1518:
#line 9269 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("force");
}
#line 46640 "preproc.c" /* yacc.c:1652  */
    break;

  case 1519:
#line 9277 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter collation"),(yyvsp[-2].str),mm_strdup("refresh version"));
}
#line 46648 "preproc.c" /* yacc.c:1652  */
    break;

  case 1520:
#line 9285 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("alter system set"),(yyvsp[0].str));
}
#line 46656 "preproc.c" /* yacc.c:1652  */
    break;

  case 1521:
#line 9289 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("alter system reset"),(yyvsp[0].str));
}
#line 46664 "preproc.c" /* yacc.c:1652  */
    break;

  case 1522:
#line 9297 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("create domain"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46672 "preproc.c" /* yacc.c:1652  */
    break;

  case 1523:
#line 9305 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46680 "preproc.c" /* yacc.c:1652  */
    break;

  case 1524:
#line 9309 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("drop not null"));
}
#line 46688 "preproc.c" /* yacc.c:1652  */
    break;

  case 1525:
#line 9313 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("set not null"));
}
#line 46696 "preproc.c" /* yacc.c:1652  */
    break;

  case 1526:
#line 9317 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-2].str),mm_strdup("add"),(yyvsp[0].str));
}
#line 46704 "preproc.c" /* yacc.c:1652  */
    break;

  case 1527:
#line 9321 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter domain"),(yyvsp[-4].str),mm_strdup("drop constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46712 "preproc.c" /* yacc.c:1652  */
    break;

  case 1528:
#line 9325 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("alter domain"),(yyvsp[-6].str),mm_strdup("drop constraint if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46720 "preproc.c" /* yacc.c:1652  */
    break;

  case 1529:
#line 9329 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("validate constraint"),(yyvsp[0].str));
}
#line 46728 "preproc.c" /* yacc.c:1652  */
    break;

  case 1530:
#line 9337 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("as");
}
#line 46736 "preproc.c" /* yacc.c:1652  */
    break;

  case 1531:
#line 9341 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46743 "preproc.c" /* yacc.c:1652  */
    break;

  case 1532:
#line 9348 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("alter text search dictionary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46751 "preproc.c" /* yacc.c:1652  */
    break;

  case 1533:
#line 9356 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("add mapping for"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46759 "preproc.c" /* yacc.c:1652  */
    break;

  case 1534:
#line 9360 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("alter mapping for"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46767 "preproc.c" /* yacc.c:1652  */
    break;

  case 1535:
#line 9364 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("alter mapping replace"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46775 "preproc.c" /* yacc.c:1652  */
    break;

  case 1536:
#line 9368 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("alter text search configuration"),(yyvsp[-8].str),mm_strdup("alter mapping for"),(yyvsp[-4].str),mm_strdup("replace"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46783 "preproc.c" /* yacc.c:1652  */
    break;

  case 1537:
#line 9372 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-4].str),mm_strdup("drop mapping for"),(yyvsp[0].str));
}
#line 46791 "preproc.c" /* yacc.c:1652  */
    break;

  case 1538:
#line 9376 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("drop mapping if exists for"),(yyvsp[0].str));
}
#line 46799 "preproc.c" /* yacc.c:1652  */
    break;

  case 1539:
#line 9384 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with");
}
#line 46807 "preproc.c" /* yacc.c:1652  */
    break;

  case 1540:
#line 9388 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with");
}
#line 46815 "preproc.c" /* yacc.c:1652  */
    break;

  case 1541:
#line 9396 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-8].str),mm_strdup("conversion"),(yyvsp[-6].str),mm_strdup("for"),(yyvsp[-4].str),mm_strdup("to"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 46823 "preproc.c" /* yacc.c:1652  */
    break;

  case 1542:
#line 9404 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("cluster"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46831 "preproc.c" /* yacc.c:1652  */
    break;

  case 1543:
#line 9408 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("cluster"),(yyvsp[0].str));
}
#line 46839 "preproc.c" /* yacc.c:1652  */
    break;

  case 1544:
#line 9412 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("cluster"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("on"),(yyvsp[0].str));
}
#line 46847 "preproc.c" /* yacc.c:1652  */
    break;

  case 1545:
#line 9420 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 46855 "preproc.c" /* yacc.c:1652  */
    break;

  case 1546:
#line 9424 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46862 "preproc.c" /* yacc.c:1652  */
    break;

  case 1547:
#line 9431 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("vacuum"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46870 "preproc.c" /* yacc.c:1652  */
    break;

  case 1548:
#line 9435 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("vacuum ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 46878 "preproc.c" /* yacc.c:1652  */
    break;

  case 1549:
#line 9443 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46886 "preproc.c" /* yacc.c:1652  */
    break;

  case 1550:
#line 9447 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 46894 "preproc.c" /* yacc.c:1652  */
    break;

  case 1551:
#line 9455 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46902 "preproc.c" /* yacc.c:1652  */
    break;

  case 1552:
#line 9459 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46910 "preproc.c" /* yacc.c:1652  */
    break;

  case 1553:
#line 9467 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("analyze");
}
#line 46918 "preproc.c" /* yacc.c:1652  */
    break;

  case 1554:
#line 9471 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("analyse");
}
#line 46926 "preproc.c" /* yacc.c:1652  */
    break;

  case 1555:
#line 9479 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46934 "preproc.c" /* yacc.c:1652  */
    break;

  case 1556:
#line 9487 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46942 "preproc.c" /* yacc.c:1652  */
    break;

  case 1557:
#line 9491 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46950 "preproc.c" /* yacc.c:1652  */
    break;

  case 1558:
#line 9499 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46958 "preproc.c" /* yacc.c:1652  */
    break;

  case 1559:
#line 9503 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46966 "preproc.c" /* yacc.c:1652  */
    break;

  case 1560:
#line 9507 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46973 "preproc.c" /* yacc.c:1652  */
    break;

  case 1561:
#line 9514 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46981 "preproc.c" /* yacc.c:1652  */
    break;

  case 1562:
#line 9518 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 46988 "preproc.c" /* yacc.c:1652  */
    break;

  case 1563:
#line 9525 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("verbose");
}
#line 46996 "preproc.c" /* yacc.c:1652  */
    break;

  case 1564:
#line 9529 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47003 "preproc.c" /* yacc.c:1652  */
    break;

  case 1565:
#line 9536 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("full");
}
#line 47011 "preproc.c" /* yacc.c:1652  */
    break;

  case 1566:
#line 9540 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47018 "preproc.c" /* yacc.c:1652  */
    break;

  case 1567:
#line 9547 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("freeze");
}
#line 47026 "preproc.c" /* yacc.c:1652  */
    break;

  case 1568:
#line 9551 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47033 "preproc.c" /* yacc.c:1652  */
    break;

  case 1569:
#line 9558 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47041 "preproc.c" /* yacc.c:1652  */
    break;

  case 1570:
#line 9562 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47048 "preproc.c" /* yacc.c:1652  */
    break;

  case 1571:
#line 9569 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47056 "preproc.c" /* yacc.c:1652  */
    break;

  case 1572:
#line 9577 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47064 "preproc.c" /* yacc.c:1652  */
    break;

  case 1573:
#line 9581 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47072 "preproc.c" /* yacc.c:1652  */
    break;

  case 1574:
#line 9589 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47080 "preproc.c" /* yacc.c:1652  */
    break;

  case 1575:
#line 9593 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47087 "preproc.c" /* yacc.c:1652  */
    break;

  case 1576:
#line 9600 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("explain"),(yyvsp[0].str));
}
#line 47095 "preproc.c" /* yacc.c:1652  */
    break;

  case 1577:
#line 9604 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("explain"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47103 "preproc.c" /* yacc.c:1652  */
    break;

  case 1578:
#line 9608 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("explain verbose"),(yyvsp[0].str));
}
#line 47111 "preproc.c" /* yacc.c:1652  */
    break;

  case 1579:
#line 9612 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("explain ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 47119 "preproc.c" /* yacc.c:1652  */
    break;

  case 1580:
#line 9620 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47127 "preproc.c" /* yacc.c:1652  */
    break;

  case 1581:
#line 9624 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47135 "preproc.c" /* yacc.c:1652  */
    break;

  case 1582:
#line 9628 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47143 "preproc.c" /* yacc.c:1652  */
    break;

  case 1583:
#line 9632 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47151 "preproc.c" /* yacc.c:1652  */
    break;

  case 1584:
#line 9636 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47159 "preproc.c" /* yacc.c:1652  */
    break;

  case 1585:
#line 9640 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47167 "preproc.c" /* yacc.c:1652  */
    break;

  case 1586:
#line 9644 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47175 "preproc.c" /* yacc.c:1652  */
    break;

  case 1587:
#line 9648 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47183 "preproc.c" /* yacc.c:1652  */
    break;

  case 1588:
#line 9652 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.str) = (yyvsp[0].exec).name;
	}
#line 47191 "preproc.c" /* yacc.c:1652  */
    break;

  case 1589:
#line 9660 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47199 "preproc.c" /* yacc.c:1652  */
    break;

  case 1590:
#line 9664 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47207 "preproc.c" /* yacc.c:1652  */
    break;

  case 1591:
#line 9672 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47215 "preproc.c" /* yacc.c:1652  */
    break;

  case 1592:
#line 9680 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47223 "preproc.c" /* yacc.c:1652  */
    break;

  case 1593:
#line 9684 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47231 "preproc.c" /* yacc.c:1652  */
    break;

  case 1594:
#line 9692 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47239 "preproc.c" /* yacc.c:1652  */
    break;

  case 1595:
#line 9696 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47247 "preproc.c" /* yacc.c:1652  */
    break;

  case 1596:
#line 9700 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47254 "preproc.c" /* yacc.c:1652  */
    break;

  case 1597:
#line 9707 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.prep).name = (yyvsp[-3].str);
		(yyval.prep).type = (yyvsp[-2].str);
		(yyval.prep).stmt = (yyvsp[0].str);
	}
#line 47264 "preproc.c" /* yacc.c:1652  */
    break;

  case 1598:
#line 9713 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.prep).name = (yyvsp[-2].str);
		(yyval.prep).type = NULL;
		(yyval.prep).stmt = (yyvsp[0].str);
	}
#line 47274 "preproc.c" /* yacc.c:1652  */
    break;

  case 1599:
#line 9723 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47282 "preproc.c" /* yacc.c:1652  */
    break;

  case 1600:
#line 9727 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47289 "preproc.c" /* yacc.c:1652  */
    break;

  case 1601:
#line 9734 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47297 "preproc.c" /* yacc.c:1652  */
    break;

  case 1602:
#line 9738 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47305 "preproc.c" /* yacc.c:1652  */
    break;

  case 1603:
#line 9742 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47313 "preproc.c" /* yacc.c:1652  */
    break;

  case 1604:
#line 9746 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47321 "preproc.c" /* yacc.c:1652  */
    break;

  case 1605:
#line 9754 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.exec).name = (yyvsp[-2].str);
		(yyval.exec).type = (yyvsp[-1].str);
	}
#line 47330 "preproc.c" /* yacc.c:1652  */
    break;

  case 1606:
#line 9759 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.exec).name = cat_str(8,mm_strdup("create"),(yyvsp[-8].str),mm_strdup("table"),(yyvsp[-6].str),mm_strdup("as execute"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str));
	}
#line 47338 "preproc.c" /* yacc.c:1652  */
    break;

  case 1607:
#line 9763 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.exec).name = cat_str(8,mm_strdup("create"),(yyvsp[-11].str),mm_strdup("table if not exists"),(yyvsp[-6].str),mm_strdup("as execute"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str));
	}
#line 47346 "preproc.c" /* yacc.c:1652  */
    break;

  case 1608:
#line 9771 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47354 "preproc.c" /* yacc.c:1652  */
    break;

  case 1609:
#line 9775 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47361 "preproc.c" /* yacc.c:1652  */
    break;

  case 1610:
#line 9782 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-6].str),mm_strdup("insert into"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47369 "preproc.c" /* yacc.c:1652  */
    break;

  case 1611:
#line 9790 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47377 "preproc.c" /* yacc.c:1652  */
    break;

  case 1612:
#line 9794 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 47385 "preproc.c" /* yacc.c:1652  */
    break;

  case 1613:
#line 9802 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47393 "preproc.c" /* yacc.c:1652  */
    break;

  case 1614:
#line 9806 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("overriding"),(yyvsp[-2].str),mm_strdup("value"),(yyvsp[0].str));
}
#line 47401 "preproc.c" /* yacc.c:1652  */
    break;

  case 1615:
#line 9810 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 47409 "preproc.c" /* yacc.c:1652  */
    break;

  case 1616:
#line 9814 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("("),(yyvsp[-5].str),mm_strdup(") overriding"),(yyvsp[-2].str),mm_strdup("value"),(yyvsp[0].str));
}
#line 47417 "preproc.c" /* yacc.c:1652  */
    break;

  case 1617:
#line 9818 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default values");
}
#line 47425 "preproc.c" /* yacc.c:1652  */
    break;

  case 1618:
#line 9826 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("user");
}
#line 47433 "preproc.c" /* yacc.c:1652  */
    break;

  case 1619:
#line 9830 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("system");
}
#line 47441 "preproc.c" /* yacc.c:1652  */
    break;

  case 1620:
#line 9838 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47449 "preproc.c" /* yacc.c:1652  */
    break;

  case 1621:
#line 9842 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47457 "preproc.c" /* yacc.c:1652  */
    break;

  case 1622:
#line 9850 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47465 "preproc.c" /* yacc.c:1652  */
    break;

  case 1623:
#line 9858 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("on conflict"),(yyvsp[-5].str),mm_strdup("do update set"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47473 "preproc.c" /* yacc.c:1652  */
    break;

  case 1624:
#line 9862 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("on conflict"),(yyvsp[-2].str),mm_strdup("do nothing"));
}
#line 47481 "preproc.c" /* yacc.c:1652  */
    break;

  case 1625:
#line 9866 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47488 "preproc.c" /* yacc.c:1652  */
    break;

  case 1626:
#line 9873 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 47496 "preproc.c" /* yacc.c:1652  */
    break;

  case 1627:
#line 9877 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("on constraint"),(yyvsp[0].str));
}
#line 47504 "preproc.c" /* yacc.c:1652  */
    break;

  case 1628:
#line 9881 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47511 "preproc.c" /* yacc.c:1652  */
    break;

  case 1629:
#line 9888 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("returning"),(yyvsp[-1].str));
}
#line 47519 "preproc.c" /* yacc.c:1652  */
    break;

  case 1630:
#line 9892 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47526 "preproc.c" /* yacc.c:1652  */
    break;

  case 1631:
#line 9899 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-6].str),mm_strdup("delete from"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47534 "preproc.c" /* yacc.c:1652  */
    break;

  case 1632:
#line 9907 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 47542 "preproc.c" /* yacc.c:1652  */
    break;

  case 1633:
#line 9911 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47549 "preproc.c" /* yacc.c:1652  */
    break;

  case 1634:
#line 9918 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("lock"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47557 "preproc.c" /* yacc.c:1652  */
    break;

  case 1635:
#line 9926 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("in"),(yyvsp[-1].str),mm_strdup("mode"));
}
#line 47565 "preproc.c" /* yacc.c:1652  */
    break;

  case 1636:
#line 9930 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47572 "preproc.c" /* yacc.c:1652  */
    break;

  case 1637:
#line 9937 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("access share");
}
#line 47580 "preproc.c" /* yacc.c:1652  */
    break;

  case 1638:
#line 9941 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row share");
}
#line 47588 "preproc.c" /* yacc.c:1652  */
    break;

  case 1639:
#line 9945 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row exclusive");
}
#line 47596 "preproc.c" /* yacc.c:1652  */
    break;

  case 1640:
#line 9949 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("share update exclusive");
}
#line 47604 "preproc.c" /* yacc.c:1652  */
    break;

  case 1641:
#line 9953 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("share");
}
#line 47612 "preproc.c" /* yacc.c:1652  */
    break;

  case 1642:
#line 9957 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("share row exclusive");
}
#line 47620 "preproc.c" /* yacc.c:1652  */
    break;

  case 1643:
#line 9961 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exclusive");
}
#line 47628 "preproc.c" /* yacc.c:1652  */
    break;

  case 1644:
#line 9965 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("access exclusive");
}
#line 47636 "preproc.c" /* yacc.c:1652  */
    break;

  case 1645:
#line 9973 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nowait");
}
#line 47644 "preproc.c" /* yacc.c:1652  */
    break;

  case 1646:
#line 9977 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47651 "preproc.c" /* yacc.c:1652  */
    break;

  case 1647:
#line 9984 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nowait");
}
#line 47659 "preproc.c" /* yacc.c:1652  */
    break;

  case 1648:
#line 9988 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("skip locked");
}
#line 47667 "preproc.c" /* yacc.c:1652  */
    break;

  case 1649:
#line 9992 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47674 "preproc.c" /* yacc.c:1652  */
    break;

  case 1650:
#line 9999 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,(yyvsp[-7].str),mm_strdup("update"),(yyvsp[-5].str),mm_strdup("set"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47682 "preproc.c" /* yacc.c:1652  */
    break;

  case 1651:
#line 10007 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47690 "preproc.c" /* yacc.c:1652  */
    break;

  case 1652:
#line 10011 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47698 "preproc.c" /* yacc.c:1652  */
    break;

  case 1653:
#line 10019 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 47706 "preproc.c" /* yacc.c:1652  */
    break;

  case 1654:
#line 10023 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-3].str),mm_strdup(") ="),(yyvsp[0].str));
}
#line 47714 "preproc.c" /* yacc.c:1652  */
    break;

  case 1655:
#line 10031 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47722 "preproc.c" /* yacc.c:1652  */
    break;

  case 1656:
#line 10039 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47730 "preproc.c" /* yacc.c:1652  */
    break;

  case 1657:
#line 10043 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47738 "preproc.c" /* yacc.c:1652  */
    break;

  case 1658:
#line 10051 "preproc.y" /* yacc.c:1652  */
    {
		struct cursor *ptr, *this;
		char *cursor_marker = (yyvsp[-5].str)[0] == ':' ? mm_strdup("$0") : mm_strdup((yyvsp[-5].str));
		char *comment, *c1, *c2;
		int (* strcmp_fn)(const char *, const char *) = (((yyvsp[-5].str)[0] == ':' || (yyvsp[-5].str)[0] == '"') ? strcmp : pg_strcasecmp);

		for (ptr = cur; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp_fn((yyvsp[-5].str), ptr->name) == 0)
			{
				if ((yyvsp[-5].str)[0] == ':')
					mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[-5].str)+1);
				else
					mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[-5].str));
			}
		}

		this = (struct cursor *) mm_alloc(sizeof(struct cursor));

		this->next = cur;
		this->name = (yyvsp[-5].str);
		this->function = (current_function ? mm_strdup(current_function) : NULL);
		this->connection = connection;
		this->opened = false;
		this->command =  cat_str(7, mm_strdup("declare"), cursor_marker, (yyvsp[-4].str), mm_strdup("cursor"), (yyvsp[-2].str), mm_strdup("for"), (yyvsp[0].str));
		this->argsinsert = argsinsert;
		this->argsinsert_oos = NULL;
		this->argsresult = argsresult;
		this->argsresult_oos = NULL;
		argsinsert = argsresult = NULL;
		cur = this;

		c1 = mm_strdup(this->command);
		if ((c2 = strstr(c1, "*/")) != NULL)
		{
			/* We put this text into a comment, so we better remove [*][/]. */
			c2[0] = '.';
			c2[1] = '.';
		}
		comment = cat_str(3, mm_strdup("/*"), c1, mm_strdup("*/"));

		(yyval.str) = cat2_str(adjust_outofscope_cursor_vars(this), comment);
	}
#line 47786 "preproc.c" /* yacc.c:1652  */
    break;

  case 1659:
#line 10099 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47794 "preproc.c" /* yacc.c:1652  */
    break;

  case 1660:
#line 10103 "preproc.y" /* yacc.c:1652  */
    {
			char *curname = mm_alloc(strlen((yyvsp[0].str)) + 2);
			sprintf(curname, ":%s", (yyvsp[0].str));
			free((yyvsp[0].str));
			(yyvsp[0].str) = curname;
			(yyval.str) = (yyvsp[0].str);
		}
#line 47806 "preproc.c" /* yacc.c:1652  */
    break;

  case 1661:
#line 10115 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 47813 "preproc.c" /* yacc.c:1652  */
    break;

  case 1662:
#line 10118 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("no scroll"));
}
#line 47821 "preproc.c" /* yacc.c:1652  */
    break;

  case 1663:
#line 10122 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("scroll"));
}
#line 47829 "preproc.c" /* yacc.c:1652  */
    break;

  case 1664:
#line 10126 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("binary"));
}
#line 47837 "preproc.c" /* yacc.c:1652  */
    break;

  case 1665:
#line 10130 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("insensitive"));
}
#line 47845 "preproc.c" /* yacc.c:1652  */
    break;

  case 1666:
#line 10138 "preproc.y" /* yacc.c:1652  */
    {
		if (compat == ECPG_COMPAT_INFORMIX_SE && autocommit)
			(yyval.str) = mm_strdup("with hold");
		else
			(yyval.str) = EMPTY;
	}
#line 47856 "preproc.c" /* yacc.c:1652  */
    break;

  case 1667:
#line 10145 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with hold");
}
#line 47864 "preproc.c" /* yacc.c:1652  */
    break;

  case 1668:
#line 10149 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("without hold");
}
#line 47872 "preproc.c" /* yacc.c:1652  */
    break;

  case 1669:
#line 10157 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47880 "preproc.c" /* yacc.c:1652  */
    break;

  case 1670:
#line 10161 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47888 "preproc.c" /* yacc.c:1652  */
    break;

  case 1671:
#line 10169 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47896 "preproc.c" /* yacc.c:1652  */
    break;

  case 1672:
#line 10173 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47904 "preproc.c" /* yacc.c:1652  */
    break;

  case 1673:
#line 10181 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47912 "preproc.c" /* yacc.c:1652  */
    break;

  case 1674:
#line 10185 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47920 "preproc.c" /* yacc.c:1652  */
    break;

  case 1675:
#line 10189 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47928 "preproc.c" /* yacc.c:1652  */
    break;

  case 1676:
#line 10193 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47936 "preproc.c" /* yacc.c:1652  */
    break;

  case 1677:
#line 10197 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47944 "preproc.c" /* yacc.c:1652  */
    break;

  case 1678:
#line 10201 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47952 "preproc.c" /* yacc.c:1652  */
    break;

  case 1679:
#line 10205 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47960 "preproc.c" /* yacc.c:1652  */
    break;

  case 1680:
#line 10209 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47968 "preproc.c" /* yacc.c:1652  */
    break;

  case 1681:
#line 10217 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47976 "preproc.c" /* yacc.c:1652  */
    break;

  case 1682:
#line 10221 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47984 "preproc.c" /* yacc.c:1652  */
    break;

  case 1683:
#line 10229 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("select"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47992 "preproc.c" /* yacc.c:1652  */
    break;

  case 1684:
#line 10233 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(9,mm_strdup("select"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48000 "preproc.c" /* yacc.c:1652  */
    break;

  case 1685:
#line 10237 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48008 "preproc.c" /* yacc.c:1652  */
    break;

  case 1686:
#line 10241 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 48016 "preproc.c" /* yacc.c:1652  */
    break;

  case 1687:
#line 10245 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("union"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48024 "preproc.c" /* yacc.c:1652  */
    break;

  case 1688:
#line 10249 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("intersect"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48032 "preproc.c" /* yacc.c:1652  */
    break;

  case 1689:
#line 10253 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("except"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48040 "preproc.c" /* yacc.c:1652  */
    break;

  case 1690:
#line 10261 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 48048 "preproc.c" /* yacc.c:1652  */
    break;

  case 1691:
#line 10265 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 48056 "preproc.c" /* yacc.c:1652  */
    break;

  case 1692:
#line 10269 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("with recursive"),(yyvsp[0].str));
}
#line 48064 "preproc.c" /* yacc.c:1652  */
    break;

  case 1693:
#line 10277 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48072 "preproc.c" /* yacc.c:1652  */
    break;

  case 1694:
#line 10281 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48080 "preproc.c" /* yacc.c:1652  */
    break;

  case 1695:
#line 10289 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("as"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48088 "preproc.c" /* yacc.c:1652  */
    break;

  case 1696:
#line 10297 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("materialized");
}
#line 48096 "preproc.c" /* yacc.c:1652  */
    break;

  case 1697:
#line 10301 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not materialized");
}
#line 48104 "preproc.c" /* yacc.c:1652  */
    break;

  case 1698:
#line 10305 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48111 "preproc.c" /* yacc.c:1652  */
    break;

  case 1699:
#line 10312 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48119 "preproc.c" /* yacc.c:1652  */
    break;

  case 1700:
#line 10316 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48126 "preproc.c" /* yacc.c:1652  */
    break;

  case 1701:
#line 10323 "preproc.y" /* yacc.c:1652  */
    {
						FoundInto = 1;
						(yyval.str)= cat2_str(mm_strdup("into"), (yyvsp[0].str));
					}
#line 48135 "preproc.c" /* yacc.c:1652  */
    break;

  case 1702:
#line 10327 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 48141 "preproc.c" /* yacc.c:1652  */
    break;

  case 1703:
#line 10329 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48148 "preproc.c" /* yacc.c:1652  */
    break;

  case 1704:
#line 10336 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48156 "preproc.c" /* yacc.c:1652  */
    break;

  case 1705:
#line 10340 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48164 "preproc.c" /* yacc.c:1652  */
    break;

  case 1706:
#line 10344 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("local temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48172 "preproc.c" /* yacc.c:1652  */
    break;

  case 1707:
#line 10348 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("local temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48180 "preproc.c" /* yacc.c:1652  */
    break;

  case 1708:
#line 10352 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("global temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48188 "preproc.c" /* yacc.c:1652  */
    break;

  case 1709:
#line 10356 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("global temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48196 "preproc.c" /* yacc.c:1652  */
    break;

  case 1710:
#line 10360 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("unlogged"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48204 "preproc.c" /* yacc.c:1652  */
    break;

  case 1711:
#line 10364 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 48212 "preproc.c" /* yacc.c:1652  */
    break;

  case 1712:
#line 10368 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48220 "preproc.c" /* yacc.c:1652  */
    break;

  case 1713:
#line 10376 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 48228 "preproc.c" /* yacc.c:1652  */
    break;

  case 1714:
#line 10380 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48235 "preproc.c" /* yacc.c:1652  */
    break;

  case 1715:
#line 10387 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 48243 "preproc.c" /* yacc.c:1652  */
    break;

  case 1716:
#line 10391 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("distinct");
}
#line 48251 "preproc.c" /* yacc.c:1652  */
    break;

  case 1717:
#line 10395 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48258 "preproc.c" /* yacc.c:1652  */
    break;

  case 1718:
#line 10402 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("distinct");
}
#line 48266 "preproc.c" /* yacc.c:1652  */
    break;

  case 1719:
#line 10406 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("distinct on ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48274 "preproc.c" /* yacc.c:1652  */
    break;

  case 1720:
#line 10414 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 48282 "preproc.c" /* yacc.c:1652  */
    break;

  case 1721:
#line 10418 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48289 "preproc.c" /* yacc.c:1652  */
    break;

  case 1722:
#line 10425 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48297 "preproc.c" /* yacc.c:1652  */
    break;

  case 1723:
#line 10429 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48304 "preproc.c" /* yacc.c:1652  */
    break;

  case 1724:
#line 10436 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("order by"),(yyvsp[0].str));
}
#line 48312 "preproc.c" /* yacc.c:1652  */
    break;

  case 1725:
#line 10444 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48320 "preproc.c" /* yacc.c:1652  */
    break;

  case 1726:
#line 10448 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48328 "preproc.c" /* yacc.c:1652  */
    break;

  case 1727:
#line 10456 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48336 "preproc.c" /* yacc.c:1652  */
    break;

  case 1728:
#line 10460 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48344 "preproc.c" /* yacc.c:1652  */
    break;

  case 1729:
#line 10468 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48352 "preproc.c" /* yacc.c:1652  */
    break;

  case 1730:
#line 10472 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48360 "preproc.c" /* yacc.c:1652  */
    break;

  case 1731:
#line 10476 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48368 "preproc.c" /* yacc.c:1652  */
    break;

  case 1732:
#line 10480 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48376 "preproc.c" /* yacc.c:1652  */
    break;

  case 1733:
#line 10488 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48384 "preproc.c" /* yacc.c:1652  */
    break;

  case 1734:
#line 10492 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48391 "preproc.c" /* yacc.c:1652  */
    break;

  case 1735:
#line 10499 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("limit"),(yyvsp[0].str));
}
#line 48399 "preproc.c" /* yacc.c:1652  */
    break;

  case 1736:
#line 10503 "preproc.y" /* yacc.c:1652  */
    {
		mmerror(PARSE_ERROR, ET_WARNING, "no longer supported LIMIT #,# syntax passed to server");
		(yyval.str) = cat_str(4, mm_strdup("limit"), (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str));
	}
#line 48408 "preproc.c" /* yacc.c:1652  */
    break;

  case 1737:
#line 10508 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("fetch"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("only"));
}
#line 48416 "preproc.c" /* yacc.c:1652  */
    break;

  case 1738:
#line 10512 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("fetch"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("with ties"));
}
#line 48424 "preproc.c" /* yacc.c:1652  */
    break;

  case 1739:
#line 10516 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("fetch"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("only"));
}
#line 48432 "preproc.c" /* yacc.c:1652  */
    break;

  case 1740:
#line 10520 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("fetch"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("with ties"));
}
#line 48440 "preproc.c" /* yacc.c:1652  */
    break;

  case 1741:
#line 10528 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("offset"),(yyvsp[0].str));
}
#line 48448 "preproc.c" /* yacc.c:1652  */
    break;

  case 1742:
#line 10532 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("offset"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48456 "preproc.c" /* yacc.c:1652  */
    break;

  case 1743:
#line 10540 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48464 "preproc.c" /* yacc.c:1652  */
    break;

  case 1744:
#line 10544 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 48472 "preproc.c" /* yacc.c:1652  */
    break;

  case 1745:
#line 10552 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48480 "preproc.c" /* yacc.c:1652  */
    break;

  case 1746:
#line 10560 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48488 "preproc.c" /* yacc.c:1652  */
    break;

  case 1747:
#line 10564 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 48496 "preproc.c" /* yacc.c:1652  */
    break;

  case 1748:
#line 10568 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 48504 "preproc.c" /* yacc.c:1652  */
    break;

  case 1749:
#line 10576 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48512 "preproc.c" /* yacc.c:1652  */
    break;

  case 1750:
#line 10580 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48520 "preproc.c" /* yacc.c:1652  */
    break;

  case 1751:
#line 10588 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row");
}
#line 48528 "preproc.c" /* yacc.c:1652  */
    break;

  case 1752:
#line 10592 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rows");
}
#line 48536 "preproc.c" /* yacc.c:1652  */
    break;

  case 1753:
#line 10600 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("first");
}
#line 48544 "preproc.c" /* yacc.c:1652  */
    break;

  case 1754:
#line 10604 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("next");
}
#line 48552 "preproc.c" /* yacc.c:1652  */
    break;

  case 1755:
#line 10612 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("group by"),(yyvsp[0].str));
}
#line 48560 "preproc.c" /* yacc.c:1652  */
    break;

  case 1756:
#line 10616 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48567 "preproc.c" /* yacc.c:1652  */
    break;

  case 1757:
#line 10623 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48575 "preproc.c" /* yacc.c:1652  */
    break;

  case 1758:
#line 10627 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48583 "preproc.c" /* yacc.c:1652  */
    break;

  case 1759:
#line 10635 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48591 "preproc.c" /* yacc.c:1652  */
    break;

  case 1760:
#line 10639 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48599 "preproc.c" /* yacc.c:1652  */
    break;

  case 1761:
#line 10643 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48607 "preproc.c" /* yacc.c:1652  */
    break;

  case 1762:
#line 10647 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48615 "preproc.c" /* yacc.c:1652  */
    break;

  case 1763:
#line 10651 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48623 "preproc.c" /* yacc.c:1652  */
    break;

  case 1764:
#line 10659 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("( )");
}
#line 48631 "preproc.c" /* yacc.c:1652  */
    break;

  case 1765:
#line 10667 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("rollup ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48639 "preproc.c" /* yacc.c:1652  */
    break;

  case 1766:
#line 10675 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("cube ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48647 "preproc.c" /* yacc.c:1652  */
    break;

  case 1767:
#line 10683 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("grouping sets ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48655 "preproc.c" /* yacc.c:1652  */
    break;

  case 1768:
#line 10691 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("having"),(yyvsp[0].str));
}
#line 48663 "preproc.c" /* yacc.c:1652  */
    break;

  case 1769:
#line 10695 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48670 "preproc.c" /* yacc.c:1652  */
    break;

  case 1770:
#line 10702 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48678 "preproc.c" /* yacc.c:1652  */
    break;

  case 1771:
#line 10706 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for read only");
}
#line 48686 "preproc.c" /* yacc.c:1652  */
    break;

  case 1772:
#line 10714 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48694 "preproc.c" /* yacc.c:1652  */
    break;

  case 1773:
#line 10718 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48701 "preproc.c" /* yacc.c:1652  */
    break;

  case 1774:
#line 10725 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48709 "preproc.c" /* yacc.c:1652  */
    break;

  case 1775:
#line 10729 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48717 "preproc.c" /* yacc.c:1652  */
    break;

  case 1776:
#line 10737 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48725 "preproc.c" /* yacc.c:1652  */
    break;

  case 1777:
#line 10745 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for update");
}
#line 48733 "preproc.c" /* yacc.c:1652  */
    break;

  case 1778:
#line 10749 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for no key update");
}
#line 48741 "preproc.c" /* yacc.c:1652  */
    break;

  case 1779:
#line 10753 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for share");
}
#line 48749 "preproc.c" /* yacc.c:1652  */
    break;

  case 1780:
#line 10757 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for key share");
}
#line 48757 "preproc.c" /* yacc.c:1652  */
    break;

  case 1781:
#line 10765 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("of"),(yyvsp[0].str));
}
#line 48765 "preproc.c" /* yacc.c:1652  */
    break;

  case 1782:
#line 10769 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48772 "preproc.c" /* yacc.c:1652  */
    break;

  case 1783:
#line 10776 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("values ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48780 "preproc.c" /* yacc.c:1652  */
    break;

  case 1784:
#line 10780 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup(", ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48788 "preproc.c" /* yacc.c:1652  */
    break;

  case 1785:
#line 10788 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 48796 "preproc.c" /* yacc.c:1652  */
    break;

  case 1786:
#line 10792 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 48803 "preproc.c" /* yacc.c:1652  */
    break;

  case 1787:
#line 10799 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48811 "preproc.c" /* yacc.c:1652  */
    break;

  case 1788:
#line 10803 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48819 "preproc.c" /* yacc.c:1652  */
    break;

  case 1789:
#line 10811 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48827 "preproc.c" /* yacc.c:1652  */
    break;

  case 1790:
#line 10815 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48835 "preproc.c" /* yacc.c:1652  */
    break;

  case 1791:
#line 10819 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48843 "preproc.c" /* yacc.c:1652  */
    break;

  case 1792:
#line 10823 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("lateral"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48851 "preproc.c" /* yacc.c:1652  */
    break;

  case 1793:
#line 10827 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48859 "preproc.c" /* yacc.c:1652  */
    break;

  case 1794:
#line 10831 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("lateral"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48867 "preproc.c" /* yacc.c:1652  */
    break;

  case 1795:
#line 10835 "preproc.y" /* yacc.c:1652  */
    { 
	if ((yyvsp[0].str) == NULL)
		mmerror(PARSE_ERROR, ET_ERROR, "subquery in FROM must have an alias");

 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48878 "preproc.c" /* yacc.c:1652  */
    break;

  case 1796:
#line 10842 "preproc.y" /* yacc.c:1652  */
    { 
	if ((yyvsp[0].str) == NULL)
		mmerror(PARSE_ERROR, ET_ERROR, "subquery in FROM must have an alias");

 (yyval.str) = cat_str(3,mm_strdup("lateral"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48889 "preproc.c" /* yacc.c:1652  */
    break;

  case 1797:
#line 10849 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48897 "preproc.c" /* yacc.c:1652  */
    break;

  case 1798:
#line 10853 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 48905 "preproc.c" /* yacc.c:1652  */
    break;

  case 1799:
#line 10861 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48913 "preproc.c" /* yacc.c:1652  */
    break;

  case 1800:
#line 10865 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("cross join"),(yyvsp[0].str));
}
#line 48921 "preproc.c" /* yacc.c:1652  */
    break;

  case 1801:
#line 10869 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("join"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48929 "preproc.c" /* yacc.c:1652  */
    break;

  case 1802:
#line 10873 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("join"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48937 "preproc.c" /* yacc.c:1652  */
    break;

  case 1803:
#line 10877 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("natural"),(yyvsp[-2].str),mm_strdup("join"),(yyvsp[0].str));
}
#line 48945 "preproc.c" /* yacc.c:1652  */
    break;

  case 1804:
#line 10881 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("natural join"),(yyvsp[0].str));
}
#line 48953 "preproc.c" /* yacc.c:1652  */
    break;

  case 1805:
#line 10889 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("as"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48961 "preproc.c" /* yacc.c:1652  */
    break;

  case 1806:
#line 10893 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 48969 "preproc.c" /* yacc.c:1652  */
    break;

  case 1807:
#line 10897 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48977 "preproc.c" /* yacc.c:1652  */
    break;

  case 1808:
#line 10901 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48985 "preproc.c" /* yacc.c:1652  */
    break;

  case 1809:
#line 10909 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48993 "preproc.c" /* yacc.c:1652  */
    break;

  case 1810:
#line 10913 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49000 "preproc.c" /* yacc.c:1652  */
    break;

  case 1811:
#line 10920 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49008 "preproc.c" /* yacc.c:1652  */
    break;

  case 1812:
#line 10924 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49016 "preproc.c" /* yacc.c:1652  */
    break;

  case 1813:
#line 10928 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("as"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49024 "preproc.c" /* yacc.c:1652  */
    break;

  case 1814:
#line 10932 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49032 "preproc.c" /* yacc.c:1652  */
    break;

  case 1815:
#line 10936 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49039 "preproc.c" /* yacc.c:1652  */
    break;

  case 1816:
#line 10943 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("full"),(yyvsp[0].str));
}
#line 49047 "preproc.c" /* yacc.c:1652  */
    break;

  case 1817:
#line 10947 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("left"),(yyvsp[0].str));
}
#line 49055 "preproc.c" /* yacc.c:1652  */
    break;

  case 1818:
#line 10951 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("right"),(yyvsp[0].str));
}
#line 49063 "preproc.c" /* yacc.c:1652  */
    break;

  case 1819:
#line 10955 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inner");
}
#line 49071 "preproc.c" /* yacc.c:1652  */
    break;

  case 1820:
#line 10963 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("outer");
}
#line 49079 "preproc.c" /* yacc.c:1652  */
    break;

  case 1821:
#line 10967 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49086 "preproc.c" /* yacc.c:1652  */
    break;

  case 1822:
#line 10974 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("using ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49094 "preproc.c" /* yacc.c:1652  */
    break;

  case 1823:
#line 10978 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("on"),(yyvsp[0].str));
}
#line 49102 "preproc.c" /* yacc.c:1652  */
    break;

  case 1824:
#line 10986 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49110 "preproc.c" /* yacc.c:1652  */
    break;

  case 1825:
#line 10990 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("*"));
}
#line 49118 "preproc.c" /* yacc.c:1652  */
    break;

  case 1826:
#line 10994 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("only"),(yyvsp[0].str));
}
#line 49126 "preproc.c" /* yacc.c:1652  */
    break;

  case 1827:
#line 10998 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("only ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49134 "preproc.c" /* yacc.c:1652  */
    break;

  case 1828:
#line 11006 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49142 "preproc.c" /* yacc.c:1652  */
    break;

  case 1829:
#line 11010 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 49150 "preproc.c" /* yacc.c:1652  */
    break;

  case 1830:
#line 11018 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49158 "preproc.c" /* yacc.c:1652  */
    break;

  case 1831:
#line 11022 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49166 "preproc.c" /* yacc.c:1652  */
    break;

  case 1832:
#line 11026 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 49174 "preproc.c" /* yacc.c:1652  */
    break;

  case 1833:
#line 11034 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("tablesample"),(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 49182 "preproc.c" /* yacc.c:1652  */
    break;

  case 1834:
#line 11042 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("repeatable ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49190 "preproc.c" /* yacc.c:1652  */
    break;

  case 1835:
#line 11046 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49197 "preproc.c" /* yacc.c:1652  */
    break;

  case 1836:
#line 11053 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49205 "preproc.c" /* yacc.c:1652  */
    break;

  case 1837:
#line 11057 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("rows from ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 49213 "preproc.c" /* yacc.c:1652  */
    break;

  case 1838:
#line 11065 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49221 "preproc.c" /* yacc.c:1652  */
    break;

  case 1839:
#line 11073 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49229 "preproc.c" /* yacc.c:1652  */
    break;

  case 1840:
#line 11077 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 49237 "preproc.c" /* yacc.c:1652  */
    break;

  case 1841:
#line 11085 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49245 "preproc.c" /* yacc.c:1652  */
    break;

  case 1842:
#line 11089 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49252 "preproc.c" /* yacc.c:1652  */
    break;

  case 1843:
#line 11096 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with ordinality");
}
#line 49260 "preproc.c" /* yacc.c:1652  */
    break;

  case 1844:
#line 11100 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49267 "preproc.c" /* yacc.c:1652  */
    break;

  case 1845:
#line 11107 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("where"),(yyvsp[0].str));
}
#line 49275 "preproc.c" /* yacc.c:1652  */
    break;

  case 1846:
#line 11111 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49282 "preproc.c" /* yacc.c:1652  */
    break;

  case 1847:
#line 11118 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("where"),(yyvsp[0].str));
}
#line 49290 "preproc.c" /* yacc.c:1652  */
    break;

  case 1848:
#line 11122 "preproc.y" /* yacc.c:1652  */
    {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		(yyval.str) = cat_str(2,mm_strdup("where current of"), cursor_marker);
	}
#line 49299 "preproc.c" /* yacc.c:1652  */
    break;

  case 1849:
#line 11127 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49306 "preproc.c" /* yacc.c:1652  */
    break;

  case 1850:
#line 11134 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49314 "preproc.c" /* yacc.c:1652  */
    break;

  case 1851:
#line 11138 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49321 "preproc.c" /* yacc.c:1652  */
    break;

  case 1852:
#line 11145 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49329 "preproc.c" /* yacc.c:1652  */
    break;

  case 1853:
#line 11149 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 49337 "preproc.c" /* yacc.c:1652  */
    break;

  case 1854:
#line 11157 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49345 "preproc.c" /* yacc.c:1652  */
    break;

  case 1855:
#line 11165 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("xmltable ("),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("columns"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49353 "preproc.c" /* yacc.c:1652  */
    break;

  case 1856:
#line 11169 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(8,mm_strdup("xmltable ( xmlnamespaces ("),(yyvsp[-7].str),mm_strdup(") ,"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("columns"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49361 "preproc.c" /* yacc.c:1652  */
    break;

  case 1857:
#line 11177 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49369 "preproc.c" /* yacc.c:1652  */
    break;

  case 1858:
#line 11181 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 49377 "preproc.c" /* yacc.c:1652  */
    break;

  case 1859:
#line 11189 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49385 "preproc.c" /* yacc.c:1652  */
    break;

  case 1860:
#line 11193 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49393 "preproc.c" /* yacc.c:1652  */
    break;

  case 1861:
#line 11197 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("for ordinality"));
}
#line 49401 "preproc.c" /* yacc.c:1652  */
    break;

  case 1862:
#line 11205 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49409 "preproc.c" /* yacc.c:1652  */
    break;

  case 1863:
#line 11209 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49417 "preproc.c" /* yacc.c:1652  */
    break;

  case 1864:
#line 11217 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49425 "preproc.c" /* yacc.c:1652  */
    break;

  case 1865:
#line 11221 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("default"),(yyvsp[0].str));
}
#line 49433 "preproc.c" /* yacc.c:1652  */
    break;

  case 1866:
#line 11225 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not null");
}
#line 49441 "preproc.c" /* yacc.c:1652  */
    break;

  case 1867:
#line 11229 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("null");
}
#line 49449 "preproc.c" /* yacc.c:1652  */
    break;

  case 1868:
#line 11237 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49457 "preproc.c" /* yacc.c:1652  */
    break;

  case 1869:
#line 11241 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 49465 "preproc.c" /* yacc.c:1652  */
    break;

  case 1870:
#line 11249 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 49473 "preproc.c" /* yacc.c:1652  */
    break;

  case 1871:
#line 11253 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("default"),(yyvsp[0].str));
}
#line 49481 "preproc.c" /* yacc.c:1652  */
    break;

  case 1872:
#line 11261 "preproc.y" /* yacc.c:1652  */
    {	(yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].index).str); }
#line 49487 "preproc.c" /* yacc.c:1652  */
    break;

  case 1873:
#line 11263 "preproc.y" /* yacc.c:1652  */
    {	(yyval.str) = cat_str(3, mm_strdup("setof"), (yyvsp[-1].str), (yyvsp[0].index).str); }
#line 49493 "preproc.c" /* yacc.c:1652  */
    break;

  case 1874:
#line 11265 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup("array ["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 49501 "preproc.c" /* yacc.c:1652  */
    break;

  case 1875:
#line 11269 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("setof"),(yyvsp[-4].str),mm_strdup("array ["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 49509 "preproc.c" /* yacc.c:1652  */
    break;

  case 1876:
#line 11273 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("array"));
}
#line 49517 "preproc.c" /* yacc.c:1652  */
    break;

  case 1877:
#line 11277 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("setof"),(yyvsp[-1].str),mm_strdup("array"));
}
#line 49525 "preproc.c" /* yacc.c:1652  */
    break;

  case 1878:
#line 11285 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.index).index1 = (yyvsp[-2].index).index1;
		(yyval.index).index2 = (yyvsp[-2].index).index2;
		if (strcmp((yyval.index).index1, "-1") == 0)
			(yyval.index).index1 = mm_strdup("0");
		else if (strcmp((yyvsp[-2].index).index2, "-1") == 0)
			(yyval.index).index2 = mm_strdup("0");
		(yyval.index).str = cat_str(2, (yyvsp[-2].index).str, mm_strdup("[]"));
	}
#line 49539 "preproc.c" /* yacc.c:1652  */
    break;

  case 1879:
#line 11295 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.index).index1 = (yyvsp[-3].index).index1;
		(yyval.index).index2 = (yyvsp[-3].index).index2;
		if (strcmp((yyvsp[-3].index).index1, "-1") == 0)
			(yyval.index).index1 = mm_strdup((yyvsp[-1].str));
		else if (strcmp((yyvsp[-3].index).index2, "-1") == 0)
			(yyval.index).index2 = mm_strdup((yyvsp[-1].str));
		(yyval.index).str = cat_str(4, (yyvsp[-3].index).str, mm_strdup("["), (yyvsp[-1].str), mm_strdup("]"));
	}
#line 49553 "preproc.c" /* yacc.c:1652  */
    break;

  case 1880:
#line 11305 "preproc.y" /* yacc.c:1652  */
    {
		(yyval.index).index1 = mm_strdup("-1");
		(yyval.index).index2 = mm_strdup("-1");
		(yyval.index).str= EMPTY;
	}
#line 49563 "preproc.c" /* yacc.c:1652  */
    break;

  case 1881:
#line 11315 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49571 "preproc.c" /* yacc.c:1652  */
    break;

  case 1882:
#line 11319 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49579 "preproc.c" /* yacc.c:1652  */
    break;

  case 1883:
#line 11323 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49587 "preproc.c" /* yacc.c:1652  */
    break;

  case 1884:
#line 11327 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49595 "preproc.c" /* yacc.c:1652  */
    break;

  case 1885:
#line 11331 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49603 "preproc.c" /* yacc.c:1652  */
    break;

  case 1886:
#line 11335 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49611 "preproc.c" /* yacc.c:1652  */
    break;

  case 1887:
#line 11339 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49619 "preproc.c" /* yacc.c:1652  */
    break;

  case 1888:
#line 11347 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49627 "preproc.c" /* yacc.c:1652  */
    break;

  case 1889:
#line 11351 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49635 "preproc.c" /* yacc.c:1652  */
    break;

  case 1890:
#line 11355 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49643 "preproc.c" /* yacc.c:1652  */
    break;

  case 1891:
#line 11359 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49651 "preproc.c" /* yacc.c:1652  */
    break;

  case 1892:
#line 11367 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49659 "preproc.c" /* yacc.c:1652  */
    break;

  case 1893:
#line 11371 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49667 "preproc.c" /* yacc.c:1652  */
    break;

  case 1894:
#line 11379 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49675 "preproc.c" /* yacc.c:1652  */
    break;

  case 1895:
#line 11383 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49682 "preproc.c" /* yacc.c:1652  */
    break;

  case 1896:
#line 11390 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("int");
}
#line 49690 "preproc.c" /* yacc.c:1652  */
    break;

  case 1897:
#line 11394 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("integer");
}
#line 49698 "preproc.c" /* yacc.c:1652  */
    break;

  case 1898:
#line 11398 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("smallint");
}
#line 49706 "preproc.c" /* yacc.c:1652  */
    break;

  case 1899:
#line 11402 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("bigint");
}
#line 49714 "preproc.c" /* yacc.c:1652  */
    break;

  case 1900:
#line 11406 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("real");
}
#line 49722 "preproc.c" /* yacc.c:1652  */
    break;

  case 1901:
#line 11410 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("float"),(yyvsp[0].str));
}
#line 49730 "preproc.c" /* yacc.c:1652  */
    break;

  case 1902:
#line 11414 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("double precision");
}
#line 49738 "preproc.c" /* yacc.c:1652  */
    break;

  case 1903:
#line 11418 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("decimal"),(yyvsp[0].str));
}
#line 49746 "preproc.c" /* yacc.c:1652  */
    break;

  case 1904:
#line 11422 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("dec"),(yyvsp[0].str));
}
#line 49754 "preproc.c" /* yacc.c:1652  */
    break;

  case 1905:
#line 11426 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("numeric"),(yyvsp[0].str));
}
#line 49762 "preproc.c" /* yacc.c:1652  */
    break;

  case 1906:
#line 11430 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("boolean");
}
#line 49770 "preproc.c" /* yacc.c:1652  */
    break;

  case 1907:
#line 11438 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49778 "preproc.c" /* yacc.c:1652  */
    break;

  case 1908:
#line 11442 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49785 "preproc.c" /* yacc.c:1652  */
    break;

  case 1909:
#line 11449 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49793 "preproc.c" /* yacc.c:1652  */
    break;

  case 1910:
#line 11453 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49801 "preproc.c" /* yacc.c:1652  */
    break;

  case 1911:
#line 11461 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49809 "preproc.c" /* yacc.c:1652  */
    break;

  case 1912:
#line 11465 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49817 "preproc.c" /* yacc.c:1652  */
    break;

  case 1913:
#line 11473 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("bit"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49825 "preproc.c" /* yacc.c:1652  */
    break;

  case 1914:
#line 11481 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("bit"),(yyvsp[0].str));
}
#line 49833 "preproc.c" /* yacc.c:1652  */
    break;

  case 1915:
#line 11489 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49841 "preproc.c" /* yacc.c:1652  */
    break;

  case 1916:
#line 11493 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49849 "preproc.c" /* yacc.c:1652  */
    break;

  case 1917:
#line 11501 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49857 "preproc.c" /* yacc.c:1652  */
    break;

  case 1918:
#line 11505 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49865 "preproc.c" /* yacc.c:1652  */
    break;

  case 1919:
#line 11513 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49873 "preproc.c" /* yacc.c:1652  */
    break;

  case 1920:
#line 11521 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49881 "preproc.c" /* yacc.c:1652  */
    break;

  case 1921:
#line 11529 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("character"),(yyvsp[0].str));
}
#line 49889 "preproc.c" /* yacc.c:1652  */
    break;

  case 1922:
#line 11533 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("char"),(yyvsp[0].str));
}
#line 49897 "preproc.c" /* yacc.c:1652  */
    break;

  case 1923:
#line 11537 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("varchar");
}
#line 49905 "preproc.c" /* yacc.c:1652  */
    break;

  case 1924:
#line 11541 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("national character"),(yyvsp[0].str));
}
#line 49913 "preproc.c" /* yacc.c:1652  */
    break;

  case 1925:
#line 11545 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("national char"),(yyvsp[0].str));
}
#line 49921 "preproc.c" /* yacc.c:1652  */
    break;

  case 1926:
#line 11549 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("nchar"),(yyvsp[0].str));
}
#line 49929 "preproc.c" /* yacc.c:1652  */
    break;

  case 1927:
#line 11557 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("varying");
}
#line 49937 "preproc.c" /* yacc.c:1652  */
    break;

  case 1928:
#line 11561 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 49944 "preproc.c" /* yacc.c:1652  */
    break;

  case 1929:
#line 11568 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("timestamp ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 49952 "preproc.c" /* yacc.c:1652  */
    break;

  case 1930:
#line 11572 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("timestamp"),(yyvsp[0].str));
}
#line 49960 "preproc.c" /* yacc.c:1652  */
    break;

  case 1931:
#line 11576 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("time ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 49968 "preproc.c" /* yacc.c:1652  */
    break;

  case 1932:
#line 11580 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("time"),(yyvsp[0].str));
}
#line 49976 "preproc.c" /* yacc.c:1652  */
    break;

  case 1933:
#line 11588 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("interval");
}
#line 49984 "preproc.c" /* yacc.c:1652  */
    break;

  case 1934:
#line 11596 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with time zone");
}
#line 49992 "preproc.c" /* yacc.c:1652  */
    break;

  case 1935:
#line 11600 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("without time zone");
}
#line 50000 "preproc.c" /* yacc.c:1652  */
    break;

  case 1936:
#line 11604 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 50007 "preproc.c" /* yacc.c:1652  */
    break;

  case 1937:
#line 11611 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("year");
}
#line 50015 "preproc.c" /* yacc.c:1652  */
    break;

  case 1938:
#line 11615 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("month");
}
#line 50023 "preproc.c" /* yacc.c:1652  */
    break;

  case 1939:
#line 11619 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("day");
}
#line 50031 "preproc.c" /* yacc.c:1652  */
    break;

  case 1940:
#line 11623 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("hour");
}
#line 50039 "preproc.c" /* yacc.c:1652  */
    break;

  case 1941:
#line 11627 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("minute");
}
#line 50047 "preproc.c" /* yacc.c:1652  */
    break;

  case 1942:
#line 11631 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50055 "preproc.c" /* yacc.c:1652  */
    break;

  case 1943:
#line 11635 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("year to month");
}
#line 50063 "preproc.c" /* yacc.c:1652  */
    break;

  case 1944:
#line 11639 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("day to hour");
}
#line 50071 "preproc.c" /* yacc.c:1652  */
    break;

  case 1945:
#line 11643 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("day to minute");
}
#line 50079 "preproc.c" /* yacc.c:1652  */
    break;

  case 1946:
#line 11647 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("day to"),(yyvsp[0].str));
}
#line 50087 "preproc.c" /* yacc.c:1652  */
    break;

  case 1947:
#line 11651 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("hour to minute");
}
#line 50095 "preproc.c" /* yacc.c:1652  */
    break;

  case 1948:
#line 11655 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("hour to"),(yyvsp[0].str));
}
#line 50103 "preproc.c" /* yacc.c:1652  */
    break;

  case 1949:
#line 11659 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("minute to"),(yyvsp[0].str));
}
#line 50111 "preproc.c" /* yacc.c:1652  */
    break;

  case 1950:
#line 11663 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 50118 "preproc.c" /* yacc.c:1652  */
    break;

  case 1951:
#line 11670 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("second");
}
#line 50126 "preproc.c" /* yacc.c:1652  */
    break;

  case 1952:
#line 11674 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("second ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50134 "preproc.c" /* yacc.c:1652  */
    break;

  case 1953:
#line 11682 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50142 "preproc.c" /* yacc.c:1652  */
    break;

  case 1954:
#line 11686 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("::"),(yyvsp[0].str));
}
#line 50150 "preproc.c" /* yacc.c:1652  */
    break;

  case 1955:
#line 11690 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("collate"),(yyvsp[0].str));
}
#line 50158 "preproc.c" /* yacc.c:1652  */
    break;

  case 1956:
#line 11694 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("at time zone"),(yyvsp[0].str));
}
#line 50166 "preproc.c" /* yacc.c:1652  */
    break;

  case 1957:
#line 11698 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 50174 "preproc.c" /* yacc.c:1652  */
    break;

  case 1958:
#line 11702 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 50182 "preproc.c" /* yacc.c:1652  */
    break;

  case 1959:
#line 11706 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("+"),(yyvsp[0].str));
}
#line 50190 "preproc.c" /* yacc.c:1652  */
    break;

  case 1960:
#line 11710 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("-"),(yyvsp[0].str));
}
#line 50198 "preproc.c" /* yacc.c:1652  */
    break;

  case 1961:
#line 11714 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("*"),(yyvsp[0].str));
}
#line 50206 "preproc.c" /* yacc.c:1652  */
    break;

  case 1962:
#line 11718 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("/"),(yyvsp[0].str));
}
#line 50214 "preproc.c" /* yacc.c:1652  */
    break;

  case 1963:
#line 11722 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("%"),(yyvsp[0].str));
}
#line 50222 "preproc.c" /* yacc.c:1652  */
    break;

  case 1964:
#line 11726 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("^"),(yyvsp[0].str));
}
#line 50230 "preproc.c" /* yacc.c:1652  */
    break;

  case 1965:
#line 11730 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<"),(yyvsp[0].str));
}
#line 50238 "preproc.c" /* yacc.c:1652  */
    break;

  case 1966:
#line 11734 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">"),(yyvsp[0].str));
}
#line 50246 "preproc.c" /* yacc.c:1652  */
    break;

  case 1967:
#line 11738 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 50254 "preproc.c" /* yacc.c:1652  */
    break;

  case 1968:
#line 11742 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<="),(yyvsp[0].str));
}
#line 50262 "preproc.c" /* yacc.c:1652  */
    break;

  case 1969:
#line 11746 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">="),(yyvsp[0].str));
}
#line 50270 "preproc.c" /* yacc.c:1652  */
    break;

  case 1970:
#line 11750 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<>"),(yyvsp[0].str));
}
#line 50278 "preproc.c" /* yacc.c:1652  */
    break;

  case 1971:
#line 11754 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50286 "preproc.c" /* yacc.c:1652  */
    break;

  case 1972:
#line 11758 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50294 "preproc.c" /* yacc.c:1652  */
    break;

  case 1973:
#line 11762 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50302 "preproc.c" /* yacc.c:1652  */
    break;

  case 1974:
#line 11766 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 50310 "preproc.c" /* yacc.c:1652  */
    break;

  case 1975:
#line 11770 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("or"),(yyvsp[0].str));
}
#line 50318 "preproc.c" /* yacc.c:1652  */
    break;

  case 1976:
#line 11774 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("not"),(yyvsp[0].str));
}
#line 50326 "preproc.c" /* yacc.c:1652  */
    break;

  case 1977:
#line 11778 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("not"),(yyvsp[0].str));
}
#line 50334 "preproc.c" /* yacc.c:1652  */
    break;

  case 1978:
#line 11782 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("like"),(yyvsp[0].str));
}
#line 50342 "preproc.c" /* yacc.c:1652  */
    break;

  case 1979:
#line 11786 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("like"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 50350 "preproc.c" /* yacc.c:1652  */
    break;

  case 1980:
#line 11790 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not like"),(yyvsp[0].str));
}
#line 50358 "preproc.c" /* yacc.c:1652  */
    break;

  case 1981:
#line 11794 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("not like"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 50366 "preproc.c" /* yacc.c:1652  */
    break;

  case 1982:
#line 11798 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("ilike"),(yyvsp[0].str));
}
#line 50374 "preproc.c" /* yacc.c:1652  */
    break;

  case 1983:
#line 11802 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("ilike"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 50382 "preproc.c" /* yacc.c:1652  */
    break;

  case 1984:
#line 11806 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not ilike"),(yyvsp[0].str));
}
#line 50390 "preproc.c" /* yacc.c:1652  */
    break;

  case 1985:
#line 11810 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("not ilike"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 50398 "preproc.c" /* yacc.c:1652  */
    break;

  case 1986:
#line 11814 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("similar to"),(yyvsp[0].str));
}
#line 50406 "preproc.c" /* yacc.c:1652  */
    break;

  case 1987:
#line 11818 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("similar to"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 50414 "preproc.c" /* yacc.c:1652  */
    break;

  case 1988:
#line 11822 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("not similar to"),(yyvsp[0].str));
}
#line 50422 "preproc.c" /* yacc.c:1652  */
    break;

  case 1989:
#line 11826 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-6].str),mm_strdup("not similar to"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 50430 "preproc.c" /* yacc.c:1652  */
    break;

  case 1990:
#line 11830 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is null"));
}
#line 50438 "preproc.c" /* yacc.c:1652  */
    break;

  case 1991:
#line 11834 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("isnull"));
}
#line 50446 "preproc.c" /* yacc.c:1652  */
    break;

  case 1992:
#line 11838 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not null"));
}
#line 50454 "preproc.c" /* yacc.c:1652  */
    break;

  case 1993:
#line 11842 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("notnull"));
}
#line 50462 "preproc.c" /* yacc.c:1652  */
    break;

  case 1994:
#line 11846 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("overlaps"),(yyvsp[0].str));
}
#line 50470 "preproc.c" /* yacc.c:1652  */
    break;

  case 1995:
#line 11850 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is true"));
}
#line 50478 "preproc.c" /* yacc.c:1652  */
    break;

  case 1996:
#line 11854 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not true"));
}
#line 50486 "preproc.c" /* yacc.c:1652  */
    break;

  case 1997:
#line 11858 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is false"));
}
#line 50494 "preproc.c" /* yacc.c:1652  */
    break;

  case 1998:
#line 11862 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not false"));
}
#line 50502 "preproc.c" /* yacc.c:1652  */
    break;

  case 1999:
#line 11866 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is unknown"));
}
#line 50510 "preproc.c" /* yacc.c:1652  */
    break;

  case 2000:
#line 11870 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not unknown"));
}
#line 50518 "preproc.c" /* yacc.c:1652  */
    break;

  case 2001:
#line 11874 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("is distinct from"),(yyvsp[0].str));
}
#line 50526 "preproc.c" /* yacc.c:1652  */
    break;

  case 2002:
#line 11878 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-5].str),mm_strdup("is not distinct from"),(yyvsp[0].str));
}
#line 50534 "preproc.c" /* yacc.c:1652  */
    break;

  case 2003:
#line 11882 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("is of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50542 "preproc.c" /* yacc.c:1652  */
    break;

  case 2004:
#line 11886 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-6].str),mm_strdup("is not of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50550 "preproc.c" /* yacc.c:1652  */
    break;

  case 2005:
#line 11890 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),mm_strdup("between"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 50558 "preproc.c" /* yacc.c:1652  */
    break;

  case 2006:
#line 11894 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-6].str),mm_strdup("not between"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 50566 "preproc.c" /* yacc.c:1652  */
    break;

  case 2007:
#line 11898 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("between symmetric"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 50574 "preproc.c" /* yacc.c:1652  */
    break;

  case 2008:
#line 11902 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-6].str),mm_strdup("not between symmetric"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 50582 "preproc.c" /* yacc.c:1652  */
    break;

  case 2009:
#line 11906 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("in"),(yyvsp[0].str));
}
#line 50590 "preproc.c" /* yacc.c:1652  */
    break;

  case 2010:
#line 11910 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not in"),(yyvsp[0].str));
}
#line 50598 "preproc.c" /* yacc.c:1652  */
    break;

  case 2011:
#line 11914 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50606 "preproc.c" /* yacc.c:1652  */
    break;

  case 2012:
#line 11918 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50614 "preproc.c" /* yacc.c:1652  */
    break;

  case 2013:
#line 11922 "preproc.y" /* yacc.c:1652  */
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("unique"),(yyvsp[0].str));
}
#line 50623 "preproc.c" /* yacc.c:1652  */
    break;

  case 2014:
#line 11927 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is document"));
}
#line 50631 "preproc.c" /* yacc.c:1652  */
    break;

  case 2015:
#line 11931 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not document"));
}
#line 50639 "preproc.c" /* yacc.c:1652  */
    break;

  case 2016:
#line 11935 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is normalized"));
}
#line 50647 "preproc.c" /* yacc.c:1652  */
    break;

  case 2017:
#line 11939 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("is"),(yyvsp[-1].str),mm_strdup("normalized"));
}
#line 50655 "preproc.c" /* yacc.c:1652  */
    break;

  case 2018:
#line 11943 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not normalized"));
}
#line 50663 "preproc.c" /* yacc.c:1652  */
    break;

  case 2019:
#line 11947 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup("is not"),(yyvsp[-1].str),mm_strdup("normalized"));
}
#line 50671 "preproc.c" /* yacc.c:1652  */
    break;

  case 2020:
#line 11951 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 50679 "preproc.c" /* yacc.c:1652  */
    break;

  case 2021:
#line 11959 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50687 "preproc.c" /* yacc.c:1652  */
    break;

  case 2022:
#line 11963 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("::"),(yyvsp[0].str));
}
#line 50695 "preproc.c" /* yacc.c:1652  */
    break;

  case 2023:
#line 11967 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 50703 "preproc.c" /* yacc.c:1652  */
    break;

  case 2024:
#line 11971 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 50711 "preproc.c" /* yacc.c:1652  */
    break;

  case 2025:
#line 11975 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("+"),(yyvsp[0].str));
}
#line 50719 "preproc.c" /* yacc.c:1652  */
    break;

  case 2026:
#line 11979 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("-"),(yyvsp[0].str));
}
#line 50727 "preproc.c" /* yacc.c:1652  */
    break;

  case 2027:
#line 11983 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("*"),(yyvsp[0].str));
}
#line 50735 "preproc.c" /* yacc.c:1652  */
    break;

  case 2028:
#line 11987 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("/"),(yyvsp[0].str));
}
#line 50743 "preproc.c" /* yacc.c:1652  */
    break;

  case 2029:
#line 11991 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("%"),(yyvsp[0].str));
}
#line 50751 "preproc.c" /* yacc.c:1652  */
    break;

  case 2030:
#line 11995 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("^"),(yyvsp[0].str));
}
#line 50759 "preproc.c" /* yacc.c:1652  */
    break;

  case 2031:
#line 11999 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<"),(yyvsp[0].str));
}
#line 50767 "preproc.c" /* yacc.c:1652  */
    break;

  case 2032:
#line 12003 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">"),(yyvsp[0].str));
}
#line 50775 "preproc.c" /* yacc.c:1652  */
    break;

  case 2033:
#line 12007 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 50783 "preproc.c" /* yacc.c:1652  */
    break;

  case 2034:
#line 12011 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<="),(yyvsp[0].str));
}
#line 50791 "preproc.c" /* yacc.c:1652  */
    break;

  case 2035:
#line 12015 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">="),(yyvsp[0].str));
}
#line 50799 "preproc.c" /* yacc.c:1652  */
    break;

  case 2036:
#line 12019 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<>"),(yyvsp[0].str));
}
#line 50807 "preproc.c" /* yacc.c:1652  */
    break;

  case 2037:
#line 12023 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50815 "preproc.c" /* yacc.c:1652  */
    break;

  case 2038:
#line 12027 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50823 "preproc.c" /* yacc.c:1652  */
    break;

  case 2039:
#line 12031 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50831 "preproc.c" /* yacc.c:1652  */
    break;

  case 2040:
#line 12035 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("is distinct from"),(yyvsp[0].str));
}
#line 50839 "preproc.c" /* yacc.c:1652  */
    break;

  case 2041:
#line 12039 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-5].str),mm_strdup("is not distinct from"),(yyvsp[0].str));
}
#line 50847 "preproc.c" /* yacc.c:1652  */
    break;

  case 2042:
#line 12043 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("is of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50855 "preproc.c" /* yacc.c:1652  */
    break;

  case 2043:
#line 12047 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-6].str),mm_strdup("is not of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50863 "preproc.c" /* yacc.c:1652  */
    break;

  case 2044:
#line 12051 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is document"));
}
#line 50871 "preproc.c" /* yacc.c:1652  */
    break;

  case 2045:
#line 12055 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not document"));
}
#line 50879 "preproc.c" /* yacc.c:1652  */
    break;

  case 2046:
#line 12063 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50887 "preproc.c" /* yacc.c:1652  */
    break;

  case 2047:
#line 12067 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50895 "preproc.c" /* yacc.c:1652  */
    break;

  case 2048:
#line 12071 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50903 "preproc.c" /* yacc.c:1652  */
    break;

  case 2049:
#line 12075 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 50911 "preproc.c" /* yacc.c:1652  */
    break;

  case 2050:
#line 12079 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50919 "preproc.c" /* yacc.c:1652  */
    break;

  case 2051:
#line 12083 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50927 "preproc.c" /* yacc.c:1652  */
    break;

  case 2052:
#line 12087 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50935 "preproc.c" /* yacc.c:1652  */
    break;

  case 2053:
#line 12091 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50943 "preproc.c" /* yacc.c:1652  */
    break;

  case 2054:
#line 12095 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("exists"),(yyvsp[0].str));
}
#line 50951 "preproc.c" /* yacc.c:1652  */
    break;

  case 2055:
#line 12099 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("array"),(yyvsp[0].str));
}
#line 50959 "preproc.c" /* yacc.c:1652  */
    break;

  case 2056:
#line 12103 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("array"),(yyvsp[0].str));
}
#line 50967 "preproc.c" /* yacc.c:1652  */
    break;

  case 2057:
#line 12107 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50975 "preproc.c" /* yacc.c:1652  */
    break;

  case 2058:
#line 12111 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50983 "preproc.c" /* yacc.c:1652  */
    break;

  case 2059:
#line 12115 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("grouping ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50991 "preproc.c" /* yacc.c:1652  */
    break;

  case 2060:
#line 12123 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("( )"));
}
#line 50999 "preproc.c" /* yacc.c:1652  */
    break;

  case 2061:
#line 12127 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51007 "preproc.c" /* yacc.c:1652  */
    break;

  case 2062:
#line 12131 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( variadic"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51015 "preproc.c" /* yacc.c:1652  */
    break;

  case 2063:
#line 12135 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(", variadic"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51023 "preproc.c" /* yacc.c:1652  */
    break;

  case 2064:
#line 12139 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( all"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51031 "preproc.c" /* yacc.c:1652  */
    break;

  case 2065:
#line 12143 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( distinct"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51039 "preproc.c" /* yacc.c:1652  */
    break;

  case 2066:
#line 12147 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("( * )"));
}
#line 51047 "preproc.c" /* yacc.c:1652  */
    break;

  case 2067:
#line 12155 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51055 "preproc.c" /* yacc.c:1652  */
    break;

  case 2068:
#line 12159 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51063 "preproc.c" /* yacc.c:1652  */
    break;

  case 2069:
#line 12167 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51071 "preproc.c" /* yacc.c:1652  */
    break;

  case 2070:
#line 12171 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51079 "preproc.c" /* yacc.c:1652  */
    break;

  case 2071:
#line 12179 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("collation for ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51087 "preproc.c" /* yacc.c:1652  */
    break;

  case 2072:
#line 12183 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_date");
}
#line 51095 "preproc.c" /* yacc.c:1652  */
    break;

  case 2073:
#line 12187 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_time");
}
#line 51103 "preproc.c" /* yacc.c:1652  */
    break;

  case 2074:
#line 12191 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("current_time ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51111 "preproc.c" /* yacc.c:1652  */
    break;

  case 2075:
#line 12195 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_timestamp");
}
#line 51119 "preproc.c" /* yacc.c:1652  */
    break;

  case 2076:
#line 12199 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("current_timestamp ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51127 "preproc.c" /* yacc.c:1652  */
    break;

  case 2077:
#line 12203 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("localtime");
}
#line 51135 "preproc.c" /* yacc.c:1652  */
    break;

  case 2078:
#line 12207 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("localtime ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51143 "preproc.c" /* yacc.c:1652  */
    break;

  case 2079:
#line 12211 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("localtimestamp");
}
#line 51151 "preproc.c" /* yacc.c:1652  */
    break;

  case 2080:
#line 12215 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("localtimestamp ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51159 "preproc.c" /* yacc.c:1652  */
    break;

  case 2081:
#line 12219 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_role");
}
#line 51167 "preproc.c" /* yacc.c:1652  */
    break;

  case 2082:
#line 12223 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_user");
}
#line 51175 "preproc.c" /* yacc.c:1652  */
    break;

  case 2083:
#line 12227 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session_user");
}
#line 51183 "preproc.c" /* yacc.c:1652  */
    break;

  case 2084:
#line 12231 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("user");
}
#line 51191 "preproc.c" /* yacc.c:1652  */
    break;

  case 2085:
#line 12235 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_catalog");
}
#line 51199 "preproc.c" /* yacc.c:1652  */
    break;

  case 2086:
#line 12239 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_schema");
}
#line 51207 "preproc.c" /* yacc.c:1652  */
    break;

  case 2087:
#line 12243 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("cast ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51215 "preproc.c" /* yacc.c:1652  */
    break;

  case 2088:
#line 12247 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("extract ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51223 "preproc.c" /* yacc.c:1652  */
    break;

  case 2089:
#line 12251 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("normalize ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51231 "preproc.c" /* yacc.c:1652  */
    break;

  case 2090:
#line 12255 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("normalize ("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51239 "preproc.c" /* yacc.c:1652  */
    break;

  case 2091:
#line 12259 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("overlay ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51247 "preproc.c" /* yacc.c:1652  */
    break;

  case 2092:
#line 12263 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("position ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51255 "preproc.c" /* yacc.c:1652  */
    break;

  case 2093:
#line 12267 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("substring ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51263 "preproc.c" /* yacc.c:1652  */
    break;

  case 2094:
#line 12271 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("treat ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51271 "preproc.c" /* yacc.c:1652  */
    break;

  case 2095:
#line 12275 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( both"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51279 "preproc.c" /* yacc.c:1652  */
    break;

  case 2096:
#line 12279 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( leading"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51287 "preproc.c" /* yacc.c:1652  */
    break;

  case 2097:
#line 12283 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( trailing"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51295 "preproc.c" /* yacc.c:1652  */
    break;

  case 2098:
#line 12287 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("trim ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51303 "preproc.c" /* yacc.c:1652  */
    break;

  case 2099:
#line 12291 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("nullif ("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51311 "preproc.c" /* yacc.c:1652  */
    break;

  case 2100:
#line 12295 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("coalesce ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51319 "preproc.c" /* yacc.c:1652  */
    break;

  case 2101:
#line 12299 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("greatest ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51327 "preproc.c" /* yacc.c:1652  */
    break;

  case 2102:
#line 12303 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("least ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51335 "preproc.c" /* yacc.c:1652  */
    break;

  case 2103:
#line 12307 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("xmlconcat ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51343 "preproc.c" /* yacc.c:1652  */
    break;

  case 2104:
#line 12311 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("xmlelement ( name"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51351 "preproc.c" /* yacc.c:1652  */
    break;

  case 2105:
#line 12315 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("xmlelement ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51359 "preproc.c" /* yacc.c:1652  */
    break;

  case 2106:
#line 12319 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("xmlelement ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51367 "preproc.c" /* yacc.c:1652  */
    break;

  case 2107:
#line 12323 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(7,mm_strdup("xmlelement ( name"),(yyvsp[-5].str),mm_strdup(","),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51375 "preproc.c" /* yacc.c:1652  */
    break;

  case 2108:
#line 12327 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("xmlexists ("),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51383 "preproc.c" /* yacc.c:1652  */
    break;

  case 2109:
#line 12331 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("xmlforest ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51391 "preproc.c" /* yacc.c:1652  */
    break;

  case 2110:
#line 12335 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("xmlparse ("),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51399 "preproc.c" /* yacc.c:1652  */
    break;

  case 2111:
#line 12339 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("xmlpi ( name"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51407 "preproc.c" /* yacc.c:1652  */
    break;

  case 2112:
#line 12343 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("xmlpi ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51415 "preproc.c" /* yacc.c:1652  */
    break;

  case 2113:
#line 12347 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("xmlroot ("),(yyvsp[-4].str),mm_strdup(","),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51423 "preproc.c" /* yacc.c:1652  */
    break;

  case 2114:
#line 12351 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("xmlserialize ("),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51431 "preproc.c" /* yacc.c:1652  */
    break;

  case 2115:
#line 12359 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 51439 "preproc.c" /* yacc.c:1652  */
    break;

  case 2116:
#line 12363 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("version no value");
}
#line 51447 "preproc.c" /* yacc.c:1652  */
    break;

  case 2117:
#line 12371 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(", standalone yes");
}
#line 51455 "preproc.c" /* yacc.c:1652  */
    break;

  case 2118:
#line 12375 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(", standalone no");
}
#line 51463 "preproc.c" /* yacc.c:1652  */
    break;

  case 2119:
#line 12379 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(", standalone no value");
}
#line 51471 "preproc.c" /* yacc.c:1652  */
    break;

  case 2120:
#line 12383 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 51478 "preproc.c" /* yacc.c:1652  */
    break;

  case 2121:
#line 12390 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("xmlattributes ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51486 "preproc.c" /* yacc.c:1652  */
    break;

  case 2122:
#line 12398 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51494 "preproc.c" /* yacc.c:1652  */
    break;

  case 2123:
#line 12402 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 51502 "preproc.c" /* yacc.c:1652  */
    break;

  case 2124:
#line 12410 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 51510 "preproc.c" /* yacc.c:1652  */
    break;

  case 2125:
#line 12414 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51518 "preproc.c" /* yacc.c:1652  */
    break;

  case 2126:
#line 12422 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("document");
}
#line 51526 "preproc.c" /* yacc.c:1652  */
    break;

  case 2127:
#line 12426 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("content");
}
#line 51534 "preproc.c" /* yacc.c:1652  */
    break;

  case 2128:
#line 12434 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("preserve whitespace");
}
#line 51542 "preproc.c" /* yacc.c:1652  */
    break;

  case 2129:
#line 12438 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("strip whitespace");
}
#line 51550 "preproc.c" /* yacc.c:1652  */
    break;

  case 2130:
#line 12442 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 51557 "preproc.c" /* yacc.c:1652  */
    break;

  case 2131:
#line 12449 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("passing"),(yyvsp[0].str));
}
#line 51565 "preproc.c" /* yacc.c:1652  */
    break;

  case 2132:
#line 12453 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("passing"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51573 "preproc.c" /* yacc.c:1652  */
    break;

  case 2133:
#line 12457 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("passing"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51581 "preproc.c" /* yacc.c:1652  */
    break;

  case 2134:
#line 12461 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("passing"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51589 "preproc.c" /* yacc.c:1652  */
    break;

  case 2135:
#line 12469 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("by ref");
}
#line 51597 "preproc.c" /* yacc.c:1652  */
    break;

  case 2136:
#line 12473 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("by value");
}
#line 51605 "preproc.c" /* yacc.c:1652  */
    break;

  case 2137:
#line 12481 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("within group ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51613 "preproc.c" /* yacc.c:1652  */
    break;

  case 2138:
#line 12485 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 51620 "preproc.c" /* yacc.c:1652  */
    break;

  case 2139:
#line 12492 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("filter ( where"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51628 "preproc.c" /* yacc.c:1652  */
    break;

  case 2140:
#line 12496 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 51635 "preproc.c" /* yacc.c:1652  */
    break;

  case 2141:
#line 12503 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("window"),(yyvsp[0].str));
}
#line 51643 "preproc.c" /* yacc.c:1652  */
    break;

  case 2142:
#line 12507 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 51650 "preproc.c" /* yacc.c:1652  */
    break;

  case 2143:
#line 12514 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51658 "preproc.c" /* yacc.c:1652  */
    break;

  case 2144:
#line 12518 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 51666 "preproc.c" /* yacc.c:1652  */
    break;

  case 2145:
#line 12526 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 51674 "preproc.c" /* yacc.c:1652  */
    break;

  case 2146:
#line 12534 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("over"),(yyvsp[0].str));
}
#line 51682 "preproc.c" /* yacc.c:1652  */
    break;

  case 2147:
#line 12538 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("over"),(yyvsp[0].str));
}
#line 51690 "preproc.c" /* yacc.c:1652  */
    break;

  case 2148:
#line 12542 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 51697 "preproc.c" /* yacc.c:1652  */
    break;

  case 2149:
#line 12549 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,mm_strdup("("),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51705 "preproc.c" /* yacc.c:1652  */
    break;

  case 2150:
#line 12557 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51713 "preproc.c" /* yacc.c:1652  */
    break;

  case 2151:
#line 12561 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 51720 "preproc.c" /* yacc.c:1652  */
    break;

  case 2152:
#line 12568 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("partition by"),(yyvsp[0].str));
}
#line 51728 "preproc.c" /* yacc.c:1652  */
    break;

  case 2153:
#line 12572 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 51735 "preproc.c" /* yacc.c:1652  */
    break;

  case 2154:
#line 12579 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("range"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51743 "preproc.c" /* yacc.c:1652  */
    break;

  case 2155:
#line 12583 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("rows"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51751 "preproc.c" /* yacc.c:1652  */
    break;

  case 2156:
#line 12587 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("groups"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51759 "preproc.c" /* yacc.c:1652  */
    break;

  case 2157:
#line 12591 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 51766 "preproc.c" /* yacc.c:1652  */
    break;

  case 2158:
#line 12598 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51774 "preproc.c" /* yacc.c:1652  */
    break;

  case 2159:
#line 12602 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("between"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 51782 "preproc.c" /* yacc.c:1652  */
    break;

  case 2160:
#line 12610 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unbounded preceding");
}
#line 51790 "preproc.c" /* yacc.c:1652  */
    break;

  case 2161:
#line 12614 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unbounded following");
}
#line 51798 "preproc.c" /* yacc.c:1652  */
    break;

  case 2162:
#line 12618 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current row");
}
#line 51806 "preproc.c" /* yacc.c:1652  */
    break;

  case 2163:
#line 12622 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("preceding"));
}
#line 51814 "preproc.c" /* yacc.c:1652  */
    break;

  case 2164:
#line 12626 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("following"));
}
#line 51822 "preproc.c" /* yacc.c:1652  */
    break;

  case 2165:
#line 12634 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exclude current row");
}
#line 51830 "preproc.c" /* yacc.c:1652  */
    break;

  case 2166:
#line 12638 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exclude group");
}
#line 51838 "preproc.c" /* yacc.c:1652  */
    break;

  case 2167:
#line 12642 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exclude ties");
}
#line 51846 "preproc.c" /* yacc.c:1652  */
    break;

  case 2168:
#line 12646 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exclude no others");
}
#line 51854 "preproc.c" /* yacc.c:1652  */
    break;

  case 2169:
#line 12650 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 51861 "preproc.c" /* yacc.c:1652  */
    break;

  case 2170:
#line 12657 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("row ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51869 "preproc.c" /* yacc.c:1652  */
    break;

  case 2171:
#line 12661 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row ( )");
}
#line 51877 "preproc.c" /* yacc.c:1652  */
    break;

  case 2172:
#line 12665 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51885 "preproc.c" /* yacc.c:1652  */
    break;

  case 2173:
#line 12673 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("row ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51893 "preproc.c" /* yacc.c:1652  */
    break;

  case 2174:
#line 12677 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row ( )");
}
#line 51901 "preproc.c" /* yacc.c:1652  */
    break;

  case 2175:
#line 12685 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51909 "preproc.c" /* yacc.c:1652  */
    break;

  case 2176:
#line 12693 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("any");
}
#line 51917 "preproc.c" /* yacc.c:1652  */
    break;

  case 2177:
#line 12697 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("some");
}
#line 51925 "preproc.c" /* yacc.c:1652  */
    break;

  case 2178:
#line 12701 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 51933 "preproc.c" /* yacc.c:1652  */
    break;

  case 2179:
#line 12709 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51941 "preproc.c" /* yacc.c:1652  */
    break;

  case 2180:
#line 12713 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51949 "preproc.c" /* yacc.c:1652  */
    break;

  case 2181:
#line 12721 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("+");
}
#line 51957 "preproc.c" /* yacc.c:1652  */
    break;

  case 2182:
#line 12725 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("-");
}
#line 51965 "preproc.c" /* yacc.c:1652  */
    break;

  case 2183:
#line 12729 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("*");
}
#line 51973 "preproc.c" /* yacc.c:1652  */
    break;

  case 2184:
#line 12733 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("/");
}
#line 51981 "preproc.c" /* yacc.c:1652  */
    break;

  case 2185:
#line 12737 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("%");
}
#line 51989 "preproc.c" /* yacc.c:1652  */
    break;

  case 2186:
#line 12741 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("^");
}
#line 51997 "preproc.c" /* yacc.c:1652  */
    break;

  case 2187:
#line 12745 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("<");
}
#line 52005 "preproc.c" /* yacc.c:1652  */
    break;

  case 2188:
#line 12749 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(">");
}
#line 52013 "preproc.c" /* yacc.c:1652  */
    break;

  case 2189:
#line 12753 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("=");
}
#line 52021 "preproc.c" /* yacc.c:1652  */
    break;

  case 2190:
#line 12757 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("<=");
}
#line 52029 "preproc.c" /* yacc.c:1652  */
    break;

  case 2191:
#line 12761 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(">=");
}
#line 52037 "preproc.c" /* yacc.c:1652  */
    break;

  case 2192:
#line 12765 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("<>");
}
#line 52045 "preproc.c" /* yacc.c:1652  */
    break;

  case 2193:
#line 12773 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52053 "preproc.c" /* yacc.c:1652  */
    break;

  case 2194:
#line 12777 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52061 "preproc.c" /* yacc.c:1652  */
    break;

  case 2195:
#line 12785 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52069 "preproc.c" /* yacc.c:1652  */
    break;

  case 2196:
#line 12789 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52077 "preproc.c" /* yacc.c:1652  */
    break;

  case 2197:
#line 12797 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52085 "preproc.c" /* yacc.c:1652  */
    break;

  case 2198:
#line 12801 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52093 "preproc.c" /* yacc.c:1652  */
    break;

  case 2199:
#line 12805 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("like");
}
#line 52101 "preproc.c" /* yacc.c:1652  */
    break;

  case 2200:
#line 12809 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not like");
}
#line 52109 "preproc.c" /* yacc.c:1652  */
    break;

  case 2201:
#line 12813 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("ilike");
}
#line 52117 "preproc.c" /* yacc.c:1652  */
    break;

  case 2202:
#line 12817 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not ilike");
}
#line 52125 "preproc.c" /* yacc.c:1652  */
    break;

  case 2203:
#line 12825 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52133 "preproc.c" /* yacc.c:1652  */
    break;

  case 2204:
#line 12829 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52141 "preproc.c" /* yacc.c:1652  */
    break;

  case 2205:
#line 12837 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52149 "preproc.c" /* yacc.c:1652  */
    break;

  case 2206:
#line 12841 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52157 "preproc.c" /* yacc.c:1652  */
    break;

  case 2207:
#line 12849 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52165 "preproc.c" /* yacc.c:1652  */
    break;

  case 2208:
#line 12853 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(":="),(yyvsp[0].str));
}
#line 52173 "preproc.c" /* yacc.c:1652  */
    break;

  case 2209:
#line 12857 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("=>"),(yyvsp[0].str));
}
#line 52181 "preproc.c" /* yacc.c:1652  */
    break;

  case 2210:
#line 12865 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52189 "preproc.c" /* yacc.c:1652  */
    break;

  case 2211:
#line 12869 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52197 "preproc.c" /* yacc.c:1652  */
    break;

  case 2212:
#line 12877 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 52205 "preproc.c" /* yacc.c:1652  */
    break;

  case 2213:
#line 12881 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 52213 "preproc.c" /* yacc.c:1652  */
    break;

  case 2214:
#line 12885 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("[ ]");
}
#line 52221 "preproc.c" /* yacc.c:1652  */
    break;

  case 2215:
#line 12893 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52229 "preproc.c" /* yacc.c:1652  */
    break;

  case 2216:
#line 12897 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52237 "preproc.c" /* yacc.c:1652  */
    break;

  case 2217:
#line 12905 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 52245 "preproc.c" /* yacc.c:1652  */
    break;

  case 2218:
#line 12909 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 52252 "preproc.c" /* yacc.c:1652  */
    break;

  case 2219:
#line 12916 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52260 "preproc.c" /* yacc.c:1652  */
    break;

  case 2220:
#line 12920 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("year");
}
#line 52268 "preproc.c" /* yacc.c:1652  */
    break;

  case 2221:
#line 12924 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("month");
}
#line 52276 "preproc.c" /* yacc.c:1652  */
    break;

  case 2222:
#line 12928 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("day");
}
#line 52284 "preproc.c" /* yacc.c:1652  */
    break;

  case 2223:
#line 12932 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("hour");
}
#line 52292 "preproc.c" /* yacc.c:1652  */
    break;

  case 2224:
#line 12936 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("minute");
}
#line 52300 "preproc.c" /* yacc.c:1652  */
    break;

  case 2225:
#line 12940 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("second");
}
#line 52308 "preproc.c" /* yacc.c:1652  */
    break;

  case 2226:
#line 12944 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52316 "preproc.c" /* yacc.c:1652  */
    break;

  case 2227:
#line 12952 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nfc");
}
#line 52324 "preproc.c" /* yacc.c:1652  */
    break;

  case 2228:
#line 12956 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nfd");
}
#line 52332 "preproc.c" /* yacc.c:1652  */
    break;

  case 2229:
#line 12960 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nfkc");
}
#line 52340 "preproc.c" /* yacc.c:1652  */
    break;

  case 2230:
#line 12964 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nfkd");
}
#line 52348 "preproc.c" /* yacc.c:1652  */
    break;

  case 2231:
#line 12972 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52356 "preproc.c" /* yacc.c:1652  */
    break;

  case 2232:
#line 12976 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52364 "preproc.c" /* yacc.c:1652  */
    break;

  case 2233:
#line 12984 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("placing"),(yyvsp[0].str));
}
#line 52372 "preproc.c" /* yacc.c:1652  */
    break;

  case 2234:
#line 12992 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("in"),(yyvsp[0].str));
}
#line 52380 "preproc.c" /* yacc.c:1652  */
    break;

  case 2235:
#line 12996 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 52387 "preproc.c" /* yacc.c:1652  */
    break;

  case 2236:
#line 13003 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52395 "preproc.c" /* yacc.c:1652  */
    break;

  case 2237:
#line 13007 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52403 "preproc.c" /* yacc.c:1652  */
    break;

  case 2238:
#line 13011 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52411 "preproc.c" /* yacc.c:1652  */
    break;

  case 2239:
#line 13015 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52419 "preproc.c" /* yacc.c:1652  */
    break;

  case 2240:
#line 13019 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52427 "preproc.c" /* yacc.c:1652  */
    break;

  case 2241:
#line 13023 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 52434 "preproc.c" /* yacc.c:1652  */
    break;

  case 2242:
#line 13030 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 52442 "preproc.c" /* yacc.c:1652  */
    break;

  case 2243:
#line 13038 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 52450 "preproc.c" /* yacc.c:1652  */
    break;

  case 2244:
#line 13046 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 52458 "preproc.c" /* yacc.c:1652  */
    break;

  case 2245:
#line 13050 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 52466 "preproc.c" /* yacc.c:1652  */
    break;

  case 2246:
#line 13054 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52474 "preproc.c" /* yacc.c:1652  */
    break;

  case 2247:
#line 13062 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52482 "preproc.c" /* yacc.c:1652  */
    break;

  case 2248:
#line 13066 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52490 "preproc.c" /* yacc.c:1652  */
    break;

  case 2249:
#line 13074 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("case"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("end"));
}
#line 52498 "preproc.c" /* yacc.c:1652  */
    break;

  case 2250:
#line 13082 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52506 "preproc.c" /* yacc.c:1652  */
    break;

  case 2251:
#line 13086 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52514 "preproc.c" /* yacc.c:1652  */
    break;

  case 2252:
#line 13094 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(4,mm_strdup("when"),(yyvsp[-2].str),mm_strdup("then"),(yyvsp[0].str));
}
#line 52522 "preproc.c" /* yacc.c:1652  */
    break;

  case 2253:
#line 13102 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("else"),(yyvsp[0].str));
}
#line 52530 "preproc.c" /* yacc.c:1652  */
    break;

  case 2254:
#line 13106 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 52537 "preproc.c" /* yacc.c:1652  */
    break;

  case 2255:
#line 13113 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52545 "preproc.c" /* yacc.c:1652  */
    break;

  case 2256:
#line 13117 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 52552 "preproc.c" /* yacc.c:1652  */
    break;

  case 2257:
#line 13124 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52560 "preproc.c" /* yacc.c:1652  */
    break;

  case 2258:
#line 13128 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52568 "preproc.c" /* yacc.c:1652  */
    break;

  case 2259:
#line 13136 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("."),(yyvsp[0].str));
}
#line 52576 "preproc.c" /* yacc.c:1652  */
    break;

  case 2260:
#line 13140 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup(". *");
}
#line 52584 "preproc.c" /* yacc.c:1652  */
    break;

  case 2261:
#line 13144 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 52592 "preproc.c" /* yacc.c:1652  */
    break;

  case 2262:
#line 13148 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,mm_strdup("["),(yyvsp[-3].str),mm_strdup(":"),(yyvsp[-1].str),mm_strdup("]"));
}
#line 52600 "preproc.c" /* yacc.c:1652  */
    break;

  case 2263:
#line 13156 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52608 "preproc.c" /* yacc.c:1652  */
    break;

  case 2264:
#line 13160 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 52615 "preproc.c" /* yacc.c:1652  */
    break;

  case 2265:
#line 13167 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52623 "preproc.c" /* yacc.c:1652  */
    break;

  case 2266:
#line 13171 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52631 "preproc.c" /* yacc.c:1652  */
    break;

  case 2267:
#line 13179 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 52638 "preproc.c" /* yacc.c:1652  */
    break;

  case 2268:
#line 13182 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52646 "preproc.c" /* yacc.c:1652  */
    break;

  case 2269:
#line 13190 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("asymmetric");
}
#line 52654 "preproc.c" /* yacc.c:1652  */
    break;

  case 2270:
#line 13194 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 52661 "preproc.c" /* yacc.c:1652  */
    break;

  case 2271:
#line 13201 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52669 "preproc.c" /* yacc.c:1652  */
    break;

  case 2272:
#line 13205 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str)=EMPTY; }
#line 52676 "preproc.c" /* yacc.c:1652  */
    break;

  case 2273:
#line 13212 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52684 "preproc.c" /* yacc.c:1652  */
    break;

  case 2274:
#line 13216 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52692 "preproc.c" /* yacc.c:1652  */
    break;

  case 2275:
#line 13224 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 52700 "preproc.c" /* yacc.c:1652  */
    break;

  case 2276:
#line 13228 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52708 "preproc.c" /* yacc.c:1652  */
    break;

  case 2277:
#line 13232 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52716 "preproc.c" /* yacc.c:1652  */
    break;

  case 2278:
#line 13236 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("*");
}
#line 52724 "preproc.c" /* yacc.c:1652  */
    break;

  case 2279:
#line 13244 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52732 "preproc.c" /* yacc.c:1652  */
    break;

  case 2280:
#line 13248 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52740 "preproc.c" /* yacc.c:1652  */
    break;

  case 2281:
#line 13256 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52748 "preproc.c" /* yacc.c:1652  */
    break;

  case 2282:
#line 13260 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52756 "preproc.c" /* yacc.c:1652  */
    break;

  case 2283:
#line 13268 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52764 "preproc.c" /* yacc.c:1652  */
    break;

  case 2284:
#line 13272 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52772 "preproc.c" /* yacc.c:1652  */
    break;

  case 2285:
#line 13280 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52780 "preproc.c" /* yacc.c:1652  */
    break;

  case 2286:
#line 13288 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52788 "preproc.c" /* yacc.c:1652  */
    break;

  case 2287:
#line 13296 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52796 "preproc.c" /* yacc.c:1652  */
    break;

  case 2288:
#line 13304 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52804 "preproc.c" /* yacc.c:1652  */
    break;

  case 2289:
#line 13312 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52812 "preproc.c" /* yacc.c:1652  */
    break;

  case 2290:
#line 13320 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52820 "preproc.c" /* yacc.c:1652  */
    break;

  case 2291:
#line 13328 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52828 "preproc.c" /* yacc.c:1652  */
    break;

  case 2292:
#line 13332 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52836 "preproc.c" /* yacc.c:1652  */
    break;

  case 2293:
#line 13340 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52844 "preproc.c" /* yacc.c:1652  */
    break;

  case 2294:
#line 13344 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52852 "preproc.c" /* yacc.c:1652  */
    break;

  case 2295:
#line 13348 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52860 "preproc.c" /* yacc.c:1652  */
    break;

  case 2296:
#line 13352 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52868 "preproc.c" /* yacc.c:1652  */
    break;

  case 2297:
#line 13356 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52876 "preproc.c" /* yacc.c:1652  */
    break;

  case 2298:
#line 13360 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52884 "preproc.c" /* yacc.c:1652  */
    break;

  case 2299:
#line 13364 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),mm_strdup("("),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 52892 "preproc.c" /* yacc.c:1652  */
    break;

  case 2300:
#line 13368 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52900 "preproc.c" /* yacc.c:1652  */
    break;

  case 2301:
#line 13372 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52908 "preproc.c" /* yacc.c:1652  */
    break;

  case 2302:
#line 13376 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 52916 "preproc.c" /* yacc.c:1652  */
    break;

  case 2303:
#line 13380 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("true");
}
#line 52924 "preproc.c" /* yacc.c:1652  */
    break;

  case 2304:
#line 13384 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("false");
}
#line 52932 "preproc.c" /* yacc.c:1652  */
    break;

  case 2305:
#line 13388 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("null");
}
#line 52940 "preproc.c" /* yacc.c:1652  */
    break;

  case 2306:
#line 13391 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52946 "preproc.c" /* yacc.c:1652  */
    break;

  case 2307:
#line 13392 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52952 "preproc.c" /* yacc.c:1652  */
    break;

  case 2308:
#line 13398 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 52958 "preproc.c" /* yacc.c:1652  */
    break;

  case 2309:
#line 13404 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52966 "preproc.c" /* yacc.c:1652  */
    break;

  case 2310:
#line 13407 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52972 "preproc.c" /* yacc.c:1652  */
    break;

  case 2311:
#line 13409 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 52980 "preproc.c" /* yacc.c:1652  */
    break;

  case 2312:
#line 13413 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 52988 "preproc.c" /* yacc.c:1652  */
    break;

  case 2313:
#line 13421 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52996 "preproc.c" /* yacc.c:1652  */
    break;

  case 2314:
#line 13429 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53004 "preproc.c" /* yacc.c:1652  */
    break;

  case 2315:
#line 13433 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_user");
}
#line 53012 "preproc.c" /* yacc.c:1652  */
    break;

  case 2316:
#line 13437 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session_user");
}
#line 53020 "preproc.c" /* yacc.c:1652  */
    break;

  case 2317:
#line 13445 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53028 "preproc.c" /* yacc.c:1652  */
    break;

  case 2318:
#line 13449 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53036 "preproc.c" /* yacc.c:1652  */
    break;

  case 2319:
#line 13457 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53044 "preproc.c" /* yacc.c:1652  */
    break;

  case 2320:
#line 13461 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53052 "preproc.c" /* yacc.c:1652  */
    break;

  case 2321:
#line 13465 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53060 "preproc.c" /* yacc.c:1652  */
    break;

  case 2322:
#line 13469 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53068 "preproc.c" /* yacc.c:1652  */
    break;

  case 2323:
#line 13477 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("abort");
}
#line 53076 "preproc.c" /* yacc.c:1652  */
    break;

  case 2324:
#line 13481 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("absolute");
}
#line 53084 "preproc.c" /* yacc.c:1652  */
    break;

  case 2325:
#line 13485 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("access");
}
#line 53092 "preproc.c" /* yacc.c:1652  */
    break;

  case 2326:
#line 13489 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("action");
}
#line 53100 "preproc.c" /* yacc.c:1652  */
    break;

  case 2327:
#line 13493 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("add");
}
#line 53108 "preproc.c" /* yacc.c:1652  */
    break;

  case 2328:
#line 13497 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("admin");
}
#line 53116 "preproc.c" /* yacc.c:1652  */
    break;

  case 2329:
#line 13501 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("after");
}
#line 53124 "preproc.c" /* yacc.c:1652  */
    break;

  case 2330:
#line 13505 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("aggregate");
}
#line 53132 "preproc.c" /* yacc.c:1652  */
    break;

  case 2331:
#line 13509 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("also");
}
#line 53140 "preproc.c" /* yacc.c:1652  */
    break;

  case 2332:
#line 13513 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("alter");
}
#line 53148 "preproc.c" /* yacc.c:1652  */
    break;

  case 2333:
#line 13517 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("always");
}
#line 53156 "preproc.c" /* yacc.c:1652  */
    break;

  case 2334:
#line 13521 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("assertion");
}
#line 53164 "preproc.c" /* yacc.c:1652  */
    break;

  case 2335:
#line 13525 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("assignment");
}
#line 53172 "preproc.c" /* yacc.c:1652  */
    break;

  case 2336:
#line 13529 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("at");
}
#line 53180 "preproc.c" /* yacc.c:1652  */
    break;

  case 2337:
#line 13533 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("attach");
}
#line 53188 "preproc.c" /* yacc.c:1652  */
    break;

  case 2338:
#line 13537 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("attribute");
}
#line 53196 "preproc.c" /* yacc.c:1652  */
    break;

  case 2339:
#line 13541 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("backward");
}
#line 53204 "preproc.c" /* yacc.c:1652  */
    break;

  case 2340:
#line 13545 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("before");
}
#line 53212 "preproc.c" /* yacc.c:1652  */
    break;

  case 2341:
#line 13549 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("begin");
}
#line 53220 "preproc.c" /* yacc.c:1652  */
    break;

  case 2342:
#line 13553 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("by");
}
#line 53228 "preproc.c" /* yacc.c:1652  */
    break;

  case 2343:
#line 13557 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cache");
}
#line 53236 "preproc.c" /* yacc.c:1652  */
    break;

  case 2344:
#line 13561 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("call");
}
#line 53244 "preproc.c" /* yacc.c:1652  */
    break;

  case 2345:
#line 13565 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("called");
}
#line 53252 "preproc.c" /* yacc.c:1652  */
    break;

  case 2346:
#line 13569 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cascade");
}
#line 53260 "preproc.c" /* yacc.c:1652  */
    break;

  case 2347:
#line 13573 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cascaded");
}
#line 53268 "preproc.c" /* yacc.c:1652  */
    break;

  case 2348:
#line 13577 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("catalog");
}
#line 53276 "preproc.c" /* yacc.c:1652  */
    break;

  case 2349:
#line 13581 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("chain");
}
#line 53284 "preproc.c" /* yacc.c:1652  */
    break;

  case 2350:
#line 13585 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("characteristics");
}
#line 53292 "preproc.c" /* yacc.c:1652  */
    break;

  case 2351:
#line 13589 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("checkpoint");
}
#line 53300 "preproc.c" /* yacc.c:1652  */
    break;

  case 2352:
#line 13593 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("class");
}
#line 53308 "preproc.c" /* yacc.c:1652  */
    break;

  case 2353:
#line 13597 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("close");
}
#line 53316 "preproc.c" /* yacc.c:1652  */
    break;

  case 2354:
#line 13601 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cluster");
}
#line 53324 "preproc.c" /* yacc.c:1652  */
    break;

  case 2355:
#line 13605 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("columns");
}
#line 53332 "preproc.c" /* yacc.c:1652  */
    break;

  case 2356:
#line 13609 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("comment");
}
#line 53340 "preproc.c" /* yacc.c:1652  */
    break;

  case 2357:
#line 13613 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("comments");
}
#line 53348 "preproc.c" /* yacc.c:1652  */
    break;

  case 2358:
#line 13617 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("commit");
}
#line 53356 "preproc.c" /* yacc.c:1652  */
    break;

  case 2359:
#line 13621 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("committed");
}
#line 53364 "preproc.c" /* yacc.c:1652  */
    break;

  case 2360:
#line 13625 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("configuration");
}
#line 53372 "preproc.c" /* yacc.c:1652  */
    break;

  case 2361:
#line 13629 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("conflict");
}
#line 53380 "preproc.c" /* yacc.c:1652  */
    break;

  case 2362:
#line 13633 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("constraints");
}
#line 53388 "preproc.c" /* yacc.c:1652  */
    break;

  case 2363:
#line 13637 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("content");
}
#line 53396 "preproc.c" /* yacc.c:1652  */
    break;

  case 2364:
#line 13641 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("continue");
}
#line 53404 "preproc.c" /* yacc.c:1652  */
    break;

  case 2365:
#line 13645 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("conversion");
}
#line 53412 "preproc.c" /* yacc.c:1652  */
    break;

  case 2366:
#line 13649 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("copy");
}
#line 53420 "preproc.c" /* yacc.c:1652  */
    break;

  case 2367:
#line 13653 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cost");
}
#line 53428 "preproc.c" /* yacc.c:1652  */
    break;

  case 2368:
#line 13657 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("csv");
}
#line 53436 "preproc.c" /* yacc.c:1652  */
    break;

  case 2369:
#line 13661 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cube");
}
#line 53444 "preproc.c" /* yacc.c:1652  */
    break;

  case 2370:
#line 13665 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cursor");
}
#line 53452 "preproc.c" /* yacc.c:1652  */
    break;

  case 2371:
#line 13669 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cycle");
}
#line 53460 "preproc.c" /* yacc.c:1652  */
    break;

  case 2372:
#line 13673 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("data");
}
#line 53468 "preproc.c" /* yacc.c:1652  */
    break;

  case 2373:
#line 13677 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("database");
}
#line 53476 "preproc.c" /* yacc.c:1652  */
    break;

  case 2374:
#line 13681 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deallocate");
}
#line 53484 "preproc.c" /* yacc.c:1652  */
    break;

  case 2375:
#line 13685 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("declare");
}
#line 53492 "preproc.c" /* yacc.c:1652  */
    break;

  case 2376:
#line 13689 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("defaults");
}
#line 53500 "preproc.c" /* yacc.c:1652  */
    break;

  case 2377:
#line 13693 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferred");
}
#line 53508 "preproc.c" /* yacc.c:1652  */
    break;

  case 2378:
#line 13697 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("definer");
}
#line 53516 "preproc.c" /* yacc.c:1652  */
    break;

  case 2379:
#line 13701 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delete");
}
#line 53524 "preproc.c" /* yacc.c:1652  */
    break;

  case 2380:
#line 13705 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delimiter");
}
#line 53532 "preproc.c" /* yacc.c:1652  */
    break;

  case 2381:
#line 13709 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("delimiters");
}
#line 53540 "preproc.c" /* yacc.c:1652  */
    break;

  case 2382:
#line 13713 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("depends");
}
#line 53548 "preproc.c" /* yacc.c:1652  */
    break;

  case 2383:
#line 13717 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("detach");
}
#line 53556 "preproc.c" /* yacc.c:1652  */
    break;

  case 2384:
#line 13721 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("dictionary");
}
#line 53564 "preproc.c" /* yacc.c:1652  */
    break;

  case 2385:
#line 13725 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("disable");
}
#line 53572 "preproc.c" /* yacc.c:1652  */
    break;

  case 2386:
#line 13729 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("discard");
}
#line 53580 "preproc.c" /* yacc.c:1652  */
    break;

  case 2387:
#line 13733 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("document");
}
#line 53588 "preproc.c" /* yacc.c:1652  */
    break;

  case 2388:
#line 13737 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("domain");
}
#line 53596 "preproc.c" /* yacc.c:1652  */
    break;

  case 2389:
#line 13741 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("double");
}
#line 53604 "preproc.c" /* yacc.c:1652  */
    break;

  case 2390:
#line 13745 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("drop");
}
#line 53612 "preproc.c" /* yacc.c:1652  */
    break;

  case 2391:
#line 13749 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("each");
}
#line 53620 "preproc.c" /* yacc.c:1652  */
    break;

  case 2392:
#line 13753 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enable");
}
#line 53628 "preproc.c" /* yacc.c:1652  */
    break;

  case 2393:
#line 13757 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("encoding");
}
#line 53636 "preproc.c" /* yacc.c:1652  */
    break;

  case 2394:
#line 13761 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("encrypted");
}
#line 53644 "preproc.c" /* yacc.c:1652  */
    break;

  case 2395:
#line 13765 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("enum");
}
#line 53652 "preproc.c" /* yacc.c:1652  */
    break;

  case 2396:
#line 13769 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("escape");
}
#line 53660 "preproc.c" /* yacc.c:1652  */
    break;

  case 2397:
#line 13773 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("event");
}
#line 53668 "preproc.c" /* yacc.c:1652  */
    break;

  case 2398:
#line 13777 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exclude");
}
#line 53676 "preproc.c" /* yacc.c:1652  */
    break;

  case 2399:
#line 13781 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("excluding");
}
#line 53684 "preproc.c" /* yacc.c:1652  */
    break;

  case 2400:
#line 13785 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exclusive");
}
#line 53692 "preproc.c" /* yacc.c:1652  */
    break;

  case 2401:
#line 13789 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("execute");
}
#line 53700 "preproc.c" /* yacc.c:1652  */
    break;

  case 2402:
#line 13793 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("explain");
}
#line 53708 "preproc.c" /* yacc.c:1652  */
    break;

  case 2403:
#line 13797 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("expression");
}
#line 53716 "preproc.c" /* yacc.c:1652  */
    break;

  case 2404:
#line 13801 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("extension");
}
#line 53724 "preproc.c" /* yacc.c:1652  */
    break;

  case 2405:
#line 13805 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("external");
}
#line 53732 "preproc.c" /* yacc.c:1652  */
    break;

  case 2406:
#line 13809 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("family");
}
#line 53740 "preproc.c" /* yacc.c:1652  */
    break;

  case 2407:
#line 13813 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("filter");
}
#line 53748 "preproc.c" /* yacc.c:1652  */
    break;

  case 2408:
#line 13817 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("first");
}
#line 53756 "preproc.c" /* yacc.c:1652  */
    break;

  case 2409:
#line 13821 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("following");
}
#line 53764 "preproc.c" /* yacc.c:1652  */
    break;

  case 2410:
#line 13825 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("force");
}
#line 53772 "preproc.c" /* yacc.c:1652  */
    break;

  case 2411:
#line 13829 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("forward");
}
#line 53780 "preproc.c" /* yacc.c:1652  */
    break;

  case 2412:
#line 13833 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("function");
}
#line 53788 "preproc.c" /* yacc.c:1652  */
    break;

  case 2413:
#line 13837 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("functions");
}
#line 53796 "preproc.c" /* yacc.c:1652  */
    break;

  case 2414:
#line 13841 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("generated");
}
#line 53804 "preproc.c" /* yacc.c:1652  */
    break;

  case 2415:
#line 13845 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("global");
}
#line 53812 "preproc.c" /* yacc.c:1652  */
    break;

  case 2416:
#line 13849 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("granted");
}
#line 53820 "preproc.c" /* yacc.c:1652  */
    break;

  case 2417:
#line 13853 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("groups");
}
#line 53828 "preproc.c" /* yacc.c:1652  */
    break;

  case 2418:
#line 13857 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("handler");
}
#line 53836 "preproc.c" /* yacc.c:1652  */
    break;

  case 2419:
#line 13861 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("header");
}
#line 53844 "preproc.c" /* yacc.c:1652  */
    break;

  case 2420:
#line 13865 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("hold");
}
#line 53852 "preproc.c" /* yacc.c:1652  */
    break;

  case 2421:
#line 13869 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("identity");
}
#line 53860 "preproc.c" /* yacc.c:1652  */
    break;

  case 2422:
#line 13873 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("if");
}
#line 53868 "preproc.c" /* yacc.c:1652  */
    break;

  case 2423:
#line 13877 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("immediate");
}
#line 53876 "preproc.c" /* yacc.c:1652  */
    break;

  case 2424:
#line 13881 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("immutable");
}
#line 53884 "preproc.c" /* yacc.c:1652  */
    break;

  case 2425:
#line 13885 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("implicit");
}
#line 53892 "preproc.c" /* yacc.c:1652  */
    break;

  case 2426:
#line 13889 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("import");
}
#line 53900 "preproc.c" /* yacc.c:1652  */
    break;

  case 2427:
#line 13893 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("include");
}
#line 53908 "preproc.c" /* yacc.c:1652  */
    break;

  case 2428:
#line 13897 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("including");
}
#line 53916 "preproc.c" /* yacc.c:1652  */
    break;

  case 2429:
#line 13901 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("increment");
}
#line 53924 "preproc.c" /* yacc.c:1652  */
    break;

  case 2430:
#line 13905 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("index");
}
#line 53932 "preproc.c" /* yacc.c:1652  */
    break;

  case 2431:
#line 13909 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("indexes");
}
#line 53940 "preproc.c" /* yacc.c:1652  */
    break;

  case 2432:
#line 13913 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inherit");
}
#line 53948 "preproc.c" /* yacc.c:1652  */
    break;

  case 2433:
#line 13917 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inherits");
}
#line 53956 "preproc.c" /* yacc.c:1652  */
    break;

  case 2434:
#line 13921 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inline");
}
#line 53964 "preproc.c" /* yacc.c:1652  */
    break;

  case 2435:
#line 13925 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("insensitive");
}
#line 53972 "preproc.c" /* yacc.c:1652  */
    break;

  case 2436:
#line 13929 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("insert");
}
#line 53980 "preproc.c" /* yacc.c:1652  */
    break;

  case 2437:
#line 13933 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("instead");
}
#line 53988 "preproc.c" /* yacc.c:1652  */
    break;

  case 2438:
#line 13937 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("invoker");
}
#line 53996 "preproc.c" /* yacc.c:1652  */
    break;

  case 2439:
#line 13941 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("isolation");
}
#line 54004 "preproc.c" /* yacc.c:1652  */
    break;

  case 2440:
#line 13945 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("key");
}
#line 54012 "preproc.c" /* yacc.c:1652  */
    break;

  case 2441:
#line 13949 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("label");
}
#line 54020 "preproc.c" /* yacc.c:1652  */
    break;

  case 2442:
#line 13953 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("language");
}
#line 54028 "preproc.c" /* yacc.c:1652  */
    break;

  case 2443:
#line 13957 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("large");
}
#line 54036 "preproc.c" /* yacc.c:1652  */
    break;

  case 2444:
#line 13961 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("last");
}
#line 54044 "preproc.c" /* yacc.c:1652  */
    break;

  case 2445:
#line 13965 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("leakproof");
}
#line 54052 "preproc.c" /* yacc.c:1652  */
    break;

  case 2446:
#line 13969 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("level");
}
#line 54060 "preproc.c" /* yacc.c:1652  */
    break;

  case 2447:
#line 13973 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("listen");
}
#line 54068 "preproc.c" /* yacc.c:1652  */
    break;

  case 2448:
#line 13977 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("load");
}
#line 54076 "preproc.c" /* yacc.c:1652  */
    break;

  case 2449:
#line 13981 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("local");
}
#line 54084 "preproc.c" /* yacc.c:1652  */
    break;

  case 2450:
#line 13985 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("location");
}
#line 54092 "preproc.c" /* yacc.c:1652  */
    break;

  case 2451:
#line 13989 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("lock");
}
#line 54100 "preproc.c" /* yacc.c:1652  */
    break;

  case 2452:
#line 13993 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("locked");
}
#line 54108 "preproc.c" /* yacc.c:1652  */
    break;

  case 2453:
#line 13997 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("logged");
}
#line 54116 "preproc.c" /* yacc.c:1652  */
    break;

  case 2454:
#line 14001 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("mapping");
}
#line 54124 "preproc.c" /* yacc.c:1652  */
    break;

  case 2455:
#line 14005 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("match");
}
#line 54132 "preproc.c" /* yacc.c:1652  */
    break;

  case 2456:
#line 14009 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("materialized");
}
#line 54140 "preproc.c" /* yacc.c:1652  */
    break;

  case 2457:
#line 14013 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("maxvalue");
}
#line 54148 "preproc.c" /* yacc.c:1652  */
    break;

  case 2458:
#line 14017 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("method");
}
#line 54156 "preproc.c" /* yacc.c:1652  */
    break;

  case 2459:
#line 14021 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("minvalue");
}
#line 54164 "preproc.c" /* yacc.c:1652  */
    break;

  case 2460:
#line 14025 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("mode");
}
#line 54172 "preproc.c" /* yacc.c:1652  */
    break;

  case 2461:
#line 14029 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("move");
}
#line 54180 "preproc.c" /* yacc.c:1652  */
    break;

  case 2462:
#line 14033 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("name");
}
#line 54188 "preproc.c" /* yacc.c:1652  */
    break;

  case 2463:
#line 14037 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("names");
}
#line 54196 "preproc.c" /* yacc.c:1652  */
    break;

  case 2464:
#line 14041 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("new");
}
#line 54204 "preproc.c" /* yacc.c:1652  */
    break;

  case 2465:
#line 14045 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("next");
}
#line 54212 "preproc.c" /* yacc.c:1652  */
    break;

  case 2466:
#line 14049 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nfc");
}
#line 54220 "preproc.c" /* yacc.c:1652  */
    break;

  case 2467:
#line 14053 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nfd");
}
#line 54228 "preproc.c" /* yacc.c:1652  */
    break;

  case 2468:
#line 14057 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nfkc");
}
#line 54236 "preproc.c" /* yacc.c:1652  */
    break;

  case 2469:
#line 14061 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nfkd");
}
#line 54244 "preproc.c" /* yacc.c:1652  */
    break;

  case 2470:
#line 14065 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("no");
}
#line 54252 "preproc.c" /* yacc.c:1652  */
    break;

  case 2471:
#line 14069 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("normalized");
}
#line 54260 "preproc.c" /* yacc.c:1652  */
    break;

  case 2472:
#line 14073 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nothing");
}
#line 54268 "preproc.c" /* yacc.c:1652  */
    break;

  case 2473:
#line 14077 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("notify");
}
#line 54276 "preproc.c" /* yacc.c:1652  */
    break;

  case 2474:
#line 14081 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nowait");
}
#line 54284 "preproc.c" /* yacc.c:1652  */
    break;

  case 2475:
#line 14085 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nulls");
}
#line 54292 "preproc.c" /* yacc.c:1652  */
    break;

  case 2476:
#line 14089 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("object");
}
#line 54300 "preproc.c" /* yacc.c:1652  */
    break;

  case 2477:
#line 14093 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("of");
}
#line 54308 "preproc.c" /* yacc.c:1652  */
    break;

  case 2478:
#line 14097 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("off");
}
#line 54316 "preproc.c" /* yacc.c:1652  */
    break;

  case 2479:
#line 14101 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("oids");
}
#line 54324 "preproc.c" /* yacc.c:1652  */
    break;

  case 2480:
#line 14105 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("old");
}
#line 54332 "preproc.c" /* yacc.c:1652  */
    break;

  case 2481:
#line 14109 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("operator");
}
#line 54340 "preproc.c" /* yacc.c:1652  */
    break;

  case 2482:
#line 14113 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("option");
}
#line 54348 "preproc.c" /* yacc.c:1652  */
    break;

  case 2483:
#line 14117 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("options");
}
#line 54356 "preproc.c" /* yacc.c:1652  */
    break;

  case 2484:
#line 14121 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("ordinality");
}
#line 54364 "preproc.c" /* yacc.c:1652  */
    break;

  case 2485:
#line 14125 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("others");
}
#line 54372 "preproc.c" /* yacc.c:1652  */
    break;

  case 2486:
#line 14129 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("over");
}
#line 54380 "preproc.c" /* yacc.c:1652  */
    break;

  case 2487:
#line 14133 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("overriding");
}
#line 54388 "preproc.c" /* yacc.c:1652  */
    break;

  case 2488:
#line 14137 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("owned");
}
#line 54396 "preproc.c" /* yacc.c:1652  */
    break;

  case 2489:
#line 14141 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("owner");
}
#line 54404 "preproc.c" /* yacc.c:1652  */
    break;

  case 2490:
#line 14145 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("parallel");
}
#line 54412 "preproc.c" /* yacc.c:1652  */
    break;

  case 2491:
#line 14149 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("parser");
}
#line 54420 "preproc.c" /* yacc.c:1652  */
    break;

  case 2492:
#line 14153 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("partial");
}
#line 54428 "preproc.c" /* yacc.c:1652  */
    break;

  case 2493:
#line 14157 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("partition");
}
#line 54436 "preproc.c" /* yacc.c:1652  */
    break;

  case 2494:
#line 14161 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("passing");
}
#line 54444 "preproc.c" /* yacc.c:1652  */
    break;

  case 2495:
#line 14165 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("password");
}
#line 54452 "preproc.c" /* yacc.c:1652  */
    break;

  case 2496:
#line 14169 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("plans");
}
#line 54460 "preproc.c" /* yacc.c:1652  */
    break;

  case 2497:
#line 14173 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("policy");
}
#line 54468 "preproc.c" /* yacc.c:1652  */
    break;

  case 2498:
#line 14177 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("preceding");
}
#line 54476 "preproc.c" /* yacc.c:1652  */
    break;

  case 2499:
#line 14181 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("prepare");
}
#line 54484 "preproc.c" /* yacc.c:1652  */
    break;

  case 2500:
#line 14185 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("prepared");
}
#line 54492 "preproc.c" /* yacc.c:1652  */
    break;

  case 2501:
#line 14189 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("preserve");
}
#line 54500 "preproc.c" /* yacc.c:1652  */
    break;

  case 2502:
#line 14193 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("prior");
}
#line 54508 "preproc.c" /* yacc.c:1652  */
    break;

  case 2503:
#line 14197 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("privileges");
}
#line 54516 "preproc.c" /* yacc.c:1652  */
    break;

  case 2504:
#line 14201 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("procedural");
}
#line 54524 "preproc.c" /* yacc.c:1652  */
    break;

  case 2505:
#line 14205 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("procedure");
}
#line 54532 "preproc.c" /* yacc.c:1652  */
    break;

  case 2506:
#line 14209 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("procedures");
}
#line 54540 "preproc.c" /* yacc.c:1652  */
    break;

  case 2507:
#line 14213 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("program");
}
#line 54548 "preproc.c" /* yacc.c:1652  */
    break;

  case 2508:
#line 14217 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("publication");
}
#line 54556 "preproc.c" /* yacc.c:1652  */
    break;

  case 2509:
#line 14221 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("quote");
}
#line 54564 "preproc.c" /* yacc.c:1652  */
    break;

  case 2510:
#line 14225 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("range");
}
#line 54572 "preproc.c" /* yacc.c:1652  */
    break;

  case 2511:
#line 14229 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("read");
}
#line 54580 "preproc.c" /* yacc.c:1652  */
    break;

  case 2512:
#line 14233 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("reassign");
}
#line 54588 "preproc.c" /* yacc.c:1652  */
    break;

  case 2513:
#line 14237 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("recheck");
}
#line 54596 "preproc.c" /* yacc.c:1652  */
    break;

  case 2514:
#line 14241 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("recursive");
}
#line 54604 "preproc.c" /* yacc.c:1652  */
    break;

  case 2515:
#line 14245 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("ref");
}
#line 54612 "preproc.c" /* yacc.c:1652  */
    break;

  case 2516:
#line 14249 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("referencing");
}
#line 54620 "preproc.c" /* yacc.c:1652  */
    break;

  case 2517:
#line 14253 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("refresh");
}
#line 54628 "preproc.c" /* yacc.c:1652  */
    break;

  case 2518:
#line 14257 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("reindex");
}
#line 54636 "preproc.c" /* yacc.c:1652  */
    break;

  case 2519:
#line 14261 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("relative");
}
#line 54644 "preproc.c" /* yacc.c:1652  */
    break;

  case 2520:
#line 14265 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("release");
}
#line 54652 "preproc.c" /* yacc.c:1652  */
    break;

  case 2521:
#line 14269 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rename");
}
#line 54660 "preproc.c" /* yacc.c:1652  */
    break;

  case 2522:
#line 14273 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("repeatable");
}
#line 54668 "preproc.c" /* yacc.c:1652  */
    break;

  case 2523:
#line 14277 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("replace");
}
#line 54676 "preproc.c" /* yacc.c:1652  */
    break;

  case 2524:
#line 14281 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("replica");
}
#line 54684 "preproc.c" /* yacc.c:1652  */
    break;

  case 2525:
#line 14285 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("reset");
}
#line 54692 "preproc.c" /* yacc.c:1652  */
    break;

  case 2526:
#line 14289 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restart");
}
#line 54700 "preproc.c" /* yacc.c:1652  */
    break;

  case 2527:
#line 14293 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("restrict");
}
#line 54708 "preproc.c" /* yacc.c:1652  */
    break;

  case 2528:
#line 14297 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("returns");
}
#line 54716 "preproc.c" /* yacc.c:1652  */
    break;

  case 2529:
#line 14301 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("revoke");
}
#line 54724 "preproc.c" /* yacc.c:1652  */
    break;

  case 2530:
#line 14305 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("role");
}
#line 54732 "preproc.c" /* yacc.c:1652  */
    break;

  case 2531:
#line 14309 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rollback");
}
#line 54740 "preproc.c" /* yacc.c:1652  */
    break;

  case 2532:
#line 14313 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rollup");
}
#line 54748 "preproc.c" /* yacc.c:1652  */
    break;

  case 2533:
#line 14317 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("routine");
}
#line 54756 "preproc.c" /* yacc.c:1652  */
    break;

  case 2534:
#line 14321 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("routines");
}
#line 54764 "preproc.c" /* yacc.c:1652  */
    break;

  case 2535:
#line 14325 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rows");
}
#line 54772 "preproc.c" /* yacc.c:1652  */
    break;

  case 2536:
#line 14329 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("rule");
}
#line 54780 "preproc.c" /* yacc.c:1652  */
    break;

  case 2537:
#line 14333 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("savepoint");
}
#line 54788 "preproc.c" /* yacc.c:1652  */
    break;

  case 2538:
#line 14337 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schema");
}
#line 54796 "preproc.c" /* yacc.c:1652  */
    break;

  case 2539:
#line 14341 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("schemas");
}
#line 54804 "preproc.c" /* yacc.c:1652  */
    break;

  case 2540:
#line 14345 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("scroll");
}
#line 54812 "preproc.c" /* yacc.c:1652  */
    break;

  case 2541:
#line 14349 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("search");
}
#line 54820 "preproc.c" /* yacc.c:1652  */
    break;

  case 2542:
#line 14353 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("security");
}
#line 54828 "preproc.c" /* yacc.c:1652  */
    break;

  case 2543:
#line 14357 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequence");
}
#line 54836 "preproc.c" /* yacc.c:1652  */
    break;

  case 2544:
#line 14361 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sequences");
}
#line 54844 "preproc.c" /* yacc.c:1652  */
    break;

  case 2545:
#line 14365 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("serializable");
}
#line 54852 "preproc.c" /* yacc.c:1652  */
    break;

  case 2546:
#line 14369 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("server");
}
#line 54860 "preproc.c" /* yacc.c:1652  */
    break;

  case 2547:
#line 14373 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session");
}
#line 54868 "preproc.c" /* yacc.c:1652  */
    break;

  case 2548:
#line 14377 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("set");
}
#line 54876 "preproc.c" /* yacc.c:1652  */
    break;

  case 2549:
#line 14381 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sets");
}
#line 54884 "preproc.c" /* yacc.c:1652  */
    break;

  case 2550:
#line 14385 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("share");
}
#line 54892 "preproc.c" /* yacc.c:1652  */
    break;

  case 2551:
#line 14389 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("show");
}
#line 54900 "preproc.c" /* yacc.c:1652  */
    break;

  case 2552:
#line 14393 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("simple");
}
#line 54908 "preproc.c" /* yacc.c:1652  */
    break;

  case 2553:
#line 14397 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("skip");
}
#line 54916 "preproc.c" /* yacc.c:1652  */
    break;

  case 2554:
#line 14401 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("snapshot");
}
#line 54924 "preproc.c" /* yacc.c:1652  */
    break;

  case 2555:
#line 14405 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sql");
}
#line 54932 "preproc.c" /* yacc.c:1652  */
    break;

  case 2556:
#line 14409 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stable");
}
#line 54940 "preproc.c" /* yacc.c:1652  */
    break;

  case 2557:
#line 14413 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("standalone");
}
#line 54948 "preproc.c" /* yacc.c:1652  */
    break;

  case 2558:
#line 14417 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("start");
}
#line 54956 "preproc.c" /* yacc.c:1652  */
    break;

  case 2559:
#line 14421 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("statement");
}
#line 54964 "preproc.c" /* yacc.c:1652  */
    break;

  case 2560:
#line 14425 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("statistics");
}
#line 54972 "preproc.c" /* yacc.c:1652  */
    break;

  case 2561:
#line 14429 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stdin");
}
#line 54980 "preproc.c" /* yacc.c:1652  */
    break;

  case 2562:
#line 14433 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stdout");
}
#line 54988 "preproc.c" /* yacc.c:1652  */
    break;

  case 2563:
#line 14437 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("storage");
}
#line 54996 "preproc.c" /* yacc.c:1652  */
    break;

  case 2564:
#line 14441 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("stored");
}
#line 55004 "preproc.c" /* yacc.c:1652  */
    break;

  case 2565:
#line 14445 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("strict");
}
#line 55012 "preproc.c" /* yacc.c:1652  */
    break;

  case 2566:
#line 14449 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("strip");
}
#line 55020 "preproc.c" /* yacc.c:1652  */
    break;

  case 2567:
#line 14453 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("subscription");
}
#line 55028 "preproc.c" /* yacc.c:1652  */
    break;

  case 2568:
#line 14457 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("support");
}
#line 55036 "preproc.c" /* yacc.c:1652  */
    break;

  case 2569:
#line 14461 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("sysid");
}
#line 55044 "preproc.c" /* yacc.c:1652  */
    break;

  case 2570:
#line 14465 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("system");
}
#line 55052 "preproc.c" /* yacc.c:1652  */
    break;

  case 2571:
#line 14469 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tables");
}
#line 55060 "preproc.c" /* yacc.c:1652  */
    break;

  case 2572:
#line 14473 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 55068 "preproc.c" /* yacc.c:1652  */
    break;

  case 2573:
#line 14477 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("temp");
}
#line 55076 "preproc.c" /* yacc.c:1652  */
    break;

  case 2574:
#line 14481 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("template");
}
#line 55084 "preproc.c" /* yacc.c:1652  */
    break;

  case 2575:
#line 14485 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("temporary");
}
#line 55092 "preproc.c" /* yacc.c:1652  */
    break;

  case 2576:
#line 14489 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("text");
}
#line 55100 "preproc.c" /* yacc.c:1652  */
    break;

  case 2577:
#line 14493 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("ties");
}
#line 55108 "preproc.c" /* yacc.c:1652  */
    break;

  case 2578:
#line 14497 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("transaction");
}
#line 55116 "preproc.c" /* yacc.c:1652  */
    break;

  case 2579:
#line 14501 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("transform");
}
#line 55124 "preproc.c" /* yacc.c:1652  */
    break;

  case 2580:
#line 14505 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("trigger");
}
#line 55132 "preproc.c" /* yacc.c:1652  */
    break;

  case 2581:
#line 14509 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("truncate");
}
#line 55140 "preproc.c" /* yacc.c:1652  */
    break;

  case 2582:
#line 14513 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("trusted");
}
#line 55148 "preproc.c" /* yacc.c:1652  */
    break;

  case 2583:
#line 14517 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("type");
}
#line 55156 "preproc.c" /* yacc.c:1652  */
    break;

  case 2584:
#line 14521 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("types");
}
#line 55164 "preproc.c" /* yacc.c:1652  */
    break;

  case 2585:
#line 14525 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("uescape");
}
#line 55172 "preproc.c" /* yacc.c:1652  */
    break;

  case 2586:
#line 14529 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unbounded");
}
#line 55180 "preproc.c" /* yacc.c:1652  */
    break;

  case 2587:
#line 14533 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("uncommitted");
}
#line 55188 "preproc.c" /* yacc.c:1652  */
    break;

  case 2588:
#line 14537 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unencrypted");
}
#line 55196 "preproc.c" /* yacc.c:1652  */
    break;

  case 2589:
#line 14541 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unknown");
}
#line 55204 "preproc.c" /* yacc.c:1652  */
    break;

  case 2590:
#line 14545 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unlisten");
}
#line 55212 "preproc.c" /* yacc.c:1652  */
    break;

  case 2591:
#line 14549 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 55220 "preproc.c" /* yacc.c:1652  */
    break;

  case 2592:
#line 14553 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("until");
}
#line 55228 "preproc.c" /* yacc.c:1652  */
    break;

  case 2593:
#line 14557 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("update");
}
#line 55236 "preproc.c" /* yacc.c:1652  */
    break;

  case 2594:
#line 14561 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("vacuum");
}
#line 55244 "preproc.c" /* yacc.c:1652  */
    break;

  case 2595:
#line 14565 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("valid");
}
#line 55252 "preproc.c" /* yacc.c:1652  */
    break;

  case 2596:
#line 14569 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("validate");
}
#line 55260 "preproc.c" /* yacc.c:1652  */
    break;

  case 2597:
#line 14573 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("validator");
}
#line 55268 "preproc.c" /* yacc.c:1652  */
    break;

  case 2598:
#line 14577 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("value");
}
#line 55276 "preproc.c" /* yacc.c:1652  */
    break;

  case 2599:
#line 14581 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("varying");
}
#line 55284 "preproc.c" /* yacc.c:1652  */
    break;

  case 2600:
#line 14585 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("version");
}
#line 55292 "preproc.c" /* yacc.c:1652  */
    break;

  case 2601:
#line 14589 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("view");
}
#line 55300 "preproc.c" /* yacc.c:1652  */
    break;

  case 2602:
#line 14593 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("views");
}
#line 55308 "preproc.c" /* yacc.c:1652  */
    break;

  case 2603:
#line 14597 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("volatile");
}
#line 55316 "preproc.c" /* yacc.c:1652  */
    break;

  case 2604:
#line 14601 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("whitespace");
}
#line 55324 "preproc.c" /* yacc.c:1652  */
    break;

  case 2605:
#line 14605 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("within");
}
#line 55332 "preproc.c" /* yacc.c:1652  */
    break;

  case 2606:
#line 14609 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("without");
}
#line 55340 "preproc.c" /* yacc.c:1652  */
    break;

  case 2607:
#line 14613 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("work");
}
#line 55348 "preproc.c" /* yacc.c:1652  */
    break;

  case 2608:
#line 14617 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("wrapper");
}
#line 55356 "preproc.c" /* yacc.c:1652  */
    break;

  case 2609:
#line 14621 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("write");
}
#line 55364 "preproc.c" /* yacc.c:1652  */
    break;

  case 2610:
#line 14625 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xml");
}
#line 55372 "preproc.c" /* yacc.c:1652  */
    break;

  case 2611:
#line 14629 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("yes");
}
#line 55380 "preproc.c" /* yacc.c:1652  */
    break;

  case 2612:
#line 14633 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("zone");
}
#line 55388 "preproc.c" /* yacc.c:1652  */
    break;

  case 2613:
#line 14641 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("between");
}
#line 55396 "preproc.c" /* yacc.c:1652  */
    break;

  case 2614:
#line 14645 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("bigint");
}
#line 55404 "preproc.c" /* yacc.c:1652  */
    break;

  case 2615:
#line 14649 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("bit");
}
#line 55412 "preproc.c" /* yacc.c:1652  */
    break;

  case 2616:
#line 14653 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("boolean");
}
#line 55420 "preproc.c" /* yacc.c:1652  */
    break;

  case 2617:
#line 14657 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("character");
}
#line 55428 "preproc.c" /* yacc.c:1652  */
    break;

  case 2618:
#line 14661 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("coalesce");
}
#line 55436 "preproc.c" /* yacc.c:1652  */
    break;

  case 2619:
#line 14665 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("dec");
}
#line 55444 "preproc.c" /* yacc.c:1652  */
    break;

  case 2620:
#line 14669 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("decimal");
}
#line 55452 "preproc.c" /* yacc.c:1652  */
    break;

  case 2621:
#line 14673 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("exists");
}
#line 55460 "preproc.c" /* yacc.c:1652  */
    break;

  case 2622:
#line 14677 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("extract");
}
#line 55468 "preproc.c" /* yacc.c:1652  */
    break;

  case 2623:
#line 14681 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("float");
}
#line 55476 "preproc.c" /* yacc.c:1652  */
    break;

  case 2624:
#line 14685 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("greatest");
}
#line 55484 "preproc.c" /* yacc.c:1652  */
    break;

  case 2625:
#line 14689 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("grouping");
}
#line 55492 "preproc.c" /* yacc.c:1652  */
    break;

  case 2626:
#line 14693 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inout");
}
#line 55500 "preproc.c" /* yacc.c:1652  */
    break;

  case 2627:
#line 14697 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("integer");
}
#line 55508 "preproc.c" /* yacc.c:1652  */
    break;

  case 2628:
#line 14701 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("interval");
}
#line 55516 "preproc.c" /* yacc.c:1652  */
    break;

  case 2629:
#line 14705 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("least");
}
#line 55524 "preproc.c" /* yacc.c:1652  */
    break;

  case 2630:
#line 14709 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("national");
}
#line 55532 "preproc.c" /* yacc.c:1652  */
    break;

  case 2631:
#line 14713 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nchar");
}
#line 55540 "preproc.c" /* yacc.c:1652  */
    break;

  case 2632:
#line 14717 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("none");
}
#line 55548 "preproc.c" /* yacc.c:1652  */
    break;

  case 2633:
#line 14721 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("normalize");
}
#line 55556 "preproc.c" /* yacc.c:1652  */
    break;

  case 2634:
#line 14725 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("nullif");
}
#line 55564 "preproc.c" /* yacc.c:1652  */
    break;

  case 2635:
#line 14729 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("numeric");
}
#line 55572 "preproc.c" /* yacc.c:1652  */
    break;

  case 2636:
#line 14733 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("out");
}
#line 55580 "preproc.c" /* yacc.c:1652  */
    break;

  case 2637:
#line 14737 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("overlay");
}
#line 55588 "preproc.c" /* yacc.c:1652  */
    break;

  case 2638:
#line 14741 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("position");
}
#line 55596 "preproc.c" /* yacc.c:1652  */
    break;

  case 2639:
#line 14745 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("precision");
}
#line 55604 "preproc.c" /* yacc.c:1652  */
    break;

  case 2640:
#line 14749 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("real");
}
#line 55612 "preproc.c" /* yacc.c:1652  */
    break;

  case 2641:
#line 14753 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("row");
}
#line 55620 "preproc.c" /* yacc.c:1652  */
    break;

  case 2642:
#line 14757 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("setof");
}
#line 55628 "preproc.c" /* yacc.c:1652  */
    break;

  case 2643:
#line 14761 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("smallint");
}
#line 55636 "preproc.c" /* yacc.c:1652  */
    break;

  case 2644:
#line 14765 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("substring");
}
#line 55644 "preproc.c" /* yacc.c:1652  */
    break;

  case 2645:
#line 14769 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("time");
}
#line 55652 "preproc.c" /* yacc.c:1652  */
    break;

  case 2646:
#line 14773 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("timestamp");
}
#line 55660 "preproc.c" /* yacc.c:1652  */
    break;

  case 2647:
#line 14777 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("treat");
}
#line 55668 "preproc.c" /* yacc.c:1652  */
    break;

  case 2648:
#line 14781 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("trim");
}
#line 55676 "preproc.c" /* yacc.c:1652  */
    break;

  case 2649:
#line 14785 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("varchar");
}
#line 55684 "preproc.c" /* yacc.c:1652  */
    break;

  case 2650:
#line 14789 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlattributes");
}
#line 55692 "preproc.c" /* yacc.c:1652  */
    break;

  case 2651:
#line 14793 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlconcat");
}
#line 55700 "preproc.c" /* yacc.c:1652  */
    break;

  case 2652:
#line 14797 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlelement");
}
#line 55708 "preproc.c" /* yacc.c:1652  */
    break;

  case 2653:
#line 14801 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlexists");
}
#line 55716 "preproc.c" /* yacc.c:1652  */
    break;

  case 2654:
#line 14805 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlforest");
}
#line 55724 "preproc.c" /* yacc.c:1652  */
    break;

  case 2655:
#line 14809 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlnamespaces");
}
#line 55732 "preproc.c" /* yacc.c:1652  */
    break;

  case 2656:
#line 14813 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlparse");
}
#line 55740 "preproc.c" /* yacc.c:1652  */
    break;

  case 2657:
#line 14817 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlpi");
}
#line 55748 "preproc.c" /* yacc.c:1652  */
    break;

  case 2658:
#line 14821 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlroot");
}
#line 55756 "preproc.c" /* yacc.c:1652  */
    break;

  case 2659:
#line 14825 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmlserialize");
}
#line 55764 "preproc.c" /* yacc.c:1652  */
    break;

  case 2660:
#line 14829 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("xmltable");
}
#line 55772 "preproc.c" /* yacc.c:1652  */
    break;

  case 2661:
#line 14837 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("authorization");
}
#line 55780 "preproc.c" /* yacc.c:1652  */
    break;

  case 2662:
#line 14841 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("binary");
}
#line 55788 "preproc.c" /* yacc.c:1652  */
    break;

  case 2663:
#line 14845 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("collation");
}
#line 55796 "preproc.c" /* yacc.c:1652  */
    break;

  case 2664:
#line 14849 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("concurrently");
}
#line 55804 "preproc.c" /* yacc.c:1652  */
    break;

  case 2665:
#line 14853 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cross");
}
#line 55812 "preproc.c" /* yacc.c:1652  */
    break;

  case 2666:
#line 14857 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_schema");
}
#line 55820 "preproc.c" /* yacc.c:1652  */
    break;

  case 2667:
#line 14861 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("freeze");
}
#line 55828 "preproc.c" /* yacc.c:1652  */
    break;

  case 2668:
#line 14865 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("full");
}
#line 55836 "preproc.c" /* yacc.c:1652  */
    break;

  case 2669:
#line 14869 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("ilike");
}
#line 55844 "preproc.c" /* yacc.c:1652  */
    break;

  case 2670:
#line 14873 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("inner");
}
#line 55852 "preproc.c" /* yacc.c:1652  */
    break;

  case 2671:
#line 14877 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("is");
}
#line 55860 "preproc.c" /* yacc.c:1652  */
    break;

  case 2672:
#line 14881 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("isnull");
}
#line 55868 "preproc.c" /* yacc.c:1652  */
    break;

  case 2673:
#line 14885 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("join");
}
#line 55876 "preproc.c" /* yacc.c:1652  */
    break;

  case 2674:
#line 14889 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("left");
}
#line 55884 "preproc.c" /* yacc.c:1652  */
    break;

  case 2675:
#line 14893 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("like");
}
#line 55892 "preproc.c" /* yacc.c:1652  */
    break;

  case 2676:
#line 14897 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("natural");
}
#line 55900 "preproc.c" /* yacc.c:1652  */
    break;

  case 2677:
#line 14901 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("notnull");
}
#line 55908 "preproc.c" /* yacc.c:1652  */
    break;

  case 2678:
#line 14905 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("outer");
}
#line 55916 "preproc.c" /* yacc.c:1652  */
    break;

  case 2679:
#line 14909 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("overlaps");
}
#line 55924 "preproc.c" /* yacc.c:1652  */
    break;

  case 2680:
#line 14913 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("right");
}
#line 55932 "preproc.c" /* yacc.c:1652  */
    break;

  case 2681:
#line 14917 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("similar");
}
#line 55940 "preproc.c" /* yacc.c:1652  */
    break;

  case 2682:
#line 14921 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("tablesample");
}
#line 55948 "preproc.c" /* yacc.c:1652  */
    break;

  case 2683:
#line 14925 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("verbose");
}
#line 55956 "preproc.c" /* yacc.c:1652  */
    break;

  case 2684:
#line 14933 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("all");
}
#line 55964 "preproc.c" /* yacc.c:1652  */
    break;

  case 2685:
#line 14937 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("analyse");
}
#line 55972 "preproc.c" /* yacc.c:1652  */
    break;

  case 2686:
#line 14941 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("analyze");
}
#line 55980 "preproc.c" /* yacc.c:1652  */
    break;

  case 2687:
#line 14945 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("and");
}
#line 55988 "preproc.c" /* yacc.c:1652  */
    break;

  case 2688:
#line 14949 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("any");
}
#line 55996 "preproc.c" /* yacc.c:1652  */
    break;

  case 2689:
#line 14953 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("array");
}
#line 56004 "preproc.c" /* yacc.c:1652  */
    break;

  case 2690:
#line 14957 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("as");
}
#line 56012 "preproc.c" /* yacc.c:1652  */
    break;

  case 2691:
#line 14961 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("asc");
}
#line 56020 "preproc.c" /* yacc.c:1652  */
    break;

  case 2692:
#line 14965 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("asymmetric");
}
#line 56028 "preproc.c" /* yacc.c:1652  */
    break;

  case 2693:
#line 14969 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("both");
}
#line 56036 "preproc.c" /* yacc.c:1652  */
    break;

  case 2694:
#line 14973 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("case");
}
#line 56044 "preproc.c" /* yacc.c:1652  */
    break;

  case 2695:
#line 14977 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("cast");
}
#line 56052 "preproc.c" /* yacc.c:1652  */
    break;

  case 2696:
#line 14981 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("check");
}
#line 56060 "preproc.c" /* yacc.c:1652  */
    break;

  case 2697:
#line 14985 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("collate");
}
#line 56068 "preproc.c" /* yacc.c:1652  */
    break;

  case 2698:
#line 14989 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("column");
}
#line 56076 "preproc.c" /* yacc.c:1652  */
    break;

  case 2699:
#line 14993 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("constraint");
}
#line 56084 "preproc.c" /* yacc.c:1652  */
    break;

  case 2700:
#line 14997 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("create");
}
#line 56092 "preproc.c" /* yacc.c:1652  */
    break;

  case 2701:
#line 15001 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_catalog");
}
#line 56100 "preproc.c" /* yacc.c:1652  */
    break;

  case 2702:
#line 15005 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_date");
}
#line 56108 "preproc.c" /* yacc.c:1652  */
    break;

  case 2703:
#line 15009 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_role");
}
#line 56116 "preproc.c" /* yacc.c:1652  */
    break;

  case 2704:
#line 15013 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_time");
}
#line 56124 "preproc.c" /* yacc.c:1652  */
    break;

  case 2705:
#line 15017 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_timestamp");
}
#line 56132 "preproc.c" /* yacc.c:1652  */
    break;

  case 2706:
#line 15021 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("current_user");
}
#line 56140 "preproc.c" /* yacc.c:1652  */
    break;

  case 2707:
#line 15025 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("default");
}
#line 56148 "preproc.c" /* yacc.c:1652  */
    break;

  case 2708:
#line 15029 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 56156 "preproc.c" /* yacc.c:1652  */
    break;

  case 2709:
#line 15033 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("desc");
}
#line 56164 "preproc.c" /* yacc.c:1652  */
    break;

  case 2710:
#line 15037 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("distinct");
}
#line 56172 "preproc.c" /* yacc.c:1652  */
    break;

  case 2711:
#line 15041 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("do");
}
#line 56180 "preproc.c" /* yacc.c:1652  */
    break;

  case 2712:
#line 15045 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("else");
}
#line 56188 "preproc.c" /* yacc.c:1652  */
    break;

  case 2713:
#line 15049 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("end");
}
#line 56196 "preproc.c" /* yacc.c:1652  */
    break;

  case 2714:
#line 15053 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("except");
}
#line 56204 "preproc.c" /* yacc.c:1652  */
    break;

  case 2715:
#line 15057 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("false");
}
#line 56212 "preproc.c" /* yacc.c:1652  */
    break;

  case 2716:
#line 15061 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("fetch");
}
#line 56220 "preproc.c" /* yacc.c:1652  */
    break;

  case 2717:
#line 15065 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("for");
}
#line 56228 "preproc.c" /* yacc.c:1652  */
    break;

  case 2718:
#line 15069 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("foreign");
}
#line 56236 "preproc.c" /* yacc.c:1652  */
    break;

  case 2719:
#line 15073 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("from");
}
#line 56244 "preproc.c" /* yacc.c:1652  */
    break;

  case 2720:
#line 15077 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("grant");
}
#line 56252 "preproc.c" /* yacc.c:1652  */
    break;

  case 2721:
#line 15081 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("group");
}
#line 56260 "preproc.c" /* yacc.c:1652  */
    break;

  case 2722:
#line 15085 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("having");
}
#line 56268 "preproc.c" /* yacc.c:1652  */
    break;

  case 2723:
#line 15089 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("in");
}
#line 56276 "preproc.c" /* yacc.c:1652  */
    break;

  case 2724:
#line 15093 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("initially");
}
#line 56284 "preproc.c" /* yacc.c:1652  */
    break;

  case 2725:
#line 15097 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("intersect");
}
#line 56292 "preproc.c" /* yacc.c:1652  */
    break;

  case 2726:
#line 15101 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("into");
}
#line 56300 "preproc.c" /* yacc.c:1652  */
    break;

  case 2727:
#line 15105 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("lateral");
}
#line 56308 "preproc.c" /* yacc.c:1652  */
    break;

  case 2728:
#line 15109 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("leading");
}
#line 56316 "preproc.c" /* yacc.c:1652  */
    break;

  case 2729:
#line 15113 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("limit");
}
#line 56324 "preproc.c" /* yacc.c:1652  */
    break;

  case 2730:
#line 15117 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("localtime");
}
#line 56332 "preproc.c" /* yacc.c:1652  */
    break;

  case 2731:
#line 15121 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("localtimestamp");
}
#line 56340 "preproc.c" /* yacc.c:1652  */
    break;

  case 2732:
#line 15125 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("not");
}
#line 56348 "preproc.c" /* yacc.c:1652  */
    break;

  case 2733:
#line 15129 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("null");
}
#line 56356 "preproc.c" /* yacc.c:1652  */
    break;

  case 2734:
#line 15133 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("offset");
}
#line 56364 "preproc.c" /* yacc.c:1652  */
    break;

  case 2735:
#line 15137 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("on");
}
#line 56372 "preproc.c" /* yacc.c:1652  */
    break;

  case 2736:
#line 15141 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("only");
}
#line 56380 "preproc.c" /* yacc.c:1652  */
    break;

  case 2737:
#line 15145 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("or");
}
#line 56388 "preproc.c" /* yacc.c:1652  */
    break;

  case 2738:
#line 15149 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("order");
}
#line 56396 "preproc.c" /* yacc.c:1652  */
    break;

  case 2739:
#line 15153 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("placing");
}
#line 56404 "preproc.c" /* yacc.c:1652  */
    break;

  case 2740:
#line 15157 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("primary");
}
#line 56412 "preproc.c" /* yacc.c:1652  */
    break;

  case 2741:
#line 15161 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("references");
}
#line 56420 "preproc.c" /* yacc.c:1652  */
    break;

  case 2742:
#line 15165 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("returning");
}
#line 56428 "preproc.c" /* yacc.c:1652  */
    break;

  case 2743:
#line 15169 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("select");
}
#line 56436 "preproc.c" /* yacc.c:1652  */
    break;

  case 2744:
#line 15173 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("session_user");
}
#line 56444 "preproc.c" /* yacc.c:1652  */
    break;

  case 2745:
#line 15177 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("some");
}
#line 56452 "preproc.c" /* yacc.c:1652  */
    break;

  case 2746:
#line 15181 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("symmetric");
}
#line 56460 "preproc.c" /* yacc.c:1652  */
    break;

  case 2747:
#line 15185 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("table");
}
#line 56468 "preproc.c" /* yacc.c:1652  */
    break;

  case 2748:
#line 15189 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("then");
}
#line 56476 "preproc.c" /* yacc.c:1652  */
    break;

  case 2749:
#line 15193 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("trailing");
}
#line 56484 "preproc.c" /* yacc.c:1652  */
    break;

  case 2750:
#line 15197 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("true");
}
#line 56492 "preproc.c" /* yacc.c:1652  */
    break;

  case 2751:
#line 15201 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("unique");
}
#line 56500 "preproc.c" /* yacc.c:1652  */
    break;

  case 2752:
#line 15205 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("user");
}
#line 56508 "preproc.c" /* yacc.c:1652  */
    break;

  case 2753:
#line 15209 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("using");
}
#line 56516 "preproc.c" /* yacc.c:1652  */
    break;

  case 2754:
#line 15213 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("variadic");
}
#line 56524 "preproc.c" /* yacc.c:1652  */
    break;

  case 2755:
#line 15217 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("when");
}
#line 56532 "preproc.c" /* yacc.c:1652  */
    break;

  case 2756:
#line 15221 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("where");
}
#line 56540 "preproc.c" /* yacc.c:1652  */
    break;

  case 2757:
#line 15225 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("window");
}
#line 56548 "preproc.c" /* yacc.c:1652  */
    break;

  case 2758:
#line 15229 "preproc.y" /* yacc.c:1652  */
    { 
 (yyval.str) = mm_strdup("with");
}
#line 56556 "preproc.c" /* yacc.c:1652  */
    break;

  case 2761:
#line 15242 "preproc.y" /* yacc.c:1652  */
    { connection = NULL; }
#line 56562 "preproc.c" /* yacc.c:1652  */
    break;

  case 2763:
#line 15245 "preproc.y" /* yacc.c:1652  */
    {
					fprintf(base_yyout, "%s", (yyvsp[0].str));
					free((yyvsp[0].str));
					output_line_number();
				}
#line 56572 "preproc.c" /* yacc.c:1652  */
    break;

  case 2765:
#line 15251 "preproc.y" /* yacc.c:1652  */
    { fprintf(base_yyout, "%s", (yyvsp[0].str)); free((yyvsp[0].str)); }
#line 56578 "preproc.c" /* yacc.c:1652  */
    break;

  case 2766:
#line 15252 "preproc.y" /* yacc.c:1652  */
    { fprintf(base_yyout, "%s", (yyvsp[0].str)); free((yyvsp[0].str)); }
#line 56584 "preproc.c" /* yacc.c:1652  */
    break;

  case 2767:
#line 15253 "preproc.y" /* yacc.c:1652  */
    { braces_open++; fputs("{", base_yyout); }
#line 56590 "preproc.c" /* yacc.c:1652  */
    break;

  case 2768:
#line 15255 "preproc.y" /* yacc.c:1652  */
    {
			remove_typedefs(braces_open);
			remove_variables(braces_open--);
			if (braces_open == 0)
			{
				free(current_function);
				current_function = NULL;
			}
			fputs("}", base_yyout);
		}
#line 56605 "preproc.c" /* yacc.c:1652  */
    break;

  case 2769:
#line 15267 "preproc.y" /* yacc.c:1652  */
    {FoundInto = 0;}
#line 56611 "preproc.c" /* yacc.c:1652  */
    break;

  case 2770:
#line 15268 "preproc.y" /* yacc.c:1652  */
    {
			if (FoundInto == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "CREATE TABLE AS cannot specify INTO");

			(yyval.str) = cat_str(7, mm_strdup("create"), (yyvsp[-6].str), mm_strdup("table"), (yyvsp[-4].str), mm_strdup("as"), (yyvsp[-1].str), (yyvsp[0].str));
		}
#line 56622 "preproc.c" /* yacc.c:1652  */
    break;

  case 2771:
#line 15274 "preproc.y" /* yacc.c:1652  */
    {FoundInto = 0;}
#line 56628 "preproc.c" /* yacc.c:1652  */
    break;

  case 2772:
#line 15275 "preproc.y" /* yacc.c:1652  */
    {
			if (FoundInto == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "CREATE TABLE AS cannot specify INTO");

			(yyval.str) = cat_str(7, mm_strdup("create"), (yyvsp[-9].str), mm_strdup("table if not exists"), (yyvsp[-4].str), mm_strdup("as"), (yyvsp[-1].str), (yyvsp[0].str));
		}
#line 56639 "preproc.c" /* yacc.c:1652  */
    break;

  case 2773:
#line 15284 "preproc.y" /* yacc.c:1652  */
    {
			connection = (yyvsp[0].str);
			/*
			 * Do we have a variable as connection target?  Remove the variable
			 * from the variable list or else it will be used twice.
			 */
			if (argsinsert != NULL)
				argsinsert = NULL;
		}
#line 56653 "preproc.c" /* yacc.c:1652  */
    break;

  case 2774:
#line 15299 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(5, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str), mm_strdup(","), (yyvsp[-1].str)); }
#line 56659 "preproc.c" /* yacc.c:1652  */
    break;

  case 2775:
#line 15301 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("NULL, NULL, NULL, \"DEFAULT\""); }
#line 56665 "preproc.c" /* yacc.c:1652  */
    break;

  case 2776:
#line 15304 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("NULL,"), (yyvsp[0].str), mm_strdup(", NULL")); }
#line 56671 "preproc.c" /* yacc.c:1652  */
    break;

  case 2777:
#line 15306 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[0].str), mm_strdup(", NULL, NULL, NULL")); }
#line 56677 "preproc.c" /* yacc.c:1652  */
    break;

  case 2778:
#line 15310 "preproc.y" /* yacc.c:1652  */
    {
			/* old style: dbname[@server][:port] */
			if (strlen((yyvsp[-1].str)) > 0 && *((yyvsp[-1].str)) != '@')
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\", found \"%s\"", (yyvsp[-1].str));

			/* C strings need to be handled differently */
			if ((yyvsp[-2].str)[0] == '\"')
				(yyval.str) = (yyvsp[-2].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), make3_str((yyvsp[-2].str), (yyvsp[-1].str), (yyvsp[0].str)), mm_strdup("\""));
		}
#line 56693 "preproc.c" /* yacc.c:1652  */
    break;

  case 2779:
#line 15322 "preproc.y" /* yacc.c:1652  */
    {
			/* new style: <tcp|unix>:postgresql://server[:port][/dbname] */
			if (strncmp((yyvsp[-6].str), "unix:postgresql", strlen("unix:postgresql")) != 0 && strncmp((yyvsp[-6].str), "tcp:postgresql", strlen("tcp:postgresql")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "only protocols \"tcp\" and \"unix\" and database type \"postgresql\" are supported");

			if (strncmp((yyvsp[-4].str), "//", strlen("//")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"://\", found \"%s\"", (yyvsp[-4].str));

			if (strncmp((yyvsp[-6].str), "unix", strlen("unix")) == 0 &&
				strncmp((yyvsp[-4].str) + strlen("//"), "localhost", strlen("localhost")) != 0 &&
				strncmp((yyvsp[-4].str) + strlen("//"), "127.0.0.1", strlen("127.0.0.1")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "Unix-domain sockets only work on \"localhost\" but not on \"%s\"", (yyvsp[-4].str) + strlen("//"));

			(yyval.str) = make3_str(make3_str(mm_strdup("\""), (yyvsp[-6].str), mm_strdup(":")), (yyvsp[-4].str), make3_str(make3_str((yyvsp[-3].str), mm_strdup("/"), (yyvsp[-1].str)), (yyvsp[0].str), mm_strdup("\"")));
		}
#line 56713 "preproc.c" /* yacc.c:1652  */
    break;

  case 2780:
#line 15338 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = (yyvsp[0].str);
		}
#line 56721 "preproc.c" /* yacc.c:1652  */
    break;

  case 2781:
#line 15342 "preproc.y" /* yacc.c:1652  */
    {
			/* We can only process double quoted strings not single quotes ones,
			 * so we change the quotes.
			 * Note, that the rule for ecpg_sconst adds these single quotes. */
			(yyvsp[0].str)[0] = '\"';
			(yyvsp[0].str)[strlen((yyvsp[0].str))-1] = '\"';
			(yyval.str) = (yyvsp[0].str);
		}
#line 56734 "preproc.c" /* yacc.c:1652  */
    break;

  case 2782:
#line 15352 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 56740 "preproc.c" /* yacc.c:1652  */
    break;

  case 2783:
#line 15353 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 56746 "preproc.c" /* yacc.c:1652  */
    break;

  case 2784:
#line 15357 "preproc.y" /* yacc.c:1652  */
    {
			if (strcmp((yyvsp[0].str), "postgresql") != 0 && strcmp((yyvsp[0].str), "postgres") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"postgresql\", found \"%s\"", (yyvsp[0].str));

			if (strcmp((yyvsp[-1].str), "tcp") != 0 && strcmp((yyvsp[-1].str), "unix") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "invalid connection type: %s", (yyvsp[-1].str));

			(yyval.str) = make3_str((yyvsp[-1].str), mm_strdup(":"), (yyvsp[0].str));
		}
#line 56760 "preproc.c" /* yacc.c:1652  */
    break;

  case 2785:
#line 15369 "preproc.y" /* yacc.c:1652  */
    {
			if (strcmp((yyvsp[-1].str), "@") != 0 && strcmp((yyvsp[-1].str), "//") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\" or \"://\", found \"%s\"", (yyvsp[-1].str));

			(yyval.str) = make2_str((yyvsp[-1].str), (yyvsp[0].str));
		}
#line 56771 "preproc.c" /* yacc.c:1652  */
    break;

  case 2786:
#line 15377 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 56777 "preproc.c" /* yacc.c:1652  */
    break;

  case 2787:
#line 15378 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 56783 "preproc.c" /* yacc.c:1652  */
    break;

  case 2788:
#line 15381 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 56789 "preproc.c" /* yacc.c:1652  */
    break;

  case 2789:
#line 15382 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str((yyvsp[-2].str), mm_strdup("."), (yyvsp[0].str)); }
#line 56795 "preproc.c" /* yacc.c:1652  */
    break;

  case 2790:
#line 15383 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 56801 "preproc.c" /* yacc.c:1652  */
    break;

  case 2791:
#line 15386 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make2_str(mm_strdup(":"), (yyvsp[0].str)); }
#line 56807 "preproc.c" /* yacc.c:1652  */
    break;

  case 2792:
#line 15387 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 56813 "preproc.c" /* yacc.c:1652  */
    break;

  case 2793:
#line 15390 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 56819 "preproc.c" /* yacc.c:1652  */
    break;

  case 2794:
#line 15391 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("NULL"); }
#line 56825 "preproc.c" /* yacc.c:1652  */
    break;

  case 2795:
#line 15394 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 56831 "preproc.c" /* yacc.c:1652  */
    break;

  case 2796:
#line 15395 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("NULL, NULL"); }
#line 56837 "preproc.c" /* yacc.c:1652  */
    break;

  case 2797:
#line 15399 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[0].str), mm_strdup(", NULL")); }
#line 56843 "preproc.c" /* yacc.c:1652  */
    break;

  case 2798:
#line 15401 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 56849 "preproc.c" /* yacc.c:1652  */
    break;

  case 2799:
#line 15403 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-3].str), mm_strdup(","), (yyvsp[0].str)); }
#line 56855 "preproc.c" /* yacc.c:1652  */
    break;

  case 2800:
#line 15405 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 56861 "preproc.c" /* yacc.c:1652  */
    break;

  case 2801:
#line 15409 "preproc.y" /* yacc.c:1652  */
    {
			if ((yyvsp[0].str)[0] == '\"')
				(yyval.str) = (yyvsp[0].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
		}
#line 56872 "preproc.c" /* yacc.c:1652  */
    break;

  case 2802:
#line 15416 "preproc.y" /* yacc.c:1652  */
    {
			if ((yyvsp[0].str)[0] == '\"')
				(yyval.str) = (yyvsp[0].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
		}
#line 56883 "preproc.c" /* yacc.c:1652  */
    break;

  case 2803:
#line 15423 "preproc.y" /* yacc.c:1652  */
    {
			enum ECPGttype type = argsinsert->variable->type->type;

			/* if array see what's inside */
			if (type == ECPGt_array)
				type = argsinsert->variable->type->u.element->type;

			/* handle varchars */
			if (type == ECPGt_varchar)
				(yyval.str) = make2_str(mm_strdup(argsinsert->variable->name), mm_strdup(".arr"));
			else
				(yyval.str) = mm_strdup(argsinsert->variable->name);
		}
#line 56901 "preproc.c" /* yacc.c:1652  */
    break;

  case 2804:
#line 15439 "preproc.y" /* yacc.c:1652  */
    {
			/* check if we have a string variable */
			struct variable *p = find_variable((yyvsp[0].str));
			enum ECPGttype type = p->type->type;

			/* If we have just one character this is not a string */
			if (atol(p->type->size) == 1)
					mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
			else
			{
				/* if array see what's inside */
				if (type == ECPGt_array)
					type = p->type->u.element->type;

				switch (type)
				{
					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						(yyval.str) = (yyvsp[0].str);
						break;
					case ECPGt_varchar:
						(yyval.str) = make2_str((yyvsp[0].str), mm_strdup(".arr"));
						break;
					default:
						mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
						(yyval.str) = (yyvsp[0].str);
						break;
				}
			}
		}
#line 56937 "preproc.c" /* yacc.c:1652  */
    break;

  case 2805:
#line 15473 "preproc.y" /* yacc.c:1652  */
    {
			if (strlen((yyvsp[-1].str)) == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

			if (strcmp((yyvsp[-1].str), "?") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[-1].str));

			(yyval.str) = make2_str(mm_strdup("?"), (yyvsp[0].str));
		}
#line 56951 "preproc.c" /* yacc.c:1652  */
    break;

  case 2806:
#line 15482 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 56957 "preproc.c" /* yacc.c:1652  */
    break;

  case 2807:
#line 15486 "preproc.y" /* yacc.c:1652  */
    {
				(yyval.str) = make2_str((yyvsp[-1].str), (yyvsp[0].str));
			}
#line 56965 "preproc.c" /* yacc.c:1652  */
    break;

  case 2808:
#line 15490 "preproc.y" /* yacc.c:1652  */
    {
				if (strlen((yyvsp[-1].str)) == 0)
					mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

				if (strcmp((yyvsp[-1].str), "&") != 0)
					mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[-1].str));

				(yyval.str) = cat_str(3, make2_str((yyvsp[-3].str), (yyvsp[-2].str)), (yyvsp[-1].str), (yyvsp[0].str));
			}
#line 56979 "preproc.c" /* yacc.c:1652  */
    break;

  case 2809:
#line 15502 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 56985 "preproc.c" /* yacc.c:1652  */
    break;

  case 2810:
#line 15504 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 56991 "preproc.c" /* yacc.c:1652  */
    break;

  case 2811:
#line 15506 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 56997 "preproc.c" /* yacc.c:1652  */
    break;

  case 2812:
#line 15508 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 57003 "preproc.c" /* yacc.c:1652  */
    break;

  case 2813:
#line 15512 "preproc.y" /* yacc.c:1652  */
    {
			if ((yyvsp[0].str)[0] == '\"' && (yyvsp[0].str)[strlen((yyvsp[0].str))-1] == '\"') /* already quoted? */
				(yyval.str) = (yyvsp[0].str);
			else /* not quoted => convert to lowercase */
			{
				size_t i;

				for (i = 0; i< strlen((yyvsp[0].str)); i++)
					(yyvsp[0].str)[i] = tolower((unsigned char) (yyvsp[0].str)[i]);

				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
			}
		}
#line 57021 "preproc.c" /* yacc.c:1652  */
    break;

  case 2814:
#line 15525 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57027 "preproc.c" /* yacc.c:1652  */
    break;

  case 2815:
#line 15533 "preproc.y" /* yacc.c:1652  */
    {
			struct cursor *ptr, *this;
			char *cursor_marker = (yyvsp[-5].str)[0] == ':' ? mm_strdup("$0") : mm_strdup((yyvsp[-5].str));
			int (* strcmp_fn)(const char *, const char *) = (((yyvsp[-5].str)[0] == ':' || (yyvsp[-5].str)[0] == '"') ? strcmp : pg_strcasecmp);
			struct variable *thisquery = (struct variable *)mm_alloc(sizeof(struct variable));
			const char *con = connection ? connection : "NULL";
			char *comment;

			for (ptr = cur; ptr != NULL; ptr = ptr->next)
			{
				if (strcmp_fn((yyvsp[-5].str), ptr->name) == 0)
				{
					/* re-definition is a bug */
					if ((yyvsp[-5].str)[0] == ':')
						mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[-5].str)+1);
					else
						mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[-5].str));
				}
			}

			this = (struct cursor *) mm_alloc(sizeof(struct cursor));

			/* initial definition */
			this->next = cur;
			this->name = (yyvsp[-5].str);
			this->function = (current_function ? mm_strdup(current_function) : NULL);
			this->connection = connection;
			this->command =  cat_str(6, mm_strdup("declare"), cursor_marker, (yyvsp[-4].str), mm_strdup("cursor"), (yyvsp[-2].str), mm_strdup("for $1"));
			this->argsresult = NULL;
			this->argsresult_oos = NULL;

			thisquery->type = &ecpg_query;
			thisquery->brace_level = 0;
			thisquery->next = NULL;
			thisquery->name = (char *) mm_alloc(sizeof("ECPGprepared_statement(, , __LINE__)") + strlen(con) + strlen((yyvsp[0].str)));
			sprintf(thisquery->name, "ECPGprepared_statement(%s, %s, __LINE__)", con, (yyvsp[0].str));

			this->argsinsert = NULL;
			this->argsinsert_oos = NULL;
			if ((yyvsp[-5].str)[0] == ':')
			{
				struct variable *var = find_variable((yyvsp[-5].str) + 1);
				remove_variable_from_list(&argsinsert, var);
				add_variable_to_head(&(this->argsinsert), var, &no_indicator);
			}
			add_variable_to_head(&(this->argsinsert), thisquery, &no_indicator);

			cur = this;

			comment = cat_str(3, mm_strdup("/*"), mm_strdup(this->command), mm_strdup("*/"));

			(yyval.str) = cat_str(2, adjust_outofscope_cursor_vars(this),
					comment);
		}
#line 57086 "preproc.c" /* yacc.c:1652  */
    break;

  case 2816:
#line 15590 "preproc.y" /* yacc.c:1652  */
    {
			  /* execute immediate means prepare the statement and
			   * immediately execute it */
			  (yyval.str) = (yyvsp[0].str);
			}
#line 57096 "preproc.c" /* yacc.c:1652  */
    break;

  case 2818:
#line 15600 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57102 "preproc.c" /* yacc.c:1652  */
    break;

  case 2819:
#line 15601 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57108 "preproc.c" /* yacc.c:1652  */
    break;

  case 2820:
#line 15604 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57114 "preproc.c" /* yacc.c:1652  */
    break;

  case 2821:
#line 15606 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57120 "preproc.c" /* yacc.c:1652  */
    break;

  case 2822:
#line 15607 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 57126 "preproc.c" /* yacc.c:1652  */
    break;

  case 2823:
#line 15610 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57132 "preproc.c" /* yacc.c:1652  */
    break;

  case 2824:
#line 15611 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("year to minute"); }
#line 57138 "preproc.c" /* yacc.c:1652  */
    break;

  case 2825:
#line 15612 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("year to second"); }
#line 57144 "preproc.c" /* yacc.c:1652  */
    break;

  case 2826:
#line 15613 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("day to day"); }
#line 57150 "preproc.c" /* yacc.c:1652  */
    break;

  case 2827:
#line 15614 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("month to month"); }
#line 57156 "preproc.c" /* yacc.c:1652  */
    break;

  case 2828:
#line 15621 "preproc.y" /* yacc.c:1652  */
    { fputs("/* exec sql begin declare section */", base_yyout); }
#line 57162 "preproc.c" /* yacc.c:1652  */
    break;

  case 2829:
#line 15623 "preproc.y" /* yacc.c:1652  */
    {
			fprintf(base_yyout, "%s/* exec sql end declare section */", (yyvsp[-1].str));
			free((yyvsp[-1].str));
			output_line_number();
		}
#line 57172 "preproc.c" /* yacc.c:1652  */
    break;

  case 2830:
#line 15630 "preproc.y" /* yacc.c:1652  */
    {}
#line 57178 "preproc.c" /* yacc.c:1652  */
    break;

  case 2831:
#line 15632 "preproc.y" /* yacc.c:1652  */
    {}
#line 57184 "preproc.c" /* yacc.c:1652  */
    break;

  case 2832:
#line 15634 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 57190 "preproc.c" /* yacc.c:1652  */
    break;

  case 2833:
#line 15635 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57196 "preproc.c" /* yacc.c:1652  */
    break;

  case 2834:
#line 15638 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57202 "preproc.c" /* yacc.c:1652  */
    break;

  case 2835:
#line 15639 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57208 "preproc.c" /* yacc.c:1652  */
    break;

  case 2836:
#line 15640 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 57214 "preproc.c" /* yacc.c:1652  */
    break;

  case 2837:
#line 15641 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 57220 "preproc.c" /* yacc.c:1652  */
    break;

  case 2838:
#line 15644 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57226 "preproc.c" /* yacc.c:1652  */
    break;

  case 2839:
#line 15645 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 57232 "preproc.c" /* yacc.c:1652  */
    break;

  case 2840:
#line 15649 "preproc.y" /* yacc.c:1652  */
    {
		/* reset this variable so we see if there was */
		/* an initializer specified */
		initializer = 0;
	}
#line 57242 "preproc.c" /* yacc.c:1652  */
    break;

  case 2841:
#line 15655 "preproc.y" /* yacc.c:1652  */
    {
		add_typedef((yyvsp[-2].str), (yyvsp[-1].index).index1, (yyvsp[-1].index).index2, (yyvsp[-4].type).type_enum, (yyvsp[-4].type).type_dimension, (yyvsp[-4].type).type_index, initializer, *(yyvsp[-3].str) ? 1 : 0);

		fprintf(base_yyout, "typedef %s %s %s %s;\n", (yyvsp[-4].type).type_str, *(yyvsp[-3].str) ? "*" : "", (yyvsp[-2].str), (yyvsp[-1].index).str);
		output_line_number();
		(yyval.str) = mm_strdup("");
	}
#line 57254 "preproc.c" /* yacc.c:1652  */
    break;

  case 2842:
#line 15665 "preproc.y" /* yacc.c:1652  */
    {
			actual_type[struct_level].type_enum = (yyvsp[0].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[0].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[0].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[0].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[0].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		}
#line 57268 "preproc.c" /* yacc.c:1652  */
    break;

  case 2843:
#line 15675 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = cat_str(5, actual_startline[struct_level], (yyvsp[-4].str), (yyvsp[-3].type).type_str, (yyvsp[-1].str), mm_strdup(";\n"));
		}
#line 57276 "preproc.c" /* yacc.c:1652  */
    break;

  case 2844:
#line 15679 "preproc.y" /* yacc.c:1652  */
    {
			actual_type[struct_level].type_enum = (yyvsp[0].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[0].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[0].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[0].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[0].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		}
#line 57290 "preproc.c" /* yacc.c:1652  */
    break;

  case 2845:
#line 15689 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = cat_str(4, actual_startline[struct_level], (yyvsp[-3].type).type_str, (yyvsp[-1].str), mm_strdup(";\n"));
		}
#line 57298 "preproc.c" /* yacc.c:1652  */
    break;

  case 2846:
#line 15693 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = cat2_str((yyvsp[-1].str), mm_strdup(";"));
		}
#line 57306 "preproc.c" /* yacc.c:1652  */
    break;

  case 2847:
#line 15698 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) =cat2_str(mm_strdup(":"), (yyvsp[0].str)); }
#line 57312 "preproc.c" /* yacc.c:1652  */
    break;

  case 2848:
#line 15699 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 57318 "preproc.c" /* yacc.c:1652  */
    break;

  case 2849:
#line 15703 "preproc.y" /* yacc.c:1652  */
    {(yyval.str) = cat2_str ((yyvsp[-1].str), (yyvsp[0].str)); }
#line 57324 "preproc.c" /* yacc.c:1652  */
    break;

  case 2850:
#line 15704 "preproc.y" /* yacc.c:1652  */
    {(yyval.str) = (yyvsp[0].str); }
#line 57330 "preproc.c" /* yacc.c:1652  */
    break;

  case 2851:
#line 15705 "preproc.y" /* yacc.c:1652  */
    {(yyval.str) = (yyvsp[0].str); }
#line 57336 "preproc.c" /* yacc.c:1652  */
    break;

  case 2852:
#line 15708 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("extern"); }
#line 57342 "preproc.c" /* yacc.c:1652  */
    break;

  case 2853:
#line 15709 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("static"); }
#line 57348 "preproc.c" /* yacc.c:1652  */
    break;

  case 2854:
#line 15710 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("register"); }
#line 57354 "preproc.c" /* yacc.c:1652  */
    break;

  case 2855:
#line 15711 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("auto"); }
#line 57360 "preproc.c" /* yacc.c:1652  */
    break;

  case 2856:
#line 15714 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("const"); }
#line 57366 "preproc.c" /* yacc.c:1652  */
    break;

  case 2857:
#line 15715 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("volatile"); }
#line 57372 "preproc.c" /* yacc.c:1652  */
    break;

  case 2858:
#line 15719 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.type).type_enum = (yyvsp[0].type_enum);
			(yyval.type).type_str = mm_strdup(ecpg_type_name((yyvsp[0].type_enum)));
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 57384 "preproc.c" /* yacc.c:1652  */
    break;

  case 2859:
#line 15727 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.type).type_str = (yyvsp[0].str);
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");

			if (strncmp((yyvsp[0].str), "struct", sizeof("struct")-1) == 0)
			{
				(yyval.type).type_enum = ECPGt_struct;
				(yyval.type).type_sizeof = ECPGstruct_sizeof;
			}
			else
			{
				(yyval.type).type_enum = ECPGt_union;
				(yyval.type).type_sizeof = NULL;
			}
		}
#line 57405 "preproc.c" /* yacc.c:1652  */
    break;

  case 2860:
#line 15744 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.type).type_str = (yyvsp[0].str);
			(yyval.type).type_enum = ECPGt_int;
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 57417 "preproc.c" /* yacc.c:1652  */
    break;

  case 2861:
#line 15752 "preproc.y" /* yacc.c:1652  */
    {
			if (strcmp((yyvsp[-4].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
			}
			else if (strcmp((yyvsp[-4].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = mm_strdup("decimal");
			}
			else
			{
				mmerror(PARSE_ERROR, ET_ERROR, "only data types numeric and decimal have precision/scale argument");
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
			}

			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 57444 "preproc.c" /* yacc.c:1652  */
    break;

  case 2862:
#line 15775 "preproc.y" /* yacc.c:1652  */
    {
			if (strlen((yyvsp[0].str)) != 0 && strcmp ((yyvsp[-1].str), "datetime") != 0 && strcmp ((yyvsp[-1].str), "interval") != 0)
				mmerror (PARSE_ERROR, ET_ERROR, "interval specification not allowed here");

			/*
			 * Check for type names that the SQL grammar treats as
			 * unreserved keywords
			 */
			if (strcmp((yyvsp[-1].str), "varchar") == 0)
			{
				(yyval.type).type_enum = ECPGt_varchar;
				(yyval.type).type_str = EMPTY; /*mm_strdup("varchar");*/
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "bytea") == 0)
			{
				(yyval.type).type_enum = ECPGt_bytea;
				(yyval.type).type_str = EMPTY;
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "float") == 0)
			{
				(yyval.type).type_enum = ECPGt_float;
				(yyval.type).type_str = mm_strdup("float");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "double") == 0)
			{
				(yyval.type).type_enum = ECPGt_double;
				(yyval.type).type_str = mm_strdup("double");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = mm_strdup("decimal");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "date") == 0)
			{
				(yyval.type).type_enum = ECPGt_date;
				(yyval.type).type_str = mm_strdup("date");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "timestamp") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = mm_strdup("timestamp");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "interval") == 0)
			{
				(yyval.type).type_enum = ECPGt_interval;
				(yyval.type).type_str = mm_strdup("interval");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "datetime") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = mm_strdup("timestamp");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if ((strcmp((yyvsp[-1].str), "string") == 0) && INFORMIX_MODE)
			{
				(yyval.type).type_enum = ECPGt_string;
				(yyval.type).type_str = mm_strdup("char");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else
			{
				/* this is for typedef'ed types */
				struct typedefs *this = get_typedef((yyvsp[-1].str));

				(yyval.type).type_str = (this->type->type_enum == ECPGt_varchar || this->type->type_enum == ECPGt_bytea) ? EMPTY : mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				if (this->type->type_sizeof && strlen(this->type->type_sizeof) != 0)
					(yyval.type).type_sizeof = this->type->type_sizeof;
				else
					(yyval.type).type_sizeof = cat_str(3, mm_strdup("sizeof("), mm_strdup(this->name), mm_strdup(")"));

				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
			}
		}
#line 57562 "preproc.c" /* yacc.c:1652  */
    break;

  case 2863:
#line 15889 "preproc.y" /* yacc.c:1652  */
    {
			/* this is for named structs/unions */
			char *name;
			struct typedefs *this;
			bool forward = (forward_name != NULL && strcmp((yyvsp[0].struct_union).symbol, forward_name) == 0 && strcmp((yyvsp[0].struct_union).su, "struct") == 0);

			name = cat2_str((yyvsp[0].struct_union).su, (yyvsp[0].struct_union).symbol);
			/* Do we have a forward definition? */
			if (!forward)
			{
				/* No */

				this = get_typedef(name);
				(yyval.type).type_str = mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				(yyval.type).type_sizeof = this->type->type_sizeof;
				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
				free(name);
			}
			else
			{
				(yyval.type).type_str = name;
				(yyval.type).type_enum = ECPGt_long;
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = mm_strdup("");
				struct_member_list[struct_level] = NULL;
			}
		}
#line 57598 "preproc.c" /* yacc.c:1652  */
    break;

  case 2864:
#line 15923 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("enum"), (yyvsp[-1].str), (yyvsp[0].str)); }
#line 57604 "preproc.c" /* yacc.c:1652  */
    break;

  case 2865:
#line 15925 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str(mm_strdup("enum"), (yyvsp[0].str)); }
#line 57610 "preproc.c" /* yacc.c:1652  */
    break;

  case 2866:
#line 15927 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str(mm_strdup("enum"), (yyvsp[0].str)); }
#line 57616 "preproc.c" /* yacc.c:1652  */
    break;

  case 2867:
#line 15931 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}")); }
#line 57622 "preproc.c" /* yacc.c:1652  */
    break;

  case 2868:
#line 15934 "preproc.y" /* yacc.c:1652  */
    {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
			forward_name = mm_strdup((yyvsp[0].struct_union).symbol);
		}
#line 57633 "preproc.c" /* yacc.c:1652  */
    break;

  case 2869:
#line 15941 "preproc.y" /* yacc.c:1652  */
    {
			struct typedefs *ptr, *this;
			struct this_type su_type;

			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			if (strncmp((yyvsp[-4].struct_union).su, "struct", sizeof("struct")-1) == 0)
				su_type.type_enum = ECPGt_struct;
			else
				su_type.type_enum = ECPGt_union;
			su_type.type_str = cat2_str((yyvsp[-4].struct_union).su, (yyvsp[-4].struct_union).symbol);
			free(forward_name);
			forward_name = NULL;

			/* This is essentially a typedef but needs the keyword struct/union as well.
			 * So we create the typedef for each struct definition with symbol */
			for (ptr = types; ptr != NULL; ptr = ptr->next)
			{
					if (strcmp(su_type.type_str, ptr->name) == 0)
							/* re-definition is a bug */
							mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", su_type.type_str);
			}

			this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

			/* initial definition */
			this->next = types;
			this->name = mm_strdup(su_type.type_str);
			this->brace_level = braces_open;
			this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
			this->type->type_enum = su_type.type_enum;
			this->type->type_str = mm_strdup(su_type.type_str);
			this->type->type_dimension = mm_strdup("-1"); /* dimension of array */
			this->type->type_index = mm_strdup("-1");	/* length of string */
			this->type->type_sizeof = ECPGstruct_sizeof;
			this->struct_member_list = struct_member_list[struct_level];

			types = this;
			(yyval.str) = cat_str(4, su_type.type_str, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}"));
		}
#line 57679 "preproc.c" /* yacc.c:1652  */
    break;

  case 2870:
#line 15984 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57685 "preproc.c" /* yacc.c:1652  */
    break;

  case 2871:
#line 15986 "preproc.y" /* yacc.c:1652  */
    {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
		}
#line 57695 "preproc.c" /* yacc.c:1652  */
    break;

  case 2872:
#line 15992 "preproc.y" /* yacc.c:1652  */
    {
			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			(yyval.str) = cat_str(4, (yyvsp[-4].str), mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}"));
		}
#line 57706 "preproc.c" /* yacc.c:1652  */
    break;

  case 2873:
#line 16001 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.struct_union).su = mm_strdup("struct");
			(yyval.struct_union).symbol = (yyvsp[0].str);
			ECPGstruct_sizeof = cat_str(3, mm_strdup("sizeof("), cat2_str(mm_strdup((yyval.struct_union).su), mm_strdup((yyval.struct_union).symbol)), mm_strdup(")"));
		}
#line 57716 "preproc.c" /* yacc.c:1652  */
    break;

  case 2874:
#line 16007 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.struct_union).su = mm_strdup("union");
			(yyval.struct_union).symbol = (yyvsp[0].str);
		}
#line 57725 "preproc.c" /* yacc.c:1652  */
    break;

  case 2875:
#line 16014 "preproc.y" /* yacc.c:1652  */
    {
			ECPGstruct_sizeof = mm_strdup(""); /* This must not be NULL to distinguish from simple types. */
			(yyval.str) = mm_strdup("struct");
		}
#line 57734 "preproc.c" /* yacc.c:1652  */
    break;

  case 2876:
#line 16019 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = mm_strdup("union");
		}
#line 57742 "preproc.c" /* yacc.c:1652  */
    break;

  case 2877:
#line 16024 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum)=(yyvsp[0].type_enum); }
#line 57748 "preproc.c" /* yacc.c:1652  */
    break;

  case 2878:
#line 16025 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum)=(yyvsp[0].type_enum); }
#line 57754 "preproc.c" /* yacc.c:1652  */
    break;

  case 2879:
#line 16028 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_short; }
#line 57760 "preproc.c" /* yacc.c:1652  */
    break;

  case 2880:
#line 16029 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_short; }
#line 57766 "preproc.c" /* yacc.c:1652  */
    break;

  case 2881:
#line 16030 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_int; }
#line 57772 "preproc.c" /* yacc.c:1652  */
    break;

  case 2882:
#line 16031 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_int; }
#line 57778 "preproc.c" /* yacc.c:1652  */
    break;

  case 2883:
#line 16032 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_long; }
#line 57784 "preproc.c" /* yacc.c:1652  */
    break;

  case 2884:
#line 16033 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_long; }
#line 57790 "preproc.c" /* yacc.c:1652  */
    break;

  case 2885:
#line 16034 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_long_long; }
#line 57796 "preproc.c" /* yacc.c:1652  */
    break;

  case 2886:
#line 16035 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_long_long; }
#line 57802 "preproc.c" /* yacc.c:1652  */
    break;

  case 2887:
#line 16036 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_unsigned_char; }
#line 57808 "preproc.c" /* yacc.c:1652  */
    break;

  case 2888:
#line 16039 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_short; }
#line 57814 "preproc.c" /* yacc.c:1652  */
    break;

  case 2889:
#line 16040 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_short; }
#line 57820 "preproc.c" /* yacc.c:1652  */
    break;

  case 2890:
#line 16041 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_int; }
#line 57826 "preproc.c" /* yacc.c:1652  */
    break;

  case 2891:
#line 16042 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_long; }
#line 57832 "preproc.c" /* yacc.c:1652  */
    break;

  case 2892:
#line 16043 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_long; }
#line 57838 "preproc.c" /* yacc.c:1652  */
    break;

  case 2893:
#line 16044 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_long_long; }
#line 57844 "preproc.c" /* yacc.c:1652  */
    break;

  case 2894:
#line 16045 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_long_long; }
#line 57850 "preproc.c" /* yacc.c:1652  */
    break;

  case 2895:
#line 16046 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_bool; }
#line 57856 "preproc.c" /* yacc.c:1652  */
    break;

  case 2896:
#line 16047 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_char; }
#line 57862 "preproc.c" /* yacc.c:1652  */
    break;

  case 2897:
#line 16048 "preproc.y" /* yacc.c:1652  */
    { (yyval.type_enum) = ECPGt_double; }
#line 57868 "preproc.c" /* yacc.c:1652  */
    break;

  case 2900:
#line 16056 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 57874 "preproc.c" /* yacc.c:1652  */
    break;

  case 2901:
#line 16058 "preproc.y" /* yacc.c:1652  */
    {
			if (actual_type[struct_level].type_enum == ECPGt_varchar || actual_type[struct_level].type_enum == ECPGt_bytea)
				(yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(";"), (yyvsp[0].str));
			else
				(yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str));
		}
#line 57885 "preproc.c" /* yacc.c:1652  */
    break;

  case 2902:
#line 16067 "preproc.y" /* yacc.c:1652  */
    {
			struct ECPGtype * type;
			char *dimension = (yyvsp[-2].index).index1;	/* dimension of array */
			char *length = (yyvsp[-2].index).index2;		/* length of string */
			char *dim_str;
			char *vcn;
			int *varlen_type_counter;
			char *struct_name;

			adjust_array(actual_type[struct_level].type_enum, &dimension, &length, actual_type[struct_level].type_dimension, actual_type[struct_level].type_index, strlen((yyvsp[-4].str)), false);
			switch (actual_type[struct_level].type_enum)
			{
				case ECPGt_struct:
				case ECPGt_union:
					if (atoi(dimension) < 0)
						type = ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof);
					else
						type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;

				case ECPGt_varchar:
				case ECPGt_bytea:
					if (actual_type[struct_level].type_enum == ECPGt_varchar)
					{
						varlen_type_counter = &varchar_counter;
						struct_name = " struct varchar_";
					}
					else
					{
						varlen_type_counter = &bytea_counter;
						struct_name = " struct bytea_";
					}
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, *varlen_type_counter);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, *varlen_type_counter), dimension);

					if (strcmp(dimension, "0") == 0 || abs(atoi(dimension)) == 1)
							dim_str=mm_strdup("");
					else
							dim_str=cat_str(3, mm_strdup("["), mm_strdup(dimension), mm_strdup("]"));
					/* cannot check for atoi <= 0 because a defined constant will yield 0 here as well */
					if (atoi(length) < 0 || strcmp(length, "0") == 0)
						mmerror(PARSE_ERROR, ET_ERROR, "pointers to varchar are not implemented");

					/* make sure varchar struct name is unique by adding a unique counter to its definition */
					vcn = (char *) mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
					sprintf(vcn, "%d", *varlen_type_counter);
					if (strcmp(dimension, "0") == 0)
						(yyval.str) = cat_str(7, make2_str(mm_strdup(struct_name), vcn), mm_strdup(" { int len; char arr["), mm_strdup(length), mm_strdup("]; } *"), mm_strdup((yyvsp[-3].str)), (yyvsp[-1].str), (yyvsp[0].str));
					else
						(yyval.str) = cat_str(8, make2_str(mm_strdup(struct_name), vcn), mm_strdup(" { int len; char arr["), mm_strdup(length), mm_strdup("]; } "), mm_strdup((yyvsp[-3].str)), dim_str, (yyvsp[-1].str), (yyvsp[0].str));
					(*varlen_type_counter)++;
					break;

				case ECPGt_char:
				case ECPGt_unsigned_char:
				case ECPGt_string:
					if (atoi(dimension) == -1)
					{
						int i = strlen((yyvsp[0].str));

						if (atoi(length) == -1 && i > 0) /* char <var>[] = "string" */
						{
							/* if we have an initializer but no string size set, let's use the initializer's length */
							free(length);
							length = mm_alloc(i+sizeof("sizeof()"));
							sprintf(length, "sizeof(%s)", (yyvsp[0].str)+2);
						}
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0);
					}
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;

				default:
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, mm_strdup("1"), 0);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, mm_strdup("1"), 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;
			}

			if (struct_level == 0)
				new_variable((yyvsp[-3].str), type, braces_open);
			else
				ECPGmake_struct_member((yyvsp[-3].str), type, &(struct_member_list[struct_level - 1]));

			free((yyvsp[-3].str));
		}
#line 57986 "preproc.c" /* yacc.c:1652  */
    break;

  case 2903:
#line 16166 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 57992 "preproc.c" /* yacc.c:1652  */
    break;

  case 2904:
#line 16168 "preproc.y" /* yacc.c:1652  */
    {
			initializer = 1;
			(yyval.str) = cat2_str(mm_strdup("="), (yyvsp[0].str));
		}
#line 58001 "preproc.c" /* yacc.c:1652  */
    break;

  case 2905:
#line 16174 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 58007 "preproc.c" /* yacc.c:1652  */
    break;

  case 2906:
#line 16175 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("*"); }
#line 58013 "preproc.c" /* yacc.c:1652  */
    break;

  case 2907:
#line 16176 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("**"); }
#line 58019 "preproc.c" /* yacc.c:1652  */
    break;

  case 2908:
#line 16183 "preproc.y" /* yacc.c:1652  */
    {
			/* this is only supported for compatibility */
			(yyval.str) = cat_str(3, mm_strdup("/* declare statement"), (yyvsp[0].str), mm_strdup("*/"));
		}
#line 58028 "preproc.c" /* yacc.c:1652  */
    break;

  case 2909:
#line 16191 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58034 "preproc.c" /* yacc.c:1652  */
    break;

  case 2910:
#line 16194 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58040 "preproc.c" /* yacc.c:1652  */
    break;

  case 2911:
#line 16195 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("\"CURRENT\""); }
#line 58046 "preproc.c" /* yacc.c:1652  */
    break;

  case 2912:
#line 16196 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("\"ALL\""); }
#line 58052 "preproc.c" /* yacc.c:1652  */
    break;

  case 2913:
#line 16197 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("\"CURRENT\""); }
#line 58058 "preproc.c" /* yacc.c:1652  */
    break;

  case 2914:
#line 16200 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 58064 "preproc.c" /* yacc.c:1652  */
    break;

  case 2915:
#line 16201 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("\"DEFAULT\""); }
#line 58070 "preproc.c" /* yacc.c:1652  */
    break;

  case 2916:
#line 16202 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58076 "preproc.c" /* yacc.c:1652  */
    break;

  case 2917:
#line 16206 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58082 "preproc.c" /* yacc.c:1652  */
    break;

  case 2918:
#line 16208 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 58088 "preproc.c" /* yacc.c:1652  */
    break;

  case 2919:
#line 16215 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58094 "preproc.c" /* yacc.c:1652  */
    break;

  case 2920:
#line 16216 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("all"); }
#line 58100 "preproc.c" /* yacc.c:1652  */
    break;

  case 2921:
#line 16223 "preproc.y" /* yacc.c:1652  */
    {
			if ((yyvsp[-1].str)[0] == ':')
				remove_variable_from_list(&argsinsert, find_variable((yyvsp[-1].str) + 1));
			(yyval.str) = (yyvsp[-1].str);
		}
#line 58110 "preproc.c" /* yacc.c:1652  */
    break;

  case 2922:
#line 16230 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 58116 "preproc.c" /* yacc.c:1652  */
    break;

  case 2923:
#line 16231 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58122 "preproc.c" /* yacc.c:1652  */
    break;

  case 2924:
#line 16234 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 58128 "preproc.c" /* yacc.c:1652  */
    break;

  case 2925:
#line 16235 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58134 "preproc.c" /* yacc.c:1652  */
    break;

  case 2926:
#line 16239 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsinsert, descriptor_variable((yyvsp[0].str),0), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 58143 "preproc.c" /* yacc.c:1652  */
    break;

  case 2927:
#line 16244 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsinsert, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 58152 "preproc.c" /* yacc.c:1652  */
    break;

  case 2928:
#line 16251 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsresult, descriptor_variable((yyvsp[0].str),1), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 58161 "preproc.c" /* yacc.c:1652  */
    break;

  case 2929:
#line 16256 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 58170 "preproc.c" /* yacc.c:1652  */
    break;

  case 2930:
#line 16263 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 58179 "preproc.c" /* yacc.c:1652  */
    break;

  case 2933:
#line 16272 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(32);

			sprintf(length, "%zu", strlen((yyvsp[0].str)));
			add_variable_to_head(&argsinsert, new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0), &no_indicator);
		}
#line 58190 "preproc.c" /* yacc.c:1652  */
    break;

  case 2934:
#line 16278 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 58196 "preproc.c" /* yacc.c:1652  */
    break;

  case 2935:
#line 16279 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 58202 "preproc.c" /* yacc.c:1652  */
    break;

  case 2936:
#line 16282 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58208 "preproc.c" /* yacc.c:1652  */
    break;

  case 2937:
#line 16283 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(2, mm_strdup("+"), (yyvsp[0].str)); }
#line 58214 "preproc.c" /* yacc.c:1652  */
    break;

  case 2938:
#line 16284 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(2, mm_strdup("-"), (yyvsp[0].str)); }
#line 58220 "preproc.c" /* yacc.c:1652  */
    break;

  case 2939:
#line 16285 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58226 "preproc.c" /* yacc.c:1652  */
    break;

  case 2940:
#line 16286 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(2, mm_strdup("+"), (yyvsp[0].str)); }
#line 58232 "preproc.c" /* yacc.c:1652  */
    break;

  case 2941:
#line 16287 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(2, mm_strdup("-"), (yyvsp[0].str)); }
#line 58238 "preproc.c" /* yacc.c:1652  */
    break;

  case 2942:
#line 16288 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58244 "preproc.c" /* yacc.c:1652  */
    break;

  case 2943:
#line 16289 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58250 "preproc.c" /* yacc.c:1652  */
    break;

  case 2944:
#line 16290 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58256 "preproc.c" /* yacc.c:1652  */
    break;

  case 2945:
#line 16297 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[-1].str));
	}
#line 58267 "preproc.c" /* yacc.c:1652  */
    break;

  case 2946:
#line 16304 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);

		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 58283 "preproc.c" /* yacc.c:1652  */
    break;

  case 2947:
#line 16316 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 58293 "preproc.c" /* yacc.c:1652  */
    break;

  case 2948:
#line 16322 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[-1].str));
	}
#line 58304 "preproc.c" /* yacc.c:1652  */
    break;

  case 2949:
#line 16329 "preproc.y" /* yacc.c:1652  */
    {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 58314 "preproc.c" /* yacc.c:1652  */
    break;

  case 2950:
#line 16336 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("output"); }
#line 58320 "preproc.c" /* yacc.c:1652  */
    break;

  case 2951:
#line 16337 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 58326 "preproc.c" /* yacc.c:1652  */
    break;

  case 2952:
#line 16350 "preproc.y" /* yacc.c:1652  */
    {
			add_descriptor((yyvsp[0].str),connection);
			(yyval.str) = (yyvsp[0].str);
		}
#line 58335 "preproc.c" /* yacc.c:1652  */
    break;

  case 2953:
#line 16361 "preproc.y" /* yacc.c:1652  */
    {
			drop_descriptor((yyvsp[0].str),connection);
			(yyval.str) = (yyvsp[0].str);
		}
#line 58344 "preproc.c" /* yacc.c:1652  */
    break;

  case 2954:
#line 16372 "preproc.y" /* yacc.c:1652  */
    {  (yyval.str) = (yyvsp[-1].str); }
#line 58350 "preproc.c" /* yacc.c:1652  */
    break;

  case 2957:
#line 16380 "preproc.y" /* yacc.c:1652  */
    { push_assignment((yyvsp[-2].str), (yyvsp[0].dtype_enum)); }
#line 58356 "preproc.c" /* yacc.c:1652  */
    break;

  case 2958:
#line 16385 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[-1].str); }
#line 58362 "preproc.c" /* yacc.c:1652  */
    break;

  case 2961:
#line 16393 "preproc.y" /* yacc.c:1652  */
    {
			push_assignment((yyvsp[0].str), (yyvsp[-2].dtype_enum));
		}
#line 58370 "preproc.c" /* yacc.c:1652  */
    break;

  case 2962:
#line 16399 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

			sprintf(length, "%zu", strlen((yyvsp[0].str)));
			new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = (yyvsp[0].str);
		}
#line 58382 "preproc.c" /* yacc.c:1652  */
    break;

  case 2963:
#line 16407 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = (yyvsp[0].str);
		}
#line 58390 "preproc.c" /* yacc.c:1652  */
    break;

  case 2964:
#line 16412 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_count; }
#line 58396 "preproc.c" /* yacc.c:1652  */
    break;

  case 2965:
#line 16420 "preproc.y" /* yacc.c:1652  */
    {  (yyval.descriptor).str = (yyvsp[-1].str); (yyval.descriptor).name = (yyvsp[-3].str); }
#line 58402 "preproc.c" /* yacc.c:1652  */
    break;

  case 2968:
#line 16427 "preproc.y" /* yacc.c:1652  */
    { push_assignment((yyvsp[-2].str), (yyvsp[0].dtype_enum)); }
#line 58408 "preproc.c" /* yacc.c:1652  */
    break;

  case 2969:
#line 16431 "preproc.y" /* yacc.c:1652  */
    {  (yyval.descriptor).str = (yyvsp[-1].str); (yyval.descriptor).name = (yyvsp[-3].str); }
#line 58414 "preproc.c" /* yacc.c:1652  */
    break;

  case 2972:
#line 16439 "preproc.y" /* yacc.c:1652  */
    {
			push_assignment((yyvsp[0].str), (yyvsp[-2].dtype_enum));
		}
#line 58422 "preproc.c" /* yacc.c:1652  */
    break;

  case 2973:
#line 16445 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

			sprintf(length, "%zu", strlen((yyvsp[0].str)));
			new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = (yyvsp[0].str);
		}
#line 58434 "preproc.c" /* yacc.c:1652  */
    break;

  case 2974:
#line 16454 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.str) = (yyvsp[0].str);
		}
#line 58442 "preproc.c" /* yacc.c:1652  */
    break;

  case 2975:
#line 16459 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = cat2_str(mm_strdup("-"), (yyvsp[0].str));

			sprintf(length, "%zu", strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 58455 "preproc.c" /* yacc.c:1652  */
    break;

  case 2976:
#line 16469 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = cat2_str(mm_strdup("-"), (yyvsp[0].str));

			sprintf(length, "%zu", strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 58468 "preproc.c" /* yacc.c:1652  */
    break;

  case 2977:
#line 16479 "preproc.y" /* yacc.c:1652  */
    {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = (yyvsp[0].str) + 1;

			var[strlen(var) - 1] = '\0';
			sprintf(length, "%zu", strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 58482 "preproc.c" /* yacc.c:1652  */
    break;

  case 2978:
#line 16490 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_cardinality; }
#line 58488 "preproc.c" /* yacc.c:1652  */
    break;

  case 2979:
#line 16491 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_data; }
#line 58494 "preproc.c" /* yacc.c:1652  */
    break;

  case 2980:
#line 16492 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_di_code; }
#line 58500 "preproc.c" /* yacc.c:1652  */
    break;

  case 2981:
#line 16493 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_di_precision; }
#line 58506 "preproc.c" /* yacc.c:1652  */
    break;

  case 2982:
#line 16494 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_indicator; }
#line 58512 "preproc.c" /* yacc.c:1652  */
    break;

  case 2983:
#line 16495 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_key_member; }
#line 58518 "preproc.c" /* yacc.c:1652  */
    break;

  case 2984:
#line 16496 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_length; }
#line 58524 "preproc.c" /* yacc.c:1652  */
    break;

  case 2985:
#line 16497 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_name; }
#line 58530 "preproc.c" /* yacc.c:1652  */
    break;

  case 2986:
#line 16498 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_nullable; }
#line 58536 "preproc.c" /* yacc.c:1652  */
    break;

  case 2987:
#line 16499 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_octet; }
#line 58542 "preproc.c" /* yacc.c:1652  */
    break;

  case 2988:
#line 16500 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_precision; }
#line 58548 "preproc.c" /* yacc.c:1652  */
    break;

  case 2989:
#line 16501 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_length; }
#line 58554 "preproc.c" /* yacc.c:1652  */
    break;

  case 2990:
#line 16502 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_ret_octet; }
#line 58560 "preproc.c" /* yacc.c:1652  */
    break;

  case 2991:
#line 16503 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_scale; }
#line 58566 "preproc.c" /* yacc.c:1652  */
    break;

  case 2992:
#line 16504 "preproc.y" /* yacc.c:1652  */
    { (yyval.dtype_enum) = ECPGd_type; }
#line 58572 "preproc.c" /* yacc.c:1652  */
    break;

  case 2993:
#line 16511 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58578 "preproc.c" /* yacc.c:1652  */
    break;

  case 2994:
#line 16512 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58584 "preproc.c" /* yacc.c:1652  */
    break;

  case 2995:
#line 16515 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("on"); }
#line 58590 "preproc.c" /* yacc.c:1652  */
    break;

  case 2996:
#line 16516 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("off"); }
#line 58596 "preproc.c" /* yacc.c:1652  */
    break;

  case 2997:
#line 16523 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58602 "preproc.c" /* yacc.c:1652  */
    break;

  case 2998:
#line 16524 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58608 "preproc.c" /* yacc.c:1652  */
    break;

  case 2999:
#line 16525 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58614 "preproc.c" /* yacc.c:1652  */
    break;

  case 3000:
#line 16532 "preproc.y" /* yacc.c:1652  */
    {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		}
#line 58624 "preproc.c" /* yacc.c:1652  */
    break;

  case 3001:
#line 16538 "preproc.y" /* yacc.c:1652  */
    {
			add_typedef((yyvsp[-4].str), (yyvsp[-1].index).index1, (yyvsp[-1].index).index2, (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_dimension, (yyvsp[-2].type).type_index, initializer, *(yyvsp[0].str) ? 1 : 0);

			if (auto_create_c == false)
				(yyval.str) = cat_str(7, mm_strdup("/* exec sql type"), mm_strdup((yyvsp[-4].str)), mm_strdup("is"), mm_strdup((yyvsp[-2].type).type_str), mm_strdup((yyvsp[-1].index).str), (yyvsp[0].str), mm_strdup("*/"));
			else
				(yyval.str) = cat_str(6, mm_strdup("typedef "), mm_strdup((yyvsp[-2].type).type_str), *(yyvsp[0].str)?mm_strdup("*"):mm_strdup(""), mm_strdup((yyvsp[-4].str)), mm_strdup((yyvsp[-1].index).str), mm_strdup(";"));
		}
#line 58637 "preproc.c" /* yacc.c:1652  */
    break;

  case 3002:
#line 16548 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("reference"); }
#line 58643 "preproc.c" /* yacc.c:1652  */
    break;

  case 3003:
#line 16549 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 58649 "preproc.c" /* yacc.c:1652  */
    break;

  case 3004:
#line 16556 "preproc.y" /* yacc.c:1652  */
    {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		}
#line 58659 "preproc.c" /* yacc.c:1652  */
    break;

  case 3005:
#line 16562 "preproc.y" /* yacc.c:1652  */
    {
			struct variable *p = find_variable((yyvsp[-4].str));
			char *dimension = (yyvsp[-1].index).index1;
			char *length = (yyvsp[-1].index).index2;
			struct ECPGtype * type;

			if (((yyvsp[-2].type).type_enum == ECPGt_struct ||
				 (yyvsp[-2].type).type_enum == ECPGt_union) &&
				initializer == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in EXEC SQL VAR command");
			else
			{
				adjust_array((yyvsp[-2].type).type_enum, &dimension, &length, (yyvsp[-2].type).type_dimension, (yyvsp[-2].type).type_index, *(yyvsp[0].str)?1:0, false);

				switch ((yyvsp[-2].type).type_enum)
				{
					case ECPGt_struct:
					case ECPGt_union:
						if (atoi(dimension) < 0)
							type = ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_str, (yyvsp[-2].type).type_sizeof);
						else
							type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_str, (yyvsp[-2].type).type_sizeof), dimension);
						break;

					case ECPGt_varchar:
					case ECPGt_bytea:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0), dimension);
						break;

					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0), dimension);
						break;

					default:
						if (atoi(length) >= 0)
							mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

						if (atoi(dimension) < 0)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, mm_strdup("1"), 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, mm_strdup("1"), 0), dimension);
						break;
				}

				ECPGfree_type(p->type);
				p->type = type;
			}

			(yyval.str) = cat_str(7, mm_strdup("/* exec sql var"), mm_strdup((yyvsp[-4].str)), mm_strdup("is"), mm_strdup((yyvsp[-2].type).type_str), mm_strdup((yyvsp[-1].index).str), (yyvsp[0].str), mm_strdup("*/"));
		}
#line 58722 "preproc.c" /* yacc.c:1652  */
    break;

  case 3006:
#line 16627 "preproc.y" /* yacc.c:1652  */
    {
			when_error.code = (yyvsp[0].action).code;
			when_error.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever sqlerror "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 58732 "preproc.c" /* yacc.c:1652  */
    break;

  case 3007:
#line 16633 "preproc.y" /* yacc.c:1652  */
    {
			when_nf.code = (yyvsp[0].action).code;
			when_nf.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever not found "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 58742 "preproc.c" /* yacc.c:1652  */
    break;

  case 3008:
#line 16639 "preproc.y" /* yacc.c:1652  */
    {
			when_warn.code = (yyvsp[0].action).code;
			when_warn.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever sql_warning "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 58752 "preproc.c" /* yacc.c:1652  */
    break;

  case 3009:
#line 16647 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_NOTHING;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("continue");
		}
#line 58762 "preproc.c" /* yacc.c:1652  */
    break;

  case 3010:
#line 16653 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_SQLPRINT;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("sqlprint");
		}
#line 58772 "preproc.c" /* yacc.c:1652  */
    break;

  case 3011:
#line 16659 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_STOP;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("stop");
		}
#line 58782 "preproc.c" /* yacc.c:1652  */
    break;

  case 3012:
#line 16665 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = mm_strdup((yyvsp[0].str));
			(yyval.action).str = cat2_str(mm_strdup("goto "), (yyvsp[0].str));
		}
#line 58792 "preproc.c" /* yacc.c:1652  */
    break;

  case 3013:
#line 16671 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = mm_strdup((yyvsp[0].str));
			(yyval.action).str = cat2_str(mm_strdup("goto "), (yyvsp[0].str));
		}
#line 58802 "preproc.c" /* yacc.c:1652  */
    break;

  case 3014:
#line 16677 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].str), mm_strdup(")"));
			(yyval.action).str = cat2_str(mm_strdup("do"), mm_strdup((yyval.action).command));
		}
#line 58812 "preproc.c" /* yacc.c:1652  */
    break;

  case 3015:
#line 16683 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_BREAK;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("break");
		}
#line 58822 "preproc.c" /* yacc.c:1652  */
    break;

  case 3016:
#line 16689 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_CONTINUE;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("continue");
		}
#line 58832 "preproc.c" /* yacc.c:1652  */
    break;

  case 3017:
#line 16695 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].str), mm_strdup(")"));
			(yyval.action).str = cat2_str(mm_strdup("call"), mm_strdup((yyval.action).command));
		}
#line 58842 "preproc.c" /* yacc.c:1652  */
    break;

  case 3018:
#line 16701 "preproc.y" /* yacc.c:1652  */
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat2_str((yyvsp[0].str), mm_strdup("()"));
			(yyval.action).str = cat2_str(mm_strdup("call"), mm_strdup((yyval.action).command));
		}
#line 58852 "preproc.c" /* yacc.c:1652  */
    break;

  case 3019:
#line 16711 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58858 "preproc.c" /* yacc.c:1652  */
    break;

  case 3020:
#line 16712 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 58864 "preproc.c" /* yacc.c:1652  */
    break;

  case 3021:
#line 16715 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("break"); }
#line 58870 "preproc.c" /* yacc.c:1652  */
    break;

  case 3022:
#line 16716 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("cardinality"); }
#line 58876 "preproc.c" /* yacc.c:1652  */
    break;

  case 3023:
#line 16717 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("count"); }
#line 58882 "preproc.c" /* yacc.c:1652  */
    break;

  case 3024:
#line 16718 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("datetime_interval_code"); }
#line 58888 "preproc.c" /* yacc.c:1652  */
    break;

  case 3025:
#line 16719 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("datetime_interval_precision"); }
#line 58894 "preproc.c" /* yacc.c:1652  */
    break;

  case 3026:
#line 16720 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("found"); }
#line 58900 "preproc.c" /* yacc.c:1652  */
    break;

  case 3027:
#line 16721 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("go"); }
#line 58906 "preproc.c" /* yacc.c:1652  */
    break;

  case 3028:
#line 16722 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("goto"); }
#line 58912 "preproc.c" /* yacc.c:1652  */
    break;

  case 3029:
#line 16723 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("identified"); }
#line 58918 "preproc.c" /* yacc.c:1652  */
    break;

  case 3030:
#line 16724 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("indicator"); }
#line 58924 "preproc.c" /* yacc.c:1652  */
    break;

  case 3031:
#line 16725 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("key_member"); }
#line 58930 "preproc.c" /* yacc.c:1652  */
    break;

  case 3032:
#line 16726 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("length"); }
#line 58936 "preproc.c" /* yacc.c:1652  */
    break;

  case 3033:
#line 16727 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("nullable"); }
#line 58942 "preproc.c" /* yacc.c:1652  */
    break;

  case 3034:
#line 16728 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("octet_length"); }
#line 58948 "preproc.c" /* yacc.c:1652  */
    break;

  case 3035:
#line 16729 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("returned_length"); }
#line 58954 "preproc.c" /* yacc.c:1652  */
    break;

  case 3036:
#line 16730 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("returned_octet_length"); }
#line 58960 "preproc.c" /* yacc.c:1652  */
    break;

  case 3037:
#line 16731 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("scale"); }
#line 58966 "preproc.c" /* yacc.c:1652  */
    break;

  case 3038:
#line 16732 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("section"); }
#line 58972 "preproc.c" /* yacc.c:1652  */
    break;

  case 3039:
#line 16733 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("sqlerror"); }
#line 58978 "preproc.c" /* yacc.c:1652  */
    break;

  case 3040:
#line 16734 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("sqlprint"); }
#line 58984 "preproc.c" /* yacc.c:1652  */
    break;

  case 3041:
#line 16735 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("sqlwarning"); }
#line 58990 "preproc.c" /* yacc.c:1652  */
    break;

  case 3042:
#line 16736 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("stop"); }
#line 58996 "preproc.c" /* yacc.c:1652  */
    break;

  case 3043:
#line 16739 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("connect"); }
#line 59002 "preproc.c" /* yacc.c:1652  */
    break;

  case 3044:
#line 16740 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("describe"); }
#line 59008 "preproc.c" /* yacc.c:1652  */
    break;

  case 3045:
#line 16741 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("disconnect"); }
#line 59014 "preproc.c" /* yacc.c:1652  */
    break;

  case 3046:
#line 16742 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("open"); }
#line 59020 "preproc.c" /* yacc.c:1652  */
    break;

  case 3047:
#line 16743 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("var"); }
#line 59026 "preproc.c" /* yacc.c:1652  */
    break;

  case 3048:
#line 16744 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("whenever"); }
#line 59032 "preproc.c" /* yacc.c:1652  */
    break;

  case 3049:
#line 16748 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("bool"); }
#line 59038 "preproc.c" /* yacc.c:1652  */
    break;

  case 3050:
#line 16749 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("long"); }
#line 59044 "preproc.c" /* yacc.c:1652  */
    break;

  case 3051:
#line 16750 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("output"); }
#line 59050 "preproc.c" /* yacc.c:1652  */
    break;

  case 3052:
#line 16751 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("short"); }
#line 59056 "preproc.c" /* yacc.c:1652  */
    break;

  case 3053:
#line 16752 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("struct"); }
#line 59062 "preproc.c" /* yacc.c:1652  */
    break;

  case 3054:
#line 16753 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("signed"); }
#line 59068 "preproc.c" /* yacc.c:1652  */
    break;

  case 3055:
#line 16754 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("unsigned"); }
#line 59074 "preproc.c" /* yacc.c:1652  */
    break;

  case 3056:
#line 16757 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59080 "preproc.c" /* yacc.c:1652  */
    break;

  case 3057:
#line 16760 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59086 "preproc.c" /* yacc.c:1652  */
    break;

  case 3058:
#line 16761 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59092 "preproc.c" /* yacc.c:1652  */
    break;

  case 3059:
#line 16762 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59098 "preproc.c" /* yacc.c:1652  */
    break;

  case 3060:
#line 16763 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59104 "preproc.c" /* yacc.c:1652  */
    break;

  case 3061:
#line 16764 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59110 "preproc.c" /* yacc.c:1652  */
    break;

  case 3062:
#line 16765 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59116 "preproc.c" /* yacc.c:1652  */
    break;

  case 3063:
#line 16766 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("char"); }
#line 59122 "preproc.c" /* yacc.c:1652  */
    break;

  case 3064:
#line 16767 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("values"); }
#line 59128 "preproc.c" /* yacc.c:1652  */
    break;

  case 3065:
#line 16780 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59134 "preproc.c" /* yacc.c:1652  */
    break;

  case 3066:
#line 16781 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59140 "preproc.c" /* yacc.c:1652  */
    break;

  case 3067:
#line 16782 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59146 "preproc.c" /* yacc.c:1652  */
    break;

  case 3068:
#line 16783 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59152 "preproc.c" /* yacc.c:1652  */
    break;

  case 3069:
#line 16784 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59158 "preproc.c" /* yacc.c:1652  */
    break;

  case 3070:
#line 16785 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("char"); }
#line 59164 "preproc.c" /* yacc.c:1652  */
    break;

  case 3071:
#line 16786 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("values"); }
#line 59170 "preproc.c" /* yacc.c:1652  */
    break;

  case 3072:
#line 16791 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59176 "preproc.c" /* yacc.c:1652  */
    break;

  case 3073:
#line 16792 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59182 "preproc.c" /* yacc.c:1652  */
    break;

  case 3074:
#line 16793 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59188 "preproc.c" /* yacc.c:1652  */
    break;

  case 3075:
#line 16794 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59194 "preproc.c" /* yacc.c:1652  */
    break;

  case 3076:
#line 16795 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59200 "preproc.c" /* yacc.c:1652  */
    break;

  case 3077:
#line 16796 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59206 "preproc.c" /* yacc.c:1652  */
    break;

  case 3078:
#line 16802 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59212 "preproc.c" /* yacc.c:1652  */
    break;

  case 3079:
#line 16803 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59218 "preproc.c" /* yacc.c:1652  */
    break;

  case 3080:
#line 16804 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("char"); }
#line 59224 "preproc.c" /* yacc.c:1652  */
    break;

  case 3081:
#line 16805 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("current"); }
#line 59230 "preproc.c" /* yacc.c:1652  */
    break;

  case 3082:
#line 16806 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("input"); }
#line 59236 "preproc.c" /* yacc.c:1652  */
    break;

  case 3083:
#line 16807 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("int"); }
#line 59242 "preproc.c" /* yacc.c:1652  */
    break;

  case 3084:
#line 16808 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("to"); }
#line 59248 "preproc.c" /* yacc.c:1652  */
    break;

  case 3085:
#line 16809 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("union"); }
#line 59254 "preproc.c" /* yacc.c:1652  */
    break;

  case 3086:
#line 16810 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("values"); }
#line 59260 "preproc.c" /* yacc.c:1652  */
    break;

  case 3087:
#line 16811 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59266 "preproc.c" /* yacc.c:1652  */
    break;

  case 3088:
#line 16812 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59272 "preproc.c" /* yacc.c:1652  */
    break;

  case 3089:
#line 16815 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59278 "preproc.c" /* yacc.c:1652  */
    break;

  case 3090:
#line 16816 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59284 "preproc.c" /* yacc.c:1652  */
    break;

  case 3091:
#line 16817 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59290 "preproc.c" /* yacc.c:1652  */
    break;

  case 3092:
#line 16818 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59296 "preproc.c" /* yacc.c:1652  */
    break;

  case 3093:
#line 16819 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("connection"); }
#line 59302 "preproc.c" /* yacc.c:1652  */
    break;

  case 3094:
#line 16822 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59308 "preproc.c" /* yacc.c:1652  */
    break;

  case 3095:
#line 16823 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59314 "preproc.c" /* yacc.c:1652  */
    break;

  case 3096:
#line 16824 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59320 "preproc.c" /* yacc.c:1652  */
    break;

  case 3097:
#line 16825 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59326 "preproc.c" /* yacc.c:1652  */
    break;

  case 3098:
#line 16828 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("auto"); }
#line 59332 "preproc.c" /* yacc.c:1652  */
    break;

  case 3099:
#line 16829 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("const"); }
#line 59338 "preproc.c" /* yacc.c:1652  */
    break;

  case 3100:
#line 16830 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("extern"); }
#line 59344 "preproc.c" /* yacc.c:1652  */
    break;

  case 3101:
#line 16831 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("register"); }
#line 59350 "preproc.c" /* yacc.c:1652  */
    break;

  case 3102:
#line 16832 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("static"); }
#line 59356 "preproc.c" /* yacc.c:1652  */
    break;

  case 3103:
#line 16833 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("typedef"); }
#line 59362 "preproc.c" /* yacc.c:1652  */
    break;

  case 3104:
#line 16834 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("volatile"); }
#line 59368 "preproc.c" /* yacc.c:1652  */
    break;

  case 3105:
#line 16851 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59374 "preproc.c" /* yacc.c:1652  */
    break;

  case 3106:
#line 16852 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59380 "preproc.c" /* yacc.c:1652  */
    break;

  case 3107:
#line 16853 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("connection"); }
#line 59386 "preproc.c" /* yacc.c:1652  */
    break;

  case 3108:
#line 16856 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("day"); }
#line 59392 "preproc.c" /* yacc.c:1652  */
    break;

  case 3109:
#line 16857 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("hour"); }
#line 59398 "preproc.c" /* yacc.c:1652  */
    break;

  case 3110:
#line 16858 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("minute"); }
#line 59404 "preproc.c" /* yacc.c:1652  */
    break;

  case 3111:
#line 16859 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("month"); }
#line 59410 "preproc.c" /* yacc.c:1652  */
    break;

  case 3112:
#line 16860 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("second"); }
#line 59416 "preproc.c" /* yacc.c:1652  */
    break;

  case 3113:
#line 16861 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("year"); }
#line 59422 "preproc.c" /* yacc.c:1652  */
    break;

  case 3116:
#line 16868 "preproc.y" /* yacc.c:1652  */
    {
				reset_variables();
				pacounter = 1;
			}
#line 59431 "preproc.c" /* yacc.c:1652  */
    break;

  case 3117:
#line 16874 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 59437 "preproc.c" /* yacc.c:1652  */
    break;

  case 3118:
#line 16875 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59443 "preproc.c" /* yacc.c:1652  */
    break;

  case 3119:
#line 16879 "preproc.y" /* yacc.c:1652  */
    { add_variable_to_head(&argsresult, find_variable((yyvsp[-1].str)), find_variable((yyvsp[0].str))); }
#line 59449 "preproc.c" /* yacc.c:1652  */
    break;

  case 3120:
#line 16881 "preproc.y" /* yacc.c:1652  */
    { add_variable_to_head(&argsresult, find_variable((yyvsp[0].str)), &no_indicator); }
#line 59455 "preproc.c" /* yacc.c:1652  */
    break;

  case 3121:
#line 16886 "preproc.y" /* yacc.c:1652  */
    {
			if (find_variable((yyvsp[0].str))->type->type == ECPGt_array)
				mmerror(PARSE_ERROR, ET_ERROR, "arrays of indicators are not allowed on input");

			add_variable_to_head(&argsinsert, find_variable((yyvsp[-1].str)), find_variable((yyvsp[0].str)));
			(yyval.str) = create_questionmarks((yyvsp[-1].str), false);
		}
#line 59467 "preproc.c" /* yacc.c:1652  */
    break;

  case 3122:
#line 16896 "preproc.y" /* yacc.c:1652  */
    {
			char *ptr = strstr((yyvsp[0].str), ".arr");

			if (ptr) /* varchar, we need the struct name here, not the struct element */
				*ptr = '\0';
			add_variable_to_head(&argsinsert, find_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = (yyvsp[0].str);
		}
#line 59480 "preproc.c" /* yacc.c:1652  */
    break;

  case 3123:
#line 16907 "preproc.y" /* yacc.c:1652  */
    {
			add_variable_to_head(&argsinsert, find_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = create_questionmarks((yyvsp[0].str), false);
		}
#line 59489 "preproc.c" /* yacc.c:1652  */
    break;

  case 3124:
#line 16913 "preproc.y" /* yacc.c:1652  */
    { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 59495 "preproc.c" /* yacc.c:1652  */
    break;

  case 3125:
#line 16914 "preproc.y" /* yacc.c:1652  */
    { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 59501 "preproc.c" /* yacc.c:1652  */
    break;

  case 3126:
#line 16915 "preproc.y" /* yacc.c:1652  */
    { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 59507 "preproc.c" /* yacc.c:1652  */
    break;

  case 3127:
#line 16919 "preproc.y" /* yacc.c:1652  */
    {
			/* As long as multidimensional arrays are not implemented we have to check for those here */
			char *ptr = (yyvsp[0].str);
			int brace_open=0, brace = false;

			for (; *ptr; ptr++)
			{
				switch (*ptr)
				{
					case '[':
							if (brace)
								mmfatal(PARSE_ERROR, "multidimensional arrays for simple data types are not supported");
							brace_open++;
							break;
					case ']':
							brace_open--;
							if (brace_open == 0)
								brace = true;
							break;
					case '\t':
					case ' ':
							break;
					default:
							if (brace_open == 0)
								brace = false;
							break;
				}
			}
			(yyval.str) = (yyvsp[0].str);
		}
#line 59542 "preproc.c" /* yacc.c:1652  */
    break;

  case 3128:
#line 16951 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 59548 "preproc.c" /* yacc.c:1652  */
    break;

  case 3129:
#line 16953 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59554 "preproc.c" /* yacc.c:1652  */
    break;

  case 3130:
#line 16955 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 59560 "preproc.c" /* yacc.c:1652  */
    break;

  case 3131:
#line 16957 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59566 "preproc.c" /* yacc.c:1652  */
    break;

  case 3132:
#line 16959 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59572 "preproc.c" /* yacc.c:1652  */
    break;

  case 3133:
#line 16961 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59578 "preproc.c" /* yacc.c:1652  */
    break;

  case 3134:
#line 16962 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 59584 "preproc.c" /* yacc.c:1652  */
    break;

  case 3135:
#line 16966 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 59590 "preproc.c" /* yacc.c:1652  */
    break;

  case 3136:
#line 16968 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make3_str(mm_strdup("("), (yyvsp[0].str), mm_strdup(")")); }
#line 59596 "preproc.c" /* yacc.c:1652  */
    break;

  case 3137:
#line 16975 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59602 "preproc.c" /* yacc.c:1652  */
    break;

  case 3138:
#line 16976 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("()"); }
#line 59608 "preproc.c" /* yacc.c:1652  */
    break;

  case 3139:
#line 16978 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("("), (yyvsp[-1].str), mm_strdup(")")); }
#line 59614 "preproc.c" /* yacc.c:1652  */
    break;

  case 3140:
#line 16981 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59620 "preproc.c" /* yacc.c:1652  */
    break;

  case 3141:
#line 16983 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 59626 "preproc.c" /* yacc.c:1652  */
    break;

  case 3142:
#line 16986 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59632 "preproc.c" /* yacc.c:1652  */
    break;

  case 3143:
#line 16987 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 59638 "preproc.c" /* yacc.c:1652  */
    break;

  case 3144:
#line 16990 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59644 "preproc.c" /* yacc.c:1652  */
    break;

  case 3145:
#line 16991 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}")); }
#line 59650 "preproc.c" /* yacc.c:1652  */
    break;

  case 3146:
#line 16994 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59656 "preproc.c" /* yacc.c:1652  */
    break;

  case 3147:
#line 16995 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("("); }
#line 59662 "preproc.c" /* yacc.c:1652  */
    break;

  case 3148:
#line 16996 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(")"); }
#line 59668 "preproc.c" /* yacc.c:1652  */
    break;

  case 3149:
#line 16997 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(","); }
#line 59674 "preproc.c" /* yacc.c:1652  */
    break;

  case 3150:
#line 16998 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(";"); }
#line 59680 "preproc.c" /* yacc.c:1652  */
    break;

  case 3151:
#line 17001 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59686 "preproc.c" /* yacc.c:1652  */
    break;

  case 3152:
#line 17002 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59692 "preproc.c" /* yacc.c:1652  */
    break;

  case 3153:
#line 17003 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59698 "preproc.c" /* yacc.c:1652  */
    break;

  case 3154:
#line 17004 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 59704 "preproc.c" /* yacc.c:1652  */
    break;

  case 3155:
#line 17005 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("*"); }
#line 59710 "preproc.c" /* yacc.c:1652  */
    break;

  case 3156:
#line 17006 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("+"); }
#line 59716 "preproc.c" /* yacc.c:1652  */
    break;

  case 3157:
#line 17007 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("-"); }
#line 59722 "preproc.c" /* yacc.c:1652  */
    break;

  case 3158:
#line 17008 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("/"); }
#line 59728 "preproc.c" /* yacc.c:1652  */
    break;

  case 3159:
#line 17009 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("%"); }
#line 59734 "preproc.c" /* yacc.c:1652  */
    break;

  case 3160:
#line 17010 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("NULL"); }
#line 59740 "preproc.c" /* yacc.c:1652  */
    break;

  case 3161:
#line 17011 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("+="); }
#line 59746 "preproc.c" /* yacc.c:1652  */
    break;

  case 3162:
#line 17012 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("&&"); }
#line 59752 "preproc.c" /* yacc.c:1652  */
    break;

  case 3163:
#line 17013 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = make_name(); }
#line 59758 "preproc.c" /* yacc.c:1652  */
    break;

  case 3164:
#line 17014 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("auto"); }
#line 59764 "preproc.c" /* yacc.c:1652  */
    break;

  case 3165:
#line 17015 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("const"); }
#line 59770 "preproc.c" /* yacc.c:1652  */
    break;

  case 3166:
#line 17016 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("--"); }
#line 59776 "preproc.c" /* yacc.c:1652  */
    break;

  case 3167:
#line 17017 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("/="); }
#line 59782 "preproc.c" /* yacc.c:1652  */
    break;

  case 3168:
#line 17018 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(".*"); }
#line 59788 "preproc.c" /* yacc.c:1652  */
    break;

  case 3169:
#line 17019 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("=="); }
#line 59794 "preproc.c" /* yacc.c:1652  */
    break;

  case 3170:
#line 17020 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("extern"); }
#line 59800 "preproc.c" /* yacc.c:1652  */
    break;

  case 3171:
#line 17021 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("++"); }
#line 59806 "preproc.c" /* yacc.c:1652  */
    break;

  case 3172:
#line 17022 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("<<"); }
#line 59812 "preproc.c" /* yacc.c:1652  */
    break;

  case 3173:
#line 17023 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("->"); }
#line 59818 "preproc.c" /* yacc.c:1652  */
    break;

  case 3174:
#line 17024 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("->*"); }
#line 59824 "preproc.c" /* yacc.c:1652  */
    break;

  case 3175:
#line 17025 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("%="); }
#line 59830 "preproc.c" /* yacc.c:1652  */
    break;

  case 3176:
#line 17026 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("*="); }
#line 59836 "preproc.c" /* yacc.c:1652  */
    break;

  case 3177:
#line 17027 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("!="); }
#line 59842 "preproc.c" /* yacc.c:1652  */
    break;

  case 3178:
#line 17028 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("||"); }
#line 59848 "preproc.c" /* yacc.c:1652  */
    break;

  case 3179:
#line 17029 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("register"); }
#line 59854 "preproc.c" /* yacc.c:1652  */
    break;

  case 3180:
#line 17030 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(">>"); }
#line 59860 "preproc.c" /* yacc.c:1652  */
    break;

  case 3181:
#line 17031 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("static"); }
#line 59866 "preproc.c" /* yacc.c:1652  */
    break;

  case 3182:
#line 17032 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("-="); }
#line 59872 "preproc.c" /* yacc.c:1652  */
    break;

  case 3183:
#line 17033 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("typedef"); }
#line 59878 "preproc.c" /* yacc.c:1652  */
    break;

  case 3184:
#line 17034 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("volatile"); }
#line 59884 "preproc.c" /* yacc.c:1652  */
    break;

  case 3185:
#line 17035 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("bool"); }
#line 59890 "preproc.c" /* yacc.c:1652  */
    break;

  case 3186:
#line 17036 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("enum"); }
#line 59896 "preproc.c" /* yacc.c:1652  */
    break;

  case 3187:
#line 17037 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("hour"); }
#line 59902 "preproc.c" /* yacc.c:1652  */
    break;

  case 3188:
#line 17038 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("int"); }
#line 59908 "preproc.c" /* yacc.c:1652  */
    break;

  case 3189:
#line 17039 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("long"); }
#line 59914 "preproc.c" /* yacc.c:1652  */
    break;

  case 3190:
#line 17040 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("minute"); }
#line 59920 "preproc.c" /* yacc.c:1652  */
    break;

  case 3191:
#line 17041 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("month"); }
#line 59926 "preproc.c" /* yacc.c:1652  */
    break;

  case 3192:
#line 17042 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("second"); }
#line 59932 "preproc.c" /* yacc.c:1652  */
    break;

  case 3193:
#line 17043 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("short"); }
#line 59938 "preproc.c" /* yacc.c:1652  */
    break;

  case 3194:
#line 17044 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("signed"); }
#line 59944 "preproc.c" /* yacc.c:1652  */
    break;

  case 3195:
#line 17045 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("struct"); }
#line 59950 "preproc.c" /* yacc.c:1652  */
    break;

  case 3196:
#line 17046 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("unsigned"); }
#line 59956 "preproc.c" /* yacc.c:1652  */
    break;

  case 3197:
#line 17047 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("year"); }
#line 59962 "preproc.c" /* yacc.c:1652  */
    break;

  case 3198:
#line 17048 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("char"); }
#line 59968 "preproc.c" /* yacc.c:1652  */
    break;

  case 3199:
#line 17049 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("float"); }
#line 59974 "preproc.c" /* yacc.c:1652  */
    break;

  case 3200:
#line 17050 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("to"); }
#line 59980 "preproc.c" /* yacc.c:1652  */
    break;

  case 3201:
#line 17051 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("union"); }
#line 59986 "preproc.c" /* yacc.c:1652  */
    break;

  case 3202:
#line 17052 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("varchar"); }
#line 59992 "preproc.c" /* yacc.c:1652  */
    break;

  case 3203:
#line 17053 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("["); }
#line 59998 "preproc.c" /* yacc.c:1652  */
    break;

  case 3204:
#line 17054 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("]"); }
#line 60004 "preproc.c" /* yacc.c:1652  */
    break;

  case 3205:
#line 17055 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("="); }
#line 60010 "preproc.c" /* yacc.c:1652  */
    break;

  case 3206:
#line 17056 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup(":"); }
#line 60016 "preproc.c" /* yacc.c:1652  */
    break;

  case 3207:
#line 17059 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 60022 "preproc.c" /* yacc.c:1652  */
    break;

  case 3208:
#line 17060 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 60028 "preproc.c" /* yacc.c:1652  */
    break;

  case 3209:
#line 17061 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("all"); }
#line 60034 "preproc.c" /* yacc.c:1652  */
    break;

  case 3210:
#line 17062 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = mm_strdup("all"); }
#line 60040 "preproc.c" /* yacc.c:1652  */
    break;

  case 3211:
#line 17065 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 60046 "preproc.c" /* yacc.c:1652  */
    break;

  case 3212:
#line 17066 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, mm_strdup("("), (yyvsp[-1].str), mm_strdup(")")); }
#line 60052 "preproc.c" /* yacc.c:1652  */
    break;

  case 3213:
#line 17067 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("+"), (yyvsp[0].str)); }
#line 60058 "preproc.c" /* yacc.c:1652  */
    break;

  case 3214:
#line 17068 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("-"), (yyvsp[0].str)); }
#line 60064 "preproc.c" /* yacc.c:1652  */
    break;

  case 3215:
#line 17069 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("*"), (yyvsp[0].str)); }
#line 60070 "preproc.c" /* yacc.c:1652  */
    break;

  case 3216:
#line 17070 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("/"), (yyvsp[0].str)); }
#line 60076 "preproc.c" /* yacc.c:1652  */
    break;

  case 3217:
#line 17071 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("%"), (yyvsp[0].str)); }
#line 60082 "preproc.c" /* yacc.c:1652  */
    break;

  case 3218:
#line 17072 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 60088 "preproc.c" /* yacc.c:1652  */
    break;

  case 3219:
#line 17073 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 60094 "preproc.c" /* yacc.c:1652  */
    break;

  case 3220:
#line 17074 "preproc.y" /* yacc.c:1652  */
    { if (pg_strcasecmp((yyvsp[-3].str), "sizeof") != 0)
							mmerror(PARSE_ERROR, ET_ERROR, "operator not allowed in variable definition");
						  else
							(yyval.str) = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].type).type_str, mm_strdup(")"));
						}
#line 60104 "preproc.c" /* yacc.c:1652  */
    break;

  case 3221:
#line 17081 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 60110 "preproc.c" /* yacc.c:1652  */
    break;

  case 3222:
#line 17082 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 60116 "preproc.c" /* yacc.c:1652  */
    break;

  case 3223:
#line 17083 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 60122 "preproc.c" /* yacc.c:1652  */
    break;

  case 3224:
#line 17084 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 60128 "preproc.c" /* yacc.c:1652  */
    break;

  case 3225:
#line 17087 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 60134 "preproc.c" /* yacc.c:1652  */
    break;

  case 3226:
#line 17088 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 60140 "preproc.c" /* yacc.c:1652  */
    break;

  case 3227:
#line 17091 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 60146 "preproc.c" /* yacc.c:1652  */
    break;

  case 3228:
#line 17092 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 60152 "preproc.c" /* yacc.c:1652  */
    break;

  case 3229:
#line 17095 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 60158 "preproc.c" /* yacc.c:1652  */
    break;

  case 3230:
#line 17097 "preproc.y" /* yacc.c:1652  */
    {
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);
		(yyval.str) = (yyvsp[0].str);
	}
#line 60171 "preproc.c" /* yacc.c:1652  */
    break;

  case 3231:
#line 17107 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = EMPTY; }
#line 60177 "preproc.c" /* yacc.c:1652  */
    break;

  case 3232:
#line 17108 "preproc.y" /* yacc.c:1652  */
    { (yyval.str) = (yyvsp[0].str); }
#line 60183 "preproc.c" /* yacc.c:1652  */
    break;


#line 60187 "preproc.c" /* yacc.c:1652  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 17111 "preproc.y" /* yacc.c:1918  */


void base_yyerror(const char *error)
{
	/* translator: %s is typically the translation of "syntax error" */
	mmerror(PARSE_ERROR, ET_ERROR, "%s at or near \"%s\"",
			_(error), token_start ? token_start : base_yytext);
}

void parser_init(void)
{
 /* This function is empty. It only exists for compatibility with the backend parser right now. */
}
